#include "header.hpp"

#include "ppaa02.amplitude.set.hpp"

#ifdef RECOLA

ppaa02_amplitude_Recola_set::ppaa02_amplitude_Recola_set(){
  static Logger logger("ppaa02_amplitude_Recola_set::ppaa02_amplitude_Recola_set ()");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  logger << LOG_DEBUG << "constructor called..." << endline_flush;

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

ppaa02_amplitude_Recola_set::~ppaa02_amplitude_Recola_set(){
  static Logger logger("ppaa02_amplitude_Recola_set::~ppaa02_amplitude_Recola_set ()");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  logger << LOG_DEBUG << "destructor called..." << endline_flush;

  if (csi->type_contribution == "VT2" && csi->type_correction == "QCD"){finalization_H2_QCD_2loop();}

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void ppaa02_amplitude_Recola_set::initialization_process(){
  static Logger logger("ppaa02_amplitude_Recola_set::initialization_process");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  process_id = -1;
  if (csi->type_contribution == "VT2" && csi->type_correction == "QCD"){
    register_RCL_subprocess(0, 2, process_id);
    munich_unselect_all_powers_BornAmpl(process_id);
    munich_unselect_all_powers_LoopAmpl(process_id);
    munich_select_power_BornAmpl(process_id, csi->contribution_order_alpha_s - 2, csi->contribution_order_alpha_e);
    munich_select_power_LoopAmpl(process_id, csi->contribution_order_alpha_s, csi->contribution_order_alpha_e);
    int process_id_loopxloop = -1;
    register_RCL_subprocess(0, 2, process_id_loopxloop);
    logger << LOG_INFO << "Amplitude identifier loop-squared: " << process_id_loopxloop << endl;
    munich_unselect_all_powers_BornAmpl(process_id_loopxloop);
    munich_unselect_all_powers_LoopAmpl(process_id_loopxloop);
    munich_select_power_LoopAmpl(process_id_loopxloop, csi->contribution_order_alpha_s, csi->contribution_order_alpha_e);
    // additional Recola-specific process initialization for VT2 contribution
  }
  else {amplitude_Recola_set::initialization_process();}

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void ppaa02_amplitude_Recola_set::initialization_process_extra(){
  static Logger logger("ppaa02_amplitude_Recola_set::initialization_process_extra");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  amplitude_Recola_set::initialization_process_extra();

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void ppaa02_amplitude_Recola_set::initialization_H2_QCD_2loop(){
  static Logger logger("ppaa02_amplitude_Recola_set::initialization_H2_QCD_2loop");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  ppaa02_amplitude_set::initialization_H2_QCD_2loop();

  // initialization of Recola-specific ingredients for 2-loop amplitudes in VT2 QCD contribution

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void ppaa02_amplitude_Recola_set::finalization_H2_QCD_2loop(){
  static Logger logger("ppaa02_amplitude_Recola_set::finalization_H2_QCD_2loop");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  ppaa02_amplitude_set::finalization_H2_QCD_2loop();

  // finalization of Recola-specific ingredients for 2-loop amplitudes in VT2 QCD contribution

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void ppaa02_amplitude_Recola_set::calculate_H2_QCD_2loop(){
  static Logger logger("ppaa02_amplitude_Recola_set::calculate_H2_QCD_2loop");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  // calculate Recola-specific ingredients for 2-loop amplitude in VT2 QCD contribution

  ppaa02_amplitude_set::calculate_H2_QCD_2loop();

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

#endif
