#include "header.hpp"

#include "ppll02.amplitude.NLOgg.set.hpp"

#ifdef OPENLOOPS

ppll02_amplitude_NLOgg_OpenLoops_set::ppll02_amplitude_NLOgg_OpenLoops_set(){
  static Logger logger("ppll02_amplitude_NLOgg_OpenLoops_set::ppll02_amplitude_NLOgg_OpenLoops_set ()");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  logger << LOG_DEBUG << "constructor called..." << endline_flush;

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

ppll02_amplitude_NLOgg_OpenLoops_set::~ppll02_amplitude_NLOgg_OpenLoops_set(){
  static Logger logger("ppll02_amplitude_NLOgg_OpenLoops_set::~ppll02_amplitude_NLOgg_OpenLoops_set ()");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  logger << LOG_DEBUG << "destructor called..." << endline_flush;

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void ppll02_amplitude_NLOgg_OpenLoops_set::initialization_process(){
  static Logger logger("ppll02_amplitude_NLOgg_OpenLoops_set::initialization_process");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  ppll02_amplitude_OpenLoops_set::initialization_process();

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void ppll02_amplitude_NLOgg_OpenLoops_set::initialization_process_extra(){
  static Logger logger("ppll02_amplitude_NLOgg_OpenLoops_set::initialization_process");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (csi->class_contribution_loopinduced && csi->class_contribution_virtual && csi->type_correction == "QCD"){
    initialization_H1gg_QCD_2loop();
  }

  ppll02_amplitude_OpenLoops_set::initialization_process_extra();

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void ppll02_amplitude_NLOgg_OpenLoops_set::calculate_ME2_VA_QCD(){
  static Logger logger("ppll02_amplitude_NLOgg_OpenLoops_set::calculate_ME2_VA_QCD");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (csi->class_contribution_loopinduced){ osi->flag_vanishing_ME2 = 1; }
  else {amplitude_OpenLoops_set::calculate_ME2_VA_QCD();}

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void ppll02_amplitude_NLOgg_OpenLoops_set::calculate_ME2_CA_QCD(){
  static Logger logger("ppll02_amplitude_NLOgg_OpenLoops_set::calculate_ME2_CA_QCD");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (csi->class_contribution_loopinduced){ osi->flag_vanishing_ME2 = 1; }
  else {amplitude_OpenLoops_set::calculate_ME2_CA_QCD();}

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void ppll02_amplitude_NLOgg_OpenLoops_set::calculate_dipole_Acc_QCD(int x_a){
  static Logger logger("ppll02_amplitude_NLOgg_OpenLoops_set::calculate_dipole_Acc_QCD");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (csi->class_contribution_loopinduced){
    osi->RA_ME2_cc[x_a] = 0.;
  }
  else { amplitude_OpenLoops_set::calculate_dipole_Acc_QCD(x_a); }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void ppll02_amplitude_NLOgg_OpenLoops_set::calculate_dipole_Asc_QCD(int x_a, fourvector & Vtensor){
  static Logger logger("ppll02_amplitude_NLOgg_OpenLoops_set::calculate_dipole_Acc_QCD");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (csi->class_contribution_loopinduced){
    osi->RA_ME2_cc[x_a] = 0.;
    osi->RA_ME2_sc[x_a] = 0.;
  }
  else { amplitude_OpenLoops_set::calculate_dipole_Asc_QCD(x_a, Vtensor); }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void ppll02_amplitude_NLOgg_OpenLoops_set::calculate_ME2_VT_QCD(){
  static Logger logger("ppll02_amplitude_NLOgg_OpenLoops_set::calculate_ME2_VT_QCD");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (csi->class_contribution_loopinduced){ osi->flag_vanishing_ME2 = 1; }
  else {amplitude_OpenLoops_set::calculate_ME2_VT_QCD();}

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void ppll02_amplitude_NLOgg_OpenLoops_set::calculate_ME2_CT_QCD(){
  static Logger logger("ppll02_amplitude_NLOgg_OpenLoops_set::calculate_ME2_CT_QCD");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (csi->class_contribution_loopinduced){ osi->flag_vanishing_ME2 = 1; }
  else {amplitude_OpenLoops_set::calculate_ME2_CT_QCD();}

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

#endif
