#include "header.hpp"

#include "ppll02.amplitude.NLOgg.set.hpp"

void ppll02_amplitude_NLOgg_initialization(munich * MUC){
  static Logger logger("ppll02_amplitude_NLOgg_initialization");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (MUC->osi->switch_OL){
#ifdef OPENLOOPS
    MUC->asi = new ppll02_amplitude_NLOgg_OpenLoops_set();
#endif
  }
  else if (MUC->osi->switch_RCL){
#ifdef RECOLA
    MUC->asi = new ppll02_amplitude_NLOgg_Recola_set();
#endif
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


ppll02_amplitude_NLOgg_set::ppll02_amplitude_NLOgg_set(){
  static Logger logger("ppll02_amplitude_NLOgg_set::ppll02_amplitude_NLOgg_set ()");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  logger << LOG_DEBUG << "constructor called..." << endline_flush;

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

ppll02_amplitude_NLOgg_set::~ppll02_amplitude_NLOgg_set(){
  static Logger logger("ppll02_amplitude_NLOgg_set::~ppll02_amplitude_NLOgg_set ()");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  logger << LOG_DEBUG << "destructor called..." << endline_flush;

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void ppll02_amplitude_NLOgg_set::initialization_H1gg_QCD_2loop(){
  static Logger logger("ppll02_amplitude_NLOgg_set::initialization_H1gg_QCD_2loop");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  osi->QT_H1_delta_QCD = 0.;
  logger << LOG_DEBUG << "osi->QT_H1_delta_QCD = " << osi->QT_H1_delta_QCD << endline_flush;

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

/*
void ppll02_amplitude_NLOgg_set::finalization_H1gg_QCD_2loop(){
  static Logger logger("ppll02_amplitude_NLOgg_set::finalization_H1gg_QCD_2loop");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;


  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}
*/

/*
void ppll02_amplitude_NLOgg_set::calculate_H1gg_QCD_2loop(){
  static Logger logger("ppll02_amplitude_NLOgg_set::calculate_H1gg_QCD_2loop");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;


  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}
*/
