#include "header.hpp"

#include "ppllll04.amplitude.NLOgg.set.hpp"

void ppllll04_amplitude_NLOgg_set::calculate_H1gg_QCD_2loop_computeVVprimeHelAmplitudes(int i_x, int i_a){
  static Logger logger("ppllll04_amplitude_NLOgg_set::calculate_H1gg_QCD_2loop_computeVVprimeHelAmplitudes");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  /*
  double_complex cos_W = osi->msi->ccos_w;
  double_complex sin_W = osi->msi->csin_w;
  double M_Z = osi->msi->M_Z;
  double Gamma_Z = osi->msi->Gamma_Z;
  double M_W = osi->msi->M_W;
  double Gamma_W = osi->msi->Gamma_W;
  double Nf=osi->N_f;
  */
  //  double ma2 = (p[3]+p[4]).m2();
  //  double mb2 = (p[5]+p[6]).m2();
  /*
  // set couplings (N_VV) of bosons to closed fermion loop
  double_complex N_VV=0.0;
  double_complex LZu=(0.5-2.0/3*sin_W*sin_W)/sin_W/cos_W;
  //  static double_complex LZu = osi->msi->cCminus_Zuu;
  double_complex LZd=(-0.5+1.0/3*sin_W*sin_W)/sin_W/cos_W;
  //  static double_complex LZd = osi->msi->cCminus_Zdd;
  double_complex RZu=-2.0/3*sin_W/cos_W;
  //  static double_complex RZu = osi->msi->cCminus_Zuu;
  double_complex RZd=1.0/3*sin_W/cos_W;
  //  static double_complex RZd = osi->msi->cCminus_Zdd;
  double_complex LW=1.0/sqrt(2)/sin_W;
  //  static double_complex LW = osi->msi->cCminus_W
  if (V1==0 && V2==0) { // gamma gamma
    N_VV = 2*(2.0/3)*(2.0/3)+(Nf-2)*(1.0/3)*(1.0/3);
  } else if (((V1==1 || V1==4) && V2==0) || (V1==0 && (V2==1 || V2==4))) { // Z gamma
    // note: sign mistake in 1503.04812, consistent with 1112.1531
    // MW: mistake in definition of L^gamma_f1f2 meant by this comment; 
    // there is indeed an additional minus sign in eqn. (3.15)?
    N_VV = 0.5*(2.0*(LZu+RZu)*2.0/3.0 + (Nf-2.0)*(LZd+RZd)*(-1.0/3.0));
  } else if ((V1==1 || V1==4) && (V2==1 || V2==4)) { // ZZ
    N_VV = 0.5*(2.0*(LZu*LZu+RZu*RZu)+(Nf-2.0)*(LZd*LZd+RZd*RZd));
  } else if ((V1==2 || V1==3) && (V2==2 || V2==3)) { // WW
    int Ng = Nf/2; // number of massless quark generations
    N_VV = 0.5*Ng*LW*LW;
  }
  */
  
  // propagators for the decay
  double_complex DV1;
  if (DR[i_x][i_a].V1 == V_PHOT){DV1 = ma2;}
  else if (DR[i_x][i_a].V1 == V_ZLL || DR[i_x][i_a].V1 == V_ZNN){DV1 = ma2 - msi->cM2_Z;}
  else if (DR[i_x][i_a].V1 == V_WMIN || DR[i_x][i_a].V1 == V_WPLU){DV1 = ma2 - msi->cM2_W;}
  double_complex DV2;
  if (DR[i_x][i_a].V2 == V_PHOT){DV2 = mb2;}
  else if (DR[i_x][i_a].V2 == V_ZLL || DR[i_x][i_a].V2 == V_ZNN){DV2 = mb2 - msi->cM2_Z;}
  else if (DR[i_x][i_a].V2 == V_WMIN || DR[i_x][i_a].V2 == V_WPLU){DV2 = mb2 - msi->cM2_W;}

  // compute undressed amplitudes
  double_complex M_undressed[2][2][2][2][3];
  for (int loop = 0; loop < 2; loop++) {
    M_undressed[0][0][0][0][loop] = compute_M_gg_ab(1, 2, 5, 6, 7, 8, 0, loop, 0); // M_LLLL
    M_undressed[0][0][0][1][loop] = compute_M_gg_ab(1, 2, 5, 6, 8, 7, 0, loop, 0); // M_LLLR
    M_undressed[0][0][1][0][loop] = compute_M_gg_ab(1, 2, 6, 5, 7, 8, 0, loop, 0); // M_LLRL
    M_undressed[0][0][1][1][loop] = compute_M_gg_ab(1, 2, 6, 5, 8, 7, 0, loop, 0); // M_LLRR
    M_undressed[0][1][0][0][loop] = compute_M_gg_ab(1, 2, 5, 6, 7, 8, 1, loop, 1); // M_LRLL
    M_undressed[0][1][0][1][loop] = compute_M_gg_ab(1, 2, 5, 6, 8, 7, 1, loop, 1); // M_LRLR
    M_undressed[0][1][1][0][loop] = compute_M_gg_ab(1, 2, 6, 5, 7, 8, 1, loop, 1); // M_LRRL
    M_undressed[0][1][1][1][loop] = compute_M_gg_ab(1, 2, 6, 5, 8, 7, 1, loop, 1); // M_LRRR
    // get other amplitudes via charge conjucate [...]^C by replacing spinor products:
    // <ij> <-> [ij], i.e., replacing za <-> zb
    M_undressed[1][0][0][0][loop] = compute_M_gg_ba(1, 2, 6, 5, 8, 7, 0, loop, 0); // M_RLLL
    M_undressed[1][0][0][1][loop] = compute_M_gg_ba(1, 2, 6, 5, 7, 8, 0, loop, 0); // M_RLLR
    M_undressed[1][0][1][0][loop] = compute_M_gg_ba(1, 2, 5, 6, 8, 7, 0, loop, 0); // M_RLRL
    M_undressed[1][0][1][1][loop] = compute_M_gg_ba(1, 2, 5, 6, 7, 8, 0, loop, 0); // M_RLRR
    M_undressed[1][1][0][0][loop] = compute_M_gg_ba(1, 2, 6, 5, 8, 7, 1, loop, 1); // M_RRLL
    M_undressed[1][1][0][1][loop] = compute_M_gg_ba(1, 2, 6, 5, 7, 8, 1, loop, 1); // M_RRLR
    M_undressed[1][1][1][0][loop] = compute_M_gg_ba(1, 2, 5, 6, 8, 7, 1, loop, 1); // M_RRRL
    M_undressed[1][1][1][1][loop] = compute_M_gg_ba(1, 2, 5, 6, 7, 8, 1, loop, 1); // M_RRRR
  }

  // compute (and return) dressed amplitudes
  for (int loop = 0; loop < 2; loop++) {
    for (int h1 = 0; h1 < 2; h1++) {
      for (int h2 = 0; h2 < 2; h2++) {
	for (int h3 = 0; h3 < 2; h3++) {
	  for (int h4 = 0; h4 < 2; h4++) {
	    M_gg_dressed_tmp[h1][h2][h3][h4][loop] = DR[i_x][i_a].N_VV * M_undressed[h1][h2][h3][h4][loop];
	    M_gg_dressed_tmp[h1][h2][h3][h4][loop] *= (DR[i_x][i_a].LR56[h3] * DR[i_x][i_a].LR78[h4] / DV1 / DV2);         
	    M_gg_dressed_tmp[h1][h2][h3][h4][loop] *= double_complex(0,1);
	  }
        }
      }
    }
  }
  
  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}


double_complex ppllll04_amplitude_NLOgg_set::compute_M_gg_ab(int i1, int i2, int i5, int i6, int i7, int i8, int hel, int loop, int type){
  static Logger logger("ppllll04_amplitude_NLOgg_set::compute_M_gg_ab");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  i5 -= 2;
  i6 -= 2;
  i7 -= 2;
  i8 -= 2;

//  cout << i1 << ", " << i2 << ", " << i5 << ", " << i6 << ", " << i7 << ", " << i8 << endl;

  double_complex result=0.0;
  result += E[loop][type][0] * za[i5][i7] * zb[i6][i8];
  result += E[loop][type][1] * za[i1][i5] * za[i1][i7] * zb[i1][i6] * zb[i1][i8];
  result += E[loop][type][2] * za[i1][i5] * za[i2][i7] * zb[i1][i6] * zb[i2][i8];
  result += E[loop][type][3] * za[i2][i5] * za[i1][i7] * zb[i2][i6] * zb[i1][i8];
  result += E[loop][type][4] * za[i2][i5] * za[i2][i7] * zb[i2][i6] * zb[i2][i8];
  // multiply first bracket (...) of eqn. (3.12)
  result *= (zb[i2][i5] * za[i5][i1]+zb[i2][i6] * za[i6][i1]); // = |2 /p3 1>

  result += E[loop][type][5] * za[i1][i5] * za[i1][i7] * zb[i1][i6] * zb[i2][i8];
  result += E[loop][type][6] * za[i1][i5] * za[i1][i7] * zb[i2][i6] * zb[i1][i8];
  result += E[loop][type][7] * za[i1][i5] * za[i2][i7] * zb[i2][i6] * zb[i2][i8];
  result += E[loop][type][8] * za[i2][i5] * za[i1][i7] * zb[i2][i6] * zb[i2][i8];

  if (hel == 0){
    result *= (zb[i1][i5] * za[i5][i2]+zb[i1][i6] * za[i6][i2]) * za[i1][i2]/zb[i1][i2]; // = C_LL = |1 /p3 2> * <12>/[12]
  }
  else if (hel == 1){
    result *= (zb[i2][i5] * za[i5][i1]+zb[i2][i6] * za[i6][i1]); // = C_LR = |2 /p3 1>
  }
  logger << LOG_DEBUG_VERBOSE << "finished - return " << result << endl;
  return result;
}


double_complex ppllll04_amplitude_NLOgg_set::compute_M_gg_ba(int i1, int i2, int i5, int i6, int i7, int i8, int hel, int loop, int type){
  static Logger logger("ppllll04_amplitude_NLOgg_set::compute_M_gg_ba");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  i5 -= 2;
  i6 -= 2;
  i7 -= 2;
  i8 -= 2;

//  cout << i1 << ", " << i2 << ", " << i5 << ", " << i6 << ", " << i7 << ", " << i8 << endl;

  double_complex result = 0.;
  result += E[loop][type][0] * zb[i5][i7] * za[i6][i8];
  result += E[loop][type][1] * zb[i1][i5] * zb[i1][i7] * za[i1][i6] * za[i1][i8];
  result += E[loop][type][2] * zb[i1][i5] * zb[i2][i7] * za[i1][i6] * za[i2][i8];
  result += E[loop][type][3] * zb[i2][i5] * zb[i1][i7] * za[i2][i6] * za[i1][i8];
  result += E[loop][type][4] * zb[i2][i5] * zb[i2][i7] * za[i2][i6] * za[i2][i8];
  // multiply first bracket (...) of eqn. (3.12)
  result *= (za[i2][i5] * zb[i5][i1]+za[i2][i6] * zb[i6][i1]); // = |2 /p3 1>

  result += E[loop][type][5] * zb[i1][i5] * zb[i1][i7] * za[i1][i6] * za[i2][i8];
  result += E[loop][type][6] * zb[i1][i5] * zb[i1][i7] * za[i2][i6] * za[i1][i8];
  result += E[loop][type][7] * zb[i1][i5] * zb[i2][i7] * za[i2][i6] * za[i2][i8];
  result += E[loop][type][8] * zb[i2][i5] * zb[i1][i7] * za[i2][i6] * za[i2][i8];

  if (hel == 0){
    result *= (za[i1][i5] * zb[i5][i2]+za[i1][i6] * zb[i6][i2]) * zb[i1][i2]/za[i1][i2]; // = C_LL = |1 /p3 2> * <12>/[12]
  }
  else if (hel == 1) {
    result *= (za[i2][i5] * zb[i5][i1]+za[i2][i6] * zb[i6][i1]); // = C_LR = |2 /p3 1>
  }

  logger << LOG_DEBUG_VERBOSE << "finished - return " << result << endl;
  return result;
}

