#include "header.hpp"

#include "ppllll04.amplitude.set.hpp"

#ifdef OPENLOOPS

ppllll04_amplitude_OpenLoops_set::ppllll04_amplitude_OpenLoops_set(){
  static Logger logger("ppllll04_amplitude_OpenLoops_set::ppllll04_amplitude_OpenLoops_set ()");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  logger << LOG_DEBUG << "constructor called..." << endline_flush;

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

ppllll04_amplitude_OpenLoops_set::~ppllll04_amplitude_OpenLoops_set(){
  static Logger logger("ppllll04_amplitude_OpenLoops_set::~ppllll04_amplitude_OpenLoops_set ()");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  logger << LOG_DEBUG << "destructor called..." << endline_flush;

  if (csi->type_contribution == "VT2" && csi->type_correction == "QCD"){finalization_H2_QCD_2loop();}

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void ppllll04_amplitude_OpenLoops_set::initialization_process(){
  static Logger logger("ppllll04_amplitude_OpenLoops_set::initialization_process");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  process_id = -1;
  if (csi->type_contribution == "VT2" && csi->type_correction == "QCD"){
    munich_ol_setparameter_int("order_ew", csi->contribution_order_alpha_e, logger);
    process_id = register_OL_subprocess(0, 11);
  }
  else {amplitude_OpenLoops_set::initialization_process();}

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void ppllll04_amplitude_OpenLoops_set::initialization_process_extra(){
  static Logger logger("ppllll04_amplitude_OpenLoops_set::initialization_process_extra");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  amplitude_OpenLoops_set::initialization_process_extra();

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void ppllll04_amplitude_OpenLoops_set::initialization_H2_QCD_2loop(){
  static Logger logger("ppllll04_amplitude_OpenLoops_set::initialization_H2_QCD_2loop");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  ppllll04_amplitude_set::initialization_H2_QCD_2loop();

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void ppllll04_amplitude_OpenLoops_set::finalization_H2_QCD_2loop(){
  static Logger logger("ppllll04_amplitude_OpenLoops_set::finalization_H2_QCD_2loop");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  ppllll04_amplitude_set::finalization_H2_QCD_2loop();

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void ppllll04_amplitude_OpenLoops_set::calculate_H2_QCD_2loop(){
  static Logger logger("ppllll04_amplitude_OpenLoops_set::calculate_H2_QCD_2loop");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  ppllll04_amplitude_set::calculate_H2_QCD_2loop();

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

#endif
