CC    Counterterm to be subtracted from real+virt to get a finite
CC    cross section at qt->0

C     Version that allows to separate also qg channel

C     Scale dependence included up to NNLO

      double precision function countint(vector,wgt)
      implicit none
      include 'constants.f'
      include 'realonly.f'
      include 'virtonly.f'
      include 'noglue.f'
      include 'vegas_common.f'
      include 'ptilde.f'
      include 'npart.f'
      include 'scale.f'
      include 'facscale.f'
      include 'zerowidth.f'
      include 'efficiency.f'
      include 'masses.f'
      include 'limits.f'
C
      include 'jetlabel.f'
      include 'qcdcouple.f'
      include 'phasemin.f'
      include 'rescoeff.f'
      include 'dynamicscale.f'
C
      integer ih1,ih2,j,k,l,nd,nmax,nmin,nvec,order
      integer i1,j1
      integer nproc
      common/nproc/nproc
      double precision vector(mxdim),W,val,xint
      double precision sqrts,qtmax
      double precision p(mxpart,4),pjet(mxpart,4),p1ext(4),p2ext(4)
      double precision pswt,rscalestart,fscalestart
      double precision s(mxpart,mxpart),wgt,msq(-nf:nf,-nf:nf)
      double precision msqc(-nf:nf,-nf:nf),xmsq(0:maxd)
      double precision flux,BrnRat,xreal,xreal2
      double precision xx1,xx2,q(mxpart,4)
      double precision m3,m4,m5,qtcut,xqtcut
CC
      logical cuts
      double precision x1,x2,dot,ptrans(mxpart,4)

ch
      double precision ptransb(mxpart,4)

ch
      double precision q2,qt2,shat,Itilde
      double precision fx10(-nf:nf),fx20(-nf:nf)
      double precision fx1p(-nf:nf),fx2p(-nf:nf)
      double precision alfa,beta,diff,Pqq,Pqg,Pqqint,Cqq,Cqg
ch
      double precision Pggreg,Pgq
ch
      double precision xjacq2,xjacqt2,xth,x3,almin,almax
      double precision xmio,fluxborn,pswt0
      double precision shad,yq,zmax,tauh,Vol,y3
      double precision xx0(2),xx10,xx20
      double precision sig1,sig2,LR,LF
      double precision sig11,sig12,sig11q,sig12q,sig11g,sig12g
      double precision sig21,sig22,sig23,sig24
ch
      double precision sig21q,sig22q,sig23q,sig24q
      double precision sig21g,sig22g,sig23g,sig24g
ch
      double precision tdelta,tH1st,tH1stF
ch     .        ,tgaga,tcga,tgamma2
ch
      double precision tdeltaq,tdeltaqb,tH1stq,tH1stFq,tdeltag,
     .                 tH1stFg,tH1stg,tH1stFqb
      double precision tgagaq,tcgaq,tgamma2q
      double precision tgagag,tcgag,tgamma2g
ch
      double precision LL1,LL2,LL3,LL4
      double precision z1,z2,diff1,diff2,cut
ch
      double precision diff1q,diff2q,diffq
      double precision diff1g,diff2g,diffg
      double precision diff1fg,diff2fg
ch
      double precision D0int,D1int
      double precision Pqqqq,Pqqqg,Pqggq,Pqggg
      double precision Pgggq,Pgqqq,CgqPqq,P2gq
      double precision CqqPqq,CqqPqg,CqgPgq,CqgPgg
      double precision P2qg,P2qqV,P2qqbV,P2qqS
      double precision Pggggreg,Pgqqg,
     .                 CgqPqg,P2gg,Cgq
ch      double precision diffg10,diffg20,diffc10,diffc20
ch      double precision diffg1f,diffg2f,diffc1f,diffc2f
ch
      double precision diffg10q,diffg20q,diffc10q,diffc20q
      double precision diffg1fq,diffg2fq,diffc1fq,diffc2fq
      double precision diffg10g,diffg20g,diffc10g,diffc20g
      double precision diffg1fg,diffg2fg,diffc1fg,diffc2fg
      double precision diff10g,diff20g
ch
      external Itilde,Pqq,Pqg,Cqq,Cqg,Pqqint,D0int,D1int
      external Pqqqq,Pqqqg,Pqggq,Pqggg,CqqPqq,CqqPqg,CqgPgq,CqgPgg
      external P2qqV,P2qqbV,P2qg,P2qqS,Pggreg,Pgq
      external Pggggreg,Pgqqg
      external CgqPqg,P2gg,Cgq
      external L34,myLi2
      double precision L34,pt,myLi2

ch
      double precision H1qqdelta,H1ggdelta,
     .                 H1qdelta,H1qbdelta,H1gdelta
      double precision beta04f
ch
      common/xmio/xmio
      common/xx0/xx0
      common/qtcut/xqtcut
      common/nnlo/order 

CC
CC    Variables passed from virtint or lowint
CC
      common/count/qt2,q2,shat


ch
      double precision y34,v34,logfin,betat,vs,vsqmin,vsqmax,
     .               Gamma1qM0M0,Gamma1gM0M0,Gamma1q,Gamma1qb,
     .               Gamma1g
      common/colour/Tqq,Tgg,Tsinglet,Toktsym,Toktasym
      double precision Tsinglet
      double precision Toktsym
      double precision Toktasym
      double precision Tqq(1:4,1:4)
      double precision Tgg(1:4,1:4)

ch    kinematical factor needed for the matrix element in the gg channel

      double precision kinasym

      double precision msqcgg

ch

CC
      integer n2,n3,sgnj,sgnk,flgq
      double precision mass2,width2,mass3,width3
      common/breit/n2,n3,mass2,width2,mass3,width3
      common/xreal/xreal,xreal2
      logical bin,first,failed
      logical incldip(0:maxd),includedipole,includereal
      logical creatent,dswhisto
      common/density/ih1,ih2
      common/energy/sqrts
      common/bin/bin
      common/Pext/p1ext,p2ext
      common/nmax/nmax
      common/BrnRat/BrnRat
      common/nmin/nmin
      common/incldip/incldip
      common/outputflags/creatent,dswhisto
      data p/48*0d0/
      data first/.true./
      save first,rscalestart,fscalestart
      if (first) then
         first=.false.
         rscalestart=scale
         fscalestart=facscale
      endif
      ntotshot=ntotshot+1
      pswt=0d0
      countint=0d0 

      do nd=0,1
      xmsq(nd)=0d0
      enddo     

      beta04f=(33-2*4)/12d0

c      if(zerowidth) then

CC Check if q2 is the proper interval
      
      if(q2.lt.wsqmin.or.q2.gt.wsqmax) goto 999
c      xjacq2=pi*mass3*width3
c      else

CC   Generate q2 again, up to wsqmax

      x3=vector(6)
c      vsqmax=1d0/wsqmin
c      vsqmin=1d0/wsqmax
c      vs=(vsqmax-vsqmin)*x3+vsqmin
c      q2=1/vs
c      xjacq2=(vsqmax-vsqmin)*q2**2
      q2=wsqmin+x3*(wsqmax-wsqmin)
      xjacq2=wsqmax-wsqmin
c      xjacq2=shat-4*mt**2

c      endif

CC   Generate qt2 up to qtmax

      xth=vector(3)

CC  Now compute qtcut from xqtcut

       qtcut=xqtcut*dsqrt(q2)

       if(xth.lt.0.02d0) goto 999
       qt2=qtcut**2*dexp(1d0/xth-1)


CC    Jacobian for qt2

      xjacqt2=1d0/xth**2*qt2



      shad=sqrts**2

      xmio=dsqrt(qt2/q2)
      
      npart=3      
      nvec=npart+2

      Vol=1d0
   

CC   Dynamic scale

      if(dynamicscale) call scaleset(q2)

CC   LR,LF

    
      LR=dlog(q2/scale**2)
      LF=dlog(q2/facscale**2) 

   
   

CC   LL1,LL2,LL3,LL4: large log (squared) corresponding to eq. (136) 
CC   In this way normalization is fixed to dsigma/dqt2


      LL1=Itilde(1)/q2**2
ch      LL1=-1d0/qt2/q2
      LL2=Itilde(2)/q2**2
ch      LL2=4d0/qt2/q2*dlog(xmio)
      LL3=Itilde(3)/q2**2
ch      LL3=-12d0/qt2/q2*dlog(xmio)**2
      LL4=Itilde(4)/q2**2
ch      write(*,*)LL1,LL2,LL3,LL4,'a'

  

CC Generate BORN momenta for counterterm
      
c      call genBORN2(q2,shat,vector,ptrans,pswt0,*999)
ch
      call genBORN2m(q2,shat,vector,ptrans,pswt0,*999)
      v34=dsqrt(1-4d0*mt**4/((2d0*dot(ptrans,3,4))**2))
      pt=dsqrt(ptrans(4,1)**2+ptrans(4,2)**2)

ch
      call storeptilde(1,ptrans)

CC Here we have to check if the counterevent passes the cuts

       jets=0
       incldip(1)=cuts(ptrans,0)
c       if (incldip(1)) goto 999

CC Compute Born matrix element


c      if(nproc.eq.3)then
c      call qqb_z(ptrans,msqc)
c      else
c      call qqb_w(ptrans,msqc)
c      endif
ch

      do i1=1,mxpart
      do j1=1,4
      if(i1.gt.2)then
      ptransb(i1,j1)=ptrans(i1,j1)
      elseif(i1.eq.1)then
      ptransb(1,j1)=ptrans(2,j1)
      elseif(i1.eq.2)then
      ptransb(2,j1)=ptrans(1,j1)
      endif
      enddo
      enddo
      call qqb_QQb(ptrans,msqc,0)

      kinasym=(2d0*dot(ptrans,1,3)-2d0*dot(ptrans,2,3))
     .        /(2d0*dot(ptrans,1,2))

      msqcgg=msqc(0,0)

      msqc(0,0)=msqc(0,0)*(Tsinglet+Toktsym+Toktasym*kinasym**2)
c      write(*,*)msqc(0,0),kinasym
      
      Tgg(1,1)=ca*msqc(0,0)
      Tgg(2,2)=ca*msqc(0,0)
      Tgg(3,3)=cf*msqc(0,0)
      Tgg(4,4)=cf*msqc(0,0)
      Tgg(3,4)=((ca/2d0-cf)*(Toktsym+Toktasym*kinasym**2)
     .         -cf*Tsinglet)*msqcgg
      Tgg(1,3)=-ca/4d0*(Toktsym+Toktasym*kinasym**2
     .                 +Toktasym*kinasym+2d0*Tsinglet*kinasym
     .                 +Toktsym*kinasym)*msqcgg
      Tgg(1,4)=-ca/4d0*(Toktsym+Toktasym*kinasym**2
     .                 -Toktasym*kinasym-2d0*Tsinglet*kinasym
     .                 -Toktsym*kinasym)*msqcgg
      Tgg(2,3)=Tgg(1,4)
      Tgg(2,4)=Tgg(1,3)
ch      write(*,*)msqc(0,0),'q'
ch      write(*,*)Tgg(1,3),'wq1'
ch      write(*,*)Tgg(2,4),'wq2'
ch      write(*,*)Tgg(1,1),'wq3'
ch      write(*,*)Tqq(1,4)+Tqq(2,4)+Tqq(4,4)+Tqq(3,4)     
c      write(*,*)msqc(1,-1),'msqc'
c      do j=1,4
c      write(*,*)ptrans(1,j),'ptrans1',j
c      write(*,*)ptrans(2,j),'ptrans2',j
c      write(*,*)ptrans(3,j),'ptrans3',j
c      write(*,*)ptrans(4,j),'ptrans4',j
c      write(*,*)dsqrt(q2),'q'
c      enddo
c      do j=-nf,nf
c      do k=-nf,nf
c      if(j.eq.-k)then
c      msqc(j,k)=2*dot(ptrans,3,4)/sqrts**2
c      endif
c      enddo
c      enddo

      betat=dsqrt(1-4*mt**2/q2)
ch  


C Scaled momentum fractions

      cut=1d-7
   

      beta=cut+(1-cut)*vector(8)
      alfa=cut+(1-cut)*vector(9)

      xx10=xx0(1)
      xx20=xx0(2)
c      write(*,*)dsqrt(-2*dot(ptrans,1,3)+mt**2),'a'
c      write(*,*)dsqrt((ptrans(1,4)-ptrans(3,4))**2
c     .          -(ptrans(1,3)-ptrans(3,3))**2
c     .          -(ptrans(1,2)-ptrans(3,2))**2
c     .          -(ptrans(1,1)-ptrans(3,1))**2)

ch      xx10=0.426883676710647d0
ch      xx20=0.832506199168213d0
ch      alfa=0.491091579871728d0
ch      beta=0.196308205115838d0
ch      msqc(0,0)=5.24695775775360d0
ch      msqc(0,0)=0d0
ch      LL1=-0.000000004267013419514816d0
ch      LL2=-0.0000001009997713546848d0
ch      LL3=-0.000001792969733154202d0
ch      LL4=-0.00002821048441927710d0
ch      facscale=173.3d0
ch      scale=173.3d0
ch      ason2pi=0.01700411926779227d0
ch      LR=5.24695775775360d0
ch      LF=5.24695775775360d0
      

      z1=xx10**beta
      z2=xx20**alfa

      y34=0.5d0*dlog(xx10/xx20)
c      write(*,*)y34,'y34'
c      write(*,*)0.5d0*dlog((ptrans(4,4)+ptrans(3,4)
c     .          +ptrans(4,3)+ptrans(3,3))/
c     .          (ptrans(4,4)+ptrans(3,4)
c     .          -ptrans(4,3)-ptrans(3,3)))

c      call genCT2(q2,qt2,y34,vector,p,pswt,*999)
ch
       call genCT2m(q2,qt2,y34,vector,p,pswt,*999)
c      write(*,*)y34,'y34'
c      write(*,*)0.5d0*dlog((p(4,4)+p(3,4)
c     .          +p(4,3)+p(3,3))/
c     .          (p(4,4)+p(3,4)
c     .          -p(4,3)-p(3,3)))
ch

ch    Gamma1 with as/pi normalization

      Gamma1q=0.5d0*(
     .       Tqq(3,3)+Tqq(4,4)
     .      +1d0/v34*dlog((1d0+v34)/(1d0-v34))
     .      *Tqq(3,4)
     .      +dlog(4d0*dot(ptrans,1,3)**2/(q2*mt**2))*Tqq(1,3)
     .      +dlog(4d0*dot(ptrans,1,4)**2/(q2*mt**2))*Tqq(1,4)
     .      +dlog(4d0*dot(ptrans,2,3)**2/(q2*mt**2))*Tqq(2,3)
     .      +dlog(4d0*dot(ptrans,2,4)**2/(q2*mt**2))*Tqq(2,4))

      Gamma1qb=0.5d0*(
     .       Tqq(3,3)+Tqq(4,4)
     .      +1d0/v34*dlog((1d0+v34)/(1d0-v34))
     .      *Tqq(3,4)
     .      +dlog(4d0*dot(ptrans,2,3)**2/(q2*mt**2))*Tqq(1,3)
     .      +dlog(4d0*dot(ptrans,2,4)**2/(q2*mt**2))*Tqq(1,4)
     .      +dlog(4d0*dot(ptrans,1,3)**2/(q2*mt**2))*Tqq(2,3)
     .      +dlog(4d0*dot(ptrans,1,4)**2/(q2*mt**2))*Tqq(2,4))

      Gamma1g=0.5d0*(
     .       Tgg(3,3)+Tgg(4,4)
     .      +1d0/v34*dlog((1d0+v34)/(1d0-v34))
     .      *Tgg(3,4)
     .      +dlog(4d0*dot(ptrans,1,3)**2/(q2*mt**2))*Tgg(1,3)
     .      +dlog(4d0*dot(ptrans,1,4)**2/(q2*mt**2))*Tgg(1,4)
     .      +dlog(4d0*dot(ptrans,2,3)**2/(q2*mt**2))*Tgg(2,3)
     .      +dlog(4d0*dot(ptrans,2,4)**2/(q2*mt**2))*Tgg(2,4))
     .      /msqc(0,0)

ch      H1qdelta=2*H1qqdelta(ptrans)/msqc(1,-1)
ch      H1qbdelta=2*H1qqdelta(ptransb)/msqc(1,-1)
ch      H1gdelta=2*H1ggdelta(ptrans)/msqc(0,0)
ch      do j=1,nf
ch       msqc(j,-j)=5.24349255330604d0
ch       msqc(-j,j)=5.24349255330604d0
ch      msqc(j,-j)=0d0
ch      msqc(-j,j)=0d0
ch      enddo

      if(order.eq.2)then

      H1qdelta=H1qqdelta(ptrans)/msqc(1,-1)
ch      H1qdelta=2*C1qqdelta
ch      H1qbdelta=2*C1qqdelta

       H1qbdelta=H1qqdelta(ptransb)/msqc(1,-1)
ch      write(*,*)H1qdelta,H1qbdelta,'a'

       H1gdelta=H1ggdelta(ptrans)/msqc(0,0)
ch      H1gdelta=2*C1ggdelta-2*beta0*LR
ch      Gamma1q=0d0
ch      Gamma1qb=0d0
ch      Gamma1g=0d0
      else
       H1qdelta=0d0
       H1qbdelta=0d0
       H1gdelta=0d0
      endif
ch      H1qdelta=2d0*C1qqdelta
ch      H1qbdelta=2d0*C1qqdelta
ch      H1gdelta=2d0*C1ggdelta-2d0*beta0*LR
ch      Gamma1q=0d0
ch      Gamma1qb=0d0
ch      Gamma1g=0d0
ch      write(*,*)ason2pi*2d0*(H1qdelta*msqc(1,-1)
ch     .             +2*beta0*LR*msqc(1,-1)),'1loopqq'
ch      write(*,*)ason2pi*2d0*(H1gdelta*msqc(0,0)
ch     .              +2*beta0*LR*msqc(0,0)),'1loopgg'
ch      write(*,*)dsqrt(2*dot(ptrans,1,2)),'2'
ch      write(*,*)2*dot(ptrans,1,3),'3'
ch      write(*,*)2*dot(ptrans,2,3),'4'
ch      write(*,*)as,'6'
ch      write(*,*)scale,'7'

ch      write(*,*)msqc(1,-1),msqc(2,-2),msqc(0,0)
c      write(*,*)H1qdelta,H1gdelta,'a'

ch      H1qdelta=H1qdelta+cf*pi**2/6d0
ch      H1qbdelta=H1qbdelta+cf*pi**2/6d0
ch      H1gdelta=H1gdelta+ca*pi**2/6d0
ch      H1qdelta=0d0
ch      H1qbdelta=0d0
ch      H1gdelta=0d0
ch        write(*,*)H1qdelta,H1gdelta,'a'
ch        write(*,*)2*H1qqdelta(ptrans)/msqc(1,-1),
ch     .            2*H1qqdelta(ptransb)/msqc(1,-1),
ch     .            2*H1ggdelta(ptrans)/msqc(0,0),'b'



ch
       incldip(1)=cuts(p,0)
       if (incldip(1)) goto 999
ch       if (dsqrt(qt2).lt. 0.0001d0) goto 999
ch       if(xmio.gt.0.0025d0.or.xmio.lt.0.002d0)goto 999

           
c--- calculate PDF's  

c      if(xx10.lt.1d-5)write(*,*)q2,xx10
c      if(xx20.lt.1d-5)write(*,*)q2,xx20

      call fdist(ih1,xx10,facscale,fx10)
      call fdist(ih2,xx20,facscale,fx20)

      call fdist(ih1,xx10**(1-beta),facscale,fx1p)
      call fdist(ih2,xx20**(1-alfa),facscale,fx2p)


CC Switch off gluon !!

      if(noglue) then
        fx10(0)=0d0
        fx20(0)=0d0
        fx1p(0)=0d0
        fx2p(0)=0d0
      endif

CC Gluon only !

      if(ggonly) then
       do j=1,5
       fx10(j)=0d0
       fx10(-j)=0d0
       fx1p(j)=0d0
       fx1p(-j)=0d0
       fx20(j)=0d0
       fx20(-j)=0d0
       fx2p(j)=0d0
       fx2p(-j)=0d0
       enddo
      endif

       flgq=1
       if(gqonly)flgq=0
ch        do j=1,5
ch       fx10(j)=0d0
ch       fx10(-j)=0d0
ch       fx1p(j)=0d0
ch       fx1p(-j)=0d0
ch       fx20(j)=0d0
ch       fx20(-j)=0d0
ch       fx2p(j)=0d0
ch       fx2p(-j)=0d0
ch       enddo
        
ch        fx10(0)=0d0
ch        fx20(0)=0d0
ch        fx1p(0)=0d0
ch        fx2p(0)=0d0

ch       do j=1,5
ch       fx10(-j)=0d0
ch       fx1p(-j)=0d0
ch       fx20(-j)=0d0
ch       fx2p(-j)=0d0
ch       fx10(j)=0d0
ch       fx1p(j)=0d0
ch       fx20(j)=0d0
ch       fx2p(j)=0d0
ch       enddo
CC     TIENI SOLO uubar
c        do j=-nf,1
c        fx10(j)=0d0
c        fx1p(j)=0d0
c        enddo
c        do j=3,nf
c        fx10(j)=0d0
c        fx1p(j)=0d0
c        enddo
c        do j=-nf,-3
c        fx20(j)=0d0
c        fx2p(j)=0d0
c        enddo
c        do j=-1,nf
c        fx20(j)=0d0
c        fx2p(j)=0d0
c        enddo
CC


C Flux for Born cross section


       fluxborn=fbGeV2/(2*q2)


CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

CC Start construction of the counterterm

        tdelta=0d0
        tdeltaq=0d0
        tdeltaqb=0d0
        tdeltag=0d0
        tH1st=0d0
        tH1stq=0d0
        tH1stg=0d0
        tH1stF=0d0
        tH1stFq=0d0
        tH1stFqb=0d0
        tH1stFg=0d0
ch        tgaga=0d0
ch        tcga=0d0
ch        tgamma2=0d0
        tgagaq=0d0
        tcgaq=0d0
        tgamma2q=0d0
        tgagag=0d0
        tcgag=0d0
        tgamma2g=0d0

ch        diffc10=0d0
ch        diffc1f=0d0
ch        diffc20=0d0
ch        diffc2f=0d0

ch        diffg10=0d0
ch        diffg1f=0d0
ch        diffg20=0d0
ch        diffg2f=0d0

        diffc10q=0d0
        diffc1fq=0d0
        diffc20q=0d0
        diffc2fq=0d0

        diffg10q=0d0
        diffg1fq=0d0
        diffg20q=0d0
        diffg2fq=0d0

        diffc10g=0d0
        diffc1fg=0d0
        diffc20g=0d0
        diffc2fg=0d0

        diffg10g=0d0
        diffg1fg=0d0
        diffg20g=0d0
        diffg2fg=0d0

        diff10g=0d0
        diff20g=0d0

        diff1fg=0d0
        diff2fg=0d0

        sig1=0d0
        sig2=0d0

        sig11q=0d0
        sig12q=0d0
        sig11g=0d0
        sig12g=0d0
        sig11=0d0
        sig12=0d0
        sig21=0d0      
        sig22=0d0
        sig23=0d0
        sig24=0d0

        sig21q=0d0      
        sig22q=0d0
        sig23q=0d0
        sig24q=0d0

        sig21g=0d0      
        sig22g=0d0
        sig23g=0d0
        sig24g=0d0
ch
        Gamma1qM0M0=0d0
        Gamma1gM0M0=0d0
ch

      
ch      write(*,*)z1,z2,xx10,xx20,facscale,beta,alfa,'1'
ch      write(*,*)msqc(1,-1),msqc(0,0),'2'
      do j=-nf,nf
      do k=-nf,nf


c      if(k.ne.0.or.j.ne.0) goto 75
ch
      if(msqc(j,k).eq.0d0) goto 75

C     Simplest term without convolutions
      
      if(j.gt.0.and.k.lt.0)then
       tdeltaq=tdeltaq+fx10(j)*fx20(k)*msqc(j,k)*flgq
      elseif(j.lt.0.and.k.gt.0)then
       tdeltaqb=tdeltaqb+fx10(j)*fx20(k)*msqc(j,k)*flgq
      elseif(j.eq.0.and.k.eq.0)then
       tdeltag=tdeltag+fx10(j)*fx20(k)*msqc(j,k)*flgq
      endif


C     Start H1st: to be used later

C     H1st delta term

ch      tH1st=tH1st+2*C1qqdelta*fx10(j)*fx20(k)*msqc(j,k)*flgq

        if(j.gt.0.and.k.lt.0)then
         tH1stq=tH1stq+H1qdelta*msqc(j,k)*fx10(j)*fx20(k)*flgq
        elseif(j.lt.0.and.k.gt.0)then
         tH1stq=tH1stq+H1qbdelta*msqc(j,k)*fx10(j)*fx20(k)*flgq
         elseif(j.eq.0.and.k.eq.0)then
          tH1stg=tH1stg+H1gdelta*msqc(j,k)*fx10(j)*fx20(k)*flgq
        endif

ch        if(j.gt.0.and.k.lt.0)then
ch         tH1stq=tH1stq+2*C1qqdelta*msqc(j,k)*fx10(j)*fx20(k)*flgq
ch        elseif(j.lt.0.and.k.gt.0)then
ch         tH1stq=tH1stq+2*C1qqdelta*msqc(j,k)*fx10(j)*fx20(k)*flgq
ch         elseif(j.eq.0.and.k.eq.0)then
ch          tH1stg=tH1stg+2*C1ggdelta*msqc(j,k)*fx10(j)*fx20(k)*flgq
ch        endif
c       tH1st


      if(j.ne.0.and.k.ne.0)then

C     H1st: non delta terms, first leg

       tH1stq=tH1stq+(fx1p(j)*Cqq(z1)*flgq+fx1p(0)*Cqg(z1))
     & *(-dlog(xx10))*fx20(k)*msqc(j,k)


C     H1st: non delta terms, second leg


       tH1stq=tH1stq+(fx2p(k)*Cqq(z2)*flgq+fx2p(0)*Cqg(z2))         
     & *(-dlog(xx20))*fx10(j)*msqc(j,k)

      endif
      

C     H1st: muf dependence (LF factor to be added at the end)


c     gammaqq and gammaqg: first leg

ch    gammagg: first leg is included      


c      diff=-dlog(xx10)
c     &  *((fx1p(j)-fx10(j)*xx10**beta)*Pqq(z1)*flgq+fx1p(0)*Pqg(z1))
ch
      if(j.ne.0.and.k.ne.0)then
       diff=-dlog(xx10)
     &  *((fx1p(j)-fx10(j)*xx10**beta)*Pqq(z1)*flgq+fx1p(0)*Pqg(z1))
      elseif(j.eq.0.and.k.eq.0)then
       diff=-dlog(xx10)*((fx1p(0)-fx10(0)*xx10**beta)*3/(1-z1)
     &    +fx1p(0)*Pggreg(z1))*flgq
      endif

ch
      if(j.ne.0.and.k.ne.0)then
ch       if(j.gt.0.and.k.lt.0)then
       tH1stFq=tH1stFq+diff*fx20(k)*msqc(j,k)
ch       tH1stFq=tH1stFq+diff*fx20(k)
       tH1stFq=tH1stFq-Pqqint(xx10)*fx10(j)*fx20(k)*msqc(j,k)*flgq
ch      elseif(j.lt.0.and.k.gt.0)then
ch       tH1stFqb=tH1stFqb+diff*fx20(k)*msqc(j,k)
ch       tH1stFq=tH1stFq+diff*fx20(k)
ch       tH1stFqb=tH1stFqb-Pqqint(xx10)*fx10(j)*fx20(k)*msqc(j,k)*flgq
      elseif(j.eq.0.and.k.eq.0)then
       tH1stFg=tH1stFg+diff*fx20(0)*msqc(j,k)
       tH1stFg=tH1stFg-3*D0int(xx10)*fx10(0)*fx20(0)*msqc(j,k)*flgq
      endif

ch

c     gammaqq and gammaqg: second leg   

ch    gammagg: second leg is included


c      diff=-dlog(xx20)
c     &  *((fx2p(k)-fx20(k)*xx20**alfa)*Pqq(z2)*flgq+fx2p(0)*Pqg(z2))
ch
      if(j.ne.0.and.k.ne.0)then
       diff=-dlog(xx20)
     &  *((fx2p(k)-fx20(k)*xx20**alfa)*Pqq(z2)*flgq+fx2p(0)*Pqg(z2))
      elseif(j.eq.0.and.k.eq.0)then
       diff=-dlog(xx20)*((fx2p(0)-fx20(0)*xx20**alfa)*3/(1-z2)
     &    +fx2p(0)*Pggreg(z2))*flgq
      endif

ch
      if(j.ne.0.and.k.ne.0)then
ch       if(j.gt.0.and.k.lt.0)then
       tH1stFq=tH1stFq+diff*fx10(j)*msqc(j,k)
ch       tH1stFq=tH1stFq+diff*fx10(j)
       tH1stFq=tH1stFq-Pqqint(xx20)*fx10(j)*fx20(k)*msqc(j,k)*flgq
ch      elseif(j.lt.0.and.k.gt.0)then
ch       tH1stFqb=tH1stFqb+diff*fx10(j)*msqc(j,k)
ch       tH1stFq=tH1stFq+diff*fx10(j)
ch       tH1stFqb=tH1stFqb-Pqqint(xx20)*fx10(j)*fx20(k)*msqc(j,k)*flgq
      elseif(j.eq.0.and.k.eq.0)then
       tH1stFg=tH1stFg+diff*fx10(0)*msqc(j,k)
       tH1stFg=tH1stFg-3*D0int(xx20)*fx10(0)*fx20(0)*msqc(j,k)*flgq
      endif

ch

c     gammagg: delta term, both legs

      if(j.eq.0.and.k.eq.0)then
       tH1stFg=tH1stFg+2*beta0*fx10(0)*fx20(0)*msqc(j,k)*flgq
      endif

CC    End of H1st


ch    Final state radiation

ch    qq channel

c      if (j.ne.0.and.k.ne.0)then
c      logfin=logfin+(
c     .       Tqq(3,3)+Tqq(4,4)
c     .      +1d0/v34*dlog((1d0+v34)/(1d0-v34))
c     .      *Tqq(3,4)
c     .      +dlog(4d0*dot(ptrans,1,3)**2/(q2*mt**2))*Tqq(1,3)
c     .      +dlog(4d0*dot(ptrans,1,4)**2/(q2*mt**2))*Tqq(1,4)
c     .      +dlog(4d0*dot(ptrans,2,3)**2/(q2*mt**2))*Tqq(2,3)
c     .      +dlog(4d0*dot(ptrans,2,4)**2/(q2*mt**2))*Tqq(2,4))
c     .      *fx10(j)*fx20(k)*msqc(j,k)*flgq
c      endif

ch      if (j.ne.0.and.k.ne.0)then
ch      if(j.gt.0.and.k.lt.0)then
ch      logfin=logfin+(
ch     .       Tqq(3,3)+Tqq(4,4)
ch     .      +1d0/v34*dlog((1d0+v34)/(1d0-v34))
ch     .      *Tqq(3,4)
ch     .      +dlog(4d0*dot(ptrans,1,3)**2/(q2*mt**2))*Tqq(1,3)
ch     .      +dlog(4d0*dot(ptrans,1,4)**2/(q2*mt**2))*Tqq(1,4)
ch     .      +dlog(4d0*dot(ptrans,2,3)**2/(q2*mt**2))*Tqq(2,3)
ch     .      +dlog(4d0*dot(ptrans,2,4)**2/(q2*mt**2))*Tqq(2,4))
ch     .      *fx10(j)*fx20(k)*msqc(j,k)*flgq
ch      elseif(j.lt.0.and.k.gt.0)then
ch      logfin=logfin+(
ch     .       Tqq(3,3)+Tqq(4,4)
ch     .      +1d0/v34*dlog((1d0+v34)/(1d0-v34))
ch     .      *Tqq(3,4)
ch     .      +dlog(4d0*dot(ptrans,2,3)**2/(q2*mt**2))*Tqq(1,3)
ch     .      +dlog(4d0*dot(ptrans,2,4)**2/(q2*mt**2))*Tqq(1,4)
ch     .      +dlog(4d0*dot(ptrans,1,3)**2/(q2*mt**2))*Tqq(2,3)
ch     .      +dlog(4d0*dot(ptrans,1,4)**2/(q2*mt**2))*Tqq(2,4))
ch     .      *fx10(j)*fx20(k)*msqc(j,k)*flgq
ch      endif
ch      endif

ch    Final state radiation

ch    qq channel

ch      if (j.ne.0.and.k.ne.0)then
ch       if(j.gt.0.and.k.lt.0)then
ch        Gamma1qM0M0=Gamma1qM0M0+Gamma1q
ch     .      *fx10(j)*fx20(k)*msqc(j,k)*flgq
ch       elseif(j.lt.0.and.k.gt.0)then
ch        Gamma1qM0M0=Gamma1qM0M0+Gamma1qb
ch     .      *fx10(j)*fx20(k)*msqc(j,k)*flgq
ch       endif
ch      endif

ch    gg channel

ch      if (j.eq.0.and.k.eq.0)then
ch      logfin=logfin+(
ch     .       Tgg(3,3)+Tgg(4,4)
ch     .      +1d0/v34*dlog((1d0+v34)/(1d0-v34))
ch     .      *Tgg(3,4)
ch     .      +dlog(4d0*dot(ptrans,1,3)**2/(q2*mt**2))*Tgg(1,3)
ch     .      +dlog(4d0*dot(ptrans,1,4)**2/(q2*mt**2))*Tgg(1,4)
ch     .      +dlog(4d0*dot(ptrans,2,3)**2/(q2*mt**2))*Tgg(2,3)
ch     .      +dlog(4d0*dot(ptrans,2,4)**2/(q2*mt**2))*Tgg(2,4))
ch     .      *fx10(j)*fx20(k)*flgq
ch      endif

c      if (j.eq.0.and.k.eq.0)then
c       Gamma1gM0M0=Gamma1gM0M0+Gamma1g
c     .      *fx10(j)*fx20(k)*flgq
c      endif



ch

      if(order.eq.1) goto 75

ch    qqb channel:

      if(j.ne.0.and.k.ne.0)then

CC    Now (gamma+gamma)*(gamma+gamma) term: to be used later

C     First part: one gamma for each leg: FLGQ here is non trivial ! DONE




      diffg1fq=-dlog(xx10)*(fx1p(j)-fx10(j)*xx10**beta)*Pqq(z1)
     &  - Pqqint(xx10)*fx10(j)


      diffg10q=-dlog(xx10)*fx1p(0)*Pqg(z1)

      diffg2fq=-dlog(xx20)*(fx2p(k)-fx20(k)*xx20**alfa)*Pqq(z2)
     &  - Pqqint(xx20)*fx20(k)


      diffg20q=-dlog(xx20)*fx2p(0)*Pqg(z2)


      tgagaq=tgagaq+2*
     #   (flgq*diffg10q*diffg20q+flgq*diffg1fq*diffg2fq
ch     #   (flgq*diffg10q*diffg20q+diffg1fq*diffg2fq
     #   +diffg10q*diffg2fq+diffg1fq*diffg20q)*msqc(j,k)



CC     Second part: gamma*gamma terms

c     Pij * Pjk = D1ijjk (log(1-z)/(1-z))_+ + D0ijjk/(1-z)_+ 
c              + Pijjk(z) + Deltaijjk delta(1-z)

C     First leg

      
      diff1q=-dlog(xx10)*(flgq*(fx1p(j)-fx10(j)*xx10**beta)
     &    *(D0qqqq/(1-z1)+D1qqqq*dlog(1-z1)/(1-z1))
     &    +fx1p(j)*Pqqqq(z1)*flgq+fx1p(0)*(Pqqqg(z1)+Pqggg(z1)))
     &    +(Deltaqqqq-D0qqqq*D0int(xx10)-D1qqqq*D1int(xx10))
     &    *fx10(j)*flgq


C    Second leg

      
      diff2q=-dlog(xx20)*(flgq*(fx2p(k)-fx20(k)*xx20**alfa)
     &    *(D0qqqq/(1-z2)+D1qqqq*dlog(1-z2)/(1-z2))
     &    +fx2p(k)*Pqqqq(z2)*flgq+fx2p(0)*(Pqqqg(z2)+Pqggg(z2)))
     &    +(Deltaqqqq-D0qqqq*D0int(xx20)-D1qqqq*D1int(xx20))
     &    *fx20(k)*flgq


C     Include Pqggq

      do l=1,nf
      diff1q=diff1q-dlog(xx10)*(fx1p(l)+fx1p(-l))*Pqggq(z1)*flgq
      diff2q=diff2q-dlog(xx20)*(fx2p(l)+fx2p(-l))*Pqggq(z2)*flgq
      enddo

      tgagaq=tgagaq+diff1q*fx20(k)*msqc(j,k)
      tgagaq=tgagaq+diff2q*fx10(j)*msqc(j,k)




C    End of (gamma+gamma)*(gamma+gamma) term: FLGQ non trivial here ! DONE

C    Start  (C+C)*(gamma+gamma) term

c    gamma first leg, C second leg


ch      diffc2fq=-dlog(xx20)*fx2p(k)*Cqq(z2)+C1qqdelta*fx20(k)
      diffc2fq=-dlog(xx20)*fx2p(k)*Cqq(z2)
ch     #          0.5d0*(H1qdelta+H1qbdelta)/2d0*fx20(k)
ch     #          +0.5d0*H1qdelta*fx20(k)

      diffc20q=-dlog(xx20)*fx2p(0)*Cqg(z2)


      tcgaq=tcgaq+msqc(j,k)*
     # (flgq*diffg10q*diffc20q+flgq*diffg1fq*diffc2fq
     #          +diffg10q*diffc2fq+diffg1fq*diffc20q)



c    C first leg, gamma second leg

ch      diffc1fq=-dlog(xx10)*fx1p(j)*Cqq(z1)+C1qqdelta*fx10(j)
      diffc1fq=-dlog(xx10)*fx1p(j)*Cqq(z1)
ch     #          0.5d0*(H1qdelta+H1qbdelta)/2d0*fx10(j)
ch     #          +0.5d0*H1qdelta*fx10(j)

      diffc10q=-dlog(xx10)*fx1p(0)*Cqg(z1)

      tcgaq=tcgaq+msqc(j,k)*
     # (flgq*diffc10q*diffg20q+flgq*diffc1fq*diffg2fq
     #          +diffc10q*diffg2fq+diffc1fq*diffg20q)

c    C*gamma: first leg (ignore delta term in Cqq: taken into account with tH1stF)

      tcgaq=tcgaq
     &     +(fx1p(j)*CqqPqq(z1)*flgq+fx1p(0)*(CqqPqg(z1)+CqgPgg(z1)))
     &     *(-dlog(xx10))*fx20(k)*msqc(j,k) 

c    C*gamma: second leg (ignore delta term in Cqq: taken into account with tH1stF)

      tcgaq=tcgaq
     &     +(fx2p(k)*CqqPqq(z2)*flgq+fx2p(0)*(CqqPqg(z2)+CqgPgg(z2)))
     &     *(-dlog(xx20))*fx10(j)*msqc(j,k) 

c    Add Cqg*Pgq contribution

      do l=1,nf
      tcgaq=tcgaq+(fx1p(l)+fx1p(-l))*CqgPgq(z1)
     &           *(-dlog(xx10))*fx20(k)*msqc(j,k)*flgq 
      tcgaq=tcgaq+(fx2p(l)+fx2p(-l))*CqgPgq(z2)
     &           *(-dlog(xx20))*fx10(j)*msqc(j,k)*flgq 
      enddo


CC  Start 2-loop AP

C   Gluon + pure singlet


      do l=-nf,nf
      if(l.eq.0) then
      tgamma2q=tgamma2q+fx1p(0)*P2qg(z1)
     & *(-dlog(xx10))*fx20(k)*msqc(j,k)
      tgamma2q=tgamma2q+fx2p(0)*P2qg(z2)
     & *(-dlog(xx20))*fx10(j)*msqc(j,k)
      else
      tgamma2q=tgamma2q+fx1p(l)*P2qqS(z1)
     & *(-dlog(xx10))*fx20(k)*msqc(j,k)*flgq
      tgamma2q=tgamma2q+fx2p(l)*P2qqS(z2)
     & *(-dlog(xx20))*fx10(j)*msqc(j,k)*flgq
      endif
      enddo


C   P2qq non-singlet: regular part

      tgamma2q=tgamma2q+fx1p(j)*P2qqV(z1)
     & *(-dlog(xx10))*fx20(k)*msqc(j,k)*flgq
      tgamma2q=tgamma2q+fx2p(k)*P2qqV(z2)
     & *(-dlog(xx20))*fx10(j)*msqc(j,k)*flgq


C   P2qq non-singlet: 1/(1-z)_+


      diffq=-dlog(xx10)
     &  *(fx1p(j)-fx10(j)*xx10**beta)/(1-z1)
     &  - D0int(xx10)*fx10(j)      
  
      tgamma2q=tgamma2q+2d0/3*Kappa*diffq*fx20(k)*msqc(j,k)*flgq


      diffq=-dlog(xx20)
     &  *(fx2p(k)-fx20(k)*xx20**alfa)/(1-z2)
     &  - D0int(xx20)*fx20(k)      
  
      tgamma2q=tgamma2q+2d0/3*Kappa*diffq*fx10(j)*msqc(j,k)*flgq

      

C   P2qqb non singlet

      tgamma2q=tgamma2q+fx1p(-j)*P2qqbV(z1)
     & *(-dlog(xx10))*fx20(k)*msqc(j,k)*flgq

      tgamma2q=tgamma2q+fx2p(-k)*P2qqbV(z2)
     & *(-dlog(xx20))*fx10(j)*msqc(j,k)*flgq

      elseif(j.eq.0.and.k.eq.0)then

CC    (gamma+gamma)*(gamma+gamma) term

C     First part: one gamma for each leg: gluon channel

      diff10g=-dlog(xx10)
     &  *(fx1p(0)-fx10(0)*xx10**beta)/(1-z1)
     &  - D0int(xx10)*fx10(0)

      diff10g=3*diff10g+beta0*fx10(0)
     &     -dlog(xx10)*fx1p(0)*Pggreg(z1)

      diff20g=-dlog(xx20)
     &  *(fx2p(0)-fx20(0)*xx20**alfa)/(1-z2)
     &  - D0int(xx20)*fx20(0)

      diff20g=3*diff20g+beta0*fx20(0)
     &     -dlog(xx20)*fx2p(0)*Pggreg(z2)


C    Second: gamma*gamma: gluon channel

c    First leg

      diffg=-dlog(xx10)*((fx1p(0)-fx10(0)*xx10**beta)
     &    *(D0gggg/(1-z1)+D1gggg*dlog(1-z1)/(1-z1))
     &      +fx1p(0)*(Pggggreg(z1)+Pgqqg(z1)))
     &    +(Deltagggg-D0gggg*D0int(xx10)-D1gggg*D1int(xx10))*fx10(0)


      tgagag=tgagag+diffg*flgq*fx20(0)*msqc(0,0)


c    Second leg

      diffg=-dlog(xx20)*((fx2p(0)-fx20(0)*xx20**alfa)
     &    *(D0gggg/(1-z2)+D1gggg*dlog(1-z2)/(1-z2))
     &      +fx2p(0)*(Pggggreg(z2)+Pgqqg(z2)))
     &    +(Deltagggg-D0gggg*D0int(xx20)-D1gggg*D1int(xx20))*fx20(0)

      tgagag=tgagag+diffg*flgq*fx10(0)*msqc(0,0)



CC    Start  (C+C)*(gamma+gamma) term: diagonal part


c    gamma first leg, C second

      diffg10g=-dlog(xx10)
     &  *((fx1p(0)-fx10(0)*xx10**beta)*3d0/(1-z1)+Pggreg(z1)*fx1p(0))
     &    +fx10(0)*(beta0-3*D0int(xx10))

ch      diffc20g=0.5d0*H1gdelta*fx20(0)
      diffc20g=0d0
ch      diffc20g=(ca*pi**2/12d0)*fx20(0)
ch      diffc20g=0d0

c    gamma second leg, C first

      diffg20g=-dlog(xx20)
     &  *((fx2p(0)-fx20(0)*xx20**alfa)*3d0/(1-z2)+Pggreg(z2)*fx2p(0))
     &    +fx20(0)*(beta0-3*D0int(xx20))


ch      diffc10g=0.5d0*H1gdelta*fx10(0)
      diffc10g=0d0
ch      diffc10g=(ca*pi**2/12d0)*fx10(0)
ch       diffc10g=0d0

c    C*gamma: first leg (ignore delta term in Cgg: taken into account in H1stf)

      tcgag=tcgag+CgqPqg(z1)*(-dlog(xx10))*
     &                 flgq*fx1p(0)*fx20(0)*msqc(0,0) 

c    C*gamma: second leg (ignore delta term in Cgg: taken into account in H1stf)

      tcgag=tcgag+CgqPqg(z2)*(-dlog(xx20))*
     &                 flgq*fx2p(0)*fx10(0)*msqc(0,0) 

c    End of (C+C)*(gamma+gamma)


CC    gamma2: diagonal part

c     First leg

      diffg=-dlog(xx10)
     &  *(fx1p(0)-fx10(0)*xx10**beta)/(1-z1)
     &  - D0int(xx10)*fx10(0)  

      tgamma2g=tgamma2g+(1.5d0*Kappa*diffg-dlog(xx10)*P2gg(z1)*fx1p(0))
     &                *flgq*fx20(0)*msqc(0,0)


c     Second leg

      diffg=-dlog(xx20)
     &  *(fx2p(0)-fx20(0)*xx20**alfa)/(1-z2)
     &  - D0int(xx20)*fx20(0)  

      tgamma2g=tgamma2g+(1.5d0*Kappa*diffg-dlog(xx20)*P2gg(z2)*fx2p(0))
     &                *flgq*fx10(0)*msqc(0,0)

      endif

 75   continue

      enddo
      enddo

ch    do here gq 

      do j=1,nf

C     H1st: Cgq, first leg


      tH1stg=tH1stg+(fx1p(j)+fx1p(-j))*Cgq(z1)
     & *(-dlog(xx10))*fx20(0)*msqc(0,0)


C     H1st: Cgq, second leg

      
      tH1stg=tH1stg+(fx2p(j)+fx2p(-j))*Cgq(z2)
     & *(-dlog(xx20))*fx10(0)*msqc(0,0)

C     gg channel H1st: muf dependence: Pgq, first leg


      tH1stFg=tH1stFg+(-dlog(xx10))
     & *(fx1p(j)+fx1p(-j))*Pgq(z1)*fx20(0)*msqc(0,0)


C     gg channel H1st: muf dependence: Pgq, second leg


      tH1stFg=tH1stFg+(-dlog(xx20))
     & *(fx2p(j)+fx2p(-j))*Pgq(z2)*fx10(0)*msqc(0,0)

CC    End of H1st

      if(order.eq.1) goto 78

CC    Now (gamma+gamma)*(gamma+gamma) term

C     First part: one gamma for each leg


      diff1fg=diff1fg-dlog(xx10)*Pgq(z1)*(fx1p(j)+fx1p(-j))

      diff2fg=diff2fg-dlog(xx20)*Pgq(z2)*(fx2p(j)+fx2p(-j))


C     Second part: gamma*gamma terms

c     Pij * Pjk = D1ijjk (log(1-z)/(1-z))_+ + D0ijjk/(1-z)_+ 
c              + Pijjk(z) + Deltaijjk delta(1-z)

      tgagag=tgagag-dlog(xx10)*(Pgqqq(z1)+Pgggq(z1))*(fx1p(j)+fx1p(-j))
     &            *fx20(0)*msqc(0,0)

      tgagag=tgagag-dlog(xx20)*(Pgqqq(z2)+Pgggq(z2))*(fx2p(j)+fx2p(-j))
     &            *fx10(0)*msqc(0,0)


C    End of (gamma+gamma)*(gamma+gamma) term


C    Start (C+C)*(gamma+gamma)


c    Gamma first leg

      diffg1fg=diffg1fg-dlog(xx10)*(fx1p(j)+fx1p(-j))*Pgq(z1)

c    C second leg

      diffc2fg=diffc2fg-dlog(xx20)*(fx2p(j)+fx2p(-j))*Cgq(z2)

c    Gamma second leg

      diffg2fg=diffg2fg-dlog(xx20)*(fx2p(j)+fx2p(-j))*Pgq(z2)

c    C first leg

      diffc1fg=diffc1fg-dlog(xx10)*(fx1p(j)+fx1p(-j))*Cgq(z1)

c    C*gamma: first leg (ignore delta term in Cgg: taken into account in H1stf)


      tcgag=tcgag+CgqPqq(z1)*(-dlog(xx10))*(fx1p(j)+fx1p(-j))
     .                *fx20(0)*msqc(0,0) 


c    C*gamma: second leg (ignore delta term in Cgg: taken into account in H1stf)


      tcgag=tcgag+CgqPqq(z2)*(-dlog(xx20))*(fx2p(j)+fx2p(-j))
     .                   *fx10(0)*msqc(0,0) 


CC    gamma2: qg channel


c    First leg

      tgamma2g=tgamma2g
     &   -dlog(xx10)*P2gq(z1)*(fx1p(j)+fx1p(-j))*fx20(0)*msqc(0,0) 

c    Second leg

      tgamma2g=tgamma2g
     &   -dlog(xx20)*P2gq(z2)*(fx2p(j)+fx2p(-j))*fx10(0)*msqc(0,0) 


 78   continue


      enddo

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

c    Check it !      

      tgagag=tgagag+2*msqc(0,0)
     # *(flgq*diff10g*diff20g+flgq*diff1fg*diff2fg
     #   +diff10g*diff2fg+diff1fg*diff20g)

c

      tcgag=tcgag+msqc(0,0)*
     # (flgq*diffg10g*diffc20g+flgq*diffg1fg*diffc2fg
     #          +diffg10g*diffc2fg+diffg1fg*diffc20g)

c    gamma second leg, C first leg

      tcgag=tcgag+msqc(0,0)*
     # (flgq*diffg20g*diffc10g+flgq*diffg2fg*diffc1fg
     #          +diffg20g*diffc1fg+diffg2fg*diffc10g)



CC   First order

ch Include also the gg channel

c      sig12=-0.5d0*A1q*tdelta
c      sig11=-B1q*tdelta-tH1stF

      sig12q=-0.5d0*A1q*(tdeltaq+tdeltaqb)
      sig11q=-B1q*(tdeltaq+tdeltaqb)-tH1stFq
     .       +Gamma1q*tdeltaq+Gamma1qb*tdeltaqb


      sig12g=-0.5d0*A1g*tdeltag
      sig11g=-B1g*tdeltag-tH1stFg
     .       +Gamma1g*tdeltag

      sig12=sig12q+sig12g
      sig11=sig11q+sig11g
ch      sig11=sig11g
ch      write(*,*)sig12q,sig11q,'3'
ch      write(*,*)sig12g,sig11g,'4'

ch

CC   Second order

      sig24q=(A1q)**2/8*(tdeltaq+tdeltaqb)

      sig24g=(A1g)**2/8*tdeltag

      sig24=sig24q+sig24g
c      sig24=sig24q
       
      sig23q=-beta0*A1q/3*(tdeltaq+tdeltaqb)
     .           -0.5d0*A1q*sig11q
      
      sig23g=-beta0*A1g/3*tdeltag-0.5d0*A1g*sig11g

c      sig23=sig23q
      sig23=sig23q+sig23g

      sig22q=0.5d0*(beta0*A1q*LR-A2q)*(tdeltaq+tdeltaqb)
     &     -0.5d0*A1q*(tH1stq+LF*tH1stFq)
     &     -0.5d0*(B1q-beta0)*sig11q
     &     +0.5d0*B1q*tH1stFq
     &     -Gamma1q*tH1stFq
     &     +0.5d0*tgagaq

      sig22g=0.5d0*(beta0*A1g*LR-A2g)*tdeltag
     &     -0.5d0*A1g*(tH1stg+LF*tH1stFg)
     &     -0.5d0*(B1g-beta0)*sig11g
     &     +0.5d0*B1g*tH1stFg
     &     -Gamma1g*tH1stFg
     &     +0.5d0*tgagag
C    Add mur dependence from H1st
ch     &     +beta0*A1g*LR*tdeltag

      sig22=sig22q+sig22g
c      sig22=sig22q



      sig21q=-beta0*LR*sig11q-B1q*(tH1stq+LF*tH1stFq)
     &     +Gamma1q*(tH1stq+LF*tH1stFq)
     &     -LF*tgagaq-B2q*(tdeltaq+tdeltaqb)
     &     +beta0*tH1stq-tcgaq-tgamma2q

c     Include missing delta term from C*gamma (no factor 2 here !)

ch      sig21q=sig21q-2*C1qqdelta*tH1stFq
      sig21q=sig21q-H1qdelta*tH1stFq




C     Include missing term from contact term in 2 loop AP

      sig21q=sig21q-2*Delta2qq*(tdeltaq+tdeltaqb)
ch
ch      sig21q=sig21q+2*beta0*LR*(B1q*tdeltaq+tH1stFq)
ch
      sig21g=-beta0*LR*sig11g-B1g*(tH1stg+LF*tH1stFg)
     &     +Gamma1g*(tH1stg+LF*tH1stFg)
     &     -LF*tgagag-B2g*tdeltag+beta0*tH1stg-tcgag-tgamma2g
c     Include missing delta term from C*gamma (no factor 2 here !)
ch      sig21g=sig21g-2*C1ggdelta*tH1stFg
      sig21g=sig21g-H1gdelta*tH1stFg
ch      sig21g=sig21g-H1gdelta
C     Include missing term from contact term in 2 loop AP
      sig21g=sig21g-2*Delta2gg*tdeltag
C     NEW: Include mur dependence from H1st
ch      sig21g=sig21g+2*beta0*LR*(B1g*tdeltag+tH1stFg)

      sig21=sig21q+sig21g
ch      sig21=sig21q
ch      write(*,*)LR,LF,'logs'
ch      write(*,*)sig24q,sig23q,sig22q,sig21q,'5'
ch      write(*,*)sig24g,sig23g,sig22g,sig21g,'6'


CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

ch      write(*,*)sig24,sig23,sig22,sig21,'2'
CC Include as/pi factors and sum O(as) and O(as^2) contributions

      sig1=sig12*LL2+sig11*LL1
ch      sig1=sig11*LL1
      sig2=sig24*LL4+sig23*LL3+sig22*LL2+sig21*LL1
ch      sig2=sig21*LL1


        sig1=sig1*ason2pi*2
        sig2=sig2*(ason2pi*2)**2

        if(order.eq.1)then
c          xmsq(1)=-sig1
          xmsq(1)=-sig1
c          xmsq(1)=-tdelta
        else
ch          xmsq(1)=-(sig1+sig2)
          xmsq(1)=-sig2
        endif
ch        write(*,*)'sig2=',sig2
ch     .    ,'ason2pi=',ason2pi,
ch     .  'xx10,xx20=',xx10,xx20,
ch     .  'alfa,beta=',alfa,beta,
ch     .  'LL1,LL2,LL3,LL4=',LL1,LL2,LL3,LL4,scale,
ch     .  facscale,
ch     .  'Lr,LF=',LR,LF,
ch     .  'msqb,msqc=',msqc(0,0),msqc(1,-1),
ch     .  'q2,xth=',q2,xth

c           xmsq(1)=sig1+sig2

CC Include iacobians

c      xmsq(1)=xmsq(1)*xjacqt2*xjacq2*q2/shad/Vol

      xmsq(1)=xmsq(1)*xjacq2*xjacqt2*q2*pswt0/shad/Vol
ch     .      *dsqrt(qt2)/dsqrt(q2)


      countint=0d0
      xint=0d0


C Multiply by BORN phase space weight

c        xmsq(1)=xmsq(1)*fluxborn*pswt0/BrnRat

        xmsq(1)=fluxBorn*xmsq(1)/BrnRat


 77    continue



c---Add to total

        xint=xmsq(1)
        val=xmsq(1)*wgt
        

c---if we're binning, add to histo too
        if (bin) then
          call getptildejet(1,pjet)
          call dotem(nvec,pjet,s)
          val=val/dfloat(itmx)       
          call plotter(ptrans,val,1)       
ch          call plotter(p,val,0)
        endif

     
      countint=xint
     
      xreal=xreal+xint*wgt/dfloat(itmx)
      xreal2=xreal2+(xint*wgt)**2/dfloat(itmx)
      

      return

 999  countint=0d0
      ntotzero=ntotzero+1
 
      return
      end

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC


CC qq splitting function (with asopi normalization)

      function Pqq(z)
      implicit none
      real *8 Pqq,z
      Pqq=2d0/3*(1+z**2)/(1-z)
      return
      end

CC qg splitting function (with asopi normalization)

      function Pqg(z)
      implicit none
      real *8 Pqg,z
      Pqg=0.25d0*(1-2*z*(1-z))
      return
      end

CC gq splitting function (with asopi normalization)

      function Pgq(z)
      implicit none
      real *8 Pgq,z
      Pgq=2d0/3*(1+(1-z)**2)/z
      return
      end

CC Non delta term in Cqq coefficient (with asopi normalization)

      function Cqq(z)
      implicit none
      real *8 Cqq,z
      Cqq=2d0/3*(1-z)
      return
      end

CC gg splitting function (not normalized !)



CC Cqg coefficient (with asopi normalization)

      function Cqg(z)
      implicit none
      real *8 Cqg,z
      Cqg=0.5d0*z*(1-z)
      return
      end

CC Cgq coefficient (with asopi normalization)

      function Cgq(z)
      implicit none
      real *8 Cgq,z
      Cgq=2d0/3*z
      return
      end


CC Integral of Pqq=1/2 CF (1+x^2)/(1-x) from 0 to z

      function Pqqint(z)
      implicit none
      real *8 Pqqint,z
      Pqqint=-2d0/3*(z+z**2/2+2*dlog(1-z))
      return
      end

CC Integral of 1/(1-x) from 0 to z

      function D0int(z)
      implicit none
      real *8 D0int,z
      D0int=-dlog(1-z)
      return
      end

CC Integral of log(1-x)/(1-x) from 0 to z

      function D1int(z)
      implicit none
      real *8 D1int,z
      D1int=-0.5d0*dlog(1-z)**2
      return
      end

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C                P*P convolutions
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

CC Regular part of Pqq*Pqq (checked !)

      function Pqqqq(z)
      implicit none
      real *8 Pqqqq,z
      Pqqqq=4d0/9*(-4*dlog(z)/(1-z)-2*(1-z)
     &  +(1+z)*(3*dlog(z)-4*dlog(1-z)-3))
      return
      end


CC Pqq*Pqg (checked !)

      function Pqqqg(z) 
      implicit none
      real *8 Pqqqg,z
      Pqqqg=1d0/3*((z**2+(1-z)**2)*dlog((1-z)/z)
     &  -(z-0.5d0)*dlog(z)+z-0.25d0)
      return
      end

CC Pqg*Pgq (checked !)

      function Pqggq(z)
      implicit none
      real *8 Pqggq,z
      Pqggq=1d0/3*(2d0/3/z+(1+z)*dlog(z)-2d0/3*z**2-0.5d0*(z-1))
      return
      end


CC Full Pqg*Pgg (checked !)

      function Pqggg(z)
      implicit none
      real *8 Pqggg,z,beta0,Pqg
      integer nf
      external Pqg
      nf=5
      beta0=(33-2*nf)/12d0
      Pqggg=1.5d0*(1/3d0/z+(z**2-z+0.5d0)*dlog(1-z)
     &     +(2*z+0.5d0)*dlog(z)+0.25d0+2*z-31d0/12*z**2)

      Pqggg=Pqggg+beta0*Pqg(z)
      return
      end


CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C                C*P convolutions
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

CC Cqq*Pqq (without delta term in Cqq) (checked !)

      function CqqPqq(z)
      implicit none
      real *8 CqqPqq,z
      CqqPqq=2d0/9*(1-z)*(4*dlog(1-z)-2*dlog(z)-1)
      return
      end

CC Cqq*Pqg (without delta term in Cqq) (checked !)

      function CqqPqg(z)
      implicit none
      real *8 CqqPqg,z
      CqqPqg=(-2+z+z**2-(1+2*z)*dlog(z))/6d0
      return
      end

CC Cqg*Pgq (checked !)

      function CqgPgq(z) 
      implicit none
      real *8 CqgPgq,z
      CqgPgq=(1d0/3/z-1+2*z**2/3-z*dlog(z))/3d0
      return
      end

CC Cqg*Pgg (checked !)

      function CqgPgg(z)
      implicit none
      real *8 CqgPgg,z,beta0
      integer nf
      nf=5
      beta0=(33-2*nf)/12d0
      CqgPgg=3d0/4*(2*z*(1-z)*dlog(1-z)-4*z*dlog(z)
     &      +1d0/3/z-1-5*z+17d0*z**2/3)+beta0/2*z*(1-z)
      return
      end

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C           Two loop AP:  pqq of ESW is my 3/2 Pqq
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

C     Pqq NS: Eq. (4.107) ESW (no 1/(1-x)_+ and delta term)

      function P2qqV(x)
      implicit none
      real *8 x,P2qqV,Pqq,pi
      integer nf
      external Pqq

      pi=3.14159265358979d0
      nf=5

      P2qqV=16d0/9*(-(2*dlog(x)*dlog(1-x)+1.5d0*dlog(x))*3d0/2*Pqq(x)
     &     -(1.5d0+3.5d0*x)*dlog(x)-0.5d0*(1+x)*dlog(x)**2-5*(1-x))
     &     +4*((0.5d0*dlog(x)**2+11d0/6*dlog(x))*3d0/2*Pqq(x)
     &     -(67d0/18-pi**2/6)*(1+x)
     &     +(1+x)*dlog(x)+20d0/3*(1-x))
     &     +2d0/3d0*nf*(-dlog(x)*Pqq(x)+10d0/9*(1+x)-4d0/3*(1-x))

c     Change to as/pi normalization

      P2qqV=P2qqV/4  

      return
      end


C    Pqqb NS: Eq. (4.108) ESW

      function P2qqbV(x)
      implicit none
      real *8 x,P2qqbV,Pqq,S2
      external Pqq,S2

      P2qqbV=-2d0/9*(3d0*Pqq(-x)*S2(x)+2*(1+x)*dlog(x)+4*(1-x))
      
c     Change to as/pi normalization

      P2qqbV=P2qqbV/4 

      return
      end



C    Pqg Singlet: Eq. (4.110) ESW (ESW Pqg is 4 times my Pqg)

      function P2qg(x)
      implicit none
      real *8 x,P2qg,Pqg,pi,S2,logx,logomxsx
      external Pqg,S2

      pi=3.14159265358979d0
      logx=dlog(x)
      logomxsx=dlog((1-x)/x)

      P2qg=2d0/3*(4-9*x-(1-4*x)*logx-(1-2*x)*logx**2+4*dlog(1-x)
     &    +(2*logomxsx**2-4*logomxsx-2d0/3*pi**2+10d0)*4*Pqg(x))
     &    +1.5d0*(182d0/9+14d0/9*x+40d0/9/x+(136d0/3*x-38d0/3)*logx
     &    -4*dlog(1-x)-(2+8*x)*logx**2+8*Pqg(-x)*S2(x)
     &    +(-logx**2+44d0/3*logx-2*dlog(1-x)**2+4*dlog(1-x)+pi**2/3
     &    -218d0/9)*4*Pqg(x))

c     Change to as/pi normalization

      P2qg=P2qg/4d0
  
c     Divide by 2 to eliminate 2nf factor

      P2qg=P2qg/2d0

      return
      end

C     Pqq Pure Singlet appearing in ESW Eq. (4.95)
C     PSqq=PSqqb
C     Obtained through Eq.(4.101)
C     PSqq=1/2/nf (P2qq-P2qqbV-P2qqV) (contains only CF TR=2/3)
CC gg splitting function (not normalized !)

      function Pgg(x)
      implicit none
      real *8 Pgg,x

      Pgg=1d0/(1-x)+1d0/x-2+x*(1-x)

      return
      end


CC gg splitting function: regular part (with asopi normalization)


      function Pggreg(z)
      implicit none
      real *8 Pggreg,z
      Pggreg=3*((1-2*z)/z+z*(1-z))
      return
      end
      function P2qqS(x)
      implicit none
      real *8 P2qqS,x

      P2qqS=2d0/3*(20 - 18*x + 54*x**2 - 56*x**3
     &    +3*x*(3 + 15*x + 8*x**2)*dlog(x) 
     &    - 9*x*(1 + x)*dlog(x)**2)/(9*x)
      
      P2qqS=P2qqS/4

      return
      end

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C                P*P convolutions
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      function Pggggreg(x) ! checked !
      implicit none
      real *8 Pggggreg,x
      real *8 Pggreg,beta0
      integer nf
      external Pggreg

      nf=5
      beta0=(33-2*nf)/12d0

      Pggggreg=-9*dlog(x)/(1-x)+2*beta0*Pggreg(x)
     &   +9*(3*(1-x)+11d0/3/x*(x**3-1d0)+2d0/3*dlog(1-x)*Pggreg(x)
     &   +dlog(x)*(x**2-3*x-1d0/x))

      return
      end


      function Pgggq(x) ! checked !
      implicit none
      real *8 Pgggq,x
      real *8 Pgq,beta0
      integer nf
      external Pgq

      nf=5
      beta0=(33-2*nf)/12d0

      Pgggq=2*((1+(1-x)**2)/x*dlog(1-x)-2*(1+x+1d0/x)*dlog(x)
     &    +4-31d0/6/x+x/2+2d0/3*x**2)+beta0*Pgq(x)

      return
      end

      function Pgqqq(x) ! checked !
      implicit none
      real *8 Pgqqq,x
      
      Pgqqq=4d0/9*((2-x)*dlog(x)+dlog(1-x)*(2*x+4/x-4)+2-x/2)
      
      return
      end

      function Pgqqg(x) ! checked !
      implicit none
      real *8 Pgqqg,x
      integer nf

      nf=5 
      Pgqqg=1d0/6*(1+4d0/3/x-x-4*x**2/3+2*(1+x)*dlog(x))

      Pgqqg=2*nf*Pgqqg

      return
      end


CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C                C*P convolutions
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC


      function CgqPqq(x) ! checked !
      implicit none
      real *8 CgqPqq,x
      
      CgqPqq=2d0/9*(2+x+4*x*dlog(1-x)-2*x*dlog(x))

      return
      end



      function CgqPqg(x) ! checked !
      implicit none
      real *8 CgqPqg,x
      integer nf

      nf=5       
      CgqPqg=1d0/6*(1+x-2*x**2+2*x*dlog(x))

      CgqPqg=2*nf*CgqPqg

      return
      end


CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C           Two loop AP:  pqq of ESW is my 3/2 Pqq
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC


      function P2gg(x)
      implicit none
      real *8 P2gg,S2,pgg,x,pi
      integer nf
      external pgg,S2

      nf=5

      pi=3.14159265358979d0

      P2gg=2d0/3*nf*(-16+8*x+20d0/3*x**2+4d0/3/x-(6+10*x)*dlog(x)
     &    -(2+2*x)*dlog(x)**2)+1.5d0*nf*(2-2*x+26d0/9*(x**2-1d0/x)
     &    -4d0/3*(1+x)*dlog(x)-20d0/9*(1/x-2+x*(1-x)))
     &    +9*(27d0/2*(1-x)+67d0/9*(x**2-1d0/x)
     &        -(25d0/3-11d0/3*x+44d0/3*x**2)*dlog(x)
     &        +4*(1+x)*dlog(x)**2+2*pgg(-x)*S2(x)
     &    +(67d0/9-pi**2/3)*(1/x-2+x*(1-x))
     &     +(-4*dlog(x)*dlog(1-x)+dlog(x)**2)*pgg(x))
     

      P2gg=P2gg/4d0

      return
      end


      function P2gq(x)
      implicit none
      real *8 P2gq,Pgq,S2,x,logx,logomx,pi
      external Pgq,S2
      integer nf
     
      pi=3.14159265358979d0

      nf=5

      logx=dlog(x)
      logomx=dlog(1-x)

      P2gq=16d0/9*(-2.5d0-3.5d0*x+(2+3.5d0*x)*logx
     &     -(1-0.5d0*x)*logx**2-2*x*logomx
     &     -(3*logomx+logomx**2)*1.5d0*Pgq(x))
     &     +4d0*(28d0/9+65d0/18*x+44d0/9*x**2-(12+5*x+8d0/3*x**2)*logx
     &     +(4+x)*logx**2+2*x*logomx+S2(x)*1.5d0*Pgq(-x)
     &     +(0.5d0-2*logx*logomx+0.5d0*logx**2+11d0/3*logomx+logomx**2
     &     -pi**2/6)*1.5d0*Pgq(x))
     &     +2d0/3*nf*(-4d0*x/3-(20d0/9+4d0/3*logomx)*1.5d0*Pgq(x))


      P2gq=P2gq/4

      return
      end


C    S2: Eq. (4.114) ESW

      function S2(x)
      implicit none
      real *8 x,pi,S2,myli2
      external myli2      
      pi=3.14159265358979d0

      S2=-2*myli2(-x)+0.5d0*dlog(x)**2-2*dlog(x)*dlog(1+x)-pi**2/6
      return
      end
