c Routines for the interpolation of the results corresponding
c to <Fex1(0)^2>, written in terms of the color structures
c T3T4^2, T3T4*CF and CF^2

      function Fex1sq_T3T4sq(beta,cost)
      ! This routine returns the contribution to T3T4T3T4
      ! coming from <Fex1(0)^2>
      ! Here beta=sqrt(1-4*mt**2/s)
      implicit none
      double precision Fex1sq_T3T4sq,beta,beta2,cost
      real beta2_r,cost_r,interpolationT3T4sq
      external interpolationT3T4sq

      beta2 = beta*beta
      beta2_r = real(beta2)
      cost_r = real(cost)
      Fex1sq_T3T4sq = dble(interpolationT3T4sq(beta2_r,cost_r))
      Fex1sq_T3T4sq = Fex1sq_T3T4sq*(1.d0+dlog(1.d0-beta2)**2.d0)**2.d0

      return
      end

      function Fex1sq_T3T4CF(beta,cost)
      ! This routine returns the contribution to T3T4*CF
      ! coming from <Fex1(0)^2>
      ! Here beta=sqrt(1-4*mt**2/s)
      implicit none
      double precision Fex1sq_T3T4CF,beta,beta2,cost
      real beta2_r,cost_r,interpolationT3T4CF
      external interpolationT3T4CF

      beta2 = beta*beta
      beta2_r = real(beta2)
      cost_r = real(cost)
      Fex1sq_T3T4CF = dble(interpolationT3T4CF(beta2_r,cost_r))
      Fex1sq_T3T4CF = Fex1sq_T3T4CF*(1.d0+dlog(1.d0-beta2)**2.d0)**2.d0

      return
      end

      function Fex1sq_CFsq(beta,cost)
      ! This routine returns the contribution to CF^2
      ! coming from <Fex1(0)^2>
      ! Here beta=sqrt(1-4*mt**2/s)
      implicit none
      double precision Fex1sq_CFsq,beta,beta2,cost
      real beta2_r,cost_r,interpolationCFsq
      external interpolationCFsq

      beta2 = beta*beta
      beta2_r = real(beta2)
      cost_r = real(cost)
      Fex1sq_CFsq = dble(interpolationCFsq(beta2_r,cost_r))
      Fex1sq_CFsq = Fex1sq_CFsq*(1.d0+dlog(1.d0-beta2)**2.d0)**2.d0

      return
      end

      subroutine init_interpolation_TTTT(
     &  path_Fex1sq_T3T4T3T4,path_Fex1sq_T3T4TITj,path_Fex1sq_TITjTKTl,
     &  len_Fex1sq_T3T4T3T4,len_Fex1sq_T3T4TITj,len_Fex1sq_TITjTKTl)
      implicit none

      integer i
      integer iopt,m,kx,ky,nxest,nyest,nmax,nx,ny,
     &        lwrk1,lwrk2,kwrk,ier
      integer nx2,ny2,nx3,ny3,kx2,ky2,kx3,ky3
      parameter (m=10000)
      parameter (nmax=210)
      parameter (lwrk1=100000000)
      parameter (lwrk2=50000000)
      parameter (kwrk=70000)
      integer iwrk(kwrk)
      real z1(m),z2(m),z3(m),aux_fac
      real x(m),y(m),w(m),xb,xe,yb,ye,eps,s1,s2,s3,
     &   tx(nmax),ty(nmax),c(50000),fp,wrk1(lwrk1),wrk2(lwrk2)
      real z_T3T4sq(m),z_T3T4CF(m),z_CFsq(m)
      real tx2(nmax),ty2(nmax),c2(50000),tx3(nmax),ty3(nmax),c3(50000)
      common/interpT3T4sq/tx,ty,c,nx,ny,kx,ky
      common/interpT3T4CF/tx2,ty2,c2,nx2,ny2,kx2,ky2
      common/interpCFsq/tx3,ty3,c3,nx3,ny3,kx3,ky3

      integer len_Fex1sq_T3T4T3T4
      integer len_Fex1sq_T3T4TITj
      integer len_Fex1sq_TITjTKTl
      
      character (len = len_Fex1sq_T3T4T3T4) path_Fex1sq_T3T4T3T4
      character (len = len_Fex1sq_T3T4TITj) path_Fex1sq_T3T4TITj
      character (len = len_Fex1sq_TITjTKTl) path_Fex1sq_TITjTKTl

c      write (*,*) "path_Fex1sq_T3T4T3T4 = ", path_Fex1sq_T3T4T3T4
c      write (*,*) "path_Fex1sq_T3T4TITj = ", path_Fex1sq_T3T4TITj
c      write (*,*) "path_Fex1sq_TITjTKTl = ", path_Fex1sq_TITjTKTl

      iopt = 0
      xb = 0.
      xe = 1.
      yb =-1.
      ye = 1.
      kx  = 3
      ky  = 3
      kx2 = 3
      ky2 = 3
      kx3 = 3
      ky3 = 3
      s1 = 0.00001
      s2 = 0.00001
      s3 = 0.00001
      nxest = 200
      nyest = 200
      eps = 0.00001

      open(unit=21,file=path_Fex1sq_T3T4T3T4,status='old')
      open(unit=22,file=path_Fex1sq_T3T4TITj,status='old')
      open(unit=23,file=path_Fex1sq_TITjTKTl,status='old')
c      open(unit=21,file='../grids/Fex1sq_T3T4T3T4.dat',status='old')
c      open(unit=22,file='../grids/Fex1sq_T3T4TITj.dat',status='old')
c      open(unit=23,file='../grids/Fex1sq_TITjTKTl.dat',status='old')

      do i=1,m
         read(21,*)x(i),y(i),z1(i)
         read(22,*)x(i),y(i),z2(i)
         read(23,*)x(i),y(i),z3(i)
C ============= arreglando factor 2 faltante ==
         z2(i) = 2.*z2(i)
C =============================================
         z_T3T4sq(i) = z1(i) - 2.*z2(i) +  4.*z3(i)
         z_T3T4CF(i) = -2.*z2(i) + 8.*z3(i)
         z_CFsq(i)   = 4.*z3(i)
c ============= probando =================
         aux_fac = (1.-y(i)**2.)/(1./x(i)-y(i)**2.)
         z_T3T4sq(i) = z_T3T4sq(i)/aux_fac**2.
         z_T3T4CF(i) = z_T3T4CF(i)/aux_fac**3.
         z_CFsq(i)   = z_CFsq(i)/aux_fac**4.
         w(i) = 1.
      enddo

      close(21)
      close(22)
      close(23)

      call surfit(iopt,m,x,y,z_T3T4sq,w,xb,xe,yb,ye,kx,ky,s1,
     &  nxest,nyest,nmax,eps,nx,tx,ny,ty,c,fp,wrk1,lwrk1,wrk2,
     &  lwrk2,iwrk,kwrk,ier)

      call surfit(iopt,m,x,y,z_T3T4CF,w,xb,xe,yb,ye,kx2,ky2,s2,
     &  nxest,nyest,nmax,eps,nx2,tx2,ny2,ty2,c2,fp,wrk1,lwrk1,wrk2,
     &  lwrk2,iwrk,kwrk,ier)

      call surfit(iopt,m,x,y,z_CFsq,w,xb,xe,yb,ye,kx3,ky3,s3,
     &  nxest,nyest,nmax,eps,nx3,tx3,ny3,ty3,c3,fp,wrk1,lwrk1,wrk2,
     &  lwrk2,iwrk,kwrk,ier)

      return
      end

      function interpolationT3T4sq(xv,yv)
      implicit none
      real interpolationT3T4sq,xv,yv
      integer i
      integer iopt,m,kx,ky,nxest,nyest,nmax,nx,ny,
     &        lwrk1,lwrk2,kwrk,ier,lwrk
      parameter (m=10000)
      parameter (nmax=210)
      parameter (lwrk1=100000000)
      parameter (lwrk2=50000000)
      parameter (kwrk=70000)
      parameter (lwrk=50)
      integer iwrk(kwrk)
      real x(m),y(m),z(m),w(m),xb,xe,yb,ye,s,eps,
     &   tx(nmax),ty(nmax),c(50000),fp,wrk1(lwrk1),wrk2(lwrk2)
      integer mx,my
      real xx(1),yy(1),zz(1),wrk(lwrk),aux_fac
      common/interpT3T4sq/tx,ty,c,nx,ny,kx,ky

      mx = 1 
      my = 1

      xx(1) = xv
      yy(1) = yv

      call bispev(tx,nx,ty,ny,c,kx,ky,xx,mx,yy,my,zz,wrk,lwrk,
     &  iwrk,kwrk,ier)

      aux_fac = (1.-yy(1)**2.)/(1./xx(1)-yy(1)**2.)
      interpolationT3T4sq = zz(1)*aux_fac**2.

      return
      end

      function interpolationT3T4CF(xv,yv)
      implicit none
      real interpolationT3T4CF,xv,yv
      integer i
      integer iopt,m,kx,ky,nxest,nyest,nmax,nx,ny,
     &        lwrk1,lwrk2,kwrk,ier,lwrk
      parameter (m=10000)
      parameter (nmax=210)
      parameter (lwrk1=100000000)
      parameter (lwrk2=50000000)
      parameter (kwrk=70000)
      parameter (lwrk=50)
      integer iwrk(kwrk)
      real x(m),y(m),z(m),w(m),xb,xe,yb,ye,s,eps,
     &   tx(nmax),ty(nmax),c(50000),fp,wrk1(lwrk1),wrk2(lwrk2)
      integer mx,my
      real xx(1),yy(1),zz(1),wrk(lwrk),aux_fac
      common/interpT3T4CF/tx,ty,c,nx,ny,kx,ky

      mx = 1 
      my = 1

      xx(1) = xv
      yy(1) = yv

      call bispev(tx,nx,ty,ny,c,kx,ky,xx,mx,yy,my,zz,wrk,lwrk,
     &  iwrk,kwrk,ier)

      aux_fac = (1.-yy(1)**2.)/(1./xx(1)-yy(1)**2.)
      interpolationT3T4CF = zz(1)*aux_fac**3.

      return
      end

      function interpolationCFsq(xv,yv)
      implicit none
      real interpolationCFsq,xv,yv
      integer i
      integer iopt,m,kx,ky,nxest,nyest,nmax,nx,ny,
     &        lwrk1,lwrk2,kwrk,ier,lwrk
      parameter (m=10000)
      parameter (nmax=210)
      parameter (lwrk1=100000000)
      parameter (lwrk2=50000000)
      parameter (kwrk=70000)
      parameter (lwrk=50)
      integer iwrk(kwrk)
      real x(m),y(m),z(m),w(m),xb,xe,yb,ye,s,eps,
     &   tx(nmax),ty(nmax),c(50000),fp,wrk1(lwrk1),wrk2(lwrk2)
      integer mx,my
      real xx(1),yy(1),zz(1),wrk(lwrk),aux_fac
      common/interpCFsq/tx,ty,c,nx,ny,kx,ky

      mx = 1 
      my = 1

      xx(1) = xv
      yy(1) = yv

      call bispev(tx,nx,ty,ny,c,kx,ky,xx,mx,yy,my,zz,wrk,lwrk,
     &  iwrk,kwrk,ier)

      aux_fac = (1.-yy(1)**2.)/(1./xx(1)-yy(1)**2.)
      interpolationCFsq = zz(1)*aux_fac**4.

      return
      end
