      function Fex2_and_11_T3T4(beta,cost)
      ! This routine returns the contribution to T3T4
      ! coming from Fex2(0)-2*pi*b0*Fex1(1), values for
      ! CA and nf fixed by the init_interpolation_T3T4 call
      ! Here beta=sqrt(1-4*mt**2/s)
      implicit none
      double precision Fex2_and_11_T3T4,beta,beta2,cost
      real beta2_r,cost_r,interpolationT3T4
      external interpolationT3T4

      beta2 = beta*beta
      beta2_r = real(beta2)
      cost_r = real(cost)
      Fex2_and_11_T3T4 = dble(interpolationT3T4(beta2_r,cost_r))
      Fex2_and_11_T3T4 = Fex2_and_11_T3T4*(1.d0+dlog(1.d0-beta2)**2.d0)

      return
      end

c      subroutine init_interpolation_T3T4(CA,nf)
      subroutine init_interpolation_T3T4(CA,nf,
     &      path_Fex2_T3T4_CA,path_Fex2_T3T4_nf,path_Fex11_T3T4,
     &      len_Fex2_T3T4_CA,len_Fex2_T3T4_nf,len_Fex11_T3T4)
      implicit none
      integer i
      integer iopt,m,kx,ky,nxest,nyest,nmax,nx,ny,
     &        lwrk1,lwrk2,kwrk,ier
      parameter (m=10000)
      parameter (nmax=210)
      parameter (lwrk1=100000000)
      parameter (lwrk2=50000000)
      parameter (kwrk=70000)
      integer iwrk(kwrk)
      real z1(m),z2(m),z3(m)
      real x(m),y(m),z(m),w(m),xb,xe,yb,ye,s,eps,
     &   tx(nmax),ty(nmax),c(50000),fp,wrk1(lwrk1),wrk2(lwrk2)
      double precision CA,nf
      real CA_r,nf_r,beta0,pi

      integer len_Fex2_T3T4_CA
      integer len_Fex2_T3T4_nf
      integer len_Fex11_T3T4
      
      character (len = len_Fex2_T3T4_CA) path_Fex2_T3T4_CA
      character (len = len_Fex2_T3T4_nf) path_Fex2_T3T4_nf
      character (len = len_Fex11_T3T4) path_Fex11_T3T4

c      write (*,*) "path_Fex2_T3T4_CA = ", path_Fex2_T3T4_CA
c      write (*,*) "path_Fex2_T3T4_nf = ", path_Fex2_T3T4_nf
c      write (*,*) "path_Fex11_T3T4 = ",  path_Fex11_T3T4

      common/interpT3T4/tx,ty,c,nx,ny,kx,ky

      pi = 3.1415926535897932385
      CA_r = real(CA)
      nf_r = real(nf)
      beta0 = (11.*CA_r - 2.*nf_r)/(12.*pi)

      iopt = 0
      xb = 0.
      xe = 1.
      yb =-1.
      ye = 1.
      kx = 3
      ky = 3
      s = 0.005
      nxest = 200
      nyest = 200
      eps = 0.00001

c     open(unit=21,file=fullpath,status='old')
      open(unit=21,file=path_Fex2_T3T4_CA,status='old')
      open(unit=22,file=path_Fex2_T3T4_nf,status='old')
      open(unit=23,file=path_Fex11_T3T4,status='old')
c      open(unit=21,file='../grids/Fex2_T3T4_CA.dat',status='old')
c      open(unit=22,file='../grids/Fex2_T3T4_nf.dat',status='old')
c      open(unit=23,file='../grids/Fex11_T3T4.dat',status='old')

      do i=1,m
         read(21,*)x(i),y(i),z1(i)
         read(22,*)x(i),y(i),z2(i)
         read(23,*)x(i),y(i),z3(i)
         z(i) = CA_r*z1(i) + nf_r*z2(i) - 2.*pi*beta0*z3(i)
         w(i) = 1.
      enddo

      close(21)
      close(22)
      close(23)

      call surfit(iopt,m,x,y,z,w,xb,xe,yb,ye,kx,ky,s,nxest,nyest,
     &  nmax,eps,nx,tx,ny,ty,c,fp,wrk1,lwrk1,wrk2,lwrk2,iwrk,kwrk,ier)

      return
      end

      function interpolationT3T4(xv,yv)
      implicit none
      real interpolationT3T4,xv,yv
      integer i
      integer iopt,m,kx,ky,nxest,nyest,nmax,nx,ny,
     &        lwrk1,lwrk2,kwrk,ier,lwrk
      parameter (m=10000)
      parameter (nmax=210)
      parameter (lwrk1=100000000)
      parameter (lwrk2=50000000)
      parameter (kwrk=70000)
      parameter (lwrk=50)
      integer iwrk(kwrk)
      real x(m),y(m),z(m),w(m),xb,xe,yb,ye,s,eps,
     &   tx(nmax),ty(nmax),c(50000),fp,wrk1(lwrk1),wrk2(lwrk2)
      integer mx,my
      real xx(1),yy(1),zz(1),wrk(lwrk)
      common/interpT3T4/tx,ty,c,nx,ny,kx,ky

      mx = 1 
      my = 1

      xx(1) = xv
      yy(1) = yv

      call bispev(tx,nx,ty,ny,c,kx,ky,xx,mx,yy,my,zz,wrk,lwrk,
     &  iwrk,kwrk,ier)

      interpolationT3T4 = zz(1)

      return
      end

