c  Implementation of the h function as defined in Stefano's notes.
c  Expansion in terms of as/(2*pi). Objects defined:
c  h1_TT(i,j,beta,cos(theta))
c  h2_TT(i,j,beta,cos(theta))
c  h2_TTTT(i,j,k,l,beta,cos(theta))
c  where beta=sqrt(1-4*mt**2/s) and theta is the angle
c  between p1 and p3, cos(theta) = (t-u)/(s*beta)
c  The indices i,j,k,l take values from 1 to 4, and the only
c  non-vanishing contributions are the ones printed in
c  this example code

	program test
      implicit none
      double precision beta,cost
      double precision CA,nf
      double precision h1_TT,h2_TT,h2_TTTT
      double precision virtgg,virtqq
      integer i_nf,i
      external h1_TT,h2_TT,h2_TTTT

      i_nf = 5
      nf = dble(i_nf)
      CA = 3.d0

      call init_interpolation_T3T4(CA,nf)
      call init_interpolation_TTTT()

      beta = dsqrt(1.d0-0.5d0)
      cost = 0.974679434480896

      write(*,*)"h1_TT(3,4) = ",h1_TT(3,4,beta,cost)
      write(*,*)"h1_TT(3,3) = ",h1_TT(3,3,beta,cost)
      write(*,*)"h2_TT(3,4) = ",h2_TT(3,4,beta,cost)
      write(*,*)"h2_TT(3,1) = ",h2_TT(3,1,beta,cost)
      write(*,*)"h2_TT(4,2) = ",h2_TT(4,2,beta,cost)
      write(*,*)"h2_TT(4,1) = ",h2_TT(4,1,beta,cost)
      write(*,*)"h2_TT(3,2) = ",h2_TT(3,2,beta,cost)
      write(*,*)"h2_TTTT(3,4,3,4) = ",h2_TTTT(3,4,3,4,beta,cost)
      write(*,*)"h2_TTTT(3,4,3,3) = ",h2_TTTT(3,4,3,3,beta,cost)
      write(*,*)"h2_TTTT(3,3,3,3) = ",h2_TTTT(3,3,3,3,beta,cost)

      do i=2,20
       beta=1d0/i
       write(*,*)beta,virtgg(beta,cost),virtqq(beta,cost)
      enddo

      return
      end
