#include "header.hpp"

#include "ppz01.amplitude.NLOgg.set.hpp"

void ppz01_amplitude_NLOgg_initialization(munich * MUC){
  static Logger logger("ppz01_amplitude_NLOgg_initialization");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (MUC->osi->switch_OL){
#ifdef OPENLOOPS
    MUC->asi = new ppz01_amplitude_NLOgg_OpenLoops_set();
#endif
  }
  else if (MUC->osi->switch_RCL){
#ifdef RECOLA
    MUC->asi = new ppz01_amplitude_NLOgg_Recola_set();
#endif
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


ppz01_amplitude_NLOgg_set::ppz01_amplitude_NLOgg_set(){
  static Logger logger("ppz01_amplitude_NLOgg_set::ppz01_amplitude_NLOgg_set ()");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  logger << LOG_DEBUG << "constructor called..." << endline_flush;

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

ppz01_amplitude_NLOgg_set::~ppz01_amplitude_NLOgg_set(){
  static Logger logger("ppz01_amplitude_NLOgg_set::~ppz01_amplitude_NLOgg_set ()");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  logger << LOG_DEBUG << "destructor called..." << endline_flush;

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void ppz01_amplitude_NLOgg_set::initialization_H1gg_QCD_2loop(){
  static Logger logger("ppz01_amplitude_NLOgg_set::initialization_H1gg_QCD_2loop");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  osi->QT_H1_delta_QCD = 0.;
  logger << LOG_DEBUG << "osi->QT_H1_delta_QCD = " << osi->QT_H1_delta_QCD << endline_flush;

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void ppz01_amplitude_NLOgg_set::finalization_H1gg_QCD_2loop(){
  static Logger logger("ppz01_amplitude_NLOgg_set::finalization_H1gg_QCD_2loop");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  logger << LOG_FATAL << "Amplitudes have not been implemented yet." << endline_flush;
  exit(1);

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

/*
void ppz01_amplitude_NLOgg_set::calculate_H1gg_QCD_2loop(){
  static Logger logger("ppz01_amplitude_NLOgg_set::calculate_H1gg_QCD_2loop");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;


  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}
*/

