#ifndef ppaa02_AMPLITUDE_SET_HPP
#define ppaa02_AMPLITUDE_SET_HPP

using namespace std;

void ppaa02_amplitude_initialization(munich * MUC);

double ppaa22_A0(double s, double t, double u);
double ppaa22_H1f(double s, double t, double u);
double ppaa22_H2f(double s, double t, double u, unsigned int Nf, double Qq);

class ppaa02_amplitude_set : virtual public amplitude_set {
private:

public:
  ppaa02_amplitude_set();
  virtual ~ppaa02_amplitude_set();

  virtual void initialization_H2_QCD_2loop();
  virtual void finalization_H2_QCD_2loop();
  virtual void calculate_H2_QCD_2loop();

};


#ifdef OPENLOOPS
class ppaa02_amplitude_OpenLoops_set : virtual public amplitude_OpenLoops_set, virtual public ppaa02_amplitude_set {
private:

public:
  ppaa02_amplitude_OpenLoops_set();
  virtual ~ppaa02_amplitude_OpenLoops_set();

  virtual void initialization_process();
  virtual void initialization_process_extra();
  virtual void initialization_H2_QCD_2loop();
  virtual void finalization_H2_QCD_2loop();
  virtual void calculate_H2_QCD_2loop();

};
#endif


#ifdef RECOLA
class ppaa02_amplitude_Recola_set : virtual public amplitude_Recola_set, virtual public ppaa02_amplitude_set {
private:

public:
  ppaa02_amplitude_Recola_set();
  virtual ~ppaa02_amplitude_Recola_set();

  virtual void initialization_process();
  virtual void initialization_process_extra();
  virtual void initialization_H2_QCD_2loop();
  virtual void finalization_H2_QCD_2loop();
  virtual void calculate_H2_QCD_2loop();

};
#endif

#endif
