#ifndef ppll02_AMPLITUDE_NLOgg_SET_HPP
#define ppll02_AMPLITUDE_NLOgg_SET_HPP

#include "ppll02.amplitude.set.hpp"

using namespace std;

void ppll02_amplitude_NLOgg_initialization(munich * MUC);

class ppll02_amplitude_NLOgg_set : virtual public ppll02_amplitude_set {
private:

public:
  ppll02_amplitude_NLOgg_set();
  virtual ~ppll02_amplitude_NLOgg_set();

  virtual void initialization_H1gg_QCD_2loop();
  virtual inline void finalization_H1gg_QCD_2loop(){}
  virtual inline void calculate_H1gg_QCD_2loop(){}
};


#ifdef OPENLOOPS
class ppll02_amplitude_NLOgg_OpenLoops_set : virtual public ppll02_amplitude_OpenLoops_set, virtual public ppll02_amplitude_NLOgg_set {
private:

public:
  ppll02_amplitude_NLOgg_OpenLoops_set();
  virtual ~ppll02_amplitude_NLOgg_OpenLoops_set();

  virtual void initialization_process();
  virtual void initialization_process_extra();

  virtual void calculate_ME2_VA_QCD();
  virtual void calculate_ME2_CA_QCD();
  virtual void calculate_dipole_Acc_QCD(int x_a);
  virtual void calculate_dipole_Asc_QCD(int x_a, fourvector & Vtensor);
  virtual void calculate_ME2_VT_QCD();
  virtual void calculate_ME2_CT_QCD();

};
#endif


#ifdef RECOLA
class ppll02_amplitude_NLOgg_Recola_set : virtual public ppll02_amplitude_Recola_set, virtual public ppll02_amplitude_NLOgg_set {
private:

public:
  ppll02_amplitude_NLOgg_Recola_set();
  virtual ~ppll02_amplitude_NLOgg_Recola_set();

  virtual void initialization_process();
  virtual void initialization_process_extra();

  virtual void calculate_ME2_VA_QCD();
  virtual void calculate_ME2_CA_QCD();
  virtual void calculate_dipole_Acc_QCD(int x_a);
  virtual void calculate_dipole_Asc_QCD(int x_a, fourvector & Vtensor);
  virtual void calculate_ME2_VT_QCD();
  virtual void calculate_ME2_CT_QCD();
};
#endif

#endif
