#ifndef ppllll04_VVPRIME_HPP
#define ppllll04_VVPRIME_HPP

class VVprimePrivate;

class VVprime {
  public:
    static VVprime &getInstance() {
      static VVprime instance;
      return instance;
    }
    ~VVprime();
    void initAmplitude(int Nf);
    void computeAmplitude(double s, double t, double ma2, double mb2, bool debug=false);
    void getAmplitude(int l, int i, int j, double &Er, double &Ei);
  private:
    VVprime();
    VVprime(VVprime const&);
    void operator=(VVprime const&);
    
    VVprimePrivate* mData;
};

class ggVVprimePrivate;

class ggVVprime {
  public:
    static ggVVprime &getInstance() {
      static ggVVprime instance;
      return instance;
    }
    ~ggVVprime();
    void initAmplitude(int Nf);
    void computeAmplitude(double s, double t, double ma2, double mb2);
    void getAmplitude(int l, int i, int j, double &Er, double &Ei);
  private:
    ggVVprime();
    ggVVprime(ggVVprime const&);
    void operator=(ggVVprime const&);
    
    ggVVprimePrivate* mData;
};

#endif
