#ifndef ppllll04_AMPLITUDE_NLOgg_SET_HPP
#define ppllll04_AMPLITUDE_NLOgg_SET_HPP

#include "ppllll04.amplitude.set.hpp"
#include "ppllll04.ggVVamp.hpp"

using namespace std;

void ppllll04_amplitude_NLOgg_initialization(munich * MUC);

class ppllll04_amplitude_NLOgg_set : virtual public ppllll04_amplitude_set {
private:

public:
  ppllll04_amplitude_NLOgg_set();
  virtual ~ppllll04_amplitude_NLOgg_set();

  virtual void initialization_H1gg_QCD_2loop();
  virtual void finalization_H1gg_QCD_2loop();
  virtual void calculate_H1gg_QCD_2loop();

  void add_hel_amplitudes_H1gg_QCD_2loop(int i_x);
  void reset_hel_amplitudes_H1gg_QCD_2loop(int i_x);
  void calculate_H1gg_QCD_2loop_computeVVprimeHelAmplitudes(int i_x, int i_a);
  double_complex compute_M_gg_ab(int i1, int i2, int i5, int i6, int i7, int i8, int hel, int loop, int type);
  double_complex compute_M_gg_ba(int i1, int i2, int i5, int i6, int i7, int i8, int hel, int loop, int type);

  vector<vector<vector<vector<vector<double_complex> > > > > M_gg_dressed;
  vector<vector<vector<vector<vector<double_complex> > > > > M_gg_dressed2;
  vector<vector<vector<vector<vector<double_complex> > > > > M_gg_dressed_tmp;
  
};


#ifdef OPENLOOPS
class ppllll04_amplitude_NLOgg_OpenLoops_set : virtual public ppllll04_amplitude_OpenLoops_set, virtual public ppllll04_amplitude_NLOgg_set {
private:

public:
  ppllll04_amplitude_NLOgg_OpenLoops_set();
  virtual ~ppllll04_amplitude_NLOgg_OpenLoops_set();

  virtual void initialization_process();
  virtual void initialization_process_extra();

};
#endif


#ifdef RECOLA
class ppllll04_amplitude_NLOgg_Recola_set : virtual public ppllll04_amplitude_Recola_set, virtual public ppllll04_amplitude_NLOgg_set {
private:

public:
  ppllll04_amplitude_NLOgg_Recola_set();
  virtual ~ppllll04_amplitude_NLOgg_Recola_set();

  virtual void initialization_process();
  virtual void initialization_process_extra();

};
#endif

#endif
