#ifndef ppv01_AMPLITUDE_SET_HPP
#define ppv01_AMPLITUDE_SET_HPP

using namespace std;

void ppv01_amplitude_initialization(munich * MUC);

class ppv01_amplitude_set : virtual public amplitude_set {
private:

public:
  ppv01_amplitude_set();
  virtual ~ppv01_amplitude_set();

  virtual void initialization_H2_QCD_2loop();
  virtual void finalization_H2_QCD_2loop();
  virtual void calculate_H2_QCD_2loop();

  // QCD 2-loop amplitudes
  double_complex F1;
  double_complex F2;
  double delta_I1;
  double beta0;
  // QCD I-operator
  double K;
  double delta_qT;
  double D2a;
  double g1a;
  double delta_I2;
};


#ifdef OPENLOOPS
class ppv01_amplitude_OpenLoops_set : virtual public amplitude_OpenLoops_set, virtual public ppv01_amplitude_set {
private:

public:
  ppv01_amplitude_OpenLoops_set();
  virtual ~ppv01_amplitude_OpenLoops_set();

  virtual void initialization_process();
  virtual void initialization_process_extra();
  virtual void initialization_H2_QCD_2loop();
  virtual void finalization_H2_QCD_2loop();
  virtual void calculate_H2_QCD_2loop();

  virtual void calculate_ME2_born();

};
#endif


#ifdef RECOLA
class ppv01_amplitude_Recola_set : virtual public amplitude_Recola_set, virtual public ppv01_amplitude_set {
private:

public:
  ppv01_amplitude_Recola_set();
  virtual ~ppv01_amplitude_Recola_set();

  virtual void initialization_process();
  virtual void initialization_process_extra();
  virtual void initialization_H2_QCD_2loop();
  virtual void finalization_H2_QCD_2loop();
  virtual void calculate_H2_QCD_2loop();

  virtual void calculate_ME2_born();

};
#endif

#endif
