#ifndef ppz01_AMPLITUDE_NLOgg_SET_HPP
#define ppz01_AMPLITUDE_NLOgg_SET_HPP

#include "ppv01.amplitude.set.hpp"

using namespace std;

void ppz01_amplitude_NLOgg_initialization(munich * MUC);

class ppz01_amplitude_NLOgg_set : virtual public ppv01_amplitude_set {
private:

public:
  ppz01_amplitude_NLOgg_set();
  virtual ~ppz01_amplitude_NLOgg_set();

  virtual void initialization_H1gg_QCD_2loop();
  virtual void finalization_H1gg_QCD_2loop();
  virtual inline void calculate_H1gg_QCD_2loop(){}

};


#ifdef OPENLOOPS
class ppz01_amplitude_NLOgg_OpenLoops_set : virtual public ppv01_amplitude_OpenLoops_set, virtual public ppz01_amplitude_NLOgg_set {
private:

public:
  ppz01_amplitude_NLOgg_OpenLoops_set();
  virtual ~ppz01_amplitude_NLOgg_OpenLoops_set();

  virtual void initialization_process();
  virtual void initialization_process_extra();

  virtual void calculate_ME2_VA_QCD();
  virtual void calculate_ME2_CA_QCD();
  virtual void calculate_dipole_Acc_QCD(int x_a);
  virtual void calculate_dipole_Asc_QCD(int x_a, fourvector & Vtensor);
  virtual void calculate_ME2_VT_QCD();
  virtual void calculate_ME2_CT_QCD();

};
#endif


#ifdef RECOLA
class ppz01_amplitude_NLOgg_Recola_set : virtual public ppv01_amplitude_Recola_set, virtual public ppz01_amplitude_NLOgg_set {
private:

public:
  ppz01_amplitude_NLOgg_Recola_set();
  virtual ~ppz01_amplitude_NLOgg_Recola_set();

  virtual void initialization_process();
  virtual void initialization_process_extra();

  virtual void calculate_ME2_VA_QCD();
  virtual void calculate_ME2_CA_QCD();
  virtual void calculate_dipole_Acc_QCD(int x_a);
  virtual void calculate_dipole_Asc_QCD(int x_a, fourvector & Vtensor);
  virtual void calculate_ME2_VT_QCD();
  virtual void calculate_ME2_CT_QCD();
};
#endif

#endif
