#ifndef ppww02_AMPLITUDE_SET_HPP
#define ppww02_AMPLITUDE_SET_HPP

using namespace std;

void ppww02_amplitude_initialization(munich * MUC);
// this is the main function
/* s, t are the usual Mandelstam invariants, m2 is the squared W mass */
void ampww(double s, double t, double m2,
           double& f0_N, double& j0_N, double& k0_N,
           double& f1_CF_N, double& j1_CF_N, double& k1_CF_N,
           double& f11_CF2_N, double& j11_CF2_N, double& k11_CF2_N,
           double& f2_CF2_N, double& j2_CF2_N, double& k2_CF2_N,
           double& f2_CF, double& j2_CF, double& k2_CF,
           double& f2_CF_N_Nf, double& j2_CF_N_Nf, double& k2_CF_N_Nf,
           double& f2_CF_N_NfWW, double& j2_CF_N_NfWW);

/*
// this is an interface to Fortran
extern "C" void ampwwfort_(double* s, double* t, double* m2,
  double* f0_N, double* j0_N, double* k0_N,
  double* f1_CF_N, double* j1_CF_N, double* k1_CF_N,
  double* f11_CF2_N, double* j11_CF2_N, double* k11_CF2_N,
  double* f2_CF2_N, double* j2_CF2_N, double* k2_CF2_N,
  double* f2_CF, double* j2_CF, double* k2_CF,
  double* f2_CF_N_Nf, double* j2_CF_N_Nf, double* k2_CF_N_Nf,
  double* f2_CF_N_NfWW, double* j2_CF_N_NfWW);
*/

class ppww02_amplitude_set : virtual public amplitude_set {
private:

public:
  ppww02_amplitude_set();
  virtual ~ppww02_amplitude_set();

  virtual void initialization_H2_QCD_2loop();
  virtual void finalization_H2_QCD_2loop();
  virtual void calculate_H2_QCD_2loop();

};


#ifdef OPENLOOPS
class ppww02_amplitude_OpenLoops_set : virtual public amplitude_OpenLoops_set, virtual public ppww02_amplitude_set {
private:

public:
  ppww02_amplitude_OpenLoops_set();
  virtual ~ppww02_amplitude_OpenLoops_set();

  virtual void initialization_process();
  virtual void initialization_process_extra();
  virtual void initialization_H2_QCD_2loop();
  virtual void finalization_H2_QCD_2loop();
  virtual void calculate_H2_QCD_2loop();

};
#endif


#ifdef RECOLA
class ppww02_amplitude_Recola_set : virtual public amplitude_Recola_set, virtual public ppww02_amplitude_set {
private:

public:
  ppww02_amplitude_Recola_set();
  virtual ~ppww02_amplitude_Recola_set();

  virtual void initialization_process();
  virtual void initialization_process_extra();
  virtual void initialization_H2_QCD_2loop();
  virtual void finalization_H2_QCD_2loop();
  virtual void calculate_H2_QCD_2loop();

};
#endif

#endif
