#ifndef MANAGERTSV_H
#define MANAGERTSV_H

#include <iostream>
#include <iomanip>
#include <fstream>
#include <sstream>
#include <map>
#include <string>
#include <vector>

using namespace std;

#include "logger.hpp"
#include "ftypes.hpp"
#include "fourvector.hpp"
#include "manager.TSV.hpp"

class observable_set;
class amplitude_set;

class manager_TSV{
private:

public:
  manager_TSV();
  manager_TSV(observable_set * _osi);
  virtual ~manager_TSV();

  //  manager_TSV(inputparameter_set * isi, contribution_set * _csi, model_set * _msi, event_set * _esi, phasespace_set * _psi, user_defined * _user);

  void initialization_basic_TSV();
  void initialization_scale_TSV();

  // src/observable/manager.TSV.initialization.cpp
  void initialization_input_predefinition_TSV(inputparameter_set * isi);
  void initialization_set_default();
  void initialization_input(inputparameter_set * isi);
  void initialization_after_input();

  
  
  // required from observable_set so far:
  /*
    min_qTcut
    n_qTcut
    step_qTcut
    switch_distribution
    prefactor_reference
    n_moments
    csi
    n_ps
  */
  

  int switch_TSV;
  
  double scale_ren;
  double scale_fact;

  int needed_scale2_ren;
  int needed_scale2_fact;

  vector<int> n_scale_TSV;
  int max_n_scale_ren_TSV;
  int max_n_scale_fact_TSV;
  int n_dynamic_scale_TSV;
  vector<int> switch_dynamic_scale_TSV;
  vector<int> dynamic_scale_TSV;
  vector<double> relative_central_scale_TSV;
  vector<int> factor_scale_TSV;
  vector<double> central_scale_TSV;
  vector<string> name_TSV;
  int n_set_TSV;
  vector<string> name_set_TSV;
  vector<double> central_scale_ren_TSV;
  vector<double> central_scale_fact_TSV;
  vector<double> relative_central_scale_ren_TSV;
  vector<double> relative_central_scale_fact_TSV;
  vector<int> n_scale_ren_TSV;
  vector<int> n_scale_fact_TSV;
  vector<int> factor_scale_ren_TSV; // integer ???
  vector<int> factor_scale_fact_TSV; // integer ???
  vector<int> dynamic_scale_ren_TSV;
  vector<int> dynamic_scale_fact_TSV;

  int max_dyn_ren;
  int max_dyn_fact;
  int max_scale_dyn_ren;
  int max_scale_dyn_fact;
  vector<int> n_scale_dyn_ren;
  vector<int> n_scale_dyn_fact;


  vector<double> min_qTcut_TSV;
  vector<double> max_qTcut_TSV;

  int switch_distribution_at_all_TSV;
  vector<int> switch_distribution_TSV;
  vector<int> max_n_integrand_TSV;
  vector<double> min_qTcut_distribution_TSV;
  vector<double> max_qTcut_distribution_TSV;


  vector<int> switch_moment_TSV;

  vector<int> no_central_scale_ren_TSV;
  vector<int> no_central_scale_fact_TSV;

  vector<vector<double> > relative_scale_ren_TSV;
  vector<vector<double> > relative_scale_fact_TSV;

  vector<string> name_diff_set_TSV;
  int n_diff_set_TSV;
  vector<string> name_diff_set_plus_TSV;
  vector<string> name_diff_set_minus_TSV;
  vector<int> no_diff_set_plus_TSV;
  vector<int> no_diff_set_minus_TSV;

  vector<string> name_extended_set_TSV;
  int n_extended_set_TSV;


  string name_reference_TSV;
  int no_reference_TSV;
  int no_scale_ren_reference_TSV;
  int no_scale_fact_reference_TSV;
  int no_qTcut_reference_TSV;


  // scale organization
  
  vector<vector<string> > name_scale_ren_TSV;
  vector<vector<string> > name_scale_fact_TSV;

  vector<vector<int> > no_value_ren_TSV;
  vector<vector<int> > no_value_fact_TSV;

  vector<int> value_no_central_scale_fact; // where is 'central' scale in each DS set
  vector<double> value_central_scale_fact; // where is 'central' scale in each DS set
  vector<double> value_central_logscale2_fact; // where is 'central' scale in each DS set

  vector<vector<double> > value_relative_scale_ren;
  vector<vector<double> > value_relative_scale2_ren;
  vector<vector<vector<double> > > value_alpha_S_TSV;
  vector<vector<vector<double> > > value_relative_factor_alpha_S;
  vector<vector<vector<double> > > value_scale_ren;
  vector<vector<vector<double> > > value_scale2_ren;

  vector<vector<double> > value_relative_scale_fact;
  vector<vector<double> > value_relative_scale2_fact;
  vector<vector<double> > value_relative_logscale2_fact;
  vector<vector<vector<double> > > value_scale_fact;
  vector<vector<vector<double> > > value_scale2_fact;

  vector<vector<double*> > pointer_relative_scale_ren;
  vector<vector<double*> > pointer_relative_scale2_ren;
  vector<vector<vector<double*> > > pointer_alpha_S_TSV;
  vector<vector<vector<double*> > > pointer_relative_factor_alpha_S;
  vector<vector<vector<double*> > > pointer_scale_ren;
  vector<vector<vector<double*> > > pointer_scale2_ren;

  vector<vector<double*> > pointer_relative_scale_fact;
  vector<vector<double*> > pointer_relative_scale2_fact;
  vector<vector<double*> > pointer_relative_logscale2_fact;
  vector<vector<vector<double*> > > pointer_scale_fact;
  vector<vector<vector<double*> > > pointer_scale2_fact;

  observable_set * osi;

};

#endif
