#ifndef MAPPINGFULLCHANNEL_H
#define MAPPINGFULLCHANNEL_H

#include <string>
#include <vector>

using namespace std;

class mapping_fullchannel{
private:
  int x_fullchannel;
  int x_a;

  vector<int> x_p;
  vector<int> x_f;
  vector<int> x_t;
  vector<int> x_d;

public:
  mapping_fullchannel();
  mapping_fullchannel(int _x_fullchannel, int _x_a, vector<int> _x_p, vector<int> _x_f, vector<int> _x_t, vector<int> _x_d, phasespace_set * _psi);
  virtual ~mapping_fullchannel();

  void initialization(int _x_fullchannel, int _x_a, string & content, phasespace_set * _psi);
  void initialization(int _x_fullchannel, int _x_a, vector<int> _x_p, vector<int> _x_f, vector<int> _x_t, vector<int> _x_d, phasespace_set * _psi);

  inline vector<int> get_x_p() const { return x_p; }
  inline vector<int> get_x_f() const { return x_f; }
  inline vector<int> get_x_t() const { return x_t; }
  inline vector<int> get_x_d() const { return x_d; }
  
  string info() const ;

  inline bool operator == (const mapping_fullchannel & ch) const {
    if ((x_a == ch.x_a) && (x_fullchannel == ch.x_fullchannel) && (x_p == ch.x_p) && (x_f == ch.x_f) && (x_t == ch.x_t) && (x_d == ch.x_d)){return true;}
    else {return false;}
  }

  vector<mapping_propagator * > propagator;
  vector<mapping_timelikeinvariant * > timelikeinvariant;
  vector<mapping_tchannel * > tchannel;
  vector<mapping_decay * > decay;


  /*
  void calculate_fullchannel_limits();

  void calculate_c();
  void calculate_g();
  void calculate_inv_r();

  void errorhandling_c();
  void errorhandling_g();
  void errorhandling_inv_r();

  void calculate_Breit_Wigner_limits();

  void calculate_Breit_Wigner_c();
  void calculate_Breit_Wigner_g();
  void calculate_Breit_Wigner_inv_r();

  void errorhandling_Breit_Wigner_c();
  void errorhandling_Breit_Wigner_g();
  void errorhandling_Breit_Wigner_inv_r();

  void calculate_vanishing_width_limits();

  void calculate_vanishing_width_c();
  void calculate_vanishing_width_g();
  void calculate_vanishing_width_inv_r();

  void errorhandling_vanishing_width_c();
  void errorhandling_vanishing_width_g();
  void errorhandling_vanishing_width_inv_r();

  
  string output_extended_info();


  string name;
  
  double * g_p;

  double r1;
  double g_IS_r1;

  randomvariable * random_psp_r1;

  double * fullchannel_out;
  double * smax_out;

  double * s_out;
  double * sqrts_out;

  bool fail;

  int n_fail_c;
  int n_fail_g;
  int n_fail_inv_r;
  */
  phasespace_set * psi;
  bool available;

};

#endif
