#ifndef MAPPINGSMAX_H
#define MAPPINGSMAX_H

#include <string>
#include <vector>

using namespace std;

class mapping_smax{
private:
  int x_smax;
  int x_a;

  vector<int> p_smax_xb;
  int p_smax_process;

  bool switch_trivial;
  //  int level_complexity;

  int xb_combination;

  vector<int> required_xbsqrts;

public:
  mapping_smax();
  mapping_smax(int _x_smax, int _x_a, int _p_smax_process, vector<int> _p_smax_xb, phasespace_set * _psi);
  virtual ~mapping_smax();

  void initialization(int _x_smax, int _x_a, string & content, phasespace_set * _psi);
  void initialization(int _x_smax, int _x_a, int _p_smax_process, vector<int> _p_smax_xb, phasespace_set * _psi);
  void initialization_integration();

  inline vector<int> get_required_xbsqrts() const { return required_xbsqrts; }

  inline void get(){ if (!available){ calculate(); } };
  inline void reset(){ available = false; }
  void calculate();
  string info() const ;

  inline bool operator == (const mapping_smax & ch) const {
    if ((x_a == ch.x_a) && (x_smax == ch.x_smax) && (p_smax_process == ch.p_smax_process) && (p_smax_xb == ch.p_smax_xb)){return true;}
    else {return false;}
  }

  double * smax;

  phasespace_set * psi;
  bool available;

};

#endif
