#ifndef MAPPINGSMIN_H
#define MAPPINGSMIN_H

#include <string>
#include <vector>

using namespace std;

class mapping_smin{
private:
  int x_smin;
  int x_a;

  vector<int> p_smin_xb;

  bool switch_trivial;

  int xb_combination;

  vector<int> required_xbsqrts;

public:
  mapping_smin();
  mapping_smin(int _x_smin, int _x_a, vector<int> _p_smin_xb, phasespace_set * _psi);
  virtual ~mapping_smin();

  void initialization(int _x_smin, int _x_a, string & content, phasespace_set * _psi);
  void initialization(int _x_smin, int _x_a, vector<int> _p_smin_xb, phasespace_set * _psi);
  void initialization_integration();

  inline vector<int> get_required_xbsqrts() const { return required_xbsqrts; }

  inline void get(){ if (!available){ calculate(); } };
  inline void reset(){ available = false; }
  void calculate();
  string info() const ;

  inline bool operator == (const mapping_smin & ch) const {
    if ((x_a == ch.x_a) && (x_smin == ch.x_smin) && (p_smin_xb == ch.p_smin_xb)){return true;}
    else {return false;}
  }

  double * smin;

  phasespace_set * psi;
  bool available;

};

#endif
