#ifndef MAPPINGTIMELIKEINVARIANT_H
#define MAPPINGTIMELIKEINVARIANT_H

#include <string>
#include <vector>

using namespace std;

class mapping_smin;
class mapping_smax;

class mapping_timelikeinvariant{
private:
  int x_f;
  int x_a;
  
  int out;

  vector<int> required_xbp;
  vector<int> required_xbs;
  vector<int> required_xbsqrts;

  int x_smin;
  int x_smax;
  
  mapping_smin * smin;
  mapping_smax * smax;

public:
  mapping_timelikeinvariant();
  mapping_timelikeinvariant(int _x_f, int _x_a, int _out, int _x_smin, int _x_smax, phasespace_set * _psi);
  virtual ~mapping_timelikeinvariant();

  void initialization(int _x_f, int _x_a, string & content, phasespace_set * _psi);
  void initialization(int _x_f, int _x_a, int _out, int _x_smin, int _x_smax, phasespace_set * _psi);
  void initialization_integration();

  void calculate_c();
  void calculate_g();
  void calculate_inv_r();

  void errorhandling_c();
  void errorhandling_g();
  void errorhandling_inv_r();
 
  inline int get_x_f() const { return x_f; }
  inline int get_x_smin() const { return x_smin; }
  inline int get_x_smax() const { return x_smax; }

  inline vector<int> get_required_xbp() const { return required_xbp; }
  inline vector<int> get_required_xbs() const { return required_xbs; }
  inline vector<int> get_required_xbsqrts() const { return required_xbsqrts; }

  string info() const ;
  string output_extended_info();

  inline bool operator == (const mapping_timelikeinvariant & ch) const {
    if ((x_a == ch.x_a) && (x_f == ch.x_f) && (out == ch.out) && (x_smin == ch.x_smin) && (x_smax == ch.x_smax)){return true;}
    else {return false;}
  }


  string name;
  string MC_IS_name_f;

  double * g_f;

  double r1;
  double g_IS_r1;
  
  randomvariable * random_psp_r1;

  double * smin_out;
  double * smax_out;

  double * s_out;
  double * sqrts_out;

  phasespace_set * psi;
  bool available;
  bool fail;

  int n_fail_c;
  int n_fail_g;
  int n_fail_inv_r;
  
};

#endif
