public:
  // qTsubtraction/observable.qTsubtraction.initialization.cpp
  void initialization_specific_VT();
  // empty !!!
  ///  void initialization_specific_QT();
  void initialization_PT();
  void initialization_QT();
  // empty !!!
  void initialization_QT_selection();
  void initialization_CX_ncollinear();
  void initialization_QT_coefficients();

  // qTsubtraction/observable.ncollinear.cpp
  void remove_empty_ncollinear();
  void determine_QT_list_combination_pdf();
  string output_ncollinear(multicollinear_set & this_ncollinear);

  // qTsubtraction/observable.qTsubtraction.specialfunctions.cpp
  void calculate_coefficients_Itilde(const double xmio, const int order);
  void calculate_integrated_Itilde(const int order);

  // qTsubtraction/observable.qTsubtraction.cpp
  void calculate_A_F();
  void calculate_B2_A_F();
  void determine_psp_weight_QT();


  // qTsubtraction/observable.ncollinear.QCD.cpp
  void determine_CX_QCD(int n_emission);
  void determine_CX_ncollinear_QCD(int n_emission);
  void determine_QT_Q2f_QCD();

  // qTsubtraction/observable.qTsubtraction.initialization.QCD.cpp
  void initialization_QT_coefficients_QCD_1();
  void initialization_QT_coefficients_QCD_2();
  void initialization_splitting_QCD_1();
  void initialization_splitting_QCD_2();

  // qTsubtraction/observable.qTsubtraction.coefficients.QCD.cpp
  void determine_splitting_tH1F_QCD();
  void determine_splitting_tH1_QCD();
  void determine_splitting_tgaga_tcga_tgamma2_QCD();
  void determine_splitting_tH2_QCD();

  // qTsubtraction/observable.qTsubtraction.QCD.cpp
  void initialization_sigma12_QCD();
  void initialization_sigma11_QCD();

  double calculate_sigma12_QCD(double & pdf_factor_x1x2);
  double calculate_sigma11_QCD(double & pdf_factor_x1x2, double & tH1F_QCD, double & LQ);
  double calculate_H1_QCD(double pdf_factor_x1x2, double tH1delta_QCD, double tH1_QCD, double tH1F_QCD, double LR, double LF, double LQ);
  double calculate_sigma24_QCD(double & pdf_factor_x1x2);
  double calculate_sigma23_QCD(double & pdf_factor_x1x2, double & sig11_QCD);
  double calculate_sigma22_QCD(double & pdf_factor_x1x2, double & sig11_QCD, double & tH1_QCD, double & tH1F_QCD, double & H1full_QCD, double & tgaga_QCD, double & LR, double & LF, double & LQ);
  double calculate_sigma21_QCD(double & pdf_factor_x1x2, double & sig11_QCD, double & tH1delta, double & tH1_QCD, double & tH1F_QCD, double & H1full_QCD, double & tgaga_QCD, double & tcga_QCD, double & tgamma2_QCD, double & LR, double & LF, double & LQ, double & A_F);
  double calculate_H2_QCD(double pdf_factor_x1x2, double tH1delta_QCD, double tH1_QCD, double tH1F_QCD, double H1full_QCD, double sig11_QCD, double tgaga_QCD, double tcga_QCD, double tgamma2_QCD, double tH2_QCD, double LR, double LF, double LQ);

  // qTsubtraction/observable.qTsubtraction.massive.QCD.cpp
  void determine_correlationoperator_QCD();

  // qTsubtraction/observable.qTsubtraction.CT.QCD.cpp
  void determine_integrand_CX_ncollinear_CT_QCD();
  string output_ME2_CT_QCD();
  string output_sigma_coefficients_CT_QCD(int i_a);

  // qTsubtraction/observable.qTsubtraction.VT.QCD.cpp
  void determine_integrand_CX_ncollinear_VT_QCD();
  string output_ME2_VT_QCD();

  // qTsubtraction/observable.qTsubtraction.CT2.QCD.cpp
  void determine_integrand_CX_ncollinear_CT2_QCD();
  string output_ME2_CT2_QCD();
  string output_sigma_coefficients_CT2_QCD(int i_a);

  // qTsubtraction/observable.qTsubtraction.VT2.QCD.cpp
  void determine_integrand_CX_ncollinear_VT2_QCD();
  string output_ME2_VT2_QCD();
  void output_integrand_maximum_VT2();


  vector<vector<multicollinear_set> > multicollinear;
  vector<multicollinear_set> ncollinear;

  vector<int> nc_splitting_QCD_1;
  vector<int> nc_splitting_QCD_2;

  vector<int> sign_QT_powercorrection_phasespace;


  double QT_A0;
  
  double QT_A1;
  //  double QT_A1_QCD could replace QT_A1 !!!
  double QT_A1_QCD;
  double QT_H1_delta_QCD;

  double QT_A2;
  //  double QT_A2_QCD; //rename ???
  double QT_H2_delta_QCD;

  double QT_H0_doublespinflip;
  double QT_H0_DG;



  int QT_initialstate_type;

// corresponds to massive_QCD/QEW for dipolesubtraction ???
  int QT_finalstate_massive_coloured;

  fourvector QT_Q;
  double QT_QT;
  double QT_sqrtQ2;


//  double m_HQ;
//  double m2_HQ;


  
  // qTsubtraction parameters - could be treated in qTsubtraction_basic
  
  int switch_qTcut;
  int n_qTcut;
  double min_qTcut;
  double step_qTcut;
  double max_qTcut;
  string binning_qTcut;
  string selection_qTcut;

  int active_qTcut;
  int output_n_qTcut;

  vector<double> value_qTcut;

  string selection_qTcut_distribution;
  string selection_no_qTcut_distribution;
  vector<int> no_qTcut_distribution;
  vector<double> value_qTcut_distribution;

  string selection_qTcut_result;
  string selection_no_qTcut_result;
  vector<int> no_qTcut_result;
  vector<double> value_qTcut_result;

  string selection_qTcut_integration;
  string selection_no_qTcut_integration;
  vector<int> no_qTcut_integration;
  vector<double> value_qTcut_integration;



  vector<vector<vector<double> > > QT_Q2f;


  // only for massive case ???
  vector<correlationoperator> QT_correlationoperator;
  vector<double> QT_ME2_cf;

  vector<double> QT_ME2_loopcf;

  vector<double> QT_ME2_Born4cf;

  vector<vector<double> > QT_ME2_cfcf;
  vector<vector<double> > QT_ME2hc_cfcf;
  
  vector<vector<double> > int_I;
  vector<vector<double> > error_I;
  vector<double> LL;
/*
  // to be replaced by int_I !!!
  vector<double> I1_int;
  vector<double> I2_int;
  vector<double> I3_int;
  vector<double> I4_int;
*/
  // Only "used" in NJsubtraction
  vector<double> LL0_int;
  vector<double> LL1_int;
  vector<double> LL2_int;
  vector<double> LL3_int;

  double beta0;
  double beta1;
  double Kappa;

  double A1g;
  double B1g;
  double A2g;
  double Delta2gg;
  double B2g;

  double D0gggg;
  double D1gggg;
  double Deltagggg;

  double H2ggD0;

  double A1q;
  double B1q;
  double A2q;
  double Delta2qq;
  double B2q;

  double gamma2Q;
  double gammacusp2;


  //  CC    Coefficients of D0 and D1 in P*P (as/pi normalization)
  double D0qqqq;
  double D1qqqq;
  //CC    Coefficients of delta(1-z) in P*P
  double Deltaqqqq;

  double H2qqD0;

  double A_F;
  double B2_A_F;

  // constant coefficient entering sigma_xy_QCD:
  double sig12_QCD;
  double sig11_QCD;
  double sig24_QCD;
  double sig23_QCD;
  double sig22_QCD;
  double sig21_QCD;

  double Ft1born;
  vector<double> Ft1born_4correlator;
  double Gamma1born;
  double Gamma1loop;
  double Gamma2;
  double Gamma1squared;
  double commutator_Gammat1_Ft1;
  //  double anticommutator_Gammat1_Ft1;
  //  double Gammat1_Ft1;
  //  double Ft1_Gammat1;





  // log µ²/Q² factors for qTsubtraction
  vector<vector<double> > value_LR;
  vector<vector<double> > value_LF;
  vector<vector<double> > value_LQ;

  vector<vector<double> > value_LR_TSV;
  vector<vector<double> > value_LF_TSV;
  vector<vector<double> > value_LQ_TSV;


  // qTsubtraction coefficients: NLO QCD
  
  vector<vector<double> > coll_tH1F_contribution_QCD;
  vector<vector<double> > coll_tH1_contribution_QCD;
  vector<vector<double> > coll_tH1_only_H1_delta_contribution_QCD;
  /////  vector<vector<double> > coll_tH1_without_H1_delta_contribution_QCD;

  vector<double> coll_tH1F_QCD;
  vector<double> coll_tH1_QCD;
  vector<double> coll_tH1_only_H1_delta_QCD;

  vector<vector<vector<double > > > coll_tH1F_QCD_pdf;
  vector<vector<vector<double > > > coll_tH1_QCD_pdf;
  vector<vector<vector<double > > > coll_tH1_only_H1_delta_QCD_pdf;
  //  vector<vector<vector<double > > > coll_tH1_without_H1_delta_QCD_pdf;
  
  vector<vector<vector<vector<double> > > > coll_tH1F_QCD_pdf_D;
  vector<vector<vector<vector<double> > > > coll_tH1_QCD_pdf_D;
  vector<vector<vector<vector<double> > > > coll_tH1_only_H1_delta_QCD_pdf_D;
  //  vector<vector<vector<vector<double> > > > coll_tH1_without_H1_delta_QCD_pdf_D;

  vector<vector<double> > value_sig11_QCD;
  vector<vector<double> > value_sig12_QCD;
  vector<vector<double> > value_tH1F_QCD;
  vector<vector<double> > value_tH1_QCD;
  vector<vector<double> > value_tH1_only_H1_delta_QCD;
  vector<vector<vector<vector<double> > > > value_H1full_QCD;

  vector<vector<vector<double> > > value_sig11_QCD_D;
  vector<vector<vector<double> > > value_tH1F_QCD_D;
  vector<vector<vector<double> > > value_tH1_QCD_D;
  vector<vector<vector<double> > > value_tH1_only_H1_delta_QCD_D;
  //  vector<vector<vector<double> > > value_tH1_without_H1_delta_QCD_D;
  vector<vector<vector<vector<vector<double> > > > > value_H1full_QCD_D;

  vector<vector<vector<vector<double> > > > coll_tH1F_QCD_pdf_TSV;
  vector<vector<vector<vector<double> > > > coll_tH1_QCD_pdf_TSV;
  vector<vector<vector<vector<double> > > > coll_tH1_only_H1_delta_QCD_pdf_TSV;
  vector<vector<vector<vector<double> > > > coll_tH1_without_H1_delta_QCD_pdf_TSV;

  vector<vector<vector<double> > > value_sig11_QCD_TSV;
  vector<vector<vector<double> > > value_tH1F_QCD_TSV;
  vector<vector<vector<double> > > value_tH1_QCD_TSV;
  vector<vector<vector<double> > > value_tH1_only_H1_delta_QCD_TSV;
  //  vector<vector<vector<double> > > value_tH1_without_H1_delta_QCD_TSV;
  vector<vector<vector<vector<vector<double> > > > > value_H1full_QCD_TSV;

  
  // qTsubtraction coefficients: NNLO QCD

  vector<vector<double> > coll_tgaga_contribution_QCD;
  vector<vector<double> > coll_tcga_contribution_QCD;
  vector<vector<double> > coll_tgamma2_contribution_QCD;
  vector<vector<double> > coll_tH2_contribution_QCD;

  vector<double> coll_tgaga_QCD;
  vector<double> coll_tcga_QCD;
  vector<double> coll_tgamma2_QCD;
  vector<double> coll_tH2_QCD;

  vector<vector<vector<double > > > coll_tgaga_QCD_pdf;
  vector<vector<vector<double > > > coll_tcga_QCD_pdf;
  vector<vector<vector<double > > > coll_tgamma2_QCD_pdf;
  vector<vector<vector<double > > > coll_tH2_QCD_pdf;

  vector<vector<vector<vector<double> > > > coll_tgaga_QCD_pdf_D;
  vector<vector<vector<vector<double> > > > coll_tcga_QCD_pdf_D;
  vector<vector<vector<vector<double> > > > coll_tgamma2_QCD_pdf_D;
  vector<vector<vector<vector<double> > > > coll_tH2_QCD_pdf_D;

  vector<vector<double> > value_tgaga_QCD;
  vector<vector<double> > value_tcga_QCD;
  vector<vector<double> > value_tgamma2_QCD;
  vector<vector<double> > value_sig23_QCD;
  vector<vector<double> > value_sig24_QCD;
  vector<vector<double> > value_tH2_QCD;
  vector<vector<vector<vector<double> > > > value_sig21_QCD;
  vector<vector<vector<vector<double> > > > value_sig22_QCD;
  vector<vector<vector<vector<double> > > > value_H2full_QCD;

  vector<vector<vector<double> > > value_tgaga_QCD_D;
  vector<vector<vector<double> > > value_tcga_QCD_D;
  vector<vector<vector<double> > > value_tgamma2_QCD_D;
  vector<vector<vector<double> > > value_sig12_QCD_D;
  vector<vector<vector<double> > > value_sig23_QCD_D;
  vector<vector<vector<double> > > value_sig24_QCD_D;
  vector<vector<vector<double> > > value_tH2_QCD_D;
  vector<vector<vector<vector<vector<double> > > > > value_sig21_QCD_D;
  vector<vector<vector<vector<vector<double> > > > > value_sig22_QCD_D;
  vector<vector<vector<vector<vector<double> > > > > value_H2full_QCD_D;

  vector<vector<vector<vector<double> > > > coll_tgaga_QCD_pdf_TSV;
  vector<vector<vector<vector<double> > > > coll_tcga_QCD_pdf_TSV;
  vector<vector<vector<vector<double> > > > coll_tgamma2_QCD_pdf_TSV;
  vector<vector<vector<vector<double> > > > coll_tH2_QCD_pdf_TSV;

  vector<vector<vector<double> > > value_tgaga_QCD_TSV;
  vector<vector<vector<double> > > value_tcga_QCD_TSV;
  vector<vector<vector<double> > > value_tgamma2_QCD_TSV;
  vector<vector<vector<double> > > value_tH2_QCD_TSV;
  vector<vector<vector<double> > > value_sig12_QCD_TSV;
  vector<vector<vector<double> > > value_sig23_QCD_TSV;
  vector<vector<vector<double> > > value_sig24_QCD_TSV;
  vector<vector<vector<vector<vector<double> > > > > value_sig21_QCD_TSV;
  vector<vector<vector<vector<vector<double> > > > > value_sig22_QCD_TSV;
  vector<vector<vector<vector<vector<double> > > > > value_H2full_QCD_TSV;

