#include "header.hpp"

#include "ppaaa03.amplitude.set.hpp"

#include "ppaaa03.contribution.set.hpp"
#include "ppaaa03.event.set.hpp"
#include "ppaaa03.phasespace.set.hpp"
#include "ppaaa03.observable.set.hpp"
#include "ppaaa03.summary.hpp"

int main(int argc, char *argv[]){
  cout << "BEGIN" << endl;

  munich * MUC;
  MUC = new munich(argc, argv, "pp-aaa+X", "ppaaa03");

  MUC->csi = new ppaaa03_contribution_set();
  MUC->esi = new ppaaa03_event_set();
  MUC->psi = new ppaaa03_phasespace_set();
  MUC->osi = new ppaaa03_observable_set();

  MUC->initialization();

  if (MUC->subprocess != ""){
    ppaaa03_amplitude_initialization(MUC);

    if (MUC->csi->type_contribution == "RT" || MUC->csi->type_contribution == "RRA"){
      MUC->psi->fake_psi = new ppaaa03_phasespace_set();
      MUC->psi->fake_psi->csi = new ppaaa03_contribution_set();
    }

    MUC->run_initialization();
    MUC->run_integration();

    cout << "END " << MUC->csi->type_contribution << " " << MUC->csi->type_correction << endl;
  }
  else {
    MUC->ysi = new ppaaa03_summary_generic();
    MUC->get_summary();

    cout << "END RESULT/DISTRIBUTION" << endl;
  }
  MUC->walltime_end();
  return 0;
}
