#include "header.hpp"

#include "ppllll04.amplitude.NLOgg.set.hpp"

#include "ppeeexex04.contribution.set.hpp"
#include "ppeeexex04.event.set.hpp"
#include "ppeeexex04.phasespace.set.hpp"
#include "ppeeexex04.observable.set.hpp"
#include "ppeeexex04.summary.hpp"

int main(int argc, char *argv[]){
  cout << "BEGIN" << endl;

  munich * MUC;
  MUC = new munich(argc, argv, "pp-ememepep+X", "ppeeexex04");

  MUC->csi = new ppeeexex04_contribution_set();
  MUC->esi = new ppeeexex04_event_set();
  MUC->psi = new ppeeexex04_phasespace_set();
  MUC->osi = new ppeeexex04_observable_set();

  MUC->initialization();

  if (MUC->subprocess != ""){
    ppllll04_amplitude_NLOgg_initialization(MUC);

    if (MUC->csi->type_contribution == "RT" || MUC->csi->type_contribution == "RRA"){
      MUC->psi->fake_psi = new ppeeexex04_phasespace_set();
      MUC->psi->fake_psi->csi = new ppeeexex04_contribution_set();
    }

    MUC->run_initialization();
    MUC->run_integration();

    cout << "END " << MUC->csi->type_contribution << " " << MUC->csi->type_correction << endl;
  }
  else {
    MUC->ysi = new ppeeexex04_summary_generic();
    MUC->get_summary();

    cout << "END RESULT/DISTRIBUTION" << endl;
  }
  MUC->walltime_end();
  return 0;
}
