#include "header.hpp"

#include "ppeexmxnm04.phasespace.set.hpp"

ppeexmxnm04_phasespace_set::~ppeexmxnm04_phasespace_set(){
  static Logger logger("ppeexmxnm04_phasespace_set::~ppeexmxnm04_phasespace_set");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;


  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

void ppeexmxnm04_phasespace_set::optimize_minv_born(){
  static Logger logger("ppeexmxnm04_phasespace_set::optimize_minv_born");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

#include "specify.optimize.phasespace.minv.born.cxx"

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

int ppeexmxnm04_phasespace_set::determination_MCchannels_born(int x_a){
  static Logger logger("ppeexmxnm04_phasespace_set::determination_MCchannels_born");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  int n_channel = 0;
  if (csi->phasespace_order_alpha_s[x_a] == 0 && csi->phasespace_order_alpha_e[x_a] == 4 && csi->phasespace_order_interference[x_a] == 0){
    if      (csi->no_process_parton[x_a] == 0){n_channel = 10;}
    else if (csi->no_process_parton[x_a] == 1){n_channel = 10;}
  }
  return n_channel;

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

void ppeexmxnm04_phasespace_set::ac_tau_psp_born(int x_a, vector<int> & tau_MC_map){
  static Logger logger("ppeexmxnm04_phasespace_set::ac_tau_psp_born");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (csi->phasespace_order_alpha_s[x_a] == 0 && csi->phasespace_order_alpha_e[x_a] == 4 && csi->phasespace_order_interference[x_a] == 0){
    if      (csi->no_process_parton[x_a] == 0){}
    else if (csi->no_process_parton[x_a] == 1){tau_MC_map = vector<int> {  0, -24};}
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void ppeexmxnm04_phasespace_set::optimize_minv_real(){
  static Logger logger("ppeexmxnm04_phasespace_set::optimize_minv_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

#include "specify.optimize.phasespace.minv.real.cxx"

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

int ppeexmxnm04_phasespace_set::determination_MCchannels_real(int x_a){
  static Logger logger("ppeexmxnm04_phasespace_set::determination_MCchannels_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  int n_channel = 0;
  if (csi->phasespace_order_alpha_s[x_a] == 1 && csi->phasespace_order_alpha_e[x_a] == 4 && csi->phasespace_order_interference[x_a] == 0){
    if      (csi->no_process_parton[x_a] == 0){n_channel = 38;}
    else if (csi->no_process_parton[x_a] == 1){n_channel = 24;}
    else if (csi->no_process_parton[x_a] == 2){n_channel = 24;}
    else if (csi->no_process_parton[x_a] == 3){n_channel = 24;}
  }
  else if (csi->phasespace_order_alpha_s[x_a] == 0 && csi->phasespace_order_alpha_e[x_a] == 5 && csi->phasespace_order_interference[x_a] == 0){
    if      (csi->no_process_parton[x_a] == 0){n_channel = 128;}
    else if (csi->no_process_parton[x_a] == 4){n_channel = 69;}
    else if (csi->no_process_parton[x_a] == 5){n_channel = 69;}
    else if (csi->no_process_parton[x_a] == 6){n_channel = 69;}
  }
  return n_channel;

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

void ppeexmxnm04_phasespace_set::ac_tau_psp_real(int x_a, vector<int> & tau_MC_map){
  static Logger logger("ppeexmxnm04_phasespace_set::ac_tau_psp_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (csi->phasespace_order_alpha_s[x_a] == 1 && csi->phasespace_order_alpha_e[x_a] == 4 && csi->phasespace_order_interference[x_a] == 0){
    if      (csi->no_process_parton[x_a] == 0){}
    else if (csi->no_process_parton[x_a] == 1){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 2){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 3){tau_MC_map = vector<int> {  0};}
  }
  else if (csi->phasespace_order_alpha_s[x_a] == 0 && csi->phasespace_order_alpha_e[x_a] == 5 && csi->phasespace_order_interference[x_a] == 0){
    if      (csi->no_process_parton[x_a] == 0){}
    else if (csi->no_process_parton[x_a] == 4){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 5){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 6){tau_MC_map = vector<int> {  0, -24};}
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void ppeexmxnm04_phasespace_set::optimize_minv_doublereal(){
  static Logger logger("ppeexmxnm04_phasespace_set::optimize_minv_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

#include "specify.optimize.phasespace.minv.doublereal.cxx"

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

int ppeexmxnm04_phasespace_set::determination_MCchannels_doublereal(int x_a){
  static Logger logger("ppeexmxnm04_phasespace_set::determination_MCchannels_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  int n_channel = 0;
  if (csi->phasespace_order_alpha_s[x_a] == 2 && csi->phasespace_order_alpha_e[x_a] == 4 && csi->phasespace_order_interference[x_a] == 0){
    if      (csi->no_process_parton[x_a] ==  0){n_channel = 262;}
    else if (csi->no_process_parton[x_a] ==  1){n_channel = 108;}
    else if (csi->no_process_parton[x_a] ==  2){n_channel = 108;}
    else if (csi->no_process_parton[x_a] ==  3){n_channel = 108;}
    else if (csi->no_process_parton[x_a] ==  5){n_channel = 64;}
    else if (csi->no_process_parton[x_a] ==  6){n_channel = 32;}
    else if (csi->no_process_parton[x_a] ==  7){n_channel = 64;}
    else if (csi->no_process_parton[x_a] ==  8){n_channel = 32;}
    else if (csi->no_process_parton[x_a] ==  9){n_channel = 32;}
    else if (csi->no_process_parton[x_a] == 10){n_channel = 64;}
    else if (csi->no_process_parton[x_a] == 11){n_channel = 32;}
    else if (csi->no_process_parton[x_a] == 12){n_channel = 108;}
    else if (csi->no_process_parton[x_a] == 13){n_channel = 64;}
    else if (csi->no_process_parton[x_a] == 14){n_channel = 64;}
    else if (csi->no_process_parton[x_a] == 15){n_channel = 32;}
    else if (csi->no_process_parton[x_a] == 16){n_channel = 32;}
    else if (csi->no_process_parton[x_a] == 17){n_channel = 64;}
    else if (csi->no_process_parton[x_a] == 18){n_channel = 32;}
    else if (csi->no_process_parton[x_a] == 19){n_channel = 32;}
    else if (csi->no_process_parton[x_a] == 20){n_channel = 32;}
    else if (csi->no_process_parton[x_a] == 21){n_channel = 32;}
    else if (csi->no_process_parton[x_a] == 23){n_channel = 64;}
    else if (csi->no_process_parton[x_a] == 24){n_channel = 64;}
    else if (csi->no_process_parton[x_a] == 25){n_channel = 32;}
    else if (csi->no_process_parton[x_a] == 26){n_channel = 32;}
  }
  return n_channel;

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

void ppeexmxnm04_phasespace_set::ac_tau_psp_doublereal(int x_a, vector<int> & tau_MC_map){
  static Logger logger("ppeexmxnm04_phasespace_set::ac_tau_psp_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (csi->phasespace_order_alpha_s[x_a] == 2 && csi->phasespace_order_alpha_e[x_a] == 4 && csi->phasespace_order_interference[x_a] == 0){
    if      (csi->no_process_parton[x_a] == 0){}
    else if (csi->no_process_parton[x_a] ==  1){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] ==  2){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] ==  3){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] ==  5){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] ==  6){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] ==  7){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] ==  8){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] ==  9){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 10){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 11){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 12){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 13){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 14){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 15){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 16){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 17){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 18){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 19){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 20){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 21){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 23){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 24){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 25){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 26){tau_MC_map = vector<int> {  0};}
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

