#include "header.hpp"

#include "ppenexa03.phasespace.set.hpp"

ppenexa03_phasespace_set::~ppenexa03_phasespace_set(){
  static Logger logger("ppenexa03_phasespace_set::~ppenexa03_phasespace_set");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;


  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

void ppenexa03_phasespace_set::optimize_minv_born(){
  static Logger logger("ppenexa03_phasespace_set::optimize_minv_born");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

#include "specify.optimize.phasespace.minv.born.cxx"

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

int ppenexa03_phasespace_set::determination_MCchannels_born(int x_a){
  static Logger logger("ppenexa03_phasespace_set::determination_MCchannels_born");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  int n_channel = 0;
  if (csi->phasespace_order_alpha_s[x_a] == 0 && csi->phasespace_order_alpha_e[x_a] == 3 && csi->phasespace_order_interference[x_a] == 0){
    if      (csi->no_process_parton[x_a] == 0){n_channel = 4;}
    else if (csi->no_process_parton[x_a] == 1){n_channel = 4;}
  }
  return n_channel;

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

void ppenexa03_phasespace_set::ac_tau_psp_born(int x_a, vector<int> & tau_MC_map){
  static Logger logger("ppenexa03_phasespace_set::ac_tau_psp_born");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (csi->phasespace_order_alpha_s[x_a] == 0 && csi->phasespace_order_alpha_e[x_a] == 3 && csi->phasespace_order_interference[x_a] == 0){
    if      (csi->no_process_parton[x_a] == 0){}
    else if (csi->no_process_parton[x_a] == 1){tau_MC_map = vector<int> {  0, -24};}
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void ppenexa03_phasespace_set::optimize_minv_real(){
  static Logger logger("ppenexa03_phasespace_set::optimize_minv_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

#include "specify.optimize.phasespace.minv.real.cxx"

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

int ppenexa03_phasespace_set::determination_MCchannels_real(int x_a){
  static Logger logger("ppenexa03_phasespace_set::determination_MCchannels_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  int n_channel = 0;
  if (csi->phasespace_order_alpha_s[x_a] == 1 && csi->phasespace_order_alpha_e[x_a] == 3 && csi->phasespace_order_interference[x_a] == 0){
    if      (csi->no_process_parton[x_a] == 0){n_channel = 16;}
    else if (csi->no_process_parton[x_a] == 1){n_channel = 10;}
    else if (csi->no_process_parton[x_a] == 2){n_channel = 10;}
    else if (csi->no_process_parton[x_a] == 3){n_channel = 10;}
  }
  else if (csi->phasespace_order_alpha_s[x_a] == 0 && csi->phasespace_order_alpha_e[x_a] == 4 && csi->phasespace_order_interference[x_a] == 0){
    if      (csi->no_process_parton[x_a] == 0){n_channel = 36;}
    else if (csi->no_process_parton[x_a] == 4){n_channel = 20;}
    else if (csi->no_process_parton[x_a] == 5){n_channel = 20;}
    else if (csi->no_process_parton[x_a] == 6){n_channel = 20;}
  }
  return n_channel;

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

void ppenexa03_phasespace_set::ac_tau_psp_real(int x_a, vector<int> & tau_MC_map){
  static Logger logger("ppenexa03_phasespace_set::ac_tau_psp_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (csi->phasespace_order_alpha_s[x_a] == 1 && csi->phasespace_order_alpha_e[x_a] == 3 && csi->phasespace_order_interference[x_a] == 0){
    if      (csi->no_process_parton[x_a] == 0){}
    else if (csi->no_process_parton[x_a] == 1){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 2){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 3){tau_MC_map = vector<int> {  0};}
  }
  else if (csi->phasespace_order_alpha_s[x_a] == 0 && csi->phasespace_order_alpha_e[x_a] == 4 && csi->phasespace_order_interference[x_a] == 0){
    if      (csi->no_process_parton[x_a] == 0){}
    else if (csi->no_process_parton[x_a] == 4){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 5){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 6){tau_MC_map = vector<int> {  0, -24};}
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void ppenexa03_phasespace_set::optimize_minv_doublereal(){
  static Logger logger("ppenexa03_phasespace_set::optimize_minv_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

#include "specify.optimize.phasespace.minv.doublereal.cxx"

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

int ppenexa03_phasespace_set::determination_MCchannels_doublereal(int x_a){
  static Logger logger("ppenexa03_phasespace_set::determination_MCchannels_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  int n_channel = 0;
  if (csi->phasespace_order_alpha_s[x_a] == 2 && csi->phasespace_order_alpha_e[x_a] == 3 && csi->phasespace_order_interference[x_a] == 0){
    if      (csi->no_process_parton[x_a] ==  0){n_channel = 116;}
    else if (csi->no_process_parton[x_a] ==  1){n_channel = 46;}
    else if (csi->no_process_parton[x_a] ==  2){n_channel = 46;}
    else if (csi->no_process_parton[x_a] ==  3){n_channel = 46;}
    else if (csi->no_process_parton[x_a] ==  5){n_channel = 28;}
    else if (csi->no_process_parton[x_a] ==  6){n_channel = 28;}
    else if (csi->no_process_parton[x_a] ==  7){n_channel = 14;}
    else if (csi->no_process_parton[x_a] ==  8){n_channel = 14;}
    else if (csi->no_process_parton[x_a] ==  9){n_channel = 28;}
    else if (csi->no_process_parton[x_a] == 10){n_channel = 14;}
    else if (csi->no_process_parton[x_a] == 11){n_channel = 46;}
    else if (csi->no_process_parton[x_a] == 12){n_channel = 28;}
    else if (csi->no_process_parton[x_a] == 13){n_channel = 28;}
    else if (csi->no_process_parton[x_a] == 14){n_channel = 14;}
    else if (csi->no_process_parton[x_a] == 15){n_channel = 14;}
    else if (csi->no_process_parton[x_a] == 16){n_channel = 14;}
    else if (csi->no_process_parton[x_a] == 17){n_channel = 14;}
    else if (csi->no_process_parton[x_a] == 18){n_channel = 14;}
    else if (csi->no_process_parton[x_a] == 20){n_channel = 28;}
    else if (csi->no_process_parton[x_a] == 21){n_channel = 14;}
    else if (csi->no_process_parton[x_a] == 22){n_channel = 14;}
    else if (csi->no_process_parton[x_a] == 23){n_channel = 28;}
    else if (csi->no_process_parton[x_a] == 24){n_channel = 14;}
    else if (csi->no_process_parton[x_a] == 25){n_channel = 28;}
    else if (csi->no_process_parton[x_a] == 26){n_channel = 14;}
  }
  return n_channel;

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

void ppenexa03_phasespace_set::ac_tau_psp_doublereal(int x_a, vector<int> & tau_MC_map){
  static Logger logger("ppenexa03_phasespace_set::ac_tau_psp_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (csi->phasespace_order_alpha_s[x_a] == 2 && csi->phasespace_order_alpha_e[x_a] == 3 && csi->phasespace_order_interference[x_a] == 0){
    if      (csi->no_process_parton[x_a] == 0){}
    else if (csi->no_process_parton[x_a] ==  1){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] ==  2){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] ==  3){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] ==  5){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] ==  6){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] ==  7){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] ==  8){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] ==  9){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 10){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 11){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 12){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 13){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 14){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 15){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 16){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 17){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 18){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 20){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 21){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 22){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 23){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 24){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 25){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 26){tau_MC_map = vector<int> {  0};}
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

