#include "header.hpp"

#include "ppqq20.amplitude.set.hpp"

#include "ppttx20.contribution.set.hpp"
#include "ppttx20.event.set.hpp"
#include "ppttx20.phasespace.set.hpp"
#include "ppttx20.observable.set.hpp"
#include "ppttx20.summary.hpp"

int main(int argc, char *argv[]){
  cout << "BEGIN" << endl;

  munich * MUC;
  MUC = new munich(argc, argv, "pp-tt~+X", "ppttx20");

  MUC->csi = new ppttx20_contribution_set();
  MUC->esi = new ppttx20_event_set();
  MUC->psi = new ppttx20_phasespace_set();
  MUC->osi = new ppttx20_observable_set();

  MUC->initialization();

  if (MUC->subprocess != ""){
    ppqq20_amplitude_initialization(MUC);

    if (MUC->csi->type_contribution == "RT" || MUC->csi->type_contribution == "RRA"){
      MUC->psi->fake_psi = new ppttx20_phasespace_set();
      MUC->psi->fake_psi->csi = new ppttx20_contribution_set();
    }

    MUC->run_initialization();
    MUC->run_integration();

    cout << "END " << MUC->csi->type_contribution << " " << MUC->csi->type_correction << endl;
  }
  else {
    MUC->ysi = new ppttx20_summary_generic();
    MUC->get_summary();

    cout << "END RESULT/DISTRIBUTION" << endl;
  }
  MUC->walltime_end();
  return 0;
}
