#include "header.hpp"

#include "ppttx20.phasespace.set.hpp"

ppttx20_phasespace_set::~ppttx20_phasespace_set(){
  static Logger logger("ppttx20_phasespace_set::~ppttx20_phasespace_set");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;


  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

void ppttx20_phasespace_set::optimize_minv_born(){
  static Logger logger("ppttx20_phasespace_set::optimize_minv_born");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

#include "specify.optimize.phasespace.minv.born.cxx"

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

int ppttx20_phasespace_set::determination_MCchannels_born(int x_a){
  static Logger logger("ppttx20_phasespace_set::determination_MCchannels_born");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  int n_channel = 0;
  if (csi->phasespace_order_alpha_s[x_a] == 2 && csi->phasespace_order_alpha_e[x_a] == 0 && csi->phasespace_order_interference[x_a] == 0){
    if      (csi->no_process_parton[x_a] == 0){n_channel = 3;}
    else if (csi->no_process_parton[x_a] == 1){n_channel = 3;}
    else if (csi->no_process_parton[x_a] == 2){n_channel = 1;}
    else if (csi->no_process_parton[x_a] == 3){n_channel = 1;}
    else if (csi->no_process_parton[x_a] == 4){n_channel = 1;}
  }
  return n_channel;

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

void ppttx20_phasespace_set::ac_tau_psp_born(int x_a, vector<int> & tau_MC_map){
  static Logger logger("ppttx20_phasespace_set::ac_tau_psp_born");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (csi->phasespace_order_alpha_s[x_a] == 2 && csi->phasespace_order_alpha_e[x_a] == 0 && csi->phasespace_order_interference[x_a] == 0){
    if      (csi->no_process_parton[x_a] == 0){}
    else if (csi->no_process_parton[x_a] == 1){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 2){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 3){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 4){tau_MC_map = vector<int> {  0};}
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void ppttx20_phasespace_set::optimize_minv_real(){
  static Logger logger("ppttx20_phasespace_set::optimize_minv_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

#include "specify.optimize.phasespace.minv.real.cxx"

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

int ppttx20_phasespace_set::determination_MCchannels_real(int x_a){
  static Logger logger("ppttx20_phasespace_set::determination_MCchannels_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  int n_channel = 0;
  if (csi->phasespace_order_alpha_s[x_a] == 3 && csi->phasespace_order_alpha_e[x_a] == 0 && csi->phasespace_order_interference[x_a] == 0){
    if      (csi->no_process_parton[x_a] ==  0){n_channel = 18;}
    else if (csi->no_process_parton[x_a] ==  1){n_channel = 15;}
    else if (csi->no_process_parton[x_a] ==  2){n_channel = 5;}
    else if (csi->no_process_parton[x_a] ==  3){n_channel = 5;}
    else if (csi->no_process_parton[x_a] ==  4){n_channel = 5;}
    else if (csi->no_process_parton[x_a] ==  5){n_channel = 5;}
    else if (csi->no_process_parton[x_a] ==  6){n_channel = 5;}
    else if (csi->no_process_parton[x_a] ==  7){n_channel = 5;}
    else if (csi->no_process_parton[x_a] ==  8){n_channel = 5;}
    else if (csi->no_process_parton[x_a] ==  9){n_channel = 5;}
    else if (csi->no_process_parton[x_a] == 10){n_channel = 5;}
  }
  return n_channel;

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

void ppttx20_phasespace_set::ac_tau_psp_real(int x_a, vector<int> & tau_MC_map){
  static Logger logger("ppttx20_phasespace_set::ac_tau_psp_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (csi->phasespace_order_alpha_s[x_a] == 3 && csi->phasespace_order_alpha_e[x_a] == 0 && csi->phasespace_order_interference[x_a] == 0){
    if      (csi->no_process_parton[x_a] == 0){}
    else if (csi->no_process_parton[x_a] ==  1){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] ==  2){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] ==  3){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] ==  4){tau_MC_map = vector<int> {  0,  -5};}
    else if (csi->no_process_parton[x_a] ==  5){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] ==  6){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] ==  7){tau_MC_map = vector<int> {  0,  -5};}
    else if (csi->no_process_parton[x_a] ==  8){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] ==  9){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 10){tau_MC_map = vector<int> {  0};}
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void ppttx20_phasespace_set::optimize_minv_doublereal(){
  static Logger logger("ppttx20_phasespace_set::optimize_minv_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

#include "specify.optimize.phasespace.minv.doublereal.cxx"

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

int ppttx20_phasespace_set::determination_MCchannels_doublereal(int x_a){
  static Logger logger("ppttx20_phasespace_set::determination_MCchannels_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  int n_channel = 0;
  if (csi->phasespace_order_alpha_s[x_a] == 4 && csi->phasespace_order_alpha_e[x_a] == 0 && csi->phasespace_order_interference[x_a] == 0){
    if      (csi->no_process_parton[x_a] ==  0){n_channel = 160;}
    else if (csi->no_process_parton[x_a] ==  1){n_channel = 105;}
    else if (csi->no_process_parton[x_a] ==  2){n_channel = 35;}
    else if (csi->no_process_parton[x_a] ==  3){n_channel = 35;}
    else if (csi->no_process_parton[x_a] ==  4){n_channel = 35;}
    else if (csi->no_process_parton[x_a] ==  5){n_channel = 35;}
    else if (csi->no_process_parton[x_a] ==  6){n_channel = 35;}
    else if (csi->no_process_parton[x_a] ==  7){n_channel = 35;}
    else if (csi->no_process_parton[x_a] ==  8){n_channel = 35;}
    else if (csi->no_process_parton[x_a] ==  9){n_channel = 35;}
    else if (csi->no_process_parton[x_a] == 10){n_channel = 35;}
    else if (csi->no_process_parton[x_a] == 11){n_channel = 14;}
    else if (csi->no_process_parton[x_a] == 12){n_channel = 7;}
    else if (csi->no_process_parton[x_a] == 13){n_channel = 7;}
    else if (csi->no_process_parton[x_a] == 14){n_channel = 7;}
    else if (csi->no_process_parton[x_a] == 16){n_channel = 7;}
    else if (csi->no_process_parton[x_a] == 17){n_channel = 35;}
    else if (csi->no_process_parton[x_a] == 18){n_channel = 14;}
    else if (csi->no_process_parton[x_a] == 19){n_channel = 7;}
    else if (csi->no_process_parton[x_a] == 20){n_channel = 7;}
    else if (csi->no_process_parton[x_a] == 21){n_channel = 7;}
    else if (csi->no_process_parton[x_a] == 22){n_channel = 7;}
    else if (csi->no_process_parton[x_a] == 23){n_channel = 7;}
    else if (csi->no_process_parton[x_a] == 25){n_channel = 7;}
    else if (csi->no_process_parton[x_a] == 27){n_channel = 7;}
    else if (csi->no_process_parton[x_a] == 28){n_channel = 7;}
    else if (csi->no_process_parton[x_a] == 29){n_channel = 14;}
    else if (csi->no_process_parton[x_a] == 30){n_channel = 7;}
    else if (csi->no_process_parton[x_a] == 31){n_channel = 7;}
    else if (csi->no_process_parton[x_a] == 32){n_channel = 7;}
    else if (csi->no_process_parton[x_a] == 34){n_channel = 35;}
    else if (csi->no_process_parton[x_a] == 35){n_channel = 7;}
    else if (csi->no_process_parton[x_a] == 36){n_channel = 14;}
    else if (csi->no_process_parton[x_a] == 37){n_channel = 7;}
    else if (csi->no_process_parton[x_a] == 38){n_channel = 7;}
    else if (csi->no_process_parton[x_a] == 39){n_channel = 7;}
    else if (csi->no_process_parton[x_a] == 40){n_channel = 7;}
    else if (csi->no_process_parton[x_a] == 42){n_channel = 7;}
    else if (csi->no_process_parton[x_a] == 43){n_channel = 7;}
    else if (csi->no_process_parton[x_a] == 44){n_channel = 14;}
    else if (csi->no_process_parton[x_a] == 45){n_channel = 7;}
    else if (csi->no_process_parton[x_a] == 46){n_channel = 7;}
    else if (csi->no_process_parton[x_a] == 47){n_channel = 35;}
    else if (csi->no_process_parton[x_a] == 48){n_channel = 7;}
    else if (csi->no_process_parton[x_a] == 49){n_channel = 7;}
    else if (csi->no_process_parton[x_a] == 50){n_channel = 14;}
    else if (csi->no_process_parton[x_a] == 51){n_channel = 14;}
    else if (csi->no_process_parton[x_a] == 52){n_channel = 7;}
    else if (csi->no_process_parton[x_a] == 53){n_channel = 7;}
    else if (csi->no_process_parton[x_a] == 54){n_channel = 7;}
    else if (csi->no_process_parton[x_a] == 56){n_channel = 7;}
    else if (csi->no_process_parton[x_a] == 57){n_channel = 14;}
    else if (csi->no_process_parton[x_a] == 58){n_channel = 7;}
    else if (csi->no_process_parton[x_a] == 59){n_channel = 7;}
    else if (csi->no_process_parton[x_a] == 60){n_channel = 14;}
  }
  return n_channel;

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

void ppttx20_phasespace_set::ac_tau_psp_doublereal(int x_a, vector<int> & tau_MC_map){
  static Logger logger("ppttx20_phasespace_set::ac_tau_psp_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (csi->phasespace_order_alpha_s[x_a] == 4 && csi->phasespace_order_alpha_e[x_a] == 0 && csi->phasespace_order_interference[x_a] == 0){
    if      (csi->no_process_parton[x_a] == 0){}
    else if (csi->no_process_parton[x_a] ==  1){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] ==  2){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] ==  3){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] ==  4){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] ==  5){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] ==  6){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] ==  7){tau_MC_map = vector<int> {  0,  -5};}
    else if (csi->no_process_parton[x_a] ==  8){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] ==  9){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 10){tau_MC_map = vector<int> {  0,  -5};}
    else if (csi->no_process_parton[x_a] == 11){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 12){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 13){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 14){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 16){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 17){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 18){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 19){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 20){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 21){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 22){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 23){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 25){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 27){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 28){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 29){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 30){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 31){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 32){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 34){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 35){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 36){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 37){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 38){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 39){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 40){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 42){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 43){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 44){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 45){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 46){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 47){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 48){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 49){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 50){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 51){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 52){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 53){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 54){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 56){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 57){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 58){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 59){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 60){tau_MC_map = vector<int> {  0};}
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

