#include "header.hpp"

#include "ppttx20.summary.hpp"

void ppttx20_summary_generic::initialization_summary_order(size_t n_order){
  Logger logger("ppttx20_summary_generic::initialization_summary_order");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  yorder.resize(n_order);
  for (size_t i_o = 0; i_o < n_order; i_o++){yorder[i_o] = new ppttx20_summary_order();}

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

void ppttx20_summary_generic::initialization_summary_list(size_t n_list){
  Logger logger("ppttx20_summary_generic::initialization_summary_list");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  xlist.resize(n_list);
  for (size_t i_l = 0; i_l < n_list; i_l++){xlist[i_l] = new ppttx20_summary_list();}

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

void ppttx20_summary_list::initialization_summary_contribution(size_t n_contribution){
  Logger logger("ppttx20_summary_list::initialization_summary_contribution");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  xcontribution.resize(n_contribution);
  for (size_t i_l = 0; i_l < n_contribution; i_l++){xcontribution[i_l] = new ppttx20_summary_contribution();}

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

void ppttx20_summary_contribution::list_subprocess_born(){
  Logger logger("ppttx20_summary_contribution::list_subprocess_born");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (in_contribution_order_alpha_s == 2 && in_contribution_order_alpha_e == 0 && interference == 0){
    subprocess.resize(5);
    subprocess[1] = "gg_tt~";
    subprocess[2] = "dd~_tt~";
    subprocess[3] = "uu~_tt~";
    subprocess[4] = "bb~_tt~";
    subgroup_no_member[0] = vector<int> {1, 2, 3, 4};
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

void ppttx20_summary_contribution::list_subprocess_C_QCD(){
  Logger logger("ppttx20_summary_contribution::list_subprocess_C_QCD");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (in_contribution_order_alpha_s == 3 && in_contribution_order_alpha_e == 0 && interference == 0){
    subprocess.resize(5);
    subprocess[1] = "gg_tt~";
    subprocess[2] = "dd~_tt~";
    subprocess[3] = "uu~_tt~";
    subprocess[4] = "bb~_tt~";
    subgroup_no_member[0] = vector<int> {1, 2, 3, 4};
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

void ppttx20_summary_contribution::list_subprocess_V_QCD(){
  Logger logger("ppttx20_summary_contribution::list_subprocess_V_QCD");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (in_contribution_order_alpha_s == 3 && in_contribution_order_alpha_e == 0 && interference == 0){
    subprocess.resize(5);
    subprocess[1] = "gg_tt~";
    subprocess[2] = "dd~_tt~";
    subprocess[3] = "uu~_tt~";
    subprocess[4] = "bb~_tt~";
    subgroup_no_member[0] = vector<int> {1, 2, 3, 4};
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

void ppttx20_summary_contribution::list_subprocess_C2_QCD(){
  Logger logger("ppttx20_summary_contribution::list_subprocess_C2_QCD");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (in_contribution_order_alpha_s == 4 && in_contribution_order_alpha_e == 0 && interference == 0){
    subprocess.resize(5);
    subprocess[1] = "gg_tt~";
    subprocess[2] = "dd~_tt~";
    subprocess[3] = "uu~_tt~";
    subprocess[4] = "bb~_tt~";
    subgroup_no_member[0] = vector<int> {1, 2, 3, 4};
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

void ppttx20_summary_contribution::list_subprocess_V2_QCD(){
  Logger logger("ppttx20_summary_contribution::list_subprocess_V2_QCD");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (in_contribution_order_alpha_s == 4 && in_contribution_order_alpha_e == 0 && interference == 0){
    subprocess.resize(5);
    subprocess[1] = "gg_tt~";
    subprocess[2] = "dd~_tt~";
    subprocess[3] = "uu~_tt~";
    subprocess[4] = "bb~_tt~";
    subgroup_no_member[0] = vector<int> {1, 2, 3, 4};
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

void ppttx20_summary_contribution::list_subprocess_R_QCD(){
  Logger logger("ppttx20_summary_contribution::list_subprocess_R_QCD");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (in_contribution_order_alpha_s == 3 && in_contribution_order_alpha_e == 0 && interference == 0){
    subprocess.resize(11);
    subprocess[1] = "gg_tt~g";
    subprocess[2] = "gd_tt~d";
    subprocess[3] = "gu_tt~u";
    subprocess[4] = "gb_tt~b";
    subprocess[5] = "gd~_tt~d~";
    subprocess[6] = "gu~_tt~u~";
    subprocess[7] = "gb~_tt~b~";
    subprocess[8] = "dd~_tt~g";
    subprocess[9] = "uu~_tt~g";
    subprocess[10] = "bb~_tt~g";
    subgroup_no_member[0] = vector<int> {1, 2, 3, 4, 5, 6, 7, 8, 9, 10};
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

void ppttx20_summary_contribution::list_subprocess_RC_QCD(){
  Logger logger("ppttx20_summary_contribution::list_subprocess_RC_QCD");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (in_contribution_order_alpha_s == 4 && in_contribution_order_alpha_e == 0 && interference == 0){
    subprocess.resize(11);
    subprocess[1] = "gg_tt~g";
    subprocess[2] = "gd_tt~d";
    subprocess[3] = "gu_tt~u";
    subprocess[4] = "gb_tt~b";
    subprocess[5] = "gd~_tt~d~";
    subprocess[6] = "gu~_tt~u~";
    subprocess[7] = "gb~_tt~b~";
    subprocess[8] = "dd~_tt~g";
    subprocess[9] = "uu~_tt~g";
    subprocess[10] = "bb~_tt~g";
    subgroup_no_member[0] = vector<int> {1, 2, 3, 4, 5, 6, 7, 8, 9, 10};
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

void ppttx20_summary_contribution::list_subprocess_RV_QCD(){
  Logger logger("ppttx20_summary_contribution::list_subprocess_RV_QCD");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (in_contribution_order_alpha_s == 4 && in_contribution_order_alpha_e == 0 && interference == 0){
    subprocess.resize(11);
    subprocess[1] = "gg_tt~g";
    subprocess[2] = "gd_tt~d";
    subprocess[3] = "gu_tt~u";
    subprocess[4] = "gb_tt~b";
    subprocess[5] = "gd~_tt~d~";
    subprocess[6] = "gu~_tt~u~";
    subprocess[7] = "gb~_tt~b~";
    subprocess[8] = "dd~_tt~g";
    subprocess[9] = "uu~_tt~g";
    subprocess[10] = "bb~_tt~g";
    subgroup_no_member[0] = vector<int> {1, 2, 3, 4, 5, 6, 7, 8, 9, 10};
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

void ppttx20_summary_contribution::list_subprocess_RR_QCD(){
  Logger logger("ppttx20_summary_contribution::list_subprocess_RR_QCD");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (in_contribution_order_alpha_s == 4 && in_contribution_order_alpha_e == 0 && interference == 0){
    subprocess.resize(55);
    subprocess[1] = "gg_tt~gg";
    subprocess[2] = "gg_tt~dd~";
    subprocess[3] = "gg_tt~uu~";
    subprocess[4] = "gg_tt~bb~";
    subprocess[5] = "gd_tt~gd";
    subprocess[6] = "gu_tt~gu";
    subprocess[7] = "gb_tt~gb";
    subprocess[8] = "gd~_tt~gd~";
    subprocess[9] = "gu~_tt~gu~";
    subprocess[10] = "gb~_tt~gb~";
    subprocess[11] = "dd_tt~dd";
    subprocess[12] = "du_tt~du";
    subprocess[13] = "ds_tt~ds";
    subprocess[14] = "dc_tt~dc";
    subprocess[15] = "db_tt~db";
    subprocess[16] = "dd~_tt~gg";
    subprocess[17] = "dd~_tt~dd~";
    subprocess[18] = "dd~_tt~uu~";
    subprocess[19] = "dd~_tt~ss~";
    subprocess[20] = "dd~_tt~cc~";
    subprocess[21] = "dd~_tt~bb~";
    subprocess[22] = "du~_tt~du~";
    subprocess[23] = "ds~_tt~ds~";
    subprocess[24] = "dc~_tt~dc~";
    subprocess[25] = "db~_tt~db~";
    subprocess[26] = "uu_tt~uu";
    subprocess[27] = "uc_tt~uc";
    subprocess[28] = "ub_tt~ub";
    subprocess[29] = "ud~_tt~ud~";
    subprocess[30] = "uu~_tt~gg";
    subprocess[31] = "uu~_tt~dd~";
    subprocess[32] = "uu~_tt~uu~";
    subprocess[33] = "uu~_tt~ss~";
    subprocess[34] = "uu~_tt~cc~";
    subprocess[35] = "uu~_tt~bb~";
    subprocess[36] = "us~_tt~us~";
    subprocess[37] = "uc~_tt~uc~";
    subprocess[38] = "ub~_tt~ub~";
    subprocess[39] = "bb_tt~bb";
    subprocess[40] = "bd~_tt~bd~";
    subprocess[41] = "bu~_tt~bu~";
    subprocess[42] = "bb~_tt~gg";
    subprocess[43] = "bb~_tt~dd~";
    subprocess[44] = "bb~_tt~uu~";
    subprocess[45] = "bb~_tt~bb~";
    subprocess[46] = "d~d~_tt~d~d~";
    subprocess[47] = "d~u~_tt~d~u~";
    subprocess[48] = "d~s~_tt~d~s~";
    subprocess[49] = "d~c~_tt~d~c~";
    subprocess[50] = "d~b~_tt~d~b~";
    subprocess[51] = "u~u~_tt~u~u~";
    subprocess[52] = "u~c~_tt~u~c~";
    subprocess[53] = "u~b~_tt~u~b~";
    subprocess[54] = "b~b~_tt~b~b~";
    subgroup_no_member[0] = vector<int> {1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 52, 53, 54};
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}
