#include "header.hpp"
#ifdef OPENLOOPS

void amplitude_OpenLoops_set::calculate_ME2_CA_QCD(){
  static Logger logger("amplitude_OpenLoops_set::calculate_ME2_CA_QCD");
  logger.called();

  set_phasespacepoint();
  if (csi->contribution_order_interference == 0){
    if (!csi->class_contribution_loopinduced){
      ol_evaluate_cc(process_id, P_OpenLoops, &M2L0, M2cc, &ewcc);
    }
    else {
      ol_evaluate_cc2(process_id, P_OpenLoops, &M2L0, M2cc, &ewcc);
    }

    for (int i_a = 0; i_a < (*osi->CA_collinear).size(); i_a++){
      for (int j_a = 0; j_a < (*osi->CA_collinear)[i_a].size(); j_a++){
	if (j_a == 0){osi->CA_ME2_cf[i_a][j_a] = M2L0;}
	else {osi->CA_ME2_cf[i_a][j_a] = M2cc[(*osi->CA_collinear)[i_a][j_a].no_BLHA_entry];}
	if (Log::getLogThreshold() <= LOG_DEBUG_POINT){ logger << LOG_DEBUG_POINT << "OpenLoops:  CA_ME2[" << i_a << "][" << j_a << "] = " << osi->CA_ME2_cf[i_a][j_a] << endline_flush; }
      }
    }
  }
  else {
    if (!csi->class_contribution_loopinduced){
      ol_evaluate_tree(process_id, P_OpenLoops, &osi->VA_b_ME2);
      ol_evaluate_cc(process_id_QCD, P_OpenLoops, &M2L0, M2cc, &ewcc);
    }
    else {
      ol_evaluate_loop2(1, P_OpenLoops, M2L2, &acc);
      osi->VA_b_ME2 = M2L2[0];
      // does not seem to be implemented (L2CA based on Born interferences):
      ol_evaluate_cc2(2, P_OpenLoops, &M2L0, M2cc, &ewcc);
    }

    for (int i_a = 0; i_a < (*osi->CA_collinear).size(); i_a++){
      for (int j_a = 0; j_a < (*osi->CA_collinear)[i_a].size(); j_a++){
	if (j_a == 0){osi->CA_ME2_cf[i_a][j_a] = osi->VA_b_ME2;}
	else {osi->CA_ME2_cf[i_a][j_a] = M2cc[(*osi->CA_collinear)[i_a][j_a].no_BLHA_entry];}
	if (Log::getLogThreshold() <= LOG_DEBUG_POINT){ logger << LOG_DEBUG_POINT << "OpenLoops:  CA_ME2[" << i_a << "][" << j_a << "] = " << osi->CA_ME2_cf[i_a][j_a] << endline_flush; }
      }
    }
  }

  logger.finished();
}

#endif
