#include "header.hpp"
#ifdef OPENLOOPS

void amplitude_OpenLoops_set::calculate_ME2_RA_MIX(){
  static Logger logger("amplitude_OpenLoops_set::calculate_ME2_RA_MIX");
  logger.called();

  if (esi->cut_ps[0] > -1){
    set_phasespacepoint();
    ol_evaluate_tree(csi->dipole[0].process_id, P_OpenLoops, &osi->value_ME2term[0]);
  }
  else {osi->value_ME2term[0] = 0.;}

  if (Log::getLogThreshold() <= LOG_DEBUG_POINT){ logger << LOG_DEBUG_POINT << "OpenLoops:     R_ME2 = " << setw(23) << setprecision(15) << osi->value_ME2term[0] << endline_flush; }

  osi->calculate_dipole_MIX();
  
  logger.finished();
}

#endif
