#include "header.hpp"
#ifdef OPENLOOPS

void amplitude_OpenLoops_set::calculate_ME2_CT_QCD(){
  static Logger logger("amplitude_OpenLoops_set::calculate_ME2_CT_QCD");
  logger.called();

  if (osi->QT_finalstate_massive_coloured){ logger << LOG_WARN << "Process-specific function needs to be called, but has not been defined!" << endline_flush; exit(1); }

  set_phasespacepoint();
  if (!csi->class_contribution_loopinduced){
    ol_evaluate_tree(process_id, P_OpenLoops, &osi->ME2);
    if (osi->switch_TSV){ osi->value_ME2term[0] = osi->ME2; }
  }
  else {
    ol_setparameter_double(renscale, osi->var_mu_ren);
    ol_setparameter_double(fact_uv, one);
    ol_setparameter_double(fact_ir, one);
    ol_evaluate_loop2(process_id, P_OpenLoops, M2L2, &acc);
    osi->ME2 = M2L2[0];
    if (osi->switch_TSV){ osi->value_ME2term[0] = M2L2[0]; }
  }
  if (Log::getLogThreshold() <= LOG_DEBUG_POINT){ logger << LOG_DEBUG_POINT << "ME2 = " << osi->ME2 << endline_flush; }

  logger.finished();
}

#endif
