#include "header.hpp"

void amplitude_set::calculate_ME2_CT_QCD(){
  static Logger logger("amplitude_set::calculate_ME2_CT_QCD");
  logger.called();

  logger << LOG_FATAL << "Basic amplitude_set function must be overwritten." << endline_flush; exit(1);

  logger.finished();
}


void amplitude_set::calculate_ME2check_CT_QCD(){
  static Logger logger("amplitude_set::calculate_ME2check_CT_QCD");
  logger.called();

  if (osi->switch_output_comparison && process_id != -1){
    esi->phasespacepoint();
    if (esi->p_parton[0][0].x0() == 0.){generate_testpoint();}
    if (esi->p_parton[0][0].x0() != 0.){
      ofstream out_comparison;
      out_comparison.open(osi->filename_comparison.c_str(), ofstream::out | ofstream::app);

      esi->perform_event_selection();
      osi->set_testpoint_scale_complete();
      vector<int> cut_ps_acc_all(csi->n_ps, 0);
      swap(esi->cut_ps, cut_ps_acc_all);

      calculate_ME2_CT_QCD();
      osi->psi->set_xz_coll_pdf();
      osi->set_testpoint_g_z_coll();
      osi->set_testpoint_psp();
      osi->calculate_pdf_LHAPDF_list_CV();
      if (osi->switch_TSV){osi->calculate_pdf_LHAPDF_list_TSV();}
      osi->determine_integrand_CX_ncollinear_CT_QCD();

      out_comparison << output_amplitude_CT_QCD();
      out_comparison << osi->output_ME2_CT_QCD();

      swap(esi->cut_ps, cut_ps_acc_all);
      out_comparison << osi->output_testpoint_kinematics() << endline;
      out_comparison << osi->output_scales() << endline;
      out_comparison.close();
    }
  }
  output_parameter("testpoint");

  logger.finished();
}


#define Fcw left << setw(17)
#define FldXV setprecision(15) << setw(23) << left

string amplitude_set::output_amplitude_CT_QCD(){
  static Logger logger("amplitude_set::output_amplitude_CT_QCD");
  logger.called();

  stringstream out_comparison;
  out_comparison << "Matrix elements (µR = " << osi->scale_ren << ", " << "alpha_S(µR) = " << setprecision(15) << osi->alpha_S << ")" << endline;
  out_comparison << endline;
  out_comparison << Fcw << "ME2_born" << " = " << FldXV << osi->ME2 << endline;
  out_comparison << endline;

  if (Log::getLogThreshold() <= LOG_DEBUG_VERBOSE){ logger << LOG_DEBUG_VERBOSE << "return " << endline << out_comparison.str() << endline_flush; }
  logger.finished();
  return out_comparison.str();
}
