#include "header.hpp"

amplitude_set::amplitude_set(){
  static Logger logger("amplitude_set::amplitude_set ()");
  logger.called();

  if (Log::getLogThreshold() <= LOG_DEBUG){ logger << LOG_DEBUG << "constructor called..." << endline_flush; }

  logger.finished();
}

amplitude_set::amplitude_set(observable_set * _osi, contribution_set * _csi, model_set * _msi, event_set * _esi){
  static Logger logger("amplitude_set::amplitude_set (osi, csi, msi, esi)");
  logger.called();

  if (Log::getLogThreshold() <= LOG_DEBUG){ logger << LOG_DEBUG << "constructor called..." << endline_flush; }

  osi = _osi;
  csi = _csi;
  msi = _msi;
  esi = _esi;

  logger.finished();
}

amplitude_set::~amplitude_set(){
  static Logger logger("amplitude_set::~amplitude_set");
  logger.called();

  if (Log::getLogThreshold() <= LOG_DEBUG){ logger << LOG_DEBUG << "destructor called..." << endline_flush; }

  logger.finished();
}


void amplitude_set::set_mu_reg(){
  static Logger logger("amplitude_set::set_mu_reg");
  logger.called();

  //  if (switch_mu_reg == 0){mu_reg = osi->scale_ren;}
  if (switch_mu_reg == 0){mu_reg = osi->var_mu_ren;}
  else if (switch_mu_reg == -1){mu_reg = scale_reg;}
  else if (switch_mu_reg == 1){mu_reg = (esi->p_parton[0][1] + esi->p_parton[0][2]).m();}

  if (Log::getLogThreshold() <= LOG_DEBUG_VERBOSE){ logger << LOG_DEBUG_VERBOSE << "mu_reg = " << mu_reg << "   switch_mu_reg = " << switch_mu_reg << endline_flush; }

  logger.finished();
}

