#include "header.hpp"

void model_set::fill_name_pdg(){
  static Logger logger("model_set::fill_name_pdg");
  logger.called();

  name_pdg[1] = "d";
  name_pdg[2] = "u";
  name_pdg[3] = "s";
  name_pdg[4] = "c";
  name_pdg[5] = "b";
  name_pdg[6] = "t";

  name_pdg[-1] = "dx";
  name_pdg[-2] = "ux";
  name_pdg[-3] = "sx";
  name_pdg[-4] = "cx";
  name_pdg[-5] = "bx";
  name_pdg[-6] = "tx";

  name_pdg[11] = "e";
  name_pdg[12] = "ne";
  name_pdg[13] = "m";
  name_pdg[14] = "nm";
  name_pdg[15] = "y";
  name_pdg[16] = "ny";

  name_pdg[-11] = "ex";
  name_pdg[-12] = "nex";
  name_pdg[-13] = "mx";
  name_pdg[-14] = "nmx";
  name_pdg[-15] = "yx";
  name_pdg[-16] = "nyx";

  name_pdg[0] = "g";
  name_pdg[21] = "g";
  name_pdg[7] = "a";
  name_pdg[22] = "a";
  name_pdg[23] = "z";
  name_pdg[-24] = "wx";
  name_pdg[24] = "w";
  name_pdg[25] = "h";
  
  logger.finished();
}


void model_set::fill_charge_pdg(){
  static Logger logger("model_set::fill_charge_pdg");
  logger.called();

  charge_pdg[1] = -1. / 3.;
  charge_pdg[2] = 2. / 3.;
  charge_pdg[3] = -1. / 3.;
  charge_pdg[4] = 2. / 3.;
  charge_pdg[5] = -1. / 3.;
  charge_pdg[6] = 2. / 3.;

  charge_pdg[-1] = 1. / 3.;
  charge_pdg[-2] = -2. / 3.;
  charge_pdg[-3] = 1. / 3.;
  charge_pdg[-4] = -2. / 3.;
  charge_pdg[-5] = 1. / 3.;
  charge_pdg[-6] = -2. / 3.;

  charge_pdg[11] = -1.;
  charge_pdg[12] = 0.;
  charge_pdg[13] = -1.;
  charge_pdg[14] = 0.;
  charge_pdg[15] = -1.;
  charge_pdg[16] = 0.;

  charge_pdg[-11] = 1.;
  charge_pdg[-12] = 0.;
  charge_pdg[-13] = 1.;
  charge_pdg[-14] = 0.;
  charge_pdg[-15] = 1.;
  charge_pdg[-16] = 0.;

  charge_pdg[0] = 0.;
  charge_pdg[21] = 0.;
  charge_pdg[7] = 0.;
  charge_pdg[22] = 0.;
  charge_pdg[23] = 0.;
  charge_pdg[24] = -1.;
  charge_pdg[-24] = 1.;
  charge_pdg[25] = 0.;

  for (int i_pdg = -25; i_pdg < 26; i_pdg++){charge2_pdg[i_pdg] = pow(charge_pdg[i_pdg], 2);}
  
  logger.finished();
}


void model_set::fill_casimir_pdg(){
  static Logger logger("model_set::fill_casimir_pdg");
  logger.called();

  casimir_pdg[1] = C_F;
  casimir_pdg[2] = C_F;
  casimir_pdg[3] = C_F;
  casimir_pdg[4] = C_F;
  casimir_pdg[5] = C_F;
  casimir_pdg[6] = C_F;

  casimir_pdg[-1] = C_F;
  casimir_pdg[-2] = C_F;
  casimir_pdg[-3] = C_F;
  casimir_pdg[-4] = C_F;
  casimir_pdg[-5] = C_F;
  casimir_pdg[-6] = C_F;

  casimir_pdg[11] = 0.;
  casimir_pdg[12] = 0.;
  casimir_pdg[13] = 0.;
  casimir_pdg[14] = 0.;
  casimir_pdg[15] = 0.;
  casimir_pdg[16] = 0.;

  casimir_pdg[-11] = 0.;
  casimir_pdg[-12] = 0.;
  casimir_pdg[-13] = 0.;
  casimir_pdg[-14] = 0.;
  casimir_pdg[-15] = 0.;
  casimir_pdg[-16] = 0.;

  casimir_pdg[0] = C_A;
  casimir_pdg[21] = C_A;
  casimir_pdg[7] = 0.;
  casimir_pdg[22] = 0.;
  //  casimir_pdg[-22] = 0.; // ???
  casimir_pdg[23] = 0.;
  casimir_pdg[24] = 0.;
  casimir_pdg[-24] = 0.;
  casimir_pdg[25] = 0.;
  
  logger.finished();
}


void model_set::fill_mass_pdg(){
  static Logger logger("model_set::fill_mass_pdg");
  logger.called();

  M_pdg[1] = M_d;
  M_pdg[2] = M_u;
  M_pdg[3] = M_s;
  M_pdg[4] = M_c;
  M_pdg[5] = M_b;
  M_pdg[6] = M_t;

  M_pdg[-1] = M_d;
  M_pdg[-2] = M_u;
  M_pdg[-3] = M_s;
  M_pdg[-4] = M_c;
  M_pdg[-5] = M_b;
  M_pdg[-6] = M_t;

  M_pdg[11] = M_e;
  M_pdg[12] = M_ve;
  M_pdg[13] = M_mu;
  M_pdg[14] = M_vm;
  M_pdg[15] = M_tau;
  M_pdg[16] = M_vt;

  M_pdg[-11] = M_e;
  M_pdg[-12] = M_ve;
  M_pdg[-13] = M_mu;
  M_pdg[-14] = M_vm;
  M_pdg[-15] = M_tau;
  M_pdg[-16] = M_vt;

  M_pdg[0] = 0.;
  M_pdg[21] = 0.;
  M_pdg[7] = 0.;
  M_pdg[22] = 0.;
  M_pdg[23] = M_Z;
  M_pdg[24] = M_W;
  M_pdg[-24] = M_W;
  M_pdg[25] = M_H;


  M2_pdg[1] = M2_d;
  M2_pdg[2] = M2_u;
  M2_pdg[3] = M2_s;
  M2_pdg[4] = M2_c;
  M2_pdg[5] = M2_b;
  M2_pdg[6] = M2_t;

  M2_pdg[-1] = M2_d;
  M2_pdg[-2] = M2_u;
  M2_pdg[-3] = M2_s;
  M2_pdg[-4] = M2_c;
  M2_pdg[-5] = M2_b;
  M2_pdg[-6] = M2_t;

  M2_pdg[11] = M2_e;
  M2_pdg[12] = M2_ve;
  M2_pdg[13] = M2_mu;
  M2_pdg[14] = M2_vm;
  M2_pdg[15] = M2_tau;
  M2_pdg[16] = M2_vt;

  M2_pdg[-11] = M2_e;
  M2_pdg[-12] = M2_ve;
  M2_pdg[-13] = M2_mu;
  M2_pdg[-14] = M2_vm;
  M2_pdg[-15] = M2_tau;
  M2_pdg[-16] = M2_vt;

  M2_pdg[0] = 0.;
  M2_pdg[21] = 0.;
  M2_pdg[7] = 0.;
  M2_pdg[22] = 0.;
  M2_pdg[23] = M2_Z;
  M2_pdg[24] = M2_W;
  M2_pdg[-24] = M2_W;
  M2_pdg[25] = M2_H;


  Gamma_pdg[1] = 0.; //  Gamma_d;
  Gamma_pdg[2] = 0.; //  Gamma_u;
  Gamma_pdg[3] = 0.; //  Gamma_s;
  Gamma_pdg[4] = Gamma_c;
  Gamma_pdg[5] = Gamma_b;
  Gamma_pdg[6] = Gamma_t;

  Gamma_pdg[-1] = 0.; //  Gamma_d;
  Gamma_pdg[-2] = 0.; //  Gamma_u;
  Gamma_pdg[-3] = 0.; //  Gamma_s;
  Gamma_pdg[-4] = Gamma_c;
  Gamma_pdg[-5] = Gamma_b;
  Gamma_pdg[-6] = Gamma_t;

  Gamma_pdg[11] = 0.; //  Gamma_e;
  Gamma_pdg[12] = 0.; //  Gamma_ve;
  Gamma_pdg[13] = 0.; //  Gamma_mu;
  Gamma_pdg[14] = 0.; //  Gamma_vm;
  Gamma_pdg[15] = 0.; //  Gamma_tau;
  Gamma_pdg[16] = 0.; //  Gamma_vt;

  Gamma_pdg[-11] = 0.; //  Gamma_e;
  Gamma_pdg[-12] = 0.; //  Gamma_ve;
  Gamma_pdg[-13] = 0.; //  Gamma_mu;
  Gamma_pdg[-14] = 0.; //  Gamma_vm;
  Gamma_pdg[-15] = 0.; //  Gamma_tau;
  Gamma_pdg[-16] = 0.; //  Gamma_vt;

  Gamma_pdg[0] = 0.;
  Gamma_pdg[21] = 0.;
  Gamma_pdg[7] = 0.;
  Gamma_pdg[22] = 0.;
  Gamma_pdg[23] = Gamma_Z;
  Gamma_pdg[24] = Gamma_W;
  Gamma_pdg[-24] = Gamma_W;
  Gamma_pdg[25] = Gamma_H;


  cM_pdg[1] = 0.; //  cM_d;
  cM_pdg[2] = 0.; //  cM_u;
  cM_pdg[3] = 0.; //  cM_s;
  cM_pdg[4] = cM_c;
  cM_pdg[5] = cM_b;
  cM_pdg[6] = cM_t;

  cM_pdg[-1] = 0.; //  cM_d;
  cM_pdg[-2] = 0.; //  cM_u;
  cM_pdg[-3] = 0.; //  cM_s;
  cM_pdg[-4] = cM_c;
  cM_pdg[-5] = cM_b;
  cM_pdg[-6] = cM_t;

  cM_pdg[11] = M_e; //  cM_e;
  cM_pdg[12] = 0.; //  cM_ve;
  cM_pdg[13] = M_mu; //  cM_mu;
  cM_pdg[14] = 0.; //  cM_vm;
  cM_pdg[15] = M_tau; //  cM_tau;
  cM_pdg[16] = 0.; //  cM_vt;

  cM_pdg[-11] = M_e; //  cM_e;
  cM_pdg[-12] = 0.; //  cM_ve;
  cM_pdg[-13] = M_mu; //  cM_mu;
  cM_pdg[-14] = 0.; //  cM_vm;
  cM_pdg[-15] = M_tau; //  cM_tau;
  cM_pdg[-16] = 0.; //  cM_vt;

  cM_pdg[0] = 0.;
  cM_pdg[21] = 0.;
  cM_pdg[7] = 0.;
  cM_pdg[22] = 0.;
  //  cM_pdg[-22] = 0.; // ???
  cM_pdg[23] = cM_Z;
  cM_pdg[24] = cM_W;
  cM_pdg[-24] = cM_W;
  cM_pdg[25] = cM_H;


  cM2_pdg[1] = 0.; //  cM2_d;
  cM2_pdg[2] = 0.; //  cM2_u;
  cM2_pdg[3] = 0.; //  cM2_s;
  cM2_pdg[4] = cM2_c;
  cM2_pdg[5] = cM2_b;
  cM2_pdg[6] = cM2_t;

  cM2_pdg[-1] = 0.; //  cM2_d;
  cM2_pdg[-2] = 0.; //  cM2_u;
  cM2_pdg[-3] = 0.; //  cM2_s;
  cM2_pdg[-4] = cM2_c;
  cM2_pdg[-5] = cM2_b;
  cM2_pdg[-6] = cM2_t;

  cM2_pdg[11] = M2_e; //  cM2_e;
  cM2_pdg[12] = 0.; //  cM2_ve;
  cM2_pdg[13] = M2_mu; //  cM2_mu;
  cM2_pdg[14] = 0.; //  cM2_vm;
  cM2_pdg[15] = M2_tau; //  cM2_tau;
  cM2_pdg[16] = 0.; //  cM2_vt;

  cM2_pdg[-11] = M2_e; //  cM2_e;
  cM2_pdg[-12] = 0.; //  cM2_ve;
  cM2_pdg[-13] = M2_mu; //  cM2_mu;
  cM2_pdg[-14] = 0.; //  cM2_vm;
  cM2_pdg[-15] = M2_tau; //  cM2_tau;
  cM2_pdg[-16] = 0.; //  cM2_vt;

  cM2_pdg[0] = 0.;
  cM2_pdg[21] = 0.;
  cM2_pdg[7] = 0.;
  cM2_pdg[22] = 0.;
  cM2_pdg[23] = cM2_Z;
  cM2_pdg[24] = cM2_W;
  cM2_pdg[-24] = cM2_W;
  cM2_pdg[25] = cM2_H;

  logger.finished();
}


string model_set::output_charge_pdg(){
  static Logger logger("model_set::output_charge_pdg");
  logger.called();

  stringstream temp_ss;
  map<int, double>::iterator it;
  for (it = charge_pdg.begin(); it != charge_pdg.end(); it++){
    temp_ss << "charge_pdg[" << right << setw(3) << it->first << "] = " << left << setprecision(8) << setw(15) << it->second << endline;
  }
  
  if (Log::getLogThreshold() <= LOG_DEBUG_VERBOSE){ logger << LOG_DEBUG_VERBOSE << "return " << temp_ss.str() << endline_flush; }
  logger.finished();
  return temp_ss.str();
}


string model_set::output_casimir_pdg(){
  static Logger logger("model_set::output_casimir_pdg");
  logger.called();

  stringstream temp_ss;
  map<int, double>::iterator it;
  for (it = casimir_pdg.begin(); it != casimir_pdg.end(); it++){
    temp_ss << "casimir_pdg[" << right << setw(3) << it->first << "] = " << left << setprecision(8) << setw(15) << it->second << endline;
  }
  
  if (Log::getLogThreshold() <= LOG_DEBUG_VERBOSE){ logger << LOG_DEBUG_VERBOSE << "return " << temp_ss.str() << endline_flush; }
  logger.finished();
  return temp_ss.str();
}


string model_set::output_mass_pdg(){
  static Logger logger("model_set::output_mass_pdg");
  logger.called();

  stringstream temp_ss;
  map<int, double>::iterator it;
  for (it = M_pdg.begin(); it != M_pdg.end(); it++){
    temp_ss << "M_pdg[" << right << setw(3) << it->first << "] = " << left << setprecision(8) << setw(15) << it->second << endline;
  }
  
  if (Log::getLogThreshold() <= LOG_DEBUG_VERBOSE){ logger << LOG_DEBUG_VERBOSE << "return " << temp_ss.str() << endline_flush; }
  logger.finished();
  return temp_ss.str();
}


string model_set::output_mass_pdg_complete(){
  static Logger logger("model_set::output_mass_pdg_complete");
  logger.called();

  stringstream temp_ss;
  vector <stringstream> temp_vss(M_pdg.size());
  int counter = 0;
  logger << LOG_DEBUG << "M_pdg.size() = " << M_pdg.size() << endline_flush;
  map<int, double>::iterator it;
  for (it = M_pdg.begin(); it != M_pdg.end(); it++){
    temp_vss[counter++] << "M_pdg[" << right << setw(3) << it->first << "] = " << left << setprecision(8) << setw(15) << it->second << "   ";
  }
  counter = 0;
  for (it = Gamma_pdg.begin(); it != Gamma_pdg.end(); it++){
    temp_vss[counter++] << "Gamma_pdg[" << right << setw(3) << it->first << "] = " << left << setprecision(8) << setw(15) << it->second << "   ";
  }
  for (int i_p = 0; i_p < temp_vss.size(); i_p++){temp_ss << temp_vss[i_p].str() << endline;}
  
  if (Log::getLogThreshold() <= LOG_DEBUG_VERBOSE){ logger << LOG_DEBUG_VERBOSE << "return " << temp_ss.str() << endline_flush; }
  logger.finished();
  return temp_ss.str();
}


string model_set::output_pdg_complete(){
  static Logger logger("model_set::output_pdg_complete");
  logger.called();

  stringstream temp_ss;
  temp_ss << "PDG ID" << "   " << setw(15) << "mass" << "   " << setw(15) << "width" << "   " << setw(15) << "mass²" << "   " << setw(30) << "complex mass" << "   " << setw(30) << "complex mass²" << "   " << setw(15) << "charge" << "   " << setw(15) << "casimir" << endline;

  vector <stringstream> temp_vss(M_pdg.size());
  logger << LOG_DEBUG << "M_pdg.size() = " << M_pdg.size() << endline_flush;
  map<int, double>::iterator it;

  int counter = 0;
  for (it = M_pdg.begin(); it != M_pdg.end(); it++){
    temp_vss[counter++] << "M_pdg[" << right << setw(3) << it->first << "] = " << left << setprecision(8) << setw(15) << it->second << "   ";
  }
  counter = 0;
  for (it = Gamma_pdg.begin(); it != Gamma_pdg.end(); it++){
    temp_vss[counter++] << "Gamma_pdg[" << right << setw(3) << it->first << "] = " << left << setprecision(8) << setw(15) << it->second << "   ";
  }
  for (int i_p = 0; i_p < temp_vss.size(); i_p++){temp_ss << temp_vss[i_p].str() << endline;}
  
  if (Log::getLogThreshold() <= LOG_DEBUG_VERBOSE){ logger << LOG_DEBUG_VERBOSE << "return " << temp_ss.str() << endline_flush; }
  logger.finished();
  return temp_ss.str();
}
