#include "header.hpp"

void observable_set::output_calculate_collinear_QCD_CS(){
  static Logger logger("observable_set::output_calculate_collinear_QCD_CS");
  logger.called();

  for (int i_dt = 0; i_dt < CA_dipole_splitting.size(); i_dt++){
    for (int i_em = 0; i_em < 3; i_em++){
      //      for (int i_em = 0; i_em < CA_dipole_splitting.size(); i_em++){
      logger << LOG_DEBUG_POINT << "CA_dipole_splitting[" << i_dt << "][" << i_em << "] = " << CA_dipole_splitting[i_dt][i_em] << endline_flush;
    }
  }

  if (CA_dipole_splitting[1][0] == 1 || CA_dipole_splitting[1][1] == 1 || CA_dipole_splitting[1][2] == 1){    // q -> q (+g) splitting
    logger << LOG_DEBUG_POINT << setw(20) << "Kbar_delta[1]" << " = " << setw(23) << setprecision(15) << Kbar_delta[1] << endline_flush;
    logger << LOG_DEBUG_POINT << setw(20) << "Kt_delta[1]" << " = " << setw(23) << setprecision(15) << Kt_delta[1] << endline_flush;
    logger << LOG_DEBUG_POINT << setw(20) << "P_delta[1]" << " = " << setw(23) << setprecision(15) << P_delta[1] << endline_flush;
  }

  for (int i_p = 0; i_p < pair.size(); i_p++){logger << LOG_DEBUG_POINT << "pair[" << i_p << "] = " << "(" << pair[i_p][0] << ", " << pair[i_p][1] << ")" << endline_flush;}

  for (int i_em = 1; i_em < 3; i_em++){
    logger << LOG_DEBUG_POINT << "psi->z_coll[" << i_em << "] = " << psi->z_coll[i_em] << "   CA_dipole_splitting[0][" << i_em << "] = " << CA_dipole_splitting[0][i_em] << endline_flush;
    logger << LOG_DEBUG_POINT << "psi->z_coll[" << i_em << "] = " << psi->z_coll[i_em] << "   CA_dipole_splitting[1][" << i_em << "] = " << CA_dipole_splitting[1][i_em] << endline_flush;
    logger << LOG_DEBUG_POINT << "psi->z_coll[" << i_em << "] = " << psi->z_coll[i_em] << "   CA_dipole_splitting[2][" << i_em << "] = " << CA_dipole_splitting[2][i_em] << endline_flush;
    logger << LOG_DEBUG_POINT << "psi->z_coll[" << i_em << "] = " << psi->z_coll[i_em] << "   CA_dipole_splitting[3][" << i_em << "] = " << CA_dipole_splitting[3][i_em] << endline_flush;
    if (CA_dipole_splitting[0][i_em] == 1 ||  // g -> g (g) splitting
	CA_dipole_splitting[1][i_em] == 1){   // q -> q (g) splitting
      size_t i_type = 0;
      if (CA_dipole_splitting[0][i_em] == 1){i_type = 0;}
      else if (CA_dipole_splitting[1][i_em] == 1){i_type = 1;}
      else {logger << LOG_FATAL << "No valid splitting type !" << endline_flush; exit(1);}

      logger << LOG_DEBUG_POINT << setw(20) << "Kbar[" << i_type << "][" << i_em << "]" << " = " << setw(23) << setprecision(15) << Kbar[i_type][i_em] << endline_flush;
      logger << LOG_DEBUG_POINT << setw(20) << "Kt[" << i_type << "][" << i_em << "]" << " = " << setw(23) << setprecision(15) << Kt[i_type][i_em] << endline_flush;
      logger << LOG_DEBUG_POINT << setw(20) << "P[" << i_type << "][" << i_em << "]" << " = " << setw(23) << setprecision(15) << P[i_type][i_em] << endline_flush;
      if (CA_dipole_splitting[0][0] == 1 || CA_dipole_splitting[1][0] == 1){
	logger << LOG_DEBUG_POINT << setw(20) << "Kbar_plus[" << i_type << "][" << i_em << "]" << " = " << setw(23) << setprecision(15) << Kbar_plus[i_type][i_em] << endline_flush;
	logger << LOG_DEBUG_POINT << setw(20) << "Kt_plus[" << i_type << "][" << i_em << "]" << " = " << setw(23) << setprecision(15) << Kt_plus[i_type][i_em] << endline_flush;
	logger << LOG_DEBUG_POINT << setw(20) << "P_plus[" << i_type << "][" << i_em << "]" << " = " << setw(23) << setprecision(15) << P_plus[i_type][i_em] << endline_flush;
	logger << LOG_DEBUG_POINT << setw(20) << "intKbar_plus[" << i_type << "][" << i_em << "]" << " = " << setw(23) << setprecision(15) << intKbar_plus[i_type][i_em] << endline_flush;
	logger << LOG_DEBUG_POINT << setw(20) << "intKt_plus[" << i_type << "][" << i_em << "]" << " = " << setw(23) << setprecision(15) << intKt_plus[i_type][i_em] << endline_flush;
	logger << LOG_DEBUG_POINT << setw(20) << "intP_plus[" << i_type << "][" << i_em << "]" << " = " << setw(23) << setprecision(15) << intP_plus[i_type][i_em] << endline_flush;
      }
    }
    if (CA_dipole_splitting[2][i_em] == 1 ||  // q -> g (q) splitting
	CA_dipole_splitting[3][i_em] == 1){   // g -> q (qx) splitting
      size_t i_type = 0;
      if (CA_dipole_splitting[2][i_em] == 1){i_type = 2;}
      else if (CA_dipole_splitting[3][i_em] == 1){i_type = 3;}
      else {logger << LOG_FATAL << "No valid splitting type !" << endline_flush; exit(1);}

      logger << LOG_DEBUG_POINT << setw(20) << "Kbar[" << i_type << "][" << i_em << "]" << " = " << setw(23) << setprecision(15) << Kbar[i_type][i_em] << endline_flush;
      logger << LOG_DEBUG_POINT << setw(20) << "Kt[" << i_type << "][" << i_em << "]" << " = " << setw(23) << setprecision(15) << Kt[i_type][i_em] << endline_flush;
      logger << LOG_DEBUG_POINT << setw(20) << "P[" << i_type << "][" << i_em << "]" << " = " << setw(23) << setprecision(15) << P[i_type][i_em] << endline_flush;
    }
  }

  for (int i_p = 0; i_p < pair.size(); i_p++){
    if (switch_TSV){
      for (int v_sf = 0; v_sf < max_dyn_fact + 1; v_sf++){
	for (int v_xf = 0; v_xf < n_scale_dyn_fact[v_sf]; v_xf++){
	  //	  logger << LOG_DEBUG_POINT << "value_scale_fact         [" << v_sf << "][" << v_xf << "] = " << value_scale_fact[v_sf][v_xf] << endline_flush;
	  logger << LOG_DEBUG_POINT << "value_logscale2_fact_papi[" << v_sf << "][" << v_xf << "][" << pair[i_p][0] << "][" << pair[i_p][1] << "] = " << value_logscale2_fact_papi[v_sf][v_xf][pair[i_p][0]][pair[i_p][1]] << endline_flush;
	  logger << LOG_DEBUG_POINT << "value_central_logscale2_fact  [" << v_sf << "]    = " << value_central_logscale2_fact[v_sf] << endline_flush;
	  logger << LOG_DEBUG_POINT << "value_relative_logscale2_fact [" << v_sf << "][" << v_xf << "] = " << value_relative_logscale2_fact[v_sf][v_xf] << endline_flush;
	  logger << LOG_DEBUG_POINT << "value_logscale2_fact          [" << v_sf << "][" << v_xf << "] = " << value_central_logscale2_fact[v_sf] + value_relative_logscale2_fact[v_sf][v_xf] << endline_flush;
	  logger << LOG_DEBUG_POINT << "pa = " << esi->p_parton[0][pair[i_p][0]] << endline_flush;
	  logger << LOG_DEBUG_POINT << "pb = " << esi->p_parton[0][pair[i_p][1]] << endline_flush;
	  logger << LOG_DEBUG_POINT << "2papb = " << 2 * esi->p_parton[0][pair[i_p][0]] * esi->p_parton[0][pair[i_p][1]] << endline_flush;
	  logger << LOG_DEBUG_POINT << "log(2papb) = " << ln_papi[pair[i_p][0]][pair[i_p][1]] << endline_flush;
	  logger << LOG_DEBUG_POINT << "log(muF²/2papb) = " << value_logscale2_fact_papi[v_sf][v_xf][pair[i_p][0]][pair[i_p][1]] << endline_flush;
	}
      }
    }
  }

  for (int i_c = 0; i_c < (*CA_collinear).size(); i_c++){
    for (int j_c = 0; j_c < (*CA_collinear)[i_c].size(); j_c++){
      logger << LOG_DEBUG_POINT << "(*CA_collinear)[" << i_c << "][" << j_c << "] = " << (*CA_collinear)[i_c][j_c].name() << endline_flush;
      logger << LOG_DEBUG_POINT << "(*CA_collinear)[" << i_c << "][" << j_c << "] = " << setw(20) << (*CA_collinear)[i_c][j_c].name() << "   no_spectator[" << i_c << "][" << j_c << "] = " << no_spectator[i_c][j_c] << "   collinear_singularity[" << i_c << "][" << j_c << "] = " << collinear_singularity[i_c][j_c] << endline_flush;
      if (no_spectator[i_c][j_c] == 0){
	logger << LOG_DEBUG_POINT << "no_emitter[" << i_c << "][" << j_c << "] = " << no_emitter[i_c][j_c] << "   no_spectator[" << i_c << "][" << j_c << "] = " << no_spectator[i_c][j_c] << "   CS data_K[0][" << i_c << "][" << j_c << "] = " << data_K[0][i_c][j_c] << endline_flush;
	logger << LOG_DEBUG_POINT << "no_emitter[" << i_c << "][" << j_c << "] = " << no_emitter[i_c][j_c] << "   no_spectator[" << i_c << "][" << j_c << "] = " << no_spectator[i_c][j_c] << "   CS data_K[1][" << i_c << "][" << j_c << "] = " << data_K[1][i_c][j_c] << endline_flush;
	logger << LOG_DEBUG_POINT << "no_emitter[" << i_c << "][" << j_c << "] = " << no_emitter[i_c][j_c] << "   no_spectator[" << i_c << "][" << j_c << "] = " << no_spectator[i_c][j_c] << "   CS data_K[2][" << i_c << "][" << j_c << "] = " << data_K[2][i_c][j_c] << endline_flush;
	logger << LOG_DEBUG_POINT << "Kbar_delta[type[i_c][j_c] = " << type[i_c][j_c] << "] = " << Kbar_delta[type[i_c][j_c]] << endline_flush;
	logger << LOG_DEBUG_POINT << "intKbar_plus[type[i_c][j_c] = " << type[i_c][j_c] << "][no_emitter[i_c][j_c] = " << no_emitter[i_c][j_c] << "] = " << intKbar_plus[type[i_c][j_c]][no_emitter[i_c][j_c]] << endline_flush;
	logger << LOG_DEBUG_POINT << "CA_ME2_cf[" << i_c << "][" << j_c << "] = " << CA_ME2_cf[i_c][j_c] << endline_flush;
      }
      else if (no_spectator[i_c][j_c] < 3){
	logger << LOG_DEBUG_POINT << "no_emitter[" << i_c << "][" << j_c << "] = " << no_emitter[i_c][j_c] << "   no_spectator[" << i_c << "][" << j_c << "] = " << no_spectator[i_c][j_c] << "   CS data_K[0][" << i_c << "][" << j_c << "] = " << data_K[0][i_c][j_c] << endline_flush;
	logger << LOG_DEBUG_POINT << "Kt     [type[" << i_c << "][" << j_c << "] = " << type[i_c][j_c] << "][no_emitter[" << i_c << "][" << j_c << "] = " << no_emitter[i_c][j_c] << "] = " << Kt[type[i_c][j_c]][no_emitter[i_c][j_c]] << endline_flush;
	logger << LOG_DEBUG_POINT << "Kt_plus[type[" << i_c << "][" << j_c << "] = " << type[i_c][j_c] << "][no_emitter[" << i_c << "][" << j_c << "] = " << no_emitter[i_c][j_c] << "] = " << Kt_plus[type[i_c][j_c]][no_emitter[i_c][j_c]] << endline_flush;
	logger << LOG_DEBUG_POINT << "CA_ME2_cf[" << i_c << "][" << j_c << "] = " << CA_ME2_cf[i_c][j_c] << endline_flush;
      }
      else if (no_spectator[i_c][j_c] > 2){
	logger << LOG_DEBUG_POINT << "no_emitter[" << i_c << "][" << j_c << "] = " << no_emitter[i_c][j_c] << "   no_spectator[" << i_c << "][" << j_c << "] = " << no_spectator[i_c][j_c] << "   CS data_K[0][" << i_c << "][" << j_c << "] = " << data_K[0][i_c][j_c] << endline_flush;

	logger << LOG_DEBUG_POINT << "no_emitter[" << i_c << "][" << j_c << "] = " << no_emitter[i_c][j_c] << "   no_spectator[" << i_c << "][" << j_c << "] = " << no_spectator[i_c][j_c] << "   CS data_K[0][" << i_c << "][" << j_c << "] = " << data_K[0][i_c][j_c] << endline_flush;
	logger << LOG_DEBUG_POINT << "CS data_K[0][" << i_c << "][" << j_c << "] = " << data_K[0][i_c][j_c] << endline_flush;
	logger << LOG_DEBUG_POINT << "CS data_K[1][" << i_c << "][" << j_c << "] = " << data_K[1][i_c][j_c] << endline_flush;
	logger << LOG_DEBUG_POINT << "CS data_K[2][" << i_c << "][" << j_c << "] = " << data_K[2][i_c][j_c] << endline_flush;
      }

      if (no_spectator[i_c][j_c] != 0){
	// P terms

	if (switch_TSV){
	  for (int v_sf = 0; v_sf < value_logscale2_fact_papi.size(); v_sf++){
	    for (int v_xf = 0; v_xf < value_logscale2_fact_papi[v_sf].size(); v_xf++){
	      logger << LOG_DEBUG_POINT << "log(muF²/2papb) = " << value_logscale2_fact_papi[v_sf][v_xf][ppair[i_c][j_c][0]][ppair[i_c][j_c][1]] << endline_flush;
	      logger << LOG_DEBUG_POINT << "P_delta[type[i_c][j_c]] = " << P_delta[type[i_c][j_c]] << endline_flush;
	      logger << LOG_DEBUG_POINT << "intP_plus[type[i_c][j_c]][no_emitter[i_c][j_c]] = " << intP_plus[type[i_c][j_c]][no_emitter[i_c][j_c]] << endline_flush;
	      logger << LOG_DEBUG_POINT << "CA_ME2_cf[i_c][j_c] = " << CA_ME2_cf[i_c][j_c] << endline_flush;
	      logger << LOG_DEBUG_POINT << "P_delta * ME2_born * log(muF²/2papb) = " << value_data_P[v_sf][v_xf][2][i_c][j_c] << endline_flush;
	    }
	  }
	}
      }
    }

    logger << LOG_DEBUG_POINT << "alpha_S_2pi = " << alpha_S_2pi << endline_flush;

    for (int i_x = 0; i_x < 3; i_x++){
      double temp_sumK = accumulate(data_K[i_x][i_c].begin(), data_K[i_x][i_c].end(), 0.);
      logger << LOG_DEBUG_POINT << "i_x = " << i_x << "   temp_sumK = " << temp_sumK << "   QCD (C_F) -> " << C_F * temp_sumK << endline_flush;
      if (switch_TSV){
	for (int v_sf = 0; v_sf < max_dyn_fact + 1; v_sf++){
	  for (int v_xf = 0; v_xf < value_logscale2_fact_papi[v_sf].size(); v_xf++){
	    logger << LOG_DEBUG_POINT << "value_ME2term_fact[" << i_c << "][" << i_x << "][" << v_sf << "][" << v_xf << "] = " << value_ME2term_fact[i_c][i_x][v_sf][v_xf] << endline_flush;
	  }
	}
      }
    }
  }

  logger.finished();
}


void observable_set::output_calculate_collinear_QCD_CDST(){
  static Logger logger("observable_set::output_calculate_collinear_QCD_CDST");
  logger.called();

  for (int i_p = 0; i_p < pair.size(); i_p++){
    int pair_em = pair[i_p][0];
    int pair_sp = pair[i_p][1];
    if (m2_Q[pair_sp] > 0.){
      logger << LOG_DEBUG_POINT << "i_p = " << i_p << "   pair_em = " << pair_em << "   pair_sp = " << pair_sp << "   psi->z_coll[" << pair_em << "] = " << psi->z_coll[pair_em] << endline_flush;
      for (int i_dt = 0; i_dt < 4; i_dt++){
	if (i_dt == 0 && (CA_dipole_splitting[i_dt][1] == 1 || CA_dipole_splitting[i_dt][2] == 1)){ //  g -> g (+g) splitting
	  //	  logger << LOG_DEBUG_POINT << "g -> g (g): dipole_phasespace[0][" << pair_sp + 6 << "] = " << dipole_phasespace[0][pair_sp + 6] << "   " << m_Q[pair_sp] << endline_flush;
	}
	if (i_dt == 1 && (CA_dipole_splitting[i_dt][1] == 1 || CA_dipole_splitting[i_dt][2] == 1)){ //  q -> q (+g) splitting
	  //	  logger << LOG_DEBUG_POINT << "q -> q (g): dipole_phasespace[0][" << pair_sp + 6 << "] = " << dipole_phasespace[0][pair_sp + 6] << "   " << m_Q[pair_sp] << endline_flush;
	}
	else if (i_dt == 2 && (CA_dipole_splitting[i_dt][1] == 1 || CA_dipole_splitting[i_dt][2] == 1)){ //  q -> g (+q) splitting
	}
	else if (i_dt == 3 && (CA_dipole_splitting[i_dt][1] == 1 || CA_dipole_splitting[i_dt][2] == 1)){ //  g -> q (+qx) splitting
	}
      }
    }

    if (switch_TSV){
      for (int v_sf = 0; v_sf < max_dyn_fact + 1; v_sf++){
	//      logger << LOG_DEBUG_POINT << "n_scale_dyn_fact[" << v_sf << "] = " << n_scale_dyn_fact[v_sf] << endline_flush;
	logger << LOG_DEBUG << "value_central_logscale2_fact[" << v_sf << "] = " << value_central_logscale2_fact[v_sf] << endline_flush;
	logger << LOG_DEBUG << "value_relative_logscale2_fact[" << v_sf << "].size() = " << value_relative_logscale2_fact[v_sf].size() << endline_flush;

	for (int v_xf = 0; v_xf < n_scale_dyn_fact[v_sf]; v_xf++){
	  logger << LOG_DEBUG << "value_relative_logscale2_fact[" << v_sf << "][" << v_xf << "] = " << value_relative_logscale2_fact[v_sf][v_xf] << endline_flush;
	  logger << LOG_DEBUG << "value_absolute_logscale2_fact[" << v_sf << "][" << v_xf << "] = " << value_central_logscale2_fact[v_sf] + value_relative_logscale2_fact[v_sf][v_xf] << endline_flush;

	  logger << LOG_DEBUG << "value_logscale2_fact_papi.size() = " << value_logscale2_fact_papi.size() << endline_flush;
	  logger << LOG_DEBUG << "value_logscale2_fact_papi[" << v_sf << "].size() = " << value_logscale2_fact_papi[v_sf].size() << endline_flush;
	  logger << LOG_DEBUG << "value_logscale2_fact_papi[" << v_sf << "][" << v_xf << "].size() = " << value_logscale2_fact_papi[v_sf][v_xf].size() << endline_flush;
	  logger << LOG_DEBUG << "value_logscale2_fact_papi[" << v_sf << "][" << v_xf << "][" << pair_em << "][" << pair_sp << "] = " << value_logscale2_fact_papi[v_sf][v_xf][pair_em][pair_sp] << endline_flush;

	}
      }
    }
  }

  for (int i_dt = 0; i_dt < 4; i_dt++){
    stringstream temp;
    temp << "CA_dipole_splitting[" << i_dt << "] = ";
    for (int i_em = 0; i_em < 3; i_em++){
      temp << CA_dipole_splitting[i_dt][i_em] << "   ";
    }
    logger << LOG_DEBUG_POINT << temp.str() << endline_flush;
  }

  for (int i_dt = 0; i_dt < 4; i_dt++){
    for (int i_p = 0; i_p < pair.size(); i_p++){
      int pair_em = pair[i_p][0];
      int pair_sp = pair[i_p][1];
      logger << LOG_DEBUG_POINT << "Kit                [" << i_dt << "][" << pair_em << "][" << pair_sp << "] = " << setw(23) << setprecision(15) << Kit[i_dt][pair_em][pair_sp] << endline_flush;
      logger << LOG_DEBUG_POINT << "Kit_plus_x         [" << i_dt << "][" << pair_em << "][" << pair_sp << "] = " << setw(23) << setprecision(15) << Kit_plus_x[i_dt][pair_em][pair_sp] << endline_flush;
      logger << LOG_DEBUG_POINT << "Kit_plus_1         [" << i_dt << "][" << pair_em << "][" << pair_sp << "] = " << setw(23) << setprecision(15) << Kit_plus_1[i_dt][pair_em][pair_sp] << endline_flush;
      logger << LOG_DEBUG_POINT << "intKit_plus        [" << i_dt << "][" << pair_em << "][" << pair_sp << "] = " << setw(23) << setprecision(15) << intKit_plus[i_dt][pair_em][pair_sp] << endline_flush;
      logger << LOG_DEBUG_POINT << "Kit_plus_outside_x [" << i_dt << "][" << pair_em << "][" << pair_sp << "] = " << setw(23) << setprecision(15) << Kit_plus_outside_x[i_dt][pair_em][pair_sp] << endline_flush;
      logger << LOG_DEBUG_POINT << "Kit_plus_outside_1 [" << i_dt << "][" << pair_em << "][" << pair_sp << "] = " << setw(23) << setprecision(15) << Kit_plus_outside_1[i_dt][pair_em][pair_sp] << endline_flush;
      logger << LOG_DEBUG_POINT << "Kit_delta          [" << i_dt << "][" << pair_em << "][" << pair_sp << "] = " << setw(23) << setprecision(15) << Kit_delta[i_dt][pair_em][pair_sp] << endline_flush;
    }
  }

  for (int i_c = 0; i_c < (*CA_collinear).size(); i_c++){
    for (int j_c = 0; j_c < (*CA_collinear)[i_c].size(); j_c++){
      logger << LOG_DEBUG_POINT << "CA_ME2_cf[" << i_c << "][" << j_c << "] = " << CA_ME2_cf[i_c][j_c] << endline_flush;
    }
  }

  for (int i_c = 0; i_c < (*CA_collinear).size(); i_c++){
    for (int j_c = 0; j_c < (*CA_collinear)[i_c].size(); j_c++){
      if (no_spectator[i_c][j_c] == 0){
      }
      else if (no_spectator[i_c][j_c] < 3){
      }
      else if (no_spectator[i_c][j_c] > 2){
	logger << LOG_DEBUG_POINT << "m2_Q[no_spectator[" << i_c << "][" << j_c << "] = " << no_spectator[i_c][j_c] << "] = " << m2_Q[no_spectator[i_c][j_c]] << endline_flush;
	if (m2_Q[no_spectator[i_c][j_c]] == 0.){
	  // remainder from final-initial dipoles -> Kit (use CA_ME2_cf_fi[i_c][j_c] instead of CA_ME2_cf[i_c][j_c] !)
	  if (collinear_singularity[i_c][j_c] == 1){
	  }
	}
	else {
	  // remainder from final-initial dipoles -> Kit (use CA_ME2_cf_fi[i_c][j_c] instead of CA_ME2_cf[i_c][j_c] !)
	  logger << LOG_DEBUG_POINT << "Kit[type[i_c][j_c]][no_emitter[i_c][j_c]][no_spectator[i_c][j_c]]  = " << Kit[type[i_c][j_c]][no_emitter[i_c][j_c]][no_spectator[i_c][j_c]]  << endline_flush;
	  logger << LOG_DEBUG_POINT << "Kit_plus_x[type[i_c][j_c]][no_emitter[i_c][j_c]][no_spectator[i_c][j_c]]  = " << Kit_plus_x[type[i_c][j_c]][no_emitter[i_c][j_c]][no_spectator[i_c][j_c]]  << endline_flush;
	  logger << LOG_DEBUG_POINT << "2. / (1. - psi->z_coll[no_emitter[i_c][j_c]]) * Kit_plus_outside_x[type[i_c][j_c]][no_emitter[i_c][j_c]][no_spectator[i_c][j_c]] = " << 2. / (1. - psi->z_coll[no_emitter[i_c][j_c]]) * Kit_plus_outside_x[type[i_c][j_c]][no_emitter[i_c][j_c]][no_spectator[i_c][j_c]] << endline_flush;
	  logger << LOG_DEBUG_POINT << "CA_ME2_cf[i_c][j_c] = " << CA_ME2_cf[i_c][j_c] << endline_flush;
	  logger << LOG_DEBUG_POINT << "data_K[0][" << i_c << "][" << j_c << "] = " << data_K[0][i_c][j_c] << endline_flush;
	  logger << LOG_DEBUG_POINT << "data_K[1][" << i_c << "][" << j_c << "] = " << data_K[1][i_c][j_c] << endline_flush;
	  logger << LOG_DEBUG_POINT << "data_K[2][" << i_c << "][" << j_c << "] = " << data_K[2][i_c][j_c] << endline_flush;
	  //	  logger << LOG_DEBUG_POINT << "collinear_singularity[" << i_c << "][" << j_c << "] = " << collinear_singularity[i_c][j_c] << endline_flush;
	  if (collinear_singularity[i_c][j_c] == 1){
	    // contributes only to irregular splittings
	    //	    logger << LOG_DEBUG_POINT << "data_K[2][" << i_c << "][" << j_c << "] = " << data_K[2][i_c][j_c] << endline_flush;
	    //	    logger << LOG_DEBUG_POINT << "data_K[2][" << i_c << "][" << j_c << "] = " << data_K[2][i_c][j_c] << endline_flush;
	  }
	}
      }
      if (no_spectator[i_c][j_c] != 0){
	// P terms
      }
    }
    for (int i_x = 0; i_x < 3; i_x++){
      for (int j_c = 0; j_c < (*CA_collinear)[i_c].size(); j_c++){
	logger << LOG_DEBUG_POINT << "data_K[" << i_x << "][" << i_c << "][" << j_c << "] = " << data_K[i_x][i_c][j_c] << endline_flush;
      }
      double temp_sumK = accumulate(data_K[i_x][i_c].begin(), data_K[i_x][i_c].end(), 0.);
      logger << LOG_DEBUG_POINT << "i_x = " << i_x << "   temp_sumK = " << temp_sumK << endline_flush;
    }
  }

  logger.finished();
}

