#include "header.hpp"

void observable_set::selection_ioperator(){
  Logger logger("observable_set::selection_ioperator");
  logger.called();

  for (int i_a = (*VA_ioperator).size() - 1; i_a >= 0; i_a--){
    for (int j_a = (*VA_ioperator)[i_a].size() - 1; j_a >= 0 ; j_a--){
      // remove final-final contribution:
      if (switch_off_CS_ff && ((*VA_ioperator)[i_a][j_a].no_emitter() > 2 && (*VA_ioperator)[i_a][j_a].no_spectator() > 2)){
	(*VA_ioperator)[i_a].erase((*VA_ioperator)[i_a].begin() + j_a);
	logger << LOG_DEBUG << "kill ff:   (*VA_ioperator)[" << i_a << "][" << j_a << "].name() = " << (*VA_ioperator)[i_a][j_a].name() << endline_flush;
	continue;
      }
      // remove final-final contribution massless:
      if (switch_off_CS_ff_massless && ((*VA_ioperator)[i_a][j_a].no_emitter() > 2 && (*VA_ioperator)[i_a][j_a].no_spectator() > 2) && !(*VA_ioperator)[i_a][j_a].massive()){
	(*VA_ioperator)[i_a].erase((*VA_ioperator)[i_a].begin() + j_a);
	logger << LOG_DEBUG << "kill ff:   (*VA_ioperator)[" << i_a << "][" << j_a << "].name() = " << (*VA_ioperator)[i_a][j_a].name() << endline_flush;
	continue;
      }
      // remove final-final contribution massive:
      if (switch_off_CS_ff_massive && ((*VA_ioperator)[i_a][j_a].no_emitter() > 2 && (*VA_ioperator)[i_a][j_a].no_spectator() > 2) && (*VA_ioperator)[i_a][j_a].massive()){
	(*VA_ioperator)[i_a].erase((*VA_ioperator)[i_a].begin() + j_a);
	logger << LOG_DEBUG << "kill ff:   (*VA_ioperator)[" << i_a << "][" << j_a << "].name() = " << (*VA_ioperator)[i_a][j_a].name() << endline_flush;
	continue;
      }
      // remove final-initial contribution:
      if (switch_off_CS_fi && ((*VA_ioperator)[i_a][j_a].no_emitter() > 2 && (*VA_ioperator)[i_a][j_a].no_spectator() < 3)){
	(*VA_ioperator)[i_a].erase((*VA_ioperator)[i_a].begin() + j_a);
	logger << LOG_DEBUG << "kill fi:   (*VA_ioperator)[" << i_a << "][" << j_a << "].name() = " << (*VA_ioperator)[i_a][j_a].name() << endline_flush;
	continue;
      }
      // remove final-initial contribution massless:
      if (switch_off_CS_fi_massless && ((*VA_ioperator)[i_a][j_a].no_emitter() > 2 && (*VA_ioperator)[i_a][j_a].no_spectator() < 3) && !(*VA_ioperator)[i_a][j_a].massive()){
	(*VA_ioperator)[i_a].erase((*VA_ioperator)[i_a].begin() + j_a);
	logger << LOG_DEBUG << "kill fi:   (*VA_ioperator)[" << i_a << "][" << j_a << "].name() = " << (*VA_ioperator)[i_a][j_a].name() << endline_flush;
	continue;
      }
      // remove final-initial contribution massive:
      if (switch_off_CS_fi_massive && ((*VA_ioperator)[i_a][j_a].no_emitter() > 2 && (*VA_ioperator)[i_a][j_a].no_spectator() < 3) && (*VA_ioperator)[i_a][j_a].massive()){
	(*VA_ioperator)[i_a].erase((*VA_ioperator)[i_a].begin() + j_a);
	logger << LOG_DEBUG << "kill fi:   (*VA_ioperator)[" << i_a << "][" << j_a << "].name() = " << (*VA_ioperator)[i_a][j_a].name() << endline_flush;
	continue;
      }
      // remove initial-final contribution:
      if (switch_off_CS_if && ((*VA_ioperator)[i_a][j_a].no_emitter() < 3 && (*VA_ioperator)[i_a][j_a].no_spectator() > 2)){
	(*VA_ioperator)[i_a].erase((*VA_ioperator)[i_a].begin() + j_a);
	logger << LOG_DEBUG << "kill if:   (*VA_ioperator)[" << i_a << "][" << j_a << "].name() = " << (*VA_ioperator)[i_a][j_a].name() << endline_flush;
 	continue;
      }
      // remove initial-final contribution massless:
      if (switch_off_CS_if_massless && ((*VA_ioperator)[i_a][j_a].no_emitter() < 3 && (*VA_ioperator)[i_a][j_a].no_spectator() > 2) && !(*VA_ioperator)[i_a][j_a].massive()){
	(*VA_ioperator)[i_a].erase((*VA_ioperator)[i_a].begin() + j_a);
	logger << LOG_DEBUG << "kill if:   (*VA_ioperator)[" << i_a << "][" << j_a << "].name() = " << (*VA_ioperator)[i_a][j_a].name() << endline_flush;
 	continue;
      }
      // remove initial-final contribution massive:
      if (switch_off_CS_if_massive && ((*VA_ioperator)[i_a][j_a].no_emitter() < 3 && (*VA_ioperator)[i_a][j_a].no_spectator() > 2) && (*VA_ioperator)[i_a][j_a].massive()){
	(*VA_ioperator)[i_a].erase((*VA_ioperator)[i_a].begin() + j_a);
	logger << LOG_DEBUG << "kill if:   (*VA_ioperator)[" << i_a << "][" << j_a << "].name() = " << (*VA_ioperator)[i_a][j_a].name() << endline_flush;
 	continue;
      }
      // remove initial-initial contribution:
      if (switch_off_CS_ii && ((*VA_ioperator)[i_a][j_a].no_emitter() < 3 && (*VA_ioperator)[i_a][j_a].no_spectator() < 3)){
	(*VA_ioperator)[i_a].erase((*VA_ioperator)[i_a].begin() + j_a);
	logger << LOG_DEBUG << "kill:   (*VA_ioperator)[" << i_a << "][" << j_a << "].name() = " << (*VA_ioperator)[i_a][j_a].name() << endline_flush;
	continue;
      }
    }
    if ((*VA_ioperator)[i_a].size() == 0){
      (*VA_ioperator).erase((*VA_ioperator).begin() + i_a);
    }
  }

  logger.finished();
}
