#include "header.hpp"

void event_set::determination_object_definition(){
  static Logger logger("event_set::determination_object_definition");
  logger.called();

  logger << LOG_DEBUG << "BEFORE  determination_object_definition  (event_set::output_object_list_no_acces)" << endline << endline << output_object_list_no_access() << endline_flush;

  determination_define_pT_lep_lm_lp("top_qa", "top", "atop");
  determination_define_pT_lep_lm_lp("bottom_qa", "bottom", "abottom");
  determination_define_pT_lep_lm_lp("charm_qa", "charm", "acharm");

  determination_define_pT_lep_lm_lp("tjet", "tjet_t", "tjet_tx");
  determination_define_pT_lep_lm_lp("bjet", "bjet_b", "bjet_bx");
  determination_define_pT_lep_lm_lp("cjet", "cjet_c", "cjet_cx");
  
  determination_define_pT_lep_lm_lp("lep", "lm", "lp");
  determination_define_pT_lep_e_mu_tau("lep", "e", "mu", "tau");
  determination_define_pT_lep_lm_lp("e", "em", "ep");
  determination_define_pT_lep_lm_lp("mu", "mum", "mup");
  determination_define_pT_lep_lm_lp("tau", "taum", "taup");
  
  determination_define_pT_lep_lm_lp("nua", "nu", "nux");
  determination_define_pT_lep_e_mu_tau("nua", "nea", "nma", "nta");
  determination_define_pT_lep_lm_lp("nea", "ne", "nex");
  determination_define_pT_lep_lm_lp("nma", "nm", "nmx");
  determination_define_pT_lep_lm_lp("nta", "nt", "ntx");

  determination_define_pT_lep_lm_lp("w", "wp", "wm");
  determination_define_pT_lep_lm_lp("v", "w", "z");
  determination_define_pT_lep_e_mu_tau("v", "z", "wp", "wm");

  
  determination_define_ET_lep_lm_lp("top_qa", "top", "atop");
  determination_define_ET_lep_lm_lp("bottom_qa", "bottom", "abottom");
  determination_define_ET_lep_lm_lp("charm_qa", "charm", "acharm");

  determination_define_ET_lep_lm_lp("tjet", "tjet_t", "tjet_tx");
  determination_define_ET_lep_lm_lp("bjet", "bjet_b", "bjet_bx");
  determination_define_ET_lep_lm_lp("cjet", "cjet_c", "cjet_cx");
  
  determination_define_ET_lep_lm_lp("lep", "lm", "lp");
  determination_define_ET_lep_e_mu_tau("lep", "e", "mu", "tau");
  determination_define_ET_lep_lm_lp("e", "em", "ep");
  determination_define_ET_lep_lm_lp("mu", "mum", "mup");
  determination_define_ET_lep_lm_lp("tau", "taum", "taup");
  
  determination_define_ET_lep_lm_lp("nua", "nu", "nux");
  determination_define_ET_lep_e_mu_tau("nua", "nea", "nma", "nta");
  determination_define_ET_lep_lm_lp("nea", "ne", "nex");
  determination_define_ET_lep_lm_lp("nma", "nm", "nmx");
  determination_define_ET_lep_lm_lp("nta", "nt", "ntx");
  
  determination_define_ET_lep_lm_lp("w", "wp", "wm");
  determination_define_ET_lep_lm_lp("v", "w", "z");
  determination_define_ET_lep_e_mu_tau("v", "z", "wp", "wm");


  determination_define_eta_lep_lm_lp("tjet", "tjet_t", "tjet_tx");
  determination_define_eta_lep_lm_lp("bjet", "bjet_b", "bjet_bx");
  determination_define_eta_lep_lm_lp("cjet", "cjet_c", "cjet_cx");

  determination_define_eta_lep_lm_lp("top_qa", "top", "atop");
  determination_define_eta_lep_lm_lp("bottom_qa", "bottom", "abottom");
  determination_define_eta_lep_lm_lp("charm_qa", "charm", "acharm");

  determination_define_eta_lep_lm_lp("lep", "lm", "lp");
  determination_define_eta_lep_e_mu_tau("lep", "e", "mu", "tau");
  determination_define_eta_lep_lm_lp("e", "em", "ep");
  determination_define_eta_lep_lm_lp("mu", "mum", "mup");
  determination_define_eta_lep_lm_lp("tau", "taum", "taup");

  determination_define_eta_lep_lm_lp("nua", "nu", "nux");
  determination_define_eta_lep_e_mu_tau("nua", "nea", "nma", "nta");
  determination_define_eta_lep_lm_lp("nea", "ne", "nex");
  determination_define_eta_lep_lm_lp("nma", "nm", "nmx");
  determination_define_eta_lep_lm_lp("nta", "nt", "ntx");

  determination_define_eta_lep_lm_lp("w", "wp", "wm");
  determination_define_eta_lep_lm_lp("v", "w", "z");
  determination_define_eta_lep_e_mu_tau("v", "z", "wp", "wm");


  determination_define_y_lep_lm_lp("tjet", "tjet_t", "tjet_tx");
  determination_define_y_lep_lm_lp("bjet", "bjet_b", "bjet_bx");
  determination_define_y_lep_lm_lp("cjet", "cjet_c", "cjet_cx");

  determination_define_y_lep_lm_lp("top_qa", "top", "atop");
  determination_define_y_lep_lm_lp("bottom_qa", "bottom", "abottom");
  determination_define_y_lep_lm_lp("charm_qa", "charm", "acharm");

  determination_define_y_lep_lm_lp("lep", "lm", "lp");
  determination_define_y_lep_e_mu_tau("lep", "e", "mu", "tau");
  determination_define_y_lep_lm_lp("e", "em", "ep");
  determination_define_y_lep_lm_lp("mu", "mum", "mup");
  determination_define_y_lep_lm_lp("tau", "taum", "taup");

  determination_define_y_lep_lm_lp("nua", "nu", "nux");
  determination_define_y_lep_e_mu_tau("nua", "nea", "nma", "nta");
  determination_define_y_lep_lm_lp("nea", "ne", "nex");
  determination_define_y_lep_lm_lp("nma", "nm", "nmx");
  determination_define_y_lep_lm_lp("nta", "nt", "ntx");

  determination_define_y_lep_lm_lp("w", "wp", "wm");
  determination_define_y_lep_lm_lp("v", "w", "z");
  determination_define_y_lep_e_mu_tau("v", "z", "wp", "wm");

  
  determination_n_observed_min_lep_lm_lp("tjet", "tjet_t", "tjet_tx");
  determination_n_observed_min_lep_lm_lp("bjet", "bjet_b", "bjet_bx");
  determination_n_observed_min_lep_lm_lp("cjet", "cjet_c", "cjet_cx");

  determination_n_observed_min_lep_lm_lp("top_qa", "top", "atop");
  determination_n_observed_min_lep_lm_lp("bottom_qa", "bottom", "abottom");
  determination_n_observed_min_lep_lm_lp("charm_qa", "charm", "acharm");

  determination_n_observed_min_lep_e_mu_tau("lm", "em", "mum", "taum");
  determination_n_observed_min_lep_e_mu_tau("lp", "ep", "mup", "taup");
  determination_n_observed_min_lep_lm_lp("lep", "lm", "lp");
  determination_n_observed_min_lep_lm_lp("e", "em", "ep");
  determination_n_observed_min_lep_lm_lp("mu", "mum", "mup");
  determination_n_observed_min_lep_lm_lp("tau", "taum", "taup");
  determination_n_observed_min_lep_e_mu_tau("lep", "e", "mu", "tau");

  determination_n_observed_min_lep_e_mu_tau("nu", "ne", "nm", "nt");
  determination_n_observed_min_lep_e_mu_tau("nux", "nex", "nmx", "ntx");
  determination_n_observed_min_lep_lm_lp("nua", "nu", "nux");
  determination_n_observed_min_lep_lm_lp("nea", "ne", "nex");
  determination_n_observed_min_lep_lm_lp("nma", "nm", "nmx");
  determination_n_observed_min_lep_lm_lp("nta", "nt", "ntx");
  determination_n_observed_min_lep_e_mu_tau("nua", "nea", "nma", "nta");

  determination_n_observed_min_lep_lm_lp("w", "wp", "wm");
  determination_n_observed_min_lep_lm_lp("v", "w", "z");
  determination_n_observed_min_lep_e_mu_tau("v", "z", "wp", "wm");

  
  determination_n_observed_max_lep_lm_lp("tjet", "tjet_t", "tjet_tx");
  determination_n_observed_max_lep_lm_lp("bjet", "bjet_b", "bjet_bx");
  determination_n_observed_max_lep_lm_lp("cjet", "cjet_c", "cjet_cx");

  determination_n_observed_max_lep_lm_lp("top_qa", "top", "atop");
  determination_n_observed_max_lep_lm_lp("bottom_qa", "bottom", "abottom");
  determination_n_observed_max_lep_lm_lp("charm_qa", "charm", "acharm");

  determination_n_observed_max_lep_e_mu_tau("lm", "em", "mum", "taum");
  determination_n_observed_max_lep_e_mu_tau("lp", "ep", "mup", "taup");
  determination_n_observed_max_lep_lm_lp("lep", "lm", "lp");
  determination_n_observed_max_lep_lm_lp("e", "em", "ep");
  determination_n_observed_max_lep_lm_lp("mu", "mum", "mup");
  determination_n_observed_max_lep_lm_lp("tau", "taum", "taup");
  determination_n_observed_max_lep_e_mu_tau("lep", "e", "mu", "tau");

  determination_n_observed_max_lep_e_mu_tau("nu", "ne", "nm", "nt");
  determination_n_observed_max_lep_e_mu_tau("nux", "nex", "nmx", "ntx");
  determination_n_observed_max_lep_lm_lp("nua", "nu", "nux");
  determination_n_observed_max_lep_lm_lp("nea", "ne", "nex");
  determination_n_observed_max_lep_lm_lp("nma", "nm", "nmx");
  determination_n_observed_max_lep_lm_lp("nta", "nt", "ntx");
  determination_n_observed_max_lep_e_mu_tau("nua", "nea", "nma", "nta");

  determination_n_observed_max_lep_lm_lp("w", "wp", "wm");
  determination_n_observed_max_lep_lm_lp("v", "w", "z");
  determination_n_observed_max_lep_e_mu_tau("v", "z", "wp", "wm");

  // possibly add anything alike for jet, ljet, hjet, etc. (so far, all thresholds are set separately there) ???
  
  logger << LOG_DEBUG << "AFTER  determination_object_definition  (event_set::output_object_list_no_acces)" << endline << endline << output_object_list_no_access() << endline_flush;

  logger.finished();
}


void event_set::determination_define_pT_lep_lm_lp(string lep, string lm, string lp){
  static Logger logger("event_set::determination_define_pT_lep_lm_lp");
  logger.called();

  // adapt define_pT (lep-lm/lp) !
  if (pda[observed_object[lm]].define_pT == 0. && pda[observed_object[lep]].define_pT > 0.){pda[observed_object[lm]].define_pT = pda[observed_object[lep]].define_pT;}
  if (pda[observed_object[lp]].define_pT == 0. && pda[observed_object[lep]].define_pT > 0.){pda[observed_object[lp]].define_pT = pda[observed_object[lep]].define_pT;}
  if (pda[observed_object[lep]].define_pT < pda[observed_object[lm]].define_pT &&
      pda[observed_object[lep]].define_pT < pda[observed_object[lp]].define_pT){
    if (pda[observed_object[lm]].define_pT >= pda[observed_object[lp]].define_pT){pda[observed_object[lep]].define_pT = pda[observed_object[lp]].define_pT;}
    else {pda[observed_object[lep]].define_pT = pda[observed_object[lm]].define_pT;}
  }

  logger.finished();
}


void event_set::determination_define_pT_lep_e_mu_tau(string lep, string e, string mu, string tau){
  static Logger logger("event_set::determination_define_pT_lep_e_mu_tau");
  logger.called();

  // adapt define_pT (lep-e/mu/tau) !
  if (pda[observed_object[e]].define_pT == 0. && pda[observed_object[lep]].define_pT > 0.){pda[observed_object[e]].define_pT = pda[observed_object[lep]].define_pT;}
  if (pda[observed_object[mu]].define_pT == 0. && pda[observed_object[lep]].define_pT > 0.){pda[observed_object[mu]].define_pT = pda[observed_object[lep]].define_pT;}
  if (pda[observed_object[tau]].define_pT == 0. && pda[observed_object[lep]].define_pT > 0.){pda[observed_object[tau]].define_pT = pda[observed_object[lep]].define_pT;}
  if (pda[observed_object[lep]].define_pT < pda[observed_object[e]].define_pT &&
      pda[observed_object[lep]].define_pT < pda[observed_object[mu]].define_pT &&
      pda[observed_object[lep]].define_pT < pda[observed_object[tau]].define_pT){
    if (pda[observed_object[tau]].define_pT >= pda[observed_object[e]].define_pT &&
	pda[observed_object[mu]].define_pT >= pda[observed_object[e]].define_pT){pda[observed_object[lep]].define_pT = pda[observed_object[e]].define_pT;}
    else if (pda[observed_object[tau]].define_pT >= pda[observed_object[mu]].define_pT){pda[observed_object[lep]].define_pT = pda[observed_object[mu]].define_pT;}
    else {pda[observed_object[lep]].define_pT = pda[observed_object[tau]].define_pT;}
  }

  logger.finished();
}


void event_set::determination_define_ET_lep_lm_lp(string lep, string lm, string lp){
  static Logger logger("event_set::determination_define_ET_lep_lm_lp");
  logger.called();

  // adapt define_pT (lep-lm/lp) !
  if (pda[observed_object[lm]].define_pT == 0. && pda[observed_object[lep]].define_pT > 0.){pda[observed_object[lm]].define_pT = pda[observed_object[lep]].define_pT;}
  if (pda[observed_object[lp]].define_pT == 0. && pda[observed_object[lep]].define_pT > 0.){pda[observed_object[lp]].define_pT = pda[observed_object[lep]].define_pT;}
  if (pda[observed_object[lep]].define_pT < pda[observed_object[lm]].define_pT &&
      pda[observed_object[lep]].define_pT < pda[observed_object[lp]].define_pT){
    if (pda[observed_object[lm]].define_pT >= pda[observed_object[lp]].define_pT){pda[observed_object[lep]].define_pT = pda[observed_object[lp]].define_pT;}
    else {pda[observed_object[lep]].define_pT = pda[observed_object[lm]].define_pT;}
  }

  logger.finished();
}

    
void event_set::determination_define_ET_lep_e_mu_tau(string lep, string e, string mu, string tau){
  static Logger logger("event_set::determination_define_ET_lep_e_mu_tau");
  logger.called();

  // adapt define_ET (lep-e/mu/tau) !
  if (pda[observed_object[e]].define_ET == 0. && pda[observed_object[lep]].define_ET > 0.){pda[observed_object[e]].define_ET = pda[observed_object[lep]].define_ET;}
  if (pda[observed_object[mu]].define_ET == 0. && pda[observed_object[lep]].define_ET > 0.){pda[observed_object[mu]].define_ET = pda[observed_object[lep]].define_ET;}
  if (pda[observed_object[tau]].define_ET == 0. && pda[observed_object[lep]].define_ET > 0.){pda[observed_object[tau]].define_ET = pda[observed_object[lep]].define_ET;}
  if (pda[observed_object[lep]].define_ET < pda[observed_object[e]].define_ET &&
      pda[observed_object[lep]].define_ET < pda[observed_object[mu]].define_ET &&
      pda[observed_object[lep]].define_ET < pda[observed_object[tau]].define_ET){
    if (pda[observed_object[tau]].define_ET >= pda[observed_object[e]].define_ET &&
	pda[observed_object[mu]].define_ET >= pda[observed_object[e]].define_ET){pda[observed_object[lep]].define_ET = pda[observed_object[e]].define_ET;}
    else if (pda[observed_object[tau]].define_ET >= pda[observed_object[mu]].define_ET){pda[observed_object[lep]].define_ET = pda[observed_object[mu]].define_ET;}
    else {pda[observed_object[lep]].define_ET = pda[observed_object[tau]].define_ET;}
  }

  logger.finished();
}


void event_set::determination_define_eta_lep_lm_lp(string lep, string lm, string lp){
  static Logger logger("event_set::determination_define_eta_lep_lm_lp");
  logger.called();

  // adapt define_eta (e-em/ep) !
  if (pda[observed_object[lm]].define_eta == numeric_limits<double>::infinity() && pda[observed_object[lep]].define_eta < numeric_limits<double>::infinity()){pda[observed_object[lm]].define_eta = pda[observed_object[lep]].define_eta;}
  if (pda[observed_object[lp]].define_eta == numeric_limits<double>::infinity() && pda[observed_object[lep]].define_eta < numeric_limits<double>::infinity()){pda[observed_object[lp]].define_eta = pda[observed_object[lep]].define_eta;}
  if (pda[observed_object[lep]].define_eta < pda[observed_object[lm]].define_eta &&
      pda[observed_object[lep]].define_eta < pda[observed_object[lp]].define_eta){
    if (pda[observed_object[lm]].define_eta > pda[observed_object[lp]].define_eta){pda[observed_object[lep]].define_eta = pda[observed_object[lp]].define_eta;}
    else {pda[observed_object[lep]].define_eta = pda[observed_object[lm]].define_eta;}
  }

  logger.finished();
}

    
void event_set::determination_define_eta_lep_e_mu_tau(string lep, string e, string mu, string tau){
  static Logger logger("event_set::determination_define_eta_lep_e_mu_tau");
  logger.called();

  // adapt define_eta (lep-e/mu/tau) !
  if (pda[observed_object[e]].define_eta == numeric_limits<double>::infinity() && pda[observed_object[lep]].define_eta < numeric_limits<double>::infinity()){pda[observed_object[e]].define_eta = pda[observed_object[lep]].define_eta;}
  if (pda[observed_object[mu]].define_eta == numeric_limits<double>::infinity() && pda[observed_object[lep]].define_eta < numeric_limits<double>::infinity()){pda[observed_object[mu]].define_eta = pda[observed_object[lep]].define_eta;}
  if (pda[observed_object[tau]].define_eta == numeric_limits<double>::infinity() && pda[observed_object[lep]].define_eta < numeric_limits<double>::infinity()){pda[observed_object[tau]].define_eta = pda[observed_object[lep]].define_eta;}
  if (pda[observed_object[lep]].define_eta < pda[observed_object[e]].define_eta &&
      pda[observed_object[lep]].define_eta < pda[observed_object[mu]].define_eta &&
      pda[observed_object[lep]].define_eta < pda[observed_object[tau]].define_eta){
    if (pda[observed_object[tau]].define_eta >= pda[observed_object[e]].define_eta &&
	pda[observed_object[mu]].define_eta >= pda[observed_object[e]].define_eta){pda[observed_object[lep]].define_eta = pda[observed_object[e]].define_eta;}
    else if (pda[observed_object[tau]].define_eta >= pda[observed_object[mu]].define_eta){pda[observed_object[lep]].define_eta = pda[observed_object[mu]].define_eta;}
    else {pda[observed_object[lep]].define_eta = pda[observed_object[tau]].define_eta;}
  }

  logger.finished();
}

    
void event_set::determination_define_y_lep_lm_lp(string lep, string lm, string lp){
  static Logger logger("event_set::determination_define_y_lep_lm_lp");
  logger.called();

  // adapt define_y (e-em/ep) !
  if (pda[observed_object[lm]].define_y == numeric_limits<double>::infinity() && pda[observed_object[lep]].define_y < numeric_limits<double>::infinity()){pda[observed_object[lm]].define_y = pda[observed_object[lep]].define_y;}
  if (pda[observed_object[lp]].define_y == numeric_limits<double>::infinity() && pda[observed_object[lep]].define_y < numeric_limits<double>::infinity()){pda[observed_object[lp]].define_y = pda[observed_object[lep]].define_y;}
  if (pda[observed_object[lep]].define_y < pda[observed_object[lm]].define_y &&
      pda[observed_object[lep]].define_y < pda[observed_object[lp]].define_y){
    if (pda[observed_object[lm]].define_y > pda[observed_object[lp]].define_y){pda[observed_object[lep]].define_y = pda[observed_object[lp]].define_y;}
    else {pda[observed_object[lep]].define_y = pda[observed_object[lm]].define_y;}
  }

  logger.finished();
}

    
void event_set::determination_define_y_lep_e_mu_tau(string lep, string e, string mu, string tau){
  static Logger logger("event_set::determination_define_y_lep_e_mu_tau");
  logger.called();

  // adapt define_y (lep-e/mu/tau) !
  if (pda[observed_object[e]].define_y == numeric_limits<double>::infinity() && pda[observed_object[lep]].define_y < numeric_limits<double>::infinity()){pda[observed_object[e]].define_y = pda[observed_object[lep]].define_y;}
  if (pda[observed_object[mu]].define_y == numeric_limits<double>::infinity() && pda[observed_object[lep]].define_y < numeric_limits<double>::infinity()){pda[observed_object[mu]].define_y = pda[observed_object[lep]].define_y;}
  if (pda[observed_object[tau]].define_y == numeric_limits<double>::infinity() && pda[observed_object[lep]].define_y < numeric_limits<double>::infinity()){pda[observed_object[tau]].define_y = pda[observed_object[lep]].define_y;}
  if (pda[observed_object[lep]].define_y < pda[observed_object[e]].define_y &&
      pda[observed_object[lep]].define_y < pda[observed_object[mu]].define_y &&
      pda[observed_object[lep]].define_y < pda[observed_object[tau]].define_y){
    if (pda[observed_object[tau]].define_y >= pda[observed_object[e]].define_y &&
	pda[observed_object[mu]].define_y >= pda[observed_object[e]].define_y){pda[observed_object[lep]].define_y = pda[observed_object[e]].define_y;}
    else if (pda[observed_object[tau]].define_y >= pda[observed_object[mu]].define_y){pda[observed_object[lep]].define_y = pda[observed_object[mu]].define_y;}
    else {pda[observed_object[lep]].define_y = pda[observed_object[tau]].define_y;}
  }

  logger.finished();
}

    
void event_set::determination_n_observed_min_lep_lm_lp(string lep, string lm, string lp){
  static Logger logger("event_set::determination_n_observed_min_lep_lm_lp");
  logger.called();

  // adapt n_observed_min (lep-lm/lp) !
  if (pda[observed_object[lep]].n_observed_min < pda[observed_object[lm]].n_observed_min + pda[observed_object[lp]].n_observed_min){
    pda[observed_object[lep]].n_observed_min = pda[observed_object[lm]].n_observed_min + pda[observed_object[lp]].n_observed_min;
  }

  logger.finished();
}


void event_set::determination_n_observed_min_lep_e_mu_tau(string lep, string e, string mu, string tau){
  static Logger logger("event_set::determination_n_observed_min_lep_e_mu_tau");
  logger.called();

  // adapt n_observed_min (lep-e/mu/tau) !
  if (pda[observed_object[lep]].n_observed_min < pda[observed_object[e]].n_observed_min + pda[observed_object[mu]].n_observed_min + pda[observed_object[tau]].n_observed_min){
    pda[observed_object[lep]].n_observed_min = pda[observed_object[e]].n_observed_min + pda[observed_object[mu]].n_observed_min + pda[observed_object[tau]].n_observed_min;
  }

  logger.finished();
}


void event_set::determination_n_observed_max_lep_lm_lp(string lep, string lm, string lp){
  static Logger logger("event_set::determination_n_observed_max_lep_lm_lp");
  logger.called();

  // adapt n_observed_max (lep-lm/lp) !
  if (pda[observed_object[lep]].n_observed_max > pda[observed_object[lm]].n_observed_max + pda[observed_object[lp]].n_observed_max){
    pda[observed_object[lep]].n_observed_max = pda[observed_object[lm]].n_observed_max + pda[observed_object[lp]].n_observed_max;
  }

  logger.finished();
}


void event_set::determination_n_observed_max_lep_e_mu_tau(string lep, string e, string mu, string tau){
  static Logger logger("event_set::determination_n_observed_max_lep_e_mu_tau");
  logger.called();

  // adapt n_observed_max (lep-e/mu/tau) !
  if (pda[observed_object[lep]].n_observed_max > pda[observed_object[e]].n_observed_max + pda[observed_object[mu]].n_observed_max + pda[observed_object[tau]].n_observed_max){
    pda[observed_object[lep]].n_observed_max = pda[observed_object[e]].n_observed_max + pda[observed_object[mu]].n_observed_max + pda[observed_object[tau]].n_observed_max;
  }

  logger.finished();
}


