#include "header.hpp"

void event_set::determination_object_partonlevel_phasespace(){
  static Logger logger("event_set::determination_object_partonlevel_phasespace");
  logger.called();

  ps_n_partonlevel.resize(csi->n_ps, vector<int> (object_list.size(), 0));

  for (int i_a = 0; i_a < csi->n_ps; i_a++){
    logger << LOG_DEBUG << "csi->type_parton[" << i_a << "].size() = " << csi->type_parton[i_a].size() << endline_flush;
    for (int i_p = 3; i_p < csi->type_parton[i_a].size(); i_p++){
      logger << LOG_DEBUG << "i_a = " << i_a << "   i_p = " << i_p << endline_flush;
      if (csi->type_parton[i_a][i_p] == 22){ps_n_partonlevel[i_a][observed_object["photon"]]++;}
      
      if (abs(csi->type_parton[i_a][i_p]) == 11 || abs(csi->type_parton[i_a][i_p]) == 13 || abs(csi->type_parton[i_a][i_p]) == 15){ps_n_partonlevel[i_a][observed_object["lep"]]++;}
      if (csi->type_parton[i_a][i_p] == 11 || csi->type_parton[i_a][i_p] == 13 || csi->type_parton[i_a][i_p] == 15){ps_n_partonlevel[i_a][observed_object["lm"]]++;}
      if (csi->type_parton[i_a][i_p] == -11 || csi->type_parton[i_a][i_p] == -13 || csi->type_parton[i_a][i_p] == -15){ps_n_partonlevel[i_a][observed_object["lp"]]++;}
      if (abs(csi->type_parton[i_a][i_p]) == 11){ps_n_partonlevel[i_a][observed_object["e"]]++;}
      if (abs(csi->type_parton[i_a][i_p]) == 13){ps_n_partonlevel[i_a][observed_object["mu"]]++;}
      if (abs(csi->type_parton[i_a][i_p]) == 15){ps_n_partonlevel[i_a][observed_object["tau"]]++;}
      if (csi->type_parton[i_a][i_p] == 11){ps_n_partonlevel[i_a][observed_object["em"]]++;}
      if (csi->type_parton[i_a][i_p] == 13){ps_n_partonlevel[i_a][observed_object["mum"]]++;}
      if (csi->type_parton[i_a][i_p] == 15){ps_n_partonlevel[i_a][observed_object["taum"]]++;}
      if (csi->type_parton[i_a][i_p] == -11){ps_n_partonlevel[i_a][observed_object["ep"]]++;}
      if (csi->type_parton[i_a][i_p] == -13){ps_n_partonlevel[i_a][observed_object["mup"]]++;}
      if (csi->type_parton[i_a][i_p] == -15){ps_n_partonlevel[i_a][observed_object["taup"]]++;}

      if (abs(csi->type_parton[i_a][i_p]) == 12 || abs(csi->type_parton[i_a][i_p]) == 14 || abs(csi->type_parton[i_a][i_p]) == 16){ps_n_partonlevel[i_a][observed_object["nua"]]++;}
      if (csi->type_parton[i_a][i_p] == 12 || csi->type_parton[i_a][i_p] == 14 || csi->type_parton[i_a][i_p] == 16){ps_n_partonlevel[i_a][observed_object["nu"]]++;}
      if (csi->type_parton[i_a][i_p] == -12 || csi->type_parton[i_a][i_p] == -14 || csi->type_parton[i_a][i_p] == -16){ps_n_partonlevel[i_a][observed_object["nux"]]++;}
      if (abs(csi->type_parton[i_a][i_p]) == 12){ps_n_partonlevel[i_a][observed_object["nea"]]++;}
      if (abs(csi->type_parton[i_a][i_p]) == 14){ps_n_partonlevel[i_a][observed_object["nma"]]++;}
      if (abs(csi->type_parton[i_a][i_p]) == 16){ps_n_partonlevel[i_a][observed_object["nta"]]++;}
      if (csi->type_parton[i_a][i_p] == 12){ps_n_partonlevel[i_a][observed_object["ne"]]++;}
      if (csi->type_parton[i_a][i_p] == 14){ps_n_partonlevel[i_a][observed_object["nm"]]++;}
      if (csi->type_parton[i_a][i_p] == 16){ps_n_partonlevel[i_a][observed_object["nt"]]++;}
      if (csi->type_parton[i_a][i_p] == -12){ps_n_partonlevel[i_a][observed_object["nex"]]++;}
      if (csi->type_parton[i_a][i_p] == -14){ps_n_partonlevel[i_a][observed_object["nmx"]]++;}
      if (csi->type_parton[i_a][i_p] == -16){ps_n_partonlevel[i_a][observed_object["ntx"]]++;}
      if (abs(csi->type_parton[i_a][i_p]) == 12 || abs(csi->type_parton[i_a][i_p]) == 14 || abs(csi->type_parton[i_a][i_p]) == 16){ps_n_partonlevel[i_a][observed_object["missing"]]++;}

      bool flag_jet = false;
      for (int i_j = 0; i_j < jet_algorithm_list.size(); i_j++){if (jet_algorithm_list[i_j] == csi->type_parton[i_a][i_p]){flag_jet = true; break;}}
      
      if ((csi->is_coloured_parton[i_a][i_p] && flag_jet) || (photon_jet_algorithm && csi->type_parton[i_a][i_p] == 22)){ps_n_partonlevel[i_a][observed_object["jet"]]++;}
      if (csi->is_coloured_parton[i_a][i_p] && !csi->is_massive_parton[i_a][i_p] && flag_jet){ps_n_partonlevel[i_a][observed_object["ljet"]]++;}
      if (csi->is_coloured_parton[i_a][i_p] && csi->is_massive_parton[i_a][i_p] && flag_jet){ps_n_partonlevel[i_a][observed_object["hjet"]]++;}
      if (photon_jet_algorithm && csi->type_parton[i_a][i_p] == 22){ps_n_partonlevel[i_a][observed_object["ajet"]]++;}

      if (csi->type_parton[i_a][i_p] == 4 && csi->is_massive_parton[i_a][i_p]){ps_n_partonlevel[i_a][observed_object["charm"]]++;}
      if (csi->type_parton[i_a][i_p] == -4 && csi->is_massive_parton[i_a][i_p]){ps_n_partonlevel[i_a][observed_object["charm"]]++;}
      if (abs(csi->type_parton[i_a][i_p]) == 4 && csi->is_massive_parton[i_a][i_p]){ps_n_partonlevel[i_a][observed_object["charm_qa"]]++;}
      if (csi->type_parton[i_a][i_p] == 4 && csi->is_massive_parton[i_a][i_p] && flag_jet){ps_n_partonlevel[i_a][observed_object["cjet_c"]]++;}
      if (csi->type_parton[i_a][i_p] == -4 && csi->is_massive_parton[i_a][i_p] && flag_jet){ps_n_partonlevel[i_a][observed_object["cjet_cx"]]++;}
      if (abs(csi->type_parton[i_a][i_p]) == 4 && csi->is_massive_parton[i_a][i_p] && flag_jet){ps_n_partonlevel[i_a][observed_object["cjet"]]++;}
      
      if (csi->type_parton[i_a][i_p] == 5 && csi->is_massive_parton[i_a][i_p]){ps_n_partonlevel[i_a][observed_object["bottom"]]++;}
      if (csi->type_parton[i_a][i_p] == -5 && csi->is_massive_parton[i_a][i_p]){ps_n_partonlevel[i_a][observed_object["abottom"]]++;}
      if (abs(csi->type_parton[i_a][i_p]) == 5 && csi->is_massive_parton[i_a][i_p]){ps_n_partonlevel[i_a][observed_object["bottom_qa"]]++;}
      if (csi->type_parton[i_a][i_p] == 5 && csi->is_massive_parton[i_a][i_p] && flag_jet){ps_n_partonlevel[i_a][observed_object["bjet_b"]]++;}
      if (csi->type_parton[i_a][i_p] == -5 && csi->is_massive_parton[i_a][i_p] && flag_jet){ps_n_partonlevel[i_a][observed_object["bjet_bx"]]++;}
      if (abs(csi->type_parton[i_a][i_p]) == 5 && csi->is_massive_parton[i_a][i_p] && flag_jet){ps_n_partonlevel[i_a][observed_object["bjet"]]++;}
      
      if (csi->type_parton[i_a][i_p] == 6 && csi->is_massive_parton[i_a][i_p]){ps_n_partonlevel[i_a][observed_object["top"]]++;}
      if (csi->type_parton[i_a][i_p] == -6 && csi->is_massive_parton[i_a][i_p]){ps_n_partonlevel[i_a][observed_object["atop"]]++;}
      if (abs(csi->type_parton[i_a][i_p]) == 6 && csi->is_massive_parton[i_a][i_p]){ps_n_partonlevel[i_a][observed_object["top_qa"]]++;}
      if (csi->type_parton[i_a][i_p] == 6 && csi->is_massive_parton[i_a][i_p] && flag_jet){ps_n_partonlevel[i_a][observed_object["tjet_t"]]++;}
      if (csi->type_parton[i_a][i_p] == -6 && csi->is_massive_parton[i_a][i_p] && flag_jet){ps_n_partonlevel[i_a][observed_object["tjet_tx"]]++;}
      if (abs(csi->type_parton[i_a][i_p]) == 6 && csi->is_massive_parton[i_a][i_p] && flag_jet){ps_n_partonlevel[i_a][observed_object["tjet"]]++;}

      if (abs(csi->type_parton[i_a][i_p]) == 24 || csi->type_parton[i_a][i_p] == 23){ps_n_partonlevel[i_a][observed_object["v"]]++;}
      if (abs(csi->type_parton[i_a][i_p]) == 24){ps_n_partonlevel[i_a][observed_object["w"]]++;}
      if (csi->type_parton[i_a][i_p] == 24){ps_n_partonlevel[i_a][observed_object["wm"]]++;}
      if (csi->type_parton[i_a][i_p] == -24){ps_n_partonlevel[i_a][observed_object["wp"]]++;}
      if (csi->type_parton[i_a][i_p] == 23){ps_n_partonlevel[i_a][observed_object["z"]]++;}
      if (csi->type_parton[i_a][i_p] == 25){ps_n_partonlevel[i_a][observed_object["h"]]++;}
    }
  }

  for (int i_p = 1; i_p < object_list.size(); i_p++){
    pda[i_p].n_partonlevel = 0;
    for (int i_a = 0; i_a < csi->n_ps; i_a++){
      if (ps_n_partonlevel[i_a][i_p] > pda[i_p].n_partonlevel){pda[i_p].n_partonlevel = ps_n_partonlevel[i_a][i_p];}
    }
  }

  logger.finished();
}


void event_set::determination_object_observed_from_partonlevel(){
  static Logger logger("event_set::determination_object_observed_from_partonlevel");
  logger.called();

  // adapt n_observed_max trivially to parton-level particles
  // Some limits on "equivalent objects" seem to be not correctly taken into account !!! -> check if solved ???
  // e.g "particle lp = n < 1" does not remove events if "particle lep = pT > 25 GeV |eta| < 2.5 n >= 1" is set

  logger << LOG_DEBUG << "BEFORE  determination_object_observed_from_partonlevel  (event_set::output_object_list_no_access)" << endline << endline << output_object_list_no_access() << endline_flush;

  for (int i_o = 1; i_o < object_list.size(); i_o++){
    if (pda[i_o].n_partonlevel < pda[i_o].n_observed_max){
      if (object_list[i_o] == "ljet"){if (pda[observed_object["jet"]].n_partonlevel < pda[i_o].n_observed_max){pda[i_o].n_observed_max = pda[observed_object["jet"]].n_partonlevel;}}
      else if (pda[i_o].is_user_defined){
	logger << LOG_DEBUG << object_list[i_o] << " is a user-defined particle -> no modification." << endline_flush;}
      else {pda[i_o].n_observed_max = pda[i_o].n_partonlevel;}
    }
  }
  
  determination_n_observed_max_from_partonlevel_lep_lm_lp("top_qa", "top", "atop");
  determination_n_observed_min_from_partonlevel_lep_lm_lp("top_qa", "top", "atop");
  determination_n_observed_max_from_partonlevel_lep_lm_lp("bottom_qa", "bottom", "abottom");
  determination_n_observed_min_from_partonlevel_lep_lm_lp("bottom_qa", "bottom", "abottom");
  determination_n_observed_max_from_partonlevel_lep_lm_lp("charm_qa", "charm", "acharm");
  determination_n_observed_min_from_partonlevel_lep_lm_lp("charm_qa", "charm", "acharm");

  // The same modifications on n_observed_min/max as for the quarks are applied on corresponding heavy jets
  // -> might need adaptation if an IR-safe definition of g->QQx splittings shall be used for massless quarks Q while still identifying them as heavy jets
  determination_n_observed_max_from_partonlevel_lep_lm_lp("tjet", "tjet_t", "tjet_tx");
  determination_n_observed_min_from_partonlevel_lep_lm_lp("tjet", "tjet_t", "tjet_tx");
  determination_n_observed_max_from_partonlevel_lep_lm_lp("bjet", "bjet_b", "bjet_bx");
  determination_n_observed_min_from_partonlevel_lep_lm_lp("bjet", "bjet_b", "bjet_bx");
  determination_n_observed_max_from_partonlevel_lep_lm_lp("cjet", "cjet_c", "cjet_cx");
  determination_n_observed_min_from_partonlevel_lep_lm_lp("cjet", "cjet_c", "cjet_cx");

  determination_n_observed_max_from_partonlevel_lep_lm_lp("lep", "lm", "lp");
  determination_n_observed_min_from_partonlevel_lep_lm_lp("lep", "lm", "lp");
  determination_n_observed_min_from_partonlevel_lep_e_mu_tau("lep", "e", "mu", "tau");
  determination_n_observed_max_from_partonlevel_lep_e_mu_tau("lep", "e", "mu", "tau");
  determination_n_observed_min_from_partonlevel_lep_e_mu_tau("lm", "em", "mum", "taum");
  determination_n_observed_max_from_partonlevel_lep_e_mu_tau("lm", "em", "mum", "taum");
  determination_n_observed_min_from_partonlevel_lep_e_mu_tau("lp", "ep", "mup", "taup");
  determination_n_observed_max_from_partonlevel_lep_e_mu_tau("lp", "ep", "mup", "taup");
  determination_n_observed_max_from_partonlevel_lep_lm_lp("e", "em", "ep");
  determination_n_observed_min_from_partonlevel_lep_lm_lp("e", "em", "ep");
  determination_n_observed_max_from_partonlevel_lep_lm_lp("mu", "mum", "mup");
  determination_n_observed_min_from_partonlevel_lep_lm_lp("mu", "mum", "mup");
  determination_n_observed_max_from_partonlevel_lep_lm_lp("tau", "taum", "taup");
  determination_n_observed_min_from_partonlevel_lep_lm_lp("tau", "taum", "taup");

  determination_n_observed_max_from_partonlevel_lep_lm_lp("nua", "nu", "nux");
  determination_n_observed_min_from_partonlevel_lep_lm_lp("nua", "nu", "nux");
  determination_n_observed_min_from_partonlevel_lep_e_mu_tau("nua", "nea", "nma", "nta");
  determination_n_observed_max_from_partonlevel_lep_e_mu_tau("nua", "nea", "nma", "nta");
  determination_n_observed_min_from_partonlevel_lep_e_mu_tau("nu", "ne", "nm", "nt");
  determination_n_observed_max_from_partonlevel_lep_e_mu_tau("nu", "ne", "nm", "nt");
  determination_n_observed_min_from_partonlevel_lep_e_mu_tau("nux", "nex", "nmx", "ntx");
  determination_n_observed_max_from_partonlevel_lep_e_mu_tau("nux", "nex", "nmx", "ntx");
  determination_n_observed_max_from_partonlevel_lep_lm_lp("nea", "ne", "nex");
  determination_n_observed_min_from_partonlevel_lep_lm_lp("nea", "ne", "nex");
  determination_n_observed_max_from_partonlevel_lep_lm_lp("nma", "nm", "nmx");
  determination_n_observed_min_from_partonlevel_lep_lm_lp("nma", "nm", "nmx");
  determination_n_observed_max_from_partonlevel_lep_lm_lp("nta", "nt", "ntx");
  determination_n_observed_min_from_partonlevel_lep_lm_lp("nta", "nt", "ntx");

  determination_n_observed_min_from_partonlevel_lep_lm_lp("w", "wp", "wm");
  determination_n_observed_max_from_partonlevel_lep_lm_lp("w", "wp", "wm");
  determination_n_observed_min_from_partonlevel_lep_lm_lp("v", "w", "z");
  determination_n_observed_max_from_partonlevel_lep_lm_lp("v", "w", "z");
  determination_n_observed_min_from_partonlevel_lep_e_mu_tau("v", "z", "wp", "wm");
  determination_n_observed_max_from_partonlevel_lep_e_mu_tau("v", "z", "wp", "wm");

  logger << LOG_DEBUG << "AFTER  determination_object_observed_from_partonlevel  (event_set::output_object_list_no_access)" << endline << endline << output_object_list_no_access() << endline_flush;

  logger.finished();
}


void event_set::determination_n_observed_max_from_partonlevel_lep_lm_lp(string lep, string lm, string lp){
  static Logger logger("event_set::determination_n_observed_max_from_partonlevel_lep_lm_lp");
  logger.called();
  // n_observed_max  is used to apply vetoes on particles
  
  // adapt n_observed_max to parton-level particles (lep-lp/lm) !
  if (pda[observed_object[lep]].n_partonlevel < pda[observed_object[lep]].n_observed_max){pda[observed_object[lep]].n_observed_max = pda[observed_object[lep]].n_partonlevel;}
  // from top_qa-top-qtop :
  if (pda[observed_object[lp]].n_partonlevel < pda[observed_object[lp]].n_observed_max){pda[observed_object[lp]].n_observed_max = pda[observed_object[lp]].n_partonlevel;}
  if (pda[observed_object[lm]].n_partonlevel < pda[observed_object[lm]].n_observed_max){pda[observed_object[lm]].n_observed_max = pda[observed_object[lm]].n_partonlevel;}
  // (i.e. set  n_observed_max  to  n_partonlevel  for lep, lm and lp  if no veto is applied on respective particle)
  if (pda[observed_object[lep]].n_partonlevel == pda[observed_object[lep]].n_observed_max){
    // (i.e. if no veto is applied on  lep )
    // (do not reset anything if a veto is explicitly applied on  lm  or  lp )
    if (pda[observed_object[lm]].n_observed_max > pda[observed_object[lm]].n_partonlevel){pda[observed_object[lm]].n_observed_max = pda[observed_object[lm]].n_partonlevel;}
    if (pda[observed_object[lp]].n_observed_max > pda[observed_object[lp]].n_partonlevel){pda[observed_object[lp]].n_observed_max = pda[observed_object[lp]].n_partonlevel;}
  }
  else if (pda[observed_object[lp]].n_partonlevel == 0){
    // (i.e. if a veto on  lep  is applied and there is no  lp  at parton level -> apply the veto on  lep  also on  lm )
    if (pda[observed_object[lm]].n_observed_max < pda[observed_object[lep]].n_observed_max){pda[observed_object[lep]].n_observed_max = pda[observed_object[lm]].n_observed_max;}
    else {pda[observed_object[lm]].n_observed_max = pda[observed_object[lep]].n_observed_max;}
  }
  else if (pda[observed_object[lm]].n_partonlevel == 0){
    // (i.e. if a veto on  lep  is applied and there is no  lm  at parton level -> apply the veto on  lep  also on  lp )
    if (pda[observed_object[lp]].n_observed_max < pda[observed_object[lep]].n_observed_max){pda[observed_object[lep]].n_observed_max = pda[observed_object[lp]].n_observed_max;}
    else {pda[observed_object[lp]].n_observed_max = pda[observed_object[lep]].n_observed_max;}
  }
  else {
    // (i.e. if a veto on lep is applied and both lp and lm exist on parton level -> reduce n_observed_max to parton content for lp and lm if there is no explicit veto)
    // (imported from top_qa-top-atop) -> performed in any case now
    //    if (pda[observed_object[lp]].n_partonlevel < pda[observed_object[lp]].n_observed_max){pda[observed_object[lp]].n_observed_max = pda[observed_object[lp]].n_partonlevel;}
    //    if (pda[observed_object[lm]].n_partonlevel < pda[observed_object[lm]].n_observed_max){pda[observed_object[lm]].n_observed_max = pda[observed_object[lm]].n_partonlevel;}
  }
  // possible extension: combine vetos on lep, lm and lp to improve n_observed_max
  
  logger.finished();
}

    
void event_set::determination_n_observed_min_from_partonlevel_lep_lm_lp(string lep, string lm, string lp){
  static Logger logger("event_set::determination_n_observed_min_from_partonlevel_lep_lm_lp");
  logger.called();

  // adapt n_observed_min to parton-level particles (lep-lp/lm) !
  if (pda[observed_object[lep]].n_partonlevel == pda[observed_object[lep]].n_observed_min){
    //  (i.e. if  lep  needs to be filled with all available partons entering  lep  -> raise  n_observed_min  for  lm  and  lp  accordingly)  
    if (pda[observed_object[lm]].n_observed_min < pda[observed_object[lm]].n_partonlevel){pda[observed_object[lm]].n_observed_min = pda[observed_object[lm]].n_partonlevel;}
    if (pda[observed_object[lp]].n_observed_min < pda[observed_object[lp]].n_partonlevel){pda[observed_object[lp]].n_observed_min = pda[observed_object[lp]].n_partonlevel;}
  }
  else if (pda[observed_object[lp]].n_partonlevel == 0){
    // (i.e. identify  n_observed_min  for  lep  and  lm  if no  lp  exists at parton level) 
    if (pda[observed_object[lm]].n_observed_min > pda[observed_object[lep]].n_observed_min){pda[observed_object[lep]].n_observed_min = pda[observed_object[lm]].n_observed_min;}
    else {pda[observed_object[lm]].n_observed_min = pda[observed_object[lep]].n_observed_min;}
  }
  else if (pda[observed_object[lm]].n_partonlevel == 0){
    // (i.e. identify  n_observed_min  for  lep  and  lp  if no  lm  exists at parton level) 
    if (pda[observed_object[lp]].n_observed_min > pda[observed_object[lep]].n_observed_min){pda[observed_object[lep]].n_observed_min = pda[observed_object[lp]].n_observed_min;}
    else {pda[observed_object[lp]].n_observed_min = pda[observed_object[lep]].n_observed_min;}
  }
  // (if n_observed_min > n_partonlevel  for  lep ,  lm  or  lp , the result is set to zero anyway, so no further modification is required.
  
  logger.finished();
}

    
void event_set::determination_n_observed_max_from_partonlevel_lep_e_mu_tau(string lep, string e, string mu, string tau){
  static Logger logger("event_set::determination_n_observed_max_from_partonlevel_lep_e_mu_tau");
  logger.called();

  // adapt n_observed_max to parton-level particles (lep-e/mu/tau) !
  if (pda[observed_object[lep]].n_partonlevel == pda[observed_object[lep]].n_observed_max){
    // (i.e. set  n_observed_max  to  n_partonlevel  for  e ,  mu  and  tau  if no veto is applied on respective particle (already done beforehand for  lep ))
    // (do not reset anything if a veto is explicitly applied on  e ,  mu  or  tau )
    if (pda[observed_object[e]].n_observed_max > pda[observed_object[e]].n_partonlevel){pda[observed_object[e]].n_observed_max = pda[observed_object[e]].n_partonlevel;}
    if (pda[observed_object[mu]].n_observed_max > pda[observed_object[mu]].n_partonlevel){pda[observed_object[mu]].n_observed_max = pda[observed_object[mu]].n_partonlevel;}
    if (pda[observed_object[tau]].n_observed_max > pda[observed_object[tau]].n_partonlevel){pda[observed_object[tau]].n_observed_max = pda[observed_object[tau]].n_partonlevel;}
  }
  else if ((pda[observed_object[e]].n_partonlevel == 0) && (pda[observed_object[mu]].n_partonlevel == 0)){
    // (i.e. if a veto on  lep  is applied and there is neither  e  nor  mu  at parton level -> apply the veto on  lep  also on  tau )
    if (pda[observed_object[tau]].n_observed_max < pda[observed_object[lep]].n_observed_max){pda[observed_object[lep]].n_observed_max = pda[observed_object[tau]].n_observed_max;}
    else {pda[observed_object[tau]].n_observed_max = pda[observed_object[lep]].n_observed_max;}
  }
  else if ((pda[observed_object[e]].n_partonlevel == 0) && (pda[observed_object[tau]].n_partonlevel == 0) && (pda[observed_object[mu]].n_observed_max > pda[observed_object[lep]].n_observed_max)){
    // (i.e. if a veto on  lep  is applied and there is neither  e  nor  tau  at parton level -> apply the veto on  lep  also on  mu )
    if (pda[observed_object[mu]].n_observed_max < pda[observed_object[lep]].n_observed_max){pda[observed_object[lep]].n_observed_max = pda[observed_object[mu]].n_observed_max;}
    else {pda[observed_object[mu]].n_observed_max = pda[observed_object[lep]].n_observed_max;}
  }
  else if ((pda[observed_object[mu]].n_partonlevel == 0) && (pda[observed_object[tau]].n_partonlevel == 0) && (pda[observed_object[e]].n_observed_max > pda[observed_object[lep]].n_observed_max)){
    // (i.e. if a veto on  lep  is applied and there is neither  mu  nor  tau  at parton level -> apply the veto on  lep  also on  e )
    if (pda[observed_object[e]].n_observed_max < pda[observed_object[lep]].n_observed_max){pda[observed_object[lep]].n_observed_max = pda[observed_object[e]].n_observed_max;}
    else {pda[observed_object[e]].n_observed_max = pda[observed_object[lep]].n_observed_max;}
  }
  else if ((pda[observed_object[e]].n_partonlevel == 0) && (pda[observed_object[mu]].n_observed_max + pda[observed_object[tau]].n_observed_max < pda[observed_object[lep]].n_observed_max)){
    // (i.e. if a veto on  lep  is applied and only no  e  at parton level -> make the veto on  lep  stronger if corresponding vetoes are explicitly applied also on  mu  and  tau )
    pda[observed_object[lep]].n_observed_max = pda[observed_object[mu]].n_observed_max + pda[observed_object[tau]].n_observed_max;
  }
  else if ((pda[observed_object[mu]].n_partonlevel == 0) && (pda[observed_object[e]].n_observed_max + pda[observed_object[tau]].n_observed_max < pda[observed_object[lep]].n_observed_max)){
    // (i.e. if a veto on  lep  is applied and only no  mu  at parton level -> make the veto on  lep  stronger if corresponding vetoes are explicitly applied also on  e  and  tau )
    pda[observed_object[lep]].n_observed_max = pda[observed_object[e]].n_observed_max + pda[observed_object[tau]].n_observed_max;
  }
  else if ((pda[observed_object[tau]].n_partonlevel == 0) && (pda[observed_object[e]].n_observed_max + pda[observed_object[mu]].n_observed_max < pda[observed_object[lep]].n_observed_max)){
    // (i.e. if a veto on  lep  is applied and only no  tau  at parton level -> make the veto on  lep  stronger if corresponding vetoes are explicitly applied also on  e  and  mu )
    pda[observed_object[lep]].n_observed_max = pda[observed_object[e]].n_observed_max + pda[observed_object[mu]].n_observed_max;
  }

  logger.finished();
}

    
void event_set::determination_n_observed_min_from_partonlevel_lep_e_mu_tau(string lep, string e, string mu, string tau){
  static Logger logger("event_set::determination_n_observed_min_from_partonlevel_lep_e_mu_tau");
  logger.called();

  // adapt n_observed_min to parton-level particles (lep-e/mu/tau) !
  if (pda[observed_object[lep]].n_partonlevel == pda[observed_object[lep]].n_observed_min){
    //  (i.e. if  lep  needs to be filled with all available partons entering  lep  -> raise  n_observed_min  for  e ,  mu  and  tau  accordingly)  
    if (pda[observed_object[e]].n_observed_min < pda[observed_object[e]].n_partonlevel){pda[observed_object[e]].n_observed_min = pda[observed_object[e]].n_partonlevel;}
    if (pda[observed_object[mu]].n_observed_min < pda[observed_object[mu]].n_partonlevel){pda[observed_object[mu]].n_observed_min = pda[observed_object[mu]].n_partonlevel;}
    if (pda[observed_object[tau]].n_observed_min < pda[observed_object[tau]].n_partonlevel){pda[observed_object[tau]].n_observed_min = pda[observed_object[tau]].n_partonlevel;}
  }
  else if ((pda[observed_object[e]].n_partonlevel == 0) && (pda[observed_object[mu]].n_partonlevel == 0)){
    // (i.e. identify  n_observed_min  for  lep  and  tau  if neither  e  nor  mu  exist at parton level) 
     if (pda[observed_object[tau]].n_observed_min > pda[observed_object[lep]].n_observed_min){pda[observed_object[lep]].n_observed_min = pda[observed_object[tau]].n_observed_min;}
    else {pda[observed_object[tau]].n_observed_min = pda[observed_object[lep]].n_observed_min;}
  }
  else if ((pda[observed_object[e]].n_partonlevel == 0) && (pda[observed_object[tau]].n_partonlevel == 0) && (pda[observed_object[mu]].n_observed_min > pda[observed_object[lep]].n_observed_min)){
    // (i.e. identify  n_observed_min  for  lep  and  mu  if neither  e  nor  tau  exist at parton level) 
    if (pda[observed_object[mu]].n_observed_min > pda[observed_object[lep]].n_observed_min){pda[observed_object[lep]].n_observed_min = pda[observed_object[mu]].n_observed_min;}
    else {pda[observed_object[mu]].n_observed_min = pda[observed_object[lep]].n_observed_min;}
  }
  else if ((pda[observed_object[mu]].n_partonlevel == 0) && (pda[observed_object[tau]].n_partonlevel == 0) && (pda[observed_object[e]].n_observed_min > pda[observed_object[lep]].n_observed_min)){
    // (i.e. identify  n_observed_min  for  lep  and  e  if neither  mu  nor  tau  exist at parton level) 
    if (pda[observed_object[e]].n_observed_min > pda[observed_object[lep]].n_observed_min){pda[observed_object[lep]].n_observed_min = pda[observed_object[e]].n_observed_min;}
    else {pda[observed_object[e]].n_observed_min = pda[observed_object[lep]].n_observed_min;}
  }
  else if ((pda[observed_object[e]].n_partonlevel == 0) && (pda[observed_object[mu]].n_observed_min + pda[observed_object[tau]].n_observed_min > pda[observed_object[lep]].n_observed_min)){
    // (i.e. if a minimumum number of  lep  is applied and only no  e  at parton level -> make request on  lep  stronger if corresponding requests are explicitly applied also on  mu  and  tau )
    pda[observed_object[lep]].n_observed_min = pda[observed_object[mu]].n_observed_min + pda[observed_object[tau]].n_observed_min;
  }
  else if ((pda[observed_object[mu]].n_partonlevel == 0) && (pda[observed_object[e]].n_observed_min + pda[observed_object[tau]].n_observed_min > pda[observed_object[lep]].n_observed_min)){
    // (i.e. if a minimumum number of  lep  is applied and only no  mu  at parton level -> make request on  lep  stronger if corresponding requests are explicitly applied also on  e  and  tau )
    pda[observed_object[lep]].n_observed_min = pda[observed_object[e]].n_observed_min + pda[observed_object[tau]].n_observed_min;
  }
  else if ((pda[observed_object[tau]].n_partonlevel == 0) && (pda[observed_object[e]].n_observed_min + pda[observed_object[mu]].n_observed_min > pda[observed_object[lep]].n_observed_min)){
    // (i.e. if a minimumum number of  lep  is applied and only no  tau  at parton level -> make request on  lep  stronger if corresponding requests are explicitly applied also on  e  and  mu )
    pda[observed_object[lep]].n_observed_min = pda[observed_object[e]].n_observed_min + pda[observed_object[mu]].n_observed_min;
  }

  logger.finished();
}

    
