#include "header.hpp"

string event_set::output_object_list_no_access(){
  static Logger logger("event_set::output_object_list_no_access");
  logger.called();

  stringstream temp_ss;
  temp_ss << "Content of  object_list  with corresponding content of  pda" << endline;
  temp_ss << endline;
  temp_ss << setw(5) << left << "index" << "   " << left << setw(10) << "object" << right << setw(10) << "n_min" << setw(10) << "n_max" << setw(10) << "pT" << setw(10) << "ET" << setw(10) << "|eta|"  << setw(10) << "|y|" << setw(20) << "is_user_defined" << endline;
  for (int i_o = 1; i_o < object_list.size(); i_o++){
    temp_ss << setw(5) << right << i_o << "   " << left << setw(10) << object_list[i_o] << right << setw(10) << pda[i_o].n_observed_min << setw(10) << pda[i_o].n_observed_max << setw(10) << pda[i_o].define_pT << setw(10) << pda[i_o].define_ET << setw(10) << pda[i_o].define_eta << setw(10) << pda[i_o].define_y << setw(20) << pda[i_o].is_user_defined << endline;
  }

  if (Log::getLogThreshold() <= LOG_DEBUG_VERBOSE){ logger << LOG_DEBUG_VERBOSE << "return " << temp_ss.str() << endline_flush; }
  logger.finished();
  return temp_ss.str();
}


string event_set::output_object_list(){
  static Logger logger("event_set::output_object_list");
  logger.called();

  stringstream temp_ss;
  temp_ss << "Content of  object_list  with corresponding content of  pda  as well as  access_object ,  observed_object  and  access_object_selection" << endline;
  temp_ss << endline;
  temp_ss << setw(5) << left << "index" << "   " << left << setw(10) << "object" << right << setw(10) << "n_min" << setw(10) << "n_max" << setw(10) << "pT" << setw(10) << "ET" << setw(10) << "|eta|"  << setw(10) << "|y|" << setw(20) << "access_object" << setw(20) << "observed_object" << setw(25) << "access_object_selection" << setw(20) << "is_user_defined" << endline;
  for (int i_o = 1; i_o < object_list.size(); i_o++){
    temp_ss << setw(5) << right << i_o << "   " << left << setw(10) << object_list[i_o] << right << setw(10) << pda[i_o].n_observed_min << setw(10) << pda[i_o].n_observed_max << setw(10) << pda[i_o].define_pT << setw(10) << pda[i_o].define_ET << setw(10) << pda[i_o].define_eta << setw(10) << pda[i_o].define_y << setw(20) << access_object[object_list[i_o]] << setw(20) << observed_object[object_list[i_o]] << setw(25) << access_object_selection[object_list[i_o]] << setw(20) << pda[i_o].is_user_defined << endline;
  }

  if (Log::getLogThreshold() <= LOG_DEBUG_VERBOSE){ logger << LOG_DEBUG_VERBOSE << "return " << temp_ss.str() << endline_flush; }
  logger.finished();
  return temp_ss.str();
}


string event_set::output_object_list_selection(){
  static Logger logger("event_set::output_object_list_selection");
  logger.called();

  stringstream temp_ss;
  temp_ss << "Content of   object_list_selection  with corresponding content of  pds  and  access_object_selection" << endline;
  temp_ss << endline;
  temp_ss << setw(5) << left << "index" << "   " << left << setw(10) << "object" << right << setw(10) << "n_min" << setw(10) << "n_max" << setw(10) << "pT" << setw(10) << "ET" << setw(10) << "|eta|"  << setw(10) << "|y|" << setw(25) << "access_object_selection" << endline;
  temp_ss << endline;
  for (int i_os = 0; i_os < object_list_selection.size(); i_os++){
    temp_ss << setw(5) << right << i_os << "   " << left << setw(10) << object_list_selection[i_os] << right << setw(10) << pds[i_os].n_observed_min << setw(10) << pds[i_os].n_observed_max << setw(10) << pds[i_os].define_pT << setw(10) << pds[i_os].define_ET << setw(10) << pds[i_os].define_eta << setw(10) << pds[i_os].define_y << setw(25) << access_object_selection[object_list_selection[i_os]] << endline;
  }

  if (Log::getLogThreshold() <= LOG_DEBUG_VERBOSE){ logger << LOG_DEBUG_VERBOSE << "return " << temp_ss.str() << endline_flush; }
  logger.finished();
  return temp_ss.str();
}


string event_set::output_equivalent_object(){
  static Logger logger("event_set::output_equivalent_object");
  logger.called();

  stringstream temp_ss;
  temp_ss << "Content of   equivalent_object (equivalent_index) : object (i_o) -> object_list_selection (i_os)" << endline;
  temp_ss << endline;
  for (int i_o = 1; i_o < object_list.size(); i_o++){
    temp_ss << left << setw(10) << object_list[i_o] << " (" << right << setw(2) << i_o << ") -> " << left << setw(10) << equivalent_object[object_list[i_o]] << " (" << right << setw(2) << equivalent_index[i_o] << ")" << endline;
  }

  if (Log::getLogThreshold() <= LOG_DEBUG_VERBOSE){ logger << LOG_DEBUG_VERBOSE << "return " << temp_ss.str() << endline_flush; }
  logger.finished();
  return temp_ss.str();
}


string event_set::output_equivalent_inverse_object(){
  static Logger logger("event_set::output_equivalent_inverse_object");
  logger.called();

  stringstream temp_ss;
  temp_ss << "Content of   equivalent_inverse_object (equivalent_inverse_index) : object_list_selection (i_os) -> object (i_o)" << endline;
  temp_ss << endline;
  for (int i_os = 1; i_os < object_list_selection.size(); i_os++){
    temp_ss << left << setw(10) << object_list_selection[i_os] << " (" << right << setw(2) << i_os << ") -> ";
    for (int i_eo = 0; i_eo < equivalent_inverse_object[object_list_selection[i_os]].size(); i_eo++){
      temp_ss << left << setw(10) << equivalent_inverse_object[object_list_selection[i_os]][i_eo] << " (" << right << setw(2) << equivalent_inverse_index[i_os][i_eo] << ")   ";
    }
    temp_ss << endline;
  }

  if (Log::getLogThreshold() <= LOG_DEBUG_VERBOSE){ logger << LOG_DEBUG_VERBOSE << "return " << temp_ss.str() << endline_flush; }
  logger.finished();
  return temp_ss.str();
}


string event_set::output_index_group_all_parton(){
  static Logger logger("event_set::output_index_group_all_parton");
  logger.called();

  stringstream temp_ss;
  temp_ss << "Content of   index_group_all_parton" << endline;
  temp_ss << endline;
  temp_ss << setw(5) << right << "no" << setw(10) << "object" << setw(10) << "n_part" << setw(5) << "" << "partons that can enter respective object (phase-space dependent)" << endline;
  for (int i_os = 0; i_os < object_list_selection.size(); i_os++){
    temp_ss << setw(5) << right << i_os << setw(10) << object_list_selection[i_os] << setw(10) << pds[i_os].n_partonlevel << setw(5) << "";
    for (int i_a = 0; i_a < csi->n_ps; i_a++){
      for (int i_j = 0; i_j < index_group_all_parton[i_a][i_os].size(); i_j++){
	temp_ss << setw(1) << index_group_all_parton[i_a][i_os][i_j] << " ";
      }
      if (i_a < csi->n_ps - 1){temp_ss << "- ";}
    }
    temp_ss << endline;
  }

  if (Log::getLogThreshold() <= LOG_DEBUG_VERBOSE){ logger << LOG_DEBUG_VERBOSE << "return " << temp_ss.str() << endline_flush; }
  logger.finished();
  return temp_ss.str();
}


string event_set::output_index_group_original(){
  static Logger logger("event_set::output_index_group_original");
  logger.called();

  stringstream temp_ss;
  temp_ss << "Content of   index_group_original (with corresponding group names)" << endline;
  temp_ss << endline;
  for (int i_j = 0; i_j < index_group_original.size(); i_j++){
    temp_ss << right << setw(2) << index_group_original[i_j] << " -> " << setw(10) << left << object_list_selection[index_group_original[i_j]] << endline;
  }
  //  temp_ss << endline;

  if (Log::getLogThreshold() <= LOG_DEBUG_VERBOSE){ logger << LOG_DEBUG_VERBOSE << "return " << temp_ss.str() << endline_flush; }
  logger.finished();
  return temp_ss.str();
}


string event_set::output_index_group_jet(){
  static Logger logger("event_set::output_index_group_jet");
  logger.called();

  stringstream temp_ss;
  temp_ss << "Content of   index_group_jet (with corresponding group names)" << endline;
  temp_ss << endline;
  for (int i_j = 0; i_j < index_group_jet.size(); i_j++){
    temp_ss << right << setw(2) << index_group_jet[i_j] << " -> " << setw(10) << left << object_list_selection[index_group_jet[i_j]] << endline;
  }
  //  temp_ss << endline;

  if (Log::getLogThreshold() <= LOG_DEBUG_VERBOSE){ logger << LOG_DEBUG_VERBOSE << "return " << temp_ss.str() << endline_flush; }
  logger.finished();
  return temp_ss.str();
}


string event_set::output_particle_definition(){
  static Logger logger("event_set::output_particle_definition");
  logger.called();

  stringstream temp_ss;
  for (int i_o = 0; i_o < object_list.size() - 1; i_o++){
    if (pda[i_o].is_restricted || pda[i_o].is_restricted_n || pda[i_o].is_user_defined){temp_ss << pda[i_o] << endline;}
  }

  if (Log::getLogThreshold() <= LOG_DEBUG_VERBOSE){ logger << LOG_DEBUG_VERBOSE << "return " << temp_ss.str() << endline_flush; }
  logger.finished();
  return temp_ss.str();
}


string event_set::output_particle_definition_selection(){
  static Logger logger("event_set::output_particle_definition_selection");
  logger.called();

  stringstream temp_ss;
  temp_ss << "Particle definition selection" << endline;
  for (int i_os = 0; i_os < object_list_selection.size(); i_os++){
    if (pds[i_os].is_restricted || pds[i_os].is_restricted_n){temp_ss << right << setw(2) << i_os << "   " << pds[i_os] << endline;}
  }

  if (Log::getLogThreshold() <= LOG_DEBUG_VERBOSE){ logger << LOG_DEBUG_VERBOSE << "return " << temp_ss.str() << endline_flush; }
  logger.finished();
  return temp_ss.str();
}


string event_set::output_list_fiducialcut(){
  static Logger logger("event_set::output_list_fiducialcut");
  logger.called();

  stringstream temp_ss;
  temp_ss << "List of general fiducial cuts:" << endline;
  temp_ss << endline;
  for (int i_f = 0; i_f < fiducial_cut.size(); i_f++){
    stringstream temp_ss_fc;
    temp_ss_fc << "fiducial_cut[" << setw(2) << i_f << "]";
    string temp_s_fc = temp_ss_fc.str();
    temp_ss << temp_s_fc << " = " << fiducial_cut[i_f].output_fiducialcut(temp_s_fc.size());
    //    = " << fiducial_cut[i_f];
  }

  if (Log::getLogThreshold() <= LOG_DEBUG_VERBOSE){ logger << LOG_DEBUG_VERBOSE << "return " << temp_ss.str() << endline_flush; }
  logger.finished();
  return temp_ss.str();
}


string event_set::output_index_group_parton(){
  static Logger logger("event_set::output_index_group_parton");
  logger.called();

  stringstream temp_ss;
  temp_ss << "Content of several  index_group_..._parton variables (partons (by in index in respective phase space) -> particle group)" << endline;
  temp_ss << endline;
  temp_ss << right << setw(11) << "phase space" << "   " << left << setw(15) << "photon" << "   " << setw(15) << "photon" << "   " << setw(15) << "jet" << "   " << setw(15) << "missing" << "   " << setw(15) << "subtraction" << "   " << setw(15) << "subtraction" << endline_flush;
  temp_ss << right << setw(11) << "" << "   " << left << setw(15) << "" << "   " << setw(15) << "recombination" << "   " << setw(15) << "algorithm" << "   " << setw(15) << "" << "   " << setw(15) << "QCD" << "   " << setw(15) << "QEW" << endline;
  for (int i_a = 0; i_a < csi->n_ps; i_a++){
    stringstream temp_ph;
    for (int i_i = 0; i_i < index_group_photon_parton[i_a].size(); i_i++){
      temp_ph << index_group_photon_parton[i_a][i_i];
      if (i_i < index_group_photon_parton[i_a].size() - 1){temp_ph << "  ";}
    }
    stringstream temp_pr;
    for (int i_i = 0; i_i < index_group_recombination_parton[i_a].size(); i_i++){
      temp_pr << index_group_recombination_parton[i_a][i_i];
      if (i_i < index_group_recombination_parton[i_a].size() - 1){temp_pr << "  ";}
    }
    stringstream temp_ja;
    for (int i_i = 0; i_i < index_group_protojet_parton[i_a].size(); i_i++){
      temp_ja << index_group_protojet_parton[i_a][i_i];
      if (i_i < index_group_protojet_parton[i_a].size() - 1){temp_ja << "  ";}
    }
    stringstream temp_mi;
    for (int i_i = 0; i_i < index_group_missing_parton[i_a].size(); i_i++){
      temp_mi << index_group_missing_parton[i_a][i_i];
      if (i_i < index_group_missing_parton[i_a].size() - 1){temp_mi << "  ";}
    }
    stringstream temp_qcd;
    for (int i_i = 0; i_i < ps_runtime_subtraction_QCD[i_a].size(); i_i++){
      temp_qcd << ps_runtime_subtraction_QCD[i_a][i_i];
      if (i_i < ps_runtime_subtraction_QCD[i_a].size() - 1){temp_qcd << "  ";}
    }
    stringstream temp_qew;
    for (int i_i = 0; i_i < ps_runtime_subtraction_QEW[i_a].size(); i_i++){
      temp_qew << ps_runtime_subtraction_QEW[i_a][i_i];
      if (i_i < ps_runtime_subtraction_QEW[i_a].size() - 1){temp_qew << "  ";}
    }
    temp_ss << right << setw(11) << i_a << "   " << left << setw(15) << temp_ph.str() << "   " << setw(15) << temp_pr.str() << "   " << setw(15) << temp_ja.str() << "   " << setw(15) << temp_mi.str() << "   " << setw(15) << temp_qcd.str() << "   " << setw(15) << temp_qew.str() << endline;
  }

  if (Log::getLogThreshold() <= LOG_DEBUG_VERBOSE){ logger << LOG_DEBUG_VERBOSE << "return " << temp_ss.str() << endline_flush; }
  logger.finished();
  return temp_ss.str();
}


void event_set::output_runtime_object(){
  static Logger logger("event_set::output_runtime_object");
  logger.called();

  logger << LOG_DEBUG << "Relevant objects:   runtime_order   collects partons that belong to the respective object class." << endline_flush;

  for (int i = 0; i < object_list_selection.size(); i++){
    stringstream sstemp;
    for (int j = 0; j < runtime_order[i].size(); j++){sstemp << setw(3) << runtime_order[i][j] << "[" << setw(6) << csi->type_parton[0][runtime_order[i][j]] << "]";}
    logger << LOG_DEBUG << setw(10) << object_list_selection[i] << " -> " << sstemp.str() << endline_flush;
  }
  logger.newLine(LOG_DEBUG);

  logger << LOG_DEBUG << "Relevant objects:   runtime_order_inverse   collects object classes a parton belongs to." << endline_flush;

  for (int i = 3; i < csi->type_parton[0].size(); i++){
    stringstream sstemp;
    for (int j = 0; j < runtime_order_inverse[i].size(); j++){sstemp << setw(10) << object_list_selection[runtime_order_inverse[i][j]] << " [" << setw(3) << runtime_order_inverse[i][j] << "]";}
    logger << LOG_DEBUG << "pa[" << setw(3) << i << "] = " << setw(5) << csi->type_parton[0][i] << " -> " << sstemp.str() << endline_flush;
  }
  logger.newLine(LOG_DEBUG);

  logger.finished();
}


void event_set::output_phasespacepoints_check_selection(){
  static Logger logger("event_set::output_phasespacepoints_check_selection");
  logger.called();

  ofstream out_point_OL;
  static int counter = 0;
  static string filename_point_OL = "list.phasespacepoints.check.selection." + csi->subprocess + ".dat";
  logger << LOG_DEBUG << "filename_point_OL = " << filename_point_OL << endline_flush;
  static bool initialization = true;
  if (initialization){
    out_point_OL.open(filename_point_OL.c_str(), ofstream::out | ofstream::trunc);
    initialization = false;
  }
  else {
    out_point_OL.open(filename_point_OL.c_str(), ofstream::out | ofstream::app);
  }
  
  if (cut_ps[0] != -1){counter++;}
  if (csi->process_class == "pp-emmupvmve~bb~+X"){
    // Output for grid production
    for (int i_p = 1; i_p < p_parton[0].size(); i_p++){
      if (i_p > 2 && i_p < 7){continue;}
      out_point_OL << setw(23) << showpoint << setprecision(15) << p_parton[0][i_p].x0() << "  "
		   << setw(23) << showpoint << setprecision(15) << p_parton[0][i_p].x1() << "  "
		   << setw(23) << showpoint << setprecision(15) << p_parton[0][i_p].x2() << "  "
		   << setw(23) << showpoint << setprecision(15) << p_parton[0][i_p].x3() << "  ";
    }
    out_point_OL << endline;
  }
  else if (csi->process_class == "pp-emve~a+X"){
    // Output for grid production
    for (int i_p = 1; i_p < p_parton[0].size(); i_p++){
      if (i_p > 2 && i_p < 6){continue;}
      out_point_OL << setw(23) << showpoint << setprecision(15) << p_parton[0][i_p].x0() << "  "
		   << setw(23) << showpoint << setprecision(15) << p_parton[0][i_p].x1() << "  "
		   << setw(23) << showpoint << setprecision(15) << p_parton[0][i_p].x2() << "  "
		   << setw(23) << showpoint << setprecision(15) << p_parton[0][i_p].x3() << "  ";
    }
    out_point_OL << endline;
  }
  else {
    out_point_OL << "! no_psp_gen = " << right << setw(7) << psi->i_gen << "   (" << setw(7) << counter << " passed)" << endline;
    for (int i_p = 1; i_p < event_original[0][0].size(); i_p++){
      int x_p = i_p;
      if (i_p == 2){x_p = 1;}
      else if (i_p == 1){x_p = 2;}
      out_point_OL << left << "p(:," << i_p << ") = (/ "
		   << setw(23) << showpoint << setprecision(15) << event_original[0][0][x_p].momentum.x1() << ", "
		   << setw(23) << showpoint << setprecision(15) << event_original[0][0][x_p].momentum.x2() << ", "
		   << setw(23) << showpoint << setprecision(15) << event_original[0][0][x_p].momentum.x3() << ", "
		   << setw(23) << showpoint << setprecision(15) << event_original[0][0][x_p].momentum.x0() << " /)" <<endline;
    }
    if (cut_ps[0] == -1){
      out_point_OL << "ipass = 0" << endline;
      out_point_OL << "ME2 = " << setw(23) << showpoint << setprecision(15) << 0. << endline;
      out_point_OL << endline;
    }
    else {
      out_point_OL << "ipass = 1" << endline;

    }
    //    out_point_OL << endline;
  }  
  out_point_OL.close();

  logger.finished();
}


