#include "header.hpp"

void munich::integration_CA_QCD(){
  static Logger logger("munich::integration_CA_QCD");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  initialization_integration();
  asi->calculate_ME2check_CA_QCD();
  initialization_integration_check();

  while (osi->int_end == 0){
    rsi.perform_iteration_step();
    if (osi->int_end == 1){break;}
    psi->calculate_IS();
    if (!psi->identical_psp){
      psi->ac_psp(0, psi->MC_phasespace.channel);
      esi->determine_p_parton();
      if (munich_isnan(esi->p_parton)){errorhandling_c_psp(); continue;}
    }
    esi->perform_event_selection();
    if (esi->cut_ps[0] == -1){psi->handling_cut_psp(); continue;}
    if (osi->switch_console_output_tau_0){psi->output_check_tau_0();}
    psi->calculate_initial_collinear_z1z2_IS();
    if (osi->switch_output_testpoint){osi->output_testpoint_input();}
    if (!psi->identical_psp){psi->ag_psp(0, 0);}
    psi->calculate_g_tot();
    if (munich_isinfnan(psi->g_tot)){errorhandling_gtot(); continue;}
    if (!psi->identical_psp){
      asi->calculate_ME2_CA_QCD();
      if (munich_isnan(osi->CA_ME2_cf)){errorhandling_collinear_me2(); continue;}
    }
    // Count g_tot = inf as nancut or cut ???
    if (munich_isinf(psi->g_tot)){psi->handling_cut_psp(); continue;}
    if (csi->class_contribution_qTcut_explicit){esi->qT_basic->counter_acc_qTcut[esi->cut_ps[0]]++;}
    // why evaluated after ME2 here ???
    if (!(osi->check_vanishing_ME2_end)){handling_vanishing_me2(); if (osi->flag_vanishing_ME2){continue;}}
    osi->determine_scale_complete();
    if (osi->switch_moment){osi->moments();}
    if (osi->switch_CV){osi->calculate_pdf_LHAPDF_CA_collinear_CV();}
    if (osi->switch_TSV){osi->calculate_pdf_LHAPDF_list_TSV();}
    osi->calculate_collinear_QCD();
    if (osi->switch_CV){osi->determine_integrand_CA();}
    if (osi->switch_output_maxevent){osi->output_integrand_maximum_CA();}
    if (munich_isnan(osi->integrand)){errorhandling_collinear_me2(); continue;}
    if (osi->switch_TSV){osi->determine_psp_weight_TSV();}
    osi->determine_psp_weight();
    if (osi->switch_distribution){osi->determine_distribution_complete();}
    if (osi->switch_optimization_modifier){osi->calculate_optimization_modifier();}
    psi->psp_optimization_complete(osi->integrand, osi->this_psp_weight, osi->this_psp_weight2, osi->optimization_modifier);
    psi->i_acc++; psi->i_acc_step++;
    if (csi->n_particle == 1){psi->identical_psp = true;}
    osi->determine_runtime();
  }
  osi->output_finalization_integration();

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}
