#include "header.hpp"

void munich::integration_PT2_QCD(){
  static Logger logger("munich::integration_PT2_QCD");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  initialization_integration();
  //  asi->calculate_ME2check_CT2_QCD();
  initialization_integration_check();
  
  while (osi->int_end == 0){
    rsi.perform_iteration_step();
    if (osi->int_end == 1){break;}
    psi->calculate_IS();
    psi->calculate_initial_collinear_z1z2_IS();
    psi->calculate_IS_QT_phi();
    if (psi->recoil_rcut == -1){psi->handling_cut_psp(); continue;}
    if (!psi->identical_psp){
      psi->ac_psp(0, psi->MC_phasespace.channel);
      esi->determine_p_parton();
      if (munich_isnan(esi->p_parton)){errorhandling_c_psp(); continue;}
    }
    if (user->switch_value[user->switch_map["recoil"]] == 1){esi->perform_QT_boost_cms();}
    else {esi->perform_QT_boost_recoil();}

    esi->perform_event_selection();

    // to reproduce counterterm ??? or to generate the grid ???
    //    if (user->switch_value[user->switch_map["PTmode"]] == 1){esi->cut_ps[1] = -1;}
    //    else if (user->switch_value[user->switch_map["PTmode"]] == -1){esi->cut_ps[0] = -1;}

    if (user->switch_value[user->switch_map["recoilinvariantscale"]] == 1){if (esi->cut_ps[0] == esi->cut_ps[1]){psi->handling_cut_psp(); continue;}}
    if (esi->cut_ps[0] == -1 && esi->cut_ps[1] == -1){psi->handling_cut_psp(); continue;}
    if (user->switch_value[user->switch_map["PTmode"]] == 2 && esi->cut_ps[0] > -1 && esi->cut_ps[1] == -1){psi->handling_cut_psp(); continue;}
    if (user->switch_value[user->switch_map["PTmode"]] == 3 && esi->cut_ps[0] == -1 && esi->cut_ps[1] > -1){psi->handling_cut_psp(); continue;}
 
    if (osi->switch_console_output_tau_0){psi->output_check_tau_0();}
    if (osi->switch_output_testpoint){osi->output_testpoint_input();}
    if (!psi->identical_psp){psi->ag_psp(0, 0);}
    psi->calculate_g_tot();
    if (munich_isinfnan(psi->g_tot)){errorhandling_gtot(); continue;}
    osi->determine_scale_complete();
    if (!psi->identical_psp){
      asi->calculate_ME2_CT2_QCD();
      osi->ME2 = osi->VA_b_ME2; // ???
      if (munich_isnan(osi->ME2)){errorhandling_me2(); continue;}
    }
    if (osi->switch_moment){osi->moments();}
    //    if (osi->switch_CV){osi->calculate_pdf_LHAPDF_list_pc_CV();}
    if (osi->switch_TSV){osi->calculate_pdf_LHAPDF_list_TSV();}
    osi->determine_integrand_CX_ncollinear_CT2_QCD();
    if (munich_isinfnan(osi->integrand)){errorhandling_me2(); continue;} // improve !!!
    if (osi->switch_TSV){osi->determine_psp_weight_TSV();}
    osi->determine_psp_weight_QT();
    if (osi->switch_output_maxevent){osi->output_integrand_maximum();}
    if (osi->switch_distribution){osi->determine_distribution_complete();}
    if (osi->switch_optimization_modifier){osi->calculate_optimization_modifier();}
    psi->psp_optimization_complete(osi->integrand, osi->this_psp_weight, osi->this_psp_weight2, osi->optimization_modifier);
    psi->i_acc++; psi->i_acc_step++;
    if (csi->n_particle == 1){psi->identical_psp = true;}
    osi->determine_runtime();
  }
  osi->output_finalization_integration();

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}
