#include "header.hpp"

manager_TSV::manager_TSV(){
  static Logger logger("manager_TSV::manager_TSV ()");
  logger.called();

  logger << LOG_DEBUG << "constructor called..." << endline_flush;

  logger.finished();
}

manager_TSV::manager_TSV(observable_set * _osi){
  static Logger logger("manager_TSV::manager_TSV (osi)");
  logger.called();

  logger << LOG_DEBUG << "constructor called..." << endline_flush;
  osi = _osi;

  logger.finished();
}

manager_TSV::~manager_TSV(){
  static Logger logger("manager_TSV::~manager_TSV ()");
  logger.called();

  logger << LOG_DEBUG << "destructor called..." << endline_flush;

  logger.finished();
}


void manager_TSV::initialization_basic_TSV(){
  static Logger logger("manager_TSV::initialization_basic_TSV (isi)");
  logger.called();

  switch_distribution_at_all_TSV = 0;

  /*
  if (!switch_TSV){n_set_TSV = 0;}
  if (!switch_TSV){logger << LOG_DEBUG << "switch_TSV = " << switch_TSV << " -> finished" << endline_flush; return;}
  */
  logger << LOG_DEBUG_VERBOSE << "switch_distribution_TSV.size() = " << switch_distribution_TSV.size() << endline_flush;
  logger << LOG_DEBUG_VERBOSE << "n_set_TSV = " << n_set_TSV << endline_flush;
  logger << LOG_DEBUG_VERBOSE << "n_extended_set_TSV = " << n_extended_set_TSV << endline_flush;

  for (int i_s = 0; i_s < n_set_TSV; i_s++){
    if (switch_distribution_TSV[i_s] > 0){switch_distribution_at_all_TSV = 1; break;}
  }

  logger << LOG_DEBUG_VERBOSE << "min_qTcut_TSV.size() = " << min_qTcut_TSV.size() << endline_flush;
  logger << LOG_DEBUG_VERBOSE << "max_qTcut_TSV.size() = " << max_qTcut_TSV.size() << endline_flush;
  logger << LOG_DEBUG_VERBOSE << "min_qTcut_distribution_TSV.size() = " << min_qTcut_distribution_TSV.size() << endline_flush;
  logger << LOG_DEBUG_VERBOSE << "max_qTcut_distribution_TSV.size() = " << max_qTcut_distribution_TSV.size() << endline_flush;
  
  for (int i_s = 0; i_s < n_set_TSV; i_s++){
    logger << LOG_DEBUG_VERBOSE << "[i_s] = " << i_s << endline_flush;
    if (min_qTcut_TSV[i_s] == empty_double){min_qTcut_TSV[i_s] = osi->min_qTcut;}
    logger << LOG_DEBUG_VERBOSE << "[i_s] = " << i_s << endline_flush;
    if (max_qTcut_TSV[i_s] == empty_double){max_qTcut_TSV[i_s] = osi->min_qTcut + osi->n_qTcut * osi->step_qTcut;}
    logger << LOG_DEBUG_VERBOSE << "[i_s] = " << i_s << endline_flush;
    if (min_qTcut_distribution_TSV[i_s] == empty_double){min_qTcut_distribution_TSV[i_s] = osi->min_qTcut;}
    logger << LOG_DEBUG_VERBOSE << "[i_s] = " << i_s << endline_flush;
    if (max_qTcut_distribution_TSV[i_s] == empty_double){max_qTcut_distribution_TSV[i_s] = osi->min_qTcut + osi->n_qTcut * osi->step_qTcut;}
    logger << LOG_DEBUG_VERBOSE << "[i_s] = " << i_s << endline_flush;
  }


  logger << LOG_DEBUG_VERBOSE << "n_extended_set_TSV = " << n_extended_set_TSV << endline_flush;
  // also needed for scale-difference contributions:
  // switch_distribution may not be set to 0 in summary routine !!!
  for (int i_s = 0; i_s < n_extended_set_TSV; i_s++){
    logger << LOG_DEBUG_VERBOSE << "switch_distribution_TSV[" << i_s << "] = " << switch_distribution_TSV[i_s] << endline_flush;
    if (switch_distribution_TSV[i_s] == empty_int){switch_distribution_TSV[i_s] = osi->switch_distribution;}
    if (switch_moment_TSV[i_s] == empty_int){switch_moment_TSV[i_s] = osi->n_moments;}

    if (switch_distribution_TSV[i_s] == 0){max_n_integrand_TSV[i_s] = 1;}
    else {max_n_integrand_TSV[i_s] = 3;}

    logger << LOG_DEBUG_VERBOSE << "switch_distribution_TSV[" << i_s << "] = " << switch_distribution_TSV[i_s] << endline_flush;
  }

  // initialization of scale-related quantities

  // central_scale_TSV
  // central_scale_ren_TSV
  // central_scale_fact_TSV
  // relative_central_scale_TSV
  // relative_central_scale_ren_TSV
  // relative_central_scale_fact_TSV
  // n_scale_TSV
  // n_scale_ren_TSV
  // n_scale_fact_TSV
  // factor_scale_TSV
  // factor_scale_ren_TSV
  // factor_scale_fact_TSV
  // dynamic_scale_TSV
  // dynamic_scale_ren_TSV
  // dynamic_scale_fact_TSV
  // no_central_scale_ren_TSV
  // no_central_scale_fact_TSV

  // max_n_scale_ren_TSV
  // max_n_scale_fact_TSV

  // relative_scale_ren_TSV
  // relative_scale_fact_TSV

  // n_dynamic_scale_TSV
  // switch_dynamic_scale_TSV


  for (int i_s = 0; i_s < n_set_TSV; i_s++){
    logger << LOG_DEBUG << "n_scale_TSV[" << i_s << "] = " << n_scale_TSV[i_s] << "   " << "n_scale_ren_TSV[" << i_s << "] = " << n_scale_ren_TSV[i_s] << endline_flush;

    if (n_scale_ren_TSV[i_s] == empty_int){n_scale_ren_TSV[i_s] = n_scale_TSV[i_s];}
    if (n_scale_ren_TSV[i_s] == empty_int){logger << LOG_FATAL << "n_scale_ren_TSV[" << i_s << "] has not been defined!" << endline_flush; exit(1);}
    if (n_scale_ren_TSV[i_s] % 2 == 0){logger << LOG_FATAL << "n_scale_ren_TSV[" << i_s << "] must be an odd number!" << endline_flush; exit(1);}
    no_central_scale_ren_TSV[i_s] = (n_scale_ren_TSV[i_s] - 1) / 2;

    if (n_scale_fact_TSV[i_s] == empty_int){n_scale_fact_TSV[i_s] = n_scale_TSV[i_s];}
    if (n_scale_fact_TSV[i_s] == empty_int){logger << LOG_FATAL << "n_scale_fact_TSV[" << i_s << "] has not been defined!" << endline_flush; exit(1);}
    if (n_scale_fact_TSV[i_s] % 2 == 0){logger << LOG_FATAL << "n_scale_fact_TSV[" << i_s << "] must be an odd number!" << endline_flush; exit(1);}
    no_central_scale_fact_TSV[i_s] = (n_scale_fact_TSV[i_s] - 1) / 2;
  }

  if (name_reference_TSV == ""){
    logger << LOG_DEBUG << "No reference scale defined. Standard value used." << endline_flush;
    logger << LOG_DEBUG << "name_extended_set_TSV.size() = " << name_extended_set_TSV.size() << endline_flush;
    int x_s = 0;
    name_reference_TSV = name_extended_set_TSV[x_s];
    no_reference_TSV = x_s;
  }
  if (no_scale_ren_reference_TSV == -1){no_scale_ren_reference_TSV = no_central_scale_ren_TSV[no_reference_TSV];}
  if (no_scale_fact_reference_TSV == -1){no_scale_fact_reference_TSV = no_central_scale_fact_TSV[no_reference_TSV];}
  if (no_qTcut_reference_TSV == -1){no_qTcut_reference_TSV = 0;}

  logger << LOG_DEBUG << "default output from TSV:" << endline_flush;
  logger << LOG_DEBUG << "name_reference_TSV          = " << name_reference_TSV << endline_flush;
  logger << LOG_DEBUG << "no_reference_TSV            = " << no_reference_TSV << endline_flush;
  logger << LOG_DEBUG << "no_scale_ren_reference_TSV  = " << no_scale_ren_reference_TSV << endline_flush;
  logger << LOG_DEBUG << "no_scale_fact_reference_TSV = " << no_scale_fact_reference_TSV << endline_flush;
  logger << LOG_DEBUG << "no_qTcut_reference_TSV      = " << no_qTcut_reference_TSV << endline_flush;
  logger.newLine(LOG_DEBUG);

  // set  n_scale_TSV / n_scale_ren_TSV / n_scale_fact_TSV  for scale-difference contributions (and exit if not consistent):
  for (int i_s = 0; i_s < n_diff_set_TSV; i_s++){
    int i_es = n_set_TSV + i_s;
    if (n_scale_TSV[no_diff_set_plus_TSV[i_s]] == n_scale_TSV[no_diff_set_minus_TSV[i_s]]){n_scale_TSV[i_es] = n_scale_TSV[no_diff_set_plus_TSV[i_s]];}
    else {logger << LOG_FATAL << "n_scale_TSV of " << name_diff_set_TSV[i_s] << " is not well-defined: n_scale_TSV[" << no_diff_set_plus_TSV[i_s] << "] = " << n_scale_TSV[no_diff_set_plus_TSV[i_s]] << " =/= " << n_scale_TSV[no_diff_set_minus_TSV[i_s]] << " = n_scale_TSV[" << no_diff_set_minus_TSV[i_s] << "]" << endline_flush; exit(1);}

    if (n_scale_ren_TSV[no_diff_set_plus_TSV[i_s]] == n_scale_ren_TSV[no_diff_set_minus_TSV[i_s]]){n_scale_ren_TSV[i_es] = n_scale_ren_TSV[no_diff_set_plus_TSV[i_s]];}
    else {logger << LOG_FATAL << "n_scale_ren_TSV of " << name_diff_set_TSV[i_s] << " is not well-defined: n_scale_ren_TSV[" << no_diff_set_plus_TSV[i_s] << "] = " << n_scale_ren_TSV[no_diff_set_plus_TSV[i_s]] << " =/= " << n_scale_ren_TSV[no_diff_set_minus_TSV[i_s]] << " = n_scale_ren_TSV[" << no_diff_set_minus_TSV[i_s] << "]" << endline_flush; exit(1);}

    if (n_scale_fact_TSV[no_diff_set_plus_TSV[i_s]] == n_scale_fact_TSV[no_diff_set_minus_TSV[i_s]]){n_scale_fact_TSV[i_es] = n_scale_fact_TSV[no_diff_set_plus_TSV[i_s]];}
    else {logger << LOG_FATAL << "n_scale_fact_TSV of " << name_diff_set_TSV[i_s] << " is not well-defined: n_scale_fact_TSV[" << no_diff_set_plus_TSV[i_s] << "] = " << n_scale_fact_TSV[no_diff_set_plus_TSV[i_s]] << " =/= " << n_scale_fact_TSV[no_diff_set_minus_TSV[i_s]] << " = n_scale_fact_TSV[" << no_diff_set_minus_TSV[i_s] << "]" << endline_flush; exit(1);}
  }

  // reason for max_n_scale... not clear !!! probably not used...
  max_n_scale_ren_TSV = 0;
  max_n_scale_fact_TSV = 0;
  for (int i_s = 0; i_s < n_set_TSV; i_s++){
    if (n_scale_ren_TSV[i_s] > max_n_scale_ren_TSV){max_n_scale_ren_TSV = n_scale_ren_TSV[i_s];}
    if (n_scale_fact_TSV[i_s] > max_n_scale_fact_TSV){max_n_scale_fact_TSV = n_scale_fact_TSV[i_s];}
  }
  logger << LOG_DEBUG << "max_n_scale_ren_TSV = " << max_n_scale_ren_TSV << endline_flush;
  logger << LOG_DEBUG << "max_n_scale_fact_TSV = " << max_n_scale_fact_TSV << endline_flush;

  // also needed for scale-difference contributions:
  relative_scale_ren_TSV.resize(n_extended_set_TSV, vector<double> (max_n_scale_ren_TSV, 0.));
  relative_scale_fact_TSV.resize(n_extended_set_TSV, vector<double> (max_n_scale_fact_TSV, 0.));

  for (int i_s = 0; i_s < n_set_TSV; i_s++){
    if (dynamic_scale_ren_TSV[i_s] == empty_int){dynamic_scale_ren_TSV[i_s] = dynamic_scale_TSV[i_s];}
    if (dynamic_scale_ren_TSV[i_s] == empty_int){
      dynamic_scale_ren_TSV[i_s] = 0;
      logger << LOG_WARN << "dynamic_scale_ren_TSV[" << i_s << "] has been set to default value (0) !" << endline_flush;
    }

    if (dynamic_scale_fact_TSV[i_s] == empty_int){dynamic_scale_fact_TSV[i_s] = dynamic_scale_TSV[i_s];}
    if (dynamic_scale_fact_TSV[i_s] == empty_int){
      dynamic_scale_fact_TSV[i_s] = 0;
      logger << LOG_WARN << "dynamic_scale_fact_TSV[" << i_s << "] has been set to default value (0) !" << endline_flush;
    }

    if (relative_central_scale_ren_TSV[i_s] == empty_double){relative_central_scale_ren_TSV[i_s] = relative_central_scale_TSV[i_s];}
    if (central_scale_ren_TSV[i_s] == empty_double){central_scale_ren_TSV[i_s] = central_scale_TSV[i_s];}

    if (relative_central_scale_ren_TSV[i_s] == empty_double && central_scale_ren_TSV[i_s] == empty_double){
      logger << LOG_FATAL << "relative_central_scale_ren_TSV[" << i_s << "] and central_scale_ren_TSV[" << i_s << "] have not been defined!" << endline_flush; exit(1);
    }
    else if (relative_central_scale_ren_TSV[i_s] == empty_double && central_scale_ren_TSV[i_s] != empty_double){
      relative_central_scale_ren_TSV[i_s] = central_scale_ren_TSV[i_s] / (scale_ren / osi->prefactor_reference);
      // !!!     relative_central_scale_ren_TSV[i_s] = central_scale_ren_TSV[i_s] / scale_ren;
    }
    else if (relative_central_scale_ren_TSV[i_s] != empty_double && central_scale_ren_TSV[i_s] == empty_double){
      central_scale_ren_TSV[i_s] = relative_central_scale_ren_TSV[i_s] * (scale_ren / osi->prefactor_reference);
      // !!!      central_scale_ren_TSV[i_s] = relative_central_scale_ren_TSV[i_s] * scale_ren;
    }
    else if (relative_central_scale_ren_TSV[i_s] != empty_double && central_scale_ren_TSV[i_s] != empty_double){
      logger << LOG_FATAL << "Both alternative definitions relative_central_scale_ren_TSV[" << i_s << "] and central_scale_ren_TSV[" << i_s << "] have been defined!" << endline_flush; exit(1);
    }

    if (relative_central_scale_fact_TSV[i_s] == empty_double){relative_central_scale_fact_TSV[i_s] = relative_central_scale_TSV[i_s];}
    if (central_scale_fact_TSV[i_s] == empty_double){central_scale_fact_TSV[i_s] = central_scale_TSV[i_s];}

    if (relative_central_scale_fact_TSV[i_s] == empty_double && central_scale_fact_TSV[i_s] == empty_double){logger << LOG_FATAL << "relative_central_scale_fact_TSV[" << i_s << "] and central_scale_fact_TSV[" << i_s << "] have not been defined!" << endline_flush; exit(1);}
    else if (relative_central_scale_fact_TSV[i_s] == empty_double && central_scale_fact_TSV[i_s] != empty_double){
      relative_central_scale_fact_TSV[i_s] = central_scale_fact_TSV[i_s] / (scale_fact / osi->prefactor_reference);
      // !!!      relative_central_scale_fact_TSV[i_s] = central_scale_fact_TSV[i_s] / scale_fact;
    }
    else if (relative_central_scale_fact_TSV[i_s] != empty_double && central_scale_fact_TSV[i_s] == empty_double){
      central_scale_fact_TSV[i_s] = relative_central_scale_fact_TSV[i_s] * (scale_fact / osi->prefactor_reference);
      // !!!      central_scale_fact_TSV[i_s] = relative_central_scale_fact_TSV[i_s] * scale_fact;
    }
    else if (relative_central_scale_fact_TSV[i_s] != empty_double && central_scale_fact_TSV[i_s] != empty_double){
      logger << LOG_FATAL << "Both alternative definitions relative_central_scale_fact_TSV[" << i_s << "] and central_scale_fact_TSV[" << i_s << "] have been defined!" << endline_flush; exit(1);
    }

    if (factor_scale_ren_TSV[i_s] == empty_int){factor_scale_ren_TSV[i_s] = factor_scale_TSV[i_s];}
    if (factor_scale_ren_TSV[i_s] == empty_int){logger << LOG_FATAL << "factor_scale_ren_TSV[" << i_s << "] has not been defined!" << endline_flush; exit(1);}

    for (int i_r = 0; i_r < n_scale_ren_TSV[i_s]; i_r++){
      if (n_scale_ren_TSV[i_s] > 1){relative_scale_ren_TSV[i_s][i_r] = pow(10., log10(double(factor_scale_ren_TSV[i_s])) * double(2. * i_r / (n_scale_ren_TSV[i_s] - 1) - 1));}
      else {relative_scale_ren_TSV[i_s][i_r] = 1.;}
    }

    if (factor_scale_fact_TSV[i_s] == empty_int){factor_scale_fact_TSV[i_s] = factor_scale_TSV[i_s];}
    if (factor_scale_fact_TSV[i_s] == empty_int){logger << LOG_FATAL << "factor_scale_fact_TSV[" << i_s << "] has not been defined!" << endline_flush; exit(1);}
    for (int i_f = 0; i_f < n_scale_fact_TSV[i_s]; i_f++){
      if (n_scale_fact_TSV[i_s] > 1){relative_scale_fact_TSV[i_s][i_f] = pow(10., log10(double(factor_scale_fact_TSV[i_s])) * double(2. * i_f / (n_scale_fact_TSV[i_s] - 1) - 1));}
      else {relative_scale_fact_TSV[i_s][i_f] = 1.;}
    }

    if (dynamic_scale_ren_TSV[i_s] == empty_int){dynamic_scale_ren_TSV[i_s] = dynamic_scale_TSV[i_s];}
    if (dynamic_scale_ren_TSV[i_s] == empty_int){logger << LOG_FATAL << "dynamic_scale_ren_TSV[" << i_s << "] has not been defined!" << endline_flush; exit(1);}

    if (dynamic_scale_fact_TSV[i_s] == empty_int){dynamic_scale_fact_TSV[i_s] = dynamic_scale_TSV[i_s];}
    if (dynamic_scale_fact_TSV[i_s] == empty_int){logger << LOG_FATAL << "dynamic_scale_fact_TSV[" << i_s << "] has not been defined!" << endline_flush; exit(1);}

    if (n_scale_ren_TSV[i_s] > max_n_scale_ren_TSV){max_n_scale_ren_TSV = n_scale_ren_TSV[i_s];}
    if (n_scale_fact_TSV[i_s] > max_n_scale_fact_TSV){max_n_scale_fact_TSV = n_scale_fact_TSV[i_s];}
  }

  // also needed for scale-difference contributions (check if identity for vector<double> comparison works here !!!):

  for (int i_s = 0; i_s < n_diff_set_TSV; i_s++){
    int i_es = n_set_TSV + i_s;
    if (relative_scale_ren_TSV[no_diff_set_plus_TSV[i_s]] == relative_scale_ren_TSV[no_diff_set_minus_TSV[i_s]]){relative_scale_ren_TSV[i_es] = relative_scale_ren_TSV[no_diff_set_plus_TSV[i_s]];}
    else {
      for (int i_r = 0; i_r < relative_scale_ren_TSV[i_s].size(); i_r++){
	logger << LOG_FATAL << "relative_scale_ren_TSV of " << name_diff_set_TSV[i_s] << " is not well-defined: "
	       << "relative_scale_ren_TSV[" << no_diff_set_plus_TSV[i_s] << "][" << i_r << "] = " << relative_scale_ren_TSV[no_diff_set_plus_TSV[i_s]][i_r] << " =/= "
	       << relative_scale_ren_TSV[no_diff_set_minus_TSV[i_s]][i_r] << " = relative_scale_ren_TSV[" << no_diff_set_minus_TSV[i_s] << "][" << i_r << "]" << endline_flush;
      }
      exit(1);
    }
  }

  for (int i_s = 0; i_s < n_diff_set_TSV; i_s++){
    int i_es = n_set_TSV + i_s;
    if (relative_scale_fact_TSV[no_diff_set_plus_TSV[i_s]] == relative_scale_fact_TSV[no_diff_set_minus_TSV[i_s]]){relative_scale_fact_TSV[i_es] = relative_scale_fact_TSV[no_diff_set_plus_TSV[i_s]];}
    else {
      for (int i_f = 0; i_f < relative_scale_fact_TSV[i_s].size(); i_f++){
	logger << LOG_FATAL << "relative_scale_fact_TSV of " << name_diff_set_TSV[i_s] << " is not well-defined: "
	       << "relative_scale_fact_TSV[" << no_diff_set_plus_TSV[i_s] << "][" << i_f << "] = " << relative_scale_fact_TSV[no_diff_set_plus_TSV[i_s]][i_f] << " =/= "
	       << relative_scale_fact_TSV[no_diff_set_minus_TSV[i_s]][i_f] << " = relative_scale_fact_TSV[" << no_diff_set_minus_TSV[i_s] << "][" << i_f << "]" << endline_flush;
      }
      exit(1);
    }
  }

  n_dynamic_scale_TSV = 1;
  for (int i_s = 0; i_s < n_set_TSV; i_s++){
    if (dynamic_scale_ren_TSV[i_s] >= n_dynamic_scale_TSV){ n_dynamic_scale_TSV = dynamic_scale_ren_TSV[i_s] + 1; }
    if (dynamic_scale_fact_TSV[i_s] >= n_dynamic_scale_TSV){ n_dynamic_scale_TSV = dynamic_scale_fact_TSV[i_s] + 1; }
  }

  switch_dynamic_scale_TSV.resize(n_dynamic_scale_TSV, 0);
  for (int i_d = 0; i_d < n_dynamic_scale_TSV; i_d++){
    for (int i_s = 0; i_s < n_set_TSV; i_s++){
      if (dynamic_scale_ren_TSV[i_s] == i_d || dynamic_scale_fact_TSV[i_s] == i_d){
	switch_dynamic_scale_TSV[i_d] = 1;
	break;
      }
    }
  }

  logger << LOG_DEBUG << "n_dynamic_scale_TSV = " << n_dynamic_scale_TSV << endline_flush;
  for (int i_d = 0; i_d < n_dynamic_scale_TSV; i_d++){
    logger << LOG_DEBUG << "switch_dynamic_scale_TSV[" << i_d << "] = " << switch_dynamic_scale_TSV[i_d] << endline_flush;
  }

  logger << LOG_DEBUG << "initialization of identifiers for renormalization/factorization scales" << endline_flush;
  name_scale_ren_TSV.resize(n_set_TSV);
  name_scale_fact_TSV.resize(n_set_TSV);
  for (int i_s = 0; i_s < n_set_TSV; i_s++){
    name_scale_ren_TSV[i_s].resize(n_scale_ren_TSV[i_s]);
    name_scale_fact_TSV[i_s].resize(n_scale_fact_TSV[i_s]);
    for (int i_r = 0; i_r < n_scale_ren_TSV[i_s]; i_r++){
      stringstream temp_ss;
      temp_ss << "µR_TSV(" << name_set_TSV[i_s] << ": " << dynamic_scale_ren_TSV[i_s] << ", " << i_r << ")";
      name_scale_ren_TSV[i_s][i_r] = temp_ss.str();
    }
    for (int i_f = 0; i_f < n_scale_fact_TSV[i_s]; i_f++){
      stringstream temp_ss;
      temp_ss << "µF_TSV(" << name_set_TSV[i_s] << ": " << dynamic_scale_fact_TSV[i_s] <<  ", " << i_f << ")";
      name_scale_fact_TSV[i_s][i_f] = temp_ss.str();
    }
  }
    // initialization of scale-related quantities done


  // Output:
  logger << LOG_DEBUG << "The following dynamic scales are used:" << endline_flush;
  for (int i_d = 0; i_d < n_dynamic_scale_TSV; i_d++){
    if (switch_dynamic_scale_TSV[i_d] == 1){
      logger << LOG_DEBUG << "switch_dynamic_scale_TSV[" << i_d << "] = " << switch_dynamic_scale_TSV[i_d] << endline_flush;
    }
  }
  logger.newLine(LOG_DEBUG);

  logger << LOG_DEBUG << "The following scalesets have been defined:" << endline_flush;
  for (int i_s = 0; i_s < n_set_TSV; i_s++){
    logger << LOG_DEBUG << endline_flush;
    logger << LOG_DEBUG << "scaleset " << i_s << ":" << endline_flush;
    logger << LOG_DEBUG << setw(35) << "name_set_TSV" << " = " << name_set_TSV[i_s] << endline_flush;
    logger << LOG_DEBUG << setw(35) << "dynamic_scale_ren_TSV" << " = " << dynamic_scale_ren_TSV[i_s] << endline_flush;
    logger << LOG_DEBUG << setw(35) << "relative_central_scale_ren_TSV" << " = " << relative_central_scale_ren_TSV[i_s] << endline_flush;
    if (dynamic_scale_ren_TSV[i_s] == 0){
      logger << LOG_DEBUG << setw(35) << "central_scale_ren_TSV" << " = " << central_scale_ren_TSV[i_s] << endline_flush;
    }
    logger << LOG_DEBUG << setw(35) << "n_scale_ren_TSV" << " = " << n_scale_ren_TSV[i_s] << endline_flush;
    logger << LOG_DEBUG << setw(35) << "factor_scale_ren_TSV" << " = " << factor_scale_ren_TSV[i_s] << endline_flush;
    logger << LOG_DEBUG << setw(35) << "no_central_scale_ren_TSV" << " = " << no_central_scale_ren_TSV[i_s] << endline_flush;
    logger << LOG_DEBUG << setw(35) << "dynamic_scale_fact_TSV" << " = " << dynamic_scale_fact_TSV[i_s] << endline_flush;
    logger << LOG_DEBUG << setw(35) << "relative_central_scale_fact_TSV" << " = " << relative_central_scale_fact_TSV[i_s] << endline_flush;
    if (dynamic_scale_fact_TSV[i_s] == 0){
      logger << LOG_DEBUG << setw(35) << "central_scale_fact_TSV" << " = " << central_scale_fact_TSV[i_s] << endline_flush;
    }
    logger << LOG_DEBUG << setw(35) << "n_scale_fact_TSV" << " = " << n_scale_fact_TSV[i_s] << endline_flush;
    logger << LOG_DEBUG << setw(35) << "factor_scale_fact_TSV" << " = " << factor_scale_fact_TSV[i_s] << endline_flush;
    logger << LOG_DEBUG << setw(35) << "no_central_scale_fact_TSV" << " = " << no_central_scale_fact_TSV[i_s] << endline_flush;
    logger.newLine(LOG_DEBUG);
    logger << LOG_DEBUG << setw(35) << "min_qTcut_TSV" << " = " << min_qTcut_TSV[i_s] << endline_flush;
    logger << LOG_DEBUG << setw(35) << "max_qTcut_TSV" << " = " << max_qTcut_TSV[i_s] << endline_flush;
    logger << LOG_DEBUG << setw(35) << "switch_distribution_TSV" << " = " << switch_distribution_TSV[i_s] << endline_flush;
    if (switch_distribution_TSV[i_s] != 0){
      logger << LOG_DEBUG << setw(35) << "min_qTcut_distribution_TSV" << " = " << min_qTcut_distribution_TSV[i_s] << endline_flush;
      logger << LOG_DEBUG << setw(35) << "max_qTcut_distribution_TSV" << " = " << max_qTcut_distribution_TSV[i_s] << endline_flush;
    }
    logger << LOG_DEBUG << setw(35) << "switch_moment_TSV" << " = " << switch_moment_TSV[i_s] << endline_flush;
  }

  logger.finished();
}


void manager_TSV::initialization_scale_TSV(){
  static Logger logger("manager_TSV::initialization_scale_TSV");
  logger.called();

  logger << LOG_DEBUG << "define_scale_calculation_TSV started" << endline_flush;

  needed_scale2_ren = 0;
  needed_scale2_fact = 0;
  if (osi->csi->class_contribution_collinear){needed_scale2_fact = 1;}

  // initialization of all renormalization-scale connected variables

  // max_dyn_ren
  // dynamic_scale_ren_TSV
  // value_relative_scale_ren
  // value_relative_scale2_ren
  // value_scale_ren
  // value_scale2_ren
  // no_value_ren_TSV

  max_dyn_ren = 0;
  for (int i_s = 0; i_s < n_set_TSV; i_s++){
    if (dynamic_scale_ren_TSV[i_s] > max_dyn_ren){
      max_dyn_ren = dynamic_scale_ren_TSV[i_s];
    }
  }
  n_scale_dyn_ren.resize(max_dyn_ren + 1, 0);

  value_alpha_S_TSV.resize(osi->n_ps);
  value_relative_factor_alpha_S.resize(osi->n_ps);
  value_scale_ren.resize(osi->n_ps);
  value_scale2_ren.resize(osi->n_ps);
  value_relative_scale_ren.resize(max_dyn_ren + 1);
  value_relative_scale2_ren.resize(max_dyn_ren + 1);
  value_alpha_S_TSV[0].resize(max_dyn_ren + 1);
  value_relative_factor_alpha_S[0].resize(max_dyn_ren + 1);
  value_scale_ren[0].resize(max_dyn_ren + 1);
  value_scale2_ren[0].resize(max_dyn_ren + 1);
  for (int i_s = 0; i_s < n_set_TSV; i_s++){
    int v_sr = dynamic_scale_ren_TSV[i_s];
    for (int i_r = 0; i_r < n_scale_ren_TSV[i_s]; i_r++){
      int flag = 0;
      for (int v_xr = 0; v_xr < value_relative_scale_ren[v_sr].size(); v_xr++){
	if (abs(value_relative_scale_ren[v_sr][v_xr] - relative_central_scale_ren_TSV[i_s] * relative_scale_ren_TSV[i_s][i_r]) / value_relative_scale_ren[v_sr][v_xr] < 1.e-15){
	  flag = 1;
	  break;
	}
      }
      if (flag == 0){
	value_relative_scale_ren[v_sr].push_back(relative_central_scale_ren_TSV[i_s] * relative_scale_ren_TSV[i_s][i_r]);
	value_relative_scale2_ren[v_sr].push_back(pow(relative_central_scale_ren_TSV[i_s] * relative_scale_ren_TSV[i_s][i_r], 2));
	if (v_sr == 0){
	  value_scale_ren[0][v_sr].push_back(central_scale_ren_TSV[i_s] * relative_scale_ren_TSV[i_s][i_r]);
	  value_scale2_ren[0][v_sr].push_back(pow(central_scale_ren_TSV[i_s] * relative_scale_ren_TSV[i_s][i_r], 2));
	}
	else {
	  value_scale_ren[0][v_sr].push_back(0.);
	  value_scale2_ren[0][v_sr].push_back(0.);
	}
      }
    }
  }

  logger << LOG_DEBUG << "value_relative_scale_ren before 'sort':" << endline_flush;
  for (int v_sr = 0; v_sr < max_dyn_ren + 1; v_sr++){
    for (int v_xr = 0; v_xr < value_relative_scale_ren[v_sr].size(); v_xr++){
      logger << LOG_DEBUG << "value_relative_scale_ren[" << setw(2) << v_sr << "][" << setw(2) << v_xr << "] = " << value_relative_scale_ren[v_sr][v_xr] << endline_flush;
    }
  }
  logger.newLine(LOG_DEBUG);

  for (int v_sr = 0; v_sr < max_dyn_ren + 1; v_sr++){
    sort(value_relative_scale_ren[v_sr].begin(), value_relative_scale_ren[v_sr].end());
    // new: (only for v_sr = 0?)
    sort(value_scale_ren[0][v_sr].begin(), value_scale_ren[0][v_sr].end());
    sort(value_scale2_ren[0][v_sr].begin(), value_scale2_ren[0][v_sr].end());
    // :
    n_scale_dyn_ren[v_sr] = value_relative_scale_ren[v_sr].size();
  }

  // calculate alpha_S (for fixed scales) only after sorting !!!
  for (int v_sr = 0; v_sr < max_dyn_ren + 1; v_sr++){
    for (int v_xr = 0; v_xr < value_relative_scale_ren[v_sr].size(); v_xr++){
      if (v_sr == 0){
	value_alpha_S_TSV[0][v_sr].push_back(LHAPDF::alphasPDF(value_scale_ren[0][v_sr][v_xr]));
	value_relative_factor_alpha_S[0][v_sr].push_back(pow(LHAPDF::alphasPDF(value_scale_ren[0][v_sr][v_xr]) / LHAPDF::alphasPDF(scale_ren), osi->csi->contribution_order_alpha_s));
      }
      else {
	value_alpha_S_TSV[0][v_sr].push_back(0.);
	value_relative_factor_alpha_S[0][v_sr].push_back(0.);
      }
    }
  }
  // !!!
  
  for (int i_a = 1; i_a < osi->n_ps; i_a++){
    value_alpha_S_TSV[i_a] = value_alpha_S_TSV[0];
    value_relative_factor_alpha_S[i_a] = value_relative_factor_alpha_S[0];
    value_scale_ren[i_a] = value_scale_ren[0];
    value_scale2_ren[i_a] = value_scale2_ren[0];
  }

  
  logger << LOG_DEBUG << "value_relative_scale_ren after 'sort':" << endline_flush;
  for (int v_sr = 0; v_sr < max_dyn_ren + 1; v_sr++){
    for (int v_xr = 0; v_xr < value_relative_scale_ren[v_sr].size(); v_xr++){
      logger << LOG_DEBUG << "value_relative_scale_ren[" << setw(2) << v_sr << "][" << setw(2) << v_xr << "] = " << value_relative_scale_ren[v_sr][v_xr] << endline_flush;
    }
  }
  logger.newLine(LOG_DEBUG);

  no_value_ren_TSV.resize(n_set_TSV);
  for (int i_s = 0; i_s < n_set_TSV; i_s++){
    int v_sr = dynamic_scale_ren_TSV[i_s];
    no_value_ren_TSV[i_s].resize(value_relative_scale_ren[v_sr].size());
    for (int i_r = 0; i_r < n_scale_ren_TSV[i_s]; i_r++){
      for (int v_xr = 0; v_xr < value_relative_scale_ren[v_sr].size(); v_xr++){
	if (abs(value_relative_scale_ren[v_sr][v_xr] - relative_central_scale_ren_TSV[i_s] * relative_scale_ren_TSV[i_s][i_r]) / value_relative_scale_ren[v_sr][v_xr] < 1.e-15){
	  no_value_ren_TSV[i_s][i_r] = v_xr;
	}
      }
    }
  }

  logger << LOG_DEBUG << "initialization of all renormalization-scale connected variables done" << endline_flush;

  // Output:
  logger << LOG_DEBUG << "value_relative_scale_ren.size() = " << value_relative_scale_ren.size() << endline_flush;
  for (int v_sr = 0; v_sr < max_dyn_ren + 1; v_sr++){
    logger << LOG_DEBUG << "n_scale_dyn_ren[" << v_sr << "] = " << n_scale_dyn_ren[v_sr] << endline_flush;
    logger << LOG_DEBUG << "value_relative_scale_ren[" << v_sr << "].size() = " << value_relative_scale_ren[v_sr].size() << endline_flush;
    for (int v_xr = 0; v_xr < value_relative_scale_ren[v_sr].size(); v_xr++){
      logger << LOG_DEBUG << "value_relative_scale_ren[" << setw(2) << v_sr << "][" << setw(2) << v_xr << "] = " << value_relative_scale_ren[v_sr][v_xr] << endline_flush;
    }
    logger.newLine(LOG_DEBUG);
  }
  logger.newLine(LOG_DEBUG);

  for (int i_s = 0; i_s < n_set_TSV; i_s++){
    logger << LOG_DEBUG << name_set_TSV[i_s] << "   dynamic_scale_ren_TSV[" << setw(2) << i_s << "] = " << dynamic_scale_ren_TSV[i_s] << endline_flush;
    for (int i_r = 0; i_r < n_scale_ren_TSV[i_s]; i_r++){
      logger << LOG_DEBUG << "no_value_ren_TSV[" << setw(2) << i_s << "][" << setw(2) << i_r << "] = " << no_value_ren_TSV[i_s][i_r] << endline_flush;
    }
    logger.newLine(LOG_DEBUG);
  }
  

  
  // initialization of all factorization-scale connected variables

  // max_dyn_fact
  // n_scale_dyn_fact
  // value_relative_scale_fact
  // value_relative_scale2_fact
  // value_relative_logscale2_fact
  // value_scale_fact
  // value_scale2_fact
  // value_no_central_scale_fact   ->   doesn't seem to be used !!!
  // value_central_scale_fact
  // value_central_logscale2_fact
  // no_value_fact_TSV


  max_dyn_fact = 0;
  for (int i_s = 0; i_s < n_set_TSV; i_s++){
    if (dynamic_scale_fact_TSV[i_s] > max_dyn_fact){
      max_dyn_fact = dynamic_scale_fact_TSV[i_s];
    }
  }
  n_scale_dyn_fact.resize(max_dyn_fact + 1, 0);
  value_scale_fact.resize(osi->n_ps);
  value_scale2_fact.resize(osi->n_ps);
  value_relative_scale_fact.resize(max_dyn_fact + 1);
  value_relative_scale2_fact.resize(max_dyn_fact + 1);
  value_relative_logscale2_fact.resize(max_dyn_fact + 1);
  value_scale_fact[0].resize(max_dyn_fact + 1);
  value_scale2_fact[0].resize(max_dyn_fact + 1);

  for (int i_s = 0; i_s < n_set_TSV; i_s++){
    int v_sf = dynamic_scale_fact_TSV[i_s];
    for (int i_f = 0; i_f < n_scale_fact_TSV[i_s]; i_f++){
      int flag = 0;
      for (int v_xf = 0; v_xf < value_relative_scale_fact[v_sf].size(); v_xf++){
	if (abs(value_relative_scale_fact[v_sf][v_xf] - relative_central_scale_fact_TSV[i_s] * relative_scale_fact_TSV[i_s][i_f]) / value_relative_scale_fact[v_sf][v_xf] < 1.e-15){
	  flag = 1;
	  break;
	}
      }
      if (flag == 0){
	value_relative_scale_fact[v_sf].push_back(relative_central_scale_fact_TSV[i_s] * relative_scale_fact_TSV[i_s][i_f]);
	value_relative_scale2_fact[v_sf].push_back(pow(relative_central_scale_fact_TSV[i_s] * relative_scale_fact_TSV[i_s][i_f], 2));
	value_relative_logscale2_fact[v_sf].push_back(2 * log(relative_central_scale_fact_TSV[i_s] * relative_scale_fact_TSV[i_s][i_f]));
	if (v_sf == 0){
	  value_scale_fact[0][v_sf].push_back(central_scale_fact_TSV[i_s] * relative_scale_fact_TSV[i_s][i_f]);
	  value_scale2_fact[0][v_sf].push_back(pow(central_scale_fact_TSV[i_s] * relative_scale_fact_TSV[i_s][i_f], 2));
	}
	else {
	  value_scale_fact[0][v_sf].push_back(0.);
	  value_scale2_fact[0][v_sf].push_back(0.);
	}
      }
    }
  }



  logger << LOG_DEBUG << "value_relative_scale_fact before 'sort':" << endline_flush;
  for (int v_sf = 0; v_sf < max_dyn_fact + 1; v_sf++){
    for (int v_xf = 0; v_xf < value_relative_scale_fact[v_sf].size(); v_xf++){
      logger << LOG_DEBUG << "value_relative_scale_fact[" << setw(2) << v_sf << "][" << setw(2) << v_xf << "] = " << value_relative_scale_fact[v_sf][v_xf] << endline_flush;
    }
  }
  logger.newLine(LOG_DEBUG);

  for (int v_sf = 0; v_sf < max_dyn_fact + 1; v_sf++){
    sort(value_relative_scale_fact[v_sf].begin(), value_relative_scale_fact[v_sf].end());
    // montone functions: same sorting automatically:
    sort(value_relative_scale2_fact[v_sf].begin(), value_relative_scale2_fact[v_sf].end());
    sort(value_relative_logscale2_fact[v_sf].begin(), value_relative_logscale2_fact[v_sf].end());
    // new: (only for v_sf = 0?)
    sort(value_scale_fact[0][v_sf].begin(), value_scale_fact[0][v_sf].end());
    sort(value_scale2_fact[0][v_sf].begin(), value_scale2_fact[0][v_sf].end());
    // :

    n_scale_dyn_fact[v_sf] = value_relative_scale_fact[v_sf].size();
  }

  logger << LOG_DEBUG << "value_relative_scale_fact after 'sort':" << endline_flush;
  for (int v_sf = 0; v_sf < max_dyn_fact + 1; v_sf++){
    for (int v_xf = 0; v_xf < value_relative_scale_fact[v_sf].size(); v_xf++){
      logger << LOG_DEBUG << "value_relative_scale_fact[" << setw(2) << v_sf << "][" << setw(2) << v_xf << "] = " << value_relative_scale_fact[v_sf][v_xf] << endline_flush;
    }
  }
  logger.newLine(LOG_DEBUG);


  value_no_central_scale_fact.resize(max_dyn_fact + 1, -1);
  value_central_scale_fact.resize(max_dyn_fact + 1);
  value_central_logscale2_fact.resize(max_dyn_fact + 1);

  no_value_fact_TSV.resize(n_set_TSV);
  for (int i_s = 0; i_s < n_set_TSV; i_s++){
    int v_sf = dynamic_scale_fact_TSV[i_s];
    no_value_fact_TSV[i_s].resize(n_scale_dyn_fact[v_sf]);
    for (int i_f = 0; i_f < n_scale_fact_TSV[i_s]; i_f++){
      for (int v_xf = 0; v_xf < value_relative_scale_fact[v_sf].size(); v_xf++){
	if (abs(value_relative_scale_fact[v_sf][v_xf] - relative_central_scale_fact_TSV[i_s] * relative_scale_fact_TSV[i_s][i_f]) / value_relative_scale_fact[v_sf][v_xf] < 1.e-15){
	  no_value_fact_TSV[i_s][i_f] = v_xf;
	  if (abs(value_relative_scale_fact[v_sf][v_xf] - 1.) < 1.e-15){value_no_central_scale_fact[v_sf] = v_xf;}
	}
      }
    }
  }

  for (int i_a = 1; i_a < osi->n_ps; i_a++){
    value_scale_fact[i_a] = value_scale_fact[0];
    value_scale2_fact[i_a] = value_scale2_fact[0];
  }

  // initialization of all factorization-scale connected variables done

  // Output:
  logger << LOG_DEBUG << "value_relative_scale_fact.size() = " << value_relative_scale_fact.size() << endline_flush;
  for (int v_sf = 0; v_sf < max_dyn_fact + 1; v_sf++){
    logger << LOG_DEBUG << "n_scale_dyn_fact[" << v_sf << "] = " << n_scale_dyn_fact[v_sf] << endline_flush;
    logger << LOG_DEBUG << "value_relative_scale_fact[" << v_sf << "].size() = " << value_relative_scale_fact[v_sf].size() << endline_flush;
    for (int v_xf = 0; v_xf < value_relative_scale_fact[v_sf].size(); v_xf++){
      logger << LOG_DEBUG << "value_relative_scale_fact[" << setw(2) << v_sf << "][" << setw(2) << v_xf << "] = " << value_relative_scale_fact[v_sf][v_xf] << endline_flush;
    }
  logger.newLine(LOG_DEBUG);
  }
  logger.newLine(LOG_DEBUG);

  for (int i_s = 0; i_s < n_set_TSV; i_s++){
    logger << LOG_DEBUG << name_set_TSV[i_s] << "   dynamic_scale_fact_TSV[" << setw(2) << i_s << "] = " << dynamic_scale_fact_TSV[i_s] << endline_flush;
    for (int i_f = 0; i_f < n_scale_fact_TSV[i_s]; i_f++){
      logger << LOG_DEBUG << "no_value_fact_TSV[" << setw(2) << i_s << "][" << setw(2) << i_f << "] = " << no_value_fact_TSV[i_s][i_f] << endline_flush;
    }
  logger.newLine(LOG_DEBUG);
  }


  logger << LOG_DEBUG << "initialization of pointers for renormalization/factorization dependent variables" << endline_flush;

  // pointer_scale_ren.resize
  // pointer_scale2_ren
  // pointer_relative_factor_alpha_S
  // pointer_scale_fact
  // pointer_scale2_fact

  pointer_scale_ren.resize(osi->n_ps, vector<vector<double*> > (n_set_TSV));
  pointer_scale2_ren.resize(osi->n_ps, vector<vector<double*> > (n_set_TSV));
  pointer_alpha_S_TSV.resize(osi->n_ps, vector<vector<double*> > (n_set_TSV));
  pointer_relative_factor_alpha_S.resize(osi->n_ps, vector<vector<double*> > (n_set_TSV));
  pointer_scale_fact.resize(osi->n_ps, vector<vector<double*> > (n_set_TSV));
  pointer_scale2_fact.resize(osi->n_ps, vector<vector<double*> > (n_set_TSV));

  for (int i_a = 0; i_a < osi->n_ps; i_a++){
    for (int i_s = 0; i_s < n_set_TSV; i_s++){
      pointer_alpha_S_TSV[i_a][i_s].resize(n_scale_ren_TSV[i_s]);
      pointer_relative_factor_alpha_S[i_a][i_s].resize(n_scale_ren_TSV[i_s]);
      pointer_scale_ren[i_a][i_s].resize(n_scale_ren_TSV[i_s]);
      pointer_scale2_ren[i_a][i_s].resize(n_scale_ren_TSV[i_s]);
      pointer_scale_fact[i_a][i_s].resize(n_scale_fact_TSV[i_s]);
      pointer_scale2_fact[i_a][i_s].resize(n_scale_fact_TSV[i_s]);
      for (int i_r = 0; i_r < n_scale_ren_TSV[i_s]; i_r++){
	pointer_scale_ren[i_a][i_s][i_r] = &value_scale_ren[i_a][dynamic_scale_ren_TSV[i_s]][no_value_ren_TSV[i_s][i_r]];
	pointer_scale2_ren[i_a][i_s][i_r] = &value_scale2_ren[i_a][dynamic_scale_ren_TSV[i_s]][no_value_ren_TSV[i_s][i_r]];
	pointer_alpha_S_TSV[i_a][i_s][i_r] = &value_alpha_S_TSV[i_a][dynamic_scale_ren_TSV[i_s]][no_value_ren_TSV[i_s][i_r]];
	pointer_relative_factor_alpha_S[i_a][i_s][i_r] = &value_relative_factor_alpha_S[i_a][dynamic_scale_ren_TSV[i_s]][no_value_ren_TSV[i_s][i_r]];
	pointer_scale_fact[i_a][i_s][i_r] = &value_scale_fact[i_a][dynamic_scale_fact_TSV[i_s]][no_value_fact_TSV[i_s][i_r]];
	pointer_scale2_fact[i_a][i_s][i_r] = &value_scale2_fact[i_a][dynamic_scale_fact_TSV[i_s]][no_value_fact_TSV[i_s][i_r]];
	logger << LOG_DEBUG << setw(40) << right << "pointer_scale_ren[" << setw(2) << i_a << "][" << setw(2) << i_s << "][" << setw(2) << i_r << "] = " << *pointer_scale_ren[i_a][i_s][i_r] << endline_flush;
      }
    }
  }

  logger.finished();
}

