#include "header.hpp"

void observable_set::initialization_TSV(){
  static Logger logger("observable_set::initialization_TSV");
  logger.called();

  manager_TSV::initialization_scale_TSV();

  // initialization of value_MEterm_ren and value_MEterm_fact 

  logger << LOG_DEBUG << "initialization of value_ME2term_..." << endline_flush;
  value_ME2term_ren.resize(n_pc, vector<vector<double> > (max_dyn_ren + 1));
  value_ME2term_fact.resize(n_pc, vector<vector<vector<double> > > (n_pz, vector<vector<double> > (max_dyn_fact + 1)));
  for (int i_c = 0; i_c < n_pc; i_c++){
    for (int v_sr = 0; v_sr < max_dyn_ren + 1; v_sr++){  //for (int i_m = 0; i_m < value_relative_scale_ren[v_sr].size(); i_m++){
      value_ME2term_ren[i_c][v_sr].resize(n_scale_dyn_ren[v_sr], 0.);
    }
    for (int i_z = 0; i_z < n_pz; i_z++){
      for (int v_sf = 0; v_sf < max_dyn_fact + 1; v_sf++){
	value_ME2term_fact[i_c][i_z][v_sf].resize(n_scale_dyn_fact[v_sf], 0.);
      }
    }
  }
  logger << LOG_DEBUG << "initialization of value_ME2term_... done" << endline_flush;



  // initialization of 'integrand, weight, moment and variations

  // ps_integrand_qTcut_TSV
  // integrand_qTcut_TSV
  // sum_weight_TSV
  // sum_weight2_TSV
  // fullsum_weight_TSV
  // fullsum_weight2_TSV
  // sum_weight_qTcut_TSV
  // sum_weight2_qTcut_TSV
  // fullsum_weight_qTcut_TSV
  // fullsum_weight2_qTcut_TSV

  // ps_moment_TSV
  // moment_TSV
  // sum_moment_TSV
  // sum_moment2_TSV
  // fullsum_moment_TSV
  // fullsum_moment2_TSV
  // sum_moment_qTcut_TSV
  // sum_moment2_qTcut_TSV
  // fullsum_moment_qTcut_TSV
  // fullsum_moment2_qTcut_TSV

  // Xsection_TSV
  // Xsection_delta_TSV


  ps_integrand_TSV.resize(n_extended_set_TSV);
  integrand_TSV.resize(n_extended_set_TSV);
  sum_weight_TSV.resize(n_extended_set_TSV);
  sum_weight2_TSV.resize(n_extended_set_TSV);
  fullsum_weight_TSV.resize(n_extended_set_TSV);
  fullsum_weight2_TSV.resize(n_extended_set_TSV);
  
  ps_integrand_qTcut_TSV.resize(n_qTcut, vector<vector<vector<vector<vector<double> > > > > (n_extended_set_TSV));
  integrand_qTcut_TSV.resize(n_qTcut, vector<vector<vector<double> > > (n_extended_set_TSV));
  sum_weight_qTcut_TSV.resize(n_extended_set_TSV);
  sum_weight2_qTcut_TSV.resize(n_extended_set_TSV);
  fullsum_weight_qTcut_TSV.resize(n_extended_set_TSV);
  fullsum_weight2_qTcut_TSV.resize(n_extended_set_TSV);

  Xsection_TSV.resize(n_extended_set_TSV);
  Xsection_delta_TSV.resize(n_extended_set_TSV);


  // only if moments are switched on !!!
  ps_moment_TSV.resize(n_extended_set_TSV);
  moment_TSV.resize(n_extended_set_TSV);
  sum_moment_TSV.resize(n_extended_set_TSV);
  sum_moment2_TSV.resize(n_extended_set_TSV);
  fullsum_moment_TSV.resize(n_extended_set_TSV);
  fullsum_moment2_TSV.resize(n_extended_set_TSV);
  
  sum_moment_qTcut_TSV.resize(n_extended_set_TSV);
  sum_moment2_qTcut_TSV.resize(n_extended_set_TSV);
  fullsum_moment_qTcut_TSV.resize(n_extended_set_TSV);
  fullsum_moment2_qTcut_TSV.resize(n_extended_set_TSV);

  Xsection_moment_TSV.resize(n_extended_set_TSV);
  Xsection_moment_delta_TSV.resize(n_extended_set_TSV);



  for (int i_s = 0; i_s < n_extended_set_TSV; i_s++){
    for (int i_q = 0; i_q < output_n_qTcut; i_q++){
      ps_integrand_qTcut_TSV[i_q][i_s].resize(n_scale_ren_TSV[i_s], vector<vector<vector<double> > > (n_scale_fact_TSV[i_s], vector<vector<double> > (max_n_integrand_TSV[i_s], vector<double> (n_ps, 0.)))); // check if really ps !!!
      integrand_qTcut_TSV[i_q][i_s].resize(n_scale_ren_TSV[i_s], vector<double> (n_scale_fact_TSV[i_s], 0.));
    }

    ps_integrand_TSV[i_s].resize(n_scale_ren_TSV[i_s], vector<vector<vector<double> > > (n_scale_fact_TSV[i_s], vector<vector<double> > (max_n_integrand_TSV[i_s], vector<double> (n_ps, 0.)))); // check if really ps !!!
    integrand_TSV[i_s].resize(n_scale_ren_TSV[i_s], vector<double> (n_scale_fact_TSV[i_s], 0.));
    sum_weight_TSV[i_s].resize(n_scale_ren_TSV[i_s], vector<double> (n_scale_fact_TSV[i_s], 0.));
    sum_weight2_TSV[i_s].resize(n_scale_ren_TSV[i_s], vector<double> (n_scale_fact_TSV[i_s], 0.));
    fullsum_weight_TSV[i_s].resize(n_scale_ren_TSV[i_s], vector<double> (n_scale_fact_TSV[i_s], 0.));
    fullsum_weight2_TSV[i_s].resize(n_scale_ren_TSV[i_s], vector<double> (n_scale_fact_TSV[i_s], 0.));
    if (active_qTcut){
      sum_weight_qTcut_TSV[i_s].resize(n_qTcut, vector<vector<double> > (n_scale_ren_TSV[i_s], vector<double> (n_scale_fact_TSV[i_s], 0.)));
      sum_weight2_qTcut_TSV[i_s].resize(n_qTcut, vector<vector<double> > (n_scale_ren_TSV[i_s], vector<double> (n_scale_fact_TSV[i_s], 0.)));
      fullsum_weight_qTcut_TSV[i_s].resize(n_qTcut, vector<vector<double> > (n_scale_ren_TSV[i_s], vector<double> (n_scale_fact_TSV[i_s], 0.)));
      fullsum_weight2_qTcut_TSV[i_s].resize(n_qTcut, vector<vector<double> > (n_scale_ren_TSV[i_s], vector<double> (n_scale_fact_TSV[i_s], 0.)));
    }

    if (switch_moment_TSV[i_s] > 0){
      ps_moment_TSV[i_s].resize(n_moments, vector<vector<vector<vector<double> > > > (n_scale_ren_TSV[i_s], vector<vector<vector<double> > > (n_scale_fact_TSV[i_s], vector<vector<double> > (max_n_integrand_TSV[i_s], vector<double> (n_ps, 0.)))));
      moment_TSV[i_s].resize(n_moments, vector<vector<double> > (n_scale_ren_TSV[i_s], vector<double> (n_scale_fact_TSV[i_s], 0.)));
      sum_moment_TSV[i_s].resize(n_moments, vector<vector<double> > (n_scale_ren_TSV[i_s], vector<double> (n_scale_fact_TSV[i_s], 0.)));
      sum_moment2_TSV[i_s].resize(n_moments, vector<vector<double> > (n_scale_ren_TSV[i_s], vector<double> (n_scale_fact_TSV[i_s], 0.)));
      fullsum_moment_TSV[i_s].resize(n_moments, vector<vector<double> > (n_scale_ren_TSV[i_s], vector<double> (n_scale_fact_TSV[i_s], 0.)));
      fullsum_moment2_TSV[i_s].resize(n_moments, vector<vector<double> > (n_scale_ren_TSV[i_s], vector<double> (n_scale_fact_TSV[i_s], 0.)));

      if (active_qTcut){
	sum_moment_qTcut_TSV[i_s].resize(n_moments, vector<vector<vector<double> > > (n_qTcut, vector<vector<double> > (n_scale_ren_TSV[i_s], vector<double> (n_scale_fact_TSV[i_s], 0.))));
	sum_moment2_qTcut_TSV[i_s].resize(n_moments, vector<vector<vector<double> > > (n_qTcut, vector<vector<double> > (n_scale_ren_TSV[i_s], vector<double> (n_scale_fact_TSV[i_s], 0.))));
	fullsum_moment_qTcut_TSV[i_s].resize(n_moments, vector<vector<vector<double> > > (n_qTcut, vector<vector<double> > (n_scale_ren_TSV[i_s], vector<double> (n_scale_fact_TSV[i_s], 0.))));
	fullsum_moment2_qTcut_TSV[i_s].resize(n_moments, vector<vector<vector<double> > > (n_qTcut, vector<vector<double> > (n_scale_ren_TSV[i_s], vector<double> (n_scale_fact_TSV[i_s], 0.))));
      }
    }

    Xsection_TSV[i_s].resize(output_n_qTcut, vector<vector<double> > (n_scale_ren_TSV[i_s], vector<double> (n_scale_fact_TSV[i_s], 0.)));
    Xsection_delta_TSV[i_s].resize(output_n_qTcut, vector<vector<double> > (n_scale_ren_TSV[i_s], vector<double> (n_scale_fact_TSV[i_s], 0.)));

    if (switch_moment_TSV[i_s]){
      Xsection_moment_TSV[i_s].resize(n_moments, vector<vector<vector<double> > > (output_n_qTcut, vector<vector<double> > (n_scale_ren_TSV[i_s], vector<double> (n_scale_fact_TSV[i_s], 0.))));
      Xsection_moment_delta_TSV[i_s].resize(n_moments, vector<vector<vector<double> > > (output_n_qTcut, vector<vector<double> > (n_scale_ren_TSV[i_s], vector<double> (n_scale_fact_TSV[i_s], 0.))));
    }
  }

  // initialization of 'integrand, weight, moment and variations done

 




  // initialization of variables relevant for PDF factors

  // value_pdf_factor
  // value_pdf_factor_a
  // value_pdf_factor_b
  
  // initialization of variables relevant for debugging KP terms against Sherpa -> should be replaced by the standard variables !!!
  // value_pdf_factor_combination_1
  // value_pdf_factor_combination_2

  active_pdf.resize(3, vector<bool> (2, false));
// maybe set (*CA_collinear)[0][0].in_collinear()[0] for "no-emission component" !!! 
//  if (csi->class_contribution_collinear){
  if (csi->class_contribution_collinear && !csi->switch_VTX){
    if (csi->class_contribution_CS_collinear){
      for (int i_c = 0; i_c < n_pc; i_c++){
	if ((*CA_collinear)[i_c][0].in_collinear()[0] == 1){active_pdf[1][0] = true; active_pdf[2][0] = true;}
	if ((*CA_collinear)[i_c][0].in_collinear()[1] == 1){active_pdf[1][1] = true; active_pdf[2][0] = true;}
	if ((*CA_collinear)[i_c][0].in_collinear()[2] == 1){active_pdf[1][0] = true; active_pdf[2][1] = true;}
      }
    }
    if (csi->class_contribution_QT_collinear || csi->class_contribution_QT_virtual || csi->class_contribution_QT_powercorrection){
      // endpoint term: check if this works !!!
      if (list_combination_pdf[ncollinear[0].no_pdf].size() > 0){active_pdf[1][0] = true; active_pdf[2][0] = true;}
      for (int i_c = 0; i_c < ncollinear.size(); i_c++){
	for (int i_e = 0; i_e < ncollinear[i_c].in_collinear.size(); i_e++){
	  if (ncollinear[i_c].in_collinear[i_e][0] == 1){active_pdf[1][0] = true; active_pdf[2][0] = true;}
	  if (ncollinear[i_c].in_collinear[i_e][1] == 1){active_pdf[1][1] = true; active_pdf[2][0] = true;}
	  if (ncollinear[i_c].in_collinear[i_e][2] == 1){active_pdf[1][0] = true; active_pdf[2][1] = true;}
	}
      }
    }
  }
  else {active_pdf[1][0] = true; active_pdf[2][0] = true;}
  stringstream temp_ss;
  for (int i_x = 1; i_x < 3; i_x++){
    if (active_pdf[i_x][0]){temp_ss << "PDF(x_" << i_x << ")   ";}
    if (active_pdf[i_x][1]){temp_ss << "PDF(x_" << i_x << " / z_" << i_x << ")   ";}
  }
  logger << LOG_DEBUG << "active_pdf = " << temp_ss.str() << endline_flush;  

  
  logger << LOG_DEBUG << "initialization of value_pdf_factor" << endline_flush;
  value_pdf_factor.resize(n_pc, vector<vector<vector<vector<double> > > > (n_pz));

  // initialization of variables relevant for debugging KP terms against Sherpa
  /*
  if (csi->class_contribution_CS_collinear){
    value_pdf_factor_combination_1.resize(n_pc, vector<vector<vector<vector<vector<double> > > > > (n_pz));
    value_pdf_factor_combination_2.resize(n_pc, vector<vector<vector<vector<vector<double> > > > > (n_pz));
    if (n_pc > 0){
      value_pdf_factor_combination_1[0][0].resize(max_dyn_fact + 1);
      value_pdf_factor_combination_2[0][0].resize(max_dyn_fact + 1);
    }
  }
  */
  // initialization of variables relevant for debugging KP terms against Sherpa done

  if (n_pc > 0){
    value_pdf_factor[0][0].resize(max_dyn_fact + 1);
  }
  
  for (int i_s = 0; i_s < n_set_TSV; i_s++){
    int v_sf = dynamic_scale_fact_TSV[i_s];
    if (n_pc > 0){
      value_pdf_factor[0][0][v_sf].resize(value_relative_scale_fact[v_sf].size(), vector<double> (3, 0.));
      /*
      if (csi->class_contribution_CS_collinear){
	value_pdf_factor_combination_1[0][0][v_sf].resize(value_relative_scale_fact[v_sf].size(), vector<vector<double> > (3));
	value_pdf_factor_combination_2[0][0][v_sf].resize(value_relative_scale_fact[v_sf].size(), vector<vector<double> > (3));
      }
      */
    }
  }
  
  for (int i_c = 0; i_c < n_pc; i_c++){
    for (int i_z = 0; i_z < n_pz; i_z++){
      value_pdf_factor[i_c][i_z] = value_pdf_factor[0][0];
      /*
      // initialization of variables relevant for debugging KP terms against Sherpa
      if (csi->class_contribution_CS_collinear){
	value_pdf_factor_combination_1[i_c][i_z] = value_pdf_factor_combination_1[0][0];
	value_pdf_factor_combination_2[i_c][i_z] = value_pdf_factor_combination_2[0][0];
      }
      // initialization of variables relevant for debugging KP terms against Sherpa done
      */
    }
  }
  logger << LOG_DEBUG << "initialization of value_pdf_factor done" << endline_flush;

  logger << LOG_DEBUG << "initialization of value_pdf_factor_TSV" << endline_flush;
  value_list_pdf_factor_TSV.resize(n_ps, vector<vector<vector<vector<double> > > > (max_dyn_fact + 1));
  for (int i_a = 0; i_a < n_ps; i_a++){
    for (int v_sf = 0; v_sf < max_dyn_fact + 1; v_sf++){
      value_list_pdf_factor_TSV[i_a][v_sf].resize(n_scale_dyn_fact[v_sf]);
      for (int i_m = 0; i_m < n_scale_dyn_fact[v_sf]; i_m++){
	value_list_pdf_factor_TSV[i_a][v_sf][i_m].resize(list_combination_pdf.size(), vector<double> (3, 0.));
      }
    }
  }

  if (csi->class_contribution_CS_collinear){
    value_pdf_factor_a.resize(list_combination_pdf.size());
    value_pdf_factor_b.resize(list_combination_pdf.size());
    for (int i_l = 0; i_l < list_combination_pdf.size(); i_l++){
      value_pdf_factor_a[i_l].resize(list_combination_pdf[i_l].size());
      value_pdf_factor_b[i_l].resize(list_combination_pdf[i_l].size());
      for (int i_i = 0; i_i < list_combination_pdf[i_l].size(); i_i++){
	value_pdf_factor_a[i_l][i_i].resize(list_combination_pdf[i_l][i_i].size(), value_pdf_factor[0]);
	value_pdf_factor_b[i_l][i_i].resize(list_combination_pdf[i_l][i_i].size(), value_pdf_factor[0]);
      }
    }
  }
  logger << LOG_DEBUG << "initialization of value_pdf_factor_TSV done" << endline_flush;


  
  // pointer_pdf_factor
  // pointer_pdf_factor_a
  // pointer_pdf_factor_b
  logger << LOG_DEBUG << "initialization of pointer_pdf_factor" << endline_flush;

  if (csi->class_contribution_CS_collinear){
    logger << LOG_DEBUG << "initialization of pointer_pdf_factor CS_collinear" << endline_flush;
    int i_a = 0;
    pointer_pdf_factor.resize(n_pc, vector<vector<vector<vector<double*> > > > (n_pz, vector<vector<vector<double*> > > (n_set_TSV)));
    for (int i_c = 0; i_c < n_pc; i_c++){
      size_t x_l = (*CA_collinear)[i_c][0].no_pdf;
      logger << LOG_DEBUG << "x_l = (*CA_collinear)[i_c = " << i_c << "][0].no_pdf = " << x_l << endline_flush;
      for (int i_z = 0; i_z < n_pz; i_z++){
	for (int i_s = 0; i_s < n_set_TSV; i_s++){
	  pointer_pdf_factor[i_c][i_z][i_s].resize(n_scale_fact_TSV[i_s], vector<double*> (3));
	  for (int i_f = 0; i_f < n_scale_fact_TSV[i_s]; i_f++){
	    for (int i_h = 0; i_h < 3; i_h++){
	      if (i_z == 0){
		pointer_pdf_factor[i_c][i_z][i_s][i_f][i_h] = &value_list_pdf_factor_TSV[i_a][dynamic_scale_fact_TSV[i_s]][no_value_fact_TSV[i_s][i_f]][0][i_h];
	      }
	      else {
		pointer_pdf_factor[i_c][i_z][i_s][i_f][i_h] = &value_list_pdf_factor_TSV[i_a][dynamic_scale_fact_TSV[i_s]][no_value_fact_TSV[i_s][i_f]][x_l][i_h];
	      }
	    }
	  }
	}
      }
    }
    pointer_pdf_factor_a.resize(n_pc);
    pointer_pdf_factor_b.resize(n_pc);
    for (int i_c = 0; i_c < n_pc; i_c++){
      size_t x_l = (*CA_collinear)[i_c][0].no_pdf;
      pointer_pdf_factor_a[i_c].resize(list_combination_pdf[x_l].size());
      pointer_pdf_factor_b[i_c].resize(list_combination_pdf[x_l].size());
      for (int i_i = 0; i_i < list_combination_pdf[x_l].size(); i_i++){
	pointer_pdf_factor_a[i_c][i_i].resize(list_combination_pdf[x_l][i_i].size(), pointer_pdf_factor[i_c]);
	pointer_pdf_factor_b[i_c][i_i].resize(list_combination_pdf[x_l][i_i].size(), pointer_pdf_factor[i_c]);
	for (int i_x = 0; i_x < list_combination_pdf[x_l][i_i].size(); i_x++){
	  for (int i_z = 0; i_z < n_pz; i_z++){
	    for (int i_s = 0; i_s < n_set_TSV; i_s++){
	      for (int i_f = 0; i_f < n_scale_fact_TSV[i_s]; i_f++){
		for (int i_h = 0; i_h < 3; i_h++){
		  if (i_z == 0){
		    if (i_i >= value_pdf_factor_a[0].size()){continue;}
		    if (i_x >= value_pdf_factor_a[0][i_i].size()){continue;}
		    pointer_pdf_factor_a[i_c][i_i][i_x][i_z][i_s][i_f][i_h] = &value_pdf_factor_a[0][i_i][i_x][0][dynamic_scale_fact_TSV[i_s]][no_value_fact_TSV[i_s][i_f]][i_h];
		    pointer_pdf_factor_b[i_c][i_i][i_x][i_z][i_s][i_f][i_h] = &value_pdf_factor_b[0][i_i][i_x][0][dynamic_scale_fact_TSV[i_s]][no_value_fact_TSV[i_s][i_f]][i_h];
		  }
		  else {
		    pointer_pdf_factor_a[i_c][i_i][i_x][i_z][i_s][i_f][i_h] = &value_pdf_factor_a[x_l][i_i][i_x][0][dynamic_scale_fact_TSV[i_s]][no_value_fact_TSV[i_s][i_f]][i_h];
		    pointer_pdf_factor_b[i_c][i_i][i_x][i_z][i_s][i_f][i_h] = &value_pdf_factor_b[x_l][i_i][i_x][0][dynamic_scale_fact_TSV[i_s]][no_value_fact_TSV[i_s][i_f]][i_h];
		  }
		}
	      }
	    }
	  }
	}
      }
    }
    logger << LOG_DEBUG << "initialization of pointer_pdf_factor CS_collinear done" << endline_flush;
  }
  else {
    logger << LOG_DEBUG << "initialization of pointer_pdf_factor !CS_collinear" << endline_flush;
    pointer_pdf_factor.resize(n_ps, vector<vector<vector<vector<double*> > > > (1, vector<vector<vector<double*> > > (n_set_TSV)));
    for (int i_a = 0; i_a < n_ps; i_a++){
      for (int i_s = 0; i_s < n_set_TSV; i_s++){
	pointer_pdf_factor[i_a][0][i_s].resize(n_scale_fact_TSV[i_s], vector<double*> (3));
	for (int i_f = 0; i_f < n_scale_fact_TSV[i_s]; i_f++){
	  for (int i_h = 0; i_h < 3; i_h++){
	    pointer_pdf_factor[i_a][0][i_s][i_f][i_h] = &value_list_pdf_factor_TSV[i_a][dynamic_scale_fact_TSV[i_s]][no_value_fact_TSV[i_s][i_f]][0][i_h];
	  }
	}
      }
    }
    logger << LOG_DEBUG << "initialization of pointer_pdf_factor !CS_collinear done" << endline_flush;
  }
  logger << LOG_DEBUG << "initialization of pointer_pdf_factor done" << endline_flush;


  
  /*
  logger << LOG_DEBUG << "before pointer_pdf_factor_1/2 for debugging against Sherpa" << endline_flush;

  if (csi->class_contribution_CS_collinear){
    logger << LOG_DEBUG_VERBOSE << "Initialization phase of value_pdf_factor_combination_1:" << endline_flush;
    for (int i_c = 0; i_c < n_pc; i_c++){
      for (int i_z = 0; i_z < n_pz; i_z++){
	logger << LOG_DEBUG_VERBOSE << "max_dyn_fact = " << max_dyn_fact << endline_flush;
	for (int v_sf = 0; v_sf < max_dyn_fact + 1; v_sf++){
	  value_pdf_factor_combination_1[i_c][i_z][v_sf].resize(n_scale_dyn_fact[v_sf], vector<vector<double> > (3));
	  value_pdf_factor_combination_2[i_c][i_z][v_sf].resize(n_scale_dyn_fact[v_sf], vector<vector<double> > (3));
	  logger << LOG_DEBUG_VERBOSE << "n_scale_dyn_fact[" << v_sf << "] = " << n_scale_dyn_fact[v_sf] << endline_flush;
	  for (int i_m = 0; i_m < n_scale_dyn_fact[v_sf]; i_m++){
	    for (int i_h = 0; i_h < 3; i_h++){
	      value_pdf_factor_combination_1[i_c][i_z][v_sf][i_m][i_h].resize(CA_combination_pdf[i_c].size(), 0.);
	      value_pdf_factor_combination_2[i_c][i_z][v_sf][i_m][i_h].resize(CA_combination_pdf[i_c].size(), 0.);
	    }
	  }
	}
      }
    }

    pointer_pdf_factor_combination_1.resize(n_pc, vector<vector<vector<vector<vector<double*> > > > > (n_pz, vector<vector<vector<vector<double*> > > > (n_set_TSV)));
    pointer_pdf_factor_combination_2.resize(n_pc, vector<vector<vector<vector<vector<double*> > > > > (n_pz, vector<vector<vector<vector<double*> > > > (n_set_TSV)));
    for (int i_c = 0; i_c < n_pc; i_c++){
      for (int i_z = 0; i_z < n_pz; i_z++){
	for (int i_s = 0; i_s < n_set_TSV; i_s++){
	  logger << LOG_DEBUG_VERBOSE << "n_scale_fact_TSV[" << i_s << "] = " << n_scale_fact_TSV[i_s] << endline_flush;
	  pointer_pdf_factor_combination_1[i_c][i_z][i_s].resize(n_scale_fact_TSV[i_s], vector<vector<double*> > (3));
	  pointer_pdf_factor_combination_2[i_c][i_z][i_s].resize(n_scale_fact_TSV[i_s], vector<vector<double*> > (3));
	  for (int i_f = 0; i_f < n_scale_fact_TSV[i_s]; i_f++){
	    for (int i_h = 0; i_h < 3; i_h++){
	      pointer_pdf_factor_combination_1[i_c][i_z][i_s][i_f][i_h].resize(CA_combination_pdf[i_c].size());
	      pointer_pdf_factor_combination_2[i_c][i_z][i_s][i_f][i_h].resize(CA_combination_pdf[i_c].size());
	      for (int i_i = 0; i_i < CA_combination_pdf[i_c].size(); i_i++){
		pointer_pdf_factor_combination_1[i_c][i_z][i_s][i_f][i_h][i_i] = &value_pdf_factor_combination_1[i_c][i_z][dynamic_scale_fact_TSV[i_s]][no_value_fact_TSV[i_s][i_f]][i_h][i_i];
		pointer_pdf_factor_combination_2[i_c][i_z][i_s][i_f][i_h][i_i] = &value_pdf_factor_combination_2[i_c][i_z][dynamic_scale_fact_TSV[i_s]][no_value_fact_TSV[i_s][i_f]][i_h][i_i];
	      }
	    }
	  }
	}
      }
    }

    logger << LOG_DEBUG_VERBOSE << "Initialization phase of value_pdf_factor_combination_1: finished" << endline_flush;

    
    for (int i_c = 0; i_c < n_pc; i_c++){
      for (int i_z = 0; i_z < n_pz; i_z++){
	for (int i_s = 0; i_s < n_set_TSV; i_s++){
	  for (int i_f = 0; i_f < n_scale_fact_TSV[i_s]; i_f++){
	    for (int i_h = 0; i_h < 3; i_h++){
	      for (int i_i = 0; i_i < CA_combination_pdf[i_c].size(); i_i++){
		logger << LOG_DEBUG_VERBOSE << "value_pdf_factor_combination_1[" << i_c << "][" << i_z << "][" << dynamic_scale_fact_TSV[i_s] << "][" << no_value_fact_TSV[i_s][i_f] << "][" << i_h << "][" << i_i << "] = " << value_pdf_factor_combination_1[i_c][i_z][dynamic_scale_fact_TSV[i_s]][no_value_fact_TSV[i_s][i_f]][i_h][i_i] << endline_flush;
		logger << LOG_DEBUG_VERBOSE << "value_pdf_factor_combination_2[" << i_c << "][" << i_z << "][" << dynamic_scale_fact_TSV[i_s] << "][" << no_value_fact_TSV[i_s][i_f] << "][" << i_h << "][" << i_i << "] = " << value_pdf_factor_combination_2[i_c][i_z][dynamic_scale_fact_TSV[i_s]][no_value_fact_TSV[i_s][i_f]][i_h][i_i] << endline_flush;
	      }
	    }
	  }
	}
      }
    }
  }

  logger << LOG_DEBUG << "initialization of pointers for renormalization/factorization dependent variables done" << endline_flush;
  */


  logger << LOG_DEBUG << "initialization of pointer_ME2term" << endline_flush;

  pointer_ME2term.resize(n_pc, vector<vector<vector<vector<double*> > > > (n_pz, vector<vector<vector<double*> > > (n_set_TSV)));
  for (int i_c = 0; i_c < n_pc; i_c++){
    for (int i_z = 0; i_z < n_pz; i_z++){
      for (int i_s = 0; i_s < n_set_TSV; i_s++){
	pointer_ME2term[i_c][i_z][i_s].resize(n_scale_ren_TSV[i_s]);
	for (int i_r = 0; i_r < n_scale_ren_TSV[i_s]; i_r++){
	  pointer_ME2term[i_c][i_z][i_s][i_r].resize(n_scale_fact_TSV[i_s]);
	  for (int i_f = 0; i_f < n_scale_fact_TSV[i_s]; i_f++){

	    // Born
	    if (csi->class_contribution_born ||
		csi->type_contribution == "loop" ||
		csi->type_contribution == "L2I"){
	      pointer_ME2term[i_c][i_z][i_s][i_r][i_f] = &value_ME2term[i_c];
	    }

	    // dipolesubtraction
	    else if (csi->class_contribution_CS_real){
	      pointer_ME2term[i_c][i_z][i_s][i_r][i_f] = &value_ME2term[i_c];
	    }
	    else if (csi->class_contribution_CS_virtual){
	      pointer_ME2term[i_c][i_z][i_s][i_r][i_f] = &value_ME2term_ren[i_c][dynamic_scale_ren_TSV[i_s]][no_value_ren_TSV[i_s][i_r]];
	    }
	    else if (csi->class_contribution_CS_collinear){
	      pointer_ME2term[i_c][i_z][i_s][i_r][i_f] = &value_ME2term_fact[i_c][i_z][dynamic_scale_fact_TSV[i_s]][no_value_fact_TSV[i_s][i_f]];
	    }

	    // qTsubtraction
	    else if (csi->class_contribution_QT_real){
	      pointer_ME2term[i_c][i_z][i_s][i_r][i_f] = &value_ME2term[i_c];
	    }
	    else if (csi->class_contribution_QT_virtual){
	      pointer_ME2term[i_c][i_z][i_s][i_r][i_f] = &value_ME2term_ren[i_c][dynamic_scale_ren_TSV[i_s]][no_value_ren_TSV[i_s][i_r]];
	    }
	    else if (csi->class_contribution_QT_collinear || csi->class_contribution_QT_powercorrection){
	      // Check if this is true for CT, CT2 and L2CT !!!
	      if (csi->type_contribution == "CT2" || csi->type_contribution == "PT2"){
		pointer_ME2term[i_c][i_z][i_s][i_r][i_f] = &value_ME2term_fact[i_c][i_z][dynamic_scale_fact_TSV[i_s]][no_value_fact_TSV[i_s][i_f]];
	      }
	      else {
		pointer_ME2term[i_c][i_z][i_s][i_r][i_f] = &value_ME2term[i_c];
	      }
	    }

	    else {logger << LOG_DEBUG << "No valid subcontribution!" << endline_flush; exit(1);}
	  }
	}
      }
    }
  }

  logger << LOG_DEBUG << "initialization of pointer_ME2term done" << endline_flush;

  logger.finished();
}





// All functions below are only relevant for CV variation:

void observable_set::initialization_basic_CV(){
  static Logger logger("observable_set::initialization_basic_CV");
  logger.called();

  scale_ren *= prefactor_reference;
  scale_fact *= prefactor_reference;

  if (switch_CV != 0){
    if (switch_CV == 1){variation_mu_ren_CV = 1; variation_mu_fact_CV = 1;}
    // equal variation of mu_ren and mu_fact
    else if (switch_CV == 2){variation_mu_ren_CV = 1; variation_mu_fact_CV = 0;}
    //  variation of mu_ren
    else if (switch_CV == 3){variation_mu_ren_CV = 0; variation_mu_fact_CV = 1;}
    //  variation of mu_fact
    else if (switch_CV == 4){variation_mu_ren_CV = 1; variation_mu_fact_CV = -1;}
    // antipodal variation of mu_ren and mu_fact
    else if (switch_CV == 5){variation_mu_ren_CV = 1; variation_mu_fact_CV = 1;}
    // 7-point variation of mu_ren and mu_fact
    else if (switch_CV == 6){variation_mu_ren_CV = 1; variation_mu_fact_CV = 1;}
    // 9-point variation of mu_ren and mu_fact
    else {logger << LOG_ERROR << "No correct switch_CV selected!" << endline_flush; exit(1);}
  }
  else {
    if (variation_mu_ren_CV == 0 && variation_mu_fact_CV == 0){}
    if (variation_mu_ren_CV == 1 && variation_mu_fact_CV == 1){switch_CV = 1;}
    // equal variation of mu_ren and mu_fact
    else if (variation_mu_ren_CV == 1 && variation_mu_fact_CV == 0){switch_CV = 2;}
    //  variation of mu_ren
    else if (variation_mu_ren_CV == 0 && variation_mu_fact_CV == 1){switch_CV = 3;}
    //  variation of mu_fact
    else if (variation_mu_ren_CV == 1 && variation_mu_fact_CV == -1){switch_CV = 4;}
    // antipodal variation of mu_ren and mu_fact
    else {switch_CV = 0; variation_mu_ren_CV = 0; variation_mu_fact_CV = 0;}
    //    else {logger << LOG_ERROR << "No correct switch_CV selected!" << endline_flush; exit(1);}
  }

  no_central_scale_CV = (n_scales_CV - 1) / 2; // !!! could be made element of observable_set
  directory_name_scale_CV.resize(n_scales_CV);
  for (int i_s = 0; i_s < n_scales_CV; i_s++){
    int j_s = n_scales_CV - i_s - 1;
    stringstream temp_ss;
    temp_ss << "scale";
    if (variation_mu_ren_CV == 1){temp_ss << "." << i_s;}
    if (variation_mu_ren_CV == 0){temp_ss << "." << no_central_scale_CV;}
    if (variation_mu_ren_CV == -1){temp_ss << "." << j_s;}

    if (variation_mu_fact_CV == 1){temp_ss << "." << i_s;}
    if (variation_mu_fact_CV == 0){temp_ss << "." << no_central_scale_CV;}
    if (variation_mu_fact_CV == -1){temp_ss << "." << j_s;}
    directory_name_scale_CV[i_s] = temp_ss.str();
  }

  logger << LOG_DEBUG << "switch_CV = " << switch_CV << endline_flush;
  logger << LOG_DEBUG << "variation_mu_ren_CV = " << variation_mu_ren_CV << endline_flush;
  logger << LOG_DEBUG << "variation_mu_fact_CV = " << variation_mu_fact_CV << endline_flush;

  logger.finished();
}

 
void observable_set::initialization_CV(){
  static Logger logger("observable_set::initialization_CV (---)");
  logger.called();

  ME2 = 0.;
  // why here ???

  if (switch_CV == 1){id_scales = 1;}
  else {id_scales = 0;}

  central_scale_CV = no_central_scale_CV;
  // should be identical !!! check if needed !!!

  mu_ren.resize(3);
  mu_fact.resize(3);
  mu_ren[0] = 1.;
  mu_ren[1] = scale_ren;
  mu_ren[2] = pow(scale_ren, 2);
  mu_fact[0] = log(mu_fact[2]);
  mu_fact[1] = scale_fact;
  mu_fact[2] = pow(scale_fact, 2);

  logger << LOG_DEBUG << "mu_ren[1] = " << mu_ren[1] << endline_flush;
  logger << LOG_DEBUG << "mu_fact[1] = " << mu_fact[1] << endline_flush;

  alpha_S = LHAPDF::alphasPDF(mu_ren[1]);
  logger << LOG_DEBUG << "alpha_S = " << alpha_S << endline_flush;

  if (switch_CV){
    scale_ren_CV.resize(n_scales_CV);
    scale_fact_CV.resize(n_scales_CV);

    mu_ren_CV.resize(3, vector<double> (n_scales_CV));
    mu_fact_CV.resize(3, vector<double> (n_scales_CV));

    rel_scale_factor_CV.resize(n_scales_CV);

    rel_scale_factor_ren_CV.resize(n_scales_CV);
    rel_scale_factor_fact_CV.resize(n_scales_CV);

    if (switch_CV < 5){
      for (int i_s = 0; i_s < n_scales_CV; i_s++){
	if (n_scales_CV > 1){rel_scale_factor_CV[i_s] = pow(10., log10(double(variation_factor_CV)) * double(2. * i_s / (n_scales_CV - 1) - 1));}
	else {rel_scale_factor_CV[i_s] = 1.;}
	rel_scale_factor_CV[i_s] = rel_scale_factor_CV[i_s] * prefactor_CV / prefactor_reference;  // check exact behaviour of reference !!!
      }

      for (int i_s = 0; i_s < n_scales_CV; i_s++){
	int j_s = n_scales_CV - i_s - 1;
	if (variation_mu_ren_CV == 1){
	  rel_scale_factor_ren_CV[i_s] = rel_scale_factor_CV[i_s];
	}
	if (variation_mu_ren_CV == 0){
	  rel_scale_factor_ren_CV[i_s] = prefactor_CV / prefactor_reference;
	}
	if (variation_mu_ren_CV == -1){
	  rel_scale_factor_ren_CV[i_s] = rel_scale_factor_CV[j_s];
	}
	if (variation_mu_fact_CV == 1){
	  rel_scale_factor_fact_CV[i_s] = rel_scale_factor_CV[i_s];
	}
	if (variation_mu_fact_CV == 0){
	  rel_scale_factor_fact_CV[i_s] = prefactor_CV / prefactor_reference;
	}
	if (variation_mu_fact_CV == -1){
	  rel_scale_factor_fact_CV[i_s] = rel_scale_factor_CV[j_s];
	}
      }
      for (int i_s = 0; i_s < n_scales_CV; i_s++){
	logger << LOG_DEBUG << "rel_scale_factor_fact_CV[" << i_s << "] = " << rel_scale_factor_fact_CV[i_s] << endline_flush;
      }
      for (int i_s = 0; i_s < n_scales_CV; i_s++){
	logger << LOG_DEBUG << "rel_scale_factor_ren_CV[" << i_s << "] = " << rel_scale_factor_ren_CV[i_s] << endline_flush;
      }
    }
      
    else if (switch_CV == 5 && n_scales_CV != 1){ // 7-point variation
      assert(n_scales_CV==7);

      rel_scale_factor_ren_CV[0] = 1.0/variation_factor_CV;
      rel_scale_factor_ren_CV[1] = 1.0/variation_factor_CV;
      rel_scale_factor_ren_CV[2] = variation_factor_CV;
      rel_scale_factor_ren_CV[3] = 1;
      rel_scale_factor_ren_CV[4] = 1;
      rel_scale_factor_ren_CV[5] = 1;
      rel_scale_factor_ren_CV[6] = variation_factor_CV;

      rel_scale_factor_fact_CV[0] = 1.0/variation_factor_CV;
      rel_scale_factor_fact_CV[1] = 1;
      rel_scale_factor_fact_CV[2] = 1;
      rel_scale_factor_fact_CV[3] = 1;
      rel_scale_factor_fact_CV[4] = variation_factor_CV;
      rel_scale_factor_fact_CV[5] = 1.0/variation_factor_CV;
      rel_scale_factor_fact_CV[6] = variation_factor_CV;


      for (int i_s = 0; i_s < n_scales_CV; i_s++){  // check exact behaviour of reference !!!
	rel_scale_factor_ren_CV[i_s] = rel_scale_factor_ren_CV[i_s] * prefactor_CV / prefactor_reference;
	rel_scale_factor_fact_CV[i_s] = rel_scale_factor_fact_CV[i_s] * prefactor_CV / prefactor_reference;
      }
    }
    // 9-pt variation
    else if (switch_CV == 6 && n_scales_CV != 1) {
      assert(n_scales_CV==9);

      rel_scale_factor_ren_CV[0] = 1.0/variation_factor_CV;
      rel_scale_factor_ren_CV[1] = 1.0/variation_factor_CV;
      rel_scale_factor_ren_CV[2] = 1.0/variation_factor_CV;
      rel_scale_factor_ren_CV[3] = variation_factor_CV;
      rel_scale_factor_ren_CV[4] = 1;
      rel_scale_factor_ren_CV[5] = 1;
      rel_scale_factor_ren_CV[6] = 1;
      rel_scale_factor_ren_CV[7] = variation_factor_CV;
      rel_scale_factor_ren_CV[8] = variation_factor_CV;

      rel_scale_factor_fact_CV[0] = variation_factor_CV;
      rel_scale_factor_fact_CV[1] = 1.0/variation_factor_CV;
      rel_scale_factor_fact_CV[2] = 1;
      rel_scale_factor_fact_CV[3] = 1;
      rel_scale_factor_fact_CV[4] = 1;
      rel_scale_factor_fact_CV[5] = variation_factor_CV;
      rel_scale_factor_fact_CV[6] = 1.0/variation_factor_CV;
      rel_scale_factor_fact_CV[7] = variation_factor_CV;
      rel_scale_factor_fact_CV[8] = 1.0/variation_factor_CV;

      for (int i_s = 0; i_s < n_scales_CV; i_s++){  // check exact behaviour of reference !!!
	rel_scale_factor_ren_CV[i_s] = rel_scale_factor_ren_CV[i_s] * prefactor_CV / prefactor_reference;
	rel_scale_factor_fact_CV[i_s] = rel_scale_factor_fact_CV[i_s] * prefactor_CV / prefactor_reference;
      }

    }
    else {
      logger << LOG_FATAL << "No valid CV settings. Aborted." << endline_flush;
      exit(1);
    }

    for (int i_s = 0; i_s < n_scales_CV; i_s++){
      scale_ren_CV[i_s] = rel_scale_factor_ren_CV[i_s] * scale_ren;
      scale_fact_CV[i_s] = rel_scale_factor_fact_CV[i_s] * scale_fact;

      mu_ren_CV[0][i_s] = 1.;
      mu_ren_CV[1][i_s] = scale_ren_CV[i_s];
      mu_ren_CV[2][i_s] = pow(scale_ren_CV[i_s], 2);

      mu_fact_CV[1][i_s] = scale_fact_CV[i_s];
      mu_fact_CV[2][i_s] = pow(scale_fact_CV[i_s], 2);
      mu_fact_CV[0][i_s] = log(mu_fact_CV[2][i_s]);
    }

    for (int i_s = 0; i_s < n_scales_CV; i_s++){
      logger << LOG_DEBUG << "scale_fact_CV[" << i_s << "] = " << scale_fact_CV[i_s] << endline_flush;
    }
    for (int i_s = 0; i_s < n_scales_CV; i_s++){
      logger << LOG_DEBUG << "scale_ren_CV[" << i_s << "] = " << scale_ren_CV[i_s] << endline_flush;
    }

  }

  if (switch_CV){
    alpha_S_CV.resize(csi->contribution_order_alpha_s + 1, vector<double> (n_scales_CV));
    rel_alpha_S_CV.resize(csi->contribution_order_alpha_s + 1, vector<double> (n_scales_CV));

    for (int i_s = 0; i_s < n_scales_CV; i_s++){
      alpha_S_CV[0][i_s] = 1.;
      rel_alpha_S_CV[0][i_s] = 1.;
      if (csi->contribution_order_alpha_s == 0){continue;}

      if (variation_mu_ren_CV == 0){
	alpha_S_CV[1][i_s] = LHAPDF::alphasPDF(mu_ren_CV[1][i_s]);
	for (int i_o = 2; i_o < alpha_S_CV.size(); i_o++){alpha_S_CV[i_o][i_s] = pow(alpha_S_CV[1][i_s], i_o);}
	for (int i_o = 1; i_o < rel_alpha_S_CV.size(); i_o++){rel_alpha_S_CV[i_o][i_s] = alpha_S_CV[1][i_s] / alpha_S;}
      }
      else {
	if (variation_mu_ren_CV == 1){
	  alpha_S_CV[1][i_s] = LHAPDF::alphasPDF(mu_ren_CV[1][i_s]);
	}
	else if (variation_mu_ren_CV == -1){
	  int j_s = n_scales_CV - i_s - 1;
	  alpha_S_CV[1][i_s] = LHAPDF::alphasPDF(mu_ren_CV[1][j_s]);
	}
	for (int i_o = 2; i_o < alpha_S_CV.size(); i_o++){alpha_S_CV[i_o][i_s] = pow(alpha_S_CV[1][i_s], i_o);}
	rel_alpha_S_CV[1][i_s] = alpha_S_CV[1][i_s] / alpha_S;
	for (int i_o = 2; i_o < rel_alpha_S_CV.size(); i_o++){rel_alpha_S_CV[i_o][i_s] = pow(rel_alpha_S_CV[1][i_s], i_o);}
      }
    }

    // new scale calculation not yet tested !!! only output:
    for (int i_s = 0; i_s < n_scales_CV; i_s++){
      if (csi->contribution_order_alpha_s == 0){continue;}
      logger << LOG_DEBUG << "alpha_S(" << setw(23) << setprecision(15) << mu_ren_CV[1][i_s] << ") = " << setw(23) << setprecision(15) << alpha_S_CV[1][i_s] << "   rel_alpha_S = " << setw(23) << setprecision(15) << rel_alpha_S_CV[1][i_s] << endline_flush;
    }
    logger.newLine(LOG_DEBUG);

    map_value_scale_fact_CV.resize(n_scales_CV);
  }

  initialization_scale_fact_CV();

  value_mu_fact = value_mu_fact_rel;  //  most likely only to have same vector size !!!

  if (switch_CV){
    if (value_mu_fact[0].size() != 0){
      for (int i_s = 0; i_s < value_mu_fact[0].size(); i_s++){
	if (variation_mu_fact_CV == 0){value_mu_fact[0][i_s] = value_mu_fact_central[0];}
	else if (variation_mu_fact_CV == 1){value_mu_fact[0][i_s] = value_mu_fact_central[0] * value_mu_fact_rel[0][i_s];}
	else if (variation_mu_fact_CV == -1){value_mu_fact[0][i_s] = value_mu_fact_central[0] * value_mu_fact_rel[0][i_s];}
	//!!!      else if (variation_mu_fact_CV == -1){value_mu_fact[0][i_s] = value_mu_fact_central[0] / value_mu_fact_rel[0][i_s];}
	logger << LOG_DEBUG << "value_mu_fact[0][" << i_s << "] = " << value_mu_fact[0][i_s] << endline_flush;
      }
    }

    map_value_scale_ren_CV.resize(n_scales_CV);
  }

  initialization_scale_ren_CV();
  
  value_mu_ren = value_mu_ren_rel;  //  most likely only to have same vector size !!!
  value_alpha_S = value_mu_ren;  //  most likely only to have same vector size !!!
  value_factor_alpha_S = value_mu_ren;  //  most likely only to have same vector size !!!


  if (value_mu_ren[0].size() != 0){
    for (int i_s = 0; i_s < value_mu_ren[0].size(); i_s++){
      if (switch_CV){
	if (variation_mu_ren_CV == 0){value_mu_ren[0][i_s] = value_mu_ren_central[0];}
	else if (variation_mu_ren_CV == 1){value_mu_ren[0][i_s] = value_mu_ren_central[0] * value_mu_ren_rel[0][i_s];}
	else if (variation_mu_ren_CV == -1){value_mu_ren[0][i_s] = value_mu_ren_central[0] * value_mu_ren_rel[0][i_s];}
      }
      //!!!      else if (variation_mu_ren_CV == -1){value_mu_ren[0][i_s] = value_mu_ren_central[0] / value_mu_ren_rel[0][i_s];}
      value_alpha_S[0][i_s] = LHAPDF::alphasPDF(value_mu_ren[0][i_s]);
      value_factor_alpha_S[0][i_s] = pow(value_alpha_S[0][i_s] / alpha_S, csi->contribution_order_alpha_s);

      logger << LOG_DEBUG << "value_mu_ren[0][" << i_s << "] = " << value_mu_ren[0][i_s] << "   value_alpha_S[0][" << i_s << "] = " << value_alpha_S[0][i_s] << endline_flush;
    }
  }

  var_mu_fact = mu_fact[1];
  var_mu_ren = mu_ren[1];
  var_alpha_S_reference = LHAPDF::alphasPDF(var_mu_ren);
  var_rel_alpha_S = 1.;

  if (switch_CV){
    // should be removed when ...value.. is completely installed! ???
    // used at all ???
    var_mu_ren_CV.resize(n_scales_CV);
    var_mu_fact_CV.resize(n_scales_CV);
    var_alpha_S_CV.resize(n_scales_CV);
    var_rel_alpha_S_CV.resize(n_scales_CV);

    var_mu_fact_CV = mu_fact_CV[1];
    var_mu_ren_CV = mu_ren_CV[1];
    var_alpha_S_CV = alpha_S_CV[csi->contribution_order_alpha_s];
    var_rel_alpha_S_CV = rel_alpha_S_CV[csi->contribution_order_alpha_s];
  }

  pdf_factor.resize(3);
  if (switch_CV){
    pdf_factor_CV.resize(n_scales_CV, vector<double> (3));
  }

  Xsection = 0;
  Xsection_delta = 0;
  if (switch_CV){
    Xsection_CV.resize(n_qTcut, vector<double> (n_scales_CV, 0.));
    Xsection_delta_CV.resize(n_qTcut, vector<double> (n_scales_CV, 0.));
  }

  if (switch_moment){
    Xsection_moment.resize(n_moments, 0.);
    Xsection_moment_delta.resize(n_moments, 0.);
    if (switch_CV){
      Xsection_moment_CV.resize(n_moments, vector<vector<double> > (n_qTcut, vector<double> (n_scales_CV, 0.)));
      Xsection_moment_delta_CV.resize(n_moments, vector<vector<double> > (n_qTcut, vector<double> (n_scales_CV, 0.)));
    }
  }

  // Shift to output function
  for (int i = 0; i < value_mu_fact_rel.size(); i++){
    logger << LOG_DEBUG << "value_mu_fact_central[" << setw(2) << i << "] = " << setw(25) << value_mu_fact_central[i] << endline_flush;
    for (int j = 0; j < value_mu_fact_rel[i].size(); j++){
      logger << LOG_DEBUG << "value_mu_fact_rel[" << setw(2) << i << "][" << setw(2) << j << "] = " << setw(25) << value_mu_fact_rel[i][j] << endline_flush;
    }
  }
  if (value_mu_fact[0].size() != 0){
    for (int j = 0; j < value_mu_fact_rel[0].size(); j++){
      logger << LOG_DEBUG << "value_mu_fact[" << setw(2) << 0 << "][" << setw(2) << j << "] = " << setw(25) << value_mu_fact[0][j] << endline_flush;
    }
  }
  logger << LOG_DEBUG << endline_flush;
  logger << LOG_DEBUG << "map_value_scale_fact = " << map_value_scale_fact << endline_flush;
  logger << LOG_DEBUG << endline_flush;
  if (switch_CV){
    for (int s = 0; s < n_scales_CV; s++){
      logger << LOG_DEBUG << "map_value_scale_fact_CV[" << s << "] = " << map_value_scale_fact_CV[s] << endline_flush;
    }
    logger << LOG_DEBUG << endline_flush;
    logger.newLine(LOG_DEBUG);
  }

  for (int i = 0; i < value_mu_ren_rel.size(); i++){
    logger << LOG_DEBUG << "value_mu_ren_central[" << setw(2) << i << "] = " << setw(25) << value_mu_ren_central[i] << endline_flush;
    for (int j = 0; j < value_mu_ren_rel[i].size(); j++){
      logger << LOG_DEBUG << "value_mu_ren_rel[" << setw(2) << i << "][" << setw(2) << j << "] = " << setw(25) << value_mu_ren_rel[i][j] << endline_flush;
    }
  }
  if (value_mu_ren[0].size() != 0){
    for (int j = 0; j < value_mu_ren_rel[0].size(); j++){
      logger << LOG_DEBUG << "value_mu_ren[" << setw(2) << 0 << "][" << setw(2) << j << "] = " << setw(25) << value_mu_ren[0][j] << endline_flush;
    }
    for (int j = 0; j < value_mu_ren_rel[0].size(); j++){
      logger << LOG_DEBUG << "value_alpha_S[" << setw(2) << 0 << "][" << setw(2) << j << "] = " << setw(25) << value_alpha_S[0][j] << endline_flush;
    }
    for (int j = 0; j < value_mu_ren_rel[0].size(); j++){
      logger << LOG_DEBUG << "value_factor_alpha_S[" << setw(2) << 0 << "][" << setw(2) << j << "] = " << setw(25) << value_factor_alpha_S[0][j] << endline_flush;
    }
  }
  logger << LOG_DEBUG << endline_flush;
  logger << LOG_DEBUG << "map_value_scale_ren = " << map_value_scale_ren << endline_flush;
  logger << LOG_DEBUG << endline_flush;
  if (switch_CV){
    for (int s = 0; s < n_scales_CV; s++){
      logger << LOG_DEBUG << "map_value_scale_ren_CV[" << s << "] = " << map_value_scale_ren_CV[s] << endline_flush;
    }
    logger << LOG_DEBUG << endline_flush;
  }
  logger << LOG_DEBUG << "id_scales = " << id_scales << endline_flush;

  logger.finished();
}


void observable_set::initialization_scale_fact_CV(){
  static Logger logger("observable_set::initialization_scale_fact_CV");
  logger.called();

  int max_dyn = 0;
  if (dynamic_scale > max_dyn){max_dyn = dynamic_scale;}

  if (switch_CV){if (dynamic_scale_CV > max_dyn){max_dyn = dynamic_scale_CV;}}

  value_mu_fact_rel.resize(max_dyn + 1);
  value_mu_fact_central.resize(max_dyn + 1);
  value_mu_fact_central[dynamic_scale] = mu_fact[1];

  if (switch_CV){
    if (dynamic_scale != dynamic_scale_CV){
      value_mu_fact_central[dynamic_scale_CV] = mu_fact_CV[1][no_central_scale_CV];  // check !!!
    }
  }

  logger << LOG_DEBUG << "value_mu_fact_central[dynamic_scale = " << dynamic_scale << "] = " << value_mu_fact_central[dynamic_scale] << endline_flush;
  if (switch_CV){
    logger << LOG_DEBUG << "value_mu_fact_central[dynamic_scale_CV = " << dynamic_scale_CV << "] = " << value_mu_fact_central[dynamic_scale_CV] << endline_flush;
  }

  for (int i = 0; i < value_mu_fact_central.size(); i++){
    logger << LOG_DEBUG << "value_mu_fact_central[" << dynamic_scale << "] = " << value_mu_fact_central[dynamic_scale] << endline_flush;
  }
  vector<double> rel_scale_CV(n_scales_CV);
  int flag = 0;
  logger << LOG_DEBUG_VERBOSE << "value_mu_fact_rel[" << dynamic_scale << "].size() = " << value_mu_fact_rel[dynamic_scale].size() << endline_flush;
  for (int i = 0; i < value_mu_fact_rel[dynamic_scale].size(); i++){
    if (abs(value_mu_fact_rel[dynamic_scale][i] - mu_fact[1] / value_mu_fact_central[dynamic_scale]) < 1.e-15){flag = 1; break;}
  }
  if (flag == 0){value_mu_fact_rel[dynamic_scale].push_back(mu_fact[1] / value_mu_fact_central[dynamic_scale]);}

  logger << LOG_DEBUG_VERBOSE << "value_mu_fact_rel[" << dynamic_scale << "].size() = " << value_mu_fact_rel[dynamic_scale].size() << endline_flush;
  for (int i_s = 0; i_s < value_mu_fact_rel[dynamic_scale].size(); i_s++){
    logger << LOG_DEBUG << "value_mu_fact_rel[" << dynamic_scale << "][" << i_s << "] = " << value_mu_fact_rel[dynamic_scale][i_s] << endline_flush;
  }

  if (switch_CV){
    for (int s = 0; s < n_scales_CV;s++){
      logger << LOG_DEBUG_VERBOSE << "CV   s = " << s << "   value_mu_fact_rel[" << dynamic_scale_CV << "].size() = " << value_mu_fact_rel[dynamic_scale_CV].size() << endline_flush;
      flag = 0;
      if (switch_CV == 5){
	rel_scale_CV[0] = 1. / variation_factor_CV;
	rel_scale_CV[1] = 1.;
	rel_scale_CV[2] = 1.;
	rel_scale_CV[3] = 1.;
	rel_scale_CV[4] = variation_factor_CV;
	rel_scale_CV[5] = 1. / variation_factor_CV;
	rel_scale_CV[6] = variation_factor_CV;
      }
      else if (switch_CV == 6){
	rel_scale_CV[0] = variation_factor_CV;
	rel_scale_CV[1] = 1. / variation_factor_CV;
	rel_scale_CV[2] = 1.;
	rel_scale_CV[3] = 1.;
	rel_scale_CV[4] = 1.;
	rel_scale_CV[5] = variation_factor_CV;
	rel_scale_CV[6] = 1. / variation_factor_CV;
	rel_scale_CV[7] = variation_factor_CV;
	rel_scale_CV[8] = 1. / variation_factor_CV;
      }
      // check !!!
      else if (variation_mu_fact_CV == 0){
	rel_scale_CV[s] = 1.;
      }
      else if (variation_mu_fact_CV == -1){
	if (n_scales_CV > 1){rel_scale_CV[s] = pow(10., log10(double(variation_factor_CV)) * double(2. * (n_scales_CV - 1 - s) / (n_scales_CV - 1) - 1));}
	else {rel_scale_CV[s] = 1.;}
      }
      else {
	if (n_scales_CV > 1){rel_scale_CV[s] = pow(10., log10(double(variation_factor_CV)) * double(2. * s / (n_scales_CV - 1) - 1));}
	else {rel_scale_CV[s] = 1.;}
      }

      for (int i = 0; i < value_mu_fact_rel[dynamic_scale_CV].size(); i++){
	if (abs(value_mu_fact_rel[dynamic_scale_CV][i] / rel_scale_CV[s] - mu_fact_CV[1][no_central_scale_CV] / value_mu_fact_central[dynamic_scale_CV]) < 1.e-15){flag = 1; break;}
      }
      if (flag == 0){value_mu_fact_rel[dynamic_scale_CV].push_back(rel_scale_CV[s] * mu_fact_CV[1][no_central_scale_CV] / value_mu_fact_central[dynamic_scale_CV]);}
      logger << LOG_DEBUG_VERBOSE << "CV TEST   s = " << s << "   value_mu_fact_rel[" << dynamic_scale_CV << "].size() = " << value_mu_fact_rel[dynamic_scale_CV].size() << endline_flush;
    }

    for (int i_s = 0; i_s < value_mu_fact_rel[dynamic_scale_CV].size(); i_s++){
      logger << LOG_DEBUG << "value_mu_fact_rel[" << dynamic_scale_CV << "][" << i_s << "] = " << value_mu_fact_rel[dynamic_scale_CV][i_s] << endline_flush;
    }
  }

  for (int j = 0; j < max_dyn + 1; j++){sort (value_mu_fact_rel[j].begin(), value_mu_fact_rel[j].end());}

  if (switch_CV){
    for (int i_s = 0; i_s < value_mu_fact_rel[dynamic_scale_CV].size(); i_s++){
      logger << LOG_DEBUG << "value_mu_fact_rel[" << dynamic_scale_CV << "][" << i_s << "] = " << value_mu_fact_rel[dynamic_scale_CV][i_s] << endline_flush;
    }
  }

  for (int i = 0; i < value_mu_fact_rel[dynamic_scale].size(); i++){
    if (abs(value_mu_fact_rel[dynamic_scale][i] - mu_fact[1] / value_mu_fact_central[dynamic_scale]) < 1.e-15){map_value_scale_fact = i;}
  }
  logger << LOG_DEBUG << "dynamic_scale = " << dynamic_scale << "   map_value_scale_fact = " << map_value_scale_fact << endline_flush;

  if (switch_CV){
    for (int s = 0; s < n_scales_CV;s++){
      for (int i = 0; i < value_mu_fact_rel[dynamic_scale_CV].size(); i++){
	if (abs(value_mu_fact_rel[dynamic_scale_CV][i] / rel_scale_CV[s] - mu_fact_CV[1][no_central_scale_CV] / value_mu_fact_central[dynamic_scale_CV]) < 1.e-15){map_value_scale_fact_CV[s] = i;}
      }
      logger << LOG_DEBUG << "dynamic_scale_CV = " << dynamic_scale_CV << "   map_value_scale_fact_CV[" << s << "] = " << map_value_scale_fact_CV[s] << endline_flush;
    }
  }

  if (dynamic_scale){
    for (int ss = 0; ss < value_mu_fact_rel[dynamic_scale].size(); ss++) {
      value_mu_fact_rel[dynamic_scale][ss] *= prefactor_reference;  // check behaviour of prefactor_reference !!!
    }
  }

  logger << LOG_DEBUG << "dynamic_scale_CV = " << dynamic_scale_CV << endline_flush;
  if (!dynamic_scale && (switch_CV && dynamic_scale_CV)){
    for (int ss = 0; ss < value_mu_fact_rel[dynamic_scale_CV].size(); ss++) {
      value_mu_fact_rel[dynamic_scale_CV][ss] *= prefactor_CV;  // check behaviour of prefactor_reference !!!
    }
  }

  logger.finished();
}

 
void observable_set::initialization_scale_ren_CV(){
  static Logger logger("observable_set::initialization_scale_ren_CV");
  logger.called();

  int max_dyn = 0;
  if (dynamic_scale > max_dyn){max_dyn = dynamic_scale;}

  if (switch_CV){if (dynamic_scale_CV > max_dyn){max_dyn = dynamic_scale_CV;}}

  value_mu_ren_rel.resize(max_dyn + 1);
  value_mu_ren_central.resize(max_dyn + 1);
  value_mu_ren_central[dynamic_scale] = mu_ren[1];

  if (switch_CV){
    if (dynamic_scale != dynamic_scale_CV){
      value_mu_ren_central[dynamic_scale_CV] = mu_ren_CV[1][no_central_scale_CV];
    }
  }

  logger << LOG_DEBUG << "value_mu_ren_central[dynamic_scale = " << dynamic_scale << "] = " << value_mu_ren_central[dynamic_scale] << endline_flush;
  if (switch_CV){
    logger << LOG_DEBUG << "value_mu_ren_central[dynamic_scale_CV = " << dynamic_scale_CV << "] = " << value_mu_ren_central[dynamic_scale_CV] << endline_flush;
  }

  // Could be a member variable ???
  vector<double> rel_scale_CV;

  int flag = 0;
  logger << LOG_DEBUG_VERBOSE << "value_mu_ren_rel[" << dynamic_scale << "].size() = " << value_mu_ren_rel[dynamic_scale].size() << endline_flush;
  for (int i = 0; i < value_mu_ren_rel[dynamic_scale].size(); i++){
    if (abs(value_mu_ren_rel[dynamic_scale][i] - mu_ren[1] / value_mu_ren_central[dynamic_scale]) < 1.e-15){flag = 1; break;}
  }
  if (flag == 0){value_mu_ren_rel[dynamic_scale].push_back(mu_ren[1] / value_mu_ren_central[dynamic_scale]);}

  logger << LOG_DEBUG_VERBOSE << "value_mu_ren_rel[" << dynamic_scale << "].size() = " << value_mu_ren_rel[dynamic_scale].size() << endline_flush;
  for (int i_s = 0; i_s < value_mu_ren_rel[dynamic_scale].size(); i_s++){
    logger << LOG_DEBUG << "value_mu_ren_rel[" << dynamic_scale << "][" << i_s << "] = " << value_mu_ren_rel[dynamic_scale][i_s] << endline_flush;
  }

  if (switch_CV){
    rel_scale_CV.resize(n_scales_CV);
    for (int s = 0; s < n_scales_CV; s++){
      logger << LOG_DEBUG_VERBOSE << "s = " << s << "   value_mu_ren_rel[" << dynamic_scale_CV << "].size() = " << value_mu_ren_rel[dynamic_scale_CV].size() << endline_flush;
      flag = 0;
      if (switch_CV == 5){
        rel_scale_CV[0] = 1. / variation_factor_CV;
        rel_scale_CV[1] = 1. / variation_factor_CV;
        rel_scale_CV[2] = variation_factor_CV;
        rel_scale_CV[3] = 1.;
        rel_scale_CV[4] = 1.;
        rel_scale_CV[5] = 1.;
        rel_scale_CV[6] = variation_factor_CV;
      }
      else if (switch_CV == 6){
        rel_scale_CV[0] = 1. / variation_factor_CV;
        rel_scale_CV[1] = 1. / variation_factor_CV;
        rel_scale_CV[2] = 1. / variation_factor_CV;
        rel_scale_CV[3] = variation_factor_CV;
        rel_scale_CV[4] = 1.;
        rel_scale_CV[5] = 1.;
        rel_scale_CV[6] = 1.;
        rel_scale_CV[7] = variation_factor_CV;
        rel_scale_CV[8] = variation_factor_CV;
      }
      // !!!
      else if (variation_mu_ren_CV == 0){
	rel_scale_CV[s] = 1.;
      }
      else if (variation_mu_ren_CV == -1){
	if (n_scales_CV > 1){rel_scale_CV[s] = pow(10., log10(double(variation_factor_CV)) * double(2. * (n_scales_CV - 1 - s) / (n_scales_CV - 1) - 1));}
	else {rel_scale_CV[s] = 1.;}
      }
      else {
	if (n_scales_CV > 1){rel_scale_CV[s] = pow(10., log10(double(variation_factor_CV)) * double(2. * s / (n_scales_CV - 1) - 1));}
	else {rel_scale_CV[s] = 1.;}
      }

      for (int i = 0; i < value_mu_ren_rel[dynamic_scale_CV].size(); i++){
	if (abs(value_mu_ren_rel[dynamic_scale_CV][i] / rel_scale_CV[s] - mu_ren_CV[1][no_central_scale_CV] / value_mu_ren_central[dynamic_scale_CV]) < 1.e-15){flag = 1; break;}
      }
      if (flag == 0){value_mu_ren_rel[dynamic_scale_CV].push_back(rel_scale_CV[s] * mu_ren_CV[1][no_central_scale_CV] / value_mu_ren_central[dynamic_scale_CV]);}
      logger << LOG_DEBUG_VERBOSE << "s = " << s << "   value_mu_ren_rel[" << dynamic_scale_CV << "].size() = " << value_mu_ren_rel[dynamic_scale_CV].size() << endline_flush;
    }

    for (int i_s = 0; i_s < value_mu_ren_rel[dynamic_scale_CV].size(); i_s++){
      logger << LOG_DEBUG << "value_mu_ren_rel[" << dynamic_scale_CV << "][" << i_s << "] = " << value_mu_ren_rel[dynamic_scale_CV][i_s] << endline_flush;
    }
  }

  for (int j = 0; j < max_dyn + 1; j++){sort (value_mu_ren_rel[j].begin(), value_mu_ren_rel[j].end());}
  for (int i = 0; i < value_mu_ren_rel[dynamic_scale].size(); i++){
    if (abs(value_mu_ren_rel[dynamic_scale][i] - mu_ren[1] / value_mu_ren_central[dynamic_scale]) < 1.e-15){map_value_scale_ren = i;}
  }
  logger << LOG_DEBUG << "dynamic_scale = " << dynamic_scale << "   map_value_scale_ren = " << map_value_scale_ren << endline_flush;

  if (switch_CV){
    for (int s = 0; s < n_scales_CV;s++){
      for (int i = 0; i < value_mu_ren_rel[dynamic_scale_CV].size(); i++){
	if (abs(value_mu_ren_rel[dynamic_scale_CV][i] / rel_scale_CV[s] - mu_ren_CV[1][no_central_scale_CV] / value_mu_ren_central[dynamic_scale_CV]) < 1.e-15){map_value_scale_ren_CV[s] = i;}
      }
      logger << LOG_DEBUG << "dynamic_scale_CV = " << dynamic_scale_CV << "   map_value_scale_ren_CV[" << s << "] = " << map_value_scale_ren_CV[s] << endline_flush;
    }
  }

  if (dynamic_scale){// && !dynamic_scale_CV) {
    for (int ss = 0; ss < value_mu_ren_rel[dynamic_scale].size(); ss++) {
      value_mu_ren_rel[dynamic_scale][ss] *= prefactor_reference;  // check exact behaviour of reference !!!
    }
  }
  if (!dynamic_scale && (switch_CV && dynamic_scale_CV)){
    for (int ss = 0; ss < value_mu_ren_rel[dynamic_scale_CV].size(); ss++) {
      value_mu_ren_rel[dynamic_scale_CV][ss] *= prefactor_CV;  // check exact behaviour of reference !!!
    }
  }

  logger.finished();
}

