#include "header.hpp"
#include "mapping.fullchannel.hpp"

mapping_fullchannel::mapping_fullchannel(){
  static Logger logger("mapping_fullchannel::mapping_fullchannel");
  logger.called();

  if (Log::getLogThreshold() <= LOG_DEBUG_VERBOSE){ logger << LOG_DEBUG_VERBOSE << "constructor called..." << endline_flush; }
 
  logger.finished();
}

mapping_fullchannel::mapping_fullchannel(int _x_fullchannel, int _x_a, vector<int> _x_p, vector<int> _x_f, vector<int> _x_t, vector<int> _x_d, phasespace_set * _psi){
  static Logger logger("mapping_fullchannel::mapping_fullchannel (x_fullchannel, x_a, out, psi)");
  logger.called();

  if (Log::getLogThreshold() <= LOG_DEBUG_VERBOSE){ logger << LOG_DEBUG_VERBOSE << "constructor called..." << endline_flush; }

  initialization(_x_fullchannel, _x_a, _x_p, _x_f, _x_t, _x_d, _psi);

  logger.finished();
}

mapping_fullchannel::~mapping_fullchannel(){
  static Logger logger("mapping_fullchannel::~mapping_fullchannel");
  logger.called();

  if (Log::getLogThreshold() <= LOG_DEBUG_VERBOSE){ logger << LOG_DEBUG_VERBOSE << "destructor called..." << endline_flush; }

  logger.finished();
}


void mapping_fullchannel::initialization(int _x_fullchannel, int _x_a, string & content, phasespace_set * _psi){
  static Logger logger("mapping_fullchannel::initialization (x_fullchannel, x_a, content, psi)");
  logger.called();

  //  vector<string> entries(1);
  logger << LOG_DEBUG << "content = " << content << endline_flush;
  vector<vector<string> > entries_per_variable(1, vector<string> (1, ""));
  for (size_t i_i = 0; i_i < content.size(); i_i++){
    size_t x_i1 = entries_per_variable.size() - 1;
    size_t x_i2 = entries_per_variable[x_i1].size() - 1;
    logger << LOG_DEBUG << "i_i = " << i_i << "   x_i1 = " << x_i1 << "   x_i2 = " << x_i2 << " : before:   entries_per_variable[" << x_i1 << "][" << x_i2 << "] = " << char(34) << entries_per_variable[x_i1][x_i2] << char(34) << endline_flush; 
    if (content[i_i] == ' ' && entries_per_variable[x_i1][x_i2] != ""){ entries_per_variable[x_i1].push_back(""); }
    else if (content[i_i] == '-'){ entries_per_variable.push_back(vector<string> (1, "")); }
    else if (content[i_i] != ' '){ entries_per_variable[x_i1][x_i2].push_back(content[i_i]); }
    logger << LOG_DEBUG << "i_i = " << i_i << "   x_i1 = " << x_i1 << "   x_i2 = " << x_i2 << " : after:    entries_per_variable[" << x_i1 << "][" << x_i2 << "] = " << char(34) << entries_per_variable[x_i1][x_i2] << char(34) << endline_flush; 
  }
  if (entries_per_variable.size() != 4){ logger << LOG_FATAL << "fullchannel[" << _x_fullchannel << "][" << _x_a << "]  does not have the right content!" << endline_flush; }
  for (size_t i_i = 0; i_i < entries_per_variable.size(); i_i++){ logger << LOG_DEBUG << "A entries_per_variable[" << i_i << "].size() = " << entries_per_variable[i_i].size() << endline_flush; }

  for (size_t i_i = 0; i_i < entries_per_variable.size(); i_i++){ entries_per_variable[i_i].pop_back(); }
  for (size_t i_i = 0; i_i < entries_per_variable.size(); i_i++){ logger << LOG_DEBUG << "B entries_per_variable[" << i_i << "].size() = " << entries_per_variable[i_i].size() << endline_flush; }

  for (size_t i_i = 0; i_i < entries_per_variable.size(); i_i++){ if (entries_per_variable[i_i].size() > 0){ if (entries_per_variable[i_i][entries_per_variable[i_i].size() - 1] == ""){ entries_per_variable[i_i].pop_back(); } } }
  for (size_t i_i = 0; i_i < entries_per_variable.size(); i_i++){ logger << LOG_DEBUG << "C entries_per_variable[" << i_i << "].size() = " << entries_per_variable[i_i].size() << endline_flush; }

  vector<int> _x_p(entries_per_variable[0].size(), 0);
  for (int i_i = 0; i_i < entries_per_variable[0].size(); i_i++){ _x_p[i_i] = atoi(entries_per_variable[0][i_i].c_str()); }
  vector<int> _x_f(entries_per_variable[1].size(), 0);
  for (int i_i = 0; i_i < entries_per_variable[1].size(); i_i++){ _x_f[i_i] = atoi(entries_per_variable[1][i_i].c_str()); }
  vector<int> _x_t(entries_per_variable[2].size(), 0);
  for (int i_i = 0; i_i < entries_per_variable[2].size(); i_i++){ _x_t[i_i] = atoi(entries_per_variable[2][i_i].c_str()); }
  vector<int> _x_d(entries_per_variable[3].size(), 0);
  for (int i_i = 0; i_i < entries_per_variable[3].size(); i_i++){ _x_d[i_i] = atoi(entries_per_variable[3][i_i].c_str()); }

  initialization(_x_fullchannel, _x_a, _x_p, _x_f, _x_t, _x_d, _psi);

  logger.finished();
}


void mapping_fullchannel::initialization(int _x_fullchannel, int _x_a, vector<int> _x_p, vector<int> _x_f, vector<int> _x_t, vector<int> _x_d, phasespace_set * _psi){
  static Logger logger("mapping_fullchannel::initialization");
  logger.called();

  x_fullchannel = _x_fullchannel;
  x_a = _x_a;
  
  x_p = _x_p;
  x_f = _x_f;
  x_t = _x_t;
  x_d = _x_d;

  psi = _psi;

  propagator.resize(x_p.size());
  for (int i_p = 0; i_p < x_p.size(); i_p++){ propagator[i_p] = & psi->propagator[x_a][x_p[i_p]]; }
  
  timelikeinvariant.resize(x_f.size());
  for (int i_f = 0; i_f < x_f.size(); i_f++){ timelikeinvariant[i_f] = & psi->timelikeinvariant[x_a][x_f[i_f]]; }
  
  tchannel.resize(x_t.size());
  for (int i_t = 0; i_t < x_t.size(); i_t++){ tchannel[i_t] = & psi->tchannel[x_a][x_t[i_t]]; }
  
  decay.resize(x_d.size());
  for (int i_d = 0; i_d < x_d.size(); i_d++){ decay[i_d] = & psi->decay[x_a][x_d[i_d]]; }
  
  /*
  out = _out;
  out_1 = _out_1;
  out_2 = _out_2;

  psi = _psi;

  p_out = & psi->xbp_all[x_a][out];
  p_out_1 = & psi->xbp_all[x_a][out_1];
  p_out_2 = & psi->xbp_all[x_a][out_2];
  
  s_out = & psi->xbs_all[x_a][out];
  s_out_1 = & psi->xbs_all[x_a][out_1] ;
  s_out_2 = & psi->xbs_all[x_a][out_2];

  sqrts_out = & psi->xbsqrts_all[x_a][out];

  g_d = & psi->g_d[x_a][x_fullchannel];
  logger << LOG_DEBUG << "g_d = " << g_d << "   has been set." << endline_flush;

  // switch_pTthreshold only makes sense for first s-fullchannel fullchannel !!!
  if (psi->csi->class_contribution_QT_powercorrection && psi->switch_fullchannel_pTthreshold && out == psi->xb_max - 4 ){
    switch_pTthreshold = 1;
    exp_pTthreshold_cth = psi->exp_fullchannel_pTthreshold_cth;
    pT2_threshold = pow(psi->exp_fullchannel_pTthreshold_cth, 2);
  }
  else { switch_pTthreshold = 0; }

  if (psi->switch_fullchannel_cth && psi->exp_fullchannel_cth != 1.){
    switch_mapping_cth = 1;
    exp_cth = psi->exp_fullchannel_cth;
  }
  else { switch_mapping_cth = 0; }

  // rotation is obsolete in partonic CMS - reconsider dipole case !!!
  if (psi->switch_fullchannel_system && !((x_a == 0 && out == psi->xb_max - 4) || (x_a > 0 && out == psi->xb_max_fullchannelipoles - 4))){ switch_rotate_system = 1; }
  else { switch_rotate_system = 0; }
  
  random_psp_r1 = psi->random_psp[psi->map_type_to_list_MC_IS[vector<int> {x_a, 4, x_fullchannel}]];
  random_psp_r2 = psi->random_psp[psi->map_type_to_list_MC_IS[vector<int> {x_a, 5, x_fullchannel}]];

  stringstream temp_ss;
  temp_ss << "fullchannel";
  if (switch_rotate_system == 0){ temp_ss << ""; }
  else if (switch_rotate_system == 1){ temp_ss << "_system"; }
  if (switch_mapping_cth == 0){ temp_ss << ""; }
  else if (switch_mapping_cth == 1){ temp_ss << "_exp" << exp_cth; }
  temp_ss << "_" << out << "__" << out_1 << "_" << out_2;
  name = temp_ss.str();

  logger << LOG_DEBUG << "fullchannel[" << setw(5) << x_fullchannel << "] =  " << name << "  has been initialized." << endline_flush;
  */
  available = false;

  logger.finished();
}


string mapping_fullchannel::info() const {
  static Logger logger("mapping_fullchannel::info");
  logger.called();

  stringstream temp_ss;
  temp_ss << "fullchannel[" << setw(2) << x_a << "][" << setw(3) << x_fullchannel << "] = ";// = " << name;
  temp_ss << "{";
  for (int i_p = 0; i_p < x_p.size(); i_p++){ temp_ss << setw(3) << x_p[i_p]; }
  temp_ss << "}{";
  for (int i_f = 0; i_f < x_f.size(); i_f++){ temp_ss << setw(3) << x_f[i_f]; }
  temp_ss << "}{";
  for (int i_t = 0; i_t < x_t.size(); i_t++){ temp_ss << setw(3) << x_t[i_t]; }
  temp_ss << "}{";
  for (int i_d = 0; i_d < x_d.size(); i_d++){ temp_ss << setw(3) << x_d[i_d]; }
  temp_ss << "}";
 
  logger.finished();
  return temp_ss.str();
}


