#include "header.hpp"

void phasespace_set::correct_phasespacepoint_real(){
  static Logger logger("phasespace_set::correct_phasespacepoint_real");
  logger.called();

  fourvector momentum_correction_violation(-xbsqrts_all[0][0], 0., 0., 0.);
  for (int xbi = 4; xbi < xbp_all[0].size(); xbi = xbi * 2){momentum_correction_violation = momentum_correction_violation + xbp_all[0][xbi];}
  momentum_correction_violation = momentum_correction_violation / csi->n_particle;

  if (momentum_correction_violation.r() > 1.e-16 * xbsqrts_all[0][0]){
    //    logger << LOG_DEBUG_VERBOSE << "i_acc = " << setw(8) << right << i_acc << "   i_gen = " << setw(8) << right << i_gen << "   momentum corrected:   " << left << setprecision(15) << setw(23) << momentum_correction_violation.r() << endline_flush;
logger << LOG_DEBUG << "i_acc = " << setw(8) << right << i_acc << "   i_gen = " << setw(8) << right << i_gen << "   momentum corrected:   " << left << setprecision(15) << setw(23) << momentum_correction_violation.r() << endline_flush;
    corrected_xbp_all[0] = start_xbp_all[0];
    corrected_xbs_all[0] = start_xbs_all[0];
    corrected_xbsqrts_all[0] = start_xbsqrts_all[0];

    //    logger << LOG_DEBUG_VERBOSE << "momentum_correction_violation = " << momentum_correction_violation << endline_flush;
    for (int xbi = 4; xbi < xbp_all[0].size(); xbi = xbi * 2){
      fourvector temp = xbp_all[0][xbi] - momentum_correction_violation;
      corrected_xbp_all[0][xbi] = fourvector(sqrt(xbs_all[0][xbi] + temp.r2()), temp.x1(), temp.x2(), temp.x3());
    }
    double corrected_E = 0.;
    double corrected_E_beam = 0.;

    //    for (int xbi = 0; xbi < xbp_all[0].size(); xbi++){logger << LOG_DEBUG_VERBOSE << "xbp_all[0][" << setw(3) << xbi << "] = " << xbp_all[0][xbi] << "   xbs_all[0][" << setw(3) << xbi << "] = " << xbs_all[0][xbi] << endline_flush;}

    for (int xbi = 4; xbi < xbp_all[0].size(); xbi = xbi * 2){corrected_E += xbp_all[0][xbi].x0();}

    int binary_all_out = intpow(2, csi->n_particle + 2) - 4;

    corrected_xbp_all[0][0] = fourvector(corrected_E, 0., 0., 0.);
    corrected_xbp_all[0][binary_all_out] = corrected_xbp_all[0][0];
    corrected_xbs_all[0][0] = pow(corrected_E, 2);
    corrected_xbs_all[0][binary_all_out] = pow(corrected_E, 2);
    corrected_xbsqrts_all[0][0] = corrected_E;
    corrected_xbsqrts_all[0][binary_all_out] = corrected_E;

    corrected_E_beam = corrected_E / 2;
    if (csi->swap_parton[0][1] == 1 && csi->swap_parton[0][2] == 2){
      corrected_xbp_all[0][1] = fourvector(corrected_E_beam, 0., 0., corrected_E_beam);
      corrected_xbp_all[0][2] = fourvector(corrected_E_beam, 0., 0., -corrected_E_beam);
    }
    else if (csi->swap_parton[0][1] == 2 && csi->swap_parton[0][2] == 1){
      corrected_xbp_all[0][1] = fourvector(corrected_E_beam, 0., 0., -corrected_E_beam);
      corrected_xbp_all[0][2] = fourvector(corrected_E_beam, 0., 0., corrected_E_beam);
    }

    xbp_all[0] = corrected_xbp_all[0];
    xbs_all[0] = corrected_xbs_all[0];
    xbsqrts_all[0] = corrected_xbsqrts_all[0];

    if (!switch_off_new_psp){
      for (int i_a = 0; i_a < csi->n_ps; i_a++){
	for (int i_r = 0; i_r < required_xbp[i_a].size(); i_r++){ psp[i_a][required_xbp[i_a][i_r]].reset_p(); }
	for (int i_r = 0; i_r < required_xbs[i_a].size(); i_r++){ psp[i_a][required_xbs[i_a][i_r]].reset_s(); psp[i_a][required_xbs[i_a][i_r]].reset_p(); }
	for (int i_r = 0; i_r < required_xbsqrts[i_a].size(); i_r++){ psp[i_a][required_xbsqrts[i_a][i_r]].reset_sqrts(); psp[i_a][required_xbsqrts[i_a][i_r]].reset_s(); psp[i_a][required_xbsqrts[i_a][i_r]].reset_p(); }
       for (int i_r = 0; i_r < required_xbp[i_a].size(); i_r++){ if (psp[i_a][required_xbp[i_a][i_r]].get_available_p()){ logger << LOG_DEBUG << "p - psp[" << i_a << "][" << required_xbp[i_a][i_r] << "]  should not be AVAILABLE" << endline_flush; } }
       for (int i_r = 0; i_r < required_xbs[i_a].size(); i_r++){ if (psp[i_a][required_xbs[i_a][i_r]].get_available_p()){ logger << LOG_DEBUG << "s - psp[" << i_a << "][" << required_xbs[i_a][i_r] << "]  should not be AVAILABLE" << endline_flush; } }
       for (int i_r = 0; i_r < required_xbsqrts[i_a].size(); i_r++){  if (psp[i_a][required_xbsqrts[i_a][i_r]].get_available_p()){ logger << LOG_DEBUG << "q - psp[" << i_a << "][" << required_xbsqrts[i_a][i_r] << "]  should not be AVAILABLE" << endline_flush; } }
     }
    }

    //     for (int xbi = 0; xbi < xbp_all[0].size(); xbi++){logger << LOG_DEBUG_VERBOSE << "xbp_all[0][" << setw(3) << xbi << "] = " << xbp_all[0][xbi] << "   xbs_all[0][" << setw(3) << xbi << "] = " << xbs_all[0][xbi] << endline_flush;}
  }
  
  logger.finished();
}


void phasespace_set::correct_phasespacepoint_dipole(){
  static Logger logger("phasespace_set::correct_phasespacepoint_dipole");
  logger.called();

  for (int i_a = 1; i_a < n_dipoles; i_a++){
    fourvector momentum_correction_violation(0., 0., 0., 0.);
    for (int xbi = 1; xbi < 4; xbi = xbi * 2){
      momentum_correction_violation = momentum_correction_violation - xbp_all[i_a][xbi];
    }
    for (int xbi = 4; xbi < xbp_all[i_a].size(); xbi = xbi * 2){
      momentum_correction_violation = momentum_correction_violation + xbp_all[i_a][xbi];
    }
    momentum_correction_violation = momentum_correction_violation / (csi->n_particle - 1);

    if (momentum_correction_violation.r() > 1.e-16 * xbsqrts_all[i_a][0]){
      //      logger << LOG_DEBUG_VERBOSE << "i_acc = " << setw(8) << right << i_acc << "   i_gen = " << setw(8) << right << i_gen << "   momentum corrected at i_a = " << i_a << ":   " << left << setprecision(15) << setw(23) << momentum_correction_violation.r() << endline_flush;

      corrected_xbp_all[i_a] = start_xbp_all[i_a];
      //      corrected_xbs_all[i_a] = start_xbs_all[i_a];
      //      corrected_xbsqrts_all[i_a] = start_xbsqrts_all[i_a];

      for (int xbi = 4; xbi < xbp_all[i_a].size(); xbi = xbi * 2){
	fourvector temp = xbp_all[i_a][xbi] - momentum_correction_violation;
	corrected_xbp_all[i_a][xbi] = fourvector(sqrt(xbs_all[i_a][xbi] + temp.r2()), temp.x1(), temp.x2(), temp.x3());
      }
      for (int xbi = 4; xbi < xbp_all[i_a].size(); xbi = xbi * 2){
	double prec = abs(1 - sqrt(xbs_all[i_a][xbi] + xbp_all[i_a][xbi].r2()) / xbp_all[i_a][xbi].x0());
	double prec_new = abs(1 - sqrt(xbs_all[i_a][xbi] + corrected_xbp_all[i_a][xbi].r2()) / corrected_xbp_all[i_a][xbi].x0());
	if (prec_new > 1.e-9){
	  logger << LOG_DEBUG << "On-shell condition badly satisfied for xbp_all[" << i_a << "][" << xbi << "], namely to       " << right << setw(25) << setprecision(16) << showpoint << -log10(prec) << " digits." << endline_flush;
	  logger << LOG_DEBUG << "                                                               new:   " << right << setw(25) << setprecision(16) << showpoint << -log10(prec_new) << " digits." << endline_flush;
	  logger << LOG_DEBUG_VERBOSE << "          xbp_all[" << i_a << "][" << setw(3) << xbi << "] = " << xbp_all[i_a][xbi] << "   m = " << sqrt(abs(xbp_all[i_a][xbi].m2())) << "   xbs_all[" << i_a << "][" << setw(3) << xbi << "] = " << xbsqrts_all[i_a][xbi] << endline_flush;
	  logger << LOG_DEBUG_VERBOSE << "corrected_xbp_all[" << i_a << "][" << setw(3) << xbi << "] = " << corrected_xbp_all[i_a][xbi] << "   m = " << sqrt(abs(corrected_xbp_all[i_a][xbi].m2())) << endline_flush;
	}
      }
      for (int xbi = 4; xbi < xbp_all[i_a].size(); xbi = xbi * 2){momentum_correction_violation = momentum_correction_violation + xbp_all[i_a][xbi];}
      for (int xbi = 4; xbi < xbp_all[i_a].size(); xbi = xbi * 2){xbp_all[i_a][xbi] = corrected_xbp_all[i_a][xbi];}

      if (!switch_off_new_psp){
	for (int i_r = 0; i_r < required_xbp[i_a].size(); i_r++){ psp[i_a][required_xbp[i_a][i_r]].reset_p(); }
	for (int i_r = 0; i_r < required_xbs[i_a].size(); i_r++){ psp[i_a][required_xbs[i_a][i_r]].reset_s(); psp[i_a][required_xbs[i_a][i_r]].reset_p(); }
	for (int i_r = 0; i_r < required_xbsqrts[i_a].size(); i_r++){ psp[i_a][required_xbsqrts[i_a][i_r]].reset_sqrts(); psp[i_a][required_xbsqrts[i_a][i_r]].reset_s(); psp[i_a][required_xbsqrts[i_a][i_r]].reset_p(); }
      }
    }
  }

  logger.finished();
}
