#include "header.hpp"

void phasespace_set::calculate_initial_tau_IS_x1x2_IS(){
  Logger logger("phasespace_set::calculate_initial_tau_IS_x1x2_IS");
  logger.called();

  random_MC_tau = rng.access_random_number(n_random_MC_tau);
  ///  random_tau = rng.access_random_number(n_random_tau);
  double random_IS_tau = 0;
  // speed-up by using intervals in general ???
  for (int i_c = 0; i_c < MC_tau.beta.size(); i_c++){if (random_MC_tau[0] <= MC_tau.beta[i_c]){MC_tau.channel = i_c; break;}}
  if (MC_tau.channel == 0){
    random_IS_tau = random_psp[index_IS_tau]->get_random();
    x_pdf[0] = h_propto_pot(random_IS_tau, tau_0, exp_pdf);
  }
  else {
    // Introduce IS sampling for BW-mappings as well !!!
    random_tau = rng.access_random_number(n_random_tau);
    x_pdf[0] = c_propagator_Breit_Wigner(random_tau[0], abs(tau_MC_map[MC_tau.channel]), tau_0_s_had, s_had) / s_had;
    // tau_MC_tau_gamma can be removed completely !!!
    //    for (int i_c = 0; i_c < tau_MC_tau_gamma[0].size(); i_c++){logger << LOG_DEBUG_VERBOSE << "tau_MC_tau_gamma[0][" << i_c << "]" << " = " << setprecision(20) << setw(28) << tau_MC_tau_gamma[0][i_c] << "   " << double2hexastr(tau_MC_tau_gamma[0][i_c]) << endline_flush;}
    //    for (int i_c = 0; i_c < tau_MC_tau_gamma[0].size(); i_c++){if (x_pdf[0] <= tau_MC_tau_gamma[0][i_c]){IS_tau->channel = i_c; break;}}

    // to reproduce old result where MC_tau events in other than 0 bins were not treated differently:
    // not sure if this should better be kept, or only for switch_IS_optimization_each_variable ???
    if (switch_old_IS_behaviour || switch_IS_optimization_each_variable){
      random_psp[0]->used = true;
      random_manager.add_var_to_queue(random_psp[0]);
    }
  }

  // Only required if point is accepted !!! ???
  double tau_s_had = x_pdf[0] * s_had;
  for (int i_c = 0; i_c < MC_tau.g_channel.size(); i_c++){
    if (i_c == 0){
      double inv_r_tau;
      if (MC_tau.channel == 0){inv_r_tau = random_IS_tau;}
      else {inv_r_tau = inv_propto_pot(x_pdf[0], tau_0, exp_pdf);}

      double g_IS_temp;
      random_psp[index_IS_tau]->get_g_IS(inv_r_tau, g_IS_temp);
      MC_tau.g_channel[i_c] = g_propto_pot(x_pdf[0], tau_0, exp_pdf) * g_IS_temp;
    }
    else {
      if (tau_MC_map[i_c] < 0){MC_tau.g_channel[i_c] = s_had * g_propagator_Breit_Wigner(tau_s_had, -tau_MC_map[i_c], tau_0_s_had, s_had);}
    }
  }
  g_tau = 0.;
  for (int i = 0; i < MC_tau.g_channel.size(); i++){g_tau += MC_tau.alpha[i] * MC_tau.g_channel[i];}
  // ... until here

  double min_x_pdf_1 = GSL_MAX_DBL(x_pdf[0], 1.e-7);
  // Make 1e-7 an input parameter (minimum of s_part/s_had) ??? Why is this actually required? Should be automatically realized through tau_0 !!!
  // rename to random_x1x2 ???
  double random_IS_x12 = random_psp[index_IS_x1x2]->get_random();
  x_pdf[1] = exp(random_IS_x12 * log(min_x_pdf_1));
  x_pdf[2] = x_pdf[0] / x_pdf[1];

  // Only required if point is accepted !!! ???
  double g_IS_x1x2;
  random_psp[index_IS_x1x2]->get_g_IS(random_IS_x12, g_IS_x1x2);
  g_x1x2 = 1. / (-log(min_x_pdf_1)) * g_IS_x1x2;
  // ... until here
  //  logger << LOG_DEBUG_VERBOSE << setw(20) << "g_x1x2" << " = " << setprecision(20) << setw(28) << g_x1x2 << "   " << double2hexastr(g_x1x2) << endline_flush;

  double sqrttau = sqrt(x_pdf[0]);
  xbp_all[0][1] = fourvector(sqrttau * E, 0., 0., sqrttau * E);
  xbp_all[0][2] = fourvector(sqrttau * E, 0., 0., -sqrttau * E);
  xbp_all[0][0] = xbp_all[0][1] + xbp_all[0][2];
  xbs_all[0][0] = 4. * x_pdf[0] * pow(E, 2);
  xbsqrts_all[0][0] = sqrt(xbs_all[0][0]);
  xbp_all[0][xb_max - 4] = xbp_all[0][0];
  xbs_all[0][xb_max - 4] = xbs_all[0][0];
  xbsqrts_all[0][xb_max - 4] = xbsqrts_all[0][0];

  logger.finished();
}


void phasespace_set::calculate_initial_tau_fixed_x1x2_IS(){
  Logger logger("phasespace_set::calculate_initial_tau_fixed_x1x2_IS");
  logger.called();

  // The parameters under (!identical_psp) statements are the same for all phase space points.
  // Make sure the parameters are not reset anywhere else !!!
  if (!identical_psp){
    x_pdf[0] = start_xbs_all[0][xb_max - 4] / s_had;
    g_tau = s_had;
  }
  
  double random_IS_x12 = random_psp[index_IS_x1x2]->get_random();
  x_pdf[1] = exp(random_IS_x12 * log(x_pdf[0]));
  //  random_x12 = rng.access_random_number(n_random_x12);

  //  for (int j = 0; j < IS_x1x2->beta.size(); j++){if (random_x12[0] <= IS_x1x2->beta[j]){IS_x1x2->channel = j; break;}}
  //  double random_x1x2 = (double(IS_x1x2->channel) + random_x12[1]) / double(IS_x1x2->beta.size());
  //  x_pdf[1] = exp(random_x1x2 * log(x_pdf[0]));
  x_pdf[2] = x_pdf[0] / x_pdf[1];

  // Only required if point is accepted !!! ???
  double g_IS_x1x2;
  random_psp[index_IS_x1x2]->get_g_IS(random_IS_x12, g_IS_x1x2);
  g_x1x2 = 1. / (-log(x_pdf[0])) * g_IS_x1x2;
  //  g_x1x2 = 1. / (-log(x_pdf[0])) * (IS_x1x2->alpha[IS_x1x2->channel] * IS_x1x2->alpha.size());

  if (!identical_psp){
    double sqrttau = sqrt(x_pdf[0]);
    xbp_all[0][1] = fourvector(sqrttau * E, 0., 0., sqrttau * E);
    xbp_all[0][2] = fourvector(sqrttau * E, 0., 0., -sqrttau * E);
    xbp_all[0][0] = xbp_all[0][1] + xbp_all[0][2];
    xbs_all[0][0] = 4. * x_pdf[0] * pow(E, 2);
    xbsqrts_all[0][0] = sqrt(xbs_all[0][0]);
    xbp_all[0][xb_max - 4] = xbp_all[0][0];
    xbs_all[0][xb_max - 4] = xbs_all[0][0];
    xbsqrts_all[0][xb_max - 4] = xbsqrts_all[0][0];
  }

  logger.finished();
}


// Note: z_coll has no impact on phase space cuts !!!

void phasespace_set::calculate_initial_collinear_z1z2_IS(){
  Logger logger("phasespace_set::calculate_initial_collinear_z1z2_IS");
  logger.called();

  for (int i_z = 1; i_z < 3; i_z++){
    double random_z1z2 = random_psp[index_IS_z1z2[i_z]]->get_random();
    z_coll[i_z] = exp(random_z1z2 * log(x_pdf[i_z]));
    double g_IS_z1z2;
    random_psp[index_IS_z1z2[i_z]]->get_g_IS(random_z1z2, g_IS_z1z2);
    g_z_coll[i_z] = 1. / (-log(x_pdf[i_z])) * g_IS_z1z2;
  }
  set_xz_coll_pdf();
  
  logger.finished();
}


// taken from former phasespace.mapping.propagator.cpp

///////////////////////////////////////
//  Breit-Wigner propagator mapping  //
///////////////////////////////////////

double phasespace_set::c_propagator_Breit_Wigner(double & r1, int m, double & smin, double & smax){
  static Logger logger("phasespace_set::c_propagator_Breit_Wigner");
  logger.called();

  // see Bronstein, Sec. 2.8.7, Eq. (2.7)
  double arg1 = (smin - M2[m]) / (M[m] * map_Gamma[m]);
  double arg2 = (smax - M2[m]) / (M[m] * map_Gamma[m]);
  double delta_y;
  if (arg1 * arg2 > -1.){delta_y = atan((arg2 - arg1) / (1 + arg1 * arg2));}
  else if (arg2 > 0.){delta_y = M_PI + atan((arg2 - arg1) / (1. + arg1 * arg2));}
  else {delta_y = -M_PI + atan((arg2 - arg1) / (1 + arg1 * arg2));}
  // see Bronstein, Sec. 2.7.2.3, Eq. (2.87)
  double s = M[m] * map_Gamma[m] * (arg1 + tan(r1 * delta_y)) / (1 - arg1 * tan(r1 * delta_y)) + M2[m];

  if (Log::getLogThreshold() <= LOG_DEBUG_VERBOSE){ logger << LOG_DEBUG_VERBOSE << "return " << setw(23) << setprecision(15) << s << endline_flush; }
  logger.finished();
  return s;
}

double phasespace_set::g_propagator_Breit_Wigner(double & s, int m, double & smin, double & smax){
  static Logger logger("phasespace_set::g_propagator_Breit_Wigner");
  logger.called();

  double arg1 = (smin - M2[m]) / (M[m] * map_Gamma[m]);
  double arg2 = (smax - M2[m]) / (M[m] * map_Gamma[m]);
  double delta_y;
  if (arg1 * arg2 > -1.){delta_y = atan((arg2 - arg1)/(1 + arg1 * arg2));}
  else if (arg2 > 0.){delta_y = M_PI + atan((arg2 - arg1) / (1 + arg1 * arg2));}
  else {delta_y = -M_PI + atan((arg2 - arg1) / (1 + arg1 * arg2));}
  double gs = (M[m] * map_Gamma[m]) / (delta_y * (pow(s - M2[m], 2) + M2[m] * pow(map_Gamma[m], 2)));

  if (Log::getLogThreshold() <= LOG_DEBUG_VERBOSE){ logger << LOG_DEBUG_VERBOSE << "return " << setw(23) << setprecision(15) << gs << endline_flush; }
  logger.finished();
  return gs;
}

double phasespace_set::inv_propagator_Breit_Wigner(double s, int m, double & smin, double & smax){
  static Logger logger("phasespace_set::inv_propagator_Breit_Wigner");
  logger.called();

  // TODO: micro optimize as above !!!
  double arg1 = atan((smin - M2[m]) / (M[m] * map_Gamma[m]));
  double arg2 = atan((smax - M2[m]) / (M[m] * map_Gamma[m]));
  double r = (atan((s - M2[m]) / (M[m] * map_Gamma[m])) - arg1) / (arg2 - arg1);
  //  logger << LOG_DEBUG << "arg1 = " << arg1 << endline_flush;
  //  logger << LOG_DEBUG << "arg2 = " << arg2 << endline_flush;
  //  logger << LOG_DEBUG << "r = " << r << endline_flush;
  
  if (munich_isnan(r)) {
    logger << LOG_DEBUG << "r is NaN in inv_propagator_Breit_Wigner!" << endline_flush;
    logger << LOG_DEBUG << "    r = " << setw(23) << setprecision(15) << r << ";            smin = " << setw(23) << setprecision(15) << smin << ";      s = " << setw(23) << setprecision(15) << s << ";   smax = " << setw(23) << setprecision(15) << smax << endline_flush;
    logger << LOG_DEBUG << "M[" << setw(2) << m << "] = " << setw(23) << setprecision(15) << M[m] << ";   map_Gamma[" << setw(2) << m << "] = " << setw(23) << setprecision(15) << map_Gamma[m] << ";   arg1 = " << setw(23) << setprecision(15) << arg1 << ";   arg2 = " << setw(23) << setprecision(15) << arg2 << endline_flush;
    if (s <= smin){r = map_technical_s;}
    else if (s >= smax){r = 1. - map_technical_s;}
    else {
      if (switch_console_output_phasespace_issue){
        logger << LOG_WARN << "   smin = " << smin << "   s = " << s << "   smax = " << smax << endline;
	logger << LOG_WARN << "   arg1 = " << arg1 << "   arg2 = " << arg2 << endline;
	logger << LOG_WARN << "   M[" << m << "] = " << M[m] << "   M2[" << m << "] = " << M2[m] << "   map_Gamma[" << m << "] = " << map_Gamma[m] << endline_flush;
        logger << LOG_ERROR << "r remains NaN in inv_propagator_Breit_Wigner!" << endline_flush;
      }
      r = map_technical_s;
      // Otherwise program might stop !!! Reason for "nan" should be clarified !!!
    }
  }
  else if (r <= 0.) {
    logger << LOG_DEBUG << "r <= 0 in inv_propagator_Breit_Wigner!" << endline_flush;
    logger << LOG_DEBUG << "    r = " << setw(23) << setprecision(15) << r << ";            smin = " << setw(23) << setprecision(15) << smin << ";      s = " << setw(23) << setprecision(15) << s << ";   smax = " << setw(23) << setprecision(15) << smax << endline_flush;
    logger << LOG_DEBUG << "M[" << setw(2) << m << "] = " << setw(23) << setprecision(15) << M[m] << ";   map_Gamma[" << setw(2) << m << "] = " << setw(23) << setprecision(15) << map_Gamma[m] << ";   arg1 = " << setw(23) << setprecision(15) << arg1 << ";   arg2 = " << setw(23) << setprecision(15) << arg2 << endline_flush;
    r = map_technical_s;
  }
  else if (r >= 1.) {
    logger << LOG_DEBUG << "r >= 1 in inv_propagator_Breit_Wigner!" << endline_flush;
    logger << LOG_DEBUG << "    r = " << setw(23) << setprecision(15) << r << ";            smin = " << setw(23) << setprecision(15) << smin << ";      s = " << setw(23) << setprecision(15) << s << ";   smax = " << setw(23) << setprecision(15) << smax << endline_flush;
    logger << LOG_DEBUG << "M[" << setw(2) << m << "] = " << setw(23) << setprecision(15) << M[m] << ";   map_Gamma[" << setw(2) << m << "] = " << setw(23) << setprecision(15) << map_Gamma[m] << ";   arg1 = " << setw(23) << setprecision(15) << arg1 << ";   arg2 = " << setw(23) << setprecision(15) << arg2 << endline_flush;
    r = 1. - map_technical_s;
  }

  if (Log::getLogThreshold() <= LOG_DEBUG_VERBOSE){ logger << LOG_DEBUG_VERBOSE << "return " << setw(23) << setprecision(15) << r << endline_flush; }
  logger.finished();
  return r;
}


