#include "header.hpp"

void phasespace_set::output_step_weight_optimization(){
  static Logger logger("phasespace_set::output_step_weight_optimization");
  logger.called();

  //  string filename_integration_weight = filename_integration;
  //  filename_integration_weight.insert (filename_integration_weight.size() - 4, ".weight_optimization");

  ofstream out_optimization;
  out_optimization.open(filename_optimization.c_str(), ofstream::out | ofstream::app);

  out_optimization << "******************************************************* integration step " << setw(2) << i_step << " *******************************************************" << endline;

  for (int i_mc = 0; i_mc < MC_active.size(); i_mc++){
    if (MC_active[i_mc]->active_optimization == 1){
      /////    if (MC_active[i_mc]->end_optimization < 2 && *i_step_mode % MC_active[i_mc]->n_event_per_step == 0){
      logger << LOG_INFO << "i_step = " << i_step << "   MC_active[i_mc]->n_optimization_repetition = " << MC_active[i_mc]->n_optimization_repetition << "   (i_step % MC_active[i_mc]->n_optimization_repetition = " << (i_step % MC_active[i_mc]->n_optimization_repetition) << endline_flush;
      if (MC_active[i_mc]->end_optimization < 2 && (i_step % MC_active[i_mc]->n_optimization_repetition == 0) && (*i_step_mode == MC_active[i_mc]->n_event_per_step / MC_active[i_mc]->n_optimization_repetition || enforce_step)){
	///    if (MC_active[i_mc]->end_optimization < 2 && (*i_step_mode == MC_active[i_mc]->n_event_per_step / MC_active[i_mc]->n_optimization_repetition || enforce_step)){
	//  if (MC_opt_end < 2 && *i_step_mode % n_event_per_step == 0){
	//	ofstream out_optimization;
	//	out_optimization.open(filename_optimization.c_str(), ofstream::out | ofstream::app);
	//      out_optimization << MC_active[i_mc]->name << endline;
	//      out_optimization << "************************************************* weight optimization step " << setw(2) << MC_active[i_mc]->i_alpha_it << " *************************************************" << endline;
	int j = MC_active[i_mc]->i_alpha_it - 1;
	out_optimization << setw(20) << MC_active[i_mc]->name << "   D_min[alpha(i),alpha(j)](step " << j << ") = " << setw(20) << setprecision(15) << MC_active[i_mc]->diff_w[j] << endline;
	vector<double>::iterator min_alpha = min_element(MC_active[i_mc]->alpha_it[j].begin(), MC_active[i_mc]->alpha_it[j].end());
	vector<double>::iterator max_alpha = max_element(MC_active[i_mc]->alpha_it[j].begin(), MC_active[i_mc]->alpha_it[j].end());
	out_optimization << "   min_alpha[" << setw(4) << distance(MC_active[i_mc]->alpha_it[j].begin(), min_alpha) << "] = " << setprecision(15) << setw(23) << *min_alpha;
	out_optimization << "   max_alpha[" << setw(4) << distance(MC_active[i_mc]->alpha_it[j].begin(), max_alpha) << "] = " << setprecision(15) << setw(23) << *max_alpha;

	if (!(*i_step_mode == MC_active[i_mc]->n_event_per_step  * MC_active[i_mc]->n_optimization_step)){
	  if (MC_active[i_mc]->counter_minimum_weight != 0){
	    out_optimization << "   switch_minimum_weight:   " << MC_active[i_mc]->counter_minimum_weight << " alpha's are set to " << MC_active[i_mc]->alpha_reserved_min << " in the next step." << endline;
	  }
	  //      out_optimization << "*******************************************************************************************************************************" << endline;
	}
	out_optimization << endline;
	//out_optimization << "*******************************************************************************************************************************" << endline;
	//	out_optimization.close();
      }
    }
  }

  for (int i_is = 0; i_is < IS_active.size(); i_is++){
    if (IS_active[i_is]->active_optimization == 1){
      /////    if (IS_active[i_is]->end_optimization < 2 && *i_step_mode % IS_active[i_is]->n_event_per_step == 0){
      logger << LOG_INFO << "i_step = " << i_step << "   IS_active[i_is]->n_optimization_repetition = " << IS_active[i_is]->n_optimization_repetition << "   (i_step % IS_active[i_is]->n_optimization_repetition = " << (i_step % IS_active[i_is]->n_optimization_repetition) << endline_flush;
      if (IS_active[i_is]->end_optimization < 2 && (i_step % IS_active[i_is]->n_optimization_repetition == 0) && (*i_step_mode == IS_active[i_is]->n_event_per_step / IS_active[i_is]->n_optimization_repetition || enforce_step)){
	///    if (IS_active[i_is]->end_optimization < 2 && (*i_step_mode == IS_active[i_is]->n_event_per_step / IS_active[i_is]->n_optimization_repetition || enforce_step)){
	//  if (MC_opt_end < 2 && *i_step_mode % n_event_per_step == 0){
	//	ofstream out_optimization;
	//	out_optimization.open(filename_optimization.c_str(), ofstream::out | ofstream::app);
	out_optimization << IS_active[i_is]->name << endline;
	out_optimization << "************************************************* weight optimization step " << setw(2) << IS_active[i_is]->i_alpha_it << " *************************************************" << endline;
	//	out_optimization << setw(20) << IS_active[i_is]->name << "   D_min[alpha(i),alpha(j)](step " << IS_active[i_is]->i_alpha_it - 1 << ") = " << setw(20) << setprecision(15) << IS_active[i_is]->diff_w[IS_active[i_is]->i_alpha_it - 1] << endline;
	int j = IS_active[i_is]->i_alpha_it - 1;
	out_optimization << setw(20) << IS_active[i_is]->name << "   D_min[alpha(i),alpha(j)](step " << j << ") = " << setw(20) << setprecision(15) << IS_active[i_is]->diff_w[j] << endline;
	vector<double>::iterator min_alpha = min_element(IS_active[i_is]->alpha_it[j].begin(), IS_active[i_is]->alpha_it[j].end());
	vector<double>::iterator max_alpha = max_element(IS_active[i_is]->alpha_it[j].begin(), IS_active[i_is]->alpha_it[j].end());
	out_optimization << "   min_alpha[" << setw(4) << distance(IS_active[i_is]->alpha_it[j].begin(), min_alpha) << "] = " << setprecision(15) << setw(23) << *min_alpha;
	out_optimization << "   max_alpha[" << setw(4) << distance(IS_active[i_is]->alpha_it[j].begin(), max_alpha) << "] = " << setprecision(15) << setw(23) << *max_alpha;

	if (!(*i_step_mode == IS_active[i_is]->n_event_per_step  * IS_active[i_is]->n_optimization_step)){
	  if (IS_active[i_is]->counter_minimum_weight != 0){
	    out_optimization << "   switch_minimum_weight:   " << IS_active[i_is]->counter_minimum_weight << " alpha's are set to " << IS_active[i_is]->alpha_reserved_min << " in the next step." << endline;
	  }
	  out_optimization << "*******************************************************************************************************************************" << endline;
	}
	//	out_optimization.close();
      }
    }
  }


  out_optimization << "************************************************* weight optimization result **************************************************" << endline;
  for (int i_mc = 0; i_mc < MC_active.size(); i_mc++){
    if (MC_active[i_mc]->active_optimization == 1){
      if (MC_active[i_mc]->end_optimization < 2 && (*i_step_mode == MC_active[i_mc]->n_event_per_step / MC_active[i_mc]->n_optimization_repetition  || enforce_step) && i_step == MC_active[i_mc]->n_optimization_step * MC_active[i_mc]->n_optimization_repetition){
	//	ofstream out_optimization;
	//	out_optimization.open(filename_optimization.c_str(), ofstream::out | ofstream::app);
	//	out_optimization << "************************************************* weight optimization result **************************************************" << endline;
	for (int j = 0; j < MC_active[i_mc]->diff_w.size(); j++){
	  out_optimization << MC_active[i_mc]->name << "diff_w[" << j << "] = " << showpoint << setprecision(15) << setw(23) << MC_active[i_mc]->diff_w[j];
	  vector<double>::iterator min_alpha = min_element(MC_active[i_mc]->alpha_it[j].begin(), MC_active[i_mc]->alpha_it[j].end());
	  vector<double>::iterator max_alpha = max_element(MC_active[i_mc]->alpha_it[j].begin(), MC_active[i_mc]->alpha_it[j].end());
	  out_optimization << "   min_alpha[" << setw(4) << distance(MC_active[i_mc]->alpha_it[j].begin(), min_alpha) << "] = " << setprecision(15) << setw(23) << *min_alpha;
	  out_optimization << "   max_alpha[" << setw(4) << distance(MC_active[i_mc]->alpha_it[j].begin(), max_alpha) << "] = " << setprecision(15) << setw(23) << *max_alpha;
	  //	  out_optimization << "   min_alpha = " << MC_active[i_mc]->alpha_it[j][min_alpha];
	  //	  out_optimization << "   max_alpha = " << MC_active[i_mc]->alpha_it[j][max_alpha];
	  //	  out_optimization << "   " << MC_active[i_mc]->alpha_it[j][0];
	  //	  out_optimization << "   " << MC_active[i_mc]->alpha_it[j][MC_active[i_mc]->alpha_it[j].size() - 1];
	  out_optimization << endline;
	}
	out_optimization << "------------------------------------------------- weight optimization result --------------------------------------------------" << endline;
	//	out_optimization << "************************************************* weight optimization result **************************************************" << endline;
	out_optimization << MC_active[i_mc]->name << "   min(D_min[alpha(i),alpha(j)]) = " << showpoint << setprecision(15) << setw(25) << MC_active[i_mc]->diff_w[MC_active[i_mc]->x_minimum_diff_w] << "   at optimization step "<< setw(2) << MC_active[i_mc]->x_minimum_diff_w << endline;
	//	out_optimization << "************************************************* end of weight optimization **************************************************" << endline;
	out_optimization << endline;
	//	out_optimization.close();
      }
    }
  }

  for (int i_is = 0; i_is < IS_active.size(); i_is++){
    if (IS_active[i_is]->active_optimization == 1){
      if (IS_active[i_is]->end_optimization < 2 && (*i_step_mode == IS_active[i_is]->n_event_per_step / IS_active[i_is]->n_optimization_repetition  || enforce_step) && i_step == IS_active[i_is]->n_optimization_step * IS_active[i_is]->n_optimization_repetition){
	//	ofstream out_optimization;
	//	out_optimization.open(filename_optimization.c_str(), ofstream::out | ofstream::app);
	//	out_optimization << "************************************************* weight optimization result **************************************************" << endline;
	for (int j = 0; j < IS_active[i_is]->diff_w.size(); j++){
	  //	  out_optimization << "diff_w[" << j << "] = " << showpoint << setprecision(15) << setw(25) << IS_active[i_is]->diff_w[j] << "   " << IS_active[i_is]->alpha_it[j][0] << "   " << IS_active[i_is]->alpha_it[j][IS_active[i_is]->alpha_it[j].size() - 1] << endline;
	  out_optimization << IS_active[i_is]->name << "diff_w[" << j << "] = " << showpoint << setprecision(15) << setw(23) << IS_active[i_is]->diff_w[j];
	  vector<double>::iterator min_alpha = min_element(IS_active[i_is]->alpha_it[j].begin(), IS_active[i_is]->alpha_it[j].end());
	  vector<double>::iterator max_alpha = max_element(IS_active[i_is]->alpha_it[j].begin(), IS_active[i_is]->alpha_it[j].end());
	  out_optimization << "   min_alpha[" << setw(4) << distance(IS_active[i_is]->alpha_it[j].begin(), min_alpha) << "] = " << setprecision(15) << setw(23) << *min_alpha;
	  out_optimization << "   max_alpha[" << setw(4) << distance(IS_active[i_is]->alpha_it[j].begin(), max_alpha) << "] = " << setprecision(15) << setw(23) << *max_alpha;
	}
	out_optimization << "------------------------------------------------- weight optimization result --------------------------------------------------" << endline;
	//	out_optimization << "************************************************* weight optimization result **************************************************" << endline;
	out_optimization << "   min(D_min[alpha(i),alpha(j)]) = " << showpoint << setprecision(15) << setw(25) << IS_active[i_is]->diff_w[IS_active[i_is]->x_minimum_diff_w] << "   at optimization step "<< setw(2) << IS_active[i_is]->x_minimum_diff_w << endline;
	//	out_optimization << "************************************************* end of weight optimization **************************************************" << endline;
	//	out_optimization.close();
      }
    }
  }

  out_optimization.close();

  logger.finished();
}


void phasespace_set::output_result_weight_optimization(){
  static Logger logger("phasespace_set::output_result_weight_optimization");
  logger.called();


  logger.finished();
}


