#include "header.hpp"

phasespace_set::phasespace_set(){
  static Logger logger("phasespace_set::phasespace_set");
  logger.called();

  if (Log::getLogThreshold() <= LOG_DEBUG_VERBOSE){ logger << LOG_DEBUG_VERBOSE << "constructor called..." << endline_flush; }
 
  logger.finished();
}

phasespace_set::~phasespace_set(){
  static Logger logger("phasespace_set::~phasespace_set");
  logger.called();

  if (Log::getLogThreshold() <= LOG_DEBUG_VERBOSE){ logger << LOG_DEBUG_VERBOSE << "destructor called..." << endline_flush; }

  if (csi->type_contribution == "RRA"){
    delete fake_psi->csi;
    delete fake_psi;
  }

  logger.finished();
}

/*
void phasespace_set::initialization_psp(int x_a){
  static Logger logger("phasespace_set::initialization_psp");
  logger.called();

  if (csi->type_contribution == "born"){initialization_psp_born(0);}
  else if (csi->type_contribution == "L2I"){initialization_psp_born(0);}
  else if (csi->type_contribution == "RT"){initialization_psp_real(0);}
  else if (csi->type_contribution == "L2RT"){initialization_psp_real(0);}
  else if (csi->type_contribution == "VA"){initialization_psp_born(0);}
  else if (csi->type_contribution == "RVA"){initialization_psp_real(0);}
  else if (csi->type_contribution == "L2VA"){initialization_psp_born(0);}
  else if (csi->type_contribution == "CA"){initialization_psp_born(0);}
  else if (csi->type_contribution == "RCA"){initialization_psp_real(0);}
  else if (csi->type_contribution == "L2CA"){initialization_psp_born(0);}
  else if (csi->type_contribution == "RA"){initialization_psp_real(0);}
  else if (csi->type_contribution == "RRA"){initialization_psp_doublereal(0);}
  else if (csi->type_contribution == "L2RA"){initialization_psp_real(0);}
  else if (csi->type_contribution == "VT"){initialization_psp_born(0);}
  else if (csi->type_contribution == "L2VT"){initialization_psp_born(0);}
  else if (csi->type_contribution == "CT"){initialization_psp_born(0);}
  else if (csi->type_contribution == "L2CT"){initialization_psp_born(0);}
  else if (csi->type_contribution == "PT"){initialization_psp_born(0);}
  else if (csi->type_contribution == "L2PT"){initialization_psp_born(0);}
  else if (csi->type_contribution == "VT2"){initialization_psp_born(0);}
  else if (csi->type_contribution == "CT2"){initialization_psp_born(0);}
  else if (csi->type_contribution == "PT2"){initialization_psp_born(0);}

  logger.finished();
}
*/
/*
void phasespace_set::ax_psp(int x_a){
  static Logger logger("phasespace_set::ax_psp");
  logger.called();

  if (switch_off_new_psp){
    if (csi->type_contribution == "born"){ax_psp_born(0);}
    else if (csi->type_contribution == "L2I"){ax_psp_born(0);}
    else if (csi->type_contribution == "RT"){ax_psp_real(0);}
    else if (csi->type_contribution == "L2RT"){ax_psp_real(0);}
    else if (csi->type_contribution == "VA"){ax_psp_born(0);}
    else if (csi->type_contribution == "RVA"){ax_psp_real(0);}
    else if (csi->type_contribution == "L2VA"){ax_psp_born(0);}
    else if (csi->type_contribution == "CA"){ax_psp_born(0);}
    else if (csi->type_contribution == "RCA"){ax_psp_real(0);}
    else if (csi->type_contribution == "L2CA"){ax_psp_born(0);}
    else if (csi->type_contribution == "RA"){ax_psp_real(0);}
    else if (csi->type_contribution == "RRA"){ax_psp_doublereal(0);}
    else if (csi->type_contribution == "L2RA"){ax_psp_real(0);}
    else if (csi->type_contribution == "VT"){ax_psp_born(0);}
    else if (csi->type_contribution == "L2VT"){ax_psp_born(0);}
    else if (csi->type_contribution == "CT"){ax_psp_born(0);}
    else if (csi->type_contribution == "L2CT"){ax_psp_born(0);}
    else if (csi->type_contribution == "PT"){ax_psp_born(0);}
    else if (csi->type_contribution == "L2PT"){ax_psp_born(0);}
    else if (csi->type_contribution == "VT2"){ax_psp_born(0);}
    else if (csi->type_contribution == "CT2"){ax_psp_born(0);}
    else if (csi->type_contribution == "PT2"){ax_psp_born(0);}
  }

  logger.finished();
}
*/

void phasespace_set::ac_psp(int x_a, int channel){
  static Logger logger("phasespace_set::ac_psp");
  logger.called();

  /*
  if (switch_off_new_psp){
    if (csi->type_contribution == "born"){ac_psp_born(0, channel);}
    else if (csi->type_contribution == "L2I"){ac_psp_born(0, channel);}
    else if (csi->type_contribution == "RT"){ac_psp_real(0, channel);}
    else if (csi->type_contribution == "L2RT"){ac_psp_real(0, channel);}
    else if (csi->type_contribution == "VA"){ac_psp_born(0, channel);}
    else if (csi->type_contribution == "RVA"){ac_psp_real(0, channel);}
    else if (csi->type_contribution == "L2VA"){ac_psp_born(0, channel);}
    else if (csi->type_contribution == "CA"){ac_psp_born(0, channel);}
    else if (csi->type_contribution == "RCA"){ac_psp_real(0, channel);}
    else if (csi->type_contribution == "L2CA"){ac_psp_born(0, channel);}
    else if (csi->type_contribution == "RA"){ac_psp_real(0, channel);}
    else if (csi->type_contribution == "RRA"){ac_psp_doublereal(0, channel);}
    else if (csi->type_contribution == "L2RA"){ac_psp_real(0, channel);}
    else if (csi->type_contribution == "VT"){ac_psp_born(0, channel);}
    else if (csi->type_contribution == "L2VT"){ac_psp_born(0, channel);}
    else if (csi->type_contribution == "CT"){ac_psp_born(0, channel);}
    else if (csi->type_contribution == "L2CT"){ac_psp_born(0, channel);}
    else if (csi->type_contribution == "PT"){ac_psp_born(0, channel);}
    else if (csi->type_contribution == "L2PT"){ac_psp_born(0, channel);}
    else if (csi->type_contribution == "VT2"){ac_psp_born(0, channel);}
    else if (csi->type_contribution == "CT2"){ac_psp_born(0, channel);}
    else if (csi->type_contribution == "PT2"){ac_psp_born(0, channel);}
  }
  */
  if (!switch_off_new_psp){
    if (Log::getLogThreshold() <= LOG_DEBUG_VERBOSE){
      logger << LOG_DEBUG_VERBOSE << "x_a = " << x_a << "   channel = " << channel << endline_flush;
      logger << LOG_DEBUG_VERBOSE << "c_p.size() = " << c_p.size()  << endline_flush;
      logger << LOG_DEBUG_VERBOSE << "c_p[" << x_a << "].size() = " << c_p[x_a].size()  << endline_flush;
      logger << LOG_DEBUG_VERBOSE << "c_f.size() = " << c_f.size()  << endline_flush;
      logger << LOG_DEBUG_VERBOSE << "c_f[" << x_a << "].size() = " << c_f[x_a].size()  << endline_flush;
      logger << LOG_DEBUG_VERBOSE << "c_d.size() = " << c_d.size()  << endline_flush;
      logger << LOG_DEBUG_VERBOSE << "c_d[" << x_a << "].size() = " << c_d[x_a].size()  << endline_flush;
      logger << LOG_DEBUG_VERBOSE << "c_t.size() = " << c_t.size()  << endline_flush;
      logger << LOG_DEBUG_VERBOSE << "c_t[" << x_a << "].size() = " << c_t[x_a].size()  << endline_flush;
    }

    for (int i_p = 0; i_p < c_p[x_a][channel].size(); i_p++){ propagator[x_a][c_p[x_a][channel][i_p]].calculate_c(); }
    for (int i_f = 0; i_f < c_f[x_a][channel].size(); i_f++){ timelikeinvariant[x_a][c_f[x_a][channel][i_f]].calculate_c(); }
    for (int i_t = 0; i_t < c_t[x_a][channel].size(); i_t++){ tchannel[x_a][c_t[x_a][channel][i_t]].calculate_c(); }
    for (int i_d = 0; i_d < c_d[x_a][channel].size(); i_d++){ decay[x_a][c_d[x_a][channel][i_d]].calculate_c(); }

    if (Log::getLogThreshold() <= LOG_DEBUG_POINT){
      for (int i_a = 0; i_a < csi->n_ps; i_a++){
	for (int i_r = 0; i_r < required_xbp[i_a].size(); i_r++){ if (psp[i_a][required_xbp[i_a][i_r]].get_available_p()){ logger << LOG_DEBUG_POINT << "p - psp[" << i_a << "][" << required_xbp[i_a][i_r] << "]  is AVAILABLE - " << xbp_all[i_a][required_xbp[i_a][i_r]] << "   " << & xbp_all[i_a][required_xbp[i_a][i_r]] << endline_flush; } }
	for (int i_r = 0; i_r < required_xbs[i_a].size(); i_r++){ if (psp[i_a][required_xbs[i_a][i_r]].get_available_p()){ logger << LOG_DEBUG_POINT << "s - psp[" << i_a << "][" << required_xbs[i_a][i_r] << "]  is AVAILABLE - " << xbp_all[i_a][required_xbs[i_a][i_r]] <<  "   " << & xbp_all[i_a][required_xbs[i_a][i_r]] << endline_flush; } }
	for (int i_r = 0; i_r < required_xbsqrts[i_a].size(); i_r++){  if (psp[i_a][required_xbsqrts[i_a][i_r]].get_available_p()){ logger << LOG_DEBUG_POINT << "q - psp[" << i_a << "][" << required_xbsqrts[i_a][i_r] << "]  is AVAILABLE - " << xbp_all[i_a][required_xbsqrts[i_a][i_r]] <<  "   " << & xbsqrts_all[i_a][required_xbp[i_a][i_r]] << endline_flush; } }
      }
    }
  }
    
  logger.finished();
}


void phasespace_set::ag_psp(int x_a, int zero){
  static Logger logger("phasespace_set::ag_psp");
  logger.called();

  /*
  if (switch_off_new_psp){
    if (csi->type_contribution == "born"){ag_psp_born(0, zero);}
    else if (csi->type_contribution == "L2I"){ag_psp_born(0, zero);}
    else if (csi->type_contribution == "RT"){ag_psp_real(0, zero);}
    else if (csi->type_contribution == "L2RT"){ag_psp_real(0, zero);}
    else if (csi->type_contribution == "VA"){ag_psp_born(0, zero);}
    else if (csi->type_contribution == "RVA"){ag_psp_real(0, zero);}
    else if (csi->type_contribution == "L2VA"){ag_psp_born(0, zero);}
    else if (csi->type_contribution == "CA"){ag_psp_born(0, zero);}
    else if (csi->type_contribution == "RCA"){ag_psp_real(0, zero);}
    else if (csi->type_contribution == "L2CA"){ag_psp_born(0, zero);}
    else if (csi->type_contribution == "RA"){ag_psp_real(0, zero);}
    else if (csi->type_contribution == "RRA"){ag_psp_doublereal(0, zero);}
    else if (csi->type_contribution == "L2RA"){ag_psp_real(0, zero);}
    else if (csi->type_contribution == "VT"){ag_psp_born(0, zero);}
    else if (csi->type_contribution == "L2VT"){ag_psp_born(0, zero);}
    else if (csi->type_contribution == "CT"){ag_psp_born(0, zero);}
    else if (csi->type_contribution == "L2CT"){ag_psp_born(0, zero);}
    else if (csi->type_contribution == "PT"){ag_psp_born(0, zero);}
    else if (csi->type_contribution == "L2PT"){ag_psp_born(0, zero);}
    else if (csi->type_contribution == "VT2"){ag_psp_born(0, zero);}
    else if (csi->type_contribution == "CT2"){ag_psp_born(0, zero);}
    else if (csi->type_contribution == "PT2"){ag_psp_born(0, zero);}
  }
  */
  
  if (!switch_off_new_psp){
    if (Log::getLogThreshold() <= LOG_DEBUG_POINT){
      //      for (int i_a = 0; i_a < csi->n_ps; i_a++){
	for (int i_r = 0; i_r < required_xbp[x_a].size(); i_r++){ if (psp[x_a][required_xbp[x_a][i_r]].get_available_p()){ logger << LOG_DEBUG_POINT << "p - psp[" << x_a << "][" << required_xbp[x_a][i_r] << "]  is AVAILABLE - " << xbp_all[x_a][required_xbp[x_a][i_r]] << "   " << & xbp_all[x_a][required_xbp[x_a][i_r]] << endline_flush; } }
	for (int i_r = 0; i_r < required_xbs[x_a].size(); i_r++){ if (psp[x_a][required_xbs[x_a][i_r]].get_available_p()){ logger << LOG_DEBUG_POINT << "s - psp[" << x_a << "][" << required_xbs[x_a][i_r] << "]  is AVAILABLE - " << xbp_all[x_a][required_xbs[x_a][i_r]] <<  "   " << & xbp_all[x_a][required_xbs[x_a][i_r]] << endline_flush; } }
	for (int i_r = 0; i_r < required_xbsqrts[x_a].size(); i_r++){  if (psp[x_a][required_xbsqrts[x_a][i_r]].get_available_p()){ logger << LOG_DEBUG_POINT << "q - psp[" << x_a << "][" << required_xbsqrts[x_a][i_r] << "]  is AVAILABLE - " << xbp_all[x_a][required_xbsqrts[x_a][i_r]] <<  "   " << & xbsqrts_all[x_a][required_xbp[x_a][i_r]] << endline_flush; } }
	//      }
    }
    
    for (int i_r = 0; i_r < required_xbp[x_a].size(); i_r++){ psp[x_a][required_xbp[x_a][i_r]].get_p(); }
    for (int i_r = 0; i_r < required_xbs[x_a].size(); i_r++){ psp[x_a][required_xbs[x_a][i_r]].get_s(); }
    for (int i_r = 0; i_r < required_xbsqrts[x_a].size(); i_r++){ psp[x_a][required_xbsqrts[x_a][i_r]].get_sqrts(); }
    
    for (int i_smin = 0; i_smin < smin[x_a].size(); i_smin++){ smin[x_a][i_smin].get(); }
    for (int i_smax = 0; i_smax < smax[x_a].size(); i_smax++){ smax[x_a][i_smax].get(); }
    for (int i_p = 0; i_p < propagator[x_a].size(); i_p++){ propagator[x_a][i_p].calculate_g(); }
    for (int i_f = 0; i_f < timelikeinvariant[x_a].size(); i_f++){ timelikeinvariant[x_a][i_f].calculate_g(); }
    for (int i_t = 0; i_t < tchannel[x_a].size(); i_t++){ tchannel[x_a][i_t].calculate_g(); }
    for (int i_d = 0; i_d < decay[x_a].size(); i_d++){ decay[x_a][i_d].calculate_g(); }
    if (switch_IS_mode_phasespace == 4){
      for (int i_p = 0; i_p < propagator[x_a].size(); i_p++){ propagator[x_a][i_p].calculate_inv_r(); }
      for (int i_f = 0; i_f < timelikeinvariant[x_a].size(); i_f++){ timelikeinvariant[x_a][i_f].calculate_inv_r(); }
      for (int i_t = 0; i_t < tchannel[x_a].size(); i_t++){ tchannel[x_a][i_t].calculate_inv_r(); }
      for (int i_d = 0; i_d < decay[x_a].size(); i_d++){ decay[x_a][i_d].calculate_inv_r(); }
    }
    for (int i_c = 0; i_c < MC_n_channel_phasespace[x_a]; i_c++){
      if (MC_phasespace.alpha[zero + i_c] != 0.){
	MC_phasespace.g_channel[zero + i_c] = 1.;
	for (int i_p = 0; i_p < c_p[x_a][i_c].size(); i_p++){ MC_phasespace.g_channel[zero + i_c] *= g_p[x_a][c_p[x_a][i_c][i_p]]; }
	for (int i_f = 0; i_f < c_f[x_a][i_c].size(); i_f++){ MC_phasespace.g_channel[zero + i_c] *= g_f[x_a][c_f[x_a][i_c][i_f]]; }
	for (int i_t = 0; i_t < c_t[x_a][i_c].size(); i_t++){ MC_phasespace.g_channel[zero + i_c] *= g_t[x_a][c_t[x_a][i_c][i_t]]; }
	for (int i_d = 0; i_d < c_d[x_a][i_c].size(); i_d++){ MC_phasespace.g_channel[zero + i_c] *= g_d[x_a][c_d[x_a][i_c][i_d]]; }
      }
    }

    if (Log::getLogThreshold() <= LOG_DEBUG_POINT){
      logger << LOG_DEBUG_POINT << "MC_n_channel_phasespace[" << x_a << "] = " << MC_n_channel_phasespace[x_a] << endline_flush;
      for (int i_c = 0; i_c < MC_n_channel_phasespace[x_a]; i_c++){
	if (MC_phasespace.alpha[zero + i_c] != 0.){
	  for (int i_p = 0; i_p < c_p[x_a][i_c].size(); i_p++){ logger << LOG_DEBUG_POINT << "g_p[" << x_a << "][" << c_p[x_a][i_c][i_p] << "] = " << g_p[x_a][c_p[x_a][i_c][i_p]] << endline_flush; }
	  for (int i_f = 0; i_f < c_f[x_a][i_c].size(); i_f++){ logger << LOG_DEBUG_POINT << "g_f[" << x_a << "][" << c_f[x_a][i_c][i_f] << "] = " << g_f[x_a][c_f[x_a][i_c][i_f]] << endline_flush; }
	  for (int i_t = 0; i_t < c_t[x_a][i_c].size(); i_t++){ logger << LOG_DEBUG_POINT << "g_t[" << x_a << "][" << c_t[x_a][i_c][i_t] << "] = " << g_t[x_a][c_t[x_a][i_c][i_t]] << endline_flush; }
	  for (int i_d = 0; i_d < c_d[x_a][i_c].size(); i_d++){ logger << LOG_DEBUG_POINT << "g_d[" << x_a << "][" << c_d[x_a][i_c][i_d] << "] = " << g_d[x_a][c_d[x_a][i_c][i_d]] << endline_flush; }
	}
      }
    }
  }

  logger.finished();
}


void phasespace_set::ac_tau_psp(int x_a, vector<int> & tau_MC_map){
  static Logger logger("phasespace_set::ac_tau_psp");
  logger.called();

  if (csi->type_contribution == "born"){ac_tau_psp_born(0, tau_MC_map);}
  else if (csi->type_contribution == "L2I"){ac_tau_psp_born(0, tau_MC_map);}
  else if (csi->type_contribution == "RT"){ac_tau_psp_real(0, tau_MC_map);}
  else if (csi->type_contribution == "L2RT"){ac_tau_psp_real(0, tau_MC_map);}
  else if (csi->type_contribution == "VA"){ac_tau_psp_born(0, tau_MC_map);}
  else if (csi->type_contribution == "RVA"){ac_tau_psp_real(0, tau_MC_map);}
  else if (csi->type_contribution == "L2VA"){ac_tau_psp_born(0, tau_MC_map);}
  else if (csi->type_contribution == "CA"){ac_tau_psp_born(0, tau_MC_map);}
  else if (csi->type_contribution == "RCA"){ac_tau_psp_real(0, tau_MC_map);}
  else if (csi->type_contribution == "L2CA"){ac_tau_psp_born(0, tau_MC_map);}
  else if (csi->type_contribution == "RA"){ac_tau_psp_real(0, tau_MC_map);}
  else if (csi->type_contribution == "RRA"){ac_tau_psp_doublereal(0, tau_MC_map);}
  else if (csi->type_contribution == "L2RA"){ac_tau_psp_real(0, tau_MC_map);}
  else if (csi->type_contribution == "VT"){ac_tau_psp_born(0, tau_MC_map);}
  else if (csi->type_contribution == "L2VT"){ac_tau_psp_born(0, tau_MC_map);}
  else if (csi->type_contribution == "CT"){ac_tau_psp_born(0, tau_MC_map);}
  else if (csi->type_contribution == "L2CT"){ac_tau_psp_born(0, tau_MC_map);}
  else if (csi->type_contribution == "PT"){ac_tau_psp_born(0, tau_MC_map);}
  else if (csi->type_contribution == "L2PT"){ac_tau_psp_born(0, tau_MC_map);}
  else if (csi->type_contribution == "VT2"){ac_tau_psp_born(0, tau_MC_map);}
  else if (csi->type_contribution == "CT2"){ac_tau_psp_born(0, tau_MC_map);}
  else if (csi->type_contribution == "PT2"){ac_tau_psp_born(0, tau_MC_map);}
  else if (csi->type_contribution == "RJ"){ac_tau_psp_real(0, tau_MC_map);}
  else if (csi->type_contribution == "VJ"){ac_tau_psp_born(0, tau_MC_map);}
  else if (csi->type_contribution == "CJ"){ac_tau_psp_born(0, tau_MC_map);}

  logger.finished();
}


void phasespace_set::ac_tau_psp_dipole(int x_a, vector<int> & tau_MC_map){
  static Logger logger("phasespace_set::ac_tau_psp_dipole");
  logger.called();

  if (csi->type_contribution == "RA"){ac_tau_psp_born(x_a, tau_MC_map);}
  else if (csi->type_contribution == "RRA"){ac_tau_psp_real(x_a, tau_MC_map);}
  else if (csi->type_contribution == "L2RA"){ac_tau_psp_born(x_a, tau_MC_map);}
  else if (csi->type_contribution == "RT"){ac_tau_psp_born(x_a, tau_MC_map);}
  else if (csi->type_contribution == "L2RT"){ac_tau_psp_born(x_a, tau_MC_map);}
  else if (csi->type_contribution == "RVA"){ac_tau_psp_born(x_a, tau_MC_map);}
  else if (csi->type_contribution == "L2VA"){ac_tau_psp_born(x_a, tau_MC_map);}
  else if (csi->type_contribution == "RCA"){ac_tau_psp_born(x_a, tau_MC_map);}
  else if (csi->type_contribution == "L2CA"){ac_tau_psp_born(x_a, tau_MC_map);}
  else if (csi->type_contribution == "RJ"){ac_tau_psp_born(x_a, tau_MC_map);}

  logger.finished();
}


void phasespace_set::ac_tau_psp_doubledipole(int x_a, vector<int> & tau_MC_map){
  static Logger logger("phasespace_set::ac_tau_psp_doubledipole");
  logger.called();

  if (csi->type_contribution == "RRA"){ac_tau_psp_born(x_a, tau_MC_map);}

  logger.finished();
}

/*
void phasespace_set::initialization_psp_dipole(int x_a){
  static Logger logger("phasespace_set::initialization_psp_dipole");
  logger.called();

  if (csi->type_contribution == "RA"){initialization_psp_born(x_a);}
  else if (csi->type_contribution == "RRA"){initialization_psp_real(x_a);}
  else if (csi->type_contribution == "L2RA"){initialization_psp_born(x_a);}

  logger.finished();
}
*/
/*
void phasespace_set::ax_psp_dipole(int x_a){
  static Logger logger("phasespace_set::ax_psp_dipole");
  logger.called();

  if (switch_off_new_psp){
    if (csi->type_contribution == "RA"){ax_psp_born(x_a);}
    else if (csi->type_contribution == "RRA"){ax_psp_real(x_a);}
    else if (csi->type_contribution == "L2RA"){ax_psp_born(x_a);}
  }

  logger.finished();
}
*/

void phasespace_set::ac_psp_dipole(int x_a, int channel){
  static Logger logger("phasespace_set::ac_psp_dipole");
  logger.called();

  if (switch_off_new_psp){
    if (csi->type_contribution == "RA"){ac_psp_born(x_a, channel);}
    else if (csi->type_contribution == "L2RA"){ac_psp_born(x_a, channel);}
    else if (csi->type_contribution == "RRA"){ac_psp_real(x_a, channel);}
  }
  // The whole function might not be required any more -> ac_psp should be identical !!!
  if (!switch_off_new_psp){ ac_psp(x_a, channel); }
  /*
  if (!switch_off_new_psp){
    for (int i_p = 0; i_p < c_p[x_a][channel].size(); i_p++){ propagator[x_a][c_p[x_a][channel][i_p]].calculate_c(); }
    for (int i_f = 0; i_f < c_f[x_a][channel].size(); i_f++){ timelikeinvariant[x_a][c_f[x_a][channel][i_f]].calculate_c(); }
    for (int i_t = 0; i_t < c_t[x_a][channel].size(); i_t++){ tchannel[x_a][c_t[x_a][channel][i_t]].calculate_c(); }
    for (int i_d = 0; i_d < c_d[x_a][channel].size(); i_d++){ decay[x_a][c_d[x_a][channel][i_d]].calculate_c(); }
  }
  */

  logger.finished();
}


void phasespace_set::ag_psp_dipole(int x_a, int zero){
  static Logger logger("phasespace_set::ag_psp_dipole");
  logger.called();

  if (switch_off_new_psp){
    if (csi->type_contribution == "RA"){ag_psp_born(x_a, zero);}
    else if (csi->type_contribution == "L2RA"){ag_psp_born(x_a, zero);}
    else if (csi->type_contribution == "RRA"){ag_psp_real(x_a, zero);}
  }
  
  if (!switch_off_new_psp){ ag_psp(x_a, zero); }
  /*
  if (!switch_off_new_psp){
    for (int i_r = 0; i_r < required_xbp[x_a].size(); i_r++){ psp[x_a][required_xbp[x_a][i_r]].get_p(); }
    for (int i_r = 0; i_r < required_xbs[x_a].size(); i_r++){ psp[x_a][required_xbs[x_a][i_r]].get_s(); }
    for (int i_r = 0; i_r < required_xbsqrts[x_a].size(); i_r++){ psp[x_a][required_xbsqrts[x_a][i_r]].get_sqrts(); }
    
    for (int i_smin = 0; i_smin < smin[x_a].size(); i_smin++){ smin[x_a][i_smin].get(); }
    for (int i_smax = 0; i_smax < smax[x_a].size(); i_smax++){ smax[x_a][i_smax].get(); }
    for (int i_p = 0; i_p < propagator[x_a].size(); i_p++){ propagator[x_a][i_p].calculate_g(); }
    for (int i_f = 0; i_f < timelikeinvariant[x_a].size(); i_f++){ timelikeinvariant[x_a][i_f].calculate_g(); }
    for (int i_t = 0; i_t < tchannel[x_a].size(); i_t++){ tchannel[x_a][i_t].calculate_g(); }
    for (int i_d = 0; i_d < decay[x_a].size(); i_d++){ decay[x_a][i_d].calculate_g(); }
    if (switch_IS_mode_phasespace == 4){
      for (int i_p = 0; i_p < propagator[x_a].size(); i_p++){ propagator[x_a][i_p].calculate_inv_r(); }
      for (int i_f = 0; i_f < timelikeinvariant[x_a].size(); i_f++){ timelikeinvariant[x_a][i_f].calculate_inv_r(); }
      for (int i_t = 0; i_t < tchannel[x_a].size(); i_t++){ tchannel[x_a][i_t].calculate_inv_r(); }
      for (int i_d = 0; i_d < decay[x_a].size(); i_d++){ decay[x_a][i_d].calculate_inv_r(); }
    }
    for (int i_c = 0; i_c < MC_n_channel_phasespace[x_a]; i_c++){
      if (MC_phasespace.alpha[zero + i_c] != 0.){
	MC_phasespace.g_channel[zero + i_c] = 1.;
	for (int i_p = 0; i_p < c_p[x_a][i_c].size(); i_p++){ MC_phasespace.g_channel[zero + i_c] *= g_p[x_a][c_p[x_a][i_c][i_p]]; }
	for (int i_f = 0; i_f < c_f[x_a][i_c].size(); i_f++){ MC_phasespace.g_channel[zero + i_c] *= g_f[x_a][c_f[x_a][i_c][i_f]]; }
	for (int i_t = 0; i_t < c_t[x_a][i_c].size(); i_t++){ MC_phasespace.g_channel[zero + i_c] *= g_t[x_a][c_t[x_a][i_c][i_t]]; }
	for (int i_d = 0; i_d < c_d[x_a][i_c].size(); i_d++){ MC_phasespace.g_channel[zero + i_c] *= g_d[x_a][c_d[x_a][i_c][i_d]]; }
      }
    }

    if (Log::getLogThreshold() <= LOG_DEBUG_POINT){
      logger << LOG_DEBUG_POINT << "MC_n_channel_phasespace[" << x_a << "] = " << MC_n_channel_phasespace[x_a] << endline_flush;
      for (int i_c = 0; i_c < MC_n_channel_phasespace[x_a]; i_c++){
	if (MC_phasespace.alpha[zero + i_c] != 0.){
	  for (int i_p = 0; i_p < c_p[x_a][i_c].size(); i_p++){ logger << LOG_DEBUG_POINT << "g_p[" << x_a << "][" << c_p[x_a][i_c][i_p] << "] = " << g_p[x_a][c_p[x_a][i_c][i_p]] << endline_flush; }
	  for (int i_f = 0; i_f < c_f[x_a][i_c].size(); i_f++){ logger << LOG_DEBUG_POINT << "g_f[" << x_a << "][" << c_f[x_a][i_c][i_f] << "] = " << g_p[x_a][c_f[x_a][i_c][i_f]] << endline_flush; }
	  for (int i_t = 0; i_t < c_t[x_a][i_c].size(); i_t++){ logger << LOG_DEBUG_POINT << "g_t[" << x_a << "][" << c_t[x_a][i_c][i_t] << "] = " << g_p[x_a][c_t[x_a][i_c][i_t]] << endline_flush; }
	  for (int i_d = 0; i_d < c_d[x_a][i_c].size(); i_d++){ logger << LOG_DEBUG_POINT << "g_d[" << x_a << "][" << c_d[x_a][i_c][i_d] << "] = " << g_p[x_a][c_d[x_a][i_c][i_d]] << endline_flush; }
	}
      }
    }
  }
  */
  
  logger.finished();
}


void phasespace_set::optimize_minv(){
  static Logger logger("phasespace_set::optimize_minv");
  logger.called();

  if (csi->type_contribution == "born"){optimize_minv_born();}
  else if (csi->type_contribution == "L2I"){optimize_minv_born();}
  else if (csi->type_contribution == "RT"){optimize_minv_real();}
  else if (csi->type_contribution == "L2RT"){optimize_minv_real();}
  else if (csi->type_contribution == "VA"){optimize_minv_born();}
  else if (csi->type_contribution == "RVA"){optimize_minv_real();}
  else if (csi->type_contribution == "L2VA"){optimize_minv_born();}
  else if (csi->type_contribution == "CA"){optimize_minv_born();}
  else if (csi->type_contribution == "RCA"){optimize_minv_real();}
  else if (csi->type_contribution == "L2CA"){optimize_minv_born();}
  else if (csi->type_contribution == "RA"){optimize_minv_real();}
  else if (csi->type_contribution == "RRA"){optimize_minv_doublereal();}
  else if (csi->type_contribution == "L2RA"){optimize_minv_real();}
  else if (csi->type_contribution == "VT"){optimize_minv_born();}
  else if (csi->type_contribution == "L2VT"){optimize_minv_born();}
  else if (csi->type_contribution == "CT"){optimize_minv_born();}
  else if (csi->type_contribution == "L2CT"){optimize_minv_born();}
  else if (csi->type_contribution == "PT"){optimize_minv_born();}
  else if (csi->type_contribution == "L2PT"){optimize_minv_born();}
  else if (csi->type_contribution == "VT2"){optimize_minv_born();}
  else if (csi->type_contribution == "CT2"){optimize_minv_born();}
  else if (csi->type_contribution == "PT2"){optimize_minv_born();}
  else if (csi->type_contribution == "RJ"){optimize_minv_real();}
  else if (csi->type_contribution == "VJ"){optimize_minv_born();}
  else if (csi->type_contribution == "CJ"){optimize_minv_born();}

  logger.finished();
}

/*
int phasespace_set::determination_MCchannels(int x_a){
  static Logger logger("phasespace_set::determination_MCchannels");
  logger.called();

  logger << LOG_DEBUG << "fullchannel[x_a = " << x_a << "].size() = " << fullchannel[x_a].size() << endline_flush;

  if (csi->type_contribution == "born"){return determination_MCchannels_born(0);}
  else if (csi->type_contribution == "L2I"){return determination_MCchannels_born(0);}
  else if (csi->type_contribution == "RT"){return determination_MCchannels_real(0);}
  else if (csi->type_contribution == "L2RT"){return determination_MCchannels_real(0);}
  else if (csi->type_contribution == "VA"){return determination_MCchannels_born(0);}
  else if (csi->type_contribution == "RVA"){return determination_MCchannels_real(0);}
  else if (csi->type_contribution == "L2VA"){return determination_MCchannels_born(0);}
  else if (csi->type_contribution == "CA"){return determination_MCchannels_born(0);}
  else if (csi->type_contribution == "RCA"){return determination_MCchannels_real(0);}
  else if (csi->type_contribution == "L2CA"){return determination_MCchannels_born(0);}
  else if (csi->type_contribution == "RA"){return determination_MCchannels_real(0);}
  else if (csi->type_contribution == "RRA"){return determination_MCchannels_doublereal(0);}
  else if (csi->type_contribution == "L2RA"){return determination_MCchannels_real(0);}
  else if (csi->type_contribution == "VT"){return determination_MCchannels_born(0);}
  else if (csi->type_contribution == "L2VT"){return determination_MCchannels_born(0);}
  else if (csi->type_contribution == "CT"){return determination_MCchannels_born(0);}
  else if (csi->type_contribution == "L2CT"){return determination_MCchannels_born(0);}
  else if (csi->type_contribution == "PT"){return determination_MCchannels_born(0);}
  else if (csi->type_contribution == "L2PT"){return determination_MCchannels_born(0);}
  else if (csi->type_contribution == "VT2"){return determination_MCchannels_born(0);}
  else if (csi->type_contribution == "CT2"){return determination_MCchannels_born(0);}
  else if (csi->type_contribution == "PT2"){return determination_MCchannels_born(0);}
  else if (csi->type_contribution == "RT"){return determination_MCchannels_real(0);}
  else if (csi->type_contribution == "VT"){return determination_MCchannels_born(0);}
  else if (csi->type_contribution == "CT"){return determination_MCchannels_born(0);}

  logger.finished();
  return 0;
}
*/
/*
int phasespace_set::determination_MCchannels_dipole(int x_a){
  static Logger logger("phasespace_set::determination_MCchannels_dipole");
  logger.called();
  logger << LOG_DEBUG << "fullchannel[x_a = " << x_a << "].size() = " << fullchannel[x_a].size() << endline_flush;

  if (csi->type_contribution == "RA"){return determination_MCchannels_born(x_a);}
  else if (csi->type_contribution == "L2RA"){return determination_MCchannels_born(x_a);}
  else if (csi->type_contribution == "RRA"){return determination_MCchannels_real(x_a);}

  logger.finished();
  return 0;
}
*/


void phasespace_set::calculate_g_tot(){
  static Logger logger("phasespace_set::calculate_g_tot");
  logger.called();

  if (!identical_psp || (!end_optimization && i_gen_step == 1)){
    g_MC = 0.;
    for (int j = 0; j < MC_phasespace.alpha.size(); j++){g_MC += MC_phasespace.g_channel[j] * MC_phasespace.alpha[j];}

    if (g_global_NWA != 1.){g_MC *= g_global_NWA;}
  }
  if (csi->coll_choice > 0){g_tot = g_MC * g_pdf;}
  else {g_tot = g_MC;}
  if (switch_IS_mode_phasespace == 1 || switch_IS_mode_phasespace == 3){g_tot = g_tot * MC_g_IS_global;}

  if (Log::getLogThreshold() <= LOG_DEBUG_POINT){
    logger << LOG_DEBUG_POINT << setw(20) << "MC_tau.channel" << " = " << MC_tau.channel << endline_flush;
    logger << LOG_DEBUG_POINT << setw(20) << "g_MC" << " = " << setprecision(20) << setw(28) << g_MC << "   " << double2hexastr(g_MC) << endline_flush;
    logger << LOG_DEBUG_POINT << setw(20) << "g_pdf" << " = " << setprecision(20) << setw(28) << g_pdf << "   " << double2hexastr(g_pdf) << endline_flush;
    logger << LOG_DEBUG_POINT << setw(20) << "g_tot" << " = " << setprecision(20) << setw(28) << g_tot << "   " << double2hexastr(g_tot) << endline_flush;
    logger << LOG_DEBUG_POINT << setw(20) << "xbs_all[0][0]" << " = " << setprecision(20) << setw(28) << xbs_all[0][0] << "   " << double2hexastr(xbs_all[0][0]) << endline_flush;
    logger << LOG_DEBUG_POINT << setw(20) << setw(20) << "g_tot" << " = " << setprecision(20) << setw(28) << g_tot << "   " << double2hexastr(g_tot) << endline_flush;
    logger << LOG_DEBUG_POINT << setw(20) << setw(20) << "xbs_all[0][0]" << " = " << setprecision(20) << setw(28) << xbs_all[0][0] << "   " << double2hexastr(xbs_all[0][0]) << endline_flush;
  }

  ps_factor = hcf / (g_tot * xbs_all[0][0]);

  logger.finished();
}


void phasespace_set::calculate_IS(){
  static Logger logger("phasespace_set::calculate_IS");
  logger.called();

  //  static bool new_psp_active = (propagator.size() || timelikeinvariant.size() || tchannel.size() || decay.size());
  
  if (Log::getLogThreshold() <= LOG_DEBUG_POINT){ logger << LOG_DEBUG_POINT << "i_gen = " << setw(12) << i_gen << "   i_acc = " << setw(12) << i_acc << "   i_rej = " << setw(12) << i_rej << "   i_nan = " << setw(12) << i_nan << "   i_tec = " << setw(12) << i_tec << endline_flush; }

  if (Log::getLogThreshold() <= LOG_DEBUG_VERBOSE){ logger << LOG_DEBUG_VERBOSE << "NEW RNG -- get_random_number_set" << endline << rng.output_random_generator_set() << endline_flush; }
  rng.get_random_number_set();
  if (Log::getLogThreshold() <= LOG_DEBUG_VERBOSE){ logger << LOG_DEBUG_VERBOSE << "NEW RNG -- random_number_set   -- n_random_per_psp = " << n_random_per_psp << endline << rng.output_random_number_set() << endline_flush; }

  if (!identical_psp){
    if (switch_off_new_psp){
      xbp_all = start_xbp_all;
      xbs_all = start_xbs_all;
      xbsqrts_all = start_xbsqrts_all;
    }

    // reset 'available' variables (based on previous phase space point):
    if (!switch_off_new_psp){
      for (int i_a = 0; i_a < csi->n_ps; i_a++){
	logger << LOG_DEBUG_VERBOSE << "i_a = " << i_a << endline_flush;
	for (int i_r = 0; i_r < required_xbp[i_a].size(); i_r++){ psp[i_a][required_xbp[i_a][i_r]].reset_p(); }
	for (int i_r = 0; i_r < required_xbs[i_a].size(); i_r++){ psp[i_a][required_xbs[i_a][i_r]].reset_s(); psp[i_a][required_xbs[i_a][i_r]].reset_p(); }
	for (int i_r = 0; i_r < required_xbsqrts[i_a].size(); i_r++){ psp[i_a][required_xbsqrts[i_a][i_r]].reset_sqrts(); psp[i_a][required_xbsqrts[i_a][i_r]].reset_s(); psp[i_a][required_xbsqrts[i_a][i_r]].reset_p(); }
	for (int i_smin = 0; i_smin < smin[i_a].size(); i_smin++){ smin[i_a][i_smin].reset(); }
	for (int i_smax = 0; i_smax < smax[i_a].size(); i_smax++){ smax[i_a][i_smax].reset(); }
      }
      logger << LOG_DEBUG_VERBOSE << "RA_x_a = " << RA_x_a << endline_flush;
      int temp_channel;
      if (RA_x_a == 0){ temp_channel = MC_phasespace.channel; }
      else { temp_channel = MC_phasespace.channel - csi->dipole[RA_x_a - 1].sum_channel(); }
      logger << LOG_DEBUG_VERBOSE << "temp_channel = " << temp_channel << endline_flush;
      logger << LOG_DEBUG_VERBOSE << "fullchannel.size() = " << fullchannel.size() << endline_flush;
      logger << LOG_DEBUG_VERBOSE << "fullchannel[RA_x_a = " << RA_x_a << "].size() = " << fullchannel[RA_x_a].size() << endline_flush;
      logger << LOG_DEBUG_VERBOSE << "c_p.size() = " << c_p.size() << endline_flush;
      logger << LOG_DEBUG_VERBOSE << "c_p[RA_x_a = " << RA_x_a << "].size() = " << c_p[RA_x_a].size() << endline_flush;
      if (c_p[RA_x_a].size()){ for (int i_p = 0; i_p < c_p[RA_x_a][temp_channel].size(); i_p++){ logger << LOG_DEBUG_VERBOSE << "i_p = " << i_p << endline_flush; propagator[RA_x_a][c_p[RA_x_a][temp_channel][i_p]].available = false; } }
      logger << LOG_DEBUG_VERBOSE << "c_f.size() = " << c_f.size() << endline_flush;
      logger << LOG_DEBUG_VERBOSE << "c_f[RA_x_a = " << RA_x_a << "].size() = " << c_f[RA_x_a].size() << endline_flush;
      if (c_f[RA_x_a].size()){ for (int i_f = 0; i_f < c_f[RA_x_a][temp_channel].size(); i_f++){ logger << LOG_DEBUG_VERBOSE << "i_f = " << i_f << endline_flush; timelikeinvariant[RA_x_a][c_f[RA_x_a][temp_channel][i_f]].available = false; } }
      logger << LOG_DEBUG_VERBOSE << "c_t.size() = " << c_t.size() << endline_flush;
      logger << LOG_DEBUG_VERBOSE << "c_t[RA_x_a = " << RA_x_a << "].size() = " << c_t[RA_x_a].size() << endline_flush;
      if (c_t[RA_x_a].size()){ for (int i_t = 0; i_t < c_t[RA_x_a][temp_channel].size(); i_t++){ logger << LOG_DEBUG_VERBOSE << "i_t = " << i_t << endline_flush; tchannel[RA_x_a][c_t[RA_x_a][temp_channel][i_t]].available = false; } }
      logger << LOG_DEBUG_VERBOSE << "c_d.size() = " << c_d.size() << endline_flush;
      logger << LOG_DEBUG_VERBOSE << "c_d[RA_x_a = " << RA_x_a << "].size() = " << c_d[RA_x_a].size() << endline_flush;
      if (c_d[RA_x_a].size()){ for (int i_d = 0; i_d < c_d[RA_x_a][temp_channel].size(); i_d++){ logger << LOG_DEBUG_VERBOSE << "i_d = " << i_d << endline_flush; decay[RA_x_a][c_d[RA_x_a][temp_channel][i_d]].available = false; } }
      logger << LOG_DEBUG_VERBOSE << "done" << endline_flush;
    }
  }
  i_gen++;
  i_gen_step++;

  if (!switch_off_new_psp){
    if (Log::getLogThreshold() <= LOG_DEBUG){
      for (int i_a = 0; i_a < csi->n_ps; i_a++){
	for (int i_r = 0; i_r < required_xbp[i_a].size(); i_r++){ if (psp[i_a][required_xbp[i_a][i_r]].get_available_p()){ logger << LOG_DEBUG << "p - psp[" << i_a << "][" << required_xbp[i_a][i_r] << "]  should not be AVAILABLE" << endline_flush; } }
	for (int i_r = 0; i_r < required_xbs[i_a].size(); i_r++){ if (psp[i_a][required_xbs[i_a][i_r]].get_available_p()){ logger << LOG_DEBUG << "s - psp[" << i_a << "][" << required_xbs[i_a][i_r] << "]  should not be AVAILABLE" << endline_flush; } }
	for (int i_r = 0; i_r < required_xbsqrts[i_a].size(); i_r++){  if (psp[i_a][required_xbsqrts[i_a][i_r]].get_available_p()){ logger << LOG_DEBUG << "q - psp[" << i_a << "][" << required_xbsqrts[i_a][i_r] << "]  should not be AVAILABLE" << endline_flush; } }
      }
    }
  }
  
  if (csi->coll_choice != 0){
    logger << LOG_DEBUG_VERBOSE << "start_xbs_all[0][xb_max - 4 = " << xb_max - 4 << "] = " << start_xbs_all[0][xb_max - 4] << endline_flush;
    if (start_xbs_all[0][xb_max - 4] != 0.){
      calculate_initial_tau_fixed_x1x2_IS();
      /*
if (IS_x1x2->switch_optimization != 0){
	calculate_initial_tau_fixed_x1x2_IS();
      }
      else if (IS_x1x2->switch_optimization == 0){
	calculate_initial_tau_fixed_x1x2();
      }
      else {
	logger << LOG_FATAL << "No valid  tau_fixed  ---  " << "IS_x1x2->switch_optimization = " << IS_x1x2->switch_optimization << "  combination." << endline_flush;
	exit(1);
      }
      */
    }
    else {
      calculate_initial_tau_IS_x1x2_IS();
      /*
      if (IS_tau->switch_optimization != 0 && IS_x1x2->switch_optimization != 0){
	calculate_initial_tau_IS_x1x2_IS();
      }
      else if (IS_tau->switch_optimization != 0 && IS_x1x2->switch_optimization == 0){
	calculate_initial_tau_IS_x1x2();
      }
      else if (IS_tau->switch_optimization == 0 && IS_x1x2->switch_optimization != 0){
	calculate_initial_tau_x1x2_IS();
      }
      else if (IS_tau->switch_optimization == 0 && IS_x1x2->switch_optimization == 0){
	calculate_initial_tau_x1x2();
      }
      else {
	logger << LOG_FATAL << "No valid  IS_tau->switch_optimization = " << IS_tau->switch_optimization << "  ---  " << "IS_x1x2->switch_optimization = " << IS_x1x2->switch_optimization << "  combination." << endline_flush;
	exit(1);
      }
      */
    }

    boost = (x_pdf[1] - x_pdf[2]) / (x_pdf[1] + x_pdf[2]);
    g_pdf = g_tau * g_x1x2;
    logger << LOG_DEBUG_VERBOSE << "g_pdf = " << g_pdf << endline_flush;
  }

  double temp_random_MC_channel = rng.access_random_number();
  for (int j = 0; j < MC_phasespace.beta.size(); j++){if (temp_random_MC_channel <= MC_phasespace.beta[j]){MC_phasespace.channel = j; break;}}


  MC_g_IS_global = 1.;

  // more informative name for 'weight_IS', e.g. switch_IS_mode_phasespace ???
  logger << LOG_DEBUG_VERBOSE << "MC_channel_phasespace = " << MC_channel_phasespace << endline_flush;
  if (switch_IS_mode_phasespace == 0){
    random_manager.counter_mode_12 = 0;
    for (int k = 0; k < no_random; k++){
      r[k + 1] = rng.access_random_number();
    }
  }
  else if (switch_IS_mode_phasespace == 1 || switch_IS_mode_phasespace == 2){
    random_manager.counter_mode_12 = 0;
    for (int k = 0; k < no_random; k++){r[k + 1] = random_manager.random_psp[MC_phasespace.channel * no_random + k].get_random();}
  }
  //  For switch_IS_mode_phasespace == 1 || switch_IS_mode_phasespace == 2,
  //  r[1 ... no_random] are not used (random numbers are determied directly).
  //  switch_IS_mode_phasespace == 1 and 2 should be removed completely !!!

  if (csi->swap_parton[0][1] == 2 && csi->swap_parton[0][2] == 1){swap(xbp_all[0][1], xbp_all[0][2]);}

  logger.finished();
}


void phasespace_set::calculate_IS_RA(){
  static Logger logger("phasespace_set::calculate_IS_RA");
  logger.called();

  for (int i_a = 0; i_a < csi->dipole.size(); i_a++){
    if (MC_phasespace.channel < csi->dipole[i_a].sum_channel()){
      RA_x_a = i_a;
      if (i_a == 0){MC_channel_phasespace = MC_phasespace.channel;}
      else {MC_channel_phasespace = MC_phasespace.channel - MC_sum_channel_phasespace[i_a - 1];}
      break;
    }
  }
  /*
  int temp_zero = 0;
  if (RA_x_a > 0){temp_zero = csi->dipole[RA_x_a - 1].sum_channel();}
  logger << LOG_DEBUG_VERBOSE << "MC_phasespace.channel = " << MC_phasespace.channel << "   RA_x_a = " << RA_x_a << "   channel[" << RA_x_a << "] = " << MC_phasespace.channel - temp_zero << endline_flush;
  */
    
  logger.finished();
}


void phasespace_set::output_check_tau_0(){
  static Logger logger("phasespace_set::output_check_tau_0");
  logger.called();
  
  if (x_pdf[0] < tau_0_num[tau_0_num.size() - 1]){
    tau_0_num.push_back(x_pdf[0]);
    logger << LOG_INFO << "tau_0 = " << setw(23) << setprecision(15) << tau_0 << "   min(" << setw(3) << tau_0_num.size() - 1 << "): " << setw(23) << setprecision(15) << tau_0_num[tau_0_num.size() - 1] << endline_flush;
  }

  logger.finished();
}


  // actually obsolete !!! variables are set directly before PDF calculation (where they are exclusively used) !!!
void phasespace_set::set_xz_coll_pdf(){
  static Logger logger("phasespace_set::set_xz_coll_pdf");
  logger.called();

  for (int i_x = 0; i_x < 3; i_x++){xz_pdf[i_x][0] = x_pdf[i_x];}
  for (int i_x = 1; i_x < 3; i_x++){xz_pdf[i_x][1] = x_pdf[i_x] / z_coll[i_x];}
  // xz_pdf: 0 - 0 : tau = x1 * x2
  //         1 - 0 : x1 -> no collinear emission from 1st parton
  //         2 - 0 : x2 -> no collinear emission from 2nd parton
  //         0 - 1 : empty
  //         1 - 1 : x1 / z1 -> collinear emission from 1st parton
  //         2 - 1 : x2 / z2 -> collinear emission from 2nd parton

  logger.finished();
}


void phasespace_set::handling_cut_psp(){
  static Logger logger("phasespace_set::handling_cut_psp");
  logger.called();

  // Overall "if (!end_optimization){" ???

  // Order of calls changed: MC_phasespace was last beforehand !!!

  if (!MC_phasespace.end_optimization){
    MC_phasespace.n_rej++;
    MC_phasespace.n_rej_channel[MC_phasespace.channel]++;
  }
  
  if (!MC_tau.end_optimization){
    MC_tau.n_rej++;
    MC_tau.n_rej_channel[MC_tau.channel]++;
  }

  // count cut events for weight optimization of dipole mappings
  if (RA_x_a != 0) {
    if ((MC_x_dipole[RA_x_a].switch_optimization != -1) && csi->class_contribution_CS_real){
      if (!MC_x_dipole[RA_x_a].end_optimization){
	MC_x_dipole[RA_x_a].n_rej++;
        MC_x_dipole[RA_x_a].n_rej_channel[MC_x_dipole[RA_x_a].channel]++;
      }
    }
  }

  i_rej++;
  // change order between these two ???
  random_manager.increase_cut_counter();

  logger.finished();
}


void phasespace_set::handling_techcut_psp(){
  static Logger logger("phasespace_set::handling_techcut_psp");
  logger.called();

  // Order of calls changed: MC_phasespace was last beforehand !!!

  if (!MC_phasespace.end_optimization){
    MC_phasespace.n_acc++;
    MC_phasespace.n_acc_channel[MC_phasespace.channel]++;
  }

  if (!MC_tau.end_optimization){
    MC_tau.n_acc++;
    MC_tau.n_acc_channel[MC_tau.channel]++;
  }

  // count cut events for weight optimization of dipole mappings
  if (RA_x_a != 0) {
    if ((MC_x_dipole[RA_x_a].switch_optimization != -1) && csi->class_contribution_CS_real){
      if (!MC_x_dipole[RA_x_a].end_optimization){
	MC_x_dipole[RA_x_a].n_acc++;
        MC_x_dipole[RA_x_a].n_acc_channel[MC_x_dipole[RA_x_a].channel]++;
      }
    }
  }

  i_acc++;
  i_acc_step++;
  // change order between these two ???
  random_manager.increase_counter_n_acc();

  logger.finished();
}

