#include "header.hpp"

string double2hexastr(double d){
  static Logger logger("double2hexastr");
  logger.called();
  
  char buffer[25] = { 0 };
  ::snprintf(buffer, 25, "%A", d);

  logger.finished();
  return buffer;
}


double hexastr2double(const string & s){
  static Logger logger("hexastr2double");
  logger.called();
  
  double d = 0.0;
  ::sscanf(s.c_str(), "%lA", &d);

  logger.finished();
  return d;
}


char * stch(string temp_s){
  static Logger logger("stch");
  logger.called();
  
  char * temp_ch = new char[temp_s.size() + 1];
  std::copy(temp_s.begin(), temp_s.end(), temp_ch);
  temp_ch[temp_s.size()] = '\0';

  logger.finished();
  return temp_ch;
}


char stchar(string & temp_s){
  static Logger logger("stchar");
  logger.called();
  
  char p[temp_s.length()]; 
  for (int i = 0; i < sizeof(p); i++){ p[i] = temp_s[i]; }

  logger.finished();
  return *p;
}


vector<int> get_vector_from_array_int(int * temp_array, int size_array){
  static Logger logger("get_vector_from_array_int");
  logger.called();
  
  vector<int> temp_vector(temp_array, temp_array + size_array);

  logger.finished();
  return temp_vector;
}


string time_hms_from_double(double & time){
  static Logger logger("time_hms_from_double");
  logger.called();
  
  stringstream time_ss;
  long long temp_d = (long long)(time / 24 / 3600);
  long long temp_h = (long long)(time / 3600) - temp_d * 24;
  long long temp_min = (long long)(time / 60) - temp_d * 24 * 60 - temp_h * 60;
  long long temp_sec = (long long)(time) - temp_d * 24 * 3600 - temp_h * 3600 - temp_min * 60;
  time_ss << setw(4) << temp_d << " d " << setw(2) << temp_h << " h " << setw(2) << temp_min << " m " << setw(2) << temp_sec << " s";

  logger.finished();
  return time_ss.str();
}


double max_subset_from_binary(vector<double> & xbsqrtsmin_opt, int b){
  static Logger logger("max_subset_from_binary");
  logger.called();
  
  vector<int> temp = vectorbinary_from_binary(b);
  vector<int> xbcomb(0);
  vector<vector<int> > xcomb(0);
  vector<vector<int> > ycomb(0);
  for (int i = 4; i < b / 2; i += 4){
    vector<int> temp_part = vectorbinary_from_binary(i);
    int temp_counter = 0;
    for (int j = 0; j < temp_part.size(); j++){
      for (int k = 0; k < temp.size(); k++){
	if (temp_part[j] == temp[k]){
	  temp_counter++;
	  break;
	}
      }
    }
    if (temp_counter < temp_part.size()){continue;}
    vector<int> temp_part2 = vectorbinary_from_binary(b - i);
    xcomb.push_back(temp_part);
    ycomb.push_back(temp_part2);
    xbcomb.push_back(i);
  }
  for (int i = 0; i < xbcomb.size(); i++){
    double temp = xbsqrtsmin_opt[accumulate(xcomb[i].begin(), xcomb[i].end(), 0)] + xbsqrtsmin_opt[accumulate(ycomb[i].begin(), ycomb[i].end(), 0)];
    if (xbsqrtsmin_opt[b] < temp){xbsqrtsmin_opt[b] = temp;}
  }

  logger.finished();
  return xbsqrtsmin_opt[b];
}


vector<int> vectorint_from_binary(int b){
  static Logger logger("vectorint_from_binary");
  logger.called();
  
  vector<int> temp;
  int counter = 1;
  while (b != 0){
    if ((b % 2) == 1){temp.push_back(counter);}
    counter++;
    b = b / 2;
  }

  logger.finished();
  return temp;
}


vector<int> vectorbinary_from_binary(int b){
  static Logger logger("vectorbinary_from_binary");
  logger.called();
  
  vector<int> temp;
  int counter = 0;
  while (b != 0){
    if ((b % 2) == 1){temp.push_back(intpow(2, counter));}
    counter++;
    b = b / 2;
  }

  logger.finished();
  return temp;
}


