#include "header.hpp"

// belongs to outdated gnuplot output !!!

void fill_gnuplotname(map<int, string> & gnuplotname){
  static Logger logger("fill_gnuplotname");
  logger.called();

  gnuplotname[0] = "&mathrm{g}";
  gnuplotname[22] = "&gamma";
  //  gnuplotname[-22] = "&bar{&gamma}";
  gnuplotname[-24] = "&mathrm{W^+}";
  gnuplotname[24] = "&mathrm{W^-}";
  gnuplotname[23] = "&mathrm{Z}";
  gnuplotname[25] = "&mathrm{H}";
  gnuplotname[1] = "&mathrm{d}";
  gnuplotname[2] = "&mathrm{u}";
  gnuplotname[3] = "&mathrm{s}";
  gnuplotname[4] = "&mathrm{c}";
  gnuplotname[5] = "&mathrm{b}";
  gnuplotname[6] = "&mathrm{t}";
  gnuplotname[11] = "&mathrm{e^-}";
  gnuplotname[12] = "&mathrm{&nu_e}";
  gnuplotname[13] = "&mathrm{&mu^-}";
  gnuplotname[14] = "&mathrm{&nu_&mu}";
  gnuplotname[15] = "&mathrm{&tau^-}";
  gnuplotname[16] = "&mathrm{&nu_&tau}";
  gnuplotname[-1] = "&mathrm{&bar{d}}";
  gnuplotname[-2] = "&mathrm{&bar{u}}";
  gnuplotname[-3] = "&mathrm{&bar{s}}";
  gnuplotname[-4] = "&mathrm{&bar{c}}";
  gnuplotname[-5] = "&mathrm{&bar{b}}";
  gnuplotname[-6] = "&mathrm{&bar{t}}";
  gnuplotname[-11] = "&mathrm{e^+}";
  gnuplotname[-12] = "&mathrm{&bar{&nu}_e}";
  gnuplotname[-13] = "&mathrm{&mu^+}";
  gnuplotname[-14] = "&mathrm{&bar{&nu}_&mu}";
  gnuplotname[-15] = "&mathrm{&tau^+}";
  gnuplotname[-16] = "&mathrm{&bar{&nu}_&tau}";

  logger.finished();
}


// belongs to outdated gnuplot output !!!

void output_gnuplotfile(string & filename, int icount, double reldeviation, int n_events_max){
  static Logger logger("output_gnuplotfile");
  logger.called();

  char LineBuffer[256];
  ifstream in_gnuplot(filename.c_str());
  vector<string> readin;
  while (in_gnuplot.getline(LineBuffer, 256)){
    readin.push_back(LineBuffer);
  }
  in_gnuplot.close();
  ofstream out_makegnuplot;

  out_makegnuplot.open(filename.c_str(), ofstream::out | ofstream::trunc);

  double xvalue = double(icount) / double(n_events_max);
  double yvalue = reldeviation;
  double yvalue_min = yvalue * sqrt(xvalue);
  int log_min = int(log10(yvalue_min)) - 1;
  for (int i = 0; i < readin.size(); i++){
    if (i == 12){
      out_makegnuplot  << "set yrange [" << pow(10.,log_min) << ":" << 5.e03 * pow(10.,log_min) << "]" << endline;
    }
    else{out_makegnuplot << readin[i] << endline;}
  }
  out_makegnuplot.close();

  logger.finished();
}


// only used in summary routines !!!

string output_result_deviation(double av_result, double av_deviation, int digits_deviation){
  static Logger logger("output_result_deviation");
  logger.called();

  double log_result = log10(abs(av_result));//!!!
  double log_deviation = log10(av_deviation);
  int ilog_result = int(log_result);
  if (log_result < 0.){ilog_result--;}
  int ilog_deviation = int(log_deviation);
  if (log_deviation < 0.){ilog_deviation--;}
  int precision = ilog_result - ilog_deviation + digits_deviation;
  double deviation2digits = av_deviation / pow(10.,ilog_deviation + 1 - digits_deviation);
  if (deviation2digits >= pow(10.,digits_deviation) - 0.5){deviation2digits = pow(10.,digits_deviation - 1); precision--;}
  stringstream out;
  out << setw(10) << setprecision(precision) << showpoint << av_result << "(" << setw(digits_deviation) << setprecision(digits_deviation) << noshowpoint << deviation2digits << ")";

  logger.finished();
  return out.str();
}


string output_latex_percent(double av_result, double result, int digits_deviation){
  static Logger logger("output_latex_percent");
  logger.called();

  double deltapercent = (result / av_result - 1.) * 100.;
  double log_dpc = log10(abs(deltapercent));
  int ilog_dpc = int(log_dpc);
  if (log_dpc < 0.){ilog_dpc--;}
  int precision = digits_deviation + ilog_dpc + 1;
  if (result == av_result){precision = digits_deviation;}
  if (precision < 1){precision = 1;}
  stringstream out;
  //  int precision = 3;
  out << setw(11 - 2) << setprecision(precision) << showpoint << showpos << deltapercent << " " << char(92) << "%";

  logger.finished();
  return out.str();
}


// not used at all - possibly useful for some output ???

string output_percent(double av_result, double result, int digits_deviation){
  static Logger logger("output_percent");
  logger.called();

  double deltapercent = (result / av_result - 1.) * 100.;
  double log_dpc = log10(abs(deltapercent));
  int ilog_dpc = int(log_dpc);
  if (log_dpc < 0.){ilog_dpc--;}
  int precision = digits_deviation + ilog_dpc + 1;
  if (result == av_result){precision = digits_deviation;}
  stringstream out;
  //  int precision = 3;
  out << setw(11 - 2) << setprecision(precision) << showpoint << showpos << deltapercent << " %";

  logger.finished();
  return out.str();
}


string output_commadigits(double result, int digits){
  static Logger logger("output_commadigits");
  logger.called();

  double log_dpc = log10(abs(result));
  int ilog_dpc = int(log_dpc);
  if (log_dpc < 0.){ilog_dpc--;}
  int precision = digits + ilog_dpc + 1;
  stringstream out;
  //  int precision = 3;
  out << setprecision(precision) << showpoint << showpos << result;

  logger.finished();
  return out.str();
}


// used in summary output, to produce output with proper tabulation !!!

void write_infile_int(ofstream & out_file, string name, int value_i){
  static Logger logger("write_infile_int");
  logger.called();

  stringstream tab_name;
  if (name.size() < 8){tab_name << char(9) << char(9) << char(9) << char(9) << char(9);}
  else if (name.size() < 16){tab_name << char(9) << char(9) << char(9) << char(9);}
  else if (name.size() < 24){tab_name << char(9) << char(9) << char(9);}
  else if (name.size() < 32){tab_name << char(9) << char(9);}
  else if (name.size() < 40){tab_name << char(9);}
  /*
  if (name.size() < 8){tab_name << char(9) << char(9) << char(9) << char(9);}
  else if (name.size() < 16){tab_name << char(9) << char(9) << char(9);}
  else if (name.size() < 24){tab_name << char(9) << char(9);}
  else if (name.size() < 32){tab_name << char(9);}
  */
  stringstream value_ss;
  value_ss << value_i;
  string value_s = value_ss.str();
  stringstream tab_value;
  if (value_s.size() < 8){tab_value << char(9) << char(9) << char(9) << char(9) << char(9);}
  else if (value_s.size() < 16){tab_value << char(9) << char(9) << char(9) << char(9);}
  else if (value_s.size() < 24){tab_value << char(9) << char(9) << char(9);}
  else if (value_s.size() < 32){tab_value << char(9) << char(9);}
  else if (value_s.size() < 40){tab_value << char(9);}
  /*
  if (value_s.size() < 8){tab_value << char(9) << char(9) << char(9) << char(9);}
  else if (value_s.size() < 16){tab_value << char(9) << char(9) << char(9);}
  else if (value_s.size() < 24){tab_value << char(9) << char(9);}
  else if (value_s.size() < 32){tab_value << char(9);}
  */
  out_file << name << tab_name.str() << "=" << char(9) << value_s << tab_value.str() << "%" << endline;

  logger.finished();
}

 
void write_infile_long_long(ofstream & out_file, string name, long long value_i){
  static Logger logger("write_infile_long_long");
  logger.called();

  stringstream tab_name;
  if (name.size() < 8){tab_name << char(9) << char(9) << char(9) << char(9) << char(9);}
  else if (name.size() < 16){tab_name << char(9) << char(9) << char(9) << char(9);}
  else if (name.size() < 24){tab_name << char(9) << char(9) << char(9);}
  else if (name.size() < 32){tab_name << char(9) << char(9);}
  else if (name.size() < 40){tab_name << char(9);}
  /*
  if (name.size() < 8){tab_name << char(9) << char(9) << char(9) << char(9);}
  else if (name.size() < 16){tab_name << char(9) << char(9) << char(9);}
  else if (name.size() < 24){tab_name << char(9) << char(9);}
  else if (name.size() < 32){tab_name << char(9);}
  */
  stringstream value_ss;
  value_ss << value_i;
  string value_s = value_ss.str();
  stringstream tab_value;
  if (value_s.size() < 8){tab_value << char(9) << char(9) << char(9) << char(9) << char(9);}
  else if (value_s.size() < 16){tab_value << char(9) << char(9) << char(9) << char(9);}
  else if (value_s.size() < 24){tab_value << char(9) << char(9) << char(9);}
  else if (value_s.size() < 32){tab_value << char(9) << char(9);}
  else if (value_s.size() < 40){tab_value << char(9);}
  /*
  if (value_s.size() < 8){tab_value << char(9) << char(9) << char(9) << char(9);}
  else if (value_s.size() < 16){tab_value << char(9) << char(9) << char(9);}
  else if (value_s.size() < 24){tab_value << char(9) << char(9);}
  else if (value_s.size() < 32){tab_value << char(9);}
  */
  out_file << name << tab_name.str() << "=" << char(9) << value_s << tab_value.str() << "%" << endline;

  logger.finished();
}

 
void write_infile_double(ofstream & out_file, string name, double value_d){
  static Logger logger("write_infile_double");
  logger.called();

  stringstream tab_name;
  if (name.size() < 8){tab_name << char(9) << char(9) << char(9) << char(9) << char(9);}
  else if (name.size() < 16){tab_name << char(9) << char(9) << char(9) << char(9);}
  else if (name.size() < 24){tab_name << char(9) << char(9) << char(9);}
  else if (name.size() < 32){tab_name << char(9) << char(9);}
  else if (name.size() < 40){tab_name << char(9);}
  /*
  if (name.size() < 8){tab_name << char(9) << char(9) << char(9) << char(9);}
  else if (name.size() < 16){tab_name << char(9) << char(9) << char(9);}
  else if (name.size() < 24){tab_name << char(9) << char(9);}
  else if (name.size() < 32){tab_name << char(9);}
  */
  stringstream value_ss;
  value_ss << setw(8) << value_d;
  string value_s = value_ss.str();
  stringstream tab_value;
  if (value_s.size() < 8){tab_value << char(9) << char(9) << char(9) << char(9) << char(9);}
  else if (value_s.size() < 16){tab_value << char(9) << char(9) << char(9) << char(9);}
  else if (value_s.size() < 24){tab_value << char(9) << char(9) << char(9);}
  else if (value_s.size() < 32){tab_value << char(9) << char(9);}
  else if (value_s.size() < 40){tab_value << char(9);}
  /*
  if (value_s.size() < 8){tab_value << char(9) << char(9) << char(9) << char(9);}
  else if (value_s.size() < 16){tab_value << char(9) << char(9) << char(9);}
  else if (value_s.size() < 24){tab_value << char(9) << char(9);}
  else if (value_s.size() < 32){tab_value << char(9);}
  */
  out_file << name << tab_name.str() << "=" << char(9) << value_s << tab_value.str() << "%" << endline;

  logger.finished();
}

 
void write_infile_string(ofstream & out_file, string name, string value_s){
  static Logger logger("write_infile_string");
  logger.called();

  stringstream tab_name;
  if (name.size() < 8){tab_name << char(9) << char(9) << char(9) << char(9) << char(9);}
  else if (name.size() < 16){tab_name << char(9) << char(9) << char(9) << char(9);}
  else if (name.size() < 24){tab_name << char(9) << char(9) << char(9);}
  else if (name.size() < 32){tab_name << char(9) << char(9);}
  else if (name.size() < 40){tab_name << char(9);}
  /*
  stringstream tab_value;
  if (value_s.size() < 8){tab_value << char(9) << char(9) << char(9) << char(9) << char(9);}
  else if (value_s.size() < 16){tab_value << char(9) << char(9) << char(9) << char(9);}
  else if (value_s.size() < 24){tab_value << char(9) << char(9) << char(9);}
  else if (value_s.size() < 32){tab_value << char(9) << char(9);}
  else if (value_s.size() < 40){tab_value << char(9);}
  */
  out_file << name << tab_name.str() << "=" << char(9) << value_s << endline;
  // << tab_value.str() << "%"

  logger.finished();
}


void old_write_infile_string(ofstream & out_file, string name, string value_s){
  static Logger logger("old_write_infile_string");
  logger.called();

  stringstream tab_name;
  if (name.size() < 8){tab_name << char(9) << char(9) << char(9) << char(9) << char(9);}
  else if (name.size() < 16){tab_name << char(9) << char(9) << char(9) << char(9);}
  else if (name.size() < 24){tab_name << char(9) << char(9) << char(9);}
  else if (name.size() < 32){tab_name << char(9) << char(9);}
  else if (name.size() < 40){tab_name << char(9);}
  stringstream tab_value;
  if (value_s.size() < 8){tab_value << char(9) << char(9) << char(9) << char(9) << char(9);}
  else if (value_s.size() < 16){tab_value << char(9) << char(9) << char(9) << char(9);}
  else if (value_s.size() < 24){tab_value << char(9) << char(9) << char(9);}
  else if (value_s.size() < 32){tab_value << char(9) << char(9);}
  else if (value_s.size() < 40){tab_value << char(9);}
  out_file << name << tab_name.str() << "=" << char(9) << value_s << tab_value.str() << "%" << endline;

  logger.finished();
}
