#include "header.hpp"

void summary_subprocess::combine_result_hybrid_TSV(){
  static Logger logger("summary_subprocess::combine_result_hybrid_TSV");
  logger.called();

  int n_conservative = ycontribution->average_factor;
  int temp_n_conservative = 0;
  int temp_n_runs = 0;
  vector<int> temp_list_no_run;
  for (int i_z = 0; i_z < n_seed; i_z++){
    if (N_event_run_TSV[i_z] != 0){
      temp_n_runs++;
      temp_list_no_run.push_back(i_z);
    }
  }
  if (temp_n_runs < n_conservative){temp_n_conservative = temp_n_runs;}
  else {temp_n_conservative = n_conservative;}
  if (ycontribution->average_factor == 0){temp_n_conservative = temp_n_runs;}

  vector<vector<vector<vector<vector<vector<double> > > > > > conservative_result_run_TSV(n_seed, result_TSV);
  vector<vector<vector<vector<vector<vector<double> > > > > > conservative_deviation_run_TSV(n_seed, deviation_TSV);
  vector<long long> conservative_N_all(temp_n_conservative, 0);
  vector<long long> conservative_no_results(temp_n_conservative, 0);

  for (int i_z = 0; i_z < temp_list_no_run.size(); i_z++){
    int conservative_i_z = i_z % temp_n_conservative;
    if (!(result_run_TSV[i_z][0][0][0][0][0] == 0. && deviation_run_TSV[i_z][0][0][0][0][0] == 0.)){
      conservative_N_all[conservative_i_z] += N_event_run_TSV[i_z];
      conservative_no_results[conservative_i_z]++;
    }
  }

  //  int x_m = 0;
    for (int i_m = 0; i_m < osi->n_moments; i_m++){
  for (int i_q = 0; i_q < ycontribution->output_n_qTcut; i_q++){
    for (int i_s = 0; i_s < osi->n_extended_set_TSV; i_s++){
      if (!ygeneric->switch_output_scaleset[i_s]){continue;}
	if (i_m > 0 && !osi->switch_moment_TSV[i_s]){continue;}
      for (int i_r = 0; i_r < osi->n_scale_ren_TSV[i_s]; i_r++){
	for (int i_f = 0; i_f < osi->n_scale_fact_TSV[i_s]; i_f++){
	  result_TSV[i_m][i_q][i_s][i_r][i_f] = 0.;
	  deviation_TSV[i_m][i_q][i_s][i_r][i_f] = 0.;

	  for (int i_z = 0; i_z < temp_list_no_run.size(); i_z++){
	    int conservative_i_z = i_z % temp_n_conservative;
	    if (!(result_run_TSV[i_z][i_m][i_q][i_s][i_r][i_f] == 0. && deviation_run_TSV[i_z][i_m][i_q][i_s][i_r][i_f] == 0.)){
	      conservative_result_run_TSV[conservative_i_z][i_m][i_q][i_s][i_r][i_f] += N_event_run_TSV[i_z] * result_run_TSV[i_z][i_m][i_q][i_s][i_r][i_f];
	      conservative_deviation_run_TSV[conservative_i_z][i_m][i_q][i_s][i_r][i_f] += pow((N_event_run_TSV[i_z] - 1) * deviation_run_TSV[i_z][i_m][i_q][i_s][i_r][i_f], 2) + N_event_run_TSV[i_z] * pow(result_run_TSV[i_z][i_m][i_q][i_s][i_r][i_f], 2);
      	    }
	  }
	  for (int conservative_i_z = 0; conservative_i_z < temp_n_conservative; conservative_i_z++){
	    conservative_deviation_run_TSV[conservative_i_z][i_m][i_q][i_s][i_r][i_f] = sqrt((conservative_N_all[conservative_i_z] * conservative_deviation_run_TSV[conservative_i_z][i_m][i_q][i_s][i_r][i_f] - pow(conservative_result_run_TSV[conservative_i_z][i_m][i_q][i_s][i_r][i_f], 2)) / conservative_N_all[conservative_i_z]) / (conservative_N_all[conservative_i_z] - 1);
	    conservative_result_run_TSV[conservative_i_z][i_m][i_q][i_s][i_r][i_f] = conservative_result_run_TSV[conservative_i_z][i_m][i_q][i_s][i_r][i_f] / conservative_N_all[conservative_i_z];
	  }
	  for (int conservative_i_z = 0; conservative_i_z < temp_n_conservative; conservative_i_z++){
	    if (conservative_no_results[conservative_i_z] == 0){
	      conservative_result_run_TSV[conservative_i_z][i_m][i_q][i_s][i_r][i_f] = 0.;
	      conservative_deviation_run_TSV[conservative_i_z][i_m][i_q][i_s][i_r][i_f] = 0.;
	    }
	    logger << LOG_DEBUG_VERBOSE << "TSV[" << setw(2) << right << i_s << "] " << setw(20) << left << name << ":   cons_res_subp_TSV[" << conservative_i_z << "][" << i_m << "][" << setw(2) << right << i_q << "][" << setw(2) << right << i_s << "][" << setw(2) << right << i_r << "][" << setw(2) << right << i_f << "] = " << setw(13) << right << setprecision(6) << conservative_result_run_TSV[conservative_i_z][i_m][i_q][i_s][i_r][i_f] << " +- " << setw(13) << setprecision(6) << conservative_deviation_run_TSV[conservative_i_z][i_m][i_q][i_s][i_r][i_f] << endline_flush;
	  }
	}
      }
    }
  }
  }

  N_event_TSV = 0;
  for (int conservative_i_z = 0; conservative_i_z < temp_n_conservative; conservative_i_z++){
    N_event_TSV += conservative_N_all[conservative_i_z];
  }

  logger << LOG_DEBUG_VERBOSE << "TSV:   N_event_TSV = " << N_event_TSV << endline_flush;
  if (N_event_TSV != 0){
    for (int i_m = 0; i_m < osi->n_moments; i_m++){
    for (int i_q = 0; i_q < ycontribution->output_n_qTcut; i_q++){
      for (int i_s = 0; i_s < osi->n_extended_set_TSV; i_s++){
	if (!ygeneric->switch_output_scaleset[i_s]){continue;}
	if (i_m > 0 && !osi->switch_moment_TSV[i_s]){continue;}
	for (int i_r = 0; i_r < osi->n_scale_ren_TSV[i_s]; i_r++){
	  for (int i_f = 0; i_f < osi->n_scale_fact_TSV[i_s]; i_f++){
	    result_TSV[i_m][i_q][i_s][i_r][i_f] = 0.;
	    deviation_TSV[i_m][i_q][i_s][i_r][i_f] = 0.;
	    for (int i_z = 0; i_z < temp_n_conservative; i_z++){
	      if (N_event_run_TSV[i_z] != 0 && conservative_result_run_TSV[i_z][i_m][i_q][i_s][i_r][i_f] != 0. && conservative_deviation_run_TSV[i_z][i_m][i_q][i_s][i_r][i_f] != 0.){
		double temp_singleweight = 1. / pow(conservative_deviation_run_TSV[i_z][i_m][i_q][i_s][i_r][i_f], 2);
		logger << LOG_DEBUG_VERBOSE << "z_result_TSV[" << i_z << "][" << i_m << "][" << i_q << "][" << i_s << "][" << i_r << "][" << i_f << "] = " << setw(23) << setprecision(15) << conservative_result_run_TSV[i_z][i_m][i_q][i_s][i_r][i_f] << " +- = " << setw(23) << setprecision(15) << conservative_deviation_run_TSV[i_z][i_m][i_q][i_s][i_r][i_f] << endline_flush;
		result_TSV[i_m][i_q][i_s][i_r][i_f] += temp_singleweight * conservative_result_run_TSV[i_z][i_m][i_q][i_s][i_r][i_f];
		deviation_TSV[i_m][i_q][i_s][i_r][i_f] += temp_singleweight;
	      }
	      else if (N_event_run_TSV[i_z] != 0 && conservative_result_run_TSV[i_z][i_m][i_q][i_s][i_r][i_f] == 0. && conservative_deviation_run_TSV[i_z][i_m][i_q][i_s][i_r][i_f] == 0.){
		result_TSV[i_m][i_q][i_s][i_r][i_f] += 0.;
		deviation_TSV[i_m][i_q][i_s][i_r][i_f] += 0.;
		logger << LOG_DEBUG_VERBOSE << "empty: z_result_TSV[" << i_z << "][" << i_m << "][" << i_q << "][" << i_s << "][" << i_r << "][" << i_f << "] = " << setw(23) << setprecision(15) << conservative_result_run_TSV[i_z][i_m][i_q][i_s][i_r][i_f] << " +- = " << setw(23) << setprecision(15) << conservative_deviation_run_TSV[i_z][i_m][i_q][i_s][i_r][i_f] << endline_flush;
	      }
	    }
	    if (N_event_TSV != 0 && result_TSV[i_m][i_q][i_s][i_r][i_f] != 0. && deviation_TSV[i_m][i_q][i_s][i_r][i_f] != 0.){
	      result_TSV[i_m][i_q][i_s][i_r][i_f] = result_TSV[i_m][i_q][i_s][i_r][i_f] / deviation_TSV[i_m][i_q][i_s][i_r][i_f];
	      deviation_TSV[i_m][i_q][i_s][i_r][i_f] = 1. / sqrt(deviation_TSV[i_m][i_q][i_s][i_r][i_f]);
	    }
	    else {
	      result_TSV[i_m][i_q][i_s][i_r][i_f] = 0.;
	      deviation_TSV[i_m][i_q][i_s][i_r][i_f] = 0.;
	    }
	    logger << LOG_DEBUG_VERBOSE << "TSV:   " << setw(20) << left << name << ":   x_result_TSV[" << setw(2) << right << i_m << "][" << setw(2) << right << i_q << "][" << setw(2) << right << i_s << "][" << setw(2) << right << i_r << "][" << setw(2) << right << i_f << "] = " << setw(23) << setprecision(15) << result_TSV[i_m][i_q][i_s][i_r][i_f] << " +- " << setw(23) << setprecision(15) << deviation_TSV[i_m][i_q][i_s][i_r][i_f] << endline_flush;
	  }
	}
      }
    }
    }
  }
  else if (N_event_TSV == 0){
    for (int i_m = 0; i_m < osi->n_moments; i_m++){
    for (int i_q = 0; i_q < ycontribution->output_n_qTcut; i_q++){
      for (int i_s = 0; i_s < osi->n_extended_set_TSV; i_s++){
	if (!ygeneric->switch_output_scaleset[i_s]){continue;}
	if (i_m > 0 && !osi->switch_moment_TSV[i_s]){continue;}
	for (int i_r = 0; i_r < osi->n_scale_ren_TSV[i_s]; i_r++){
	  for (int i_f = 0; i_f < osi->n_scale_fact_TSV[i_s]; i_f++){
	    result_TSV[i_m][i_q][i_s][i_r][i_f] = 0.;
	    deviation_TSV[i_m][i_q][i_s][i_r][i_f] = 0.;
	    logger << LOG_DEBUG_VERBOSE << "TSV: no result   " << setw(20) << left << name << ":   x_result_TSV[" << setw(2) << right << i_m << "][" << setw(2) << right << i_q << "][" << setw(2) << right << i_s << "][" << setw(2) << right << i_r << "][" << setw(2) << right << i_f << "] = " << setw(23) << setprecision(15) << result_TSV[i_m][i_q][i_s][i_r][i_f] << " +- " << setw(23) << setprecision(15) << deviation_TSV[i_m][i_q][i_s][i_r][i_f] << endline_flush;
	  }
	}
      }
    }
  }
  }

  logger.finished();
}



void summary_subprocess::combine_result_alternative_TSV(){
  static Logger logger("summary_subprocess::combine_result_alternative_TSV");
  logger.called();

  //  int x_m = 0;
  N_event_TSV = accumulate(N_event_run_TSV.begin(), N_event_run_TSV.end(), 0);
  logger << LOG_DEBUG_VERBOSE << "TSV:   N_event_TSV = " << N_event_TSV << endline_flush;
  if (N_event_TSV != 0){
    for (int i_m = 0; i_m < osi->n_moments; i_m++){
     for (int i_q = 0; i_q < ycontribution->output_n_qTcut; i_q++){
      for (int i_s = 0; i_s < osi->n_extended_set_TSV; i_s++){
	if (!ygeneric->switch_output_scaleset[i_s]){continue;}
	if (i_m > 0 && !osi->switch_moment_TSV[i_s]){continue;}
	for (int i_r = 0; i_r < osi->n_scale_ren_TSV[i_s]; i_r++){
	  for (int i_f = 0; i_f < osi->n_scale_fact_TSV[i_s]; i_f++){
	    result_TSV[i_m][i_q][i_s][i_r][i_f] = 0.;
	    deviation_TSV[i_m][i_q][i_s][i_r][i_f] = 0.;
	    for (int i_z = 0; i_z < n_seed; i_z++){
	      if (N_event_run_TSV[i_z] != 0 && result_run_TSV[i_z][i_m][i_q][i_s][i_r][i_f] != 0. && deviation_run_TSV[i_z][i_m][i_q][i_s][i_r][i_f] != 0.){
		double temp_singleweight = 1. / pow(deviation_run_TSV[i_z][i_m][i_q][i_s][i_r][i_f], 2);
		logger << LOG_DEBUG_VERBOSE << "z_result_TSV[" << i_z << "][" << i_m << "][" << i_q << "][" << i_s << "][" << i_r << "][" << i_f << "] = " << setw(23) << setprecision(15) << result_run_TSV[i_z][i_m][i_q][i_s][i_r][i_f] << " +- = " << setw(23) << setprecision(15) << deviation_run_TSV[i_z][i_m][i_q][i_s][i_r][i_f] << endline_flush;
		result_TSV[i_m][i_q][i_s][i_r][i_f] += temp_singleweight * result_run_TSV[i_z][i_m][i_q][i_s][i_r][i_f];
		deviation_TSV[i_m][i_q][i_s][i_r][i_f] += temp_singleweight;
	      }
	      else if (N_event_run_TSV[i_z] != 0 && result_run_TSV[i_z][i_m][i_q][i_s][i_r][i_f] == 0. && deviation_run_TSV[i_z][i_m][i_q][i_s][i_r][i_f] == 0.){
		result_TSV[i_m][i_q][i_s][i_r][i_f] += 0.;
		deviation_TSV[i_m][i_q][i_s][i_r][i_f] += 0.;
		logger << LOG_DEBUG_VERBOSE << "empty: z_result_TSV[" << i_z << "][" << i_m << "][" << i_q << "][" << i_s << "][" << i_r << "][" << i_f << "] = " << setw(23) << setprecision(15) << result_run_TSV[i_z][i_m][i_q][i_s][i_r][i_f] << " +- = " << setw(23) << setprecision(15) << deviation_run_TSV[i_z][i_m][i_q][i_s][i_r][i_f] << endline_flush;
	      }
	    }
	    if (N_event_TSV != 0 && result_TSV[i_m][i_q][i_s][i_r][i_f] != 0. && deviation_TSV[i_m][i_q][i_s][i_r][i_f] != 0.){
	      result_TSV[i_m][i_q][i_s][i_r][i_f] = result_TSV[i_m][i_q][i_s][i_r][i_f] / deviation_TSV[i_m][i_q][i_s][i_r][i_f];
	      deviation_TSV[i_m][i_q][i_s][i_r][i_f] = 1. / sqrt(deviation_TSV[i_m][i_q][i_s][i_r][i_f]);
	    }
	    else {
	      result_TSV[i_m][i_q][i_s][i_r][i_f] = 0.;
	      deviation_TSV[i_m][i_q][i_s][i_r][i_f] = 0.;
	    }
	    logger << LOG_DEBUG_VERBOSE << "TSV:   " << setw(20) << left << name << ":   x_result_TSV[" << setw(2) << right << i_m << "][" << setw(2) << right << i_q << "][" << setw(2) << right << i_s << "][" << setw(2) << right << i_r << "][" << setw(2) << right << i_f << "] = " << setw(23) << setprecision(15) << result_TSV[i_m][i_q][i_s][i_r][i_f] << " +- " << setw(23) << setprecision(15) << deviation_TSV[i_m][i_q][i_s][i_r][i_f] << endline_flush;
	  }
	}
      }
    }
    }
  }
  else if (N_event_TSV == 0){
    for (int i_m = 0; i_m < osi->n_moments; i_m++){
    for (int i_q = 0; i_q < ycontribution->output_n_qTcut; i_q++){
      for (int i_s = 0; i_s < osi->n_extended_set_TSV; i_s++){
	if (!ygeneric->switch_output_scaleset[i_s]){continue;}
	if (i_m > 0 && !osi->switch_moment_TSV[i_s]){continue;}
	for (int i_r = 0; i_r < osi->n_scale_ren_TSV[i_s]; i_r++){
	  for (int i_f = 0; i_f < osi->n_scale_fact_TSV[i_s]; i_f++){
	    result_TSV[i_m][i_q][i_s][i_r][i_f] = 0.;
	    deviation_TSV[i_m][i_q][i_s][i_r][i_f] = 0.;
	    logger << LOG_DEBUG_VERBOSE << "TSV: no result   " << setw(20) << left << name << ":   x_result_TSV[" << setw(2) << right << i_m << "][" << setw(2) << right << i_q << "][" << setw(2) << right << i_s << "][" << setw(2) << right << i_r << "][" << setw(2) << right << i_f << "] = " << setw(23) << setprecision(15) << result_TSV[i_m][i_q][i_s][i_r][i_f] << " +- " << setw(23) << setprecision(15) << deviation_TSV[i_m][i_q][i_s][i_r][i_f] << endline_flush;
	  }
	}
      }
    }
  }
  }

  logger.finished();
}


void summary_subprocess::combine_result_alternative_CV(){
  static Logger logger("summary_subprocess::combine_result_alternative_CV");
  logger.called();

  double temp_singleweight;
  //  for (int i_q = 0; i_q < osi->n_qTcut; i_q++){
  for (int i_q = 0; i_q < ycontribution->output_n_qTcut; i_q++){
    for (int i_s = 0; i_s < osi->n_scales_CV; i_s++){
      result_CV[i_q][i_s] = 0.;
      deviation_CV[i_q][i_s] = 0.;
      for (int i_z = 0; i_z < n_seed; i_z++){
	if (N_event_run_CV[i_z] != 0 && deviation_run_CV[i_q][i_s][i_z] != 0. && result_run_CV[i_q][i_s][i_z] != 0.){
	  temp_singleweight = 1. / pow(deviation_run_CV[i_q][i_s][i_z], 2);
	  result_CV[i_q][i_s] += temp_singleweight * result_run_CV[i_q][i_s][i_z];
	  deviation_CV[i_q][i_s] += temp_singleweight;
	}
      }
      if (N_event_CV != 0){
	result_CV[i_q][i_s] = result_CV[i_q][i_s] / deviation_CV[i_q][i_s];
	deviation_CV[i_q][i_s] = 1. / sqrt(deviation_CV[i_q][i_s]);
	if (result_CV[i_q][i_s] != result_CV[i_q][i_s]){
	  logger << LOG_DEBUG_VERBOSE << N_event_CV << endline_flush;
	  for (int i_z = 0; i_z < n_seed; i_z++){logger << LOG_DEBUG_VERBOSE << N_event_run_CV[i_z] << endline_flush;}
	}
      }
      else {
	result_CV[i_q][i_s] = 0.;
	deviation_CV[i_q][i_s] = 0.;
      }

      logger << LOG_DEBUG << "CV[" << setw(2) << right << i_s << "] " << setw(20) << left << name << ":   result_subprocess_CV[" << setw(2) << right << i_q << "][" << setw(2) << right << i_s << "] = " << setw(13) << right << setprecision(6) << result_CV[i_q][i_s] << " +- " << setw(13) << setprecision(6) << deviation_CV[i_q][i_s] << endline_flush;
    }
  }

  if (ycontribution->output_n_qTcut < osi->n_qTcut){
    for (int i_q = ycontribution->output_n_qTcut; i_q < osi->n_qTcut; i_q++){
      for (int i_s = 0; i_s < osi->n_scales_CV; i_s++){
	result_CV[i_q][i_s] = result_CV[0][i_s];
      }
    }
  }

 logger.finished();
}



void summary_subprocess::combine_result_hybrid_CV(){
  static Logger logger("summary_subprocess::combine_result_hybrid_CV");
  logger.called();

  int n_conservative = ycontribution->average_factor;
  int temp_n_conservative = 0;

  int temp_n_runs = 0;
  vector<int> temp_list_no_run;
  for (int i_z = 0; i_z < n_seed; i_z++){
    if (N_event_run_CV[i_z] != 0){
      temp_n_runs++;
      temp_list_no_run.push_back(i_z);
    }
  }

  if (temp_n_runs < n_conservative){
    temp_n_conservative = temp_n_runs;
  }
  else {
    temp_n_conservative = n_conservative;
  }
  vector<vector<vector<double> > > conservative_result_run_CV(ycontribution->output_n_qTcut, vector<vector<double> > (osi->n_scales_CV, vector<double> (temp_n_conservative, 0.)));
  vector<vector<vector<double> > > conservative_deviation_run_CV(ycontribution->output_n_qTcut, vector<vector<double> > (osi->n_scales_CV, vector<double> (temp_n_conservative, 0.)));
  vector<vector<vector<double> > > conservative_chi2_CV(ycontribution->output_n_qTcut, vector<vector<double> > (osi->n_scales_CV, vector<double> (temp_n_conservative, 0.)));
  vector<long long> conservative_N_all(temp_n_conservative, 0);
  vector<long long> conservative_no_results(temp_n_conservative, 0);

  for (int i_z = 0; i_z < temp_list_no_run.size(); i_z++){
    int conservative_i_z = i_z % temp_n_conservative;
    if (!(result_run_CV[0][0][i_z] == 0. && deviation_run_CV[0][0][i_z] == 0.)){
      conservative_N_all[conservative_i_z] += N_event_run_CV[i_z];
      conservative_no_results[conservative_i_z]++;
    }
  }

  for (int i_q = 0; i_q < ycontribution->output_n_qTcut; i_q++){
    for (int i_s = 0; i_s < osi->n_scales_CV; i_s++){
      result_CV[i_q][i_s] = 0.;
      deviation_CV[i_q][i_s] = 0.;
      for (int i_z = 0; i_z < temp_list_no_run.size(); i_z++){
	int conservative_i_z = i_z % temp_n_conservative;
	if (!(result_run_CV[i_q][i_s][i_z] == 0. && deviation_run_CV[i_q][i_s][i_z] == 0.)){
	  conservative_result_run_CV[i_q][i_s][conservative_i_z] += N_event_run_CV[i_z] * result_run_CV[i_q][i_s][i_z];
	  conservative_deviation_run_CV[i_q][i_s][conservative_i_z] += pow((N_event_run_CV[i_z] - 1) * deviation_run_CV[i_q][i_s][i_z], 2) + N_event_run_CV[i_z] * pow(result_run_CV[i_q][i_s][i_z], 2);
	}
      }

      for (int conservative_i_z = 0; conservative_i_z < temp_n_conservative; conservative_i_z++){
	conservative_deviation_run_CV[i_q][i_s][conservative_i_z] = sqrt((conservative_N_all[conservative_i_z] * conservative_deviation_run_CV[i_q][i_s][conservative_i_z] - pow(conservative_result_run_CV[i_q][i_s][conservative_i_z], 2)) / conservative_N_all[conservative_i_z]) / (conservative_N_all[conservative_i_z] - 1);
	conservative_result_run_CV[i_q][i_s][conservative_i_z] = conservative_result_run_CV[i_q][i_s][conservative_i_z] / conservative_N_all[conservative_i_z];
	conservative_chi2_CV[i_q][i_s][conservative_i_z] = 0.;
      }

      for (int i_z = 0; i_z < temp_list_no_run.size(); i_z++){
	int conservative_i_z = i_z % temp_n_conservative;
	if (!(result_run_CV[i_q][i_s][i_z] == 0. && deviation_run_CV[i_q][i_s][i_z] == 0.)){
	  conservative_chi2_CV[i_q][i_s][conservative_i_z] += pow((result_run_CV[i_q][i_s][i_z] - conservative_result_run_CV[i_q][i_s][conservative_i_z]) / deviation_run_CV[i_q][i_s][i_z], 2.);
	}
      }

      for (int conservative_i_z = 0; conservative_i_z < temp_n_conservative; conservative_i_z++){
	conservative_chi2_CV[i_q][i_s][conservative_i_z] = conservative_chi2_CV[i_q][i_s][conservative_i_z] / conservative_no_results[conservative_i_z];
	if (conservative_no_results[conservative_i_z] == 0){
	  conservative_result_run_CV[i_q][i_s][conservative_i_z] = 0.;
	  conservative_deviation_run_CV[i_q][i_s][conservative_i_z] = 0.;
	  conservative_chi2_CV[i_q][i_s][conservative_i_z] = 0.;
	}
	logger << LOG_DEBUG << "CV[" << setw(2) << right << i_s << "] " << setw(20) << left << name << ":   cons_res_subp_CV[" << setw(2) << right << i_q << "][" << setw(2) << right << i_s << "][" << conservative_i_z << "] = " << setw(13) << right << setprecision(6) << conservative_result_run_CV[i_q][i_s][conservative_i_z] << " +- " << setw(13) << setprecision(6) << conservative_deviation_run_CV[i_q][i_s][conservative_i_z] << "   chi2 = " << setw(6) << setprecision(4) << conservative_chi2_CV[i_q][i_s][conservative_i_z] << endline_flush;

      }
    }
  }





  N_event_CV = 0;
  for (int conservative_i_z = 0; conservative_i_z < temp_n_conservative; conservative_i_z++){
    N_event_CV += conservative_N_all[conservative_i_z];
  }

  double temp_singleweight = 0.;
  for (int i_q = 0; i_q < ycontribution->output_n_qTcut; i_q++){
    for (int i_s = 0; i_s < osi->n_scales_CV; i_s++){
      result_CV[i_q][i_s] = 0.;
      deviation_CV[i_q][i_s] = 0.;
      for (int i_z = 0; i_z < temp_n_conservative; i_z++){
	if (conservative_N_all[i_z] != 0 && conservative_deviation_run_CV[i_q][i_s][i_z] != 0. && conservative_result_run_CV[i_q][i_s][i_z] != 0.){
	  temp_singleweight = 1. / pow(conservative_deviation_run_CV[i_q][i_s][i_z], 2);
	  result_CV[i_q][i_s] += temp_singleweight * conservative_result_run_CV[i_q][i_s][i_z];
	  deviation_CV[i_q][i_s] += temp_singleweight;
	}
      }
      if (N_event_CV != 0){
	result_CV[i_q][i_s] = result_CV[i_q][i_s] / deviation_CV[i_q][i_s];
	deviation_CV[i_q][i_s] = 1. / sqrt(deviation_CV[i_q][i_s]);
	if (result_CV[i_q][i_s] != result_CV[i_q][i_s]){
	  logger << LOG_DEBUG_VERBOSE << N_event_CV << endline_flush;
	  for (int i_z = 0; i_z < temp_n_conservative; i_z++){logger << LOG_DEBUG_VERBOSE << conservative_N_all[i_z] << endline_flush;}
	}
      }
      else {
	result_CV[i_q][i_s] = 0.;
	deviation_CV[i_q][i_s] = 0.;
      }
    }
  }

  if (ycontribution->output_n_qTcut < osi->n_qTcut){
    for (int i_q = ycontribution->output_n_qTcut; i_q < osi->n_qTcut; i_q++){
      for (int i_s = 0; i_s < osi->n_scales_CV; i_s++){
	result_CV[i_q][i_s] = result_CV[0][i_s];
      }
    }
  }

  logger.finished();
}


