#include "header.hpp"

summary_contribution::summary_contribution(){
  static Logger logger("summary_contribution::summary_contribution ()");
  logger.called();

  if (Log::getLogThreshold() <= LOG_DEBUG_VERBOSE){ logger << LOG_DEBUG_VERBOSE << "constructor called..." << endline_flush; }

  logger.finished();
}

summary_contribution::summary_contribution(string _type_contribution, summary_list * _list){
  static Logger logger("summary_contribution::summary_contribution (type_contribution, list)");
  logger.called();

  if (Log::getLogThreshold() <= LOG_DEBUG_VERBOSE){ logger << LOG_DEBUG_VERBOSE << "constructor called..." << endline_flush; }

  initialization(_type_contribution, _list);

  logger.finished();
}

summary_contribution::~summary_contribution(){
  static Logger logger("summary_contribution::~summary_contribution");
  logger.called();

  if (Log::getLogThreshold() <= LOG_DEBUG_VERBOSE){ logger << LOG_DEBUG_VERBOSE << "destructor called..." << endline_flush; }

  logger.finished();
}


void summary_contribution::initialization(string _type_contribution, summary_list * _list){
  static Logger logger("summary_contribution::initialization");
  logger.called();

  ylist = _list;
  ygeneric = ylist->ygeneric;
  osi = ygeneric->osi;

  logger << LOG_DEBUG << "ylist->resultdirectory = " << ylist->resultdirectory << endline_flush;

  type_contribution = _type_contribution;

  // ???
  subprocess.resize(1);
  xsubprocess.resize(1);
  subgroup_no_member.resize(1);
  //

  in_contribution_order_alpha_s = 0;
  in_contribution_order_alpha_e = 0;
  interference = 0;
  photon_induced = 0;

  combination = "";
  
  logger.finished();
}


void summary_contribution::readin_contribution_remove_run(){
  static Logger logger("summary_contribution::readin_contribution_remove_run");
  logger.called();

  int n_seed = directory.size();
  int default_size_CV = 1 + 2;
  if (active_qTcut){default_size_CV += 2 * osi->n_qTcut * osi->n_scales_CV;}
  else {default_size_CV += 2 * osi->n_scales_CV;}

  xsubprocess.resize(subprocess.size());
  for (int i_p = 0; i_p < xsubprocess.size(); i_p++){xsubprocess[i_p]->initialization(subprocess[i_p], n_seed, default_size_CV, this);}

  logger.finished();
}


