#include "header.hpp"

void summary_contribution::output_distribution_TSV(){
  static Logger logger("summary_contribution::output_distribution_TSV");
  logger.called();

  int plot_mode = 0;
  string name_result = infix_order_contribution;

  vector<string> identifier_sdd(2);
  identifier_sdd[0] = "norm";
  identifier_sdd[1] = "plot";

  string subdirectory = "/" + ylist->resultdirectory + "/" + infix_contribution;
  
  if (Log::getLogThreshold() <= LOG_DEBUG){ logger << LOG_DEBUG << "subdirectory = " << subdirectory << "   resultdirectory = " << resultdirectory << "   selection_n_qTcut = " << selection_n_qTcut << endline_flush; }
  for (int i_i = 0; i_i < identifier_sdd.size(); i_i++){
    if (Log::getLogThreshold() <= LOG_DEBUG){ logger << LOG_DEBUG << "ygeneric->output_distribution_initialization_file_reduction_TSV(name_result = " << name_result << "   subdirectory = " << subdirectory << "   identifier_sdd[" << i_i << "] = " << identifier_sdd[i_i] << "   selection_n_qTcut = " << selection_n_qTcut << ");" << endline_flush; }
    if (!active_qTcut || selection_n_qTcut == 1){
      if (ygeneric->switch_output_plot_reduction == 1){ ygeneric->output_distribution_initialization_file_reduction_TSV(name_result, subdirectory, identifier_sdd[i_i], selection_n_qTcut); }
    }
     
    if (active_qTcut){
      // inverted output for bin-wise rcut dependence
      for (int i_g = 0; i_g < ygeneric->subgroup.size(); i_g++){
	for (int i_d = 0; i_d < ygeneric->osi->extended_distribution.size(); i_d++){
	  if (!ygeneric->switch_output_distribution[i_d]){continue;}
	  vector<vector<vector<vector<vector<double> > > > > rcut_distribution_result_qTcut_TSV(selection_n_qTcut);
	  vector<vector<vector<vector<vector<double> > > > > rcut_distribution_deviation_qTcut_TSV(selection_n_qTcut);
	  for (int x_q = 0; x_q < selection_n_qTcut; x_q++){
	    rcut_distribution_result_qTcut_TSV[x_q] = distribution_result_qTcut_TSV[x_q][i_g][i_d];
	    rcut_distribution_deviation_qTcut_TSV[x_q] = distribution_deviation_qTcut_TSV[x_q][i_g][i_d];
	  }
	  if (i_d < ygeneric->osi->dat.size()){
	    ygeneric->output_rcut_sddistribution_TSV(identifier_sdd[i_i], rcut_distribution_result_qTcut_TSV, rcut_distribution_deviation_qTcut_TSV, i_d, name_result, subdirectory, plot_mode);
	  }
	  else {
	    ygeneric->output_rcut_dddistribution_TSV(identifier_sdd[i_i], rcut_distribution_result_qTcut_TSV, rcut_distribution_deviation_qTcut_TSV, i_d, name_result, subdirectory, plot_mode);
	  }
	}
      }
    }

    if (!active_qTcut){
      // single-differential distributions
      for (int i_g = 0; i_g < ygeneric->subgroup.size(); i_g++){
	for (int i_d = 0; i_d < ygeneric->osi->dat.size(); i_d++){
	  //    for (int i_d = 0; i_d < ygeneric->osi->extended_distribution.size(); i_d++){
	  if (!ygeneric->switch_output_distribution[i_d]){continue;}
	  ygeneric->output_distribution_TSV(identifier_sdd[i_i], distribution_result_qTcut_TSV[0][i_g][i_d], distribution_deviation_qTcut_TSV[0][i_g][i_d], i_d, name_result, subdirectory, plot_mode);
	  ygeneric->output_sddistribution_TSV(identifier_sdd[i_i], distribution_result_qTcut_TSV[0][i_g][i_d], distribution_deviation_qTcut_TSV[0][i_g][i_d], i_d, name_result, subdirectory, plot_mode);
	}
      }
      // double-differential distributions
      for (int i_g = 0; i_g < ygeneric->subgroup.size(); i_g++){
	for (int i_d = ygeneric->osi->dat.size(); i_d < ygeneric->osi->extended_distribution.size(); i_d++){
	  if (!ygeneric->switch_output_distribution[i_d]){continue;}
	  ygeneric->output_dddistribution_TSV(identifier_sdd[i_i], distribution_result_qTcut_TSV[0][i_g][i_d], distribution_deviation_qTcut_TSV[0][i_g][i_d], i_d, name_result, subdirectory, plot_mode);
	  ygeneric->output_dddistribution_reconstruct_first_sdd_TSV(identifier_sdd[i_i], distribution_result_qTcut_TSV[0][i_g][i_d], distribution_deviation_qTcut_TSV[0][i_g][i_d], i_d, name_result, subdirectory, plot_mode);
	  ygeneric->output_dddistribution_reconstruct_second_sdd_TSV(identifier_sdd[i_i], distribution_result_qTcut_TSV[0][i_g][i_d], distribution_deviation_qTcut_TSV[0][i_g][i_d], i_d, name_result, subdirectory, plot_mode);
	  ygeneric->output_dddistribution_slice_in_first_sdd_TSV(identifier_sdd[i_i], distribution_result_qTcut_TSV[0][i_g][i_d], distribution_deviation_qTcut_TSV[0][i_g][i_d], i_d, name_result, subdirectory, plot_mode);
	  ygeneric->output_dddistribution_slice_in_second_sdd_TSV(identifier_sdd[i_i], distribution_result_qTcut_TSV[0][i_g][i_d], distribution_deviation_qTcut_TSV[0][i_g][i_d], i_d, name_result, subdirectory, plot_mode);
	  ygeneric->output_dddistribution_ge_in_first_sdd_TSV(identifier_sdd[i_i], distribution_result_qTcut_TSV[0][i_g][i_d], distribution_deviation_qTcut_TSV[0][i_g][i_d], i_d, name_result, subdirectory, plot_mode);
	  ygeneric->output_dddistribution_ge_in_second_sdd_TSV(identifier_sdd[i_i], distribution_result_qTcut_TSV[0][i_g][i_d], distribution_deviation_qTcut_TSV[0][i_g][i_d], i_d, name_result, subdirectory, plot_mode);
	  ygeneric->output_dddistribution_lt_in_first_sdd_TSV(identifier_sdd[i_i], distribution_result_qTcut_TSV[0][i_g][i_d], distribution_deviation_qTcut_TSV[0][i_g][i_d], i_d, name_result, subdirectory, plot_mode);
	  ygeneric->output_dddistribution_lt_in_second_sdd_TSV(identifier_sdd[i_i], distribution_result_qTcut_TSV[0][i_g][i_d], distribution_deviation_qTcut_TSV[0][i_g][i_d], i_d, name_result, subdirectory, plot_mode);
	}
      }
    }
  }
  
  logger.finished();
}


void summary_contribution::output_distribution_qTcut_TSV(){
  static Logger logger("summary_contribution::output_distribution_qTcut_TSV");
  logger.called();

  if (!active_qTcut || selection_n_qTcut == 1){return;}

  int local_n_qTcut = 1;
  if (active_qTcut){local_n_qTcut = selection_n_qTcut;}

  int plot_mode = 0;
  string name_result = infix_order_contribution;

  vector<string> identifier_sdd(2);
  identifier_sdd[0] = "norm";
  identifier_sdd[1] = "plot";

  string subdirectory = "/" + ylist->resultdirectory + "/" + infix_contribution;
  vector<string> subdirectory_qTcut(selection_n_qTcut, "");
  for (int x_q = 0; x_q < local_n_qTcut; x_q++){
    if (active_qTcut){
      stringstream qTcut_ss;
      qTcut_ss << "qTcut-" << ygeneric->osi->value_qTcut_distribution[x_q];
      subdirectory_qTcut[x_q] = "/" + ylist->resultdirectory + "/" + infix_contribution + "/" + qTcut_ss.str();
    }
    else {subdirectory_qTcut[x_q] = "/" + ylist->resultdirectory + "/" + infix_contribution;}
  }

  for (int x_q = 0; x_q < local_n_qTcut; x_q++){
    for (int i_s = 0; i_s < osi->n_extended_set_TSV; i_s++){
      if (!ygeneric->switch_output_scaleset[i_s]){continue;}
      if (!ygeneric->osi->switch_distribution_TSV[i_s]){continue;}
      for (int i_r = 0; i_r < ygeneric->osi->n_scale_ren_TSV[i_s]; i_r++){
	for (int i_f = 0; i_f < ygeneric->osi->n_scale_fact_TSV[i_s]; i_f++){
	  string directory_distribution_plot = ygeneric->scalepath_TSV[i_s][i_r][i_f] + "/" + subdirectory_qTcut[x_q];
	  if (Log::getLogThreshold() <= LOG_DEBUG){ logger << LOG_DEBUG << "mkdir " << directory_distribution_plot << endline_flush; }
	  system_execute(logger, "mkdir " + directory_distribution_plot);
	}
      }
    }

    for (int i_i = 0; i_i < identifier_sdd.size(); i_i++){
      if (ygeneric->switch_output_plot_reduction == 1){
	//	for (int x_q = 0; x_q < selection_n_qTcut; x_q++){
	ygeneric->output_distribution_initialization_file_reduction_qTcut_TSV(name_result, subdirectory_qTcut[x_q], identifier_sdd[i_i], selection_n_qTcut);
	//	}
      }
      // single-differential distributions
      for (int i_g = 0; i_g < ygeneric->subgroup.size(); i_g++){
	for (int i_d = 0; i_d < ygeneric->osi->dat.size(); i_d++){
	  if (!ygeneric->switch_output_distribution[i_d]){continue;}
	  ygeneric->output_distribution_TSV(identifier_sdd[i_i], distribution_result_qTcut_TSV[x_q][i_g][i_d], distribution_deviation_qTcut_TSV[x_q][i_g][i_d], i_d, name_result, subdirectory_qTcut[x_q], plot_mode);
	  ygeneric->output_sddistribution_TSV(identifier_sdd[i_i], distribution_result_qTcut_TSV[x_q][i_g][i_d], distribution_deviation_qTcut_TSV[x_q][i_g][i_d], i_d, name_result, subdirectory_qTcut[x_q], plot_mode);
	}
      }
      // double-differential distributions
      for (int i_g = 0; i_g < ygeneric->subgroup.size(); i_g++){
	for (int i_d = ygeneric->osi->dat.size(); i_d < ygeneric->osi->extended_distribution.size(); i_d++){
	  if (!ygeneric->switch_output_distribution[i_d]){continue;}
	  ygeneric->output_dddistribution_TSV(identifier_sdd[i_i], distribution_result_qTcut_TSV[x_q][i_g][i_d], distribution_deviation_qTcut_TSV[x_q][i_g][i_d], i_d, name_result, subdirectory_qTcut[x_q], plot_mode);
	  ygeneric->output_dddistribution_reconstruct_first_sdd_TSV(identifier_sdd[i_i], distribution_result_qTcut_TSV[x_q][i_g][i_d], distribution_deviation_qTcut_TSV[x_q][i_g][i_d], i_d, name_result, subdirectory_qTcut[x_q], plot_mode);
	  ygeneric->output_dddistribution_reconstruct_second_sdd_TSV(identifier_sdd[i_i], distribution_result_qTcut_TSV[x_q][i_g][i_d], distribution_deviation_qTcut_TSV[x_q][i_g][i_d], i_d, name_result, subdirectory_qTcut[x_q], plot_mode);
	  ygeneric->output_dddistribution_slice_in_first_sdd_TSV(identifier_sdd[i_i], distribution_result_qTcut_TSV[x_q][i_g][i_d], distribution_deviation_qTcut_TSV[x_q][i_g][i_d], i_d, name_result, subdirectory_qTcut[x_q], plot_mode);
	  ygeneric->output_dddistribution_slice_in_second_sdd_TSV(identifier_sdd[i_i], distribution_result_qTcut_TSV[x_q][i_g][i_d], distribution_deviation_qTcut_TSV[x_q][i_g][i_d], i_d, name_result, subdirectory_qTcut[x_q], plot_mode);
	  ygeneric->output_dddistribution_ge_in_first_sdd_TSV(identifier_sdd[i_i], distribution_result_qTcut_TSV[x_q][i_g][i_d], distribution_deviation_qTcut_TSV[x_q][i_g][i_d], i_d, name_result, subdirectory_qTcut[x_q], plot_mode);
	  ygeneric->output_dddistribution_ge_in_second_sdd_TSV(identifier_sdd[i_i], distribution_result_qTcut_TSV[x_q][i_g][i_d], distribution_deviation_qTcut_TSV[x_q][i_g][i_d], i_d, name_result, subdirectory_qTcut[x_q], plot_mode);
	  ygeneric->output_dddistribution_lt_in_first_sdd_TSV(identifier_sdd[i_i], distribution_result_qTcut_TSV[x_q][i_g][i_d], distribution_deviation_qTcut_TSV[x_q][i_g][i_d], i_d, name_result, subdirectory_qTcut[x_q], plot_mode);
	  ygeneric->output_dddistribution_lt_in_second_sdd_TSV(identifier_sdd[i_i], distribution_result_qTcut_TSV[x_q][i_g][i_d], distribution_deviation_qTcut_TSV[x_q][i_g][i_d], i_d, name_result, subdirectory_qTcut[x_q], plot_mode);
	}
      }
    }
  }

  logger.finished();
}


void summary_contribution::output_distribution_overview_TSV(){
  static Logger logger("summary_contribution::output_distribution_overview_TSV");
  logger.called();

  ofstream out_overviewfile;
  string filename_distribution_overview;
  string filepath_distribution_overview;

  stringstream header_ss;
  header_ss << left << setw(16) << "qTcut";
  header_ss << left << setw(25) << "contribution/subprocess";
  header_ss << right << setw(16) << "dsigma";
  header_ss << setw(4) << " +- ";
  header_ss << right << setw(16) << "error";
  header_ss << setw(3) << "";
  header_ss << right << setw(10) << "chi2_dof";
  header_ss << setw(3) << "";
  header_ss << right << setw(5) << "n_run";
  header_ss << setw(1) << "";
  header_ss << right << setw(7) << "[total]";
  header_ss << setw(3) << "";
  header_ss << setw(9) << "(removed)";
  header_ss << setw(3) << "";
  header_ss << setw(12) << right << "events / bin";

  stringstream temp_ss_separation_one;
  stringstream temp_ss_separation_two;
  int counter_separation = 20 + 5 + 16 + 25 + 16 + 4 + 16 + 3 + 10 + 3 + 5 + 1 + 7 + 3 + 9 + 3 + 12;
  for (int i_x = 0; i_x < counter_separation; i_x++){
    temp_ss_separation_one << "-";
    temp_ss_separation_two << "=";
  }

  for (int i_s = 0; i_s < osi->n_extended_set_TSV; i_s++){
    if (!ygeneric->switch_output_scaleset[i_s]){continue;}
    if (!osi->switch_distribution_TSV[i_s]){continue;}
    if (i_s != osi->no_reference_TSV){ continue;}
    /*
      if (ygeneric->switch_output_overview_reduction == 2){
      filename_distribution_overview = "overview." + resultdirectory + ".dat";
      // directory does not exist yet !!!
      filepath_distribution_overview = ygeneric->final_resultdirectory + "/" + osi->name_extended_set_TSV[i_s] + "/" + resultdirectory + "/" + filename_distribution_overview;
      out_overviewfile.open(filepath_distribution_overview.c_str(), ofstream::out | ofstream::trunc);
      }
    */
    for (int i_r = 0; i_r < osi->n_scale_ren_TSV[i_s]; i_r++){
      for (int i_f = 0; i_f < osi->n_scale_fact_TSV[i_s]; i_f++){
	if (i_r != osi->no_scale_ren_reference_TSV || i_f != osi->no_scale_fact_reference_TSV){ continue; }

	if (ygeneric->switch_output_overview_reduction == 1){
	  filename_distribution_overview = "overview.." + infix_order_contribution + ".dat";
	  filepath_distribution_overview = ygeneric->scalepath_TSV[i_s][i_r][i_f] + "/" + ylist->resultdirectory + "/" + infix_contribution + "/" + filename_distribution_overview;
	  out_overviewfile.open(filepath_distribution_overview.c_str(), ofstream::out | ofstream::trunc);
	}

	for (int i_g = 0; i_g < ygeneric->subgroup.size(); i_g++){
	  for (int i_d = 0; i_d < osi->dat.size(); i_d++){
	    if (!ygeneric->switch_output_distribution[i_d]){continue;}
	    
	    if (ygeneric->switch_output_overview_reduction){
	      out_overviewfile << "## " << ygeneric->scalename_TSV[i_s][i_r][i_f] << "/" << ylist->resultdirectory + "/" + infix_contribution + "/" << "overview." + osi->extended_distribution[i_d].xdistribution_name + ".." + infix_order_contribution + ".dat" << endline;
	      out_overviewfile << endline;
	    }
	    else {
	      filename_distribution_overview = "overview." + osi->extended_distribution[i_d].xdistribution_name + ".." + infix_order_contribution + ".dat";
	      filepath_distribution_overview = ygeneric->scalepath_TSV[i_s][i_r][i_f] + "/" + ylist->resultdirectory + "/" + infix_contribution + "/" + filename_distribution_overview;
	      logger << LOG_DEBUG << "filename_distribution_overview = " << filename_distribution_overview << endline_flush;
	      logger << LOG_DEBUG << "filepath_distribution_overview = " << filepath_distribution_overview << endline_flush;
	      out_overviewfile.open(filepath_distribution_overview.c_str(), ofstream::out | ofstream::trunc);
	    }

	    // first list all subprocesses that do not contribute
	    bool non_contribution_run = false;
	    vector<int> counter_run(xsubprocess.size());
	    for (int i_p = 1; i_p < xsubprocess.size(); i_p++){
	      counter_run[i_p] = 0;
	      for (int i_m = 0; i_m < extended_directory.size(); i_m++){
		counter_run[i_p] += xsubprocess[i_p]->distribution_group_counter_run_TSV[i_m];
	      }
	      if (counter_run[i_p] == 0){non_contribution_run = true;}
	    }
	    if (non_contribution_run){
	      out_overviewfile << right << setw(38) << "non-contributing subprocesses";
	      out_overviewfile << setw(3) << "";
	      out_overviewfile << left << setw(25) << infix_order_contribution;
	      
	      if (ylist->channel_selection != "" && ylist->channel_selection != "---"){ out_overviewfile << left << setw(10) << ylist->channel_selection; }
	      out_overviewfile << endline;
	      out_overviewfile << temp_ss_separation_one.str() << endline;
	      for (int i_p = 1; i_p < xsubprocess.size(); i_p++){
		if (counter_run[i_p] == 0){out_overviewfile << setw(41) << "" << left << setw(25) << xsubprocess[i_p]->name << endline;}
	      }
	      out_overviewfile << temp_ss_separation_two.str() << endline;
	      out_overviewfile << endline;
	    }
	    
	    stringstream bin_label;
	    bin_label << "bin (" << osi->extended_distribution[i_d].xdistribution_name << ")";
	    out_overviewfile << right << setw(22) << bin_label.str() << setw(3) << "" << header_ss.str() << endline;
	    out_overviewfile << endline;

	    for (int i_b = 0; i_b < osi->extended_distribution[i_d].n_bins; i_b++){
	      int counter_empty_bin = 0;
	      for (int x_q = 0; x_q < selection_n_qTcut; x_q++){
		// check if bin is empty (to reduce output)
		if (xsubprocess[0]->distribution_result_TSV[i_d][i_b][x_q][i_s][i_r][i_f] == 0.){counter_empty_bin++; continue;}

		int temp_size_result = int(log10(abs(osi->unit_factor_distribution * xsubprocess[0]->distribution_result_TSV[i_d][i_b][x_q][i_s][i_r][i_f])));
		for (int i_p = 0; i_p < subprocess.size(); i_p++){
		  int temp_size_result_c = int(log10(abs(osi->unit_factor_distribution * xsubprocess[i_p]->distribution_result_TSV[i_d][i_b][x_q][i_s][i_r][i_f])));
		  if (temp_size_result_c > temp_size_result){temp_size_result = temp_size_result_c;}
		}
		int temp_size_deviation = int(log10(abs(osi->unit_factor_distribution * xsubprocess[0]->distribution_deviation_TSV[i_d][i_b][x_q][i_s][i_r][i_f])));
		if (osi->unit_factor_distribution * xsubprocess[0]->distribution_deviation_TSV[i_d][i_b][x_q][i_s][i_r][i_f] >= 1.){temp_size_deviation++;}

		for (int i_p = 0; i_p < xsubprocess.size(); i_p++){
		  if (i_p > 0 && counter_run[i_p] == 0){continue;}
		  int temp_size_result_subprocess = int(log10(abs(osi->unit_factor_distribution * xsubprocess[i_p]->distribution_result_TSV[i_d][i_b][x_q][i_s][i_r][i_f])));
		  int temp_size_deviation_subprocess = int(log10(abs(osi->unit_factor_distribution * xsubprocess[i_p]->distribution_deviation_TSV[i_d][i_b][x_q][i_s][i_r][i_f])));
		  if (osi->unit_factor_distribution * xsubprocess[i_p]->distribution_deviation_TSV[i_d][i_b][x_q][i_s][i_r][i_f] >= 1.){temp_size_deviation_subprocess++;}
		  if (xsubprocess[i_p]->distribution_result_TSV[i_d][i_b][x_q][i_s][i_r][i_f] == 0){temp_size_result_subprocess = 0;}
		  if (xsubprocess[i_p]->distribution_deviation_TSV[i_d][i_b][x_q][i_s][i_r][i_f] == 0){temp_size_deviation_subprocess = 0;}
		  int setw_result = 9 + temp_size_result_subprocess - temp_size_result;
		  int setw_deviation = 9 + temp_size_deviation_subprocess - temp_size_deviation - (temp_size_result - temp_size_deviation + 1);
		  if (xsubprocess[i_p]->distribution_result_TSV[i_d][i_b][x_q][i_s][i_r][i_f] == 0.){setw_result = 1; setw_deviation = 1;}
		  else if (abs(osi->unit_factor_distribution * xsubprocess[i_p]->distribution_result_TSV[i_d][i_b][x_q][i_s][i_r][i_f]) < 1.){setw_result--;}


		  if (extended_directory.size() > 1 || i_p == 0){
		    out_overviewfile << right << setw(10) << setprecision(8) << noshowpoint << osi->extended_distribution[i_d].bin_edge[i_b];
		    out_overviewfile << setw(2) << "";
		    out_overviewfile << right << setw(10) << setprecision(8) << noshowpoint << osi->extended_distribution[i_d].bin_edge[i_b + 1];
		    out_overviewfile << setw(3) << "";
		    if (active_qTcut){out_overviewfile << left << setw(16) << setprecision(8) << osi->value_qTcut_distribution[x_q];}
		    else {out_overviewfile << left << setw(16) << "independent";}
		    if (i_p == 0){out_overviewfile << left << setw(25) << infix_order_contribution;}
		    else {out_overviewfile << left << setw(25) << xsubprocess[i_p]->name;}
		    out_overviewfile << showpoint << right << setw(16) << setprecision(setw_result) << osi->unit_factor_distribution * xsubprocess[i_p]->distribution_result_TSV[i_d][i_b][x_q][i_s][i_r][i_f];
		    out_overviewfile << " +- ";
		    out_overviewfile << showpoint << right << setw(16) << setprecision(setw_deviation)<< osi->unit_factor_distribution * xsubprocess[i_p]->distribution_deviation_TSV[i_d][i_b][x_q][i_s][i_r][i_f];
		    if (i_p > 0){
		      out_overviewfile << "   ";
		      out_overviewfile << right << showpoint << setprecision(4) << setw(10) << xsubprocess[i_p]->distribution_chi2_TSV[i_d][i_b][x_q][i_s][i_r][i_f];
		    }
		    out_overviewfile << endline;
		  }
		  if (i_p > 0){
		    if (xsubprocess[i_p]->distribution_result_TSV[i_d][i_b][x_q][i_s][i_r][i_f] != 0.){
		      for (int i_m = 0; i_m < extended_directory.size(); i_m++){
			if (extended_directory.size() > 1){
			  out_overviewfile << setw(25) << "";
			  out_overviewfile << setw(16) << "";
			  if (extended_directory_name[i_m] == ""){out_overviewfile << setw(23) << right << "standard";}
			  else {out_overviewfile << setw(23) << right << extended_directory_name[i_m];}
			  out_overviewfile << setw(2) << "";
			}
			else {
			  out_overviewfile << right << setw(10) << setprecision(8) << noshowpoint << osi->extended_distribution[i_d].bin_edge[i_b];
			  out_overviewfile << setw(2) << "";
			  out_overviewfile << right << setw(10) << setprecision(8) << noshowpoint << osi->extended_distribution[i_d].bin_edge[i_b + 1];
			  out_overviewfile << setw(3) << "";
			  if (active_qTcut){out_overviewfile << left << noshowpoint << setw(16) << setprecision(8) << osi->value_qTcut_distribution[x_q];}
			  else {out_overviewfile << left << setw(16) << "independent";}
			  if (i_p == 0){out_overviewfile << left << setw(25) << infix_order_contribution;}
			  else {out_overviewfile << left << setw(25) << xsubprocess[i_p]->name;}
			}

			out_overviewfile << showpoint << right << setw(16) << setprecision(setw_result) << osi->unit_factor_distribution * xsubprocess[i_p]->distribution_group_result_TSV[i_m][i_d][i_b][x_q][i_s][i_r][i_f];
			out_overviewfile << " +- ";
			out_overviewfile << showpoint << right << setw(16) << setprecision(setw_deviation) << osi->unit_factor_distribution * xsubprocess[i_p]->distribution_group_deviation_TSV[i_m][i_d][i_b][x_q][i_s][i_r][i_f];
			out_overviewfile << setw(3) << "";
			out_overviewfile << right << showpoint << setprecision(4) << setw(10) << xsubprocess[i_p]->distribution_group_chi2_TSV[i_m][i_d][i_b][x_q][i_s][i_r][i_f];
			out_overviewfile << setw(3) << "";
			out_overviewfile << setw(5) << right << xsubprocess[i_p]->distribution_group_counter_nonzero_run_qTcut_TSV[i_m][i_d][i_b][x_q];
			out_overviewfile << " [" << setw(5) << right << xsubprocess[i_p]->distribution_group_counter_run_TSV[i_m] << "]";
			out_overviewfile << setw(3) << "";
			out_overviewfile << setw(3) << "";
			out_overviewfile << "(" << setw(4) << right << xsubprocess[i_p]->distribution_group_counter_removal_run_qTcut_TSV[i_m][i_d][i_b][x_q] << ")";
			out_overviewfile << setw(3) << "";
			out_overviewfile << right << setw(12) << xsubprocess[i_p]->distribution_group_N_binwise_TSV[i_m][i_d][i_b][x_q];
			out_overviewfile << endline;
		      }
		    }
		    if (extended_directory.size() > 1){ out_overviewfile << temp_ss_separation_one.str() << endline; }
		  }
		  if (i_p == 0){ out_overviewfile << temp_ss_separation_one.str() << endline; }
		}
		out_overviewfile << endline;
	      }
	      if (counter_empty_bin < selection_n_qTcut){out_overviewfile << temp_ss_separation_two.str() << endl << endline;}
	    }
	    if (!ygeneric->switch_output_overview_reduction){ out_overviewfile.close(); }
	    logger << LOG_DEBUG_VERBOSE << "filepath_distribution_overview = " << filepath_distribution_overview << "   finished." << endline_flush;
	  }
	  if (ygeneric->switch_output_overview_reduction == 1){ out_overviewfile.close(); }
	}
      }
    }
  }

  logger.finished();
}


void summary_contribution::output_dddistribution_overview_TSV(){
  static Logger logger("summary_contribution::output_dddistribution_overview_TSV");
  logger.called();

  ofstream out_overviewfile;
  string filename_distribution_overview;
  string filepath_distribution_overview;

  stringstream header_ss;
  header_ss << left << setw(16) << "qTcut";
  header_ss << left << setw(25) << "contribution/subprocess";
  header_ss << right << setw(16) << "dsigma";
  header_ss << setw(4) << " +- ";
  header_ss << right << setw(16) << "error";
  header_ss << setw(3) << "";
  header_ss << right << setw(10) << "chi2_dof";
  header_ss << setw(3) << "";
  header_ss << right << setw(5) << "n_run";
  header_ss << setw(1) << "";
  header_ss << right << setw(7) << "[total]";
  header_ss << setw(3) << "";
  header_ss << setw(9) << "(removed)";
  header_ss << setw(3) << "";
  header_ss << setw(12) << right << "events / bin";

  stringstream temp_ss_separation_one;
  stringstream temp_ss_separation_two;
  int counter_separation = 20 + 5 + 20 + 5 + 16 + 25 + 16 + 4 + 16 + 3 + 10 + 3 + 5 + 1 + 7 + 3 + 9 + 3 + 12;
  for (int i_x = 0; i_x < counter_separation; i_x++){
    temp_ss_separation_one << "-";
    temp_ss_separation_two << "=";
  }

  for (int i_s = 0; i_s < osi->n_extended_set_TSV; i_s++){
    if (!ygeneric->switch_output_scaleset[i_s]){continue;}
    if (!osi->switch_distribution_TSV[i_s]){continue;}
    if (i_s != osi->no_reference_TSV){ continue;}
    /*
      if (ygeneric->switch_output_overview_reduction == 2){
      filename_distribution_overview = "overview." + resultdirectory + ".dat";
      // directory does not exist yet !!!
      filepath_distribution_overview = ygeneric->final_resultdirectory + "/" + osi->name_extended_set_TSV[i_s] + "/" + resultdirectory + "/" + filename_distribution_overview;
      out_overviewfile.open(filepath_distribution_overview.c_str(), ofstream::out | ofstream::trunc);
      }
    */
    for (int i_r = 0; i_r < osi->n_scale_ren_TSV[i_s]; i_r++){
      for (int i_f = 0; i_f < osi->n_scale_fact_TSV[i_s]; i_f++){
	if (i_r != osi->no_scale_ren_reference_TSV || i_f != osi->no_scale_fact_reference_TSV){ continue; }

	if (ygeneric->switch_output_overview_reduction == 1){
	  filename_distribution_overview = "overview.." + infix_order_contribution + ".dat";
	  filepath_distribution_overview = ygeneric->scalepath_TSV[i_s][i_r][i_f] + "/" + ylist->resultdirectory + "/" + infix_contribution + "/" + filename_distribution_overview;
	  out_overviewfile.open(filepath_distribution_overview.c_str(), ofstream::out | ofstream::app);
	}
	
	for (int i_g = 0; i_g < ygeneric->subgroup.size(); i_g++){
	  for (int i_d = osi->dat.size(); i_d < osi->extended_distribution.size(); i_d++){
	    int i_ddd = i_d - osi->dat.size();
	    if (!ygeneric->switch_output_distribution[i_d]){continue;}
	    
	    if (ygeneric->switch_output_overview_reduction){
	      out_overviewfile << "## " << ygeneric->scalename_TSV[i_s][i_r][i_f] << "/" << ylist->resultdirectory + "/" + infix_contribution + "/" << "overview." + osi->extended_distribution[i_d].xdistribution_name + ".." + infix_order_contribution + ".dat" << endline;
	      out_overviewfile << endline;
	    }
	    else {
	      filename_distribution_overview = "overview." + osi->extended_distribution[i_d].xdistribution_name + ".." + infix_order_contribution + ".dat";
	      filepath_distribution_overview = ygeneric->scalepath_TSV[i_s][i_r][i_f] + "/" + ylist->resultdirectory + "/" + infix_contribution + "/" + filename_distribution_overview;
	      logger << LOG_DEBUG << "filename_distribution_overview = " << filename_distribution_overview << endline_flush;
	      logger << LOG_DEBUG << "filepath_distribution_overview = " << filepath_distribution_overview << endline_flush;
	      out_overviewfile.open(filepath_distribution_overview.c_str(), ofstream::out | ofstream::trunc);
	    }
	    
	    // first list all subprocesses that do not contribute first
	    bool non_contribution_run = false;
	    vector<int> counter_run(xsubprocess.size());
	    for (int i_p = 1; i_p < xsubprocess.size(); i_p++){
	      counter_run[i_p] = 0;
	      for (int i_m = 0; i_m < extended_directory.size(); i_m++){
		counter_run[i_p] += xsubprocess[i_p]->distribution_group_counter_run_TSV[i_m];
	      }
	      if (counter_run[i_p] == 0){non_contribution_run = true;}
	    }
	    if (non_contribution_run){
	      out_overviewfile << right << setw(41) << "non-contributing subprocesses" << setw(3) << "" << setw(25) << infix_order_contribution;
	      if (ylist->channel_selection != "" && ylist->channel_selection != "---"){ out_overviewfile << setw(10) << ylist->channel_selection; }
	      out_overviewfile << endline;
	      out_overviewfile << temp_ss_separation_one.str() << endline;
	      for (int i_p = 1; i_p < xsubprocess.size(); i_p++){
		if (counter_run[i_p] == 0){out_overviewfile << left << setw(41) << "" << setw(25) << xsubprocess[i_p]->name << endline;}
	      }
	      out_overviewfile << temp_ss_separation_two.str() << endline;
	      out_overviewfile << endline;
	    }
	    
	    stringstream bin_label_1;
	    bin_label_1 << "bin (" << osi->dddat[i_ddd].distribution_1.xdistribution_name << ")";
	    stringstream bin_label_2;
	    bin_label_2 << "bin (" << osi->dddat[i_ddd].distribution_2.xdistribution_name << ")";
	    out_overviewfile << setw(22) << bin_label_1.str() << setw(3) << "" << setw(22) << bin_label_2.str() << setw(3) << "" << header_ss.str() << endline;
	    out_overviewfile << endline;

	    for (int i_b1 = 0; i_b1 < osi->dddat[i_ddd].distribution_1.n_bins; i_b1++){
	      for (int i_b2 = 0; i_b2 < osi->dddat[i_ddd].distribution_2.n_bins; i_b2++){
		int i_b = i_b1 * osi->dddat[i_ddd].distribution_2.n_bins + i_b2;
		//	    for (int i_b = 0; i_b < osi->extended_distribution[i_d].n_bins; i_b++){
		int counter_empty_bin = 0;
		for (int x_q = 0; x_q < selection_n_qTcut; x_q++){
		  // check if bin is empty (to reduce output):
		  if (xsubprocess[0]->distribution_result_TSV[i_d][i_b][x_q][i_s][i_r][i_f] == 0.){counter_empty_bin++; continue;}

		  int temp_size_result = int(log10(abs(osi->unit_factor_distribution * xsubprocess[0]->distribution_result_TSV[i_d][i_b][x_q][i_s][i_r][i_f])));
		  for (int i_p = 0; i_p < subprocess.size(); i_p++){
		    int temp_size_result_c = int(log10(abs(osi->unit_factor_distribution * xsubprocess[i_p]->distribution_result_TSV[i_d][i_b][x_q][i_s][i_r][i_f])));
		    if (temp_size_result_c > temp_size_result){temp_size_result = temp_size_result_c;}
		  }
		  int temp_size_deviation = int(log10(abs(osi->unit_factor_distribution * xsubprocess[0]->distribution_deviation_TSV[i_d][i_b][x_q][i_s][i_r][i_f])));
		  if (osi->unit_factor_distribution * xsubprocess[0]->distribution_deviation_TSV[i_d][i_b][x_q][i_s][i_r][i_f] >= 1.){temp_size_deviation++;}

		  for (int i_p = 0; i_p < xsubprocess.size(); i_p++){
		    if (i_p > 0 && counter_run[i_p] == 0){continue;}
		    int temp_size_result_subprocess = int(log10(abs(osi->unit_factor_distribution * xsubprocess[i_p]->distribution_result_TSV[i_d][i_b][x_q][i_s][i_r][i_f])));
		    int temp_size_deviation_subprocess = int(log10(abs(osi->unit_factor_distribution * xsubprocess[i_p]->distribution_deviation_TSV[i_d][i_b][x_q][i_s][i_r][i_f])));
		    if (osi->unit_factor_distribution * xsubprocess[i_p]->distribution_deviation_TSV[i_d][i_b][x_q][i_s][i_r][i_f] >= 1.){temp_size_deviation_subprocess++;}
		    if (xsubprocess[i_p]->distribution_result_TSV[i_d][i_b][x_q][i_s][i_r][i_f] == 0){temp_size_result_subprocess = 0;}
		    if (xsubprocess[i_p]->distribution_deviation_TSV[i_d][i_b][x_q][i_s][i_r][i_f] == 0){temp_size_deviation_subprocess = 0;}
		    int setw_result = 9 + temp_size_result_subprocess - temp_size_result;
		    int setw_deviation = 9 + temp_size_deviation_subprocess - temp_size_deviation - (temp_size_result - temp_size_deviation + 1);
		    if (xsubprocess[i_p]->distribution_result_TSV[i_d][i_b][x_q][i_s][i_r][i_f] == 0.){setw_result = 1; setw_deviation = 1;}
		    else if (abs(osi->unit_factor_distribution * xsubprocess[i_p]->distribution_result_TSV[i_d][i_b][x_q][i_s][i_r][i_f]) < 1.){setw_result--;}


		    if (extended_directory.size() > 1 || i_p == 0){
		      out_overviewfile << right << noshowpoint << setw(10) << setprecision(8) << osi->dddat[i_ddd].distribution_1.bin_edge[i_b1];
		      out_overviewfile << setw(2) << "";
		      out_overviewfile << right << noshowpoint << setw(10) << setprecision(8) << osi->dddat[i_ddd].distribution_1.bin_edge[i_b1 + 1];
		      out_overviewfile << setw(3) << "";
		      out_overviewfile << right << noshowpoint << setw(10) << setprecision(8) << osi->dddat[i_ddd].distribution_2.bin_edge[i_b2];
		      out_overviewfile << setw(2) << "";
		      out_overviewfile << right << noshowpoint << setw(10) << setprecision(8) << osi->dddat[i_ddd].distribution_2.bin_edge[i_b2 + 1];
		      out_overviewfile << setw(3) << "";
		      if (active_qTcut){out_overviewfile << left << setw(16) << setprecision(8) << osi->value_qTcut_distribution[x_q];}
		      else {out_overviewfile << left << setw(16) << "independent";}
		      if (i_p == 0){out_overviewfile << left << setw(25) << infix_order_contribution;}
		      else {out_overviewfile << left << setw(25) << xsubprocess[i_p]->name;}
		      out_overviewfile << showpoint << right << setw(16) << setprecision(setw_result) << osi->unit_factor_distribution * xsubprocess[i_p]->distribution_result_TSV[i_d][i_b][x_q][i_s][i_r][i_f];
		      out_overviewfile << " +- ";
		      out_overviewfile << showpoint << right << setw(16) << setprecision(setw_deviation)<< osi->unit_factor_distribution * xsubprocess[i_p]->distribution_deviation_TSV[i_d][i_b][x_q][i_s][i_r][i_f];
		      if (i_p > 0){
			out_overviewfile << "   ";
			out_overviewfile << right << showpoint << setprecision(4) << setw(10) << xsubprocess[i_p]->distribution_chi2_TSV[i_d][i_b][x_q][i_s][i_r][i_f];
		      }
		      out_overviewfile << endline;
		    }
		    if (i_p > 0){
		      if (xsubprocess[i_p]->distribution_result_TSV[i_d][i_b][x_q][i_s][i_r][i_f] != 0.){
			for (int i_m = 0; i_m < extended_directory.size(); i_m++){
			  if (extended_directory.size() > 1){
			    out_overviewfile << setw(50) << "";
			    out_overviewfile << setw(16) << "";
			    if (extended_directory_name[i_m] == ""){out_overviewfile << setw(23) << right << "standard";}
			    else {out_overviewfile << setw(23) << right << extended_directory_name[i_m];}
			    out_overviewfile << setw(2) << "";
			  }
			  else {
			    out_overviewfile << right << noshowpoint << setw(10) << setprecision(8) << osi->dddat[i_ddd].distribution_1.bin_edge[i_b1];
			    out_overviewfile << setw(2) << "";
			    out_overviewfile << right << noshowpoint << setw(10) << setprecision(8) << osi->dddat[i_ddd].distribution_1.bin_edge[i_b1 + 1];
			    out_overviewfile << setw(3) << "";
			    out_overviewfile << right << noshowpoint << setw(10) << setprecision(8) << osi->dddat[i_ddd].distribution_2.bin_edge[i_b2];
			    out_overviewfile << setw(2) << "";
			    out_overviewfile << right << noshowpoint << setw(10) << setprecision(8) << osi->dddat[i_ddd].distribution_2.bin_edge[i_b2 + 1];
			    out_overviewfile << setw(3) << "";
			    if (active_qTcut){out_overviewfile << left << noshowpoint << setw(16) << setprecision(8) << osi->value_qTcut_distribution[x_q];}
			    else {out_overviewfile << left << setw(16) << "independent";}
			    if (i_p == 0){out_overviewfile << left << setw(25) << infix_order_contribution;}
			    else {out_overviewfile << left << setw(25) << xsubprocess[i_p]->name;}
			  }

			  out_overviewfile << showpoint << right << setw(16) << setprecision(setw_result) << osi->unit_factor_distribution * xsubprocess[i_p]->distribution_group_result_TSV[i_m][i_d][i_b][x_q][i_s][i_r][i_f];
			  out_overviewfile << " +- ";
			  out_overviewfile << showpoint << right << setw(16) << setprecision(setw_deviation) << osi->unit_factor_distribution * xsubprocess[i_p]->distribution_group_deviation_TSV[i_m][i_d][i_b][x_q][i_s][i_r][i_f];
			  out_overviewfile << setw(3) << "";
			  out_overviewfile << right << showpoint << setprecision(4) << setw(10) << xsubprocess[i_p]->distribution_group_chi2_TSV[i_m][i_d][i_b][x_q][i_s][i_r][i_f];
			  out_overviewfile << setw(3) << "";
			  out_overviewfile << setw(5) << right << xsubprocess[i_p]->distribution_group_counter_nonzero_run_qTcut_TSV[i_m][i_d][i_b][x_q];
			  out_overviewfile << " [" << setw(5) << right << xsubprocess[i_p]->distribution_group_counter_run_TSV[i_m] << "]";
			  out_overviewfile << setw(3) << "";
			  out_overviewfile << setw(3) << "";
			  out_overviewfile << "(" << setw(4) << right << xsubprocess[i_p]->distribution_group_counter_removal_run_qTcut_TSV[i_m][i_d][i_b][x_q] << ")";
			  out_overviewfile << setw(3) << "";
			  out_overviewfile << right << setw(12) << xsubprocess[i_p]->distribution_group_N_binwise_TSV[i_m][i_d][i_b][x_q];
			  out_overviewfile << endline;
			}
		      }
		      if (extended_directory.size() > 1){ out_overviewfile << temp_ss_separation_one.str() << endline; }
		    }
		    if (i_p == 0){ out_overviewfile << temp_ss_separation_one.str() << endline; }
		  }
		  out_overviewfile << endline;
		}
		if (counter_empty_bin < selection_n_qTcut){out_overviewfile << temp_ss_separation_two.str() << endl << endline;}
	      }
	    }
	    if (!ygeneric->switch_output_overview_reduction){ out_overviewfile.close(); }
	    logger << LOG_DEBUG_VERBOSE << "filepath_distribution_overview = " << filepath_distribution_overview << "   finished." << endline_flush;
	  }
	  if (ygeneric->switch_output_overview_reduction == 1){ out_overviewfile.close(); }
	}
      }
    }
  }

  logger.finished();
}





// asymmetry output (not up-to-date, but only available in CV) could be re-activated (as a special format for dddistributions) !!!

// All functions below are only relevant for CV variation:

void summary_contribution::output_distribution_overview_qTcut_CV(){
  static Logger logger("summary_contribution::output_distribution_overview_qTcut_CV");
  logger.called();

  stringstream header_ss;
  header_ss << left
	    << setw(16) << "bin"
	    << setw(16) << "qTcut"
	    << setw(25) << "subprocess"
	    << right
	    << setw(34) << "dXS +- err (subprocess)"
	    << setw(3) << ""
	    << right << setw(10) << "chi2_dof"
	    << setw(3) << ""
	    << right << setw(5) << "n_run"
	    << setw(3) << ""
	    << setw(9) << "(removed)";

  stringstream temp_ss_separation_one;
  stringstream temp_ss_separation_two;
  int counter_separation = 16 + 16 + 25 + 16 + 4 + 16 + 3 + 10 + 3 + 5 + 3 + 9;
  for (int i_x = 0; i_x < counter_separation; i_x++){
    temp_ss_separation_one << "-";
    temp_ss_separation_two << "=";
  }

  int i_q = 0;
  for (int i_s = 0; i_s < osi->n_scales_CV; i_s++){
    for (int i_d = 0; i_d < osi->extended_distribution.size(); i_d++){
      if (!ygeneric->switch_output_distribution[i_d]){continue;}
      string filename_distribution_overview = "overview." + osi->extended_distribution[i_d].xdistribution_name + "." + infix_order_contribution + ".dat";
      string filepath_distribution_overview = ygeneric->final_resultdirectory + "/CV/" + osi->directory_name_scale_CV[i_s] + "/" + ylist->resultdirectory + "/" + infix_contribution + "/" + filename_distribution_overview;
      logger << LOG_DEBUG << "filename_distribution_overview = " << filename_distribution_overview << endline_flush;
      logger << LOG_DEBUG << "filepath_distribution_overview = " << filepath_distribution_overview << endline_flush;

      ofstream out_overviewfile;
      out_overviewfile.open(filepath_distribution_overview.c_str(), ofstream::out | ofstream::trunc);
      out_overviewfile << header_ss.str() << endline;
      out_overviewfile << endline;

      for (int i_b = 0; i_b < osi->extended_distribution[i_d].n_bins; i_b++){
	int counter_empty_bin = 0;
	// check if bin is empty (to reduce output):
	if (xsubprocess[0]->distribution_result_CV[i_d][i_b][i_s] == 0.){counter_empty_bin++; continue;}

	int temp_size_result = int(log10(abs(osi->unit_factor_distribution * xsubprocess[0]->distribution_result_CV[i_d][i_b][i_s])));
	for (int i_p = 0; i_p < subprocess.size(); i_p++){
	  int temp_size_result_c = int(log10(abs(osi->unit_factor_distribution * xsubprocess[i_p]->distribution_result_CV[i_d][i_b][i_s])));
	  if (temp_size_result_c > temp_size_result){temp_size_result = temp_size_result_c;}
	}
	int temp_size_deviation = int(log10(abs(osi->unit_factor_distribution * xsubprocess[0]->distribution_deviation_CV[i_d][i_b][i_s])));
	if (osi->unit_factor_distribution * xsubprocess[0]->distribution_deviation_CV[i_d][i_b][i_s] >= 1.){temp_size_deviation++;}

	for (int i_p = 0; i_p < xsubprocess.size(); i_p++){
	  int temp_size_result_subprocess = int(log10(abs(osi->unit_factor_distribution * xsubprocess[i_p]->distribution_result_CV[i_d][i_b][i_s])));
	  int temp_size_deviation_subprocess = int(log10(abs(osi->unit_factor_distribution * xsubprocess[i_p]->distribution_deviation_CV[i_d][i_b][i_s])));
	  if (osi->unit_factor_distribution * xsubprocess[i_p]->distribution_deviation_CV[i_d][i_b][i_s] >= 1.){temp_size_deviation_subprocess++;}
	  if (xsubprocess[i_p]->distribution_result_CV[i_d][i_b][i_s] == 0){temp_size_result_subprocess = 0;}
	  if (xsubprocess[i_p]->distribution_deviation_CV[i_d][i_b][i_s] == 0){temp_size_deviation_subprocess = 0;}
	  int setw_result = 9 + temp_size_result_subprocess - temp_size_result;
	  int setw_deviation = 9 + temp_size_deviation_subprocess - temp_size_deviation - (temp_size_result - temp_size_deviation + 1);
	  if (xsubprocess[i_p]->distribution_result_CV[i_d][i_b][i_s] == 0.){setw_result = 1;setw_deviation = 1;}
	  else if (abs(osi->unit_factor_distribution * xsubprocess[i_p]->distribution_result_CV[i_d][i_b][i_s]) < 1.){setw_result--;}

	  if (extended_directory.size() > 1 || i_p == 0){
	    out_overviewfile << left << noshowpoint
			     << setw(16) << setprecision(8) << osi->extended_distribution[i_d].bin_edge[i_b];
	    if (active_qTcut){out_overviewfile << setw(16) << setprecision(8) << osi->value_qTcut_distribution[i_q];}
	    else {out_overviewfile << setw(16) << "independent";}
	    if (i_p == 0){out_overviewfile << setw(25) << infix_order_contribution;}
	    else {out_overviewfile << setw(25) << xsubprocess[i_p]->name;}
	    out_overviewfile << showpoint << right
			     << setw(16) << setprecision(setw_result)
			     << osi->unit_factor_distribution * xsubprocess[i_p]->distribution_result_CV[i_d][i_b][i_s]
			     << " +- "
			     << setw(16) << setprecision(setw_deviation)
			     << osi->unit_factor_distribution * xsubprocess[i_p]->distribution_deviation_CV[i_d][i_b][i_s];
	    if (i_p > 0){
	      out_overviewfile << setw(3) << ""
			       << right << showpoint << setprecision(4) << setw(10) << xsubprocess[i_p]->distribution_chi2_CV[i_d][i_b][i_s]
		;
	      /*
			       << setw(3) << ""
			       << setw(5) << right << xsubprocess[i_p]->counter_nonzero_distribution_run_CV[i_d][i_b]
			       << setw(3) << ""
			       << "   (" << setw(4) << right << xsubprocess[i_p]->counter_remove_distribution_run_CV[i_d][i_b]
			       << ")";
	      */
	    }
	    out_overviewfile << endline;
	  }

	  if (i_p > 0){
	    if (xsubprocess[i_p]->distribution_result_CV[i_d][i_b][i_s] != 0.){
	      for (int i_m = 0; i_m < extended_directory.size(); i_m++){
		if (extended_directory.size() > 1){
		  out_overviewfile << left << noshowpoint
				   << setw(16) << ""
				   << setw(16) << ""
				   << setw(23) << right << extended_directory_name[i_m]
				   << setw(2) << "";
		}
		else {
		  out_overviewfile << left << noshowpoint
				   << setw(16) << setprecision(8) << osi->extended_distribution[i_d].bin_edge[i_b];
		  if (active_qTcut){out_overviewfile << setw(16) << setprecision(8) << osi->value_qTcut_distribution[i_q];}
		  else {out_overviewfile << setw(16) << "independent";}
		  if (i_p == 0){out_overviewfile << setw(25) << infix_order_contribution;}
		  else {out_overviewfile << setw(25) << xsubprocess[i_p]->name;}
		}

		out_overviewfile << showpoint << right
				 << setw(16) << setprecision(setw_result)
				 << osi->unit_factor_distribution * xsubprocess[i_p]->distribution_group_result_CV[i_m][i_d][i_b][i_s]
				 << " +- "
				 << setw(16) << setprecision(setw_deviation)
				 << osi->unit_factor_distribution * xsubprocess[i_p]->distribution_group_deviation_CV[i_m][i_d][i_b][i_s];
		out_overviewfile << setw(3) << ""
				 << right << showpoint << setprecision(4) << setw(10) << xsubprocess[i_p]->distribution_group_chi2_CV[i_m][i_d][i_b][i_s] //xsubprocess[i_p]->chi2_TSV[i_m][i_q][i_s][i_r][i_f]
				 << setw(3) << ""
				 << setw(5) << right << xsubprocess[i_p]->distribution_group_counter_nonzero_run_CV[i_m][i_d][i_b]
				 << setw(3) << ""
				 << setw(3) << ""
				 << "(" << setw(4) << right << xsubprocess[i_p]->distribution_group_counter_removal_run_CV[i_m][i_d][i_b] << ")"
				 << setw(3) << ""
				 << setw(12) << right << xsubprocess[i_p]->distribution_group_N_binwise_CV[i_m][i_d][i_b]
				 << endline;
	      }
	    }
	    if (extended_directory.size() > 1){out_overviewfile << temp_ss_separation_one.str() << endline;}
	  }
	  if (i_p == 0){out_overviewfile << temp_ss_separation_one.str() << endline;}
	}
	out_overviewfile << endline;
      }
      out_overviewfile.close();
    }
  }

  logger.finished();
}


void summary_contribution::output_distribution_plot_CV(){
  static Logger logger("summary_contribution::output_distribution_plot_CV");
  logger.called();

  vector<double> n_bin_distribution(osi->extended_distribution.size());
  for (int i_d = 0; i_d < osi->extended_distribution.size(); i_d++){
    if (!ygeneric->switch_output_distribution[i_d]){continue;}
    n_bin_distribution[i_d] = osi->extended_distribution[i_d].n_bins;
  }
  // can most likely be just replaced by n_bin_distribution_modasym or osi->extended_distribution[i_d].n_bins !!!

  ////////////////////////////
  //  output for subgroups  // (only 0 = all)
  ////////////////////////////
  // too slow // ofstream out_checksum;
  // too slow // string filename_checksum = vs + "" + ygeneric->final_resultdirectory + "/" + scalename + "checksum." + distdat.xdistribution_name + "." + infix_order_contribution + observable + ".dat";
  // too slow // checksum.open(filename_checksum.c_str(), ofstream::out | ofstream::trunc);
  //  for (int i_g = 0; i_g < ygeneric->subgroup.size(); i_g++){
  for (int i_g = 0; i_g < 1; i_g++){
    for (int i_d = 0; i_d < osi->extended_distribution.size(); i_d++){
      if (!ygeneric->switch_output_distribution[i_d]){continue;}
      for (int i_s = 0; i_s < osi->n_scales_CV; i_s++){
	//	logger << LOG_DEBUG_VERBOSE << "i_s = " << i_s << endline_flush;
	if ((osi->extended_distribution[i_d].xdistribution_name).substr(0, 4) == "asym"){
	  double result_fw = 0.;
	  double result_bw = 0.;
	  double deviation_fw = 0.;
	  double deviation_bw = 0.;
	  ofstream out_asymfile;
	  string filename_asym = ygeneric->final_resultdirectory + "/CV/" + osi->directory_name_scale_CV[i_s] + "/" + osi->extended_distribution[i_d].xdistribution_name + "." + infix_order_contribution + ".dat";
	  logger << LOG_DEBUG_VERBOSE << "filename_asym = " << filename_asym << endline_flush;
	  out_asymfile.open(filename_asym.c_str(), ofstream::out | ofstream::trunc);
	  if (osi->extended_distribution[i_d].xdistribution_type == "asym1" || osi->extended_distribution[i_d].xdistribution_type == "asym2"){
	    ofstream out_plotfile;
	    string filename_plot = ygeneric->final_resultdirectory + "/CV/" + osi->directory_name_scale_CV[i_s] + "/plot." + osi->extended_distribution[i_d].xdistribution_name + "." + infix_order_contribution + ".dat";
	    logger << LOG_DEBUG_VERBOSE << "infix_order_contribution = " << infix_order_contribution << endline_flush;
	    logger << LOG_DEBUG_VERBOSE << "filename_plot = " << filename_plot << endline_flush;
	    out_plotfile.open(filename_plot.c_str(), ofstream::out | ofstream::trunc);
	    // too slow // checksum << setw(16) << "interval" << " " << setw(16) << "backward cs." << setw(16) << "forward cs." << setw(16) << "cross section" << endline;
	    for (int i_b = 0; i_b < n_bin_distribution[i_d]; i_b++){
	      if (osi->extended_distribution[i_d].xdistribution_type == "asym1"){
		result_fw = distribution_result_CV[0][i_d][n_bin_distribution[i_d] + i_b][i_s] * osi->fakeasymfactor[i_d];
		result_bw = distribution_result_CV[0][i_d][i_b][i_s] * osi->fakeasymfactor[i_d];
		deviation_fw = distribution_deviation_CV[0][i_d][n_bin_distribution[i_d] + i_b][i_s] * osi->fakeasymfactor[i_d];
		deviation_bw = distribution_deviation_CV[0][i_d][i_b][i_s] * osi->fakeasymfactor[i_d];
	      }
	      else if (osi->extended_distribution[i_d].xdistribution_type == "asym2"){
		result_fw = distribution_result_CV[0][i_d][2 * i_b + 1][i_s] * osi->fakeasymfactor[i_d];
		result_bw = distribution_result_CV[0][i_d][2 * i_b + 0][i_s] * osi->fakeasymfactor[i_d];
		deviation_fw = distribution_deviation_CV[0][i_d][2 * i_b + 1][i_s] * osi->fakeasymfactor[i_d];
		deviation_bw = distribution_deviation_CV[0][i_d][2 * i_b + 0][i_s] * osi->fakeasymfactor[i_d];
	      }
	      out_asymfile << setw(25) << "backw. cross section: " << "   [" << setw(5) << setprecision(4) << osi->extended_distribution[i_d].bin_edge[i_b] << ";" << setw(5) << setprecision(4) << osi->extended_distribution[i_d].bin_edge[i_b + 1] << "]   " << setw(16) << setprecision(8) << result_bw * osi->extended_distribution[i_d].step << setw(16) << setprecision(8) << deviation_bw * osi->extended_distribution[i_d].step << endline;
	      out_asymfile << setw(25) << "forw. cross section: " << "   [" << setw(5) << setprecision(4) << osi->extended_distribution[i_d].bin_edge[i_b] << ";" << setw(5) << setprecision(4) << osi->extended_distribution[i_d].bin_edge[i_b + 1] << "]   " << setw(16) << setprecision(8) << result_fw * osi->extended_distribution[i_d].step << setw(16) << setprecision(8) << deviation_fw * osi->extended_distribution[i_d].step << endline;
	      out_asymfile << setw(25) << "forw.-backw. asymmetry: " << "   [" << setw(5) << setprecision(4) << osi->extended_distribution[i_d].bin_edge[i_b] << ";" << setw(5) << setprecision(4) << osi->extended_distribution[i_d].bin_edge[i_b + 1] << "]   " << setw(16) << setprecision(8) << (result_fw - result_bw) / (result_fw + result_bw) << setw(16) << 2. * (deviation_fw * result_bw + deviation_bw * result_fw) / pow(result_bw + result_fw, 2) << endline;
	      out_plotfile << setw(5) << setprecision(4) << osi->extended_distribution[i_d].bin_edge[i_b] << setw(16) << setprecision(8) << (result_fw - result_bw) / (result_fw + result_bw) << setw(16) << 2. * (deviation_fw * result_bw + deviation_bw * result_fw) / pow(result_bw + result_fw, 2) << endline;
	      // too slow // checksum << "[ " << setw(5) << setprecision(4) << osi->extended_distribution[i_d].bin_edge[i_b] << "; " << setw(5) << setprecision(4) << bin_edge[i_d][n_bin_distribution[i_d]] << "] ";
	      double sum_result_fw = 0., sum_result_bw = 0.;
	      for (int c = i_b; c < n_bin_distribution[i_d]; c++){
		if (osi->extended_distribution[i_d].xdistribution_type == "asym1"){
		  sum_result_fw += distribution_result_CV[0][i_d][n_bin_distribution[i_d] + c][i_s] * osi->fakeasymfactor[i_d];
		  sum_result_bw += distribution_result_CV[0][i_d][c][i_s] * osi->fakeasymfactor[i_d];
		}
		else if (osi->extended_distribution[i_d].xdistribution_type == "asym2"){
		  sum_result_fw += distribution_result_CV[0][i_d][2 * c + 1][i_s] * osi->fakeasymfactor[i_d];
		  sum_result_bw += distribution_result_CV[0][i_d][2 * c + 0][i_s] * osi->fakeasymfactor[i_d];
		}
	      }
	      // too slow // checksum << setw(16) << setprecision(8) << sum_result_bw * osi->extended_distribution[i_d].step << setw(16) << setprecision(8) << sum_result_fw * osi->extended_distribution[i_d].step << setw(16) << setprecision(8) << (sum_result_fw + sum_result_bw) * osi->extended_distribution[i_d].step << endline;
	    }
	    out_plotfile << setw(5) << setprecision(4) << osi->extended_distribution[i_d].end << setw(16) << setprecision(8) << (result_fw - result_bw) / (result_fw + result_bw) << setw(16) << 2. * (deviation_fw * result_bw + deviation_bw * result_fw) / pow(result_bw + result_fw, 2) << endline;
	    out_asymfile.close();
	    out_plotfile.close();
	  }
	  else {
	    result_fw = distribution_result_CV[0][i_d][1][i_s] * osi->fakeasymfactor[i_d];
	    result_bw = distribution_result_CV[0][i_d][0][i_s] * osi->fakeasymfactor[i_d];
	    deviation_fw = distribution_deviation_CV[0][i_d][1][i_s] * osi->fakeasymfactor[i_d];
	    deviation_bw = distribution_deviation_CV[0][i_d][0][i_s] * osi->fakeasymfactor[i_d];
	    out_asymfile << setw(25) << "backw. cross section: " << setw(16) << setprecision(8) << result_bw << setw(16) << setprecision(8) << deviation_bw << endline;
	    out_asymfile << setw(25) << "forw. cross section: " << setw(16) << setprecision(8) << result_fw << setw(16) << setprecision(8) << deviation_fw << endline;
	    out_asymfile << setw(25) << "forw.-backw. asymmetry: " << setw(16) << setprecision(8) << (result_fw - result_bw) / (result_fw + result_bw) << setw(16) << 2. * (deviation_fw * result_bw + deviation_bw * result_fw) / pow(result_bw + result_fw, 2) << endline;
	    // too slow // checksum << setw(16) << "backward cs." << setw(16) << "forward cs." << setw(16) << "cross section" << endline;
	    // too slow // checksum << setw(16) << setprecision(8) << result_bw << setw(16) << setprecision(8) << result_fw << setw(16) << setprecision(8) << (result_fw + result_bw) << endline;
	    out_asymfile.close();
	  }
	}
	else {
	  ofstream out_plotfile;
	  string filename_plot = ygeneric->final_resultdirectory + "/CV/" + osi->directory_name_scale_CV[i_s] + "/" + ylist->resultdirectory + "/" + infix_contribution + "/plot." + osi->extended_distribution[i_d].xdistribution_name + "." + infix_order_contribution + ".dat";
	  logger << LOG_DEBUG_VERBOSE << "filename_plot = " << filename_plot << endline_flush;
	  out_plotfile.open(filename_plot.c_str(), ofstream::out | ofstream::trunc);
	  // too slow // checksum << setw(16) << "interval" << " " << setw(16) << "cross section" << endline;
	  //	  logger << LOG_DEBUG_VERBOSE << "distribution_result_CV.size() = " << distribution_result_CV.size() << endline_flush;
	  //	  logger << LOG_DEBUG_VERBOSE << "distribution_result_CV[" << i_g << "].size() = " << distribution_result_CV[i_g].size() << endline_flush;
	  //	  logger << LOG_DEBUG_VERBOSE << "distribution_result_CV[" << i_g << "][" << i_d << "].size() = " << distribution_result_CV[i_g][i_d].size() << endline_flush;
	  //	  logger << LOG_DEBUG_VERBOSE << "distribution_deviation_CV.size() = " << distribution_deviation_CV.size() << endline_flush;
	  //	  logger << LOG_DEBUG_VERBOSE << "distribution_deviation_CV[" << i_g << "].size() = " << distribution_deviation_CV[i_g].size() << endline_flush;
	  //	  logger << LOG_DEBUG_VERBOSE << "distribution_deviation_CV[" << i_g << "][" << i_d << "].size() = " << distribution_deviation_CV[i_g][i_d].size() << endline_flush;
	  for (int i_b = 0; i_b < distribution_result_CV[i_g][i_d].size(); i_b++){
	    //	    logger << LOG_DEBUG_VERBOSE << "i_b = " << i_b << endline_flush;
	    //	  for (int i_b = 0; i_b < distribution_result_CV[i_g].size(); i_b++){
	    //	    logger << LOG_DEBUG_VERBOSE << "distribution_result_CV[" << i_g << "][" << i_d << "][" << i_b << "].size() = " << distribution_result_CV[i_g][i_d][i_b].size() << endline_flush;
	    out_plotfile << setw(10) << osi->extended_distribution[i_d].bin_edge[i_b] << setw(16) << setprecision(8) << osi->unit_factor_distribution * distribution_result_CV[i_g][i_d][i_b][i_s] / osi->extended_distribution[i_d].bin_width[i_b] << setw(16) << setprecision(8) << osi->unit_factor_distribution * distribution_deviation_CV[i_g][i_d][i_b][i_s] / osi->extended_distribution[i_d].bin_width[i_b] << endline;
	    // norm ->	    out_plotfile << setw(10) << osi->extended_distribution[i_d].bin_edge[i_b] << setw(16) << setprecision(8) << osi->unit_factor_distribution * distribution_result_CV[i_g][i_d][i_b][i_s] << setw(16) << setprecision(8) << osi->unit_factor_distribution * distribution_deviation_CV[i_g][i_d][i_b][i_s] << endline;



	    // too slow // checksum << "[ " << setw(5) << setprecision(4) << osi->extended_distribution[i_d].bin_edge[i_b] << "; " << setw(5) << setprecision(4) << osi->extended_distribution[i_d].bin_edge[n_bin_distribution[i_d]] << "] ";
	    double sum_result = 0.;
	    for (int j_b = i_b; j_b < n_bin_distribution[i_d]; j_b++){sum_result += distribution_result_CV[i_g][i_d][j_b][i_s];}
	    // norm ->	    for (int j_b = i_b; j_b < n_bin_distribution[i_d]; j_b++){sum_result += distribution_result_CV[i_g][i_d][j_b][i_s] / osi->extended_distribution[i_d].bin_width[i_b];}
	    // too slow // checksum << setw(16) << setprecision(8) << sum_result * osi->extended_distribution[i_d].step << endline;
	  }
	  //	  logger << LOG_DEBUG_VERBOSE << "osi->extended_distribution[i_d].end = " << osi->extended_distribution[i_d].end << endline_flush;
	  //	  logger << LOG_DEBUG_VERBOSE << "distribution_result_CV[" << i_g << "][" << i_d << "][" << distribution_result_CV[i_g][i_d].size() - 1 << "][" << i_s << "] = " << distribution_result_CV[i_g][i_d][distribution_result_CV[i_g][i_d].size() - 1][i_s] << endline_flush;
	  //	  logger << LOG_DEBUG_VERBOSE << "distribution_deviation_CV[" << i_g << "][" << i_d << "][" << distribution_deviation_CV[i_g][i_d].size() - 1 << "][" << i_s << "] = " << distribution_deviation_CV[i_g][i_d][distribution_deviation_CV[i_g][i_d].size() - 1][i_s] << endline_flush;
	  //	  logger << LOG_DEBUG_VERBOSE << " = " <<  << endline_flush;
	  //	  logger << LOG_DEBUG_VERBOSE << " = " <<  << endline_flush;
	  out_plotfile << setw(10) << osi->extended_distribution[i_d].end << setw(16) << setprecision(8) << osi->unit_factor_distribution * distribution_result_CV[i_g][i_d][distribution_result_CV[i_g][i_d].size() - 1][i_s] / osi->extended_distribution[i_d].bin_width[osi->extended_distribution[i_d].n_bins - 1] << setw(16) << setprecision(8) << osi->unit_factor_distribution * distribution_deviation_CV[i_g][i_d][distribution_deviation_CV[i_g][i_d].size() - 1][i_s] / osi->extended_distribution[i_d].bin_width[osi->extended_distribution[i_d].n_bins - 1] << endline; // endpoint
	  // norm ->	    out_plotfile << setw(10) << osi->extended_distribution[i_d].end << setw(16) << setprecision(8) << osi->unit_factor_distribution * distribution_result_CV[i_g][i_d][distribution_result_CV[i_g][i_d].size() - 1][i_s] << setw(16) << setprecision(8) << osi->unit_factor_distribution * distribution_deviation_CV[i_g][i_d][distribution_deviation_CV[i_g][i_d].size() - 1][i_s] << endline; // endpoint
	  //	  logger << LOG_DEBUG_VERBOSE << "end i_s = " << i_s << endline_flush;
	  out_plotfile.close();
	}
      }
    }
  }

  logger.finished();
}



void summary_contribution::output_distribution_asymmetry_CV(){
  static Logger logger("summary_contribution::output_distribution_asymmetry_CV");
  logger.called();

  /*
  logger << LOG_DEBUG_VERBOSE << "asym calculation begins" << endline_flush;

  ///////////////////////////////
  //  output for subprocesses  //
  ///////////////////////////////
  for (int i_p = 0; i_p < xsubprocess.size(); i_p++){
    for (int i_d = 0; i_d < osi->extended_distribution.size(); i_d++){
      ///// too slow // ofstream out_checksum;
      ///// too slow // string filename_checksum = ylist->resultdirectory + "/" + infix_order_contribution + "/" + scalename + "checksum." + osi->extended_distribution[i_d].xdistribution_name + "." + subprocess[i_p] + ".dat";
      ///// too slow // checksum.open(filename_checksum.c_str(), ofstream::out | ofstream::trunc);
      if ((osi->extended_distribution[i_d].xdistribution_name).substr(0, 4) == "asym"){
	double result_fw, result_bw, deviation_fw, deviation_bw;
	ofstream out_asymfile;
	string filename_asym = ylist->resultdirectory + "/" + infix_order_contribution + "/" + scalename + osi->extended_distribution[i_d].xdistribution_name + "." + subprocess[i_p] + ".dat";
	logger << LOG_DEBUG_VERBOSE << "filename_asym = " << filename_asym << endline_flush;
	///      out_asymfile.open(filename_asym.c_str(), ofstream::out | ofstream::trunc);
	if (osi->extended_distribution[i_d].xdistribution_type == "asym1" || osi->extended_distribution[i_d].xdistribution_type == "asym2"){
	  ///	ofstream out_plotfile;
	  ///	string filename_plot = ylist->resultdirectory + "/" + infix_order_contribution + "/" + scalename + "plot." + osi->extended_distribution[i_d].xdistribution_name + "." + subprocess[i_p] + ".dat";
	  ///	logger << LOG_DEBUG_VERBOSE << "filename_plot = " << filename_plot << endline_flush;
	  ///	out_plotfile.open(filename_plot.c_str(), ofstream::out | ofstream::trunc);
	  ///// too slow // checksum << setw(16) << "interval" << " " << setw(16) << "backward cs." << setw(16) << "forward cs." << setw(16) << "cross section" << endline;
	  for (int i_b = 0; i_b < n_bin_distribution[i_d]; i_b++){
	    if (osi->extended_distribution[i_d].xdistribution_type == "asym1"){
	      //xsubprocess[i_p]->distribution_result_CV[i_d][i_b][i_s]
	    result_fw = xsubprocess[i_p]->distribution_result_CV[i_d][n_bin_distribution[i_d] + i_b][i_s] * osi->fakeasymfactor[i_d];
	    result_bw = xsubprocess[i_p]->distribution_result_CV[i_d][i_b][i_s] * osi->fakeasymfactor[i_d];
	    deviation_fw = xsubprocess[i_p]->distribution_deviation_CV[i_d][n_bin_distribution[i_d] + i_b][i_s] * osi->fakeasymfactor[i_d];
	    deviation_bw = xsubprocess[i_p]->distribution_deviation_CV[i_d][i_b][i_s] * osi->fakeasymfactor[i_d];
	  }
	  else if (osi->extended_distribution[i_d].xdistribution_type == "asym2"){
	    result_fw = xsubprocess[i_p]->distribution_result_CV[i_d][2 * i_b + 1][i_s] * osi->fakeasymfactor[i_d];
	    result_bw = xsubprocess[i_p]->distribution_result_CV[i_d][2 * i_b + 0][i_s] * osi->fakeasymfactor[i_d];
	    deviation_fw = xsubprocess[i_p]->distribution_deviation_CV[i_d][2 * i_b + 1][i_s] * osi->fakeasymfactor[i_d];
	    deviation_bw = xsubprocess[i_p]->distribution_deviation_CV[i_d][2 * i_b + 0][i_s] * osi->fakeasymfactor[i_d];
	  }
	  ///	  out_asymfile << setw(25) << "backw. cross section: ";
	  ///	  out_asymfile << "   [" << setw(5) << setprecision(4) << osi->extended_distribution[i_d].bin_edge[i_b] << ";" << setw(5) << setprecision(4) << osi->extended_distribution[i_d].bin_edge[i_b + 1] << "]   " << setw(16) << setprecision(8) << result_bw * osi->extended_distribution[i_d].step << setw(16) << setprecision(8) << deviation_bw * osi->extended_distribution[i_d].step;// * (bin_edge[i_d][n_bin_distribution[i_d]] - bin_edge[i_d][0]);
	  ///	  out_asymfile << endline;
	  ///	  out_asymfile << setw(25) << "forw. cross section: ";
	  ///	  out_asymfile << "   [" << setw(5) << setprecision(4) << osi->extended_distribution[i_d].bin_edge[i_b] << ";" << setw(5) << setprecision(4) << osi->extended_distribution[i_d].bin_edge[i_b + 1] << "]   " << setw(16) << setprecision(8) << result_fw * osi->extended_distribution[i_d].step << setw(16) << setprecision(8) << deviation_fw * osi->extended_distribution[i_d].step;// * (bin_edge[i_d][n_bin_distribution[i_d]] - bin_edge[i_d][0]);
	  ///	  out_asymfile << endline;
	  ///	  out_asymfile << setw(25) << "forw.-backw. asymmetry: ";
	  ///	  out_asymfile << "   [" << setw(5) << setprecision(4) << osi->extended_distribution[i_d].bin_edge[i_b] << ";" << setw(5) << setprecision(4) << osi->extended_distribution[i_d].bin_edge[i_b + 1] << "]   " << setw(16) << setprecision(8) << (result_fw - result_bw) / (result_fw + result_bw) << setw(16) << 2. * (deviation_fw * result_bw + deviation_bw * result_fw) / pow(result_bw + result_fw, 2);
	  ///	  out_asymfile << endline;
	  ///	  out_plotfile << setw(5) << setprecision(4) << osi->extended_distribution[i_d].bin_edge[i_b] << setw(16) << setprecision(8) << (result_fw - result_bw) / (result_fw + result_bw) << setw(16) << 2. * (deviation_fw * result_bw + deviation_bw * result_fw) / pow(result_bw + result_fw, 2) << endline;
	  ///// too slow // checksum << "[ " << setw(5) << setprecision(4) << osi->extended_distribution[i_d].bin_edge[i_b] << "; " << setw(5) << setprecision(4) << bin_edge[i_d][n_bin_distribution[i_d]] << "] ";
	  double sum_result_fw = 0., sum_result_bw = 0.;
	  for (int j_b = i_b; j_b < n_bin_distribution[i_d]; j_b++){
	    if (osi->extended_distribution[i_d].xdistribution_type == "asym1"){
	      sum_result_fw += xsubprocess[i_p]->distribution_result_CV[i_d][n_bin_distribution[i_d] + j_b][i_s] * osi->fakeasymfactor[i_d];
	      sum_result_bw += xsubprocess[i_p]->distribution_result_CV[i_d][j_b][i_s] * osi->fakeasymfactor[i_d];
	    }
	    else if (osi->extended_distribution[i_d].xdistribution_type == "asym2"){
	      sum_result_fw += xsubprocess[i_p]->distribution_result_CV[i_d][2 * j_b + 1][i_s] * osi->fakeasymfactor[i_d];
	      sum_result_bw += xsubprocess[i_p]->distribution_result_CV[i_d][2 * j_b + 0][i_s] * osi->fakeasymfactor[i_d];
	    }
	  }
	  ///// too slow // checksum << setw(16) << setprecision(8) << sum_result_bw * osi->extended_distribution[i_d].step << setw(16) << setprecision(8) << sum_result_fw * osi->extended_distribution[i_d].step << setw(16) << setprecision(8) << (sum_result_fw + sum_result_bw) * osi->extended_distribution[i_d].step << endline;
	}
	///	out_plotfile << setw(5) << setprecision(4) << osi->extended_distribution[i_d].end << setw(16) << setprecision(8) << (result_fw - result_bw) / (result_fw + result_bw) << setw(16) << 2. * (deviation_fw * result_bw + deviation_bw * result_fw) / pow(result_bw + result_fw, 2) << endline;
	///	out_plotfile.close();
	///	out_asymfile.close();
      }
      else {
	result_fw = xsubprocess[i_p]->distribution_result_CV[i_d][1][i_s] * osi->fakeasymfactor[i_d];
	result_bw = xsubprocess[i_p]->distribution_result_CV[i_d][0][i_s] * osi->fakeasymfactor[i_d];
	deviation_fw = xsubprocess[i_p]->distribution_deviation_CV[i_d][1][i_s] * osi->fakeasymfactor[i_d];
	deviation_bw = xsubprocess[i_p]->distribution_deviation_CV[i_d][0][i_s] * osi->fakeasymfactor[i_d];
	///	out_asymfile << setw(25) << "backw. cross section: " << setw(16) << setprecision(8) << result_bw << setw(16) << setprecision(8) << deviation_bw << endline;
	///	out_asymfile << setw(25) << "forw. cross section: " << setprecision(8) << result_fw << setw(16) << setprecision(8) << deviation_fw << endline;
	///	out_asymfile << setw(25) << "forw.-backw. asymmetry: " << setw(16) << setprecision(8) << (result_fw - result_bw) / (result_fw + result_bw) << setw(16) << 2. * (deviation_fw * result_bw + deviation_bw * result_fw) / pow(result_bw + result_fw, 2) << endline;
	///// too slow // checksum << setw(16) << "backward cs." << setw(16) << "forward cs." << setw(16) << "cross section" << endline;
	///// too slow // checksum << setw(16) << setprecision(8) << result_bw << setw(16) << setprecision(8) << result_fw << setw(16) << setprecision(8) << (result_fw + result_bw) << endline;
	///	out_asymfile.close();
      }
    }
    else {
      ofstream out_plotfile;
      string filename_plot = ylist->resultdirectory + "/" + infix_order_contribution + "/" + scalename + "plot." + osi->extended_distribution[i_d].xdistribution_name + "." + subprocess[i_p] + ".dat";
      logger << LOG_DEBUG_VERBOSE << "filename_plot = " << filename_plot << endline_flush;
      out_plotfile.open(filename_plot.c_str(), ofstream::out | ofstream::trunc);
      ///// too slow // checksum << setw(16) << "interval" << " " << setw(16) << "cross section" << endline;
      for (int i_b = 0; i_b < n_bin_distribution[i_d]; i_b++){
	out_plotfile << setw(10) << osi->extended_distribution[i_d].bin_edge[i_b] << setw(16) << setprecision(8) << xsubprocess[i_p]->distribution_result_CV[i_d][i_b][i_s] << setw(16) << setprecision(8) << xsubprocess[i_p]->distribution_deviation_CV[i_d][i_b][i_s] << endline;
	///// too slow // checksum << "[ " << setw(5) << setprecision(4) << osi->extended_distribution[i_d].bin_edge[i_b] << "; " << setw(5) << setprecision(4) << bin_edge[i_d][n_bin_distribution[i_d]] << "] ";
	///// too slow // double sum_result = 0.;
	///// too slow // for (int j_b = i_b; j_b < n_bin_distribution[i_d]; j_b++){sum_result += xsubprocess[i_p]->distribution_result_CV[i_d][j_b][i_s];}
	///// too slow // checksum << setw(16) << setprecision(8) << sum_result * osi->extended_distribution[i_d].step << endline;
      }
      ///      out_plotfile << setw(10) << osi->extended_distribution[i_d].end << setw(16) << setprecision(8) << xsubprocess[i_p]->distribution_result_CV[i_d][n_bin_distribution[i_d] - 1] << setw(16) << setprecision(8) << xsubprocess[i_p]->distribution_deviation_CV[i_d][n_bin_distribution[i_d] - 1] << endline; // endpoint
      out_plotfile.close();
    }
    ///// too slow // checksum.close();
  }
  logger << LOG_DEBUG_VERBOSE << "asym calculation ends" << endline_flush;
*/

  logger.finished();
}



