#include "header.hpp"

void summary_contribution::output_overview_TSV(){
  static Logger logger("summary_contribution::output_overview_TSV");
  logger.called();

  int start_i_m = 0; // temporary !!!
  //  for (int i_m = start_i_m; i_m < osi->n_moments; i_m++){
  for (int i_m = start_i_m; i_m < 1; i_m++){
    for (int i_s = 0; i_s < osi->n_extended_set_TSV; i_s++){
      if (!ygeneric->switch_output_scaleset[i_s]){continue;}
      if (ygeneric->switch_output_complete){ output_selection_overview_TSV("complete", i_m, i_s); }
      if (ygeneric->switch_output_ren){ output_selection_overview_TSV("ren", i_m, i_s); }
      if (ygeneric->switch_output_fact){ output_selection_overview_TSV("fact", i_m, i_s); }
      if (ygeneric->switch_output_equal){ output_selection_overview_TSV("equal", i_m, i_s); }
      if (ygeneric->switch_output_antipodal){ output_selection_overview_TSV("antipodal", i_m, i_s); }
      if (ygeneric->switch_output_7point){ output_selection_overview_TSV("7-point", i_m, i_s); }
      if (ygeneric->switch_output_9point){ output_selection_overview_TSV("9-point", i_m, i_s); }
    }
  }

  logger.finished();
}


void summary_contribution::output_selection_overview_TSV(string selection, int i_m, int i_s){
  static Logger logger("summary_contribution::output_selection_overview_TSV");
  logger.called();

  static string temp_s_separation_one;
  static string temp_s_separation_two;
  static vector<string> temp_vs_header;
  static bool initialization = true;
  if (initialization){
    stringstream temp_ss_separation_one;
    stringstream temp_ss_separation_two;
    int counter_separation = 15 + 15 + 15 + 5 + 25 + 15 + 15 + 4 + 15 + 3 + 10 + 3 + 5 + 3 + 9;
    for (int i_x = 0; i_x < counter_separation; i_x++){
      temp_ss_separation_one << "-";
      temp_ss_separation_two << "=";
    }
    temp_s_separation_one = temp_ss_separation_one.str();
    temp_s_separation_two = temp_ss_separation_two.str();

    temp_vs_header.resize(osi->n_extended_set_TSV);
    for (int i_s = 0; i_s < osi->n_extended_set_TSV; i_s++){
      if (!ygeneric->switch_output_scaleset[i_s]){continue;}
      stringstream name_ss;
      name_ss << "dXS +- err (subprocess)";
      stringstream header_ss;
      header_ss << left	<< setw(15) << "qTcut";
      header_ss << left	<< setw(5) << "mu_R/" << setw(10) << osi->name_extended_set_TSV[i_s];
      header_ss << left	<< setw(5) << "mu_F/" << setw(10) << osi->name_extended_set_TSV[i_s];
      header_ss << setw(5) << "CHS";
      header_ss << left	<< setw(25) << "subprocess";
      header_ss << setw(15) << "";
      header_ss << right << setw(34) << name_ss.str() << "   ";
      header_ss << right << setw(10) << "chi2_dof" << "   ";
      header_ss << right << setw(5) << "n_run"<< "   ";
      header_ss << setw(9) << "(removed)";
      temp_vs_header[i_s] = header_ss.str();
    }
    initialization = false;
  }

  string filename_selection;
  ofstream outfile_selection;
  filename_selection = "" + ygeneric->final_resultdirectory + "/" + osi->name_extended_set_TSV[i_s] + "/" + selection + "/" + ylist->resultdirectory + "/overview" + ygeneric->infix_name_moment[i_m] + "." + infix_order_contribution + ".dat";
  if (Log::getLogThreshold() <= LOG_DEBUG){ logger << LOG_DEBUG << "filename_selection = " << filename_selection << endline_flush; }

  outfile_selection.open(filename_selection.c_str(), ofstream::out | ofstream::trunc);
  outfile_selection << temp_vs_header[i_s] << endline;
  outfile_selection << endline;

  for (int i_q = 0; i_q < output_n_qTcut; i_q++){
    for (int i_r = 0; i_r < osi->n_scale_ren_TSV[i_s]; i_r++){
      for (int i_f = 0; i_f < osi->n_scale_fact_TSV[i_s]; i_f++){
	if (!ygeneric->output_selection_scale_check_TSV(selection, i_s, i_r, i_f)){continue;}
	int temp_size_result = int(log10(abs(osi->unit_factor_result * xsubprocess[0]->result_TSV[i_m][i_q][i_s][i_r][i_f])));
	for (int i_p = 0; i_p < subprocess.size(); i_p++){
	  int temp_size_result_c = int(log10(abs(osi->unit_factor_result * xsubprocess[i_p]->result_TSV[i_m][i_q][i_s][i_r][i_f])));
	  if (temp_size_result_c > temp_size_result){temp_size_result = temp_size_result_c;}
	}
	int temp_size_deviation = int(log10(abs(osi->unit_factor_result * xsubprocess[0]->deviation_TSV[i_m][i_q][i_s][i_r][i_f])));
	if (osi->unit_factor_result * xsubprocess[0]->deviation_TSV[i_m][i_q][i_s][i_r][i_f] >= 1.){temp_size_deviation++;}

	if (Log::getLogThreshold() <= LOG_DEBUG_STEP){ logger << LOG_DEBUG_STEP << "result_TSV[" << i_m << "][" << i_q << "][" << i_s << "][" << i_r << "][" << i_f << "]  " << setw(15) << osi->unit_factor_result * xsubprocess[0]->result_TSV[i_m][i_q][i_s][i_r][i_f] << " --- " << setw(2) << temp_size_result << "     " << setw(15) << osi->unit_factor_result * xsubprocess[0]->deviation_TSV[i_m][i_q][i_s][i_r][i_f] << " --- " << setw(2) << temp_size_deviation << endline_flush; }

	for (int i_p = 0; i_p < subprocess.size(); i_p++){
	  int temp_size_result_subprocess = int(log10(abs(osi->unit_factor_result * xsubprocess[i_p]->result_TSV[i_m][i_q][i_s][i_r][i_f])));
	  int temp_size_deviation_subprocess = int(log10(abs(osi->unit_factor_result * xsubprocess[i_p]->deviation_TSV[i_m][i_q][i_s][i_r][i_f])));
	  if (osi->unit_factor_result * xsubprocess[i_p]->deviation_TSV[i_m][i_q][i_s][i_r][i_f] >= 1.){temp_size_deviation_subprocess++;}
	  if (xsubprocess[i_p]->result_TSV[i_m][i_q][i_s][i_r][i_f] == 0){temp_size_result_subprocess = 0;}
	  if (xsubprocess[i_p]->deviation_TSV[i_m][i_q][i_s][i_r][i_f] == 0){temp_size_deviation_subprocess = 0;}
	  int setw_result = 9 + temp_size_result_subprocess - temp_size_result;
	  int setw_deviation = 9 + temp_size_deviation_subprocess - temp_size_deviation - (temp_size_result - temp_size_deviation + 1);
	  if (xsubprocess[i_p]->result_TSV[i_m][i_q][i_s][i_r][i_f] == 0.){setw_result = 1; setw_deviation = 1;}
	  else if (abs(osi->unit_factor_result * xsubprocess[i_p]->result_TSV[i_m][i_q][i_s][i_r][i_f]) < 1.){setw_result--;}

	  stringstream temp_ss;
	  temp_ss << left;
	  if (active_qTcut){temp_ss << setw(15) << setprecision(8) << osi->value_qTcut[i_q];}
	  else {temp_ss << setw(15) << "independent";}
	  temp_ss << setw(15) << setprecision(8) << osi->relative_scale_ren_TSV[i_s][i_r];
	  temp_ss << setw(15) << setprecision(8) << osi->relative_scale_fact_TSV[i_s][i_f];
	  if (ylist->channel_selection != "" && ylist->channel_selection != "---"){temp_ss << left << setw(5) << ylist->channel_selection;}
	  else {temp_ss << left << setw(5) << "";}
	  if (i_p == 0){temp_ss << setw(25) << infix_order_contribution;}
	  else {temp_ss << setw(25) << subprocess[i_p];}
	  if (extra_selection_contribution != "" && extra_selection_contribution != "---"){temp_ss << left << setw(15) << extra_selection_contribution;}
	  else {temp_ss << left << setw(15) << "";}
	  temp_ss << right << setw(15) << setprecision(setw_result) << showpoint;
	  temp_ss  << osi->unit_factor_result * xsubprocess[i_p]->result_TSV[i_m][i_q][i_s][i_r][i_f];
	  temp_ss  << " +- ";
	  temp_ss  << right << setw(15) << setprecision(setw_deviation) << showpoint;
	  temp_ss  << osi->unit_factor_result * xsubprocess[i_p]->deviation_TSV[i_m][i_q][i_s][i_r][i_f];
	  if (i_p == 0){temp_ss << setw(3 + 10 + 3 + 5 + 9);}
	  else {
	    temp_ss	<< "   ";
	    temp_ss	<< right << showpoint << setprecision(4) << setw(10) << xsubprocess[i_p]->chi2_TSV[i_m][i_q][i_s][i_r][i_f];
	    temp_ss	<< "   ";
	    temp_ss	<< setw(5) << right << xsubprocess[i_p]->n_parallel_runs_group_TSV[0][i_m][i_q][i_s][i_r][i_f];
	    //		temp_ss	<< setw(5) << right << xsubprocess[i_p]->n_parallel_runs_TSV[i_m][i_q][i_s][i_r][i_f]
	    temp_ss	<< "   ";
	    temp_ss	<< "   (" << setw(4) << right << accumulate(xsubprocess[i_p]->remove_group_run_qTcut_TSV[i_q][0].begin(), xsubprocess[i_p]->remove_group_run_qTcut_TSV[i_q][0].end(), 0) << ")";
	    //		temp_ss	<< "   (" << setw(4) << right << accumulate(xsubprocess[i_p]->remove_run_qTcut_TSV[i_q].begin(), xsubprocess[i_p]->remove_run_qTcut_TSV[i_q].end(), 0) << ")";
	  }

	  outfile_selection << temp_ss.str() << endline;
	  if (i_p == 0){
	    outfile_selection << temp_s_separation_one << endline;
	  }
	}
	outfile_selection << endline;
      }
    }
    outfile_selection << temp_s_separation_two << endline << endline;
  }
  outfile_selection.close();

  logger.finished();
}


void summary_contribution::output_result_TSV(){
  static Logger logger("summary_contribution::output_result_TSV");
  logger.called();

  if (Log::getLogThreshold() <= LOG_DEBUG){
    logger << LOG_DEBUG << "resultdirectory = " << resultdirectory << endline_flush;
    logger << LOG_DEBUG << "processname = " << processname << endline_flush;
    logger << LOG_DEBUG << "type_perturbative_order = " << type_perturbative_order << endline_flush;
    logger << LOG_DEBUG << "type_subtraction_method = " << type_subtraction_method << endline_flush;
    logger << LOG_DEBUG << "in_contribution_order_alpha_s = " << in_contribution_order_alpha_s << endline_flush;
    logger << LOG_DEBUG << "in_contribution_order_alpha_e = " << in_contribution_order_alpha_e << endline_flush;
    logger << LOG_DEBUG << "infix_contribution = " << infix_contribution << endline_flush;
    logger << LOG_DEBUG << "infix_order_contribution = " << infix_order_contribution << endline_flush;
    logger << LOG_DEBUG << "infix_path_contribution = " << infix_path_contribution << endline_flush;
  }

  int start_i_m = 0; // temporary !!!
  for (int i_m = start_i_m; i_m < 1; i_m++){
    //  for (int i_m = start_i_m; i_m < osi->n_moments; i_m++){
    for (int i_s = 0; i_s < osi->n_extended_set_TSV; i_s++){
      if (!ygeneric->switch_output_scaleset[i_s]){continue;}
      if (ygeneric->switch_output_complete){output_selection_result_TSV("complete", i_m, i_s);}
      if (ygeneric->switch_output_ren){output_selection_result_TSV("ren", i_m, i_s);}
      if (ygeneric->switch_output_fact){output_selection_result_TSV("fact", i_m, i_s);}
      if (ygeneric->switch_output_equal){output_selection_result_TSV("equal", i_m, i_s);}
      if (ygeneric->switch_output_antipodal){output_selection_result_TSV("antipodal", i_m, i_s);}
      if (ygeneric->switch_output_7point){output_selection_result_TSV("7-point", i_m, i_s);}
      if (ygeneric->switch_output_9point){output_selection_result_TSV("9-point", i_m, i_s);}
    }
  }

  logger.finished();
}


void summary_contribution::output_selection_result_TSV(string selection, int i_m, int i_s){
  static Logger logger("summary_contribution::output_selection_result_TSV");
  logger.called();

  static vector<string> temp_vs_header;
  static bool initialization = true;
  if (initialization){
    temp_vs_header.resize(osi->n_extended_set_TSV);
    for (int i_s = 0; i_s < osi->n_extended_set_TSV; i_s++){
      if (!ygeneric->switch_output_scaleset[i_s]){continue;}
      stringstream header_ss;
      header_ss << left;
      header_ss << setw(15) << "qTcut";
      header_ss << setw(5) << "mu_R/" << setw(10) << osi->name_extended_set_TSV[i_s];
      header_ss << setw(5) << "mu_F/" << setw(10) << osi->name_extended_set_TSV[i_s];
      header_ss << setw(10) << "dXS +- err";
      temp_vs_header[i_s] = header_ss.str();
    }
    initialization = false;
  }

  string filename_selection;
  ofstream outfile_selection;
  filename_selection = "" + ygeneric->final_resultdirectory + "/" + osi->name_extended_set_TSV[i_s] + "/" + selection + "/" + ylist->resultdirectory + "/result" + ygeneric->infix_name_moment[i_m] + "." + infix_order_contribution + ".dat";
  if (Log::getLogThreshold() <= LOG_DEBUG){ logger << LOG_DEBUG << "filename_selection = " << filename_selection << endline_flush; }
  outfile_selection.open(filename_selection.c_str(), ofstream::out | ofstream::trunc);
  stringstream name_ss;
  name_ss << "(" << infix_order_contribution << ")";
  outfile_selection << temp_vs_header[i_s] << " " << left << setw(23) << name_ss.str() << endline;

  for (int i_q = 0; i_q < output_n_qTcut; i_q++){
    outfile_selection << endline;
    for (int i_r = 0; i_r < osi->n_scale_ren_TSV[i_s]; i_r++){
      for (int i_f = 0; i_f < osi->n_scale_fact_TSV[i_s]; i_f++){
	if (!ygeneric->output_selection_scale_check_TSV(selection, i_s, i_r, i_f)){continue;}
	stringstream temp_ss;
	temp_ss << left;
	if (active_qTcut){temp_ss << setw(15) << osi->value_qTcut[i_q];}
	else {temp_ss << setw(15) << "independent";}
	temp_ss << setw(15) << setprecision(8) << osi->relative_scale_ren_TSV[i_s][i_r];
	temp_ss << setw(15) << setprecision(8) << osi->relative_scale_fact_TSV[i_s][i_f];
	temp_ss << setprecision(8) << setw(15) << osi->unit_factor_result * result_TSV[i_m][0][i_q][i_s][i_r][i_f];
	temp_ss << " +- ";
	temp_ss << setprecision(8) << setw(15) << osi->unit_factor_result * deviation_TSV[i_m][0][i_q][i_s][i_r][i_f];
	outfile_selection << temp_ss.str() << endline;
      }
    }
  }
  outfile_selection.close();

  logger.finished();
}


void summary_contribution::output_plot_qTcut_TSV(){
  static Logger logger("summary_contribution::output_plot_qTcut_TSV");
  logger.called();

  int start_i_m = 0;
  //  for (int i_m = start_i_m; i_m < osi->n_moments; i_m++){
  for (int i_m = start_i_m; i_m < 1; i_m++){
    for (int i_s = 0; i_s < osi->n_extended_set_TSV; i_s++){
      if (!ygeneric->switch_output_scaleset[i_s]){continue;}
      if (ygeneric->switch_output_complete){output_selection_plot_qTcut_TSV("complete", i_m, i_s);}
      if (ygeneric->switch_output_ren){output_selection_plot_qTcut_TSV("ren", i_m, i_s);}
      if (ygeneric->switch_output_fact){output_selection_plot_qTcut_TSV("fact", i_m, i_s);}
      if (ygeneric->switch_output_equal){output_selection_plot_qTcut_TSV("equal", i_m, i_s);}
      if (ygeneric->switch_output_antipodal){output_selection_plot_qTcut_TSV("antipodal", i_m, i_s);}
      if (ygeneric->switch_output_7point){output_selection_plot_qTcut_TSV("7-point", i_m, i_s);}
      if (ygeneric->switch_output_9point){output_selection_plot_qTcut_TSV("9-point", i_m, i_s);}
    }
  }

  logger.finished();
}


void summary_contribution::output_selection_plot_qTcut_TSV(string selection, int i_m, int i_s){
  static Logger logger("summary_contribution::output_selection_plot_qTcut_TSV");
  logger.called();

  string filename_selection;
  ofstream outfile_selection;
  filename_selection = "" + ygeneric->final_resultdirectory + "/" + osi->name_extended_set_TSV[i_s] + "/" + selection + "/" + ylist->resultdirectory + "/plot" + ygeneric->infix_name_moment[i_m] + ".qTcut." + infix_order_contribution + ".dat";
  if (Log::getLogThreshold() <= LOG_DEBUG){ logger << LOG_DEBUG << "filename_selection = " << filename_selection << endline_flush; }

  outfile_selection.open(filename_selection.c_str(), ofstream::out | ofstream::trunc);
  outfile_selection << left << setw(15) << "#qTcut";
  for (int i_r = 0; i_r < osi->n_scale_ren_TSV[i_s]; i_r++){
    for (int i_f = 0; i_f < osi->n_scale_fact_TSV[i_s]; i_f++){
      if (!ygeneric->output_selection_scale_check_TSV(selection, i_s, i_r, i_f)){continue;}
      outfile_selection << left << setw(30) << ygeneric->scalelabel_xi_R_F_TSV[i_s][i_r][i_f];
    }
  }
  outfile_selection << ygeneric->scalelabel_mu_R_F_TSV[i_s] << endline;

  if (!active_qTcut){
    outfile_selection << setw(15) << "0";
    for (int i_r = 0; i_r < osi->n_scale_ren_TSV[i_s]; i_r++){
      for (int i_f = 0; i_f < osi->n_scale_fact_TSV[i_s]; i_f++){
	if (!ygeneric->output_selection_scale_check_TSV(selection, i_s, i_r, i_f)){continue;}
	stringstream temp_ss;
	temp_ss << left << setprecision(8) << setw(15) << osi->unit_factor_result * result_TSV[i_m][0][0][i_s][i_r][i_f];
	temp_ss << left << setprecision(8) << setw(15) << osi->unit_factor_result * deviation_TSV[i_m][0][0][i_s][i_r][i_f];
	outfile_selection << temp_ss.str();
      }
    }
    outfile_selection << endline;
  }
  for (int i_q = 0; i_q < osi->n_qTcut; i_q++){
    int x_q = 0;
    if (active_qTcut){ x_q = i_q; }
    outfile_selection << setw(15) << osi->value_qTcut[i_q];
    for (int i_r = 0; i_r < osi->n_scale_ren_TSV[i_s]; i_r++){
      for (int i_f = 0; i_f < osi->n_scale_fact_TSV[i_s]; i_f++){
	if (!ygeneric->output_selection_scale_check_TSV(selection, i_s, i_r, i_f)){continue;}
	stringstream temp_ss;
	temp_ss << left << setprecision(8) << setw(15) << osi->unit_factor_result * result_TSV[i_m][0][x_q][i_s][i_r][i_f];
	temp_ss << left << setprecision(8) << setw(15) << osi->unit_factor_result * deviation_TSV[i_m][0][x_q][i_s][i_r][i_f];
	outfile_selection << temp_ss.str();
      }
    }
    outfile_selection << endline;
  }
  outfile_selection.close();

  logger.finished();
}


void summary_contribution::output_plot_TSV(){
  static Logger logger("summary_contribution::output_plot_TSV");
  logger.called();

  if (active_qTcut && osi->n_qTcut > 1){
    if (ygeneric->switch_output_qTcut < 3){ output_plot_qTcut_TSV(); }
    return;
  }
  
  int start_i_m = 0; // temporary !!!
  for (int i_m = start_i_m; i_m < osi->n_moments; i_m++){
    for (int i_s = 0; i_s < osi->n_extended_set_TSV; i_s++){
      if (!ygeneric->switch_output_scaleset[i_s]){continue;}

      if (ygeneric->switch_output_complete){output_selection_plot_TSV("complete", i_m, i_s);}
      if (ygeneric->switch_output_ren){output_selection_plot_TSV("ren", i_m, i_s);}
      if (ygeneric->switch_output_fact){output_selection_plot_TSV("fact", i_m, i_s);}
      if (ygeneric->switch_output_equal){output_selection_plot_TSV("equal", i_m, i_s);}
      if (ygeneric->switch_output_antipodal){output_selection_plot_TSV("antipodal", i_m, i_s);}
      if (ygeneric->switch_output_7point){output_selection_plot_TSV("7-point", i_m, i_s);}
      if (ygeneric->switch_output_9point){output_selection_plot_TSV("9-point", i_m, i_s);}
    }
  }

  logger.finished();
}


void summary_contribution::output_selection_plot_TSV(string selection, int i_m, int i_s){
  static Logger logger("summary_contribution::output_selection_plot_TSV");
  logger.called();

  string filename_selection;
  ofstream outfile_selection;
  filename_selection =  "" + ygeneric->final_resultdirectory + "/" + osi->name_extended_set_TSV[i_s] + "/" + selection + "/" + ylist->resultdirectory + "/plot" + ygeneric->infix_name_moment[i_m] + "." + infix_order_contribution + ".dat";
  outfile_selection.open(filename_selection.c_str(), ofstream::out | ofstream::trunc);
  outfile_selection << left << setw(15) << "#qTcut";
  for (int i_r = 0; i_r < osi->n_scale_ren_TSV[i_s]; i_r++){
    for (int i_f = 0; i_f < osi->n_scale_fact_TSV[i_s]; i_f++){
      if (!ygeneric->output_selection_scale_check_TSV(selection, i_s, i_r, i_f)){continue;}
      outfile_selection << left << setw(30) << ygeneric->scalelabel_xi_R_F_TSV[i_s][i_r][i_f]; 
    }
  }
  outfile_selection << ygeneric->scalelabel_mu_R_F_TSV[i_s] << endline;
  outfile_selection << setw(15) << "0";
  for (int i_r = 0; i_r < osi->n_scale_ren_TSV[i_s]; i_r++){
    for (int i_f = 0; i_f < osi->n_scale_fact_TSV[i_s]; i_f++){
      if (!ygeneric->output_selection_scale_check_TSV(selection, i_s, i_r, i_f)){continue;}
      stringstream temp_ss;
      temp_ss << left << setprecision(8) << setw(15) << osi->unit_factor_result * result_TSV[i_m][0][0][i_s][i_r][i_f];
      temp_ss << left << setprecision(8) << setw(15) << osi->unit_factor_result * deviation_TSV[i_m][0][0][i_s][i_r][i_f];
      outfile_selection << temp_ss.str();
    }
  }
  outfile_selection << endline;
  outfile_selection.close();
	
  logger.finished();
}





// All functions below are only relevant for CV variation:

void summary_contribution::output_result_overview_qTcut_CV(){
  static Logger logger("summary_contribution::output_result_overview_qTcut_CV");
  logger.called();

  string filename;
  string signame = "XS_" + infix_order_contribution;
  string dsigname = "dXS_" + infix_order_contribution;

  stringstream muscale_ss;
  muscale_ss << setprecision(6) << osi->scale_ren;
  string muscale = muscale_ss.str();

  stringstream temp_ss_separation_one;
  stringstream temp_ss_separation_two;
  int counter_separation = 15 + 15 + 15 + 25 + 15 + 4 + 15 + 3 + 10 + 3 + 5 + 3 + 9;
  for (int i_x = 0; i_x < counter_separation; i_x++){
    temp_ss_separation_one << "-";
    temp_ss_separation_two << "=";
  }

  int start_i_m = 0; // temporary !!!
  for (int i_m = start_i_m; i_m < osi->n_moments; i_m++){
    ofstream outfile_result;
    filename = "" + ygeneric->final_resultdirectory + "/CV/" + ygeneric->name_variation_CV + "/" + ylist->resultdirectory + "/overview" + ygeneric->infix_name_moment[i_m] + "." + infix_order_contribution + ".dat";

    logger << LOG_DEBUG << "FILENAME:   " << filename << endline_flush;

    outfile_result.open(filename.c_str(), ofstream::out | ofstream::trunc);

    stringstream name_ss;
    name_ss << "dXS +- err (subprocess)";

    stringstream header_ss;
    header_ss << left
	      << setw(15) << "qTcut"
	      << setw(5) << "mu_R/" << setw(10) << "CV"
	      << setw(5) << "mu_F/" << setw(10) << "CV"
	      << setw(25) << "subprocess"
	      << right << setw(34) << name_ss.str()
	      << "   "
	      << right << setw(10) << "chi2_dof"
	      << "   "
	      << right << setw(5) << "n_run"
	      << "   "
	      << setw(9) << "(removed)";

    for (int i_q = 0; i_q < output_n_qTcut; i_q++){
      outfile_result << header_ss.str() << endline;
      outfile_result << endline;
      for (int i_s = 0; i_s < osi->n_scales_CV; i_s++){
	int temp_size_result = int(log10(abs(osi->unit_factor_result * xsubprocess[0]->result_CV[i_q][i_s])));
	for (int i_p = 0; i_p < subprocess.size(); i_p++){
	  int temp_size_result_c = int(log10(abs(osi->unit_factor_result * xsubprocess[i_p]->result_CV[i_q][i_s])));
	  if (temp_size_result_c > temp_size_result){temp_size_result = temp_size_result_c;}
	}
	int temp_size_deviation = int(log10(abs(osi->unit_factor_result * xsubprocess[0]->deviation_CV[i_q][i_s])));
	if (osi->unit_factor_result * xsubprocess[0]->deviation_CV[i_q][i_s] >= 1.){temp_size_deviation++;}

	for (int i_p = 0; i_p < subprocess.size(); i_p++){
	  int temp_size_result_subprocess = int(log10(abs(osi->unit_factor_result * xsubprocess[i_p]->result_CV[i_q][i_s])));
	  int temp_size_deviation_subprocess = int(log10(abs(osi->unit_factor_result * xsubprocess[i_p]->deviation_CV[i_q][i_s])));
	  if (osi->unit_factor_result * xsubprocess[i_p]->deviation_CV[i_q][i_s] >= 1.){temp_size_deviation_subprocess++;}
	  if (xsubprocess[i_p]->result_CV[i_q][i_s] == 0){temp_size_result_subprocess = 0;}
	  if (xsubprocess[i_p]->deviation_CV[i_q][i_s] == 0){temp_size_deviation_subprocess = 0;}
	  int setw_result = 9 + temp_size_result_subprocess - temp_size_result;
	  int setw_deviation = 9 + temp_size_deviation_subprocess - temp_size_deviation - (temp_size_result - temp_size_deviation + 1);
	  if (xsubprocess[i_p]->result_CV[i_q][i_s] == 0.){setw_result = 1; setw_deviation = 1;}
	  else if (abs(osi->unit_factor_result * xsubprocess[i_p]->result_CV[i_q][i_s]) < 1.){setw_result--;}

	  stringstream temp_ss;
	  temp_ss << left;
	  if (active_qTcut){temp_ss << setw(15) << setprecision(8) << osi->value_qTcut[i_q];}
	  temp_ss << setw(15) << setprecision(8) << osi->rel_scale_factor_ren_CV[i_s]
		  << setw(15) << setprecision(8) << osi->rel_scale_factor_fact_CV[i_s];
	  if (i_p == 0){temp_ss << setw(25) << infix_order_contribution;}
	  else {temp_ss << setw(25) << subprocess[i_p];}
	  temp_ss << showpoint
		  << right << setw(15) << setprecision(setw_result) << osi->unit_factor_result * xsubprocess[i_p]->result_CV[i_q][i_s]
		  << " +- "
		  << right << setw(15) << setprecision(setw_deviation) << osi->unit_factor_result * xsubprocess[i_p]->deviation_CV[i_q][i_s];
	  if (i_p == 0){temp_ss << setw(3 + 10 + 3 + 5 + 9);}
	  else {
	    temp_ss << "   "
		    << right << showpoint << setprecision(4) << setw(10) << xsubprocess[i_p]->chi2_CV[i_q][i_s]
		    << "   "
		    << setw(5) << right << xsubprocess[i_p]->n_parallel_runs_CV[i_q][i_s]
	      //		    << setw(5) << right << xsubprocess[i_p]->no_results
		    << "   "
		    << "   (" << setw(4) << right << accumulate(xsubprocess[i_p]->remove_run_qTcut_CV[i_q].begin(), xsubprocess[i_p]->remove_run_qTcut_CV[i_q].end(), 0) << ")";
	  }

	  outfile_result << temp_ss.str() << endline;

	  if (i_p == 0){
	    outfile_result << temp_ss_separation_one.str() << endline;
	  }
	}
	outfile_result << endline;
      }
      outfile_result << temp_ss_separation_two.str() << endl << endline;
    }
    outfile_result.close();
  }

  logger.finished();
}


void summary_contribution::output_result_qTcut_CV(){
  static Logger logger("summary_contribution::output_result_qTcut_CV");
  logger.called();

  string filename;
  ofstream outfile;

  int start_i_m = 0;
  for (int i_m = start_i_m; i_m < osi->n_moments; i_m++){
    filename = "" + ygeneric->final_resultdirectory + "/CV/" + ygeneric->name_variation_CV + "/" + ylist->resultdirectory + "/result" + ygeneric->infix_name_moment[i_m] + "." + infix_order_contribution + ".dat";

    logger << LOG_DEBUG << "FILENAME:   " << filename << endline_flush;

    outfile.open(filename.c_str(), ofstream::out | ofstream::trunc);

    stringstream name_ss;
    name_ss << "dXS +- err (" << infix_order_contribution << ")";

    stringstream header_ss;
    header_ss << left
	      << setw(15) << "qTcut"
	      << setw(5) << "mu_R/" << setw(10) << "CV"
	      << setw(5) << "mu_F/" << setw(10) << "CV"
	      << setw(34) << name_ss.str();

    outfile << header_ss.str() << endline;

    for (int i_q = 0; i_q < output_n_qTcut; i_q++){
      outfile << endline;
      for (int i_s = 0; i_s < osi->n_scales_CV; i_s++){
	stringstream temp_ss;
	temp_ss << noshowpoint << left;
	if (active_qTcut){temp_ss << setw(15) << osi->value_qTcut[i_q];}
	else {outfile << setw(15) << "independent";}
	temp_ss << setw(15) << setprecision(8) << osi->rel_scale_factor_ren_CV[i_s]
		<< setw(15) << setprecision(8) << osi->rel_scale_factor_fact_CV[i_s]
		<< showpoint
		<< setprecision(8) << setw(15) << osi->unit_factor_result * result_CV[i_m][0][i_q][i_s]
		<< " +- "
		<< setprecision(8) << setw(15) << osi->unit_factor_result * deviation_CV[i_m][0][i_q][i_s];
	outfile << temp_ss.str() << endline;
      }
    }
  }
  outfile.close();

  logger.finished();
}


void summary_contribution::output_result_plot_qTcut_CV(){
  static Logger logger("summary_contribution::output_result_plot_qTcut_CV");
  logger.called();

  string filename;

  int start_i_m = 0;
  for (int i_m = start_i_m; i_m < 1; i_m++){
    //  for (int i_m = start_i_m; i_m < osi->n_moments; i_m++){
    ofstream outfile;
    ///////////////////////////////////////////////////////////////////
    //  subprocess qTcut output for CV variation (all qTcut values)  //
    ///////////////////////////////////////////////////////////////////
    filename = "" + ygeneric->final_resultdirectory + "/CV/" + ygeneric->name_variation_CV + "/" + ylist->resultdirectory + "/" + "/plot" + ygeneric->infix_name_moment[i_m] + ".qTcut." + infix_order_contribution + ".dat";

    logger << LOG_DEBUG << "FILENAME:   " << filename << endline_flush;

    outfile.open(filename.c_str(), ofstream::out | ofstream::trunc);
    outfile << showpoint;
    outfile << left << setw(15) << "# qTcut";
    for (int i_s = 0; i_s < osi->n_scales_CV; i_s++){
      stringstream temp_ss;
      temp_ss << "mu_R = " << setprecision(2) << setw(4) << i_s
	      << " -- "
	      << "mu_F = " << setw(4) << i_s
	      << "    ";
      outfile << setw(30) << temp_ss.str() << left;
    }
    outfile << endline;
    for (int i_q = 0; i_q < osi->n_qTcut; i_q++){
      outfile << noshowpoint << left << setw(15) << setprecision(4) << osi->value_qTcut[i_q];
      for (int i_s = 0; i_s < osi->n_scales_CV; i_s++){
	outfile << showpoint
		<< setw(15) << setprecision(8) << osi->unit_factor_result * result_CV[i_m][0][i_q][i_s]
		<< setw(15) << setprecision(8) << osi->unit_factor_result * deviation_CV[i_m][0][i_q][i_s];
      }
      outfile << endline;
    }
    outfile.close();
  }

  logger.finished();
}





// contains actually subprocess output !!!

void summary_contribution::output_subprocesses_result_plot_qTcut_CV(){
  static Logger logger("summary_contribution::output_subprocesses_result_plot_qTcut_CV");
  logger.called();

  string filename;

  int start_i_m = 0;
  for (int i_m = start_i_m; i_m < osi->n_moments; i_m++){
    ofstream outfile_subprocess;
    ///////////////////////////////////////////////////////////////////
    //  subprocess qTcut output for CV variation (all qTcut values)  //
    ///////////////////////////////////////////////////////////////////
    for (int i_p = 1; i_p < subprocess.size(); i_p++){
      filename = "" + ygeneric->final_resultdirectory + "/CV/" + ygeneric->name_variation_CV + "/" + ylist->resultdirectory + "/" + infix_contribution + "/plot" + ygeneric->infix_name_moment[i_m] + ".qTcut." + subprocess[i_p] + ".dat";

      logger << LOG_DEBUG << "FILENAME:   " << filename << endline_flush;

      outfile_subprocess.open(filename.c_str(), ofstream::out | ofstream::trunc);
      outfile_subprocess << showpoint;
      outfile_subprocess << left << setw(15) << "# qTcut";
      for (int i_s = 0; i_s < osi->n_scales_CV; i_s++){
	stringstream temp_ss;
	temp_ss << "mu_R = " << setprecision(2) << setw(4) << i_s
	  //	showpoint << 
		<< " -- "
		<< "mu_F = " << setw(4) << i_s
	  //    showpoint << 
		<< "    ";
	outfile_subprocess << setw(30) << temp_ss.str() << left;
	//	outfile_subprocess << "mu_R @ " << right << setprecision(2) << setw(4) << showpoint << i_s << " -- " << "mu_F @ " << setw(4) << showpoint << i_s << "    ";
      }
      outfile_subprocess << endline;
      //      outfile_subprocess << showpoint;
      for (int i_q = 0; i_q < osi->n_qTcut; i_q++){
	outfile_subprocess << noshowpoint << left << setw(15) << setprecision(4) << osi->value_qTcut[i_q];
	for (int i_s = 0; i_s < osi->n_scales_CV; i_s++){
	  outfile_subprocess
	    << showpoint << setw(15) << setprecision(8) << osi->unit_factor_result * xsubprocess[i_p]->result_CV[i_q][i_s]
	    << setw(15) << setprecision(8) << osi->unit_factor_result * xsubprocess[i_p]->deviation_CV[i_q][i_s];
	}
	outfile_subprocess << endline;
      }
      outfile_subprocess.close();
    }
  }

  logger.finished();
}





void summary_contribution::output_result_plot_CV(){
  static Logger logger("summary_contribution::output_result_plot_CV");
  logger.called();

  string filename;

  vector<double> rel_scale_CV(osi->n_scales_CV);
  vector<double> scale_CV(osi->n_scales_CV);
  logger << LOG_DEBUG << "osi->n_scales_CV = " << osi->n_scales_CV << endline_flush;
  for (int i_s = 0; i_s < osi->n_scales_CV; i_s++){
    if (osi->n_scales_CV > 1){rel_scale_CV[i_s] = pow(10,log10(double(osi->variation_factor_CV)) * double(2. * i_s / (osi->n_scales_CV - 1) - 1));}
    else {rel_scale_CV[i_s] = 1;}
    scale_CV[i_s] = rel_scale_CV[i_s] * osi->scale_ren;
  }

  int start_i_m = 0;
  for (int i_m = start_i_m; i_m < osi->n_moments; i_m++){
    ofstream outfile_subprocess;
    ////////////////////////////////////////////////////////////////
    //  subprocess output for CV variation (osi->min_qTcut value)  //
    ////////////////////////////////////////////////////////////////
    logger.newLine(LOG_DEBUG);
    logger << LOG_DEBUG << "subprocess output for CV variation (osi->min_qTcut value)" << endline_flush;
    filename = "" + ygeneric->final_resultdirectory + "/CV/" + ygeneric->name_variation_CV + "/" + ylist->resultdirectory + "/" + "/plot" + ygeneric->infix_name_moment[i_m] + ".CV." + infix_order_contribution + ".dat";

    logger << LOG_DEBUG << "FILENAME:   " << filename << endline_flush;

    outfile_subprocess.open(filename.c_str(), ofstream::out | ofstream::trunc);
    outfile_subprocess << showpoint;
    int i_q = 0;
    for (int i_s = 0; i_s < osi->n_scales_CV; i_s++){
      outfile_subprocess << setw(15) << setprecision(8) << rel_scale_CV[i_s]
			 << setw(15) << setw(15) << setprecision(8) << osi->unit_factor_result * result_CV[i_m][0][i_q][i_s]
			 << setw(15) << setprecision(8) << osi->unit_factor_result * deviation_CV[i_m][0][i_q][i_s] << endline;
    }
    outfile_subprocess.close();
  }

  logger.finished();
}





// contains actually subprocess output !!!

void summary_contribution::output_subprocesses_result_plot_CV(){
  //string result_moment, int x_m
  static Logger logger("summary_contribution::output_subprocesses_result_plot_CV");
  logger.called();

  string filename;


  vector<double> rel_scale_CV(osi->n_scales_CV);
  vector<double> scale_CV(osi->n_scales_CV);
  logger << LOG_DEBUG << "osi->n_scales_CV = " << osi->n_scales_CV << endline_flush;
  for (int i_s = 0; i_s < osi->n_scales_CV; i_s++){
    if (osi->n_scales_CV > 1){rel_scale_CV[i_s] = pow(10,log10(double(osi->variation_factor_CV)) * double(2. * i_s / (osi->n_scales_CV - 1) - 1));}
    else {rel_scale_CV[i_s] = 1;}
    scale_CV[i_s] = rel_scale_CV[i_s] * osi->scale_ren;
  }


  int start_i_m = 0;
  for (int i_m = start_i_m; i_m < osi->n_moments; i_m++){
    //  if ((x_m == 0 || x_m == osi->n_moments)){
      ofstream outfile_subprocess;
      ////////////////////////////////////////////////////////////////
      //  subprocess output for CV variation (osi->min_qTcut value)  //
      ////////////////////////////////////////////////////////////////
      logger.newLine(LOG_DEBUG);
      logger << LOG_DEBUG << "subprocess output for CV variation (osi->min_qTcut value)" << endline_flush;
      for (int i_p = 1; i_p < subprocess.size(); i_p++){
	/*
	if (x_m == osi->n_moments){filename = "" + ygeneric->final_resultdirectory + "/CV/" + ygeneric->name_variation_CV + "/" + ylist->resultdirectory + "/" + infix_contribution + "/plot.CV." + subprocess[i_p] + ".dat";}
	else {filename = "" + ygeneric->final_resultdirectory + "/CV/" + ygeneric->name_variation_CV + "/" + ylist->resultdirectory + "/" + infix_contribution + "/plot" + ygeneric->infix_name_moment[i_m] + ".CV." + subprocess[i_p] + ".dat";}
	*/
	filename = "" + ygeneric->final_resultdirectory + "/CV/" + ygeneric->name_variation_CV + "/" + ylist->resultdirectory + "/" + infix_contribution + "/plot" + ygeneric->infix_name_moment[i_m] + ".CV." + subprocess[i_p] + ".dat";
	logger << LOG_DEBUG << "XXX filename = " << filename << endline_flush;
	logger << LOG_DEBUG << "Output: xfilename = " << filename << endline_flush;
	outfile_subprocess.open(filename.c_str(), ofstream::out | ofstream::trunc);
	outfile_subprocess << showpoint;
	int i_q = 0;
	for (int i_s = 0; i_s < osi->n_scales_CV; i_s++){
	  outfile_subprocess << setw(15) << setprecision(8) << rel_scale_CV[i_s] << setw(15) << setw(15) << setprecision(8) << osi->unit_factor_result * xsubprocess[i_p]->result_CV[i_q][i_s] << setw(15) << setprecision(8) << osi->unit_factor_result * xsubprocess[i_p]->deviation_CV[i_q][i_s] << endline;
	}
	outfile_subprocess.close();
      }
      logger << LOG_DEBUG << "output osi->min_qTcut variation - each subprocess finished" << endline_flush;

  }

  logger.finished();
}




/*
void summary_contribution::output_result_check_CV(){
  //string result_moment, int x_m
  static Logger logger("summary_contribution::output_check_CV");
  logger.called();

  int start_i_m = 0;
  for (int i_m = start_i_m; i_m < osi->n_moments; i_m++){
    //  if ((x_m == 0 || x_m == osi->n_moments)){// || (infix_order_contribution == "LO")){
    //    logger << LOG_DEBUG << "n_subprocess = " << n_subprocess << endline_flush;
    //    logger << LOG_DEBUG << "result_subprocess.size() = " << result_subprocess.size() << endline_flush;
    //    logger << LOG_DEBUG << "deviation_subprocess.size() = " << deviation_subprocess.size() << endline_flush;

    ofstream outfile_check;
    string filename;
    string signame = "XS_" + infix_order_contribution;
    string dsigname = "dXS_" + infix_order_contribution;

    //////////////////////////////////////////
    //  subprocess-wise check output begin  //
    //////////////////////////////////////////
    filename = "" + ygeneric->final_resultdirectory + "/CV/" + ygeneric->name_variation_CV + "/" + ylist->resultdirectory + "/" + infix_contribution + "/check" + ygeneric->infix_name_moment[i_m] + "." + infix_order_contribution + ".dat";
    logger << LOG_DEBUG << "XXX filename = " << filename << endline_flush;
    // + infix_order_contribution + "
    outfile_check.open(filename.c_str(), ofstream::out | ofstream::trunc);
    outfile_check << showpoint;
    for (int i_p = 1; i_p < subprocess.size(); i_p++){
      outfile_check << subprocess[i_p] << endl << endline;
      outfile_check << setw(15) << setprecision(8) << osi->unit_factor_result * xsubprocess[i_p]->result << setw(15) << setprecision(8) << osi->unit_factor_result * xsubprocess[i_p]->deviation << endline;

      logger << LOG_DEBUG << "result_subprocess_CV[" << i_p << "][0][" << osi->no_central_scale_CV << "] = " << xsubprocess[i_p]->result_CV[0][osi->no_central_scale_CV] << endline_flush;
      if (osi->n_qTcut != 0){outfile_check << setw(15) << setprecision(8) << osi->unit_factor_result * xsubprocess[i_p]->result_CV[0][osi->no_central_scale_CV] << setw(15) << setprecision(8) << osi->unit_factor_result * xsubprocess[i_p]->deviation_CV[0][osi->no_central_scale_CV] << setw(8) << setprecision(2) << endline;}
      outfile_check << endline;
    }
    stringstream muscale_ss;
    muscale_ss << setprecision(6) << osi->scale_ren;
    string muscale = muscale_ss.str();
    /*
    vector<double> rel_scale_CV(osi->n_scales_CV);
    vector<double> scale_CV(osi->n_scales_CV);
    logger << LOG_DEBUG << "osi->n_scales_CV = " << osi->n_scales_CV << endline_flush;
    for (int i_s = 0; i_s < osi->n_scales_CV; i_s++){
      if (osi->n_scales_CV > 1){rel_scale_CV[i_s] = pow(10,log10(double(osi->variation_factor_CV)) * double(2. * i_s / (osi->n_scales_CV - 1) - 1));}
      else {rel_scale_CV[i_s] = 1;}
      scale_CV[i_s] = rel_scale_CV[i_s] * osi->scale_ren;
    }
*//*
  }

  logger.finished();
}
  */


