#include "header.hpp"

void summary_generic::output_distribution_initialization_file_reduction_TSV(string & name_result, string & subdirectory, string & identifier, int selection_n_qTcut){
  static Logger logger("summary_generic::output_distribution_initialization_file_reduction_TSV");
  logger.called();

  for (int i_s = 0; i_s < osi->n_extended_set_TSV; i_s++){
    if (!switch_output_scaleset[i_s]){continue;}
    if (!osi->switch_distribution_TSV[i_s]){continue;}
    for (int i_r = 0; i_r < osi->n_scale_ren_TSV[i_s]; i_r++){
      for (int i_f = 0; i_f < osi->n_scale_fact_TSV[i_s]; i_f++){
	if (switch_output_only_reference_scale && (i_s != osi->no_reference_TSV || i_r != osi->no_scale_ren_reference_TSV || i_f != osi->no_scale_fact_reference_TSV)){continue;}
	if (selection_n_qTcut > 1){
	//	output_rcut_sddistribution_TSV
	  int flag = 0;
	  for (int i_d = 0; i_d < osi->extended_distribution.size(); i_d++){
	    if (!switch_output_distribution[i_d]){ continue; }
	    for (size_t i_f = 0; i_f < output_distribution_format[i_d].size(); i_f++){
	      if (output_distribution_format[i_d][i_f] == identifier){ flag = 1; break; }
	    }
	    if (flag){ break; }
	  }
	  if (flag){
	    string filename_distribution_plot = "rcut." + identifier + ".." + name_result + ".dat";
	    // subdirectory should contain the complete path between scalepath_TSV[i_s][i_r][i_f]  and  "/" + filename_distribution_plot;
	    string filepath_distribution_plot = scalepath_TSV[i_s][i_r][i_f] + subdirectory + "/" + filename_distribution_plot;
	    logger << LOG_DEBUG_VERBOSE << "filepath_distribution_plot = " << filepath_distribution_plot << endline_flush;
	    ofstream out_plotfile;
	    out_plotfile.open(filepath_distribution_plot.c_str(), ofstream::out | ofstream::trunc);
	    out_plotfile.close();
	  }
	}

	output_distribution_initialization_file_reduction_scale_TSV(name_result, subdirectory, identifier, i_s, i_r, i_f);
      }
    }
  }

  logger.finished();
}


void summary_generic::output_distribution_initialization_file_reduction_qTcut_TSV(string & name_result, string & subdirectory, string & identifier, int selection_n_qTcut){
  static Logger logger("summary_generic::output_distribution_initialization_file_reduction_qTcut_TSV");
  logger.called();

  vector<string> subdirectory_qTcut(selection_n_qTcut, "");
  if (selection_n_qTcut > 1){
    for (int x_q = 0; x_q < selection_n_qTcut; x_q++){
      stringstream qTcut_ss;
      qTcut_ss << "qTcut-" << osi->value_qTcut_distribution[x_q];
      subdirectory_qTcut[x_q] = subdirectory + "/" + qTcut_ss.str();
    }
  }
  else if (selection_n_qTcut == 1){ subdirectory_qTcut[0] = subdirectory; }
  else { logger << LOG_FATAL << "selection_n_qTcut = " << selection_n_qTcut << " is not a valid value." << endline_flush; exit(1); }

  for (int i_s = 0; i_s < osi->n_extended_set_TSV; i_s++){
    if (!switch_output_scaleset[i_s]){continue;}
    if (!osi->switch_distribution_TSV[i_s]){continue;}
    for (int i_r = 0; i_r < osi->n_scale_ren_TSV[i_s]; i_r++){
      for (int i_f = 0; i_f < osi->n_scale_fact_TSV[i_s]; i_f++){
	if (switch_output_only_reference_scale && (i_s != osi->no_reference_TSV || i_r != osi->no_scale_ren_reference_TSV || i_f != osi->no_scale_fact_reference_TSV)){continue;}
	for (int x_q = 0; x_q < selection_n_qTcut; x_q++){ output_distribution_initialization_file_reduction_scale_TSV(name_result, subdirectory_qTcut[x_q], identifier, i_s, i_r, i_f); }
      }
    }
  }

  logger.finished();
}


void summary_generic::output_distribution_initialization_file_reduction_scale_TSV(string & name_result, string & subdirectory, string & identifier, int i_s, int i_r, int i_f){
  static Logger logger("summary_generic::output_distribution_initialization_file_reduction_scale_TSV");
  logger.called();

  //  output_distribution_TSV
  int flag = 0;
  for (int i_d = 0; i_d < osi->extended_distribution.size(); i_d++){
    if (!switch_output_distribution[i_d]){ continue; }
    for (size_t i_f = 0; i_f < output_distribution_format[i_d].size(); i_f++){
      if (output_distribution_format[i_d][i_f] == identifier){ flag = 1; break; }
    }
    if (flag){ break; }
  }
  if (flag){
    string filename_distribution_plot = identifier + ".." + name_result + ".dat";
    string filepath_distribution_plot = scalepath_TSV[i_s][i_r][i_f] + subdirectory + "/" + filename_distribution_plot;
    logger << LOG_DEBUG_VERBOSE << "filepath_distribution_plot = " << filepath_distribution_plot << endline_flush;
    ofstream out_plotfile;
    out_plotfile.open(filepath_distribution_plot.c_str(), ofstream::out | ofstream::trunc);
    out_plotfile.close();
  }

  //  output_sddistribution_TSV
  flag = 0;
  for (int i_d = 0; i_d < osi->extended_distribution.size(); i_d++){
    if (!switch_output_distribution[i_d]){ continue; }
    for (size_t i_f = 0; i_f < output_distribution_format[i_d].size(); i_f++){
      if (output_distribution_format[i_d][i_f] == "1dd." + identifier){ flag = 1; break; }
    }
    if (flag){ break; }
  }
  if (flag){
    string filename_distribution_plot = "1dd." + identifier + ".." + name_result + ".dat";
    string filepath_distribution_plot = scalepath_TSV[i_s][i_r][i_f] + subdirectory + "/" + filename_distribution_plot;
    logger << LOG_DEBUG_VERBOSE << "filepath_distribution_plot = " << filepath_distribution_plot << endline_flush;
    ofstream out_plotfile;
    out_plotfile.open(filepath_distribution_plot.c_str(), ofstream::out | ofstream::trunc);
    out_plotfile.close();
  }

  //  output_dddistribution_TSV
  flag = 0;
  for (int i_d = 0; i_d < osi->extended_distribution.size(); i_d++){
    if (!switch_output_distribution[i_d]){ continue; }
    for (size_t i_f = 0; i_f < output_distribution_format[i_d].size(); i_f++){
      if (output_distribution_format[i_d][i_f] == "2dd." + identifier){flag = 1; break;}
    }
    if (flag){ break; }
  }
  if (flag){
    string filename_distribution_plot = "2dd." + identifier + ".." + name_result + ".dat";
    string filepath_distribution_plot = scalepath_TSV[i_s][i_r][i_f] + subdirectory + "/" + filename_distribution_plot;
    logger << LOG_DEBUG_VERBOSE << "filepath_distribution_plot = " << filepath_distribution_plot << endline_flush;
    ofstream out_plotfile;
    out_plotfile.open(filepath_distribution_plot.c_str(), ofstream::out | ofstream::trunc);
    out_plotfile.close();
  }
	  
  //  output_dddistribution_reconstruct_first_sdd_TSV
  //  output_dddistribution_reconstruct_second_sdd_TSV
  flag = 0;
  for (int i_d = 0; i_d < osi->extended_distribution.size(); i_d++){
    if (!switch_output_distribution[i_d]){ continue; }
    for (size_t i_f = 0; i_f < output_distribution_format[i_d].size(); i_f++){
      if (output_distribution_format[i_d][i_f] == "2dd.rec." + identifier ||
	  output_distribution_format[i_d][i_f] == "2dd.rec_in_first." + identifier ||
	  output_distribution_format[i_d][i_f] == "2dd.rec_in_second." + identifier ||
	  output_distribution_format[i_d][i_f] == "2dd.reconstruct." + identifier ||
	  output_distribution_format[i_d][i_f] == "2dd.reconstruct_in_first." + identifier ||
	  output_distribution_format[i_d][i_f] == "2dd.reconstruct_in_second." + identifier){flag = 1; break;}
    }
    if (flag){ break; }
  }
  if (flag){
    string filename_distribution_plot = "2dd.rec." + identifier + ".." + name_result + ".dat";
    string filepath_distribution_plot = scalepath_TSV[i_s][i_r][i_f] + subdirectory + "/" + filename_distribution_plot;
    logger << LOG_DEBUG_VERBOSE << "filepath_distribution_plot = " << filepath_distribution_plot << endline_flush;
    ofstream out_plotfile;
    out_plotfile.open(filepath_distribution_plot.c_str(), ofstream::out | ofstream::trunc);
    out_plotfile.close();
  }
 
  //  output_dddistribution_ge_in_first_sdd_TSV
  //  output_dddistribution_ge_in_second_sdd_TSV
  flag = 0;
  for (int i_d = 0; i_d < osi->extended_distribution.size(); i_d++){
    if (!switch_output_distribution[i_d]){ continue; }
    for (size_t i_f = 0; i_f < output_distribution_format[i_d].size(); i_f++){
      if (output_distribution_format[i_d][i_f] == "2dd.ge." + identifier ||
	  output_distribution_format[i_d][i_f] == "2dd.ge_in_first." + identifier ||
	  output_distribution_format[i_d][i_f] == "2dd.ge_in_second." + identifier ||
	  output_distribution_format[i_d][i_f] == "2dd.ge_lt." + identifier ||
	  output_distribution_format[i_d][i_f] == "2dd.ge_lt_in_first." + identifier ||
	  output_distribution_format[i_d][i_f] == "2dd.ge_lt_in_second." + identifier){flag = 1; break;}
    }
    if (flag){ break; }
  }
  if (flag){
    string filename_distribution_plot = "2dd.ge." + identifier + ".." + name_result + ".dat";
    string filepath_distribution_plot = scalepath_TSV[i_s][i_r][i_f] + subdirectory + "/" + filename_distribution_plot;
    logger << LOG_DEBUG_VERBOSE << "filepath_distribution_plot = " << filepath_distribution_plot << endline_flush;
    ofstream out_plotfile;
    out_plotfile.open(filepath_distribution_plot.c_str(), ofstream::out | ofstream::trunc);
    out_plotfile.close();
  }

  //  output_dddistribution_lt_in_first_sdd_TSV
  //  output_dddistribution_lt_in_second_sdd_TSV
  flag = 0;
  for (int i_d = 0; i_d < osi->extended_distribution.size(); i_d++){
    if (!switch_output_distribution[i_d]){ continue; }
    for (size_t i_f = 0; i_f < output_distribution_format[i_d].size(); i_f++){
      if (output_distribution_format[i_d][i_f] == "2dd.lt." + identifier ||
	  output_distribution_format[i_d][i_f] == "2dd.lt_in_first." + identifier ||
	  output_distribution_format[i_d][i_f] == "2dd.lt_in_second." + identifier ||
	  output_distribution_format[i_d][i_f] == "2dd.ge_lt." + identifier ||
	  output_distribution_format[i_d][i_f] == "2dd.ge_lt_in_first." + identifier ||
	  output_distribution_format[i_d][i_f] == "2dd.ge_lt_in_second." + identifier){flag = 1; break;}
    }
    if (flag){ break; }
  }
  if (flag){
    string filename_distribution_plot_lt = "2dd.lt." + identifier + ".." + name_result + ".dat";
    string filepath_distribution_plot_lt = scalepath_TSV[i_s][i_r][i_f] + subdirectory + "/" + filename_distribution_plot_lt;
    logger << LOG_DEBUG_VERBOSE << "filepath_distribution_plot_lt = " << filepath_distribution_plot_lt << endline_flush;
    ofstream out_plotfile_lt;
    out_plotfile_lt.open(filepath_distribution_plot_lt.c_str(), ofstream::out | ofstream::trunc);
    out_plotfile_lt.close();
  }
   
  //  output_dddistribution_slice_in_first_sdd_TSV  
  //  output_dddistribution_slice_in_second_sdd_TSV
  flag = 0;
  for (int i_d = 0; i_d < osi->extended_distribution.size(); i_d++){
    if (!switch_output_distribution[i_d]){ continue; }
    for (size_t i_f = 0; i_f < output_distribution_format[i_d].size(); i_f++){
      if (output_distribution_format[i_d][i_f] == "2dd.slice." + identifier ||
	  output_distribution_format[i_d][i_f] == "2dd.slice_in_first." + identifier ||
	  output_distribution_format[i_d][i_f] == "2dd.slice_in_second." + identifier){flag = 1; break;}
    }
    if (flag){ break; }
  }
  if (flag){
    string filename_distribution_plot = "2dd.slice." + identifier + ".." + name_result + ".dat";
    string filepath_distribution_plot = scalepath_TSV[i_s][i_r][i_f] + subdirectory + "/" + filename_distribution_plot;
    logger << LOG_DEBUG_VERBOSE << "filepath_distribution_plot = " << filepath_distribution_plot << endline_flush;
    ofstream out_plotfile;
    out_plotfile.open(filepath_distribution_plot.c_str(), ofstream::out | ofstream::trunc);
    out_plotfile.close();
  }
 
  logger.finished();
}

void summary_generic::output_rcut_sddistribution_TSV(string & identifier, vector<vector<vector<vector<vector<double> > > > > & rcut_distribution_result_TSV, vector<vector<vector<vector<vector<double> > > > > & rcut_distribution_deviation_TSV, int i_d, string & name_result, string & subdirectory, int plotmode, vector<vector<vector<vector<double> > > > extrapolated_distribution_result_TSV, vector<vector<vector<vector<double> > > > extrapolated_distribution_deviation_TSV, vector<vector<vector<vector<double> > > > distribution_xmin_extrapolation_TSV, vector<vector<vector<vector<double> > > > distribution_xmax_extrapolation_TSV){
  //void summary_generic::output_rcut_sddistribution_TSV(string & identifier, vector<vector<vector<vector<vector<double> > > > > & rcut_distribution_result_TSV, vector<vector<vector<vector<vector<double> > > > > & rcut_distribution_deviation_TSV, int i_d, string & name_result, string & subdirectory, int plotmode){
  static Logger logger("summary_generic::output_rcut_sddistribution_TSV");
  logger.called();

  int flag = 0;
  for (size_t i_f = 0; i_f < output_distribution_format[i_d].size(); i_f++){
    if (output_distribution_format[i_d][i_f] == "1dd." + identifier){flag = 1; break;}
  }
  if (!flag){return;}

  ofstream out_plotfile;
  string filename_distribution_plot;
  string filepath_distribution_plot;

  for (int i_s = 0; i_s < osi->n_extended_set_TSV; i_s++){
    if (!switch_output_scaleset[i_s]){continue;}
    if (!osi->switch_distribution_TSV[i_s]){continue;}
    for (int i_r = 0; i_r < osi->n_scale_ren_TSV[i_s]; i_r++){
      for (int i_f = 0; i_f < osi->n_scale_fact_TSV[i_s]; i_f++){
	if (switch_output_only_reference_scale && (i_s != osi->no_reference_TSV || i_r != osi->no_scale_ren_reference_TSV || i_f != osi->no_scale_fact_reference_TSV)){continue;}

	if (switch_output_plot_reduction){
	  filename_distribution_plot = "rcut." + identifier + ".." + name_result + ".dat";
	  filepath_distribution_plot = scalepath_TSV[i_s][i_r][i_f] + subdirectory + "/" + filename_distribution_plot;
	  logger << LOG_DEBUG_VERBOSE << "i_d = " << setw(2) << i_d << "   filepath_distribution_plot = " << filepath_distribution_plot << endline_flush;
	  out_plotfile.open(filepath_distribution_plot.c_str(), ofstream::out | ofstream::app);
	  out_plotfile << "## " << scalename_TSV[i_s][i_r][i_f] << subdirectory << "/" << "rcut." << identifier << "." << osi->extended_distribution[i_d].xdistribution_name << ".." << name_result << ".dat" << endline;
	  out_plotfile << endline;
	}
	else {
	  filename_distribution_plot = "rcut." + identifier + "." + osi->extended_distribution[i_d].xdistribution_name + ".." + name_result + ".dat";
	  filepath_distribution_plot = scalepath_TSV[i_s][i_r][i_f] + subdirectory + "/" + filename_distribution_plot;
	  logger << LOG_DEBUG_VERBOSE << "filepath_distribution_plot = " << filepath_distribution_plot << endline_flush;
	  out_plotfile.open(filepath_distribution_plot.c_str(), ofstream::out | ofstream::trunc);
	}
	
	double temp_result = 0;
	double temp_deviation = 0;
	for (int i_b = 0; i_b < osi->extended_distribution[i_d].n_bins; i_b++){
	  out_plotfile << "# bin (" << osi->extended_distribution[i_d].xdistribution_name << ")" << "   " << noshowpoint << osi->extended_distribution[i_d].bin_edge[i_b] << " - " << noshowpoint << osi->extended_distribution[i_d].bin_edge[i_b + 1] << endline;
	  if (extrapolated_distribution_result_TSV.size() > 0){
	    if (distribution_xmin_extrapolation_TSV.size() > 0){
	      out_plotfile << "# extrapolation range for minimal chi2: [ " << right << setw(5) << distribution_xmin_extrapolation_TSV[i_b][i_s][i_r][i_f] << "% : " << right << setw(5) << distribution_xmax_extrapolation_TSV[i_b][i_s][i_r][i_f] << "% ]" << endline;
	    }
	  }
	  out_plotfile << endline;
	  if (extrapolated_distribution_result_TSV.size() > 0){
	    if (identifier == "norm"){
	      temp_result = extrapolated_distribution_result_TSV[i_b][i_s][i_r][i_f];
	      temp_deviation = extrapolated_distribution_deviation_TSV[i_b][i_s][i_r][i_f];
	    }
	    else if (identifier == "plot"){
	      temp_result = extrapolated_distribution_result_TSV[i_b][i_s][i_r][i_f] / osi->extended_distribution[i_d].bin_width[i_b];
	      temp_deviation = extrapolated_distribution_deviation_TSV[i_b][i_s][i_r][i_f] / osi->extended_distribution[i_d].bin_width[i_b];
	    }
	    if (plotmode == 1){if (temp_result < 0.){temp_result = 0.;}}

	    out_plotfile << "  " << setw(12) << "extrapolated";
	    out_plotfile << setw(3) << "";
	    out_plotfile << right << showpoint << setw(15) << setprecision(8) << osi->unit_factor_distribution * temp_result;
	    out_plotfile << right << showpoint << setw(13) << setprecision(6) << osi->unit_factor_distribution * temp_deviation;
	    out_plotfile << endline;
	    for (int i_s = 0; i_s < 45; i_s++){out_plotfile << "-";} out_plotfile << endline;
	  }

	  for (int x_q = 0; x_q < rcut_distribution_result_TSV.size(); x_q++){
	    if (identifier == "norm"){
	      temp_result = rcut_distribution_result_TSV[x_q][i_b][i_s][i_r][i_f];
	      temp_deviation = rcut_distribution_deviation_TSV[x_q][i_b][i_s][i_r][i_f];
	    }
	    else if (identifier == "plot"){
	      temp_result = rcut_distribution_result_TSV[x_q][i_b][i_s][i_r][i_f] / osi->extended_distribution[i_d].bin_width[i_b];
	      temp_deviation = rcut_distribution_deviation_TSV[x_q][i_b][i_s][i_r][i_f] / osi->extended_distribution[i_d].bin_width[i_b];
	    }
	    if (plotmode == 1){if (temp_result < 0.){temp_result = 0.;}}

	    out_plotfile << "  " << right << noshowpoint << setw(12) << osi->value_qTcut_distribution[x_q];
	    out_plotfile << setw(3) << "";
	    out_plotfile << right << showpoint << setw(15) << setprecision(8) << osi->unit_factor_distribution * temp_result;
	    out_plotfile << right << showpoint << setw(13) << setprecision(6) << osi->unit_factor_distribution * temp_deviation;
	    out_plotfile << endline;
	  }
	  out_plotfile << endline;
	}
	out_plotfile.close();
      }
    }
  }

  logger.finished();
}


void summary_generic::output_rcut_dddistribution_TSV(string & identifier, vector<vector<vector<vector<vector<double> > > > > & rcut_distribution_result_TSV, vector<vector<vector<vector<vector<double> > > > > & rcut_distribution_deviation_TSV, int i_d, string & name_result, string & subdirectory, int plotmode){
  static Logger logger("summary_generic::output_rcut_dddistribution_TSV");
  logger.called();

  int flag = 0;
  for (size_t i_f = 0; i_f < output_distribution_format[i_d].size(); i_f++){
    if (output_distribution_format[i_d][i_f] == "2dd." + identifier){flag = 1; break;}
  }
  if (!flag){return;}

  int i_ddd = i_d - osi->dat.size();

  ofstream out_plotfile;
  string filename_distribution_plot;
  string filepath_distribution_plot;

  for (int i_s = 0; i_s < osi->n_extended_set_TSV; i_s++){
    if (!switch_output_scaleset[i_s]){continue;}
    if (!osi->switch_distribution_TSV[i_s]){continue;}
    for (int i_r = 0; i_r < osi->n_scale_ren_TSV[i_s]; i_r++){
      for (int i_f = 0; i_f < osi->n_scale_fact_TSV[i_s]; i_f++){
	if (switch_output_only_reference_scale && (i_r != osi->no_scale_ren_reference_TSV || i_f != osi->no_scale_fact_reference_TSV)){continue;}
	if (switch_output_only_reference_scale > 1 && (i_s != osi->no_reference_TSV || i_r != osi->no_scale_ren_reference_TSV || i_f != osi->no_scale_fact_reference_TSV)){continue;}

	if (switch_output_plot_reduction){
	  filename_distribution_plot = "rcut." + identifier + ".." + name_result + ".dat";
	  filepath_distribution_plot = scalepath_TSV[i_s][i_r][i_f] + subdirectory + "/" + filename_distribution_plot;
	  logger << LOG_DEBUG_VERBOSE << "i_d = " << setw(2) << i_d << "   filepath_distribution_plot = " << filepath_distribution_plot << endline_flush;
	  out_plotfile.open(filepath_distribution_plot.c_str(), ofstream::out | ofstream::app);
	  out_plotfile << "## " << scalename_TSV[i_s][i_r][i_f] << subdirectory << "/" << "rcut." << identifier << "." << osi->extended_distribution[i_d].xdistribution_name << ".." << name_result << ".dat" << endline;
	  out_plotfile << endline;
	}
	else {
	  filename_distribution_plot = "rcut." + identifier + "." + osi->extended_distribution[i_d].xdistribution_name + ".." + name_result + ".dat";
	  filepath_distribution_plot = scalepath_TSV[i_s][i_r][i_f] + subdirectory + "/" + filename_distribution_plot;
	  logger << LOG_DEBUG_VERBOSE << "filepath_distribution_plot = " << filepath_distribution_plot << endline_flush;
	  out_plotfile.open(filepath_distribution_plot.c_str(), ofstream::out | ofstream::trunc);
	}
	
	double temp_result = 0;
	double temp_deviation = 0;

	for (int i_b1 = 0; i_b1 < osi->dddat[i_ddd].distribution_1.n_bins; i_b1++){
	  for (int i_b2 = 0; i_b2 < osi->dddat[i_ddd].distribution_2.n_bins; i_b2++){
	    int i_b = i_b1 * osi->dddat[i_ddd].distribution_2.n_bins + i_b2;

	    out_plotfile << "# bin (" << osi->dddat[i_ddd].distribution_1.xdistribution_name << ") ";
	    out_plotfile << noshowpoint << setprecision(8) << osi->dddat[i_ddd].distribution_1.bin_edge[i_b1] << " - " << noshowpoint << osi->dddat[i_ddd].distribution_1.bin_edge[i_b1 + 1];
	    out_plotfile << " --- ";
	    out_plotfile << "bin (" << osi->dddat[i_ddd].distribution_2.xdistribution_name << ") ";
	    out_plotfile << noshowpoint << setprecision(8) << osi->dddat[i_ddd].distribution_2.bin_edge[i_b2] << " - " << noshowpoint << osi->dddat[i_ddd].distribution_2.bin_edge[i_b2 + 1];
	    out_plotfile << endline;
	    out_plotfile << endline;
	    for (int x_q = 0; x_q < rcut_distribution_result_TSV.size(); x_q++){
	      if (identifier == "norm"){
		temp_result = rcut_distribution_result_TSV[x_q][i_b][i_s][i_r][i_f];
		temp_deviation = rcut_distribution_deviation_TSV[x_q][i_b][i_s][i_r][i_f];
	      }
	      else if (identifier == "plot"){
		temp_result = rcut_distribution_result_TSV[x_q][i_b][i_s][i_r][i_f] / osi->extended_distribution[i_d].bin_width[i_b];
		temp_deviation = rcut_distribution_deviation_TSV[x_q][i_b][i_s][i_r][i_f] / osi->extended_distribution[i_d].bin_width[i_b];
	      }
	      if (plotmode == 1){if (temp_result < 0.){temp_result = 0.;}}

	      out_plotfile << "  " << right << noshowpoint << setw(10) << osi->value_qTcut_distribution[x_q];
	      out_plotfile << setw(3) << "";
	      out_plotfile << right << showpoint << setw(15) << setprecision(8) << osi->unit_factor_distribution * temp_result;
	      out_plotfile << right << showpoint << setw(13) << setprecision(6) << osi->unit_factor_distribution * temp_deviation;
	      out_plotfile << endline;
	    }
	    out_plotfile << endline;
	  }
	}
	out_plotfile.close();
      }
    }
  }

  logger.finished();
}


void summary_generic::output_distribution_TSV(string & identifier, vector<vector<vector<vector<double> > > > & this_distribution_result_TSV, vector<vector<vector<vector<double> > > > & this_distribution_deviation_TSV, int i_d, string & name_result, string & subdirectory, int plotmode){
  static Logger logger("summary_generic::output_distribution_TSV");
  logger.called();

  int flag = 0;
  for (size_t i_f = 0; i_f < output_distribution_format[i_d].size(); i_f++){
    if (output_distribution_format[i_d][i_f] == identifier){flag = 1; break;}
  }
  if (!flag){return;}

  ofstream out_plotfile;
  string filename_distribution_plot;
  string filepath_distribution_plot;

  for (int i_s = 0; i_s < osi->n_extended_set_TSV; i_s++){
    if (!switch_output_scaleset[i_s]){continue;}
    if (!osi->switch_distribution_TSV[i_s]){continue;}
    for (int i_r = 0; i_r < osi->n_scale_ren_TSV[i_s]; i_r++){
      for (int i_f = 0; i_f < osi->n_scale_fact_TSV[i_s]; i_f++){

	if (switch_output_only_reference_scale && (i_r != osi->no_scale_ren_reference_TSV || i_f != osi->no_scale_fact_reference_TSV)){continue;}
	if (switch_output_only_reference_scale > 1 && (i_s != osi->no_reference_TSV || i_r != osi->no_scale_ren_reference_TSV || i_f != osi->no_scale_fact_reference_TSV)){continue;}
	
	if (switch_output_plot_reduction){
	  filename_distribution_plot = identifier + ".." + name_result + ".dat";
	  filepath_distribution_plot = scalepath_TSV[i_s][i_r][i_f] + subdirectory + "/" + filename_distribution_plot;
	  logger << LOG_DEBUG_VERBOSE << "filepath_distribution_plot = " << filepath_distribution_plot << endline_flush;
	  out_plotfile.open(filepath_distribution_plot.c_str(), ofstream::out | ofstream::app);
	  out_plotfile << "## " << scalename_TSV[i_s][i_r][i_f] << subdirectory << "/" << identifier << "." << osi->extended_distribution[i_d].xdistribution_name << ".." << name_result << ".dat" << endline;
	  out_plotfile << endline;
	}
	else {
	  filename_distribution_plot = identifier + "." + osi->extended_distribution[i_d].xdistribution_name + ".." + name_result + ".dat";
	  filepath_distribution_plot = scalepath_TSV[i_s][i_r][i_f] + subdirectory + "/" + filename_distribution_plot;
	  logger << LOG_DEBUG_VERBOSE << "filepath_distribution_plot = " << filepath_distribution_plot << endline_flush;
	  out_plotfile.open(filepath_distribution_plot.c_str(), ofstream::out | ofstream::trunc);
	}
	
	double temp_result = 0;
	double temp_deviation = 0;
	for (int i_b = 0; i_b < osi->extended_distribution[i_d].n_bins; i_b++){
	  if (identifier == "norm"){
	    temp_result = this_distribution_result_TSV[i_b][i_s][i_r][i_f];
	    temp_deviation = this_distribution_deviation_TSV[i_b][i_s][i_r][i_f];
	  }
	  else if (identifier == "plot"){
	    temp_result = this_distribution_result_TSV[i_b][i_s][i_r][i_f] / osi->extended_distribution[i_d].bin_width[i_b];
	    temp_deviation = this_distribution_deviation_TSV[i_b][i_s][i_r][i_f] / osi->extended_distribution[i_d].bin_width[i_b];
	  }
	  if (plotmode == 1){if (temp_result < 0.){temp_result = 0.;}}

	  out_plotfile << "  " << right << noshowpoint << setw(10) << osi->extended_distribution[i_d].bin_edge[i_b];
	  out_plotfile << setw(3) << "";
	  out_plotfile << "  " << right << showpoint << setw(15) << setprecision(8) << osi->unit_factor_distribution * temp_result;
	  out_plotfile << "  " << right << showpoint << setw(13) << setprecision(6) << osi->unit_factor_distribution * temp_deviation;
	  out_plotfile << endline;
	}
	if (switch_output_plot_reduction){ out_plotfile << endline; }
	out_plotfile.close();
      }
    }
  }

  logger.finished();
}


void summary_generic::output_sddistribution_TSV(string & identifier, vector<vector<vector<vector<double> > > > & this_distribution_result_TSV, vector<vector<vector<vector<double> > > > & this_distribution_deviation_TSV, int i_d, string & name_result, string & subdirectory, int plotmode){
  static Logger logger("summary_generic::output_sddistribution_TSV");
  logger.called();

  int flag = 0;
  for (size_t i_f = 0; i_f < output_distribution_format[i_d].size(); i_f++){
    if (output_distribution_format[i_d][i_f] == "1dd." + identifier){flag = 1; break;}
  }
  if (!flag){return;}

  ofstream out_plotfile;
  string filename_distribution_plot;
  string filepath_distribution_plot;

  for (int i_s = 0; i_s < osi->n_extended_set_TSV; i_s++){
    if (!switch_output_scaleset[i_s]){continue;}
    if (!osi->switch_distribution_TSV[i_s]){continue;}
    for (int i_r = 0; i_r < osi->n_scale_ren_TSV[i_s]; i_r++){
      for (int i_f = 0; i_f < osi->n_scale_fact_TSV[i_s]; i_f++){

	if (switch_output_only_reference_scale && (i_r != osi->no_scale_ren_reference_TSV || i_f != osi->no_scale_fact_reference_TSV)){continue;}
	if (switch_output_only_reference_scale > 1 && (i_s != osi->no_reference_TSV || i_r != osi->no_scale_ren_reference_TSV || i_f != osi->no_scale_fact_reference_TSV)){continue;}
	
	if (switch_output_plot_reduction){
	  filename_distribution_plot = "1dd." + identifier + ".." + name_result + ".dat";
	  filepath_distribution_plot = scalepath_TSV[i_s][i_r][i_f] + subdirectory + "/" + filename_distribution_plot;
	  logger << LOG_DEBUG_VERBOSE << "filepath_distribution_plot = " << filepath_distribution_plot << endline_flush;
	  out_plotfile.open(filepath_distribution_plot.c_str(), ofstream::out | ofstream::app);
	  out_plotfile << "## " << scalename_TSV[i_s][i_r][i_f] << subdirectory << "/" << "1dd." << identifier << "." << osi->extended_distribution[i_d].xdistribution_name << ".." << name_result << ".dat" << endline;
	  out_plotfile << endline;
	}
	else {
	  filename_distribution_plot = "1dd." + identifier + "." + osi->extended_distribution[i_d].xdistribution_name + ".." + name_result + ".dat";
	  filepath_distribution_plot = scalepath_TSV[i_s][i_r][i_f] + subdirectory + "/" + filename_distribution_plot;
	  logger << LOG_DEBUG_VERBOSE << "filepath_distribution_plot = " << filepath_distribution_plot << endline_flush;
	  out_plotfile.open(filepath_distribution_plot.c_str(), ofstream::out | ofstream::trunc);
	}
	
	double temp_result = 0;
	double temp_deviation = 0;
	for (int i_b = 0; i_b < osi->extended_distribution[i_d].n_bins; i_b++){
	  if (identifier == "norm"){
	    temp_result = this_distribution_result_TSV[i_b][i_s][i_r][i_f];
	    temp_deviation = this_distribution_deviation_TSV[i_b][i_s][i_r][i_f];
	  }
	  else if (identifier == "plot"){
	    temp_result = this_distribution_result_TSV[i_b][i_s][i_r][i_f] / osi->extended_distribution[i_d].bin_width[i_b];
	    temp_deviation = this_distribution_deviation_TSV[i_b][i_s][i_r][i_f] / osi->extended_distribution[i_d].bin_width[i_b];
	  }
	  if (plotmode == 1){if (temp_result < 0.){temp_result = 0.;}}

	  out_plotfile << "  " << right << noshowpoint << setw(10) << osi->extended_distribution[i_d].bin_edge[i_b];
	  out_plotfile << "  " << right << noshowpoint << setw(10) << osi->extended_distribution[i_d].bin_edge[i_b + 1];
	  out_plotfile << setw(3) << "";
	  out_plotfile << "  " << right << showpoint << setw(15) << setprecision(8) << osi->unit_factor_distribution * temp_result;
	  out_plotfile << "  " << right << showpoint << setw(13) << setprecision(6) << osi->unit_factor_distribution * temp_deviation;
	  out_plotfile << endline;
	}
	if (switch_output_plot_reduction){ out_plotfile << endline; }
	out_plotfile.close();
      }
    }
  }

  logger.finished();
}


void summary_generic::output_dddistribution_TSV(string & identifier, vector<vector<vector<vector<double> > > > & this_distribution_result_TSV, vector<vector<vector<vector<double> > > > & this_distribution_deviation_TSV, int i_d, string & name_result, string & subdirectory, int plotmode){
  static Logger logger("summary_generic::output_dddistribution_TSV");
  logger.called();

  int flag = 0;
  for (size_t i_f = 0; i_f < output_distribution_format[i_d].size(); i_f++){
    if (output_distribution_format[i_d][i_f] == "2dd." + identifier){flag = 1; break;}
  }
  if (!flag){return;}

  ofstream out_plotfile;
  string filename_distribution_plot;
  string filepath_distribution_plot;

  int i_ddd = i_d - osi->dat.size();

  for (int i_s = 0; i_s < osi->n_extended_set_TSV; i_s++){
    if (!switch_output_scaleset[i_s]){continue;}
    if (!osi->switch_distribution_TSV[i_s]){continue;}
    for (int i_r = 0; i_r < osi->n_scale_ren_TSV[i_s]; i_r++){
      for (int i_f = 0; i_f < osi->n_scale_fact_TSV[i_s]; i_f++){
	if (switch_output_only_reference_scale && (i_r != osi->no_scale_ren_reference_TSV || i_f != osi->no_scale_fact_reference_TSV)){continue;}
	if (switch_output_only_reference_scale > 1 && (i_s != osi->no_reference_TSV || i_r != osi->no_scale_ren_reference_TSV || i_f != osi->no_scale_fact_reference_TSV)){continue;}
	
	if (switch_output_plot_reduction){
	  filename_distribution_plot = "2dd." + identifier + ".." + name_result + ".dat";
	  filepath_distribution_plot = scalepath_TSV[i_s][i_r][i_f] + subdirectory + "/" + filename_distribution_plot;
	  logger << LOG_DEBUG_VERBOSE << "filepath_distribution_plot = " << filepath_distribution_plot << endline_flush;
	  out_plotfile.open(filepath_distribution_plot.c_str(), ofstream::out | ofstream::app);
	  out_plotfile << "## " << scalename_TSV[i_s][i_r][i_f] << subdirectory << "/" << "2dd." << identifier << "." << osi->extended_distribution[i_d].xdistribution_name << ".." << name_result << ".dat" << endline;
	  out_plotfile << endline;
	}
	else {
	  filename_distribution_plot = "2dd." + identifier + "." + osi->extended_distribution[i_d].xdistribution_name + ".." + name_result + ".dat";
	  filepath_distribution_plot = scalepath_TSV[i_s][i_r][i_f] + subdirectory + "/" + filename_distribution_plot;
	  logger << LOG_DEBUG_VERBOSE << "filepath_distribution_plot = " << filepath_distribution_plot << endline_flush;
	  out_plotfile.open(filepath_distribution_plot.c_str(), ofstream::out | ofstream::trunc);
	}

	double temp_result = 0;
	double temp_deviation = 0;
	for (int i_b1 = 0; i_b1 < osi->dddat[i_ddd].distribution_1.n_bins; i_b1++){
	  for (int i_b2 = 0; i_b2 < osi->dddat[i_ddd].distribution_2.n_bins; i_b2++){
	    int i_b = i_b1 * osi->dddat[i_ddd].distribution_2.n_bins + i_b2;
	    if (identifier == "norm"){
	      temp_result = this_distribution_result_TSV[i_b][i_s][i_r][i_f];
	      temp_deviation = this_distribution_deviation_TSV[i_b][i_s][i_r][i_f];
	    }
	    else if (identifier == "plot"){
	      temp_result = this_distribution_result_TSV[i_b][i_s][i_r][i_f] / osi->dddat[i_ddd].distribution_1.bin_width[i_b1] / osi->dddat[i_ddd].distribution_2.bin_width[i_b2];
	      temp_deviation = this_distribution_deviation_TSV[i_b][i_s][i_r][i_f] / osi->dddat[i_ddd].distribution_1.bin_width[i_b1] / osi->dddat[i_ddd].distribution_2.bin_width[i_b2];
	    }
	    //	    if (plotmode == 1){if (temp_result < 0.){temp_result = 0.;}}
	    out_plotfile << "  " << right << noshowpoint << setw(10) << osi->dddat[i_ddd].distribution_1.bin_edge[i_b1];
	    out_plotfile << "  " << right << noshowpoint << setw(10) << osi->dddat[i_ddd].distribution_1.bin_edge[i_b1 + 1];
	    out_plotfile << setw(3) << "";
	    out_plotfile << "  " << right << noshowpoint << setw(10) << osi->dddat[i_ddd].distribution_2.bin_edge[i_b2];
	    out_plotfile << "  " << right << noshowpoint << setw(10) << osi->dddat[i_ddd].distribution_2.bin_edge[i_b2 + 1];
	    out_plotfile << setw(3) << "";
	    out_plotfile << "  " << right << showpoint << setw(15) << setprecision(8) << osi->unit_factor_distribution * temp_result;
	    out_plotfile << "  " << right << showpoint << setw(13) << setprecision(6) << osi->unit_factor_distribution * temp_deviation;
	    out_plotfile << endline;
	  }
	}
	if (switch_output_plot_reduction){ out_plotfile << endline; }
	out_plotfile.close();
      }
    }
  }

  logger.finished();
}


void summary_generic::output_dddistribution_reconstruct_first_sdd_TSV(string & identifier, vector<vector<vector<vector<double> > > > & this_distribution_result_TSV, vector<vector<vector<vector<double> > > > & this_distribution_deviation_TSV, int i_d, string & name_result, string & subdirectory, int plotmode){
  static Logger logger("summary_generic::output_dddistribution_reconstruct_first_sdd_TSV");
  logger.called();

  int flag = 0;
  for (size_t i_f = 0; i_f < output_distribution_format[i_d].size(); i_f++){
    if (output_distribution_format[i_d][i_f] == "2dd.rec." + identifier ||
	output_distribution_format[i_d][i_f] == "2dd.rec_in_first." + identifier ||
	output_distribution_format[i_d][i_f] == "2dd.reconstruct." + identifier ||
	output_distribution_format[i_d][i_f] == "2dd.reconstruct_in_first." + identifier){flag = 1; break;}
  }
  if (!flag){return;}

  ofstream out_plotfile;
  string filename_distribution_plot;
  string filepath_distribution_plot;
  
  int i_ddd = i_d - osi->dat.size();

  for (int i_s = 0; i_s < osi->n_extended_set_TSV; i_s++){
    if (!switch_output_scaleset[i_s]){continue;}
    if (!osi->switch_distribution_TSV[i_s]){continue;}
    for (int i_r = 0; i_r < osi->n_scale_ren_TSV[i_s]; i_r++){
      for (int i_f = 0; i_f < osi->n_scale_fact_TSV[i_s]; i_f++){
	if (switch_output_plot_reduction){
	  filename_distribution_plot = "2dd.rec." + identifier + ".." + name_result + ".dat";
	  filepath_distribution_plot = scalepath_TSV[i_s][i_r][i_f] + subdirectory + "/" + filename_distribution_plot;
	  logger << LOG_DEBUG_VERBOSE << "filepath_distribution_plot = " << filepath_distribution_plot << endline_flush;
	  out_plotfile.open(filepath_distribution_plot.c_str(), ofstream::out | ofstream::app);
	  out_plotfile << "## " << scalename_TSV[i_s][i_r][i_f] << subdirectory << "/" << "2dd.rec." << identifier << "." << osi->dddat[i_ddd].distribution_1.xdistribution_name << ".from." << osi->dddat[i_ddd].name << ".." << name_result << ".dat" << endline;
	  out_plotfile << endline;
	}
	else {
	  stringstream filename_distribution_plot_ss;
	  filename_distribution_plot_ss << "2dd.rec." << identifier << "." << osi->dddat[i_ddd].distribution_1.xdistribution_name << ".from." << osi->dddat[i_ddd].name << ".." << name_result << ".dat";
	  filename_distribution_plot = filename_distribution_plot_ss.str();
	  filepath_distribution_plot = scalepath_TSV[i_s][i_r][i_f] + subdirectory + "/" + filename_distribution_plot;
	  logger << LOG_DEBUG_VERBOSE << "filepath_distribution_plot              = " << filepath_distribution_plot << endline_flush;
	  out_plotfile.open(filepath_distribution_plot.c_str(), ofstream::out | ofstream::trunc);
	}
	
	for (int i_b1 = 0; i_b1 < osi->dddat[i_ddd].distribution_1.n_bins; i_b1++){
	  double temp_result = 0;
	  double temp_deviation = 0;
	  for (int i_b2 = 0; i_b2 < osi->dddat[i_ddd].distribution_2.n_bins; i_b2++){
	    int i_b = i_b1 * osi->dddat[i_ddd].distribution_2.n_bins + i_b2;
	    if (identifier == "norm"){
	      temp_result += this_distribution_result_TSV[i_b][i_s][i_r][i_f];
	      temp_deviation += pow(this_distribution_deviation_TSV[i_b][i_s][i_r][i_f], 2);
	    }
	    else if (identifier == "plot"){
	      temp_result += this_distribution_result_TSV[i_b][i_s][i_r][i_f] / osi->dddat[i_ddd].distribution_1.bin_width[i_b1];
	      temp_deviation += pow(this_distribution_deviation_TSV[i_b][i_s][i_r][i_f] / osi->dddat[i_ddd].distribution_1.bin_width[i_b1], 2);
	    }
	  }
	  temp_deviation = sqrt(temp_deviation);
	  out_plotfile << "  " << right << noshowpoint << setw(10) << osi->dddat[i_ddd].distribution_1.bin_edge[i_b1];
	  out_plotfile << "  " << right << noshowpoint << setw(10) << osi->dddat[i_ddd].distribution_1.bin_edge[i_b1 + 1];
	  out_plotfile << setw(3) << "";
	  out_plotfile << "  " << right << showpoint << setw(15) << setprecision(8) << osi->unit_factor_distribution * temp_result;
	  out_plotfile << "  " << right << showpoint << setw(13) << setprecision(6) << osi->unit_factor_distribution * temp_deviation;
	  out_plotfile << endline;
	  /*
	  if (i_b1 == osi->dddat[i_ddd].distribution_1.n_bins - 1){
	    out_plotfile << "  " << right << noshowpoint << setw(10) << osi->dddat[i_ddd].distribution_1.bin_edge[osi->dddat[i_ddd].distribution_1.n_bins];
	    out_plotfile << "  " << right << noshowpoint << setw(10) << osi->dddat[i_ddd].distribution_1.bin_edge[osi->dddat[i_ddd].distribution_1.n_bins];
	    out_plotfile << setw(3) << "";
	    out_plotfile << "  " << right << showpoint << setw(15) << setprecision(8) << osi->unit_factor_distribution * temp_result;
	    out_plotfile << "  " << right << showpoint << setw(13) << setprecision(6) << osi->unit_factor_distribution * temp_deviation;
	    out_plotfile << endline;
	  }
	  */
	}
	if (switch_output_plot_reduction){ out_plotfile << endline; }
	out_plotfile.close();
      }
    }
  }

  logger.finished();
}


void summary_generic::output_dddistribution_reconstruct_second_sdd_TSV(string & identifier, vector<vector<vector<vector<double> > > > & this_distribution_result_TSV, vector<vector<vector<vector<double> > > > & this_distribution_deviation_TSV, int i_d, string & name_result, string & subdirectory, int plotmode){
  static Logger logger("summary_generic::output_dddistribution_reconstruct_second_sdd_TSV");
  logger.called();

  int flag = 0;
  for (size_t i_f = 0; i_f < output_distribution_format[i_d].size(); i_f++){
    if (output_distribution_format[i_d][i_f] == "2dd.rec." + identifier ||
	output_distribution_format[i_d][i_f] == "2dd.rec_in_second." + identifier ||
	output_distribution_format[i_d][i_f] == "2dd.reconstruct." + identifier ||
	output_distribution_format[i_d][i_f] == "2dd.reconstruct_in_second." + identifier){flag = 1; break;}
  }
  if (!flag){return;}

  ofstream out_plotfile;
  string filename_distribution_plot;
  string filepath_distribution_plot;

  int i_ddd = i_d - osi->dat.size();

  for (int i_s = 0; i_s < osi->n_extended_set_TSV; i_s++){
    if (!switch_output_scaleset[i_s]){continue;}
    if (!osi->switch_distribution_TSV[i_s]){continue;}
    for (int i_r = 0; i_r < osi->n_scale_ren_TSV[i_s]; i_r++){
      for (int i_f = 0; i_f < osi->n_scale_fact_TSV[i_s]; i_f++){
	if (switch_output_plot_reduction){
	  filename_distribution_plot = "2dd.rec." + identifier + ".." + name_result + ".dat";
	  filepath_distribution_plot = scalepath_TSV[i_s][i_r][i_f] + subdirectory + "/" + filename_distribution_plot;
	  logger << LOG_DEBUG_VERBOSE << "filepath_distribution_plot = " << filepath_distribution_plot << endline_flush;
	  out_plotfile.open(filepath_distribution_plot.c_str(), ofstream::out | ofstream::app);
	  out_plotfile << "## " << scalename_TSV[i_s][i_r][i_f] << subdirectory << "/" << "2dd.rec." << identifier << "." << osi->dddat[i_ddd].distribution_2.xdistribution_name << ".from." << osi->dddat[i_ddd].name << ".." << name_result << ".dat" << endline;
	  out_plotfile << endline;
	}
	else {
	  stringstream filename_distribution_plot_ss;
	  filename_distribution_plot_ss << "2dd.rec." << identifier << "." << osi->dddat[i_ddd].distribution_2.xdistribution_name << ".from." << osi->dddat[i_ddd].name << ".." << name_result << ".dat";
	  filename_distribution_plot = filename_distribution_plot_ss.str();
	  filepath_distribution_plot = scalepath_TSV[i_s][i_r][i_f] + subdirectory + "/" + filename_distribution_plot;
	  logger << LOG_DEBUG_VERBOSE << "filepath_distribution_plot              = " << filepath_distribution_plot << endline_flush;
	  out_plotfile.open(filepath_distribution_plot.c_str(), ofstream::out | ofstream::trunc);
	}
	for (int i_b2 = 0; i_b2 < osi->dddat[i_ddd].distribution_2.n_bins; i_b2++){
	  double temp_result = 0;
	  double temp_deviation = 0;
	  for (int i_b1 = 0; i_b1 < osi->dddat[i_ddd].distribution_1.n_bins; i_b1++){
	    int i_b = i_b1 * osi->dddat[i_ddd].distribution_2.n_bins + i_b2;
	    if (identifier == "norm"){
	      temp_result += this_distribution_result_TSV[i_b][i_s][i_r][i_f];
	      temp_deviation += pow(this_distribution_deviation_TSV[i_b][i_s][i_r][i_f], 2);
	    }
	    else if (identifier == "plot"){
	      temp_result += this_distribution_result_TSV[i_b][i_s][i_r][i_f] / osi->dddat[i_ddd].distribution_2.bin_width[i_b2];
	      temp_deviation += pow(this_distribution_deviation_TSV[i_b][i_s][i_r][i_f] / osi->dddat[i_ddd].distribution_2.bin_width[i_b2], 2);
	    }
	  }
	  temp_deviation = sqrt(temp_deviation);
	  out_plotfile << "  " << right << noshowpoint << setw(10) << osi->dddat[i_ddd].distribution_2.bin_edge[i_b2];
	  out_plotfile << "  " << right << noshowpoint << setw(10) << osi->dddat[i_ddd].distribution_2.bin_edge[i_b2 + 1];
	  out_plotfile << setw(3) << "";
	  out_plotfile << "  " << right << showpoint << setw(15) << setprecision(8) << osi->unit_factor_distribution * temp_result;
	  out_plotfile << "  " << right << showpoint << setw(13) << setprecision(6) << osi->unit_factor_distribution * temp_deviation;
	  out_plotfile << endline;
	  /*
	  if (i_b2 == osi->dddat[i_ddd].distribution_2.n_bins - 1){
	    out_plotfile << "  " << right << noshowpoint << setw(10) << osi->dddat[i_ddd].distribution_2.bin_edge[osi->dddat[i_ddd].distribution_2.n_bins];
	    out_plotfile << "  " << right << noshowpoint << setw(10) << osi->dddat[i_ddd].distribution_2.bin_edge[osi->dddat[i_ddd].distribution_2.n_bins];
	    out_plotfile << setw(3) << "";
	    out_plotfile << "  " << right << showpoint << setw(15) << setprecision(8) << osi->unit_factor_distribution * temp_result;
	    out_plotfile << "  " << right << showpoint << setw(13) << setprecision(6) << osi->unit_factor_distribution * temp_deviation;
	    out_plotfile << endline;
	  }
	  */
	}
	if (switch_output_plot_reduction){ out_plotfile << endline; }
	out_plotfile.close();
      }
    }
  }

  logger.finished();
}


void summary_generic::output_dddistribution_slice_in_first_sdd_TSV(string & identifier, vector<vector<vector<vector<double> > > > & this_distribution_result_TSV, vector<vector<vector<vector<double> > > > & this_distribution_deviation_TSV, int i_d, string & name_result, string & subdirectory, int plotmode){
  static Logger logger("summary_generic::output_dddistribution_slice_in_first_sdd_TSV");
  logger.called();

  int flag = 0;
  for (size_t i_f = 0; i_f < output_distribution_format[i_d].size(); i_f++){
    if (output_distribution_format[i_d][i_f] == "2dd.slice." + identifier ||
	output_distribution_format[i_d][i_f] == "2dd.slice_in_first." + identifier){flag = 1; break;}
  }
  if (!flag){return;}

  ofstream out_plotfile;
  string filename_distribution_plot;
  string filepath_distribution_plot;
  
  int i_ddd = i_d - osi->dat.size();

  for (int i_s = 0; i_s < osi->n_extended_set_TSV; i_s++){
    if (!switch_output_scaleset[i_s]){continue;}
    if (!osi->switch_distribution_TSV[i_s]){continue;}
    for (int i_r = 0; i_r < osi->n_scale_ren_TSV[i_s]; i_r++){
      for (int i_f = 0; i_f < osi->n_scale_fact_TSV[i_s]; i_f++){
	for (int i_b1 = 0; i_b1 < osi->dddat[i_ddd].distribution_1.n_bins; i_b1++){
	  if (switch_output_plot_reduction){
	    filename_distribution_plot = "2dd.slice." + identifier + ".." + name_result + ".dat";
	    filepath_distribution_plot = scalepath_TSV[i_s][i_r][i_f] + subdirectory + "/" + filename_distribution_plot;
	    logger << LOG_DEBUG_VERBOSE << "filepath_distribution_plot = " << filepath_distribution_plot << endline_flush;
	    out_plotfile.open(filepath_distribution_plot.c_str(), ofstream::out | ofstream::app);
	    out_plotfile << "## " << scalename_TSV[i_s][i_r][i_f] << subdirectory << "/" <<"2dd.slice." +  identifier << "." << osi->dddat[i_ddd].name << "." << osi->dddat[i_ddd].distribution_1.xdistribution_name << "_" << noshowpoint << osi->dddat[i_ddd].distribution_1.bin_edge[i_b1] << "-" << noshowpoint << osi->dddat[i_ddd].distribution_1.bin_edge[i_b1 + 1] << ".." << name_result << ".dat" << endline;
	    out_plotfile << endline;
	  }
	  else {
	    stringstream filename_distribution_plot_ss;
	    filename_distribution_plot_ss << "2dd.slice." << identifier << "." << osi->dddat[i_ddd].name << "." << osi->dddat[i_ddd].distribution_1.xdistribution_name << "_" << noshowpoint << osi->dddat[i_ddd].distribution_1.bin_edge[i_b1] << "-" << noshowpoint << osi->dddat[i_ddd].distribution_1.bin_edge[i_b1 + 1] << ".." << name_result << ".dat";
	    filename_distribution_plot = filename_distribution_plot_ss.str();
	    filepath_distribution_plot = scalepath_TSV[i_s][i_r][i_f] + subdirectory + "/" + filename_distribution_plot;
	    logger << LOG_DEBUG_VERBOSE << "filepath_distribution_plot              = " << filepath_distribution_plot << endline_flush;
	    out_plotfile.open(filepath_distribution_plot.c_str(), ofstream::out | ofstream::trunc);
	  }
	  double temp_result = 0;
	  double temp_deviation = 0;
	  for (int i_b2 = 0; i_b2 < osi->dddat[i_ddd].distribution_2.n_bins; i_b2++){
	    int i_b = i_b1 * osi->dddat[i_ddd].distribution_2.n_bins + i_b2;
	    if (identifier == "norm"){
	      temp_result = this_distribution_result_TSV[i_b][i_s][i_r][i_f];
	      temp_deviation = this_distribution_deviation_TSV[i_b][i_s][i_r][i_f];
	    }
	    else if (identifier == "plot"){
	      temp_result = this_distribution_result_TSV[i_b][i_s][i_r][i_f] / osi->dddat[i_ddd].distribution_2.bin_width[i_b2];
	      temp_deviation = this_distribution_deviation_TSV[i_b][i_s][i_r][i_f] / osi->dddat[i_ddd].distribution_2.bin_width[i_b2];
	    }
	    out_plotfile << "  " << right << noshowpoint << setw(10) << osi->dddat[i_ddd].distribution_2.bin_edge[i_b2];
	    out_plotfile << "  " << right << noshowpoint << setw(10) << osi->dddat[i_ddd].distribution_2.bin_edge[i_b2 + 1];
	    out_plotfile << setw(3) << "";
	    out_plotfile << "  " << right << showpoint << setw(15) << setprecision(8) << osi->unit_factor_distribution * temp_result;
	    out_plotfile << "  " << right << showpoint << setw(13) << setprecision(6) << osi->unit_factor_distribution * temp_deviation;
	    out_plotfile << endline;
	  }
	  /*
	  out_plotfile << "  " << right << noshowpoint << setw(10) << osi->dddat[i_ddd].distribution_2.bin_edge[osi->dddat[i_ddd].distribution_2.n_bins];
	  out_plotfile << "  " << right << noshowpoint << setw(10) << osi->dddat[i_ddd].distribution_2.bin_edge[osi->dddat[i_ddd].distribution_2.n_bins];
	  out_plotfile << setw(3) << "";
	  out_plotfile << "  " << right << showpoint << setw(15) << setprecision(8) << osi->unit_factor_distribution * temp_result;
	  out_plotfile << "  " << right << showpoint << setw(13) << setprecision(6) << osi->unit_factor_distribution * temp_deviation;
	  out_plotfile << endline;
	  */
	  if (switch_output_plot_reduction){ out_plotfile << endline; }
	  out_plotfile.close();
	}
      }
    }
  }

  logger.finished();
}


void summary_generic::output_dddistribution_slice_in_second_sdd_TSV(string & identifier, vector<vector<vector<vector<double> > > > & this_distribution_result_TSV, vector<vector<vector<vector<double> > > > & this_distribution_deviation_TSV, int i_d, string & name_result, string & subdirectory, int plotmode){
  static Logger logger("summary_generic::output_dddistribution_slice_in_first_sdd_TSV");
  logger.called();

  int flag = 0;
  for (size_t i_f = 0; i_f < output_distribution_format[i_d].size(); i_f++){
    if (output_distribution_format[i_d][i_f] == "2dd.slice." + identifier ||
	output_distribution_format[i_d][i_f] == "2dd.slice_in_second." + identifier){flag = 1; break;}
  }
  if (!flag){return;}

  ofstream out_plotfile;
  string filename_distribution_plot;
  string filepath_distribution_plot;
  
  int i_ddd = i_d - osi->dat.size();

  for (int i_s = 0; i_s < osi->n_extended_set_TSV; i_s++){
    if (!switch_output_scaleset[i_s]){continue;}
    if (!osi->switch_distribution_TSV[i_s]){continue;}
    for (int i_r = 0; i_r < osi->n_scale_ren_TSV[i_s]; i_r++){
      for (int i_f = 0; i_f < osi->n_scale_fact_TSV[i_s]; i_f++){
	for (int i_b2 = 0; i_b2 < osi->dddat[i_ddd].distribution_2.n_bins; i_b2++){
	  if (switch_output_plot_reduction){
	    filename_distribution_plot = "2dd.slice." + identifier + ".." + name_result + ".dat";
	    filepath_distribution_plot = scalepath_TSV[i_s][i_r][i_f] + subdirectory + "/" + filename_distribution_plot;
	    logger << LOG_DEBUG_VERBOSE << "filepath_distribution_plot = " << filepath_distribution_plot << endline_flush;
	    out_plotfile.open(filepath_distribution_plot.c_str(), ofstream::out | ofstream::app);
	    out_plotfile << "## " << scalename_TSV[i_s][i_r][i_f] << subdirectory << "/" << "2dd.slice." << identifier << "." << osi->dddat[i_ddd].name << "." << osi->dddat[i_ddd].distribution_2.xdistribution_name << "_" << noshowpoint << osi->dddat[i_ddd].distribution_2.bin_edge[i_b2] << "-" << noshowpoint << osi->dddat[i_ddd].distribution_2.bin_edge[i_b2 + 1] << ".." << name_result << ".dat" << endline;
	    out_plotfile << endline;
	  }
	  else {
	    stringstream filename_distribution_plot_ss;
	    filename_distribution_plot_ss << "2dd.slice." << identifier << "." << osi->dddat[i_ddd].name << "." << osi->dddat[i_ddd].distribution_2.xdistribution_name << "_" << noshowpoint << osi->dddat[i_ddd].distribution_2.bin_edge[i_b2] << "-" << noshowpoint << osi->dddat[i_ddd].distribution_2.bin_edge[i_b2 + 1] << ".." << name_result << ".dat";
	    filename_distribution_plot = filename_distribution_plot_ss.str();
	    filepath_distribution_plot = scalepath_TSV[i_s][i_r][i_f] + subdirectory + "/" + filename_distribution_plot;
	    logger << LOG_DEBUG_VERBOSE << "filepath_distribution_plot              = " << filepath_distribution_plot << endline_flush;
	    out_plotfile.open(filepath_distribution_plot.c_str(), ofstream::out | ofstream::trunc);
	  }
	  double temp_result = 0;
	  double temp_deviation = 0;
	  for (int i_b1 = 0; i_b1 < osi->dddat[i_ddd].distribution_1.n_bins; i_b1++){
	    int i_b = i_b1 * osi->dddat[i_ddd].distribution_2.n_bins + i_b2;
	    if (identifier == "norm"){
	      temp_result = this_distribution_result_TSV[i_b][i_s][i_r][i_f];
	      temp_deviation = this_distribution_deviation_TSV[i_b][i_s][i_r][i_f];
	    }
	    else if (identifier == "plot"){
	      temp_result = this_distribution_result_TSV[i_b][i_s][i_r][i_f] / osi->dddat[i_ddd].distribution_1.bin_width[i_b1];
	      temp_deviation = this_distribution_deviation_TSV[i_b][i_s][i_r][i_f] / osi->dddat[i_ddd].distribution_1.bin_width[i_b1];
	    }
	    out_plotfile << "  " << right << noshowpoint << setw(10) << osi->dddat[i_ddd].distribution_1.bin_edge[i_b1];
	    out_plotfile << "  " << right << noshowpoint << setw(10) << osi->dddat[i_ddd].distribution_1.bin_edge[i_b1 + 1];
	    out_plotfile << setw(3) << "";
	    out_plotfile << "  " << right << showpoint << setw(15) << setprecision(8) << osi->unit_factor_distribution * temp_result;
	    out_plotfile << "  " << right << showpoint << setw(13) << setprecision(6) << osi->unit_factor_distribution * temp_deviation;
	    out_plotfile << endline;
	  }
	  /*
	  out_plotfile << "  " << right << noshowpoint << setw(10) << osi->dddat[i_ddd].distribution_1.bin_edge[osi->dddat[i_ddd].distribution_1.n_bins];
	  out_plotfile << "  " << right << noshowpoint << setw(10) << osi->dddat[i_ddd].distribution_1.bin_edge[osi->dddat[i_ddd].distribution_1.n_bins];
	  out_plotfile << setw(3) << "";
	  out_plotfile << "  " << right << showpoint << setw(15) << setprecision(8) << osi->unit_factor_distribution * temp_result;
	  out_plotfile << "  " << right << showpoint << setw(13) << setprecision(6) << osi->unit_factor_distribution * temp_deviation;
	  out_plotfile << endline;
	  */
	  if (switch_output_plot_reduction){ out_plotfile << endline; }
	  out_plotfile.close();
	}
      }
    }
  }

  logger.finished();
}


void summary_generic::output_dddistribution_ge_in_first_sdd_TSV(string & identifier, vector<vector<vector<vector<double> > > > & this_distribution_result_TSV, vector<vector<vector<vector<double> > > > & this_distribution_deviation_TSV, int i_d, string & name_result, string & subdirectory, int plotmode){
  static Logger logger("summary_generic::output_dddistribution_ge_in_first_sdd_TSV");
  logger.called();

  int flag = 0;
  for (size_t i_f = 0; i_f < output_distribution_format[i_d].size(); i_f++){
    if (output_distribution_format[i_d][i_f] == "2dd.ge." + identifier ||
	output_distribution_format[i_d][i_f] == "2dd.ge_in_first." + identifier ||
	output_distribution_format[i_d][i_f] == "2dd.ge_lt." + identifier ||
	output_distribution_format[i_d][i_f] == "2dd.ge_lt_in_first." + identifier){flag = 1; break;}
  }
  if (!flag){return;}

  ofstream out_plotfile;
  string filename_distribution_plot;
  string filepath_distribution_plot;

  int i_ddd = i_d - osi->dat.size();

  for (int i_s = 0; i_s < osi->n_extended_set_TSV; i_s++){
    if (!switch_output_scaleset[i_s]){continue;}
    if (!osi->switch_distribution_TSV[i_s]){continue;}
    for (int i_r = 0; i_r < osi->n_scale_ren_TSV[i_s]; i_r++){
      for (int i_f = 0; i_f < osi->n_scale_fact_TSV[i_s]; i_f++){
	for (int i_b1 = 0; i_b1 < osi->dddat[i_ddd].distribution_1.n_bins; i_b1++){
	  if (switch_output_plot_reduction){
	    filename_distribution_plot = "2dd.ge." + identifier + ".." + name_result + ".dat";
	    filepath_distribution_plot = scalepath_TSV[i_s][i_r][i_f] + subdirectory + "/" + filename_distribution_plot;
	    logger << LOG_DEBUG_VERBOSE << "filepath_distribution_plot = " << filepath_distribution_plot << endline_flush;
	    out_plotfile.open(filepath_distribution_plot.c_str(), ofstream::out | ofstream::app);
	    out_plotfile << "## " << scalename_TSV[i_s][i_r][i_f] << subdirectory << "/" << "2dd.ge." << identifier << "." << osi->dddat[i_ddd].name << "." << osi->dddat[i_ddd].distribution_1.xdistribution_name << "_ge" << noshowpoint << osi->dddat[i_ddd].distribution_1.bin_edge[i_b1] << ".." << name_result << ".dat" << endline;
	    out_plotfile << endline;
	  }
	  else {
	    stringstream filename_distribution_plot_ss;
	    filename_distribution_plot_ss << "2dd.ge." << identifier << "." << osi->dddat[i_ddd].name << "." << osi->dddat[i_ddd].distribution_1.xdistribution_name << "_ge" << noshowpoint << osi->dddat[i_ddd].distribution_1.bin_edge[i_b1] << ".." << name_result << ".dat";
	    filename_distribution_plot = filename_distribution_plot_ss.str();
	    filepath_distribution_plot = scalepath_TSV[i_s][i_r][i_f] + subdirectory + "/" + filename_distribution_plot;
	    logger << LOG_DEBUG_VERBOSE << "filepath_distribution_plot              = " << filepath_distribution_plot << endline_flush;
	    out_plotfile.open(filepath_distribution_plot.c_str(), ofstream::out | ofstream::trunc);
	  }
	  for (int i_b2 = 0; i_b2 < osi->dddat[i_ddd].distribution_2.n_bins; i_b2++){
	    double temp_result = 0;
	    double temp_deviation = 0;
	    for (int j_b1 = i_b1; j_b1 < osi->dddat[i_ddd].distribution_1.n_bins; j_b1++){
	      int i_b = j_b1 * osi->dddat[i_ddd].distribution_2.n_bins + i_b2;
	      if (identifier == "norm"){
		temp_result += this_distribution_result_TSV[i_b][i_s][i_r][i_f];
		temp_deviation += pow(this_distribution_deviation_TSV[i_b][i_s][i_r][i_f], 2);
	      }
	      else if (identifier == "plot"){
		temp_result += this_distribution_result_TSV[i_b][i_s][i_r][i_f] / osi->dddat[i_ddd].distribution_2.bin_width[i_b2];
		temp_deviation += pow(this_distribution_deviation_TSV[i_b][i_s][i_r][i_f] / osi->dddat[i_ddd].distribution_2.bin_width[i_b2], 2);
	      }
	    }
	    temp_deviation = sqrt(temp_deviation);
	    out_plotfile << "  " << right << noshowpoint << setw(10) << osi->dddat[i_ddd].distribution_2.bin_edge[i_b2];
	    out_plotfile << "  " << right << noshowpoint << setw(10) << osi->dddat[i_ddd].distribution_2.bin_edge[i_b2 + 1];
	    out_plotfile << setw(3) << "";
	    out_plotfile << "  " << right << showpoint << setw(15) << setprecision(8) << osi->unit_factor_distribution * temp_result;
	    out_plotfile << "  " << right << showpoint << setw(13) << setprecision(6) << osi->unit_factor_distribution * temp_deviation;
	    out_plotfile << endline;
	    /*
	    if (i_b2 == osi->dddat[i_ddd].distribution_2.n_bins - 1){
	      out_plotfile << "  " << right << noshowpoint << setw(10) << osi->dddat[i_ddd].distribution_2.bin_edge[i_b2 + 1];
	      out_plotfile << "  " << right << noshowpoint << setw(10) << osi->dddat[i_ddd].distribution_2.bin_edge[i_b2 + 1];
	      out_plotfile << setw(3) << "";
	      out_plotfile << "  " << right << showpoint << setw(15) << setprecision(8) << osi->unit_factor_distribution * temp_result;
	      out_plotfile << "  " << right << showpoint << setw(13) << setprecision(6) << osi->unit_factor_distribution * temp_deviation;
	      out_plotfile << endline;
	    }
	    */
	  }
	  if (switch_output_plot_reduction){ out_plotfile << endline; }
	  out_plotfile.close();
	}
      }
    }
  }

  logger.finished();
}


void summary_generic::output_dddistribution_ge_in_second_sdd_TSV(string & identifier, vector<vector<vector<vector<double> > > > & this_distribution_result_TSV, vector<vector<vector<vector<double> > > > & this_distribution_deviation_TSV, int i_d, string & name_result, string & subdirectory, int plotmode){
  static Logger logger("summary_generic::output_dddistribution_ge_in_second_sdd_TSV");
  logger.called();

  int flag = 0;
  for (size_t i_f = 0; i_f < output_distribution_format[i_d].size(); i_f++){
    if (output_distribution_format[i_d][i_f] == "2dd.ge." + identifier ||
	output_distribution_format[i_d][i_f] == "2dd.ge_in_second." + identifier ||
	output_distribution_format[i_d][i_f] == "2dd.ge_lt." + identifier ||
	output_distribution_format[i_d][i_f] == "2dd.ge_lt_in_second." + identifier){flag = 1; break;}
  }
  if (!flag){return;}

  ofstream out_plotfile;
  string filename_distribution_plot;
  string filepath_distribution_plot;

  int i_ddd = i_d - osi->dat.size();

  for (int i_s = 0; i_s < osi->n_extended_set_TSV; i_s++){
    if (!switch_output_scaleset[i_s]){continue;}
    if (!osi->switch_distribution_TSV[i_s]){continue;}
    for (int i_r = 0; i_r < osi->n_scale_ren_TSV[i_s]; i_r++){
      for (int i_f = 0; i_f < osi->n_scale_fact_TSV[i_s]; i_f++){
	for (int i_b2 = 0; i_b2 < osi->dddat[i_ddd].distribution_2.n_bins; i_b2++){
	  if (switch_output_plot_reduction){
	    filename_distribution_plot = "2dd.ge." + identifier + ".." + name_result + ".dat";
	    filepath_distribution_plot = scalepath_TSV[i_s][i_r][i_f] + subdirectory + "/" + filename_distribution_plot;
	    logger << LOG_DEBUG_VERBOSE << "filepath_distribution_plot = " << filepath_distribution_plot << endline_flush;
	    out_plotfile.open(filepath_distribution_plot.c_str(), ofstream::out | ofstream::app);
	    out_plotfile << "## " << scalename_TSV[i_s][i_r][i_f] << subdirectory << "/" << "2dd.ge." << identifier << "." << osi->dddat[i_ddd].name << "." << osi->dddat[i_ddd].distribution_2.xdistribution_name << "_ge" << noshowpoint << osi->dddat[i_ddd].distribution_2.bin_edge[i_b2] << ".." << name_result << ".dat" << endline;
	    out_plotfile << endline;
	  }
	  else {
	    stringstream filename_distribution_plot_ss;
	    filename_distribution_plot_ss << "2dd.ge." << identifier << "." << osi->dddat[i_ddd].name << "." << osi->dddat[i_ddd].distribution_2.xdistribution_name << "_ge" << noshowpoint << osi->dddat[i_ddd].distribution_2.bin_edge[i_b2] << ".." << name_result << ".dat";
	    filename_distribution_plot = filename_distribution_plot_ss.str();
	    filepath_distribution_plot = scalepath_TSV[i_s][i_r][i_f] + subdirectory + "/" + filename_distribution_plot;
	    logger << LOG_DEBUG_VERBOSE << "filepath_distribution_plot              = " << filepath_distribution_plot << endline_flush;
	    out_plotfile.open(filepath_distribution_plot.c_str(), ofstream::out | ofstream::trunc);
	  }
	  for (int i_b1 = 0; i_b1 < osi->dddat[i_ddd].distribution_1.n_bins; i_b1++){
	    double temp_result = 0;
	    double temp_deviation = 0;
	    for (int j_b2 = i_b2; j_b2 < osi->dddat[i_ddd].distribution_2.n_bins; j_b2++){
	      int i_b = i_b1 * osi->dddat[i_ddd].distribution_2.n_bins + j_b2;
	      if (identifier == "norm"){
		temp_result += this_distribution_result_TSV[i_b][i_s][i_r][i_f];
		temp_deviation += pow(this_distribution_deviation_TSV[i_b][i_s][i_r][i_f], 2);
	      }
	      else if (identifier == "plot"){
		temp_result += this_distribution_result_TSV[i_b][i_s][i_r][i_f] / osi->dddat[i_ddd].distribution_1.bin_width[i_b1];
		temp_deviation += pow(this_distribution_deviation_TSV[i_b][i_s][i_r][i_f] / osi->dddat[i_ddd].distribution_1.bin_width[i_b1], 2);
	      }
	    }
	    temp_deviation = sqrt(temp_deviation);
	    out_plotfile << "  " << right << noshowpoint << setw(10) << osi->dddat[i_ddd].distribution_1.bin_edge[i_b1];
	    out_plotfile << "  " << right << noshowpoint << setw(10) << osi->dddat[i_ddd].distribution_1.bin_edge[i_b1 + 1];
	    out_plotfile << setw(3) << "";
	    out_plotfile << "  " << right << showpoint << setw(15) << setprecision(8) << osi->unit_factor_distribution * temp_result;
	    out_plotfile << "  " << right << showpoint << setw(13) << setprecision(6) << osi->unit_factor_distribution * temp_deviation;
	    out_plotfile << endline;
	    /*
	    if (i_b1 == osi->dddat[i_ddd].distribution_1.n_bins - 1){
	      out_plotfile << "  " << right << noshowpoint << setw(10) << osi->dddat[i_ddd].distribution_1.bin_edge[i_b1 + 1];
	      out_plotfile << "  " << right << noshowpoint << setw(10) << osi->dddat[i_ddd].distribution_1.bin_edge[i_b1 + 1];
	      out_plotfile << setw(3) << "";
	      out_plotfile << "  " << right << showpoint << setw(15) << setprecision(8) << osi->unit_factor_distribution * temp_result;
	      out_plotfile << "  " << right << showpoint << setw(13) << setprecision(6) << osi->unit_factor_distribution * temp_deviation;
	      out_plotfile << endline;
	    }
	    */
	  }
	  if (switch_output_plot_reduction){ out_plotfile << endline; }
	  out_plotfile.close();
	}
      }
    }
  }

  logger.finished();
}


void summary_generic::output_dddistribution_lt_in_first_sdd_TSV(string & identifier, vector<vector<vector<vector<double> > > > & this_distribution_result_TSV, vector<vector<vector<vector<double> > > > & this_distribution_deviation_TSV, int i_d, string & name_result, string & subdirectory, int plotmode){
  static Logger logger("summary_generic::output_dddistribution_lt_in_first_sdd_TSV");
  logger.called();

  int flag = 0;
  for (size_t i_f = 0; i_f < output_distribution_format[i_d].size(); i_f++){
    if (output_distribution_format[i_d][i_f] == "2dd.lt." + identifier ||
	output_distribution_format[i_d][i_f] == "2dd.lt_in_first." + identifier ||
	output_distribution_format[i_d][i_f] == "2dd.ge_lt." + identifier ||
	output_distribution_format[i_d][i_f] == "2dd.ge_lt_in_first." + identifier){flag = 1; break;}
  }
  if (!flag){return;}

  ofstream out_plotfile;
  string filename_distribution_plot;
  string filepath_distribution_plot;

  int i_ddd = i_d - osi->dat.size();

  for (int i_s = 0; i_s < osi->n_extended_set_TSV; i_s++){
    if (!switch_output_scaleset[i_s]){continue;}
    if (!osi->switch_distribution_TSV[i_s]){continue;}
    for (int i_r = 0; i_r < osi->n_scale_ren_TSV[i_s]; i_r++){
      for (int i_f = 0; i_f < osi->n_scale_fact_TSV[i_s]; i_f++){
	for (int i_b1 = 0; i_b1 < osi->dddat[i_ddd].distribution_1.n_bins; i_b1++){
	  if (switch_output_plot_reduction){
	    filename_distribution_plot = "2dd.lt." + identifier + ".." + name_result + ".dat";
	    filepath_distribution_plot = scalepath_TSV[i_s][i_r][i_f] + subdirectory + "/" + filename_distribution_plot;
	    logger << LOG_DEBUG_VERBOSE << "filepath_distribution_plot = " << filepath_distribution_plot << endline_flush;
	    out_plotfile.open(filepath_distribution_plot.c_str(), ofstream::out | ofstream::app);
	    out_plotfile << "## " << scalename_TSV[i_s][i_r][i_f] << subdirectory << "/" << "2dd.lt." << identifier << "." << osi->dddat[i_ddd].name << "." << osi->dddat[i_ddd].distribution_1.xdistribution_name << "_lt" << noshowpoint << osi->dddat[i_ddd].distribution_1.bin_edge[i_b1] << ".." << name_result << ".dat" << endline;
	    out_plotfile << endline;
	  }
	  else {
	    stringstream filename_distribution_plot_ss;
	    filename_distribution_plot_ss << "2dd.lt." << identifier << "." << osi->dddat[i_ddd].name << "." << osi->dddat[i_ddd].distribution_1.xdistribution_name << "_lt" << noshowpoint << osi->dddat[i_ddd].distribution_1.bin_edge[i_b1] << ".." << name_result << ".dat";
	    filename_distribution_plot = filename_distribution_plot_ss.str();
	    filepath_distribution_plot = scalepath_TSV[i_s][i_r][i_f] + subdirectory + "/" + filename_distribution_plot;
	    logger << LOG_DEBUG_VERBOSE << "filepath_distribution_plot              = " << filepath_distribution_plot << endline_flush;
	    out_plotfile.open(filepath_distribution_plot.c_str(), ofstream::out | ofstream::trunc);
	  }
	  for (int i_b2 = 0; i_b2 < osi->dddat[i_ddd].distribution_2.n_bins; i_b2++){
	    double temp_result = 0;
	    double temp_deviation = 0;
	    for (int j_b1 = 0; j_b1 < i_b1; j_b1++){
	      int i_b = j_b1 * osi->dddat[i_ddd].distribution_2.n_bins + i_b2;
	      if (identifier == "norm"){
		temp_result += this_distribution_result_TSV[i_b][i_s][i_r][i_f];
		temp_deviation += pow(this_distribution_deviation_TSV[i_b][i_s][i_r][i_f], 2);
	      }
	      else if (identifier == "plot"){
		temp_result += this_distribution_result_TSV[i_b][i_s][i_r][i_f] / osi->dddat[i_ddd].distribution_2.bin_width[i_b2];
		temp_deviation += pow(this_distribution_deviation_TSV[i_b][i_s][i_r][i_f] / osi->dddat[i_ddd].distribution_2.bin_width[i_b2], 2);
	      }
	    }
	    temp_deviation = sqrt(temp_deviation);
	    out_plotfile << "  " << right << noshowpoint << setw(10) << osi->dddat[i_ddd].distribution_2.bin_edge[i_b2];
	    out_plotfile << "  " << right << noshowpoint << setw(10) << osi->dddat[i_ddd].distribution_2.bin_edge[i_b2 + 1];
	    out_plotfile << setw(3) << "";
	    out_plotfile << "  " << right << showpoint << setw(15) << setprecision(8) << osi->unit_factor_distribution * temp_result;
	    out_plotfile << "  " << right << showpoint << setw(13) << setprecision(6) << osi->unit_factor_distribution * temp_deviation;
	    out_plotfile << endline;
	    /*
	    if (i_b2 == osi->dddat[i_ddd].distribution_2.n_bins - 1){
	      out_plotfile << "  " << right << noshowpoint << setw(10) << osi->dddat[i_ddd].distribution_2.bin_edge[i_b2 + 1];
	      out_plotfile << "  " << right << noshowpoint << setw(10) << osi->dddat[i_ddd].distribution_2.bin_edge[i_b2 + 1];
	      out_plotfile << setw(3) << "";
	      out_plotfile << "  " << right << showpoint << setw(15) << setprecision(8) << osi->unit_factor_distribution * temp_result;
	      out_plotfile << "  " << right << showpoint << setw(13) << setprecision(6) << osi->unit_factor_distribution * temp_deviation;
	      out_plotfile << endline;
	    }
	    */
	  }
	  if (switch_output_plot_reduction){ out_plotfile << endline; }
	  out_plotfile.close();
	}
      }
    }
  }

  logger.finished();
}


void summary_generic::output_dddistribution_lt_in_second_sdd_TSV(string & identifier, vector<vector<vector<vector<double> > > > & this_distribution_result_TSV, vector<vector<vector<vector<double> > > > & this_distribution_deviation_TSV, int i_d, string & name_result, string & subdirectory, int plotmode){
  static Logger logger("summary_generic::output_dddistribution_lt_in_second_sdd_TSV");
  logger.called();

  int flag = 0;
  for (size_t i_f = 0; i_f < output_distribution_format[i_d].size(); i_f++){
    if (output_distribution_format[i_d][i_f] == "2dd.lt." + identifier ||
	output_distribution_format[i_d][i_f] == "2dd.lt_in_second." + identifier ||
	output_distribution_format[i_d][i_f] == "2dd.ge_lt." + identifier ||
	output_distribution_format[i_d][i_f] == "2dd.ge_lt_in_second." + identifier){flag = 1; break;}
  }
  if (!flag){return;}

  ofstream out_plotfile;
  string filename_distribution_plot;
  string filepath_distribution_plot;

  int i_ddd = i_d - osi->dat.size();

  for (int i_s = 0; i_s < osi->n_extended_set_TSV; i_s++){
    if (!switch_output_scaleset[i_s]){continue;}
    if (!osi->switch_distribution_TSV[i_s]){continue;}
    for (int i_r = 0; i_r < osi->n_scale_ren_TSV[i_s]; i_r++){
      for (int i_f = 0; i_f < osi->n_scale_fact_TSV[i_s]; i_f++){
	for (int i_b2 = 0; i_b2 < osi->dddat[i_ddd].distribution_2.n_bins; i_b2++){
	  if (switch_output_plot_reduction){
	    filename_distribution_plot = "2dd.lt." + identifier + ".." + name_result + ".dat";
	    filepath_distribution_plot = scalepath_TSV[i_s][i_r][i_f] + subdirectory + "/" + filename_distribution_plot;
	    logger << LOG_DEBUG_VERBOSE << "filepath_distribution_plot = " << filepath_distribution_plot << endline_flush;
	    out_plotfile.open(filepath_distribution_plot.c_str(), ofstream::out | ofstream::app);
	    out_plotfile << "## " << scalename_TSV[i_s][i_r][i_f] << subdirectory << "/" << "2dd.lt." << identifier << "." << osi->dddat[i_ddd].name << "." << osi->dddat[i_ddd].distribution_2.xdistribution_name << "_lt" << noshowpoint << osi->dddat[i_ddd].distribution_2.bin_edge[i_b2] << ".." << name_result << ".dat" << endline;
	    out_plotfile << endline;
	  }
	  else {
	    stringstream filename_distribution_plot_ss;
	    filename_distribution_plot_ss << "2dd.lt." << identifier << "." << osi->dddat[i_ddd].name << "." << osi->dddat[i_ddd].distribution_2.xdistribution_name << "_lt" << noshowpoint << osi->dddat[i_ddd].distribution_2.bin_edge[i_b2] << ".." << name_result << ".dat";
	    filename_distribution_plot = filename_distribution_plot_ss.str();
	    filepath_distribution_plot = scalepath_TSV[i_s][i_r][i_f] + subdirectory + "/" + filename_distribution_plot;
	    logger << LOG_DEBUG_VERBOSE << "filepath_distribution_plot              = " << filepath_distribution_plot << endline_flush;
	    out_plotfile.open(filepath_distribution_plot.c_str(), ofstream::out | ofstream::trunc);
	  }
	  for (int i_b1 = 0; i_b1 < osi->dddat[i_ddd].distribution_1.n_bins; i_b1++){
	    double temp_result = 0;
	    double temp_deviation = 0;
	    for (int j_b2 = 0; j_b2 < i_b2; j_b2++){
	      int i_b = i_b1 * osi->dddat[i_ddd].distribution_2.n_bins + j_b2;
	      if (identifier == "norm"){
		temp_result += this_distribution_result_TSV[i_b][i_s][i_r][i_f];
		temp_deviation += pow(this_distribution_deviation_TSV[i_b][i_s][i_r][i_f], 2);
	      }
	      else if (identifier == "plot"){
		temp_result += this_distribution_result_TSV[i_b][i_s][i_r][i_f] / osi->dddat[i_ddd].distribution_1.bin_width[i_b1];
		temp_deviation += pow(this_distribution_deviation_TSV[i_b][i_s][i_r][i_f] / osi->dddat[i_ddd].distribution_1.bin_width[i_b1], 2);
	      }
	    }
	    temp_deviation = sqrt(temp_deviation);
	    out_plotfile << "  " << right << noshowpoint << setw(10) << osi->dddat[i_ddd].distribution_1.bin_edge[i_b1];
	    out_plotfile << "  " << right << noshowpoint << setw(10) << osi->dddat[i_ddd].distribution_1.bin_edge[i_b1 + 1];
	    out_plotfile << setw(3) << "";
	    out_plotfile << "  " << right << showpoint << setw(15) << setprecision(8) << osi->unit_factor_distribution * temp_result;
	    out_plotfile << "  " << right << showpoint << setw(13) << setprecision(6) << osi->unit_factor_distribution * temp_deviation;
	    out_plotfile << endline;
	    /*
	    if (i_b1 == osi->dddat[i_ddd].distribution_1.n_bins - 1){
	      out_plotfile << "  " << right << noshowpoint << setw(10) << osi->dddat[i_ddd].distribution_1.bin_edge[i_b1 + 1];
	      out_plotfile << "  " << right << noshowpoint << setw(10) << osi->dddat[i_ddd].distribution_1.bin_edge[i_b1 + 1];
	      out_plotfile << setw(3) << "";
	      out_plotfile << "  " << right << showpoint << setw(15) << setprecision(8) << osi->unit_factor_distribution * temp_result;
	      out_plotfile << "  " << right << showpoint << setw(13) << setprecision(6) << osi->unit_factor_distribution * temp_deviation;
	      out_plotfile << endline;
	    }
	    */
	  }
	  if (switch_output_plot_reduction){ out_plotfile << endline; }
	  out_plotfile.close();
	}
      }
    }
  }

  logger.finished();
}

