#include "header.hpp"

void summary_generic::determine_scaleband(){
  static Logger logger("summary_generic::determine_scaleband");
  logger.called();

  vector<string> subgroup;
  //  int plotmode = 0;

  logger << LOG_DEBUG << "final_resultdirectory = " << final_resultdirectory << endline_flush;

  readin_infile_scaleband();

  logger << LOG_DEBUG_VERBOSE << "osi->value_qTcut_distribution.size() = " << osi->value_qTcut_distribution.size() << endline_flush;

  for (int i_sb = 0; i_sb < outpath_scaleband.size(); i_sb++){
    logger << LOG_INFO << "Determination of scaleband for " << outpath_scaleband[i_sb] << endline_flush;
    int x_v = -1;
    for (int i_v = 0; i_v < inpath_scalevariation[i_sb].size(); i_v++){
      if (inpath_scalecentral[i_sb] == inpath_scalevariation[i_sb][i_v]){x_v = i_v; break;}
    }
    if (x_v == -1){
      x_v = inpath_scalevariation[i_sb].size();
      inpath_scalevariation[i_sb].push_back(inpath_scalecentral[i_sb]);
    }

    system_execute(logger, "mkdir " + final_resultdirectory + "/" + outpath_scaleband[i_sb]);
    if (switch_output_geneva){ system_execute(logger, "mkdir " + final_resultdirectory + "/" + outpath_scalegeneva[i_sb]); }

    for (int x_q = 0; x_q < osi->value_qTcut_distribution.size() + 1; x_q++){
      if (x_q == 0 && osi->value_qTcut_distribution.size() == 1){ continue; }
      string directory_qTcut;
      string in_directory_qTcut;
      string out_directory_qTcut;
      if (x_q == osi->value_qTcut_distribution.size()){
	directory_qTcut = "";
	in_directory_qTcut = "";
	out_directory_qTcut = "";
      }
      else {
	stringstream qTcut_ss;
	qTcut_ss << "qTcut-" << osi->value_qTcut_distribution[x_q];
	directory_qTcut = "/" + qTcut_ss.str();
	in_directory_qTcut = "";
	out_directory_qTcut = directory_qTcut;
      }

      logger << LOG_DEBUG << "x_q = " << x_q << "   directory_qTcut = " << directory_qTcut << endline_flush;

      if (x_q != osi->value_qTcut_distribution.size()){
	system_execute(logger, "mkdir " + final_resultdirectory + "/" + outpath_scaleband[i_sb] + directory_qTcut);
	if (switch_output_geneva){ system_execute(logger, "mkdir " + final_resultdirectory + "/" + outpath_scalegeneva[i_sb] + directory_qTcut); }
      }


      string infilename;

      char LineBuffer[1024];
      string s0;
      vector<string> vs0, vs1(1);

      vector<vector<vector<vector<string> > > > list_output_distribution(osi->extended_distribution.size(), vector<vector<vector<string> > > (yorder.size()));
      vector<vector<vector<vector<int> > > > format_output_distribution(osi->extended_distribution.size(), vector<vector<vector<int> > > (yorder.size()));
 
      logger << LOG_DEBUG << "osi->extended_distribution.size() = " << osi->extended_distribution.size() << endline_flush;
      for (int i_d = 0; i_d < osi->extended_distribution.size(); i_d++){
	logger << LOG_INFO << "Determination of scaleband for " << outpath_scaleband[i_sb] << " : " << osi->extended_distribution[i_d].xdistribution_name << endline_flush;

	logger << LOG_DEBUG << "switch_output_distribution[" << i_d << "] = " << switch_output_distribution[i_d] << endline_flush;
	if (!switch_output_distribution[i_d]){continue;}
	logger << LOG_DEBUG << "osi->extended_distribution[" << i_d << "].xdistribution_name = " << osi->extended_distribution[i_d].xdistribution_name << endline_flush;

	for (int i_o = 0; i_o < yorder.size(); i_o++){
	  list_output_distribution[i_d][i_o].resize(output_distribution_format[i_d].size());
	  format_output_distribution[i_d][i_o].resize(output_distribution_format[i_d].size());

	  logger << LOG_DEBUG << "(!yorder[i_o]->active_qTcut && x_q < osi->value_qTcut_distribution.size()) = " << (!yorder[i_o]->active_qTcut && x_q < osi->value_qTcut_distribution.size()) << endline_flush;
	  logger << LOG_DEBUG << "osi->value_qTcut_distribution.size() = " << osi->value_qTcut_distribution.size() << endline_flush;
	  logger << LOG_DEBUG << "yorder[" << i_o << "].active_qTcut = " << yorder[i_o]->active_qTcut << endline_flush;

	  if (!yorder[i_o]->active_qTcut && x_q < osi->value_qTcut_distribution.size()){continue;}

	  vector<string> format_plot;
	  vector<string> name_plot;
	  string identifier;
	  for (size_t i_f = 0; i_f < output_distribution_format[i_d].size(); i_f++){
	    for (size_t i_x = 0; i_x < 2; i_x++){
	      if (i_x == 0){ identifier = "plot"; }
	      else if (i_x == 1){ identifier = "norm"; }
	    
	      if (output_distribution_format[i_d][i_f] == identifier){
		if (i_d >= osi->dat.size()){ continue; }
		string temp_name = osi->extended_distribution[i_d].xdistribution_name;
		list_output_distribution[i_d][i_o][i_f].push_back("plot." + temp_name + ".." + yorder[i_o]->resultdirectory + ".dat");
		format_output_distribution[i_d][i_o][i_f].push_back(1);
	      }
	      else if (output_distribution_format[i_d][i_f] == "1dd." + identifier){
		if (i_d >= osi->dat.size()){ continue; }
		string temp_name = osi->extended_distribution[i_d].xdistribution_name;
		list_output_distribution[i_d][i_o][i_f].push_back("1dd." + identifier + "." + temp_name + ".." + yorder[i_o]->resultdirectory + ".dat");
		format_output_distribution[i_d][i_o][i_f].push_back(2);
	      }
	      else if (output_distribution_format[i_d][i_f] == "2dd." + identifier){
		if (i_d < osi->dat.size()){ continue; }
		string temp_name = osi->extended_distribution[i_d].xdistribution_name;
		list_output_distribution[i_d][i_o][i_f].push_back("2dd." + identifier + "." + temp_name + ".." + yorder[i_o]->resultdirectory + ".dat");
		format_output_distribution[i_d][i_o][i_f].push_back(4);
	      }
	      else if (output_distribution_format[i_d][i_f] == "2dd.rec." + identifier ||
		       output_distribution_format[i_d][i_f] == "2dd.reconstruct." + identifier ||
		       output_distribution_format[i_d][i_f] == "2dd.rec_in_first." + identifier ||
		       output_distribution_format[i_d][i_f] == "2dd.reconstruct_in_first." + identifier ||
		       output_distribution_format[i_d][i_f] == "2dd.rec_in_second." + identifier ||
		       output_distribution_format[i_d][i_f] == "2dd.reconstruct_in_second." + identifier){
		if (i_d < osi->dat.size()){ continue; }
		int i_ddd = i_d - osi->dat.size();
		if (output_distribution_format[i_d][i_f] == "2dd.rec." + identifier ||
		    output_distribution_format[i_d][i_f] == "2dd.reconstruct." + identifier ||
		    output_distribution_format[i_d][i_f] == "2dd.rec_in_first." + identifier ||
		    output_distribution_format[i_d][i_f] == "2dd.reconstruct_in_first." + identifier){
		  string temp_name = osi->dddat[i_ddd].distribution_1.xdistribution_name + ".from." + osi->dddat[i_ddd].name;
		  list_output_distribution[i_d][i_o][i_f].push_back("2dd.rec." + identifier + "." + temp_name + ".." + yorder[i_o]->resultdirectory + ".dat");
		  format_output_distribution[i_d][i_o][i_f].push_back(2);
		}
		if (output_distribution_format[i_d][i_f] == "2dd.rec." + identifier ||
		    output_distribution_format[i_d][i_f] == "2dd.reconstruct." + identifier ||
		    output_distribution_format[i_d][i_f] == "2dd.rec_in_second." + identifier ||
		    output_distribution_format[i_d][i_f] == "2dd.reconstruct_in_second." + identifier){
		  string temp_name = osi->dddat[i_ddd].distribution_2.xdistribution_name + ".from." + osi->dddat[i_ddd].name;
		  list_output_distribution[i_d][i_o][i_f].push_back("2dd.rec." + identifier + "." + temp_name + ".." + yorder[i_o]->resultdirectory + ".dat");
		  format_output_distribution[i_d][i_o][i_f].push_back(2);
		}
	      }
	      else if (output_distribution_format[i_d][i_f] == "2dd.slice." + identifier ||
		       output_distribution_format[i_d][i_f] == "2dd.slice_in_first." + identifier ||
		       output_distribution_format[i_d][i_f] == "2dd.slice_in_second." + identifier){
		if (i_d < osi->dat.size()){ continue; }
		int i_ddd = i_d - osi->dat.size();
		if (output_distribution_format[i_d][i_f] == "2dd.slice." + identifier ||
		    output_distribution_format[i_d][i_f] == "2dd.slice_in_first." + identifier){
		  for (int i_b1 = 0; i_b1 < osi->dddat[i_ddd].distribution_1.n_bins; i_b1++){
		    stringstream name_slice_bin;
		    name_slice_bin << osi->dddat[i_ddd].name << "." << osi->dddat[i_ddd].distribution_1.xdistribution_name << "_" << osi->dddat[i_ddd].distribution_1.bin_edge[i_b1] << "-" << osi->dddat[i_ddd].distribution_1.bin_edge[i_b1 + 1];
		    list_output_distribution[i_d][i_o][i_f].push_back("2dd.slice." + identifier + "." + name_slice_bin.str() + ".." + yorder[i_o]->resultdirectory + ".dat");
		    format_output_distribution[i_d][i_o][i_f].push_back(2);
		  }
		}
		if (output_distribution_format[i_d][i_f] == "2dd.slice." + identifier ||
		    output_distribution_format[i_d][i_f] == "2dd.slice_in_second." + identifier){
		  for (int i_b2 = 0; i_b2 < osi->dddat[i_ddd].distribution_2.n_bins; i_b2++){
		    stringstream name_slice_bin;
		    name_slice_bin << osi->dddat[i_ddd].name << "." << osi->dddat[i_ddd].distribution_2.xdistribution_name << "_" << osi->dddat[i_ddd].distribution_2.bin_edge[i_b2] << "-" << osi->dddat[i_ddd].distribution_2.bin_edge[i_b2 + 1];
		    list_output_distribution[i_d][i_o][i_f].push_back("2dd.slice." + identifier + "." + name_slice_bin.str() + ".." + yorder[i_o]->resultdirectory + ".dat");
		    format_output_distribution[i_d][i_o][i_f].push_back(2);
		  }
		}
	      }
	      else if (output_distribution_format[i_d][i_f] == "2dd.lt." + identifier ||
		       output_distribution_format[i_d][i_f] == "2dd.lt_in_first." + identifier ||
		       output_distribution_format[i_d][i_f] == "2dd.lt_in_second." + identifier){
		if (i_d < osi->dat.size()){ continue; }
		int i_ddd = i_d - osi->dat.size();
		if (output_distribution_format[i_d][i_f] == "2dd.lt." + identifier ||
		    output_distribution_format[i_d][i_f] == "2dd.lt_in_first." + identifier){
		  for (int i_b1 = 0; i_b1 < osi->dddat[i_ddd].distribution_1.n_bins; i_b1++){
		    stringstream name_cumulative_lt;
		    name_cumulative_lt << osi->dddat[i_ddd].name << "." << osi->dddat[i_ddd].distribution_1.xdistribution_name << "_lt" << osi->dddat[i_ddd].distribution_1.bin_edge[i_b1];
		    list_output_distribution[i_d][i_o][i_f].push_back("2dd.lt." + identifier + "." + name_cumulative_lt.str() + ".." + yorder[i_o]->resultdirectory + ".dat");
		    format_output_distribution[i_d][i_o][i_f].push_back(2);
		  }
		}
		if (output_distribution_format[i_d][i_f] == "2dd.lt." + identifier ||
		    output_distribution_format[i_d][i_f] == "2dd.lt_in_second." + identifier){
		  for (int i_b2 = 0; i_b2 < osi->dddat[i_ddd].distribution_2.n_bins; i_b2++){
		    stringstream name_cumulative_lt;
		    name_cumulative_lt << osi->dddat[i_ddd].name << "." << osi->dddat[i_ddd].distribution_2.xdistribution_name << "_lt" << osi->dddat[i_ddd].distribution_2.bin_edge[i_b2];
		    list_output_distribution[i_d][i_o][i_f].push_back("2dd.lt." + identifier + "." + name_cumulative_lt.str() + ".." + yorder[i_o]->resultdirectory + ".dat");
		    format_output_distribution[i_d][i_o][i_f].push_back(2);
		  }
		}
	      }
	      else if (output_distribution_format[i_d][i_f] == "2dd.ge." + identifier ||
		       output_distribution_format[i_d][i_f] == "2dd.ge_in_first." + identifier ||
		       output_distribution_format[i_d][i_f] == "2dd.ge_in_second." + identifier){
		if (i_d < osi->dat.size()){ continue; }
		int i_ddd = i_d - osi->dat.size();
		if (output_distribution_format[i_d][i_f] == "2dd.ge." + identifier ||
		    output_distribution_format[i_d][i_f] == "2dd.ge_in_first." + identifier){
		  for (int i_b1 = 0; i_b1 < osi->dddat[i_ddd].distribution_1.n_bins; i_b1++){
		    stringstream name_cumulative_ge;
		    name_cumulative_ge << osi->dddat[i_ddd].name << "." << osi->dddat[i_ddd].distribution_1.xdistribution_name << "_ge" << osi->dddat[i_ddd].distribution_1.bin_edge[i_b1];
		    list_output_distribution[i_d][i_o][i_f].push_back("2dd.ge." + identifier + "." + name_cumulative_ge.str() + ".." + yorder[i_o]->resultdirectory + ".dat");
		    format_output_distribution[i_d][i_o][i_f].push_back(2);
		  }
		}
		if (output_distribution_format[i_d][i_f] == "2dd.ge." + identifier ||
		    output_distribution_format[i_d][i_f] == "2dd.ge_in_second." + identifier){
		  for (int i_b2 = 0; i_b2 < osi->dddat[i_ddd].distribution_2.n_bins; i_b2++){
		    stringstream name_cumulative_ge;
		    name_cumulative_ge << osi->dddat[i_ddd].name << "." << osi->dddat[i_ddd].distribution_2.xdistribution_name << "_ge" << osi->dddat[i_ddd].distribution_2.bin_edge[i_b2];
		    list_output_distribution[i_d][i_o][i_f].push_back("2dd.ge." + identifier + "." + name_cumulative_ge.str() + ".." + yorder[i_o]->resultdirectory + ".dat");
		    format_output_distribution[i_d][i_o][i_f].push_back(2);
		  }
		}
	      }
	    }

	    logger << LOG_INFO << "output_distribution_format[" << i_d << "][" << i_f << "] = " << output_distribution_format[i_d][i_f] << endline_flush;
	    logger << LOG_INFO << "Output selection: " << osi->extended_distribution[i_d].xdistribution_name  << " : ";

	    int n_output_version = list_output_distribution[i_d][i_o][i_f].size();
	    for (int i_x = 0; i_x < n_output_version; i_x++){

	      logger << LOG_INFO << "list_output_distribution[" << i_d << "][" << i_o << "][" << i_f << "][" << i_x << "] = " << list_output_distribution[i_d][i_o][i_f][i_x] << endline_flush;

	      int switch_exist = 0;

	      vector<vector<vector<double> > > xresult, xdeviation, xdeviation2;
	      vector<double> variable;
	      vector<double> centralresult;
	      vector<double> centraldeviation;

	      vector<vector<double> > left_edge;
	      vector<vector<double> > right_edge;
	      // 1st: dimensionality of distribution
	      // 2nd: variable

	      int shift_column = format_output_distribution[i_d][i_o][i_f][i_x];
	      if (shift_column == 2){
		left_edge.resize(1);
		right_edge.resize(1);
	      }
	      else if (shift_column == 4){
		left_edge.resize(2);
		right_edge.resize(2);
	      }

	      for (int i_v = 0; i_v < inpath_scalevariation[i_sb].size(); i_v++){
		vector<string> readin;
		vector<vector<string> > readin2;
		infilename = final_resultdirectory + "/" + inpath_scalevariation[i_sb][i_v] + directory_qTcut + "/" + list_output_distribution[i_d][i_o][i_f][i_x];

		logger << LOG_DEBUG << "i_d = " << setw(2) << i_d << "   i_v = " << setw(2) << i_v << "   i_o = " << setw(2) << i_o << "   infilename = " << infilename << endline_flush;

		ifstream inf(infilename.c_str());
		readin = vs0;
		while (inf.getline(LineBuffer, 1024)){readin.push_back(LineBuffer);}
		logger << LOG_INFO << "infilename = " << infilename << "   readin.size() = " << readin.size() << endline_flush;
		if (readin.size() == 0){continue;}
		else {switch_exist = 1;}
		for (int i_b = 0; i_b < readin.size(); i_b++){
		  if (readin[i_b][0] == char(35)){}
		  else {
		    readin2.push_back(vs0);
		    int start = 0;
		    for (int j = 0; j < readin[i_b].size(); j++){
		      if (readin[i_b][j] != ' '){
			if (start == 0){start = 1; readin2[readin2.size() - 1].push_back(s0); readin2[readin2.size() - 1][readin2[readin2.size() - 1].size() - 1] = readin[i_b][j];}
			else {readin2[readin2.size() - 1][readin2[readin2.size() - 1].size() - 1] = readin2[readin2.size() - 1][readin2[readin2.size() - 1].size() - 1] + readin[i_b][j];}
		      }
		      else if ((readin[i_b][j] == ' ') && (start == 1)){start = 0;}
		    }
		  }
		  if (i_b == 0 || i_b == readin.size() - 1){logger << LOG_DEBUG_VERBOSE << "i_b = " << setw(2) << i_b << "   (" << readin.size() << " - " << readin2.size() << ")" << endline_flush;}
		}

		if (i_v == 0){
		  variable.resize(readin2.size());
		  for (int i_h = 0; i_h < left_edge.size(); i_h++){
		    left_edge[i_h].resize(readin2.size());
		    right_edge[i_h].resize(readin2.size());
		  }
		}
		vector<vector<double> > data(readin2.size());
		vector<vector<double> > result(readin2.size()), deviation(readin2.size()), deviation2(readin2.size());


		logger << LOG_DEBUG << "i_v = " << i_v << "   readin2.size() = " << readin2.size() << endline_flush;

		for (int i_b = 0; i_b < readin2.size(); i_b++){
		  data[i_b].resize(readin2[i_b].size());
		  result[i_b].resize((readin2[i_b].size() - 1) / 2);
		  deviation[i_b].resize((readin2[i_b].size() - 1) / 2);
		  deviation2[i_b].resize((readin2[i_b].size() - 1) / 2);
		}

		for (int i_b = 0; i_b < readin2.size(); i_b++){
		  for (int j = 0; j < readin2[i_b].size(); j++){
		    data[i_b][j] = atof(readin2[i_b][j].c_str());
		  }
		}
		for (int i_b = 0; i_b < result.size(); i_b++){
		  if (i_v == 0){
		    variable[i_b] = data[i_b][0];
		    for (int i_h = 0; i_h < left_edge.size(); i_h++){
		      left_edge[i_h][i_b] = data[i_b][0 + 2 * i_h];
		      right_edge[i_h][i_b] = data[i_b][1 + 2 * i_h];
		    }
		  }
		
		  for (int j = 0; j < result[i_b].size(); j++){
		    result[i_b][j] = data[i_b][j * 2 + shift_column];
		    deviation[i_b][j] = data[i_b][j * 2 + shift_column + 1];
		    deviation2[i_b][j] = pow(deviation[i_b][j], 2);
		  }
		}

		if (x_v == i_v){
		  centralresult.resize(result.size());
		  centraldeviation.resize(deviation.size());
		  for (int i_b = 0; i_b < result.size(); i_b++){
		    centralresult[i_b] = result[i_b][0];
		    centraldeviation[i_b] = deviation[i_b][0];
		  }
		}
		xresult.push_back(result);
		xdeviation.push_back(deviation);
		xdeviation2.push_back(deviation2);

		logger << LOG_DEBUG << "i_d = " << setw(2) << i_d << "   i_v = " << setw(2) << i_v << "   i_o = " << setw(2) << i_o << "   infilename = " << infilename << "   " << readin.size() << " " << readin2.size() << endline_flush;

	      }

	      logger << LOG_INFO << "switch_exist = " << switch_exist << endline_flush;
	    
	      if (!switch_exist){continue;}


	      vector<double> minresult(xresult[0].size(), 0.);
	      vector<double> maxresult(xresult[0].size(), 0.);
	      vector<double> mindeviation(xdeviation[0].size(), 0.);
	      vector<double> maxdeviation(xdeviation[0].size(), 0.);
	      for (int i_v = 0; i_v < xresult[0].size(); i_v++){
		logger << LOG_DEBUG_VERBOSE << "i_v = " << i_v << "   xresult.size() = " << xresult.size() << endline_flush;

		minresult[i_v] = 1.e99;
		maxresult[i_v] = -1.e99;
		for (int i_c = 0; i_c < xresult.size(); i_c++){
		  if (xresult[i_c][i_v][0] < minresult[i_v]){
		    minresult[i_v] = xresult[i_c][i_v][0];
		    mindeviation[i_v] = xdeviation[i_c][i_v][0];
		  }
		  if (xresult[i_c][i_v][0] > maxresult[i_v]){
		    maxresult[i_v] = xresult[i_c][i_v][0];
		    maxdeviation[i_v] = xdeviation[i_c][i_v][0];
		  }
		}
		//	if (plotmode == 1){if (minresult[i_b] < 0.){minresult[i_b] = 0.;}}
		logger << LOG_DEBUG_VERBOSE << "i_v = " << i_v << "   xresult.size() = " << xresult.size() << " done." << endline_flush;
	      }

	      ofstream outf;


	      //  scaleband

	      string outfilename_scaleband_matrix = final_resultdirectory + "/" + outpath_scaleband[i_sb] + directory_qTcut + "/" + list_output_distribution[i_d][i_o][i_f][i_x];
	      logger << LOG_DEBUG << "outfilename_scaleband_matrix = " << outfilename_scaleband_matrix << endline_flush;

	      outf.open(outfilename_scaleband_matrix.c_str(), ofstream::out | ofstream::trunc);
	      outf << right << "# ";
	      if (shift_column == 1){
		outf << " " << setw(10) << "left-edge";
	      }
	      else {
		for (int i_h = 0; i_h < left_edge.size(); i_h++){
		  stringstream left;
		  left << "left-edge";
		  if (left_edge.size() > 1){ left << i_h + 1; }
		  if (i_h == 0){ outf << setw(10) << left.str(); }
		  else { outf << setw(12) << left.str(); }
		  stringstream right;
		  right << "right-edge";
		  if (right_edge.size() > 1){ right << i_h + 1; }
		  outf << setw(12) << right.str();
		}
	      }
	      outf << setw(3) << "";
	      outf << setw(17) << "scale-central";
	      outf << setw(15) << "central-error";
	      outf << setw(17) << "scale-min";
	      outf << setw(15) << "min-error";
	      outf << setw(17) << "scale-max";
	      outf << setw(15) << "max-error";
	      outf << setw(3) << "";
	      outf << setw(11) << "rel-down";
	      outf << setw(11) << "rel-up";
	      outf << endline;

	      for (int i_b = 0; i_b < centralresult.size(); i_b++){
		double scale_down_rel = (minresult[i_b] / centralresult[i_b] - 1.) * 100.;
		double scale_up_rel = (maxresult[i_b] / centralresult[i_b] - 1.) * 100.;
		if (centralresult[i_b] == 0.){ scale_down_rel = 0.; scale_up_rel = 0.; } 
		outf << right << noshowpoint;
		if (shift_column == 1){ outf << "  " << setw(10) << setprecision(6) << variable[i_b]; }
		else {
		  for (int i_h = 0; i_h < left_edge.size(); i_h++){
		    outf << "  " << setw(10) << setprecision(6) << left_edge[i_h][i_b];
		    outf << "  " << setw(10) << setprecision(6) << right_edge[i_h][i_b];
		  }
		}
		if (centralresult[i_b] == 0.){ outf << setw(3) << "" << noshowpoint; }
		else { outf << setw(3) << "" << showpoint; }
		outf << "  " << setw(15) << setprecision(8) << centralresult[i_b] << "  " << setw(13) << setprecision(6) << centraldeviation[i_b];
		outf << "  " << setw(15) << setprecision(8) << minresult[i_b] << "  " << setw(13) << setprecision(6) << mindeviation[i_b];
		outf << "  " << setw(15) << setprecision(8) << maxresult[i_b] << "  " << setw(13) << setprecision(6) << maxdeviation[i_b];
		outf << setw(3) << ""; // << showpoint;
		outf << "  " << right << setprecision(int(log10(abs(scale_down_rel)) + 3)) << setw(8) << scale_down_rel << "%";
		outf << "  " << right << setprecision(int(log10(abs(scale_up_rel)) + 3)) << setw(8) << scale_up_rel << "%";
		outf << endline;
	      }
	      outf.close();

	      /*
	      string outfilename_scaleband = final_resultdirectory + "/" + outpath_scaleband[i_sb] + directory_qTcut + "/fill." + list_output_distribution[i_d][i_o][i_f][i_x];
	      logger << LOG_DEBUG << "outfilename_scaleband = " << outfilename_scaleband << endline_flush;
	      outf.open(outfilename_scaleband.c_str(), ofstream::out | ofstream::trunc);
	      for (int i_b = 0; i_b < minresult.size(); i_b++){
		double scale_down_rel = (minresult[i_b] / centralresult[i_b] - 1.) * 100.;
		double scale_up_rel = (maxresult[i_b] / centralresult[i_b] - 1.) * 100.;
		if (centralresult[i_b] == 0.){ scale_down_rel = 0.; scale_up_rel = 0.; } 
		outf << right;
		if (shift_column == 1){ outf << setw(10) << setprecision(6) << variable[i_b]; }
		else {
		  for (int i_h = 0; i_h < left_edge.size(); i_h++){
		    outf << " " << setw(10) << setprecision(6) << left_edge[i_h][i_b];
		    outf << " " << setw(10) << setprecision(6) << right_edge[i_h][i_b];
		  }
		}
		outf << "   ";
		outf << setw(15) << setprecision(8) << centralresult[i_b] << "   " << setw(13) << setprecision(6) << centraldeviation[i_b];
		outf << setw(15) << setprecision(8) << minresult[i_b] << "   " << setw(13) << setprecision(6) << mindeviation[i_b];
		outf << setw(15) << setprecision(8) << maxresult[i_b] << "   " << setw(13) << setprecision(6) << maxdeviation[i_b];
		outf << " " << right << setprecision(int(log10(abs(scale_down_rel)) + 3)) << setw(10) << scale_down_rel << "%";
		outf << " " << right << setprecision(int(log10(abs(scale_up_rel)) + 3)) << setw(10) << scale_up_rel << "%";
		outf << endline;

		if (i_b < minresult.size() - 1){
		  if (shift_column == 1){ outf << " " << setw(10) << setprecision(6) << variable[i_b + 1]; }
		  else {
		    for (int i_h = 0; i_h < left_edge.size(); i_h++){
		      outf << " " << setw(10) << setprecision(6) << left_edge[i_h][i_b];
		      outf << " " << setw(10) << setprecision(6) << right_edge[i_h][i_b];
		    }
		  }
		  outf << "   ";
		  outf << setw(15) << setprecision(8) << centralresult[i_b] << "   " << setw(13) << setprecision(6) << centraldeviation[i_b];
		  outf << setw(15) << setprecision(8) << minresult[i_b] << "   " << setw(13) << setprecision(6) << mindeviation[i_b];
		  outf << setw(15) << setprecision(8) << maxresult[i_b] << "   " << setw(13) << setprecision(6) << maxdeviation[i_b];
		  outf << " " << right << setprecision(int(log10(abs(scale_down_rel)) + 3)) << setw(10) << scale_down_rel << "%";
		  outf << " " << right << setprecision(int(log10(abs(scale_up_rel)) + 3)) << setw(10) << scale_up_rel << "%";
		  outf << endline;
		}
	      }
	      outf.close();
	      */
	    
	      /*
	      //  scaleband-ref
	      string outfilename_scaleband_ref = final_resultdirectory + "/" + outpath_scaleband[i_sb] + directory_qTcut + "/reffill." + list_output_distribution[i_d][i_o][i_f][i_x];
	      logger << LOG_DEBUG << "outfilename_scaleband_ref = " << outfilename_scaleband_ref << endline_flush;
	      outf.open(outfilename_scaleband_ref.c_str(), ofstream::out | ofstream::trunc);
	      for (int i_b = 0; i_b < centralresult.size(); i_b++){
		outf << setw(15) << setprecision(8) << variable[i_b] << setw(15) << setprecision(8) << centralresult[i_b] << endline;
		if (i_b < centralresult.size() - 1){
		  outf << setw(15) << setprecision(8) << variable[i_b + 1] << setw(15) << setprecision(8) << centralresult[i_b] << endline;
		}
	      }
	      outf.close();
	      */
	    

	      //  scale.geneva
	      if (switch_output_geneva){
		string outfilename_scaleband_geneva = final_resultdirectory + "/" + outpath_scalegeneva[i_sb] + directory_qTcut + "/" + list_output_distribution[i_d][i_o][i_f][i_x];
		logger << LOG_DEBUG << "outfilename_scaleband_geneva = " << outfilename_scaleband_geneva << endline_flush;
		outf.open(outfilename_scaleband_geneva.c_str(), ofstream::out | ofstream::trunc);
		if (xresult.size() == 3){
		  if (osi->extended_distribution[i_d].type_binning == "logarithmic"){
		    for (int i_b = 0; i_b < centralresult.size(); i_b++){
		      //		  for (int i_b = 0; i_b < variable.size() - 1; i_b++){
		      double factor = osi->extended_distribution[i_d].bin_width[i_b] / (log10(osi->extended_distribution[i_d].bin_edge[i_b + 1]) - log10(osi->extended_distribution[i_d].bin_edge[i_b]));
		      outf << setw(15) << setprecision(8) << log10(variable[i_b]) << "   "
			   << setw(15) << setprecision(8) << log10(variable[i_b + 1]) << "   "
			   << setw(15) << setprecision(8) << xresult[1][i_b][0] * factor << "   " << setw(13) << setprecision(6) << xdeviation[1][i_b][0] * factor
			   << setw(15) << setprecision(8) << xresult[2][i_b][0] * factor << "   " << setw(13) << setprecision(6) << xdeviation[2][i_b][0] * factor
			   << setw(15) << setprecision(8) << xresult[0][i_b][0] * factor << "   " << setw(13) << setprecision(6) << xdeviation[0][i_b][0] * factor
			   << endline;
		    }
		  }
		  else {
		    for (int i_b = 0; i_b < centralresult.size(); i_b++){
		      //		  for (int i_b = 0; i_b < variable.size() - 1; i_b++){
		      outf << setw(15) << setprecision(8) << variable[i_b] << "   "
			   << setw(15) << setprecision(8) << variable[i_b + 1] << "   "
			   << setw(15) << setprecision(8) << xresult[1][i_b][0] << "   " << setw(13) << setprecision(6) << xdeviation[1][i_b][0]
			   << setw(15) << setprecision(8) << xresult[2][i_b][0] << "   " << setw(13) << setprecision(6) << xdeviation[2][i_b][0]
			   << setw(15) << setprecision(8) << xresult[0][i_b][0] << "   " << setw(13) << setprecision(6) << xdeviation[0][i_b][0]
			   << endline;
		    }
		  }
		}
		else {
		  if (osi->extended_distribution[i_d].type_binning == "logarithmic"){
		    for (int i_b = 0; i_b < centralresult.size(); i_b++){
		      //		  for (int i_b = 0; i_b < variable.size() - 1; i_b++){
		      double factor = osi->extended_distribution[i_d].bin_width[i_b] / (log10(osi->extended_distribution[i_d].bin_edge[i_b + 1]) - log10(osi->extended_distribution[i_d].bin_edge[i_b]));
		      outf << setw(15) << setprecision(8) << log10(variable[i_b]) << "   "
			   << setw(15) << setprecision(8) << log10(variable[i_b + 1]) << "   "
			   << setw(15) << setprecision(8) << centralresult[i_b] * factor << "   " << setw(13) << setprecision(6) << centraldeviation[i_b] * factor
			   << setw(15) << setprecision(8) << minresult[i_b] * factor << "   " << setw(13) << setprecision(6) << mindeviation[i_b] * factor
			   << setw(15) << setprecision(8) << maxresult[i_b] * factor << "   " << setw(13) << setprecision(6) << maxdeviation[i_b] * factor
			   << endline;
		    }
		  }
		  else {
		    for (int i_b = 0; i_b < centralresult.size(); i_b++){
		      //		  for (int i_b = 0; i_b < variable.size() - 1; i_b++){
		      outf << setw(15) << setprecision(8) << variable[i_b] << "   "
			   << setw(15) << setprecision(8) << variable[i_b + 1] << "   "
			   << setw(15) << setprecision(8) << centralresult[i_b] << "   " << setw(13) << setprecision(6) << centraldeviation[i_b]
			   << setw(15) << setprecision(8) << minresult[i_b] << "   " << setw(13) << setprecision(6) << mindeviation[i_b]
			   << setw(15) << setprecision(8) << maxresult[i_b] << "   " << setw(13) << setprecision(6) << maxdeviation[i_b]
			   << endline;
		    }
		  }
		}
		outf.close();
	      }
	    }
	  }
	}
      }
    }
  }

  //  if (switch_output_table_order){output_distribution_table_order();}
  if (switch_output_table_order){output_distribution_table_order_nNNLOQCDxEW();}
  if (switch_output_table_Kfactor){output_distribution_table_Kfactor();}
  if (switch_output_table_crosssection_Kfactor){output_distribution_table_crosssection_Kfactor();}
  if (switch_output_table_IS_splitting){output_distribution_table_IS_splitting();}
  if (switch_output_table_crosssection_Kfactor_combination_NNLOQCD_NLOEW){output_distribution_table_crosssection_Kfactor_combination_NNLOQCD_NLOEW();}
  if (switch_output_table_order_cumulative_ggNLO){output_distribution_table_order_cumulative_ggNLO();}
  logger << LOG_DEBUG << "switch_output_table_order_cumulative_ggLO = " << switch_output_table_order_cumulative_ggLO << endline_flush;
  if (switch_output_table_order_cumulative_ggLO){output_distribution_table_order_cumulative_ggLO();}
  if (switch_output_table_crosssection_Kfactor_ggNLO){output_distribution_table_crosssection_Kfactor_ggNLO();}

  logger.finished();
}

