#include "header.hpp"

summary_list::summary_list(){
  static Logger logger("summary_list::summary_list ()");
  logger.called();

  if (Log::getLogThreshold() <= LOG_DEBUG_VERBOSE){ logger << LOG_DEBUG_VERBOSE << "constructor called..." << endline_flush; }

  logger.finished();
}

summary_list::summary_list(string & infilename, summary_generic * _generic){
  static Logger logger("summary_list::summary_list (infilename, generic)");
  logger.called();

  if (Log::getLogThreshold() <= LOG_DEBUG_VERBOSE){ logger << LOG_DEBUG_VERBOSE << "constructor called..." << endline_flush; }

  initialization(infilename, _generic);

  logger.finished();
}

summary_list::~summary_list(){
  static Logger logger("summary_list::~summary_list");
  logger.called();

  if (Log::getLogThreshold() <= LOG_DEBUG_VERBOSE){ logger << LOG_DEBUG_VERBOSE << "destructor called..." << endline_flush; }

  logger.finished();
}


void summary_list::initialization(string & infilename, summary_generic * _generic){
  static Logger logger("summary_list::initialization");
  logger.called();

  ygeneric = _generic;
  osi = ygeneric->osi;

  //  logger << LOG_DEBUG << "ygeneric->osi->value_qTcut_distribution.size() = " << ygeneric->osi->value_qTcut_distribution.size() << endline_flush;
  //  logger << LOG_DEBUG << "osi->value_qTcut_distribution.size() = " << osi->value_qTcut_distribution.size() << endline_flush;

  in_contribution_order_alpha_s = 0;
  in_contribution_order_alpha_e = 0;
  photon_induced = 0;

  channel_selection == "";
  extra_selection == "";
  dot_channel_selection == "";
  dot_extra_selection == "";
  slash_channel_selection == "";
  slash_extra_selection == "";
  name_channel_selection == "";
  name_extra_selection == "";

  //  string filename;
  //  string rundirectory;
  vector<string> readin;
  get_data(infilename, readin);

  vector<string> user_variable;
  vector<string> user_value;
  vector<string> user_variable_additional;
  get_userinput_from_readin(user_variable, user_variable_additional, user_value, readin);

  list_contribution.clear();
  list_contribution.push_back("");
  for (int i = 0; i < user_variable.size(); i++){if (user_variable[i] == "type_contribution"){list_contribution.push_back(user_value[i]);}}
  if (Log::getLogThreshold() <= LOG_DEBUG){
    for (int i = 0; i < list_contribution.size(); i++){logger << LOG_DEBUG << "list_contribution[" << i << "] = " << list_contribution[i] << endline_flush;}
  }
  initialization_summary_contribution(list_contribution.size());

  // Contribution-independent input:
  for (int i = 0; i < user_variable.size(); i++){
    if (user_variable[i] == "processname"){processname = user_value[i];}
    else if (user_variable[i] == "resultdirectory"){resultdirectory = user_value[i];}
    else if (user_variable[i] == "type_perturbative_order"){type_perturbative_order = user_value[i];}
    else if (user_variable[i] == "subtraction_method"){type_subtraction_method = user_value[i];}
    else if (user_variable[i] == "contribution_order_alpha_s"){in_contribution_order_alpha_s = atoi(user_value[i].c_str());}
    else if (user_variable[i] == "contribution_order_alpha_e"){in_contribution_order_alpha_e = atoi(user_value[i].c_str());}
    else if (user_variable[i] == "channel_selection"){channel_selection = user_value[i];}
    else if (user_variable[i] == "extra_selection"){extra_selection = user_value[i];}
  }
  
  if (channel_selection != "" && channel_selection != "---"){
    name_channel_selection = channel_selection;
    //    name_channel_selection = name_channel_selection;
    dot_channel_selection = "." + channel_selection;
    slash_channel_selection = "/CHS." + channel_selection;
    resultdirectory += dot_channel_selection;
    //    resultdirectory += "." + channel_selection;
  }
  else {
    channel_selection = "---";
    name_channel_selection = "";
    dot_channel_selection = "";
    slash_channel_selection = ""; 
  }

  if (extra_selection != "" && extra_selection != "---"){
    name_extra_selection = extra_selection;
    //    name_extra_selection = name_extra_selection;
    dot_extra_selection = "." + extra_selection;
    slash_extra_selection = "/" + extra_selection;
    resultdirectory += dot_extra_selection;
    //    resultdirectory += "." + extra_selection;
  }
  else {
    extra_selection = "---";
    name_extra_selection = "";
    dot_extra_selection = "";
    slash_extra_selection = ""; 
  }

  int x_c = 0;
  // Contribution-dependent input:
  for (int i = 0; i < user_variable.size(); i++){
    if (user_variable[i] == "type_contribution"){
      x_c++;
      xcontribution[x_c]->initialization(user_value[i], this);
    }
    else if (user_variable[i] == "type_correction"){
      xcontribution[x_c]->type_correction = user_value[i];
    }
    else if (user_variable[i] == "interference"){
      xcontribution[x_c]->interference = atoi(user_value[i].c_str());
    }
    else if (user_variable[i] == "photon_induced"){
      photon_induced = atoi(user_value[i].c_str());
      xcontribution[x_c]->photon_induced = atoi(user_value[i].c_str());
    }

    else if (user_variable[i] == "combination"){
      xcontribution[x_c]->combination = user_value[i];
    }

    else if (user_variable[i] == "directory" || user_variable[i] == "directory_list"){
      int x_n = -1;
      for (int i_n = 0; i_n < xcontribution[x_c]->extended_directory_name.size(); i_n++){
	if (user_variable_additional[i] == xcontribution[x_c]->extended_directory_name[i_n]){x_n = i_n; break;}
      }
      if (x_n == -1){
	xcontribution[x_c]->extended_directory_name.push_back(user_variable_additional[i]);
	xcontribution[x_c]->extended_directory.push_back(vector<string> ());
	x_n = xcontribution[x_c]->extended_directory_name.size() - 1;
      }
      if (user_variable[i] == "directory"){
	xcontribution[x_c]->extended_directory[x_n].push_back(user_value[i]);

	// directory and directory_extra should be later removed !!!
	xcontribution[x_c]->directory.push_back(user_value[i]);
	xcontribution[x_c]->directory_extra.push_back(0);

      }
      else if (user_variable[i] == "directory_list"){
	string infilepath = "../" + user_value[i];
	if (Log::getLogThreshold() <= LOG_DEBUG_VERBOSE){ logger << LOG_DEBUG_VERBOSE << "directory_list = " << user_value[i] << "   path = " << infilepath << endline_flush; }
	vector<string> readin_list;
	get_data(infilepath, readin_list);

	for (int i_l = 0; i_l < readin_list.size(); i_l++){
	  if (Log::getLogThreshold() <= LOG_DEBUG_VERBOSE){ logger << LOG_DEBUG_VERBOSE << "directory_list: readin_list[" << setw(4) << right << i_l << "] = " << readin_list[i_l] << endline_flush; }
	  xcontribution[x_c]->extended_directory[x_n].push_back(readin_list[i_l]);

	  // directory and directory_extra should be later removed !!!
	  xcontribution[x_c]->directory.push_back(readin_list[i_l]);
	  xcontribution[x_c]->directory_extra.push_back(0);

	}
      }
    }
    // should be removed later...
    else if (user_variable[i] == "directory_extra"){
      xcontribution[x_c]->directory.push_back(user_value[i]);
      xcontribution[x_c]->directory_extra.push_back(1);
    }
    else if (user_variable[i] == "extra_selection_contribution"){
      xcontribution[x_c]->extra_selection_contribution = user_value[i];
    }
  }

  for (int i_c = 0; i_c < xcontribution.size(); i_c++){
    if (xcontribution[i_c]->extra_selection_contribution != "" && xcontribution[i_c]->extra_selection_contribution != "---"){
      xcontribution[i_c]->name_extra_selection_contribution = xcontribution[i_c]->extra_selection_contribution;
      xcontribution[i_c]->dot_extra_selection_contribution = "." + xcontribution[i_c]->extra_selection_contribution;
      xcontribution[i_c]->slash_extra_selection_contribution = "/" + xcontribution[i_c]->extra_selection_contribution;
      //      xcontribution[i_c]->resultdirectory += xcontribution[i_c]->dot_extra_selection_contribution;
      //    resultdirectory += "." + extra_selection;
    }
    else {
      xcontribution[i_c]->extra_selection_contribution = "---";
      xcontribution[i_c]->name_extra_selection_contribution = "";
      xcontribution[i_c]->dot_extra_selection_contribution = "";
      xcontribution[i_c]->slash_extra_selection_contribution = ""; 
    }
    if (Log::getLogThreshold() <= LOG_DEBUG_VERBOSE){
      logger << LOG_DEBUG_VERBOSE << "xcontribution[" << i_c << "]->extra_selection_contribution = " << xcontribution[i_c]->extra_selection_contribution << endline_flush;
      logger << LOG_DEBUG_VERBOSE << "xcontribution[" << i_c << "]->name_extra_selection_contribution = " << xcontribution[i_c]->name_extra_selection_contribution << endline_flush;
      logger << LOG_DEBUG_VERBOSE << "xcontribution[" << i_c << "]->dot_extra_selection_contribution = " << xcontribution[i_c]->dot_extra_selection_contribution << endline_flush;
      logger << LOG_DEBUG_VERBOSE << "xcontribution[" << i_c << "]->slash_extra_selection_contribution = " << xcontribution[i_c]->slash_extra_selection_contribution << endline_flush;
    }
  }
  
  for (int i_c = 0; i_c < xcontribution.size(); i_c++){
    //  for (int i_c = 1; i_c < xcontribution.size(); i_c++){
    xcontribution[i_c]->processname = processname;
    xcontribution[i_c]->resultdirectory = resultdirectory;
    xcontribution[i_c]->type_perturbative_order = type_perturbative_order;
    xcontribution[i_c]->type_subtraction_method = type_subtraction_method;
    xcontribution[i_c]->in_contribution_order_alpha_s = in_contribution_order_alpha_s;
    xcontribution[i_c]->in_contribution_order_alpha_e = in_contribution_order_alpha_e;
  }

  if (Log::getLogThreshold() <= LOG_DEBUG){
    logger << LOG_DEBUG << "resultdirectory = " << resultdirectory << endline_flush;
    for (int i_c = 0; i_c < xcontribution.size(); i_c++){
      for (int i_n = 0; i_n < xcontribution[i_c]->extended_directory_name.size(); i_n++){
	logger << LOG_DEBUG << "xcontribution[" << i_c << "].infix_order_contribution = " << xcontribution[i_c]->infix_order_contribution << "   extended_directory_name[" << i_n << "] = " << setw(10) << xcontribution[i_c]->extended_directory_name[i_n] << "   entries: " << xcontribution[i_c]->extended_directory[i_n].size() << endline_flush;
      }
      logger << LOG_DEBUG << "xcontribution[" << i_c << "].infix_order_contribution = " << xcontribution[i_c]->infix_order_contribution << "     directory.size() = " << xcontribution[i_c]->directory.size() << endline_flush;
    }
  }

  for (int i_c = 1; i_c < xcontribution.size(); i_c++){
    if (!xcontribution[i_c]->extended_directory_name.size()){
      logger << LOG_DEBUG << "xcontribution[" << i_c << "].resultdirectory = " << xcontribution[i_c]->resultdirectory << "  has been deleted because no input is selected." << endline_flush;
      xcontribution.erase(xcontribution.begin() + i_c);
      i_c--;
    }
  }
  
  if (Log::getLogThreshold() <= LOG_DEBUG){
    logger << LOG_DEBUG << "Persisiting contributions in  resultdirectory = " << resultdirectory << " : " << endline_flush;
    for (int i_c = 1; i_c < xcontribution.size(); i_c++){
      logger << LOG_DEBUG << "xcontribution[" << i_c << "]: type_contribution = " << xcontribution[i_c]->type_contribution << "   type_correction = " << xcontribution[i_c]->type_correction << "   interference = " << xcontribution[i_c]->interference << "   extended_directory_name.size() = " << xcontribution[i_c]->extended_directory_name.size() << endline_flush;
    }
  }

  for (int i_c = 1; i_c < xcontribution.size(); i_c++){
    for (int i_o = 0; i_o < xcontribution[i_c]->extended_directory_name.size(); i_o++){
      int flag = true;
      for (int j_o = 0; j_o < xcontribution[0]->extended_directory_name.size(); j_o++){
	if (xcontribution[0]->extended_directory_name[j_o] == xcontribution[i_c]->extended_directory_name[i_o]){flag = false;}
      }
      if (flag){xcontribution[0]->extended_directory_name.push_back(xcontribution[i_c]->extended_directory_name[i_o]);}
    }
  }
  
  if (Log::getLogThreshold() <= LOG_DEBUG){
    logger << LOG_DEBUG << "xcontribution[0]->extended_directory_name.size() = " << xcontribution[0]->extended_directory_name.size() << endline_flush;
    for (int i_o = 0; i_o < xcontribution[0]->extended_directory_name.size(); i_o++){logger << LOG_DEBUG << "xcontribution[0]->extended_directory_name[" << i_o << "] = " << setw(10) << xcontribution[0]->extended_directory_name[i_o] << endline_flush;}
    for (int i_c = 1; i_c < xcontribution.size(); i_c++){if (xcontribution[0]->extended_directory_name != xcontribution[i_c]->extended_directory_name){logger << LOG_DEBUG << "different optimizations for xcontribution[" << i_c << "].infix_order_contribution = " << xcontribution[i_c]->infix_order_contribution << endline_flush;}}
  }

  extended_directory_name = xcontribution[0]->extended_directory_name;
  

  xcontribution[0]->xsubprocess.resize(1);
  xcontribution[0]->xsubprocess[0] = new summary_subprocess(ygeneric);

  stringstream temp_photon_induced;
  if (xcontribution[0]->photon_induced){temp_photon_induced << "a";}
  stringstream temp_order;
  stringstream temp_path;
  temp_order << type_perturbative_order;
  temp_path << type_perturbative_order;
  if (type_subtraction_method != "---"){
    temp_order << "." << type_subtraction_method;
    temp_path << "." << type_subtraction_method;
  }
  temp_order << "." << temp_photon_induced.str() << in_contribution_order_alpha_s << in_contribution_order_alpha_e;
  temp_path << "/" << temp_photon_induced.str() << in_contribution_order_alpha_s << in_contribution_order_alpha_e;
  xcontribution[0]->infix_order_contribution = temp_order.str();
  xcontribution[0]->infix_path_contribution = temp_path.str();
  if (Log::getLogThreshold() <= LOG_DEBUG){
    logger << LOG_DEBUG << "xcontribution.size() = " << xcontribution.size() << endline_flush;
    logger << LOG_DEBUG << "xcontribution[0]->infix_order_contribution   = " << xcontribution[0]->infix_order_contribution << endline_flush;
  }

  active_qTcut = 0;
  output_n_qTcut = 1;
  selection_n_qTcut = 1;
  for (int i_c = 1; i_c < xcontribution.size(); i_c++){
    if (Log::getLogThreshold() <= LOG_DEBUG){ logger << LOG_DEBUG << "xcontribution[" << i_c << "] = " << xcontribution[i_c]->type_contribution << endline_flush; }
    if (xcontribution[i_c]->type_contribution == "" ||
	xcontribution[i_c]->type_contribution == "CT" ||
	xcontribution[i_c]->type_contribution == "RT" ||
	xcontribution[i_c]->type_contribution == "PT" ||
	xcontribution[i_c]->type_contribution == "CT2" ||
	xcontribution[i_c]->type_contribution == "RVA" ||
	xcontribution[i_c]->type_contribution == "RCA" ||
	xcontribution[i_c]->type_contribution == "RRA" ||
	xcontribution[i_c]->type_contribution == "PT2" ||
	xcontribution[i_c]->type_contribution == "L2RT" ||
	xcontribution[i_c]->type_contribution == "L2CT" ||
	xcontribution[i_c]->type_contribution == "L2PT"){
      xcontribution[i_c]->active_qTcut = 1;
      xcontribution[i_c]->output_n_qTcut = osi->n_qTcut;
      xcontribution[i_c]->selection_n_qTcut = osi->value_qTcut_distribution.size();
      active_qTcut = 1;
      output_n_qTcut = osi->n_qTcut;
      selection_n_qTcut = osi->value_qTcut_distribution.size();
    }
    else {
      xcontribution[i_c]->active_qTcut = 0;
      xcontribution[i_c]->output_n_qTcut = 1;
      xcontribution[i_c]->selection_n_qTcut = 1;
    }
  }
  xcontribution[0]->active_qTcut = active_qTcut;
  xcontribution[0]->output_n_qTcut = output_n_qTcut;
  xcontribution[0]->selection_n_qTcut = selection_n_qTcut;

  if (Log::getLogThreshold() <= LOG_DEBUG){
    logger << LOG_DEBUG << "list      active_qTcut = " << active_qTcut << "   output_n_qTcut = " << setw(3) << output_n_qTcut << "   selection_n_qTcut = " << selection_n_qTcut << endline_flush;
    for (int i_c = 0; i_c < xcontribution.size(); i_c++){
      logger << LOG_DEBUG << "i_c = " << i_c << "   active_qTcut = " << xcontribution[i_c]->active_qTcut << "   output_n_qTcut = " << setw(3) << xcontribution[i_c]->output_n_qTcut << "   selection_n_qTcut = " << xcontribution[i_c]->selection_n_qTcut << endline_flush;
    }
  }

  for (int i_c = 1; i_c < xcontribution.size(); i_c++){
    stringstream temp_contribution;
    temp_contribution << xcontribution[i_c]->type_contribution;
    if (xcontribution[i_c]->type_correction != "---" && xcontribution[i_c]->type_correction != ""){temp_contribution << "." << xcontribution[i_c]->type_correction;}
    if (xcontribution[i_c]->interference != 0){temp_contribution << ".i" << xcontribution[i_c]->interference;}
    xcontribution[i_c]->infix_order_contribution = temp_order.str() + "." + temp_contribution.str();
    xcontribution[i_c]->infix_path_contribution = temp_path.str() + "/" + temp_contribution.str();
    xcontribution[i_c]->infix_contribution = temp_contribution.str();
    if (Log::getLogThreshold() <= LOG_DEBUG){
      logger << LOG_DEBUG << "type_contribution[" << i_c << "] = " << xcontribution[i_c]->type_contribution << endline_flush;
      logger << LOG_DEBUG << "type_correction[" << i_c << "] = " << xcontribution[i_c]->type_correction << endline_flush;
      logger << LOG_DEBUG << "interference[" << i_c << "] = " << xcontribution[i_c]->interference << endline_flush;
      logger << LOG_DEBUG << "infix_order_contribution[" << i_c << "] = " << xcontribution[i_c]->infix_order_contribution << endline_flush;
      logger << LOG_DEBUG << "infix_path_contribution [" << i_c << "] = " << xcontribution[i_c]->infix_path_contribution << endline_flush;
      logger << LOG_DEBUG << "infix_contribution      [" << i_c << "] = " << xcontribution[i_c]->infix_contribution << endline_flush;
      logger << LOG_DEBUG << "active_qTcut[" << i_c << "] = " << xcontribution[i_c]->active_qTcut << endline_flush;
      logger << LOG_DEBUG << "output_n_qTcut[" << i_c << "] = " << xcontribution[i_c]->output_n_qTcut << endline_flush;
      logger << LOG_DEBUG << "selection_n_qTcut[" << i_c << "] = " << xcontribution[i_c]->selection_n_qTcut << endline_flush;
      for (int i_q = 0; i_q < osi->value_qTcut_distribution.size(); i_q++){
	logger << LOG_DEBUG << "osi->value_qTcut_distribution[" << setw(2) << i_q << "] = " << osi->value_qTcut_distribution[i_q] << endline_flush;
      }
    }
  }

  ///  stringstream temp_ss;
  for (int i_c = 1; i_c < xcontribution.size(); i_c++){
    xcontribution[i_c]->average_factor = ygeneric->average_factor;
    ///    temp_ss << "xcontribution[" << i_c << "] : " << xcontribution[i_c]->type_contribution << "   " << xcontribution[i_c]->type_correction << "   " << "a_s^" << xcontribution[i_c]->in_contribution_order_alpha_s << "   " << "a_e^" << xcontribution[i_c]->in_contribution_order_alpha_e << "   " << "intf " << xcontribution[i_c]->interference << endline;
    /*
    logger << LOG_INFO << "xcontribution[" << i_c << "]->type_contribution = " << xcontribution[i_c]->type_contribution << endline_flush;
    logger << LOG_INFO << "xcontribution[" << i_c << "]->type_correction = " << xcontribution[i_c]->type_correction << endline_flush;
    logger << LOG_INFO << "xcontribution[" << i_c << "]->in_contribution_order_alpha_s = " << xcontribution[i_c]->in_contribution_order_alpha_s << "  " << in_contribution_order_alpha_s << endline_flush;
    logger << LOG_INFO << "xcontribution[" << i_c << "]->in_contribution_order_alpha_e = " << xcontribution[i_c]->in_contribution_order_alpha_e << "  " << in_contribution_order_alpha_e << endline_flush;
    logger << LOG_INFO << "xcontribution[" << i_c << "]->interference = " << xcontribution[i_c]->interference << endline_flush;
    */
    
    if (xcontribution[i_c]->type_contribution == "born"){xcontribution[i_c]->list_subprocess_born();}

    else if (xcontribution[i_c]->type_contribution == "RA" && xcontribution[i_c]->type_correction == "---"){xcontribution[i_c]->list_subprocess_R();}

    else if (xcontribution[i_c]->type_contribution == "VA" && xcontribution[i_c]->type_correction == "QCD"){xcontribution[i_c]->list_subprocess_V_QCD();}
    else if (xcontribution[i_c]->type_contribution == "VA" && xcontribution[i_c]->type_correction == "QEW"){xcontribution[i_c]->list_subprocess_V_QEW();}
    else if (xcontribution[i_c]->type_contribution == "VA" && xcontribution[i_c]->type_correction == "MIX"){xcontribution[i_c]->list_subprocess_V_MIX();}
    else if (xcontribution[i_c]->type_contribution == "CA" && xcontribution[i_c]->type_correction == "QCD"){xcontribution[i_c]->list_subprocess_C_QCD();}
    else if (xcontribution[i_c]->type_contribution == "CA" && xcontribution[i_c]->type_correction == "QEW"){xcontribution[i_c]->list_subprocess_C_QEW();}
    else if (xcontribution[i_c]->type_contribution == "RA" && xcontribution[i_c]->type_correction == "QCD"){xcontribution[i_c]->list_subprocess_R_QCD();}
    else if (xcontribution[i_c]->type_contribution == "RA" && xcontribution[i_c]->type_correction == "QEW"){xcontribution[i_c]->list_subprocess_R_QEW();}
    else if (xcontribution[i_c]->type_contribution == "RA" && xcontribution[i_c]->type_correction == "MIX"){xcontribution[i_c]->list_subprocess_R_MIX();}


    else if (xcontribution[i_c]->type_contribution == "RT" && xcontribution[i_c]->type_correction == "---"){xcontribution[i_c]->list_subprocess_R();}

    else if (xcontribution[i_c]->type_contribution == "VT" && xcontribution[i_c]->type_correction == "QCD"){xcontribution[i_c]->list_subprocess_V_QCD();}
    else if (xcontribution[i_c]->type_contribution == "CT" && xcontribution[i_c]->type_correction == "QCD"){xcontribution[i_c]->list_subprocess_C_QCD();}
    else if (xcontribution[i_c]->type_contribution == "RT" && xcontribution[i_c]->type_correction == "QCD"){xcontribution[i_c]->list_subprocess_R_QCD();}
    else if (xcontribution[i_c]->type_contribution == "PT" && xcontribution[i_c]->type_correction == "QCD"){xcontribution[i_c]->list_subprocess_C_QCD();}

    else if (xcontribution[i_c]->type_contribution == "loop"){xcontribution[i_c]->list_subprocess_born();}

    else if (xcontribution[i_c]->type_contribution == "RRA" && xcontribution[i_c]->type_correction == "---"){xcontribution[i_c]->list_subprocess_RR();}

    else if (xcontribution[i_c]->type_contribution == "VT2" && xcontribution[i_c]->type_correction == "QCD"){xcontribution[i_c]->list_subprocess_V2_QCD();}
    else if (xcontribution[i_c]->type_contribution == "CT2" && xcontribution[i_c]->type_correction == "QCD"){xcontribution[i_c]->list_subprocess_C2_QCD();}
    else if (xcontribution[i_c]->type_contribution == "RVA" && xcontribution[i_c]->type_correction == "QCD"){xcontribution[i_c]->list_subprocess_RV_QCD();}
    else if (xcontribution[i_c]->type_contribution == "RCA" && xcontribution[i_c]->type_correction == "QCD"){xcontribution[i_c]->list_subprocess_RC_QCD();}
    else if (xcontribution[i_c]->type_contribution == "RRA" && xcontribution[i_c]->type_correction == "QCD"){xcontribution[i_c]->list_subprocess_RR_QCD();}
    else if (xcontribution[i_c]->type_contribution == "PT2" && xcontribution[i_c]->type_correction == "QCD"){xcontribution[i_c]->list_subprocess_C2_QCD();}

    else if (xcontribution[i_c]->type_contribution == "L2I"){xcontribution[i_c]->list_subprocess_born();}

    else if (xcontribution[i_c]->type_contribution == "L2RA" && xcontribution[i_c]->type_correction == "---"){xcontribution[i_c]->list_subprocess_R();}

    else if (xcontribution[i_c]->type_contribution == "L2VA" && xcontribution[i_c]->type_correction == "QCD"){xcontribution[i_c]->list_subprocess_V_QCD();}
    else if (xcontribution[i_c]->type_contribution == "L2CA" && xcontribution[i_c]->type_correction == "QCD"){xcontribution[i_c]->list_subprocess_C_QCD();}
    else if (xcontribution[i_c]->type_contribution == "L2RA" && xcontribution[i_c]->type_correction == "QCD"){xcontribution[i_c]->list_subprocess_R_QCD();}

    else if (xcontribution[i_c]->type_contribution == "L2RT" && xcontribution[i_c]->type_correction == "---"){xcontribution[i_c]->list_subprocess_R();}

    else if (xcontribution[i_c]->type_contribution == "L2VT" && xcontribution[i_c]->type_correction == "QCD"){xcontribution[i_c]->list_subprocess_V_QCD();}
    else if (xcontribution[i_c]->type_contribution == "L2CT" && xcontribution[i_c]->type_correction == "QCD"){xcontribution[i_c]->list_subprocess_C_QCD();}
    else if (xcontribution[i_c]->type_contribution == "L2RT" && xcontribution[i_c]->type_correction == "QCD"){xcontribution[i_c]->list_subprocess_R_QCD();}
    else if (xcontribution[i_c]->type_contribution == "L2PT" && xcontribution[i_c]->type_correction == "QCD"){xcontribution[i_c]->list_subprocess_C_QCD();}

    else {logger << LOG_ERROR << "ERROR:   type_contribution[" << i_c << "] = " << xcontribution[i_c]->type_contribution <<  "type_correction[" << i_c << "] = " << xcontribution[i_c]->type_correction << endline_flush;}

    // Check why  xcontribution[i_c]->xsubprocess[i_p]  is initialized here and in  summary_contribution::readin_contribution_remove_run() !!!
    // Set proper initial runtime related values !!!

    xcontribution[i_c]->xsubprocess.resize(xcontribution[i_c]->subprocess.size());
    for (int i_p = 0; i_p < xcontribution[i_c]->xsubprocess.size(); i_p++){
      //    for (int i_p = 1; i_p < xcontribution[i_c]->xsubprocess.size(); i_p++){
      ///      if (i_p > 0){temp_ss << setw(16) << "" << "subprocess[" << setw(3) << right << i_p << "] = " << left << xcontribution[i_c]->subprocess[i_p] << endline;}
      //      logger << LOG_INFO << "xcontribution[" << i_c << "].subprocess[" << i_p << "] = " << xcontribution[i_c]->subprocess[i_p] << endline_flush;
      xcontribution[i_c]->xsubprocess[i_p] = new summary_subprocess(xcontribution[i_c]->subprocess[i_p], xcontribution[i_c]);
    }
  }

  ///  logger << LOG_INFO << "Contributions in list  " << resultdirectory << endline << temp_ss.str() << endline_flush;

  // subprocess not yet filled here !!! to be checked !!!

  logger.finished();
}



string summary_list::output_info(){
  static Logger logger("summary_list::output_info");
  logger.called();

  stringstream temp_ss;
  for (int i_c = 1; i_c < xcontribution.size(); i_c++){
    //    temp_ss << resultdirectory << "   xcontribution[" << i_c << "].infix_order_contribution[" << i_c << "] = " << xcontribution[i_c]->infix_order_contribution << "   with   " << xcontribution[i_c]->subprocess.size() - 1 << "   subprocesses" << endline;
    // resultdirectory << "   " <<
    temp_ss << "xcontribution[" << i_c << "] = " << xcontribution[i_c]->type_contribution << "   " << xcontribution[i_c]->type_correction << "   " << "alpha_s " << xcontribution[i_c]->in_contribution_order_alpha_s << "   " << "alpha_e " << xcontribution[i_c]->in_contribution_order_alpha_e << "   " << "interference " << xcontribution[i_c]->interference << "   ";
    if (xcontribution[i_c]->photon_induced){temp_ss << "photon-induced   ";}
    temp_ss << " (" << xcontribution[i_c]->infix_order_contribution << ")  with  " << xcontribution[i_c]->subprocess.size() - 1 << "  subprocess";
    if (xcontribution[i_c]->subprocess.size() > 2){temp_ss << "es";}
    temp_ss << endline;
    temp_ss << endline;
    for (int i_p = 1; i_p < xcontribution[i_c]->subprocess.size(); i_p++){
      temp_ss << setw(19) << "" << "subprocess[" << setw(3) << right << i_p << "] = " << left << xcontribution[i_c]->subprocess[i_p] << endline;
    }
    temp_ss << endline;
    //    logger.newLine(LOG_INFO);
  }
  //  logger << LOG_INFO << "Contributions in list  " << resultdirectory << endline << endline << temp_ss.str() << endline_flush;
  return temp_ss.str();
  
  logger.finished();
}






