#include "header.hpp"

void summary_list::extrapolation_TSV(int order_fit){
  static Logger logger("summary_list::extrapolation_TSV");
  logger.called();

  vector<double> X;
  vector<double> dX;

  for (int i_m = 0; i_m < osi->n_moments; i_m++){
    //    if (i_m > 0){continue;} // no moments implemented so far !!!
    for (int i_g = 0; i_g < ygeneric->subgroup.size(); i_g++){

      /*
      if (!(osi->value_qTcut.size() == xcontribution[0]->result_TSV[i_m][i_g].size())){logger << LOG_WARN << "osi->value_qTcut.size() = " << osi->value_qTcut.size() << " != " << xcontribution[0]->result_TSV[i_m][i_g].size() << " = xcontribution[0]->result_TSV[i_m][i_g].size()" << endline_flush;}
      assert(osi->value_qTcut.size() == xcontribution[0]->result_TSV[i_m][i_g].size());
      if (!(osi->value_qTcut.size() == xcontribution[0]->deviation_TSV[i_m][i_g].size())){logger << LOG_WARN << "osi->value_qTcut.size() = " << osi->value_qTcut.size() << " != " << xcontribution[0]->deviation_TSV[i_m][i_g].size() << " = xcontribution[0]->deviation_TSV[i_m][i_g].size()" << endline_flush;}
      assert(osi->value_qTcut.size() == xcontribution[0]->deviation_TSV[i_m][i_g].size());
      */

      static double xmin = ygeneric->min_qTcut_extrapolation;
      static double xmax = ygeneric->max_qTcut_extrapolation;

      static int x_s = osi->no_reference_TSV;
      static int x_r = osi->no_scale_ren_reference_TSV;
      static int x_f = osi->no_scale_fact_reference_TSV;
      if (Log::getLogThreshold() <= LOG_DEBUG_VERBOSE){
	logger << LOG_DEBUG_VERBOSE << "x_s = " << x_s << endline_flush;
	logger << LOG_DEBUG_VERBOSE << "x_r = " << x_r << endline_flush;
	logger << LOG_DEBUG_VERBOSE << "x_f = " << x_f << endline_flush;
      }

      vector<vector<double> > twodim_chi2_dof(osi->value_qTcut.size(), vector<double> (osi->value_qTcut.size(), 1.e99));
      vector<vector<double> > twodim_extrapolation_result(osi->value_qTcut.size(), vector<double> (osi->value_qTcut.size(), 0.));
      vector<vector<double> > twodim_extrapolation_deviation(osi->value_qTcut.size(), vector<double> (osi->value_qTcut.size(), 0.));

      vector<double> data_result(osi->value_qTcut.size());
      vector<double> data_deviation2(osi->value_qTcut.size());

      vector<vector<vector<int> > > no_xmin_TSV(osi->n_extended_set_TSV);
      vector<vector<vector<int> > > no_xmax_TSV(osi->n_extended_set_TSV);
      for (int i_s = 0; i_s < osi->n_extended_set_TSV; i_s++){
	if (!ygeneric->switch_output_scaleset[i_s]){continue;}
	no_xmin_TSV[i_s].resize(osi->n_scale_ren_TSV[i_s], vector<int> (osi->n_scale_fact_TSV[i_s], 0));
 	no_xmax_TSV[i_s].resize(osi->n_scale_ren_TSV[i_s], vector<int> (osi->n_scale_fact_TSV[i_s], 0));
      }

      for (int i_s = 0; i_s < result_TSV[i_m][i_g].size(); i_s++){
	for (int i_r = 0; i_r < result_TSV[i_m][i_g][i_s].size(); i_r++){
	  for (int i_f = 0; i_f < result_TSV[i_m][i_g][i_s][i_r].size(); i_f++){
	    for (int i_q = 0; i_q < osi->value_qTcut.size(); i_q++){
	      data_result[i_q] = xcontribution[0]->result_TSV[i_m][i_g][i_q][i_s][i_r][i_f];
	      data_deviation2[i_q] = pow(xcontribution[0]->deviation_TSV[i_m][i_g][i_q][i_s][i_r][i_f], 2);
	    }
	    int no_xmin = 0;
	    int no_xmax = 0;
	    //	    logger << LOG_INFO << resultdirectory << "   Extrapolation at  " << osi->name_scale_ren_TSV[i_s][i_r] << "  " << osi->name_scale_fact_TSV[i_s][i_f] << " :" << endline_flush;
	    string extrapolation_info;
	    extrapolation_fit_range_determination(osi->value_qTcut, data_result, data_deviation2, twodim_extrapolation_result, twodim_extrapolation_deviation, twodim_chi2_dof, order_fit, no_xmin, no_xmax, xmin, xmax, extrapolation_info);
	    logger << LOG_INFO << "(extrapolation_fit_range_determination)" << endline << endline << left << resultdirectory << "   " << osi->name_scale_ren_TSV[i_s][i_r] << "  " << osi->name_scale_fact_TSV[i_s][i_f] << " :" << endline << extrapolation_info << endline_flush;
	    //	    logger << LOG_INFO << resultdirectory << "   Extrapolation between  " << xmin << "  and  " << xmax << "  considered optimal." << endline_flush;
	    deviation_extrapolation_TSV[i_m][i_g][i_s][i_r][i_f] = twodim_extrapolation_deviation[no_xmin][no_xmax];
	    no_xmin_TSV[i_s][i_r][i_f] = no_xmin;
	    no_xmax_TSV[i_s][i_r][i_f] = no_xmax;
	  }
	}
      }
      
      for (int i_s = 0; i_s < result_TSV[i_m][i_g].size(); i_s++){
	for (int i_r = 0; i_r < result_TSV[i_m][i_g][i_s].size(); i_r++){
	  for (int i_f = 0; i_f < result_TSV[i_m][i_g][i_s][i_r].size(); i_f++){
	    xmin = osi->value_qTcut[no_xmin_TSV[i_s][i_r][i_f]];
	    xmax = osi->value_qTcut[no_xmax_TSV[i_s][i_r][i_f]];
	    //	    vector<double> data_result(osi->value_qTcut.size());
	    //	    vector<double> data_deviation2(osi->value_qTcut.size());
	    for (int i_q = 0; i_q < osi->value_qTcut.size(); i_q++){
	      data_result[i_q] = xcontribution[0]->result_TSV[i_m][i_g][i_q][i_s][i_r][i_f];
	      data_deviation2[i_q] = pow(xcontribution[0]->deviation_TSV[i_m][i_g][i_q][i_s][i_r][i_f], 2);
	    }
	    double chi2_dof = 0.;
	    if	(order_fit == 1){ extrapolation_linear(osi->value_qTcut, xmin, xmax, data_result, data_deviation2, X, dX, chi2_dof); }
	    else if (order_fit == 2){ extrapolation_quadratic(osi->value_qTcut, xmin, xmax, data_result, data_deviation2, X, dX, chi2_dof); }
	    else { extrapolation_function_gsl(osi->value_qTcut, xmin, xmax, data_result, data_deviation2, X, dX, chi2_dof, order_fit); }
	    //	    else {logger << LOG_FATAL << "No fit order specified." << endline_flush; exit(1);}
	    result_TSV[i_m][i_g][i_s][i_r][i_f] = X[0];
	    //	out_chi2[i_s][i_r][i_f] = chi2_dof;

	    double temp_error_fitvalue_at_fixed_qTcut = 0.;
	    if	(order_fit == 1){  // (analytic) linear fit:  y(qTcut) = X[0] + qTcut * X[1]
	      temp_error_fitvalue_at_fixed_qTcut = abs(xmin * X[1]) / 2;
	    }
	    else if (order_fit == 2){  // (analytic) quadratic fit:  y(qTcut) = X[0] + qTcut * X[1] + qTcut² * X[2]
	      temp_error_fitvalue_at_fixed_qTcut = abs(xmin * X[1] + pow(xmin, 2) * X[2]) / 2;
	    }
	    else if (order_fit == 3){  // (numeric) fit:  y(qTcut) = X[0] + qTcut * X[1] + qTcut * log(qTcut) * X[3] + qTcut² * X[2] + qTcut² * log(qTcut) * X[4]
	      temp_error_fitvalue_at_fixed_qTcut = abs(xmin * X[1] + pow(xmin, 2) * X[2] + xmin * log(xmin) * X[3] + pow(xmin, 2) * log(xmin) * X[4]) / 2;
	    }
	    else { logger << LOG_INFO << "temp_error_fitvalue_at_fixed_qTcut needs to be defined." << endline_flush; }

	    if (Log::getLogThreshold() <= LOG_DEBUG){
	      if (i_s == x_s && i_r == x_r && i_f == x_f){
		logger << LOG_DEBUG << "extrapolation    = " << setw(15) << setprecision(8) << result_TSV[i_m][i_g][i_s][i_r][i_f] << "   chi2_dof = " << chi2_dof << endline_flush;
		for (int i_q = 0; i_q < osi->value_qTcut.size(); i_q++){
		  logger << LOG_DEBUG << "data_result[" << setw(3) << i_q << "] = " << setw(15) << setprecision(8) << data_result[i_q] << " +- " << setw(15) << setprecision(8) << sqrt(data_deviation2[i_q]) << endline_flush;
		}
	      }
	    }

	    double extrapolation_plus = 0.;
	    for (int i_q = 0; i_q < osi->value_qTcut.size(); i_q++){
	      data_result[i_q] = xcontribution[0]->result_TSV[i_m][i_g][i_q][i_s][i_r][i_f] + xcontribution[0]->deviation_TSV[i_m][i_g][i_q][i_s][i_r][i_f];
	    }
	    if	(order_fit == 1){extrapolation_linear(osi->value_qTcut, xmin, xmax, data_result, data_deviation2, X, dX, chi2_dof);}
	    else if (order_fit == 2){extrapolation_quadratic(osi->value_qTcut, xmin, xmax, data_result, data_deviation2, X, dX, chi2_dof);}
	    else { extrapolation_function_gsl(osi->value_qTcut, xmin, xmax, data_result, data_deviation2, X, dX, chi2_dof, order_fit); }
	    //	    else {logger << LOG_FATAL << "No fit order specified." << endline_flush; exit(1);}
	    extrapolation_plus = X[0];

	    double extrapolation_minus = 0.;
	    for (int i_q = 0; i_q < osi->value_qTcut.size(); i_q++){
	      data_result[i_q] = xcontribution[0]->result_TSV[i_m][i_g][i_q][i_s][i_r][i_f] - xcontribution[0]->deviation_TSV[i_m][i_g][i_q][i_s][i_r][i_f];
	    }
	    if	(order_fit == 1){extrapolation_linear(osi->value_qTcut, xmin, xmax, data_result, data_deviation2, X, dX, chi2_dof);}
	    else if (order_fit == 2){extrapolation_quadratic(osi->value_qTcut, xmin, xmax, data_result, data_deviation2, X, dX, chi2_dof);}
	    else { extrapolation_function_gsl(osi->value_qTcut, xmin, xmax, data_result, data_deviation2, X, dX, chi2_dof, order_fit); }
	    //	    else {logger << LOG_FATAL << "No fit order specified." << endline_flush; exit(1);}
	    extrapolation_minus = X[0];

	    deviation_statistics_TSV[i_m][i_g][i_s][i_r][i_f] = (extrapolation_plus - extrapolation_minus) / 2;

	    // larger error estimate for large uncertainty due to high lowest qTcut value
	    if (temp_error_fitvalue_at_fixed_qTcut > deviation_extrapolation_TSV[i_m][i_g][i_s][i_r][i_f]){
	      if (Log::getLogThreshold() <= LOG_DEBUG){
		logger << LOG_DEBUG << resultdirectory << "   Extrapolation error is changed due to fixed lowest value:" << endline_flush;
		logger << LOG_DEBUG << "     old   deviation_extrapolation_TSV[" << i_m << "][" << i_g << "][" << i_s << "][" << i_r << "][" << i_f << "] = " << deviation_extrapolation_TSV[i_m][i_g][i_s][i_r][i_f] << endline_flush;
		logger << LOG_DEBUG << "     new   deviation_extrapolation_TSV[" << i_m << "][" << i_g << "][" << i_s << "][" << i_r << "][" << i_f << "] = " << temp_error_fitvalue_at_fixed_qTcut << endline_flush;
	      }
	      deviation_extrapolation_TSV[i_m][i_g][i_s][i_r][i_f] = temp_error_fitvalue_at_fixed_qTcut;
	    }
	    else {
	      if (Log::getLogThreshold() <= LOG_DEBUG){
		logger << LOG_DEBUG << resultdirectory << "   Extrapolation error is not changed due to fixed lowest value:" << endline_flush;
		logger << LOG_DEBUG << "     old   deviation_extrapolation_TSV[" << i_m << "][" << i_g << "][" << i_s << "][" << i_r << "][" << i_f << "] = " << deviation_extrapolation_TSV[i_m][i_g][i_s][i_r][i_f] << endline_flush;
		logger << LOG_DEBUG << "    (new)  deviation_extrapolation_TSV[" << i_m << "][" << i_g << "][" << i_s << "][" << i_r << "][" << i_f << "] = " << temp_error_fitvalue_at_fixed_qTcut << endline_flush;
	      }
	    }

	    //  pure statistical error, "extrapolated" to qTcut->0.
	    //  A further error estimate from the extrapolation curve (in particular its actually random fit range) added
	    deviation_TSV[i_m][i_g][i_s][i_r][i_f] = sqrt(pow(deviation_statistics_TSV[i_m][i_g][i_s][i_r][i_f], 2) + pow(deviation_extrapolation_TSV[i_m][i_g][i_s][i_r][i_f], 2));
	    
	    logger << LOG_INFO << resultdirectory << "   result_TSV[" << i_m << "][" << i_g << "][" << i_s << "][" << i_r << "][" << i_f << "] = " << setw(15) << setprecision(8) << result_TSV[i_m][i_g][i_s][i_r][i_f] << " +- " << setw(15) << setprecision(8) << deviation_TSV[i_m][i_g][i_s][i_r][i_f] << "   [ " << setw(15) << setprecision(8) << deviation_statistics_TSV[i_m][i_g][i_s][i_r][i_f] << " (statistics) +- " << deviation_extrapolation_TSV[i_m][i_g][i_s][i_r][i_f] << " (extrapolation)" << " ]" << endline_flush;

	    if (Log::getLogThreshold() <= LOG_DEBUG){
	      for (int i_q = 0; i_q < osi->value_qTcut.size(); i_q += 5){
		logger << LOG_DEBUG << resultdirectory << "   " << setw(3) << i_q << "   qTcut = " << setw(10) << setprecision(5) << osi->value_qTcut[i_q] << "   result = " << setw(23) << setprecision(15) << xcontribution[0]->result_TSV[i_m][i_g][i_q][i_s][i_r][i_f] << " +- " << setw(23) << setprecision(15) << xcontribution[0]->deviation_TSV[i_m][i_g][i_q][i_s][i_r][i_f] << endline_flush;
	      }
	    }
	  }
	}
      }
    }
  }

  logger.finished();
}


void summary_list::extrapolation_distribution_TSV(int i_g, int i_d, int i_b, int order_fit){
  static Logger logger("summary_list::extrapolation_TSV");
  logger.called();

  vector<double> X(3, 0.);
  vector<double> dX(3, 0.);

  // data_result_TSV[i_q][i_s][i_r][i_f]
  // xcontribution[0]->distribution_deviation_TSV[i_g][i_d][i_b] -> data_result_TSV
  // instead use:
  // distribution_result_qTcut_TSV[i_q][i_g][i_d][i_b][i_s][i_r][i_f]
  // extrapolation_result_TSV
  // instead use:
  // distribution_result_TSV[i_g][i_d][i_b]
  /*
  if (!(osi->value_qTcut_distribution.size() == data_result_TSV.size())){logger << LOG_WARN << "osi->value_qTcut_distribution.size() = " << osi->value_qTcut_distribution.size() << " != " << data_result_TSV.size() << " = data_result_TSV.size()" << endline_flush;}
  assert(osi->value_qTcut_distribution.size() == data_result_TSV.size());
  if (!(osi->value_qTcut_distribution.size() == data_deviation_TSV.size())){logger << LOG_WARN << "osi->value_qTcut_distribution.size() = " << osi->value_qTcut_distribution.size() << " != " << data_deviation_TSV.size() << " = data_deviation_TSV.size()" << endline_flush;}
  assert(osi->value_qTcut_distribution.size() == data_deviation_TSV.size());
  */
  static double xmin = ygeneric->min_qTcut_extrapolation;
  static double xmax = ygeneric->max_qTcut_extrapolation;
  static vector<double> xvalue = osi->value_qTcut_distribution;
  
  static int x_s = osi->no_reference_TSV;
  static int x_r = osi->no_scale_ren_reference_TSV;
  static int x_f = osi->no_scale_fact_reference_TSV;
  if (Log::getLogThreshold() <= LOG_DEBUG_VERBOSE){
    logger << LOG_DEBUG_VERBOSE << "x_s = " << x_s << endline_flush;
    logger << LOG_DEBUG_VERBOSE << "x_r = " << x_r << endline_flush;
    logger << LOG_DEBUG_VERBOSE << "x_f = " << x_f << endline_flush;
  }
  
  vector<vector<vector<double> > > deviation_extrapolation_TSV(osi->n_extended_set_TSV);
  for (int i_s = 0; i_s < osi->n_extended_set_TSV; i_s++){
    if (!ygeneric->switch_output_scaleset[i_s]){continue;}
    deviation_extrapolation_TSV[i_s].resize(osi->n_scale_ren_TSV[i_s], vector<double> (osi->n_scale_fact_TSV[i_s], 0.));
  }

  vector<vector<vector<double> > > deviation_statistics_TSV(osi->n_extended_set_TSV);
  for (int i_s = 0; i_s < osi->n_extended_set_TSV; i_s++){
    if (!ygeneric->switch_output_scaleset[i_s]){continue;}
    deviation_statistics_TSV[i_s].resize(osi->n_scale_ren_TSV[i_s], vector<double> (osi->n_scale_fact_TSV[i_s], 0.));
  }

  vector<vector<double> > twodim_chi2_dof(xvalue.size(), vector<double> (xvalue.size(), 1.e99));
  vector<vector<double> > twodim_extrapolation_result(xvalue.size(), vector<double> (xvalue.size(), 0.));
  vector<vector<double> > twodim_extrapolation_deviation(xvalue.size(), vector<double> (xvalue.size(), 0.));

  vector<double> data_result(xvalue.size());
  vector<double> data_deviation2(xvalue.size());

  for (int i_s = 0; i_s < distribution_result_TSV[i_g][i_d][i_b].size(); i_s++){
    for (int i_r = 0; i_r < distribution_result_TSV[i_g][i_d][i_b][i_s].size(); i_r++){
      for (int i_f = 0; i_f < distribution_result_TSV[i_g][i_d][i_b][i_s][i_r].size(); i_f++){
	for (int i_q = 0; i_q < xvalue.size(); i_q++){
	  data_result[i_q] = distribution_result_qTcut_TSV[i_q][i_g][i_d][i_b][i_s][i_r][i_f];
	  data_deviation2[i_q] = pow(distribution_deviation_qTcut_TSV[i_q][i_g][i_d][i_b][i_s][i_r][i_f], 2);
	}
	if (Log::getLogThreshold() <= LOG_DEBUG){
	  for (int i_q = 0; i_q < xvalue.size(); i_q++){
	    logger << LOG_DEBUG << setw(3) << i_q << "   qTcut = " << setw(10) << setprecision(5) << xvalue[i_q] << "   result = " << setw(15) << setprecision(8) << distribution_result_qTcut_TSV[i_q][i_g][i_d][i_b][i_s][i_r][i_f] << " +- " << setw(15) << setprecision(8) << distribution_deviation_qTcut_TSV[i_q][i_g][i_d][i_b][i_s][i_r][i_f] << endline_flush;
	  }
	}
	int no_xmin = 0;
	int no_xmax = 0;
	string extrapolation_info;

	extrapolation_fit_range_determination(xvalue, data_result, data_deviation2, twodim_extrapolation_result, twodim_extrapolation_deviation, twodim_chi2_dof, order_fit, no_xmin, no_xmax, xmin, xmax, extrapolation_info);
	deviation_extrapolation_TSV[i_s][i_r][i_f] = twodim_extrapolation_deviation[no_xmin][no_xmax];
	distribution_xmin_extrapolation_TSV[i_g][i_d][i_b][i_s][i_r][i_f] = xmin;
	distribution_xmax_extrapolation_TSV[i_g][i_d][i_b][i_s][i_r][i_f] = xmax;
	logger << LOG_DEBUG << "distribution_xmin/xmax_extrapolation_TSV[" << setw(1) << i_g << "][" << setw(2) << i_d << "][" << setw(2) << i_b << "][" << setw(1) << i_s << "][" << setw(1) << i_r << "][" << setw(1) << i_f << "] = " << distribution_xmin_extrapolation_TSV[i_g][i_d][i_b][i_s][i_r][i_f] << "   " << distribution_xmax_extrapolation_TSV[i_g][i_d][i_b][i_s][i_r][i_f] << "     xmin = " << xmin << "   xmax = " << xmax << endline_flush;
      }
    }
  }

  for (int i_s = 0; i_s < distribution_result_TSV[i_g][i_d][i_b].size(); i_s++){
    for (int i_r = 0; i_r < distribution_result_TSV[i_g][i_d][i_b][i_s].size(); i_r++){
      for (int i_f = 0; i_f < distribution_result_TSV[i_g][i_d][i_b][i_s][i_r].size(); i_f++){
	xmin = distribution_xmin_extrapolation_TSV[i_g][i_d][i_b][i_s][i_r][i_f];
	xmax = distribution_xmax_extrapolation_TSV[i_g][i_d][i_b][i_s][i_r][i_f];
	//	vector<double> data_result(xvalue.size());
	//	vector<double> data_deviation2(xvalue.size());
	for (int i_q = 0; i_q < xvalue.size(); i_q++){
	  data_result[i_q] = distribution_result_qTcut_TSV[i_q][i_g][i_d][i_b][i_s][i_r][i_f];
	  data_deviation2[i_q] = pow(distribution_deviation_qTcut_TSV[i_q][i_g][i_d][i_b][i_s][i_r][i_f], 2);
	}
	double chi2_dof = 0.;
	//	vector<double> X(3, 0.);
	//	vector<double> dX(3, 0.);
	if	(order_fit == 1){ extrapolation_linear(xvalue, xmin, xmax, data_result, data_deviation2, X, dX, chi2_dof); }
	else if (order_fit == 2){ extrapolation_quadratic(xvalue, xmin, xmax, data_result, data_deviation2, X, dX, chi2_dof); }
	else { extrapolation_function_gsl(xvalue, xmin, xmax, data_result, data_deviation2, X, dX, chi2_dof, order_fit); }
	//	else {logger << LOG_FATAL << "No fit order specified." << endline_flush; exit(1);}
	distribution_result_TSV[i_g][i_d][i_b][i_s][i_r][i_f] = X[0];

	// new here:
	double temp_error_fitvalue_at_fixed_qTcut = 0.;
	if	(order_fit == 1){  // (analytic) linear fit:  y(qTcut) = X[0] + qTcut * X[1]
	  temp_error_fitvalue_at_fixed_qTcut = abs(xmin * X[1]) / 2;
	}
	else if (order_fit == 2){  // (analytic) quadratic fit:  y(qTcut) = X[0] + qTcut * X[1] + qTcut² * X[2]
	  temp_error_fitvalue_at_fixed_qTcut = abs(xmin * X[1] + pow(xmin, 2) * X[2]) / 2;
	}
	else if (order_fit == 3){  // (numeric) fit:  y(qTcut) = X[0] + qTcut * X[1] + qTcut * log(qTcut) * X[3] + qTcut² * X[2] + qTcut² * log(qTcut) * X[4]
	  temp_error_fitvalue_at_fixed_qTcut = abs(xmin * X[1] + pow(xmin, 2) * X[2] + xmin * log(xmin) * X[3] + pow(xmin, 2) * log(xmin) * X[4]) / 2;
	}
	else { logger << LOG_INFO << "temp_error_fitvalue_at_fixed_qTcut needs to be defined." << endline_flush; }

	if (Log::getLogThreshold() <= LOG_DEBUG){
	  if (i_s == x_s && i_r == x_r && i_f == x_f){
	    logger << LOG_DEBUG << "extrapolation    = " << setw(15) << setprecision(8) << distribution_result_TSV[i_g][i_d][i_b][i_s][i_r][i_f] << "   chi2_dof = " << chi2_dof << endline_flush;
	    for (int i_q = 0; i_q < xvalue.size(); i_q++){
	      logger << LOG_DEBUG << "data_result[" << setw(3) << i_q << "] = " << setw(15) << setprecision(8) << data_result[i_q] << " +- " << setw(15) << setprecision(8) << sqrt(data_deviation2[i_q]) << endline_flush;
	    }
	  }
	}

	double extrapolation_plus = 0.;
	for (int i_q = 0; i_q < xvalue.size(); i_q++){
	  data_result[i_q] = distribution_result_qTcut_TSV[i_q][i_g][i_d][i_b][i_s][i_r][i_f] + distribution_deviation_qTcut_TSV[i_q][i_g][i_d][i_b][i_s][i_r][i_f];
	}
	if	(order_fit == 1){extrapolation_linear(xvalue, xmin, xmax, data_result, data_deviation2, X, dX, chi2_dof);}
	else if (order_fit == 2){extrapolation_quadratic(xvalue, xmin, xmax, data_result, data_deviation2, X, dX, chi2_dof);}
	else { extrapolation_function_gsl(xvalue, xmin, xmax, data_result, data_deviation2, X, dX, chi2_dof, order_fit); }
	//	else {logger << LOG_FATAL << "No fit order specified." << endline_flush; exit(1);}
	extrapolation_plus = X[0];

	double extrapolation_minus = 0.;
	for (int i_q = 0; i_q < xvalue.size(); i_q++){
	  data_result[i_q] = distribution_result_qTcut_TSV[i_q][i_g][i_d][i_b][i_s][i_r][i_f] - distribution_deviation_qTcut_TSV[i_q][i_g][i_d][i_b][i_s][i_r][i_f];
	}
	if	(order_fit == 1){extrapolation_linear(xvalue, xmin, xmax, data_result, data_deviation2, X, dX, chi2_dof);}
	else if (order_fit == 2){extrapolation_quadratic(xvalue, xmin, xmax, data_result, data_deviation2, X, dX, chi2_dof);}
	else { extrapolation_function_gsl(xvalue, xmin, xmax, data_result, data_deviation2, X, dX, chi2_dof, order_fit); }
	//	else {logger << LOG_FATAL << "No fit order specified." << endline_flush; exit(1);}
	extrapolation_minus = X[0];

	deviation_statistics_TSV[i_s][i_r][i_f] = (extrapolation_plus - extrapolation_minus) / 2;

	// larger error estimate for large uncertainty due to high lowest qTcut value
	if (temp_error_fitvalue_at_fixed_qTcut > deviation_extrapolation_TSV[i_s][i_r][i_f]){
	  if (Log::getLogThreshold() <= LOG_DEBUG_STEP){
	    logger << LOG_DEBUG_STEP << resultdirectory << "   Extrapolation error is changed due to fixed lowest value:" << endline_flush;
	    logger << LOG_DEBUG_STEP << "     old   deviation_extrapolation_TSV[" << i_s << "][" << i_r << "][" << i_f << "] = " << deviation_extrapolation_TSV[i_s][i_r][i_f] << endline_flush;
	    logger << LOG_DEBUG_STEP << "     new   deviation_extrapolation_TSV[" << i_s << "][" << i_r << "][" << i_f << "] = " << temp_error_fitvalue_at_fixed_qTcut << endline_flush;
	  }
	  deviation_extrapolation_TSV[i_s][i_r][i_f] = temp_error_fitvalue_at_fixed_qTcut;
	}
	else {
	  if (Log::getLogThreshold() <= LOG_DEBUG_STEP){
	    logger << LOG_DEBUG_STEP << resultdirectory << "   Extrapolation error is not changed due to fixed lowest value:" << endline_flush;
	    logger << LOG_DEBUG_STEP << "     old   deviation_extrapolation_TSV[" << i_s << "][" << i_r << "][" << i_f << "] = " << deviation_extrapolation_TSV[i_s][i_r][i_f] << endline_flush;
	    logger << LOG_DEBUG_STEP << "    (new)  deviation_extrapolation_TSV[" << i_s << "][" << i_r << "][" << i_f << "] = " << temp_error_fitvalue_at_fixed_qTcut << endline_flush;
	  }
	}
	
	//  pure statistical error, "extrapolated" to qTcut->0.
	//	distribution_deviation_TSV[i_g][i_d][i_b][i_s][i_r][i_f] = deviation_statistics_TSV[i_s][i_r][i_f];
	//  A further error estimate from the extrapolation curve (in particular its actually random fit range) added
	distribution_deviation_TSV[i_g][i_d][i_b][i_s][i_r][i_f] = sqrt(pow(deviation_statistics_TSV[i_s][i_r][i_f], 2) + pow(deviation_extrapolation_TSV[i_s][i_r][i_f], 2));

	if (Log::getLogThreshold() <= LOG_DEBUG){ logger << LOG_DEBUG << "distribution_result_TSV[" << i_g << "][" << i_d << "][" << i_b << "][" << i_s << "][" << i_r << "][" << i_f << "] = " << setw(15) << setprecision(8) << distribution_result_TSV[i_g][i_d][i_b][i_s][i_r][i_f] << " +- " << setw(15) << setprecision(8) << distribution_deviation_TSV[i_g][i_d][i_b][i_s][i_r][i_f] << "   [ " << setw(15) << setprecision(8) << deviation_statistics_TSV[i_s][i_r][i_f] << " (statistic) +- " << setw(15) << setprecision(8) << deviation_extrapolation_TSV[i_s][i_r][i_f] << " (extrapolation)" << " ]" << endline_flush; }
	if (Log::getLogThreshold() <= LOG_DEBUG_VERBOSE){
	  for (int i_q = 0; i_q < xvalue.size(); i_q++){
	    logger << LOG_DEBUG_VERBOSE << setw(3) << i_q << "   qTcut = " << setw(10) << setprecision(5) << xvalue[i_q] << "   result = " << setw(15) << setprecision(8) << distribution_result_qTcut_TSV[i_q][i_g][i_d][i_b][i_s][i_r][i_f] << " +- " << setw(15) << setprecision(8) << distribution_deviation_qTcut_TSV[i_q][i_g][i_d][i_b][i_s][i_r][i_f] << endline_flush;
	  }
	}
      }
    }
  }

  logger.finished();
}


// version with variation of lower and upper bound of the extrapolation range

void summary_list::extrapolation_fit_range_determination(vector<double> & xvalue, vector<double> & data_result, vector<double> & data_deviation2, vector<vector<double> > & twodim_extrapolation_result, vector<vector<double> > & twodim_extrapolation_deviation, vector<vector<double> > & twodim_chi2_dof, int order_fit, int & no_xmin, int & no_xmax, double & xmin, double & xmax, string & info_extrapolation){
  static Logger logger("extrapolation_fit_range_determination");
  logger.called();

  vector<double> X(3, 0.);
  vector<double> dX(3, 0.);

  int no_value_xmin = 0;
  for (int i_q = 0; i_q < xvalue.size(); i_q++){
    if (xvalue[i_q] >= xmin){no_value_xmin = i_q; break;}
  }

  stringstream temp_ss;
  temp_ss << left << endline;
  temp_ss << setw(20) << "xmin" << " = " << setw(5) << xmin << "  at qTcut value no. " << setw(3) << no_value_xmin << endline_flush;

  double eps = 1.e-12;
  // Replace  no_value_xmin  by  start_value_xmin  and  start_value_xmin :
  int start_value_xmin = 0;
  for (int i_q = 0; i_q < xvalue.size(); i_q++){if (xvalue[i_q] >= ygeneric->min_qTcut_extrapolation - eps){start_value_xmin = i_q; break;}}
  temp_ss << setw(20) << "start_value_xmin" << " = " << setw(5) << xvalue[start_value_xmin] << "  at qTcut value no. " << setw(3) << start_value_xmin << endline;

  int end_value_xmin = 0;
  for (int i_q = 0; i_q < xvalue.size(); i_q++){if (xvalue[i_q] >= ygeneric->max_min_value_extrapolation_range - eps){end_value_xmin = i_q; break;}}
  //    //    temp_ss << "xvalue[" << i_q << "] = " << xvalue[i_q] << " >= " << ygeneric->max_min_value_extrapolation_range << " = ygeneric->max_min_value_extrapolation_range" << endline;
  temp_ss << setw(20) << "end_value_xmin" << " = " << setw(5) << xvalue[end_value_xmin] << "  at qTcut value no. " << setw(3) << end_value_xmin << endline;
  
  int start_value_xmax = 0;
  for (int i_q = 0; i_q < xvalue.size(); i_q++){if (xvalue[i_q] >= ygeneric->min_max_value_extrapolation_range - eps){start_value_xmax = i_q; break;}}
  //  logger << LOG_DEBUG << resultdirectory << "   start_value_xmax  after   ygeneric->min_max_value_extrapolation_range = " << setw(5) << ygeneric->min_max_value_extrapolation_range << " : xvalue[" << setw(3) << start_value_xmax << "] = " << xvalue[start_value_xmax] << endline_flush;
  temp_ss << setw(20) << "start_value_xmax" << " = " << setw(5) << xvalue[start_value_xmax] << "  at qTcut value no. " << setw(3) << start_value_xmax << endline;

  /*
  if (start_value_xmax - no_value_xmin <= ygeneric->min_n_qTcut_extrapolation_range){start_value_xmax = no_value_xmin + ygeneric->min_n_qTcut_extrapolation_range;}
  logger << LOG_DEBUG << resultdirectory << "   start_value_xmax  after ygeneric->min_n_qTcut_extrapolation_range   = " << setw(5) << ygeneric->min_n_qTcut_extrapolation_range << " : xvalue[" << setw(3) << start_value_xmax << "] = " << xvalue[start_value_xmax] << endline_flush;
  temp_ss << setw(20) << "start_value_xmax" << " = " << setw(5) << xvalue[start_value_xmax] << "  at qTcut value no. " << setw(3) << start_value_xmax << endline;
  */
  
  int end_value_xmax = 0;
  for (int i_q = 0; i_q < xvalue.size(); i_q++){if (xvalue[i_q] >= ygeneric->max_qTcut_extrapolation - eps){end_value_xmax = i_q; break;}}
  //  for (int i_q = 0; i_q < xvalue.size(); i_q++){if (xvalue[i_q] >= ygeneric->max_qTcut_extrapolation){end_value_xmax = i_q + 1; break;}}
  //  temp_ss << setw(20) << "end_value_xmax" << " = " << setw(5) << end_value_xmax << " at qTcut value no_value_xmin = " << setw(3) << no_value_xmin << endline_flush;
  temp_ss << setw(20) << "end_value_xmax" << " = " << setw(5) << xvalue[end_value_xmax] << "  at qTcut value no. " << setw(3) << end_value_xmax << endline;
  temp_ss << endline;

  //  logger << LOG_INFO << resultdirectory << "   end_value_xmax  after ygeneric->max_qTcut_extrapolation             = " << setw(5) << ygeneric->max_qTcut_extrapolation << " : xvalue[" << setw(3) << end_value_xmax << "] = " << xvalue[end_value_xmax] << endline_flush;
  temp_ss << "Extrapolation performed in ranges between [ " << setw(5) << xvalue[start_value_xmin] << " ; " << setw(5) << xvalue[start_value_xmax] << " ]  and  [ " << setw(5) << xvalue[end_value_xmin] << " ; " << setw(5) << xvalue[end_value_xmax] << " ]" << endline;
  //  temp_ss << "Extrapolation performed in the ranges [ " << setw(5) << xmin << " ; " << setw(5) << xvalue[start_value_xmax] << " ]  to  [ " << setw(5) << xmin << " ; " << setw(5) << xvalue[end_value_xmax] << " ] ." << endline;
  temp_ss << endline;




  
  for (int i_q = start_value_xmin; i_q <= end_value_xmin; i_q++){
    for (int j_q = start_value_xmax; j_q <= end_value_xmax; j_q++){
      xmin = xvalue[i_q];
      xmax = xvalue[j_q];
      if ((xmax - xmin) < ygeneric->min_value_extrapolation_range){continue;}
      if ((j_q - i_q + 1) < ygeneric->min_n_qTcut_extrapolation_range){continue;}
      
      //      extrapolation_function_gsl(xvalue, xmin, xmax, data_result, data_deviation2, X, dX, twodim_chi2_dof[i_q][j_q], order_fit);
      
      if (order_fit == 1){extrapolation_linear(xvalue, xmin, xmax, data_result, data_deviation2, X, dX, twodim_chi2_dof[i_q][j_q]);}
      else if (order_fit == 2){extrapolation_quadratic(xvalue, xmin, xmax, data_result, data_deviation2, X, dX, twodim_chi2_dof[i_q][j_q]);}
      else {extrapolation_function_gsl(xvalue, xmin, xmax, data_result, data_deviation2, X, dX, twodim_chi2_dof[i_q][j_q], order_fit);}
      //      else {logger << LOG_FATAL << "No fit order specified." << endline_flush; exit(1);}
      twodim_extrapolation_result[i_q][j_q] = X[0];

      logger << LOG_DEBUG << "xvalue[" << setw(2) << i_q << "] = " << setw(8) << xvalue[i_q] << "   " << "xvalue[" << setw(2) << j_q << "] = " << setw(8) << xvalue[j_q] << "   twodim_chi2_dof[" << setw(2) << i_q << " ][" << setw(2) << j_q << "] = " << setw(15) << setprecision(8) << twodim_chi2_dof[i_q][j_q] << endline_flush;
      
      temp_ss << "[ " << setw(5) << xvalue[i_q] << " ; " << setw(5) << xvalue[j_q] << " ] :   extrapolated result = " << setw(15) << setprecision(8) << twodim_extrapolation_result[i_q][j_q] << "   chi2_dof = " << setw(15) << setprecision(8) << twodim_chi2_dof[i_q][j_q] << endline;
    }
  }
  temp_ss << endline;
  double temp_min = 1.e99;
  for (int i_q = start_value_xmin; i_q <= end_value_xmin; i_q++){
    for (int j_q = start_value_xmax; j_q <= end_value_xmax; j_q++){
      xmin = xvalue[i_q];
      xmax = xvalue[j_q];
      if ((xmax - xmin) < ygeneric->min_value_extrapolation_range){continue;}
      if ((j_q - i_q + 1) < ygeneric->min_n_qTcut_extrapolation_range){continue;}

      if (twodim_chi2_dof[i_q][j_q] < temp_min){temp_min = twodim_chi2_dof[i_q][j_q]; no_xmin = i_q; no_xmax = j_q;}
    }
  }
  logger << LOG_DEBUG << "minimum chi2:" << endline_flush;
  logger << LOG_DEBUG << "xvalue[" << setw(2) << no_xmin << "] = " << setw(8) << xvalue[no_xmin] << "   " << "xvalue[" << setw(2) << no_xmax << "] = " << setw(8) << xvalue[no_xmax] << "   twodim_chi2_dof[" << setw(2) << no_xmin << "][" << setw(2) << no_xmax << "] = " << setw(15) << setprecision(8) << twodim_chi2_dof[no_xmin][no_xmax] << endline_flush;

  /*
    not here ???
  xmin = xvalue[no_xmin];
  xmax = xvalue[no_xmax];
  */
  string order_fit_name;
  if (order_fit == 1){order_fit_name = "linear";}
  else if (order_fit == 2){order_fit_name = "quadratic";}
  else if (order_fit == 3){order_fit_name = "log-enhanced quadratic";}
  temp_ss << "  Best chi2 value from " << setw(9) << order_fit_name << "  fit in interval [ " << setw(5) << xvalue[no_xmin] << " ; " << setw(5) << xvalue[no_xmax] << " ]  for values " << no_xmin << " ; " << no_xmax << " :   " << setw(10) << "result" << " = " << setw(15) << setprecision(8) << twodim_extrapolation_result[no_xmin][no_xmax] << "   chi2 = " << setw(15) << setprecision(8) << twodim_chi2_dof[no_xmin][no_xmax] << endline_flush;

  double best_fit_result = twodim_extrapolation_result[no_xmin][no_xmax];
  double least_chi2 = twodim_chi2_dof[no_xmin][no_xmax];
  /*
  for (int i_q = start_value_xmax; i_q < xvalue.size(); i_q++){
    logger << LOG_INFO << "extrapolation[" << setw(2) << i_q << "] / best_fit_result = " << setw(8) << setprecision(5) << showpoint << right << (all_extrapolation_result[i_q] / best_fit_result - 1.) * 100 << " %   at relative chi2 = " << setw(8) << setprecision(5) << noshowpoint << left << all_chi2_dof[i_q] / least_chi2 << endline_flush;
  }
  */
  
  double chi2_range = ygeneric->error_extrapolation_range_chi2;
  //  int no_max_deviation_in_chi2_range = 0;
  int no_min_deviation_in_chi2_range = no_xmin;
  int no_max_deviation_in_chi2_range = no_xmax;
  double max_deviation_in_chi2_range = 0.;
  
  for (int i_q = start_value_xmin; i_q <= end_value_xmin; i_q++){
    for (int j_q = start_value_xmax; j_q <= end_value_xmax; j_q++){
      xmin = xvalue[i_q];
      xmax = xvalue[j_q];
      if ((xmax - xmin) < ygeneric->min_value_extrapolation_range){continue;}
      if ((j_q - i_q + 1) < ygeneric->min_n_qTcut_extrapolation_range){continue;}

      if (twodim_chi2_dof[i_q][j_q] / least_chi2 < chi2_range){
	if (abs(twodim_extrapolation_result[i_q][j_q] - best_fit_result) > max_deviation_in_chi2_range){
	  no_min_deviation_in_chi2_range = i_q;
	  no_max_deviation_in_chi2_range = j_q;
	  max_deviation_in_chi2_range = abs(twodim_extrapolation_result[i_q][j_q] - best_fit_result);
	}
      }
    }
  }

  /*
  xmin = xvalue[no_min_deviation_in_chi2_range];
  xmax = xvalue[no_max_deviation_in_chi2_range];
  */
  temp_ss << "Maximum deviation from " << setw(9) << order_fit_name << " fit in interval  [ " << setw(5) << xvalue[no_min_deviation_in_chi2_range] << " ; " << setw(5) << xvalue[no_max_deviation_in_chi2_range] << " ]  for values " << no_min_deviation_in_chi2_range << " ; " << no_max_deviation_in_chi2_range << " :   " << setw(10) << "deviation" << " = " << setw(15) << setprecision(8) << max_deviation_in_chi2_range << "   chi2 = " << setw(15) << setprecision(8) << twodim_chi2_dof[no_min_deviation_in_chi2_range][no_max_deviation_in_chi2_range] << "   chi2 ratio = " << setw(15) << setprecision(8) << twodim_chi2_dof[no_min_deviation_in_chi2_range][no_max_deviation_in_chi2_range] / least_chi2 << "   " << endline_flush;
  temp_ss << endline;
  logger << LOG_INFO << temp_ss.str() << endline_flush;
  info_extrapolation = temp_ss.str();
  twodim_extrapolation_deviation[no_xmin][no_xmax] = max_deviation_in_chi2_range;

  // in order to store the values used for the best fit:
  xmin = xvalue[no_xmin];
  xmax = xvalue[no_xmax];

  logger.finished();
}



// used in distributions so far:

void summary_list::extrapolation_TSV(int i_g, int i_d, int i_b, vector<double> & xvalue, vector<vector<vector<vector<double> > > > & data_result_TSV, vector<vector<vector<vector<double> > > > & data_deviation_TSV, vector<vector<vector<double> > > & extrapolation_result_TSV, vector<vector<vector<double> > > & extrapolation_deviation_TSV, int order_fit){
  static Logger logger("summary_list::extrapolation_TSV");
  logger.called();

  if (!(xvalue.size() == data_result_TSV.size())){logger << LOG_WARN << "xvalue.size() = " << xvalue.size() << " != " << data_result_TSV.size() << " = data_result_TSV.size()" << endline_flush;}
  assert(xvalue.size() == data_result_TSV.size());
  if (!(xvalue.size() == data_deviation_TSV.size())){logger << LOG_WARN << "xvalue.size() = " << xvalue.size() << " != " << data_deviation_TSV.size() << " = data_deviation_TSV.size()" << endline_flush;}
  assert(xvalue.size() == data_deviation_TSV.size());

  static double xmin = ygeneric->min_qTcut_extrapolation;
  static double xmax = ygeneric->max_qTcut_extrapolation;

  static int x_s = osi->no_reference_TSV;
  static int x_r = osi->no_scale_ren_reference_TSV;
  static int x_f = osi->no_scale_fact_reference_TSV;
  logger << LOG_DEBUG << "x_s = " << x_s << endline_flush;
  logger << LOG_DEBUG << "x_r = " << x_r << endline_flush;
  logger << LOG_DEBUG << "x_f = " << x_f << endline_flush;

  vector<vector<vector<double> > > new_extrapolation_deviation_TSV(osi->n_extended_set_TSV);
  for (int i_s = 0; i_s < osi->n_extended_set_TSV; i_s++){
    if (!ygeneric->switch_output_scaleset[i_s]){continue;}
    new_extrapolation_deviation_TSV[i_s].resize(osi->n_scale_ren_TSV[i_s], vector<double> (osi->n_scale_fact_TSV[i_s], 0.));
  }

  /*
  vector<double> all_chi2_dof(xvalue.size(), 1.e99);
  vector<double> all_extrapolation_result(xvalue.size(), 0.);
  vector<double> all_extrapolation_deviation(xvalue.size(), 0.);
  */
  // new:
  vector<vector<double> > twodim_chi2_dof(xvalue.size(), vector<double> (xvalue.size(), 1.e99));
  vector<vector<double> > twodim_extrapolation_result(xvalue.size(), vector<double> (xvalue.size(), 0.));
  vector<vector<double> > twodim_extrapolation_deviation(xvalue.size(), vector<double> (xvalue.size(), 0.));

  vector<double> X(3, 0.);
  vector<double> dX(3, 0.);
  vector<double> data_result(xvalue.size());
  vector<double> data_deviation2(xvalue.size());

  for (int i_s = 0; i_s < extrapolation_result_TSV.size(); i_s++){
    for (int i_r = 0; i_r < extrapolation_result_TSV[i_s].size(); i_r++){
      for (int i_f = 0; i_f < extrapolation_result_TSV[i_s][i_r].size(); i_f++){

	for (int i_q = 0; i_q < xvalue.size(); i_q++){
	  data_result[i_q] = data_result_TSV[i_q][i_s][i_r][i_f];
	  data_deviation2[i_q] = pow(data_deviation_TSV[i_q][i_s][i_r][i_f], 2);
	}
	for (int i_q = 0; i_q < xvalue.size(); i_q++){
	  logger << LOG_DEBUG << setw(3) << i_q << "   qTcut = " << setw(10) << setprecision(5) << xvalue[i_q] << "   result = " << setw(15) << setprecision(8) << data_result_TSV[i_q][i_s][i_r][i_f] << " +- " << setw(15) << setprecision(8) << data_deviation_TSV[i_q][i_s][i_r][i_f] << endline_flush;
	}
	// new: no_xmin
	int no_xmin = 0;
	int no_xmax = 0;
	string extrapolation_info;

	// new: min and max varied
	extrapolation_fit_range_determination(xvalue, data_result, data_deviation2, twodim_extrapolation_result, twodim_extrapolation_deviation, twodim_chi2_dof, order_fit, no_xmin, no_xmax, xmin, xmax, extrapolation_info);
	new_extrapolation_deviation_TSV[i_s][i_r][i_f] = twodim_extrapolation_deviation[no_xmin][no_xmax];
	distribution_xmin_extrapolation_TSV[i_g][i_d][i_b][i_s][i_r][i_f] = xmin;
	distribution_xmax_extrapolation_TSV[i_g][i_d][i_b][i_s][i_r][i_f] = xmax;
	// old: only max varied
	//	extrapolation_fit_range_determination(xvalue, data_result, data_deviation2, all_extrapolation_result, all_extrapolation_deviation, all_chi2_dof, order_fit, no_xmax, xmin, xmax, extrapolation_info);
	//	new_extrapolation_deviation_TSV[i_s][i_r][i_f] = all_extrapolation_deviation[no_xmax];
	logger << LOG_DEBUG << "distribution_xmin/xmax_extrapolation_TSV[" << setw(1) << i_g << "][" << setw(2) << i_d << "][" << setw(2) << i_b << "][" << setw(1) << i_s << "][" << setw(1) << i_r << "][" << setw(1) << i_f << "] = " << distribution_xmin_extrapolation_TSV[i_g][i_d][i_b][i_s][i_r][i_f] << "   " << distribution_xmax_extrapolation_TSV[i_g][i_d][i_b][i_s][i_r][i_f] << "     xmin = " << xmin << "   xmax = " << xmax << endline_flush;
      }
    }
  }
  /*
  xmax = ygeneric->max_qTcut_extrapolation;
  logger << LOG_DEBUG << "Fit performed with the standard value xmax = " << xmax << endline_flush;
  // to be improved - optimize range as for cross section !!!
  */


  for (int i_s = 0; i_s < extrapolation_result_TSV.size(); i_s++){
    for (int i_r = 0; i_r < extrapolation_result_TSV[i_s].size(); i_r++){
      for (int i_f = 0; i_f < extrapolation_result_TSV[i_s][i_r].size(); i_f++){
	// new: xmin and xmax  from  extrapolation_fit_range_determination
	xmin = distribution_xmin_extrapolation_TSV[i_g][i_d][i_b][i_s][i_r][i_f];
	xmax = distribution_xmax_extrapolation_TSV[i_g][i_d][i_b][i_s][i_r][i_f];

	vector<double> data_result(xvalue.size());
	vector<double> data_deviation2(xvalue.size());
	for (int i_q = 0; i_q < xvalue.size(); i_q++){
	  data_result[i_q] = data_result_TSV[i_q][i_s][i_r][i_f];
	  data_deviation2[i_q] = pow(data_deviation_TSV[i_q][i_s][i_r][i_f], 2);
	}
	double chi2_dof = 0.;
	vector<double> X(3, 0.);
	vector<double> dX(3, 0.);

	if	(order_fit == 1){extrapolation_linear(xvalue, xmin, xmax, data_result, data_deviation2, X, dX, chi2_dof);}
	else if (order_fit == 2){extrapolation_quadratic(xvalue, xmin, xmax, data_result, data_deviation2, X, dX, chi2_dof);}
	else {logger << LOG_FATAL << "No fit order specified." << endline_flush; exit(1);}
	extrapolation_result_TSV[i_s][i_r][i_f] = X[0];

	double extrapolation_plus = 0.;
	for (int i_q = 0; i_q < xvalue.size(); i_q++){
	  data_result[i_q] = data_result_TSV[i_q][i_s][i_r][i_f] + data_deviation_TSV[i_q][i_s][i_r][i_f];
	}
	X.resize(3, 0.);
	dX.resize(3, 0.);
	if	(order_fit == 1){extrapolation_linear(xvalue, xmin, xmax, data_result, data_deviation2, X, dX, chi2_dof);}
	else if (order_fit == 2){extrapolation_quadratic(xvalue, xmin, xmax, data_result, data_deviation2, X, dX, chi2_dof);}
	else {logger << LOG_FATAL << "No fit order specified." << endline_flush; exit(1);}
	extrapolation_plus = X[0];

	double extrapolation_minus = 0.;
	for (int i_q = 0; i_q < xvalue.size(); i_q++){
	  data_result[i_q] = data_result_TSV[i_q][i_s][i_r][i_f] - data_deviation_TSV[i_q][i_s][i_r][i_f];
	}
	X.resize(3, 0.);
	dX.resize(3, 0.);
	if	(order_fit == 1){extrapolation_linear(xvalue, xmin, xmax, data_result, data_deviation2, X, dX, chi2_dof);}
	else if (order_fit == 2){extrapolation_quadratic(xvalue, xmin, xmax, data_result, data_deviation2, X, dX, chi2_dof);}
	else {logger << LOG_FATAL << "No fit order specified." << endline_flush; exit(1);}
	extrapolation_minus = X[0];

	extrapolation_deviation_TSV[i_s][i_r][i_f] = (extrapolation_plus - extrapolation_minus) / 2;
	//  pure statistical error, "extrapolated" to qTcut->0.
	//  A further error estimate from the extrapolation curve (in particular its actually random fit range) should be added !!!

	logger << LOG_INFO << "extrapolation_result_TSV[" << i_s << "][" << i_r << "][" << i_f << "] = " << setw(15) << setprecision(8) << extrapolation_result_TSV[i_s][i_r][i_f] << " +- " << setw(15) << setprecision(8) << extrapolation_deviation_TSV[i_s][i_r][i_f] << " (statistic) +- " << new_extrapolation_deviation_TSV[i_s][i_r][i_f] << " (extrapolation)" << endline_flush;

	/*
	for (int i_q = 0; i_q < xvalue.size(); i_q++){
	  logger << LOG_INFO << setw(3) << i_q << "   qTcut = " << setw(10) << setprecision(5) << xvalue[i_q] << "   result = " << setw(15) << setprecision(8) << data_result_TSV[i_q][i_s][i_r][i_f] << " +- " << setw(15) << setprecision(8) << data_deviation_TSV[i_q][i_s][i_r][i_f] << endline_flush;
	}
	*/
      }
    }
  }

  logger.finished();
}





// All functions below are only relevant for CV variation:

void summary_list::extrapolation_CV(int order_fit){
  static Logger logger("summary_list::extrapolation_CV");
  logger.called();

  for (int i_m = 0; i_m < osi->n_moments; i_m++){
    //    if (i_m > 0){continue;} // no moments implemented so far !!!
    for (int i_g = 0; i_g < ygeneric->subgroup.size(); i_g++){

      if (!(osi->value_qTcut.size() == xcontribution[0]->result_CV[i_m][i_g].size())){logger << LOG_WARN << "osi->value_qTcut.size() = " << osi->value_qTcut.size() << " != " << xcontribution[0]->result_CV[i_m][i_g].size() << " = xcontribution[0]->result_CV[i_m][i_g].size()" << endline_flush;}
      assert(osi->value_qTcut.size() == xcontribution[0]->result_CV[i_m][i_g].size());
      if (!(osi->value_qTcut.size() == xcontribution[0]->deviation_CV[i_m][i_g].size())){logger << LOG_WARN << "osi->value_qTcut.size() = " << osi->value_qTcut.size() << " != " << xcontribution[0]->deviation_CV[i_m][i_g].size() << " = xcontribution[0]->deviation_CV[i_m][i_g].size()" << endline_flush;}
      assert(osi->value_qTcut.size() == xcontribution[0]->deviation_CV[i_m][i_g].size());

      static double xmin = ygeneric->min_qTcut_extrapolation;
      static double xmax = ygeneric->max_qTcut_extrapolation;

      static int x_s = (osi->n_scales_CV - 1 ) / 2;
      logger << LOG_DEBUG << "x_s = " << x_s << endline_flush;

      vector<double> all_chi2_dof(osi->value_qTcut.size(), 1.e99);
      vector<double> all_extrapolation_result(osi->value_qTcut.size(), 0.);
      vector<double> all_extrapolation_deviation(osi->value_qTcut.size(), 0.);
      vector<double> X(3, 0.);
      vector<double> dX(3, 0.);
      vector<double> data_result(osi->value_qTcut.size());
      vector<double> data_deviation2(osi->value_qTcut.size());

      vector<int> no_xmax_CV(osi->n_scales_CV, 0);

      for (int i_s = 0; i_s < result_CV[i_m][i_g].size(); i_s++){
	for (int i_q = 0; i_q < osi->value_qTcut.size(); i_q++){
	  data_result[i_q] = xcontribution[0]->result_CV[i_m][i_g][i_q][i_s];
	  data_deviation2[i_q] = pow(xcontribution[0]->deviation_CV[i_m][i_g][i_q][i_s], 2);
	}
	int no_xmax = 0;
	string extrapolation_info;
	//	logger << LOG_INFO << "Extrapolation at i_s = " << i_s << endline_flush;
	extrapolation_fit_range_determination(osi->value_qTcut, data_result, data_deviation2, all_extrapolation_result, all_extrapolation_deviation, all_chi2_dof, order_fit, no_xmax, xmin, xmax, extrapolation_info);
	//	logger << LOG_INFO << "Extrapolation between  " << xmin << "  and  " << xmax << "  considered optimal." << endline_flush;
	logger << LOG_INFO << "(extrapolation_fit_range_determination)" << endline << endline << left << resultdirectory << "   i_s = " << i_s << " :" << endline << extrapolation_info << endline_flush;

	deviation_extrapolation_CV[i_m][i_g][i_s] = all_extrapolation_deviation[no_xmax];
	no_xmax_CV[i_s] = no_xmax;
      }

      for (int i_s = 0; i_s < result_CV[i_m][i_g].size(); i_s++){
	xmax = osi->value_qTcut[no_xmax_CV[i_s]];
	vector<double> data_result(osi->value_qTcut.size());
	vector<double> data_deviation2(osi->value_qTcut.size());
	for (int i_q = 0; i_q < osi->value_qTcut.size(); i_q++){
	  data_result[i_q] = xcontribution[0]->result_CV[i_m][i_g][i_q][i_s];
	  data_deviation2[i_q] = pow(xcontribution[0]->deviation_CV[i_m][i_g][i_q][i_s], 2);
	}
	double chi2_dof = 0.;
	vector <double> X(3, 0.);
	vector <double> dX(3, 0.);
	if	(order_fit == 1){extrapolation_linear(osi->value_qTcut, xmin, xmax, data_result, data_deviation2, X, dX, chi2_dof);}
	else if (order_fit == 2){extrapolation_quadratic(osi->value_qTcut, xmin, xmax, data_result, data_deviation2, X, dX, chi2_dof);}
	else {logger << LOG_FATAL << "No fit order specified." << endline_flush; exit(1);}
	result_CV[i_m][i_g][i_s] = X[0];
	//    out_chi2[i_s] = chi2_dof;

	double temp_error_fitvalue_at_fixed_qTcut = 0.;
	if	(order_fit == 1){
	  //	  y(qTcut) = X[0] + qTcut * X[1]
	  //	  temp_error_fitvalue_at_fixed_qTcut = abs(osi->value_qTcut[no_value_xmin] * X[1]) / 2;
	  temp_error_fitvalue_at_fixed_qTcut = abs(xmin * X[1]) / 2;
	}
	else if (order_fit == 2){
	  //	  y(qTcut) = X[0] + qTcut * X[1] + qTcut² * X[2]
	  //	  temp_error_fitvalue_at_fixed_qTcut = abs(osi->value_qTcut[no_value_xmin] * X[1] + pow(osi->value_qTcut[no_value_xmin], 2) * X[2]) / 2;
	  temp_error_fitvalue_at_fixed_qTcut = abs(xmin * X[1] + pow(xmin, 2) * X[2]) / 2;
	}

	double extrapolation_plus = 0.;
	for (int i_q = 0; i_q < osi->value_qTcut.size(); i_q++){
	  data_result[i_q] = xcontribution[0]->result_CV[i_m][i_g][i_q][i_s] + xcontribution[0]->deviation_CV[i_m][i_g][i_q][i_s];
	}
	X.resize(3, 0.);
	dX.resize(3, 0.);
	if	(order_fit == 1){extrapolation_linear(osi->value_qTcut, xmin, xmax, data_result, data_deviation2, X, dX, chi2_dof);}
	else if (order_fit == 2){extrapolation_quadratic(osi->value_qTcut, xmin, xmax, data_result, data_deviation2, X, dX, chi2_dof);}
	else {logger << LOG_FATAL << "No fit order specified." << endline_flush; exit(1);}
	extrapolation_plus = X[0];

	double extrapolation_minus = 0.;
	for (int i_q = 0; i_q < osi->value_qTcut.size(); i_q++){
	  data_result[i_q] = xcontribution[0]->result_CV[i_m][i_g][i_q][i_s] - xcontribution[0]->deviation_CV[i_m][i_g][i_q][i_s];
	}
	X.resize(3, 0.);
	dX.resize(3, 0.);
	if	(order_fit == 1){extrapolation_linear(osi->value_qTcut, xmin, xmax, data_result, data_deviation2, X, dX, chi2_dof);}
	else if (order_fit == 2){extrapolation_quadratic(osi->value_qTcut, xmin, xmax, data_result, data_deviation2, X, dX, chi2_dof);}
	else {logger << LOG_FATAL << "No fit order specified." << endline_flush; exit(1);}
	extrapolation_minus = X[0];


	// larger error estimate for large uncetainty due to high lowest qTcut value:

	if (temp_error_fitvalue_at_fixed_qTcut > deviation_extrapolation_CV[i_m][i_g][i_s]){
	  logger << LOG_INFO << resultdirectory << "   Extrapolation error is changed due to fixed lowest value:" << endline_flush;
	  logger << LOG_INFO << "     old   deviation_extrapolation_CV[" << i_m << "][" << i_g << "][" << i_s << "] = " << deviation_extrapolation_CV[i_m][i_g][i_s] << endline_flush;
	  deviation_extrapolation_CV[i_m][i_g][i_s] = temp_error_fitvalue_at_fixed_qTcut;
	  logger << LOG_INFO << "     new   deviation_extrapolation_CV[" << i_m << "][" << i_g << "][" << i_s << "] = " << deviation_extrapolation_CV[i_m][i_g][i_s] << endline_flush;
	}
	else {
	  logger << LOG_INFO << resultdirectory << "   Extrapolation error is not changed due to fixed lowest value:" << endline_flush;
	  logger << LOG_INFO << "     old   deviation_extrapolation_CV[" << i_m << "][" << i_g << "][" << i_s << "] = " << deviation_extrapolation_CV[i_m][i_g][i_s] << endline_flush;
	  logger << LOG_INFO << "    (new)  deviation_extrapolation_CV[" << i_m << "][" << i_g << "][" << i_s << "] = " << temp_error_fitvalue_at_fixed_qTcut << endline_flush;
	}

	deviation_statistics_CV[i_m][i_g][i_s] = (extrapolation_plus - extrapolation_minus) / 2;

	deviation_CV[i_m][i_g][i_s] = sqrt(pow(deviation_statistics_CV[i_m][i_g][i_s], 2) + pow(deviation_extrapolation_CV[i_m][i_g][i_s], 2));

	logger << LOG_INFO << "result_CV[" << i_m << "][" << i_g << "][" << i_s << "] = " << endl << setw(15) << setprecision(8) << result_CV[i_m][i_g][i_s] << " +- " << setw(15) << setprecision(8) << deviation_CV[i_m][i_g][i_s] << "    [ " << setw(15) << setprecision(8) << deviation_statistics_CV[i_m][i_g][i_s] << " (statistics) +- " << deviation_extrapolation_CV[i_m][i_g][i_s] << " (extrapolation)" << " ]" << endline_flush;


	for (int i_q = 0; i_q < osi->value_qTcut.size(); i_q += 5){
	  logger << LOG_INFO << setw(3) << i_q << "   qTcut = " << setw(10) << setprecision(5) << osi->value_qTcut[i_q] << "   result = " << setw(15) << setprecision(8) << xcontribution[0]->result_CV[i_m][i_g][i_q][i_s] << " +- " << setw(15) << setprecision(8) << xcontribution[0]->deviation_CV[i_m][i_g][i_q][i_s] << endline_flush;
	}
      }
    }
  }

  logger.finished();
}


void summary_list::extrapolation_CV(vector<double> & xvalue, vector<vector<double> > & data_result_CV, vector<vector<double> > & data_deviation_CV, vector<double> & extrapolation_result_CV, vector<double> & extrapolation_deviation_CV, int order_fit){
  static Logger logger("summary_list::extrapolation_CV");
  logger.called();

  if (!(xvalue.size() == data_result_CV.size())){logger << LOG_WARN << "xvalue.size() = " << xvalue.size() << " != " << data_result_CV.size() << " = data_result_CV.size()" << endline_flush;}
  assert(xvalue.size() == data_result_CV.size());
  if (!(xvalue.size() == data_deviation_CV.size())){logger << LOG_WARN << "xvalue.size() = " << xvalue.size() << " != " << data_deviation_CV.size() << " = data_deviation_CV.size()" << endline_flush;}
  assert(xvalue.size() == data_deviation_CV.size());

  static double xmin = ygeneric->min_qTcut_extrapolation;
  static double xmax = ygeneric->max_qTcut_extrapolation;

  static int x_s = (osi->n_scales_CV - 1 ) / 2;
  logger << LOG_DEBUG << "x_s = " << x_s << endline_flush;

  vector<double> new_extrapolation_deviation_CV(osi->n_scales_CV, 0.);

  vector<double> all_chi2_dof(xvalue.size(), 1.e99);
  vector<double> all_extrapolation_result(xvalue.size(), 0.);
  vector<double> all_extrapolation_deviation(xvalue.size(), 0.);
  vector<double> X(3, 0.);
  vector<double> dX(3, 0.);
  vector<double> data_result(xvalue.size());
  vector<double> data_deviation2(xvalue.size());


  for (int i_s = 0; i_s < extrapolation_result_CV.size(); i_s++){
    for (int i_q = 0; i_q < xvalue.size(); i_q++){
      data_result[i_q] = data_result_CV[i_q][i_s];
      data_deviation2[i_q] = pow(data_deviation_CV[i_q][i_s], 2);
    }
    int no_xmax = 0;
    logger << LOG_DEBUG << "Extrapolation at i_s = " << i_s << endline_flush;
    string extrapolation_info;
    extrapolation_fit_range_determination(xvalue, data_result, data_deviation2, all_extrapolation_result, all_extrapolation_deviation, all_chi2_dof, order_fit, no_xmax, xmin, xmax, extrapolation_info);

    new_extrapolation_deviation_CV[i_s] = all_extrapolation_deviation[no_xmax];
  }
  /*
  for (int i_q = 0; i_q < xvalue.size(); i_q++){
    data_result[i_q] = data_result_CV[i_q][x_s];
    data_deviation2[i_q] = pow(data_deviation_CV[i_q][x_s], 2);
  }
  int no_xmax = 0;

  string extrapolation_info;
  extrapolation_fit_range_determination(xvalue, data_result, data_deviation2, all_extrapolation_result, all_extrapolation_deviation, all_chi2_dof, order_fit, no_xmax, xmin, xmax, extrapolation_info);
  */

  xmax = ygeneric->max_qTcut_extrapolation;
  logger << LOG_DEBUG << "Fit performed with the standard value xmax = " << xmax << endline_flush;



  for (int i_s = 0; i_s < extrapolation_result_CV.size(); i_s++){
    vector<double> data_result(xvalue.size());
    vector<double> data_deviation2(xvalue.size());
    for (int i_q = 0; i_q < xvalue.size(); i_q++){
      data_result[i_q] = data_result_CV[i_q][i_s];
      data_deviation2[i_q] = pow(data_deviation_CV[i_q][i_s], 2);
    }
    double chi2_dof = 0.;
    vector <double> X(3, 0.);
    vector <double> dX(3, 0.);
    if	(order_fit == 1){extrapolation_linear(xvalue, xmin, xmax, data_result, data_deviation2, X, dX, chi2_dof);}
    else if (order_fit == 2){extrapolation_quadratic(xvalue, xmin, xmax, data_result, data_deviation2, X, dX, chi2_dof);}
    else {logger << LOG_FATAL << "No fit order specified." << endline_flush; exit(1);}
    extrapolation_result_CV[i_s] = X[0];
    //    out_chi2[i_s] = chi2_dof;

    /*
    if (i_s == 0){
      logger << LOG_DEBUG << "extrapolation    = " << setw(15) << setprecision(8) << extrapolation_result_CV[i_s] << "   chi2_dof = " << chi2_dof << endline_flush;
      for (int i_q = 0; i_q < xvalue.size(); i_q++){
	logger << LOG_DEBUG << "data_result[" << setw(3) << i_q << "] = " << setw(15) << setprecision(8) << data_result[i_q] << " +- " << setw(15) << setprecision(8) << sqrt(data_deviation2[i_q]) << endline_flush;
      }
    }
    */

    double extrapolation_plus = 0.;
    for (int i_q = 0; i_q < xvalue.size(); i_q++){
      data_result[i_q] = data_result_CV[i_q][i_s] + data_deviation_CV[i_q][i_s];
    }
    X.resize(3, 0.);
    dX.resize(3, 0.);
    if	(order_fit == 1){extrapolation_linear(xvalue, xmin, xmax, data_result, data_deviation2, X, dX, chi2_dof);}
    else if (order_fit == 2){extrapolation_quadratic(xvalue, xmin, xmax, data_result, data_deviation2, X, dX, chi2_dof);}
    else {logger << LOG_FATAL << "No fit order specified." << endline_flush; exit(1);}
    extrapolation_plus = X[0];

    double extrapolation_minus = 0.;
    for (int i_q = 0; i_q < xvalue.size(); i_q++){
      data_result[i_q] = data_result_CV[i_q][i_s] - data_deviation_CV[i_q][i_s];
    }
    X.resize(3, 0.);
    dX.resize(3, 0.);
    if	(order_fit == 1){extrapolation_linear(xvalue, xmin, xmax, data_result, data_deviation2, X, dX, chi2_dof);}
    else if (order_fit == 2){extrapolation_quadratic(xvalue, xmin, xmax, data_result, data_deviation2, X, dX, chi2_dof);}
    else {logger << LOG_FATAL << "No fit order specified." << endline_flush; exit(1);}
    extrapolation_minus = X[0];

    extrapolation_deviation_CV[i_s] = (extrapolation_plus - extrapolation_minus) / 2;

    logger << LOG_INFO << "extrapolation_result_CV[" << i_s << "] = " << setw(15) << setprecision(8) << extrapolation_result_CV[i_s] << " +- " << setw(15) << setprecision(8) << extrapolation_deviation_CV[i_s] << " (statistic) +- " << new_extrapolation_deviation_CV[i_s] << " (extrapolation)" << endline_flush;
    for (int i_q = 0; i_q < xvalue.size(); i_q += 5){
      logger << LOG_DEBUG << setw(3) << i_q << "   qTcut = " << setw(10) << setprecision(5) << xvalue[i_q] << "   result = " << setw(15) << setprecision(8) << data_result_CV[i_q][i_s] << " +- " << setw(15) << setprecision(8) << data_deviation_CV[i_q][i_s] << endline_flush;
    }
  }

  logger.finished();
}


void summary_list::extrapolation_fit_range_determination(vector<double> & xvalue, vector<double> & data_result, vector<double> & data_deviation2, vector<double> & all_extrapolation_result, vector<double> & all_extrapolation_deviation, vector<double> & all_chi2_dof, int order_fit, int & no_xmax, double & xmin, double & xmax, string & info_extrapolation){
  static Logger logger("extrapolation_fit_range_determination");
  logger.called();

  vector<double> X(3, 0.);
  vector<double> dX(3, 0.);

  int no_value_xmin = 0;
  for (int i_q = 0; i_q < xvalue.size(); i_q++){
    if (xvalue[i_q] >= xmin){no_value_xmin = i_q; break;}
  }

  stringstream temp_ss;
  temp_ss << left << endline;
  temp_ss << setw(20) << "xmin" << " = " << setw(5) << xmin << "  at qTcut value no. " << setw(3) << no_value_xmin << endline_flush;

  int start_value_xmax = 0;
  for (int i_q = 0; i_q < xvalue.size(); i_q++){if (xvalue[i_q] >= ygeneric->min_max_value_extrapolation_range){start_value_xmax = i_q; break;}}
  logger << LOG_DEBUG << resultdirectory << "   start_value_xmax  after   ygeneric->min_max_value_extrapolation_range = " << setw(5) << ygeneric->min_max_value_extrapolation_range << " : xvalue[" << setw(3) << start_value_xmax << "] = " << xvalue[start_value_xmax] << endline_flush;

  if (start_value_xmax < no_value_xmin + ygeneric->min_n_qTcut_extrapolation_range){start_value_xmax = no_value_xmin + ygeneric->min_n_qTcut_extrapolation_range;}
  logger << LOG_DEBUG << resultdirectory << "   start_value_xmax  after ygeneric->min_n_qTcut_extrapolation_range   = " << setw(5) << ygeneric->min_n_qTcut_extrapolation_range << " : xvalue[" << setw(3) << start_value_xmax << "] = " << xvalue[start_value_xmax] << endline_flush;
  temp_ss << setw(20) << "start_value_xmax" << " = " << setw(5) << xvalue[start_value_xmax] << "  at qTcut value no. " << setw(3) << start_value_xmax << endline;

  int end_value_xmax = 0;
  //  int end_value_xmax = xvalue.size();
  for (int i_q = 0; i_q < xvalue.size(); i_q++){if (xvalue[i_q] >= ygeneric->max_qTcut_extrapolation){end_value_xmax = i_q; break;}}
  //  for (int i_q = 0; i_q < xvalue.size(); i_q++){if (xvalue[i_q] >= ygeneric->max_qTcut_extrapolation){end_value_xmax = i_q + 1; break;}}
  //  temp_ss << setw(20) << "end_value_xmax" << " = " << setw(5) << end_value_xmax << " at qTcut value no_value_xmin = " << setw(3) << no_value_xmin << endline_flush;
  temp_ss << setw(20) << "end_value_xmax" << " = " << setw(5) << xvalue[end_value_xmax] << "  at qTcut value no. " << setw(3) << end_value_xmax << endline;
  temp_ss << endline;

  //  logger << LOG_INFO << resultdirectory << "   end_value_xmax  after ygeneric->max_qTcut_extrapolation             = " << setw(5) << ygeneric->max_qTcut_extrapolation << " : xvalue[" << setw(3) << end_value_xmax << "] = " << xvalue[end_value_xmax] << endline_flush;
  temp_ss << "Extrapolation performed in the ranges [ " << setw(5) << xmin << " ; " << setw(5) << xvalue[start_value_xmax] << " ]  to  [ " << setw(5) << xmin << " ; " << setw(5) << xvalue[end_value_xmax] << " ] ." << endline;
  temp_ss << endline;

  for (int i_q = start_value_xmax; i_q <= end_value_xmax; i_q++){
    //  for (int i_q = start_value_xmax; i_q < xvalue.size(); i_q++){
    xmax = xvalue[i_q];

    //    extrapolation_function_gsl(xvalue, xmin, xmax, data_result, data_deviation2, X, dX, all_chi2_dof[i_q], order_fit);
    if (order_fit == 1){extrapolation_linear(xvalue, xmin, xmax, data_result, data_deviation2, X, dX, all_chi2_dof[i_q]);}
    else if (order_fit == 2){extrapolation_quadratic(xvalue, xmin, xmax, data_result, data_deviation2, X, dX, all_chi2_dof[i_q]);}
    //    if (order_fit == 1){extrapolation_linear(xvalue, xmin, xmax, data_result, data_deviation2, X, dX, all_chi2_dof[i_q]);}
    //    else if (order_fit == 2){extrapolation_quadratic(xvalue, xmin, xmax, data_result, data_deviation2, X, dX, all_chi2_dof[i_q]);}
    else {logger << LOG_FATAL << "No fit order specified." << endline_flush; exit(1);}
    all_extrapolation_result[i_q] = X[0];

    /////    temp_ss << "[ " << setw(5) << xvalue[no_value_xmin] << " ; " << setw(5) << xvalue[i_q] << " ] :   extrapolated result = " << setw(15) << setprecision(8) << all_extrapolation_result[i_q] << "   chi2_dof = " << setw(15) << setprecision(8) << all_chi2_dof[i_q] << endline;

  }
  temp_ss << endline;
  double temp_min = 1.e99;
  for (int i_q = start_value_xmax; i_q <= end_value_xmax; i_q++){
    //  for (int i_q = start_value_xmax; i_q < xvalue.size(); i_q++){
    if (all_chi2_dof[i_q] < temp_min){temp_min = all_chi2_dof[i_q]; no_xmax = i_q;}
  }
  xmax = xvalue[no_xmax];

  string order_fit_name;
  if (order_fit == 1){order_fit_name = "linear";}
  else if (order_fit == 2){order_fit_name = "quadratic";}
  temp_ss << "  Best chi2 value from " << setw(9) << order_fit_name << "  fit in interval [ " << setw(5) << xmin << " ; " << setw(5) << xvalue[no_xmax] << " ]  for value " << no_xmax << " :   " << setw(10) << "result" << " = " << setw(15) << setprecision(8) << all_extrapolation_result[no_xmax] << "   chi2 = " << setw(15) << setprecision(8) << all_chi2_dof[no_xmax] << endline_flush;
  // logger << LOG_INFO << "Best chi2 value from " << setw(9) << order_fit_name << " fit at " << no_xmax << " :   extrapolation_result = " << setw(15) << setprecision(8) << all_extrapolation_result[no_xmax] << "   chi2 = " << all_chi2_dof[no_xmax] << endline_flush;

  double best_fit_result = all_extrapolation_result[no_xmax];
  double least_chi2 = all_chi2_dof[no_xmax];
  /*
  for (int i_q = start_value_xmax; i_q < xvalue.size(); i_q++){
    logger << LOG_INFO << "extrapolation[" << setw(2) << i_q << "] / best_fit_result = " << setw(8) << setprecision(5) << showpoint << right << (all_extrapolation_result[i_q] / best_fit_result - 1.) * 100 << " %   at relative chi2 = " << setw(8) << setprecision(5) << noshowpoint << left << all_chi2_dof[i_q] / least_chi2 << endline_flush;
  }
*/

  double chi2_range = ygeneric->error_extrapolation_range_chi2;
  //  int no_max_deviation_in_chi2_range = 0;
  int no_max_deviation_in_chi2_range = no_xmax;
  double max_deviation_in_chi2_range = 0.;
  for (int i_q = start_value_xmax; i_q < xvalue.size(); i_q++){
    if (all_chi2_dof[i_q] / least_chi2 < chi2_range){
      if (abs(all_extrapolation_result[i_q] - best_fit_result) > max_deviation_in_chi2_range){
	no_max_deviation_in_chi2_range = i_q;
	max_deviation_in_chi2_range = abs(all_extrapolation_result[i_q] - best_fit_result);
      }
    }
  }
  temp_ss << "Maximum deviation from " << setw(9) << order_fit_name << " fit in interval  [ " << setw(5) << xmin << " ; " << setw(5) << xvalue[no_max_deviation_in_chi2_range] << " ]  for value " << no_max_deviation_in_chi2_range << " :   " << setw(10) << "deviation" << " = " << setw(15) << setprecision(8) << max_deviation_in_chi2_range << "   chi2 = " << setw(15) << setprecision(8) << all_chi2_dof[no_max_deviation_in_chi2_range] << "   chi2 ratio = " << setw(15) << setprecision(8) << all_chi2_dof[no_max_deviation_in_chi2_range] / least_chi2 << "   " << endline_flush;
  //  temp_ss << endline;
  //  logger << LOG_INFO << temp_ss.str() << endline_flush;
  info_extrapolation = temp_ss.str();
  all_extrapolation_deviation[no_xmax] = max_deviation_in_chi2_range;

  logger.finished();
}



