#include "header.hpp"

void summary_list::output_distribution_TSV(){
  static Logger logger("summary_list::output_distribution_TSV");
  logger.called();

  int plot_mode = 0;
  string name_result = xcontribution[0]->infix_order_contribution;
  string subdirectory = "/" + resultdirectory;

  vector<string> identifier_sdd(2);
  identifier_sdd[0] = "norm";
  identifier_sdd[1] = "plot";

  if (Log::getLogThreshold() <= LOG_DEBUG){ logger << LOG_DEBUG << "subdirectory = " << subdirectory << "   resultdirectory = " << resultdirectory << "   selection_n_qTcut = " << selection_n_qTcut << endline_flush; }
  for (int i_i = 0; i_i < identifier_sdd.size(); i_i++){
    if (Log::getLogThreshold() <= LOG_DEBUG){ logger << LOG_DEBUG << "ygeneric->output_distribution_initialization_file_reduction_TSV(name_result = " << name_result << "   subdirectory = " << subdirectory << "   identifier_sdd[" << i_i << "] = " << identifier_sdd[i_i] << "   selection_n_qTcut = " << selection_n_qTcut << ");" << endline_flush; }
    if (ygeneric->switch_output_plot_reduction == 1){ ygeneric->output_distribution_initialization_file_reduction_TSV(name_result, subdirectory, identifier_sdd[i_i], selection_n_qTcut); }

    if (active_qTcut && selection_n_qTcut > 1){
      // inverted output for bin-wise rcut dependence
      for (int i_g = 0; i_g < ygeneric->subgroup.size(); i_g++){
	//    for (int i_d = 0; i_d < ygeneric->osi->dat.size(); i_d++){
	for (int i_d = 0; i_d < ygeneric->osi->extended_distribution.size(); i_d++){
	  if (!ygeneric->switch_output_distribution[i_d]){continue;}
	  vector<vector<vector<vector<vector<double> > > > > rcut_distribution_result_qTcut_TSV(selection_n_qTcut);
	  vector<vector<vector<vector<vector<double> > > > > rcut_distribution_deviation_qTcut_TSV(selection_n_qTcut);
	  for (int x_q = 0; x_q < selection_n_qTcut; x_q++){
	    rcut_distribution_result_qTcut_TSV[x_q] = distribution_result_qTcut_TSV[x_q][i_g][i_d];
	    rcut_distribution_deviation_qTcut_TSV[x_q] = distribution_deviation_qTcut_TSV[x_q][i_g][i_d];
	  }
	  if (i_d < ygeneric->osi->dat.size()){
	    ygeneric->output_rcut_sddistribution_TSV(identifier_sdd[i_i], rcut_distribution_result_qTcut_TSV, rcut_distribution_deviation_qTcut_TSV, i_d, name_result, subdirectory, plot_mode, distribution_result_TSV[i_g][i_d], distribution_deviation_TSV[i_g][i_d], distribution_xmin_extrapolation_TSV[i_g][i_d], distribution_xmax_extrapolation_TSV[i_g][i_d]);
	  }
	  else {
	    ygeneric->output_rcut_dddistribution_TSV(identifier_sdd[i_i], rcut_distribution_result_qTcut_TSV, rcut_distribution_deviation_qTcut_TSV, i_d, name_result, subdirectory, plot_mode);
	  }
	}
      }
    }
    // single-differential distributions
    for (int i_g = 0; i_g < ygeneric->subgroup.size(); i_g++){
      for (int i_d = 0; i_d < ygeneric->osi->dat.size(); i_d++){
	//    for (int i_d = 0; i_d < ygeneric->osi->extended_distribution.size(); i_d++){
	if (!ygeneric->switch_output_distribution[i_d]){continue;}
	ygeneric->output_distribution_TSV(identifier_sdd[i_i], distribution_result_TSV[i_g][i_d], distribution_deviation_TSV[i_g][i_d], i_d, name_result, subdirectory, plot_mode);
	ygeneric->output_sddistribution_TSV(identifier_sdd[i_i], distribution_result_TSV[i_g][i_d], distribution_deviation_TSV[i_g][i_d], i_d, name_result, subdirectory, plot_mode);
      }
    }
    // double-differential distributions
    for (int i_g = 0; i_g < ygeneric->subgroup.size(); i_g++){
      for (int i_d = ygeneric->osi->dat.size(); i_d < ygeneric->osi->extended_distribution.size(); i_d++){
	if (!ygeneric->switch_output_distribution[i_d]){continue;}
	ygeneric->output_dddistribution_TSV(identifier_sdd[i_i], distribution_result_TSV[i_g][i_d], distribution_deviation_TSV[i_g][i_d], i_d, name_result, subdirectory, plot_mode);
	ygeneric->output_dddistribution_reconstruct_first_sdd_TSV(identifier_sdd[i_i], distribution_result_TSV[i_g][i_d], distribution_deviation_TSV[i_g][i_d], i_d, name_result, subdirectory, plot_mode);
	ygeneric->output_dddistribution_reconstruct_second_sdd_TSV(identifier_sdd[i_i], distribution_result_TSV[i_g][i_d], distribution_deviation_TSV[i_g][i_d], i_d, name_result, subdirectory, plot_mode);
	ygeneric->output_dddistribution_slice_in_first_sdd_TSV(identifier_sdd[i_i], distribution_result_TSV[i_g][i_d], distribution_deviation_TSV[i_g][i_d], i_d, name_result, subdirectory, plot_mode);
	ygeneric->output_dddistribution_slice_in_second_sdd_TSV(identifier_sdd[i_i], distribution_result_TSV[i_g][i_d], distribution_deviation_TSV[i_g][i_d], i_d, name_result, subdirectory, plot_mode);
	ygeneric->output_dddistribution_ge_in_first_sdd_TSV(identifier_sdd[i_i], distribution_result_TSV[i_g][i_d], distribution_deviation_TSV[i_g][i_d], i_d, name_result, subdirectory, plot_mode);
	ygeneric->output_dddistribution_ge_in_second_sdd_TSV(identifier_sdd[i_i], distribution_result_TSV[i_g][i_d], distribution_deviation_TSV[i_g][i_d], i_d, name_result, subdirectory, plot_mode);
	ygeneric->output_dddistribution_lt_in_first_sdd_TSV(identifier_sdd[i_i], distribution_result_TSV[i_g][i_d], distribution_deviation_TSV[i_g][i_d], i_d, name_result, subdirectory, plot_mode);
	ygeneric->output_dddistribution_lt_in_second_sdd_TSV(identifier_sdd[i_i], distribution_result_TSV[i_g][i_d], distribution_deviation_TSV[i_g][i_d], i_d, name_result, subdirectory, plot_mode);
      }
    }
  }

  logger.finished();
}


void summary_list::output_distribution_qTcut_TSV(){
  static Logger logger("summary_list::output_distribution_qTcut_TSV");
  logger.called();

  if (!active_qTcut || selection_n_qTcut == 1){return;}

  int plot_mode = 0;
  string name_result = xcontribution[0]->infix_order_contribution;

  vector<string> identifier_sdd(2);
  identifier_sdd[0] = "norm";
  identifier_sdd[1] = "plot";

  string subdirectory = "/" + resultdirectory;
  vector<string> subdirectory_qTcut(selection_n_qTcut, "");
  for (int x_q = 0; x_q < selection_n_qTcut; x_q++){
    stringstream qTcut_ss;
    qTcut_ss << "qTcut-" << ygeneric->osi->value_qTcut_distribution[x_q];
    subdirectory_qTcut[x_q] = "/" + resultdirectory + "/" + qTcut_ss.str();
  }

  for (int x_q = 0; x_q < selection_n_qTcut; x_q++){
    for (int i_s = 0; i_s < osi->n_extended_set_TSV; i_s++){
      if (!ygeneric->switch_output_scaleset[i_s]){continue;}
      if (!ygeneric->osi->switch_distribution_TSV[i_s]){continue;}
      for (int i_r = 0; i_r < ygeneric->osi->n_scale_ren_TSV[i_s]; i_r++){
	for (int i_f = 0; i_f < ygeneric->osi->n_scale_fact_TSV[i_s]; i_f++){
	  string directory_distribution_plot = ygeneric->scalepath_TSV[i_s][i_r][i_f] + "/" + subdirectory_qTcut[x_q];
	  if (Log::getLogThreshold() <= LOG_DEBUG){ logger << LOG_DEBUG << "mkdir " << directory_distribution_plot << endline_flush; }
	  system_execute(logger, "mkdir " + directory_distribution_plot);
	}
      }
    }
  }

  for (int i_i = 0; i_i < identifier_sdd.size(); i_i++){
    if (ygeneric->switch_output_plot_reduction == 1){
      for (int x_q = 0; x_q < selection_n_qTcut; x_q++){
	ygeneric->output_distribution_initialization_file_reduction_qTcut_TSV(name_result, subdirectory_qTcut[x_q], identifier_sdd[i_i], selection_n_qTcut);
      }
    }

    for (int x_q = 0; x_q < selection_n_qTcut; x_q++){
      // single-differential distributions
      for (int i_g = 0; i_g < ygeneric->subgroup.size(); i_g++){
	for (int i_d = 0; i_d < ygeneric->osi->dat.size(); i_d++){
	  if (!ygeneric->switch_output_distribution[i_d]){continue;}
	  ygeneric->output_distribution_TSV(identifier_sdd[i_i], distribution_result_qTcut_TSV[x_q][i_g][i_d], distribution_deviation_qTcut_TSV[x_q][i_g][i_d], i_d, name_result, subdirectory_qTcut[x_q], plot_mode);
	  ygeneric->output_sddistribution_TSV(identifier_sdd[i_i], distribution_result_qTcut_TSV[x_q][i_g][i_d], distribution_deviation_qTcut_TSV[x_q][i_g][i_d], i_d, name_result, subdirectory_qTcut[x_q], plot_mode);
	}
      }
      // double-differential distributions
      for (int i_g = 0; i_g < ygeneric->subgroup.size(); i_g++){
	for (int i_d = ygeneric->osi->dat.size(); i_d < ygeneric->osi->extended_distribution.size(); i_d++){
	  if (!ygeneric->switch_output_distribution[i_d]){continue;}
	  ygeneric->output_dddistribution_TSV(identifier_sdd[i_i], distribution_result_qTcut_TSV[x_q][i_g][i_d], distribution_deviation_qTcut_TSV[x_q][i_g][i_d], i_d, name_result, subdirectory_qTcut[x_q], plot_mode);
	  ygeneric->output_dddistribution_reconstruct_first_sdd_TSV(identifier_sdd[i_i], distribution_result_qTcut_TSV[x_q][i_g][i_d], distribution_deviation_qTcut_TSV[x_q][i_g][i_d], i_d, name_result, subdirectory_qTcut[x_q], plot_mode);
	  ygeneric->output_dddistribution_reconstruct_second_sdd_TSV(identifier_sdd[i_i], distribution_result_qTcut_TSV[x_q][i_g][i_d], distribution_deviation_qTcut_TSV[x_q][i_g][i_d], i_d, name_result, subdirectory_qTcut[x_q], plot_mode);
	  ygeneric->output_dddistribution_slice_in_first_sdd_TSV(identifier_sdd[i_i], distribution_result_qTcut_TSV[x_q][i_g][i_d], distribution_deviation_qTcut_TSV[x_q][i_g][i_d], i_d, name_result, subdirectory_qTcut[x_q], plot_mode);
	  ygeneric->output_dddistribution_slice_in_second_sdd_TSV(identifier_sdd[i_i], distribution_result_qTcut_TSV[x_q][i_g][i_d], distribution_deviation_qTcut_TSV[x_q][i_g][i_d], i_d, name_result, subdirectory_qTcut[x_q], plot_mode);
	  ygeneric->output_dddistribution_ge_in_first_sdd_TSV(identifier_sdd[i_i], distribution_result_qTcut_TSV[x_q][i_g][i_d], distribution_deviation_qTcut_TSV[x_q][i_g][i_d], i_d, name_result, subdirectory_qTcut[x_q], plot_mode);
	  ygeneric->output_dddistribution_ge_in_second_sdd_TSV(identifier_sdd[i_i], distribution_result_qTcut_TSV[x_q][i_g][i_d], distribution_deviation_qTcut_TSV[x_q][i_g][i_d], i_d, name_result, subdirectory_qTcut[x_q], plot_mode);
	  ygeneric->output_dddistribution_lt_in_first_sdd_TSV(identifier_sdd[i_i], distribution_result_qTcut_TSV[x_q][i_g][i_d], distribution_deviation_qTcut_TSV[x_q][i_g][i_d], i_d, name_result, subdirectory_qTcut[x_q], plot_mode);
	  ygeneric->output_dddistribution_lt_in_second_sdd_TSV(identifier_sdd[i_i], distribution_result_qTcut_TSV[x_q][i_g][i_d], distribution_deviation_qTcut_TSV[x_q][i_g][i_d], i_d, name_result, subdirectory_qTcut[x_q], plot_mode);
	}
      }
    }
  }

  logger.finished();
}


void summary_list::output_distribution_overview_TSV(){
  static Logger logger("summary_list::output_distribution_overview_TSV");
  logger.called();

  ofstream out_overviewfile;
  string filename_distribution_overview;
  string filepath_distribution_overview;

  stringstream header_ss;
  header_ss << left << setw(16) << "qTcut";
  header_ss << left << setw(25) << "list/contribution";
  header_ss << setw(15) << "";
  header_ss << right << setw(16) << "dsigma";
  header_ss << setw(4) << " +- ";
  header_ss << right << setw(16) << "error";

  stringstream temp_ss_separation_one;
  stringstream temp_ss_separation_two;
  int counter_separation = 20 + 5 + 16 + 25 + 15 + 16 + 4 + 16;
  for (int i_x = 0; i_x < counter_separation; i_x++){
    temp_ss_separation_one << "-";
    temp_ss_separation_two << "=";
  }

  for (int i_s = 0; i_s < osi->n_extended_set_TSV; i_s++){
    if (!ygeneric->switch_output_scaleset[i_s]){continue;}
    if (!osi->switch_distribution_TSV[i_s]){continue;}
    if (i_s != osi->no_reference_TSV){ continue; }
    /*
    if (ygeneric->switch_output_overview_reduction == 2){
      filename_distribution_overview = "overview." + resultdirectory + ".dat";
      // directory does not exist yet !!!
      filepath_distribution_overview = ygeneric->final_resultdirectory + "/" + osi->name_extended_set_TSV[i_s] + "/" + resultdirectory + "/" + filename_distribution_overview;
      out_overviewfile.open(filepath_distribution_overview.c_str(), ofstream::out | ofstream::trunc);
    } 
    */
    for (int i_r = 0; i_r < osi->n_scale_ren_TSV[i_s]; i_r++){
      for (int i_f = 0; i_f < osi->n_scale_fact_TSV[i_s]; i_f++){
	if (i_r != osi->no_scale_ren_reference_TSV || i_f != osi->no_scale_fact_reference_TSV){ continue; }

	if (ygeneric->switch_output_overview_reduction == 1){
	  filename_distribution_overview = "overview.." + xcontribution[0]->infix_order_contribution  + ".dat";
	  //	  filename_distribution_overview = "overview.." + resultdirectory + ".dat";
	  filepath_distribution_overview = ygeneric->scalepath_TSV[i_s][i_r][i_f] + "/" + resultdirectory + "/" + filename_distribution_overview;
	  out_overviewfile.open(filepath_distribution_overview.c_str(), ofstream::out | ofstream::trunc);
	}

	for (int i_g = 0; i_g < ygeneric->subgroup.size(); i_g++){
	  for (int i_d = 0; i_d < osi->dat.size(); i_d++){
	    if (!ygeneric->switch_output_distribution[i_d]){continue;}

	    if (ygeneric->switch_output_overview_reduction){
	      out_overviewfile << "## " << ygeneric->scalename_TSV[i_s][i_r][i_f] << "/" << resultdirectory << "/" << "overview." << osi->extended_distribution[i_d].xdistribution_name << ".." << xcontribution[0]->infix_order_contribution << ".dat" << endline;
	      out_overviewfile << endline;
	    }
	    else {
	      filename_distribution_overview = "overview." + osi->extended_distribution[i_d].xdistribution_name + ".." + xcontribution[0]->infix_order_contribution + ".dat";
	      filepath_distribution_overview = ygeneric->scalepath_TSV[i_s][i_r][i_f] + "/" + resultdirectory + "/" + filename_distribution_overview;
	      if (Log::getLogThreshold() <= LOG_DEBUG){
		logger << LOG_DEBUG << "filename_distribution_overview = " << filename_distribution_overview << endline_flush;
		logger << LOG_DEBUG << "filepath_distribution_overview = " << filepath_distribution_overview << endline_flush;
	      }
	      out_overviewfile.open(filepath_distribution_overview.c_str(), ofstream::out | ofstream::trunc);
	    }
	    
	    stringstream bin_label;
	    bin_label << "bin (" << osi->extended_distribution[i_d].xdistribution_name << ")";
	    out_overviewfile << setw(22) << bin_label.str() << setw(3) << "" << header_ss.str() << endline;
	    out_overviewfile << endline;

	    for (int i_b = 0; i_b < osi->extended_distribution[i_d].n_bins; i_b++){
	      if (active_qTcut && distribution_result_TSV[i_g][i_d][i_b][i_s][i_r][i_f] != 0.){
		out_overviewfile << right << setw(10) << setprecision(8) << noshowpoint << osi->extended_distribution[i_d].bin_edge[i_b];
		out_overviewfile << setw(2) << "";
		out_overviewfile << right << setw(10) << setprecision(8) << noshowpoint << osi->extended_distribution[i_d].bin_edge[i_b + 1];
		out_overviewfile << setw(3) << "";
		if (active_qTcut){out_overviewfile << left << setw(16) << "extrapolation";}
		else {out_overviewfile << left << setw(16) << "independent";}
		out_overviewfile << left << setw(25) << resultdirectory;
		if (channel_selection != "" && channel_selection != "---"){out_overviewfile << left << setw(5) << channel_selection;}
		else {out_overviewfile << setw(5) << "";}
		if (extra_selection != "" && extra_selection != "---"){out_overviewfile << left << setw(10) << extra_selection;}
		else {out_overviewfile << setw(10) << "";}
		out_overviewfile << showpoint << right << setw(16) << setprecision(9) << osi->unit_factor_distribution * distribution_result_TSV[i_g][i_d][i_b][i_s][i_r][i_f];
		out_overviewfile << " +- ";
		out_overviewfile << showpoint << right << setw(16) << setprecision(9) << osi->unit_factor_distribution * distribution_deviation_TSV[i_g][i_d][i_b][i_s][i_r][i_f];
		out_overviewfile << endline;
		out_overviewfile << temp_ss_separation_one.str() << endline;
		out_overviewfile << endline;
	      }

	      int counter_empty_bin = 0;
	      for (int x_q = 0; x_q < selection_n_qTcut; x_q++){
		// check if bin is empty (to reduce output)
		if (xcontribution[0]->distribution_result_TSV[i_g][i_d][i_b][x_q][i_s][i_r][i_f] == 0.){counter_empty_bin++; continue;}
		int temp_size_result = int(log10(abs(osi->unit_factor_distribution * xcontribution[0]->distribution_result_TSV[i_g][i_d][i_b][x_q][i_s][i_r][i_f])));
		for (int i_c = 0; i_c < xcontribution.size(); i_c++){
		  int y_q = 0;
		  if (xcontribution[i_c]->active_qTcut){y_q = x_q;}
		  int temp_size_result_c = int(log10(abs(osi->unit_factor_distribution * xcontribution[i_c]->distribution_result_TSV[i_g][i_d][i_b][y_q][i_s][i_r][i_f])));
		  if (temp_size_result_c > temp_size_result){temp_size_result = temp_size_result_c;}
		}
		int temp_size_deviation = int(log10(abs(osi->unit_factor_distribution * xcontribution[0]->distribution_deviation_TSV[i_g][i_d][i_b][x_q][i_s][i_r][i_f])));
		if (osi->unit_factor_distribution * xcontribution[0]->distribution_deviation_TSV[i_g][i_d][i_b][x_q][i_s][i_r][i_f] >= 1.){temp_size_deviation++;}

		for (int i_c = 0; i_c < xcontribution.size(); i_c++){
		  int y_q = 0;
		  if (xcontribution[i_c]->active_qTcut){y_q = x_q;}

		  int temp_size_result_subprocess = int(log10(abs(osi->unit_factor_distribution * xcontribution[i_c]->distribution_result_TSV[i_g][i_d][i_b][y_q][i_s][i_r][i_f])));
		  int temp_size_deviation_subprocess = int(log10(abs(osi->unit_factor_distribution * xcontribution[i_c]->distribution_deviation_TSV[i_g][i_d][i_b][y_q][i_s][i_r][i_f])));
		  if (osi->unit_factor_distribution * xcontribution[i_c]->distribution_deviation_TSV[i_g][i_d][i_b][y_q][i_s][i_r][i_f] >= 1.){temp_size_deviation_subprocess++;}
		  if (xcontribution[i_c]->distribution_result_TSV[i_g][i_d][i_b][y_q][i_s][i_r][i_f] == 0){temp_size_result_subprocess = 0;}
		  if (xcontribution[i_c]->distribution_deviation_TSV[i_g][i_d][i_b][y_q][i_s][i_r][i_f] == 0){temp_size_deviation_subprocess = 0;}
		  int setw_result = 9 + temp_size_result_subprocess - temp_size_result;
		  int setw_deviation = 9 + temp_size_deviation_subprocess - temp_size_deviation - (temp_size_result - temp_size_deviation + 1);
		  if (xcontribution[i_c]->distribution_result_TSV[i_g][i_d][i_b][y_q][i_s][i_r][i_f] == 0.){setw_result = 1; setw_deviation = 1;}
		  else if (abs(osi->unit_factor_distribution * xcontribution[i_c]->distribution_result_TSV[i_g][i_d][i_b][y_q][i_s][i_r][i_f]) < 1.){setw_result--;}

		  out_overviewfile << right << setw(10) << setprecision(8) << noshowpoint << osi->extended_distribution[i_d].bin_edge[i_b];
		  out_overviewfile << setw(2) << "";
		  out_overviewfile << right << setw(10) << setprecision(8) << noshowpoint << osi->extended_distribution[i_d].bin_edge[i_b + 1];
		  out_overviewfile << setw(3) << "";
		  if (xcontribution[i_c]->active_qTcut){out_overviewfile << left << noshowpoint << setw(16) << osi->value_qTcut_distribution[x_q];}
		  else {out_overviewfile << left << setw(16) << "independent";}
		  if (i_c == 0){out_overviewfile << setw(25) << xcontribution[i_c]->infix_order_contribution;}
		  else {out_overviewfile << left << setw(25) << xcontribution[i_c]->infix_contribution;}
		  if (channel_selection != "" && channel_selection != "---"){out_overviewfile << left << setw(5) << channel_selection;}
		  else {out_overviewfile << setw(5) << "";}
		  if (extra_selection != "" && extra_selection != "---"){out_overviewfile << left << setw(10) << extra_selection;}
		  else {out_overviewfile << setw(10) << "";}
		  out_overviewfile << showpoint << right << setw(16) << setprecision(setw_result) << osi->unit_factor_distribution * xcontribution[i_c]->distribution_result_TSV[i_g][i_d][i_b][y_q][i_s][i_r][i_f];
		  out_overviewfile << " +- ";
		  out_overviewfile << showpoint << right << setw(16) << setprecision(setw_deviation) << osi->unit_factor_distribution * xcontribution[i_c]->distribution_deviation_TSV[i_g][i_d][i_b][y_q][i_s][i_r][i_f];
		  out_overviewfile << endline;
		  if (i_c == 0){out_overviewfile << temp_ss_separation_one.str() << endline;}
		}
		out_overviewfile << endline;
	      }
	      if (counter_empty_bin < selection_n_qTcut){out_overviewfile << temp_ss_separation_two.str() << endl << endline;}
	    }
	    if (!ygeneric->switch_output_overview_reduction){ out_overviewfile.close(); }
	  }
	  if (ygeneric->switch_output_overview_reduction == 1){ out_overviewfile.close(); }
	}
      }
    }
  }

  logger.finished();
}


void summary_list::output_dddistribution_overview_TSV(){
  static Logger logger("summary_list::output_dddistribution_overview_TSV");
  logger.called();

  ofstream out_overviewfile;
  string filename_distribution_overview;
  string filepath_distribution_overview;

  stringstream header_ss;
  header_ss << left << setw(16) << "qTcut";
  header_ss << left << setw(25) << "list/contribution";
  header_ss << setw(15) << "";
  header_ss << right << setw(16) << "dsigma";
  header_ss << setw(4) << " +- ";
  header_ss << right << setw(16) << "error";

  stringstream temp_ss_separation_one;
  stringstream temp_ss_separation_two;
  int counter_separation = 20 + 5 + 20 + 5 + 16 + 25 + 15 + 16 + 4 + 16;
  for (int i_x = 0; i_x < counter_separation; i_x++){
    temp_ss_separation_one << "-";
    temp_ss_separation_two << "=";
  }

  for (int i_s = 0; i_s < osi->n_extended_set_TSV; i_s++){
    if (!ygeneric->switch_output_scaleset[i_s]){continue;}
    if (!osi->switch_distribution_TSV[i_s]){continue;}
    if (i_s != osi->no_reference_TSV){ continue; }
    /*
      if (ygeneric->switch_output_overview_reduction == 2){
      filename_distribution_overview = "overview." + resultdirectory + ".dat";
      // directory does not exist yet !!!
      filepath_distribution_overview = ygeneric->final_resultdirectory + "/" + osi->name_extended_set_TSV[i_s] + "/" + resultdirectory + "/" + filename_distribution_overview;
      out_overviewfile.open(filepath_distribution_overview.c_str(), ofstream::out | ofstream::trunc);
      }
    */
    for (int i_r = 0; i_r < osi->n_scale_ren_TSV[i_s]; i_r++){
      for (int i_f = 0; i_f < osi->n_scale_fact_TSV[i_s]; i_f++){
	if (i_r != osi->no_scale_ren_reference_TSV || i_f != osi->no_scale_fact_reference_TSV){ continue; }

	if (ygeneric->switch_output_overview_reduction == 1){
	  filename_distribution_overview = "overview.." + xcontribution[0]->infix_order_contribution  + ".dat";
	  //	  filename_distribution_overview = "overview.." + resultdirectory + ".dat";
	  filepath_distribution_overview = ygeneric->scalepath_TSV[i_s][i_r][i_f] + "/" + resultdirectory + "/" + filename_distribution_overview;
	  out_overviewfile.open(filepath_distribution_overview.c_str(), ofstream::out | ofstream::app);
	}
	
	for (int i_g = 0; i_g < ygeneric->subgroup.size(); i_g++){
	  for (int i_d = osi->dat.size(); i_d < osi->extended_distribution.size(); i_d++){
	    int i_ddd = i_d - osi->dat.size();
	    if (!ygeneric->switch_output_distribution[i_d]){continue;}

	    if (ygeneric->switch_output_overview_reduction){
	      out_overviewfile << "## " << ygeneric->scalename_TSV[i_s][i_r][i_f] << "/" << resultdirectory << "/" << "overview." << osi->extended_distribution[i_d].xdistribution_name << ".." << xcontribution[0]->infix_order_contribution << ".dat" << endline;
	      out_overviewfile << endline;
	    }
	    else {
	      filename_distribution_overview = "overview." + osi->extended_distribution[i_d].xdistribution_name + ".." + xcontribution[0]->infix_order_contribution + ".dat";
	      filepath_distribution_overview = ygeneric->scalepath_TSV[i_s][i_r][i_f] + "/" + resultdirectory + "/" + filename_distribution_overview;
	      logger << LOG_DEBUG << "filename_distribution_overview = " << filename_distribution_overview << endline_flush;
	      logger << LOG_DEBUG << "filepath_distribution_overview = " << filepath_distribution_overview << endline_flush;

	      out_overviewfile.open(filepath_distribution_overview.c_str(), ofstream::out | ofstream::trunc);
	    }
	    
	    stringstream bin_label_1;
	    bin_label_1 << "bin (" << osi->dddat[i_ddd].distribution_1.xdistribution_name << ")";
	    stringstream bin_label_2;
	    bin_label_2 << "bin (" << osi->dddat[i_ddd].distribution_2.xdistribution_name << ")";
	    out_overviewfile << setw(22) << bin_label_1.str() << setw(3) << "" << setw(22) << bin_label_2.str() << setw(3) << "" << header_ss.str() << endline;
	    out_overviewfile << endline;

	    for (int i_b1 = 0; i_b1 < osi->dddat[i_ddd].distribution_1.n_bins; i_b1++){
	      for (int i_b2 = 0; i_b2 < osi->dddat[i_ddd].distribution_2.n_bins; i_b2++){
		int i_b = i_b1 * osi->dddat[i_ddd].distribution_2.n_bins + i_b2;
		if (active_qTcut && distribution_result_TSV[i_g][i_d][i_b][i_s][i_r][i_f] != 0.){
		  out_overviewfile << right << noshowpoint << setw(10) << setprecision(8) << osi->dddat[i_ddd].distribution_1.bin_edge[i_b1];
		  out_overviewfile << setw(2) << "";
		  out_overviewfile << right << noshowpoint << setw(10) << setprecision(8) << osi->dddat[i_ddd].distribution_1.bin_edge[i_b1 + 1];
		  out_overviewfile << setw(3) << "";
		  out_overviewfile << right << noshowpoint << setw(10) << setprecision(8) << osi->dddat[i_ddd].distribution_2.bin_edge[i_b2];
		  out_overviewfile << setw(2) << "";
		  out_overviewfile << right << noshowpoint << setw(10) << setprecision(8) << osi->dddat[i_ddd].distribution_2.bin_edge[i_b2 + 1];
		  out_overviewfile << setw(3) << "";
		  if (active_qTcut){out_overviewfile << left << setw(16) << "extrapolation";}
		  else {out_overviewfile << left << setw(16) << "independent";}
		  out_overviewfile << left << setw(25) << resultdirectory;
		  if (channel_selection != "" && channel_selection != "---"){out_overviewfile << left << setw(5) << channel_selection;}
		  else {out_overviewfile << setw(5) << "";}
		  if (extra_selection != "" && extra_selection != "---"){out_overviewfile << left << setw(10) << extra_selection;}
		  else {out_overviewfile << setw(10) << "";}
		  out_overviewfile << showpoint << right << setw(16) << setprecision(9) << osi->unit_factor_distribution * distribution_result_TSV[i_g][i_d][i_b][i_s][i_r][i_f];
		  out_overviewfile << " +- ";
		  out_overviewfile << showpoint << right << setw(16) << setprecision(9) << osi->unit_factor_distribution * distribution_deviation_TSV[i_g][i_d][i_b][i_s][i_r][i_f];
		  out_overviewfile << endline;
		  out_overviewfile << temp_ss_separation_one.str() << endline;
		  out_overviewfile << endline;
		}

		int counter_empty_bin = 0;
		for (int x_q = 0; x_q < selection_n_qTcut; x_q++){
		  // check if bin is empty (to reduce output)
		  if (xcontribution[0]->distribution_result_TSV[i_g][i_d][i_b][x_q][i_s][i_r][i_f] == 0.){counter_empty_bin++; continue;}
		  int temp_size_result = int(log10(abs(osi->unit_factor_distribution * xcontribution[0]->distribution_result_TSV[i_g][i_d][i_b][x_q][i_s][i_r][i_f])));
		  for (int i_c = 0; i_c < xcontribution.size(); i_c++){
		    int y_q = 0;
		    if (xcontribution[i_c]->active_qTcut){y_q = x_q;}
		    int temp_size_result_c = int(log10(abs(osi->unit_factor_distribution * xcontribution[i_c]->distribution_result_TSV[i_g][i_d][i_b][y_q][i_s][i_r][i_f])));
		    if (temp_size_result_c > temp_size_result){temp_size_result = temp_size_result_c;}
		  }
		  int temp_size_deviation = int(log10(abs(osi->unit_factor_distribution * xcontribution[0]->distribution_deviation_TSV[i_g][i_d][i_b][x_q][i_s][i_r][i_f])));
		  if (osi->unit_factor_distribution * xcontribution[0]->distribution_deviation_TSV[i_g][i_d][i_b][x_q][i_s][i_r][i_f] >= 1.){temp_size_deviation++;}

		  for (int i_c = 0; i_c < xcontribution.size(); i_c++){
		    int y_q = 0;
		    if (xcontribution[i_c]->active_qTcut){y_q = x_q;}

		    int temp_size_result_subprocess = int(log10(abs(osi->unit_factor_distribution * xcontribution[i_c]->distribution_result_TSV[i_g][i_d][i_b][y_q][i_s][i_r][i_f])));
		    int temp_size_deviation_subprocess = int(log10(abs(osi->unit_factor_distribution * xcontribution[i_c]->distribution_deviation_TSV[i_g][i_d][i_b][y_q][i_s][i_r][i_f])));
		    if (osi->unit_factor_distribution * xcontribution[i_c]->distribution_deviation_TSV[i_g][i_d][i_b][y_q][i_s][i_r][i_f] >= 1.){temp_size_deviation_subprocess++;}
		    if (xcontribution[i_c]->distribution_result_TSV[i_g][i_d][i_b][y_q][i_s][i_r][i_f] == 0){temp_size_result_subprocess = 0;}
		    if (xcontribution[i_c]->distribution_deviation_TSV[i_g][i_d][i_b][y_q][i_s][i_r][i_f] == 0){temp_size_deviation_subprocess = 0;}
		    int setw_result = 9 + temp_size_result_subprocess - temp_size_result;
		    int setw_deviation = 9 + temp_size_deviation_subprocess - temp_size_deviation - (temp_size_result - temp_size_deviation + 1);
		    if (xcontribution[i_c]->distribution_result_TSV[i_g][i_d][i_b][y_q][i_s][i_r][i_f] == 0.){setw_result = 1; setw_deviation = 1;}
		    else if (abs(osi->unit_factor_distribution * xcontribution[i_c]->distribution_result_TSV[i_g][i_d][i_b][y_q][i_s][i_r][i_f]) < 1.){setw_result--;}

		    out_overviewfile << right << noshowpoint << setw(10) << setprecision(8) << osi->dddat[i_ddd].distribution_1.bin_edge[i_b1];
		    out_overviewfile << setw(2) << "";
		    out_overviewfile << right << noshowpoint << setw(10) << setprecision(8) << osi->dddat[i_ddd].distribution_1.bin_edge[i_b1 + 1];
		    out_overviewfile << setw(3) << "";
		    out_overviewfile << right << noshowpoint << setw(10) << setprecision(8) << osi->dddat[i_ddd].distribution_2.bin_edge[i_b2];
		    out_overviewfile << setw(2) << "";
		    out_overviewfile << right << noshowpoint << setw(10) << setprecision(8) << osi->dddat[i_ddd].distribution_2.bin_edge[i_b2 + 1];
		    out_overviewfile << setw(3) << "";
		    if (xcontribution[i_c]->active_qTcut){out_overviewfile << left << noshowpoint << setw(16) << osi->value_qTcut_distribution[x_q];}
		    else {out_overviewfile << left << setw(16) << "independent";}
		    if (i_c == 0){out_overviewfile << setw(25) << xcontribution[i_c]->infix_order_contribution;}
		    else {out_overviewfile << left << setw(25) << xcontribution[i_c]->infix_contribution;}
		    if (channel_selection != "" && channel_selection != "---"){out_overviewfile << left << setw(5) << channel_selection;}
		    else {out_overviewfile << setw(5) << "";}
		    if (extra_selection != "" && extra_selection != "---"){out_overviewfile << left << setw(10) << extra_selection;}
		    else {out_overviewfile << setw(10) << "";}
		    out_overviewfile << showpoint << right << setw(16) << setprecision(setw_result) << osi->unit_factor_distribution * xcontribution[i_c]->distribution_result_TSV[i_g][i_d][i_b][y_q][i_s][i_r][i_f];
		    out_overviewfile << " +- ";
		    out_overviewfile << showpoint << right << setw(16) << setprecision(setw_deviation) << osi->unit_factor_distribution * xcontribution[i_c]->distribution_deviation_TSV[i_g][i_d][i_b][y_q][i_s][i_r][i_f];
		    out_overviewfile << endline;
		    if (i_c == 0){out_overviewfile << temp_ss_separation_one.str() << endline;}
		  }
		  out_overviewfile << endline;
		}
		if (counter_empty_bin < selection_n_qTcut){out_overviewfile << temp_ss_separation_two.str() << endl << endline;}
	      }
	    }
	    if (!ygeneric->switch_output_overview_reduction){ out_overviewfile.close(); }
	  }
	  if (ygeneric->switch_output_overview_reduction == 1){ out_overviewfile.close(); }
	}
      }
    }
  }

  logger.finished();
}


void summary_list::output_contribution_distribution_check_TSV(){
  static Logger logger("summary_list::output_contribution_distribution_check_TSV");
  logger.called();

  //////////////////////////////////////////////////////////////////////////////
  //  output to check if distributions sum to cross section in TSV variation  //
  //////////////////////////////////////////////////////////////////////////////
  for (int i_s = 0; i_s < osi->n_extended_set_TSV; i_s++){
    if (!ygeneric->switch_output_scaleset[i_s]){continue;}
    if (!osi->switch_distribution_TSV[i_s]){continue;}
    for (int x_q = 0; x_q < selection_n_qTcut; x_q++){
      ofstream out_check;
      stringstream qTcut_ss;
      qTcut_ss << "qTcut" << osi->no_qTcut_distribution[x_q];
      string filename_check = ygeneric->final_resultdirectory + "/" + osi->name_extended_set_TSV[i_s] + "/scale.1.1/" + resultdirectory + "/" + "check." + qTcut_ss.str() + ".distribution.txt";
      //    string filename_check = ygeneric->final_resultdirectory + "/" + resultdirectory + "/" + osi->name_extended_set_TSV[i_s] + "/" +"check.distribution.txt";
      logger << LOG_DEBUG << "filename_check = " << filename_check << endline_flush;
      out_check.open(filename_check.c_str(), ofstream::out | ofstream::trunc);

      for (int i_c = 0; i_c < xcontribution.size(); i_c++){
	logger << LOG_DEBUG << "xcontribution[" << i_c << "].type_contribution = " << xcontribution[i_c]->type_contribution << endline_flush;
	int y_q = 0;
	if (xcontribution[i_c]->active_qTcut){y_q = x_q;}
	for (int i_g = 0; i_g < ygeneric->subgroup.size(); i_g++){
  	  // check output: check if sum over all bins gives a result <= XSection
	  // print output only at central scales!!!
	  for (int i_d = 0; i_d < osi->extended_distribution.size(); i_d++){
	    if (!ygeneric->switch_output_distribution[i_d]){continue;}
	    if (osi->extended_distribution[i_d].typeCumulative == CUMULATIVE_NONE){
	      out_check << setw(5) << "distribution: " << setw(25) << osi->extended_distribution[i_d].xdistribution_name;
	      double temp_weight = 0.;
	      double temp_deviation = 0.;
	      for (int i_b = 0; i_b < osi->extended_distribution[i_d].n_bins; i_b++){
		temp_weight += xcontribution[i_c]->distribution_result_TSV[i_g][i_d][i_b][y_q][i_s][osi->no_central_scale_ren_TSV[i_s]][osi->no_central_scale_fact_TSV[i_s]];
		temp_deviation += pow(xcontribution[i_c]->distribution_deviation_TSV[i_g][i_d][i_b][y_q][i_s][osi->no_central_scale_ren_TSV[i_s]][osi->no_central_scale_fact_TSV[i_s]], 2);
	      }
	      temp_weight = temp_weight * osi->extended_distribution[i_d].step;
	      temp_deviation = sqrt(temp_deviation) * osi->extended_distribution[i_d].step;
	      out_check << setw(16) << setprecision(8) << osi->unit_factor_distribution * temp_weight << " +- " << setw(16) << setprecision(8) << osi->unit_factor_distribution * temp_deviation << endline;
	    }
	    else if (osi->extended_distribution[i_d].typeCumulative == CUMULATIVE_LOWER){
	      out_check << setw(5) << "distribution: " << setw(25) << osi->extended_distribution[i_d].xdistribution_name;
	      out_check << setw(16) << setprecision(8) << osi->unit_factor_distribution * xcontribution[i_c]->distribution_result_TSV[i_g][i_d][osi->extended_distribution[i_d].n_bins - 1][y_q][i_s][osi->no_central_scale_ren_TSV[i_s]][osi->no_central_scale_fact_TSV[i_s]] << " +- " << setw(16) << setprecision(8) << osi->unit_factor_distribution * xcontribution[i_c]->distribution_deviation_TSV[i_g][i_d][osi->extended_distribution[i_d].n_bins - 1][y_q][i_s][osi->no_central_scale_ren_TSV[i_s]][osi->no_central_scale_fact_TSV[i_s]] << endline;
	    }
	    else if (osi->extended_distribution[i_d].typeCumulative == CUMULATIVE_UPPER){
	      out_check << setw(5) << "distribution: " << setw(25) << osi->extended_distribution[i_d].xdistribution_name;
	      out_check << setw(16) << setprecision(8) << osi->unit_factor_distribution * xcontribution[i_c]->distribution_result_TSV[i_g][i_d][0][y_q][i_s][osi->no_central_scale_ren_TSV[i_s]][osi->no_central_scale_fact_TSV[i_s]] << " +- " << setw(16) << setprecision(8) << osi->unit_factor_distribution * xcontribution[i_c]->distribution_deviation_TSV[i_g][i_d][0][y_q][i_s][osi->no_central_scale_ren_TSV[i_s]][osi->no_central_scale_fact_TSV[i_s]] << endline;
	    }
	    else if (osi->extended_distribution[i_d].typeCumulative == CUMULATIVE_BOTH){
	      out_check << setw(5) << "distribution: " << setw(25) << osi->extended_distribution[i_d].xdistribution_name;
	      out_check << setw(5) << "0" << setw(16) << setprecision(8) << osi->unit_factor_distribution * xcontribution[i_c]->distribution_result_TSV[i_g][i_d][0][y_q][i_s][osi->no_central_scale_ren_TSV[i_s]][osi->no_central_scale_fact_TSV[i_s]] << " +- " << setw(16) << setprecision(8) << osi->unit_factor_distribution * xcontribution[i_c]->distribution_deviation_TSV[i_g][i_d][0][y_q][i_s][osi->no_central_scale_ren_TSV[i_s]][osi->no_central_scale_fact_TSV[i_s]] << endline;
	      out_check << setw(5) << "max" << setw(16) << setprecision(8) << osi->unit_factor_distribution * xcontribution[i_c]->distribution_result_TSV[i_g][i_d][osi->extended_distribution[i_d].n_bins - 1][y_q][i_s][osi->no_central_scale_ren_TSV[i_s]][osi->no_central_scale_fact_TSV[i_s]] << " +- " << setw(16) << setprecision(8) << osi->unit_factor_distribution * xcontribution[i_c]->distribution_deviation_TSV[i_g][i_d][osi->extended_distribution[i_d].n_bins - 1][y_q][i_s][osi->no_central_scale_ren_TSV[i_s]][osi->no_central_scale_fact_TSV[i_s]] << endline;
	    }
	  }
	}
      }
      out_check.close();
    }
  }

  logger.finished();
}





// All functions below are only relevant for CV variation:

void summary_list::output_distribution_overview_CV(){
  static Logger logger("summary_list::output_distribution_overview_CV");
  logger.called();

  stringstream header_ss;
  header_ss << left
	    << setw(16) << "bin"
	    << setw(16) << "qTcut"
	    << setw(25) << "contribution"
	    << right << setw(34) << "dXS +- err (contribution)";

  stringstream temp_ss_separation_one;
  stringstream temp_ss_separation_two;
  int counter_separation = 16 + 16 + 25 + 16 + 4 + 16;
  for (int i_x = 0; i_x < counter_separation; i_x++){
    temp_ss_separation_one << "-";
    temp_ss_separation_two << "=";
  }

  int i_q = 0;
  for (int i_s = 0; i_s < osi->n_scales_CV; i_s++){
    for (int i_g = 0; i_g < ygeneric->subgroup.size(); i_g++){
      for (int i_d = 0; i_d < osi->extended_distribution.size(); i_d++){
	if (!ygeneric->switch_output_distribution[i_d]){continue;}
	string filename_distribution_overview = "overview." + osi->extended_distribution[i_d].xdistribution_name + ".." + xcontribution[0]->infix_order_contribution + ".dat";
	string filepath_distribution_overview = ygeneric->final_resultdirectory + "/CV/" + osi->directory_name_scale_CV[i_s] + "/" + resultdirectory + "/" + filename_distribution_overview;
	logger << LOG_DEBUG << "filename_distribution_overview = " << filename_distribution_overview << endline_flush;
	logger << LOG_DEBUG << "filepath_distribution_overview = " << filepath_distribution_overview << endline_flush;

	ofstream out_overviewfile;
	out_overviewfile.open(filepath_distribution_overview.c_str(), ofstream::out | ofstream::trunc);
	out_overviewfile << header_ss.str() << endline;
	out_overviewfile << endline;

	for (int i_b = 0; i_b < osi->extended_distribution[i_d].n_bins; i_b++){
	  int counter_empty_bin = 0;
	  // check if bin is empty (to reduce output):
	  if (xcontribution[0]->distribution_result_CV[i_g][i_d][i_b][i_s] == 0.){counter_empty_bin++; continue;}

	  int temp_size_result = int(log10(abs(osi->unit_factor_distribution * xcontribution[0]->distribution_result_CV[i_g][i_d][i_b][i_s])));
	  //		int temp_size_result_list = temp_size_result; // ???
	  for (int i_c = 0; i_c < xcontribution.size(); i_c++){
	    //	int y_q = 0;
	    //		if (xcontribution[i_c]->active_qTcut){y_q = x_q;}
	    int temp_size_result_c = int(log10(abs(osi->unit_factor_distribution * xcontribution[i_c]->distribution_result_CV[i_g][i_d][i_b][i_s])));
	    if (temp_size_result_c > temp_size_result){temp_size_result = temp_size_result_c;}
	  }
	  int temp_size_deviation = int(log10(abs(osi->unit_factor_distribution * xcontribution[0]->distribution_deviation_CV[i_g][i_d][i_b][i_s])));
	  if (osi->unit_factor_distribution * xcontribution[0]->distribution_deviation_CV[i_g][i_d][i_b][i_s] >= 1.){temp_size_deviation++;}

	  for (int i_c = 0; i_c < xcontribution.size(); i_c++){
	    //		int y_q = 0;
	    //		if (xcontribution[i_c]->active_qTcut){y_q = x_q;}

	    int temp_size_result_subprocess = int(log10(abs(osi->unit_factor_distribution * xcontribution[i_c]->distribution_result_CV[i_g][i_d][i_b][i_s])));
	    int temp_size_deviation_subprocess = int(log10(abs(osi->unit_factor_distribution * xcontribution[i_c]->distribution_deviation_CV[i_g][i_d][i_b][i_s])));
	    if (osi->unit_factor_distribution * xcontribution[i_c]->distribution_deviation_CV[i_g][i_d][i_b][i_s] >= 1.){temp_size_deviation_subprocess++;}
	    if (xcontribution[i_c]->distribution_result_CV[i_g][i_d][i_b][i_s] == 0){temp_size_result_subprocess = 0;}
	    if (xcontribution[i_c]->distribution_deviation_CV[i_g][i_d][i_b][i_s] == 0){temp_size_deviation_subprocess = 0;}
	    int setw_result = 9 + temp_size_result_subprocess - temp_size_result;
	    int setw_deviation = 9 + temp_size_deviation_subprocess - temp_size_deviation - (temp_size_result - temp_size_deviation + 1);
	    if (xcontribution[i_c]->distribution_result_CV[i_g][i_d][i_b][i_s] == 0.){setw_result = 1;setw_deviation = 1;}
	    else if (abs(osi->unit_factor_distribution * xcontribution[i_c]->distribution_result_CV[i_g][i_d][i_b][i_s]) < 1.){setw_result--;}

	    out_overviewfile << left
			     << setw(16) << setprecision(8) << noshowpoint
			     << osi->extended_distribution[i_d].bin_edge[i_b];
	    if (xcontribution[i_c]->active_qTcut){out_overviewfile << noshowpoint << setw(16) << osi->value_qTcut[i_q];}
	    else {out_overviewfile << setw(16) << "independent";}
	    if (i_c == 0){out_overviewfile << setw(25) << xcontribution[i_c]->infix_order_contribution;}
	    else {out_overviewfile << setw(25) << xcontribution[i_c]->infix_contribution;}
	    out_overviewfile << showpoint << right
			     << setw(16) << setprecision(setw_result) << osi->unit_factor_distribution * xcontribution[i_c]->distribution_result_CV[i_g][i_d][i_b][i_s]
			     << " +- "
			     << setw(16) << setprecision(setw_deviation) << osi->unit_factor_distribution * xcontribution[i_c]->distribution_deviation_CV[i_g][i_d][i_b][i_s]
			     << endline;
	    if (i_c == 0){out_overviewfile << temp_ss_separation_one.str() << endline;}
	  }
	  out_overviewfile << endline;
	  if (counter_empty_bin < selection_n_qTcut){out_overviewfile << temp_ss_separation_two.str() << endl << endline;}
	}
	out_overviewfile.close();
      }
    }
  }

  logger.finished();
}


