#include "header.hpp"

void summary_list::output_overview_TSV(){
  static Logger logger("summary_list::output_overview_TSV");
  logger.called();
  
  int start_i_m = 0; // temporary !!!
  for (int i_m = start_i_m; i_m < 1; i_m++){
    //  for (int i_m = start_i_m; i_m < osi->n_moments; i_m++){
    for (int i_s = 0; i_s < osi->n_extended_set_TSV; i_s++){
      if (!ygeneric->switch_output_scaleset[i_s]){continue;}
      if (ygeneric->switch_output_complete){ output_selection_overview_TSV("complete", i_m, i_s); }
      if (ygeneric->switch_output_ren){ output_selection_overview_TSV("ren", i_m, i_s); }
      if (ygeneric->switch_output_fact){ output_selection_overview_TSV("fact", i_m, i_s); }
      if (ygeneric->switch_output_equal){ output_selection_overview_TSV("equal", i_m, i_s); }
      if (ygeneric->switch_output_antipodal){ output_selection_overview_TSV("antipodal", i_m, i_s); }
      if (ygeneric->switch_output_7point){ output_selection_overview_TSV("7-point", i_m, i_s); }
      if (ygeneric->switch_output_9point){ output_selection_overview_TSV("9-point", i_m, i_s); }
    }
  }

  logger.finished();
}


void summary_list::output_selection_overview_TSV(string selection, int i_m, int i_s){
  static Logger logger("summary_list::output_selection_overview_TSV");
  logger.called();

  static string temp_s_separation_one;
  static string temp_s_separation_two;
  static vector<string> temp_vs_header;
  static bool initialization = true;
  if (initialization){
    stringstream temp_ss_separation_one;
    stringstream temp_ss_separation_two;
    int counter_separation = 15 + 15 + 15 + 5 + 25 + 15 + 15 + 4 + 15;
    for (int i_x = 0; i_x < counter_separation; i_x++){
      temp_ss_separation_one << "-";
      temp_ss_separation_two << "=";
    }
    temp_s_separation_one = temp_ss_separation_one.str();
    temp_s_separation_two = temp_ss_separation_two.str();

    temp_vs_header.resize(osi->n_extended_set_TSV);
    for (int i_s = 0; i_s < osi->n_extended_set_TSV; i_s++){
      if (!ygeneric->switch_output_scaleset[i_s]){continue;}
      stringstream name_ss;
      name_ss << "dXS +- err (contribution)";
      stringstream header_ss;
      header_ss << left	<< setw(15) << "qTcut";
      header_ss << setw(5) << "mu_R/" << setw(10) << osi->name_extended_set_TSV[i_s];
      header_ss << setw(5) << "mu_F/" << setw(10) << osi->name_extended_set_TSV[i_s];
      header_ss << setw(5) << "CHS";
      header_ss << setw(25) << "contribution";
      header_ss << setw(15) << "";
      header_ss << setw(34) << right << name_ss.str();
      temp_vs_header[i_s] = header_ss.str();
    }
    initialization = false;
  }

  string filename_selection;
  ofstream outfile_selection;
  filename_selection = "" + ygeneric->final_resultdirectory + "/" + osi->name_extended_set_TSV[i_s] + "/" + selection + "/" + resultdirectory + "/overview" + ygeneric->infix_name_moment[i_m] + "." + xcontribution[0]->infix_order_contribution + ".dat";
  if (Log::getLogThreshold() <= LOG_DEBUG){ logger << LOG_DEBUG << "filename_selection = " << filename_selection << endline_flush; }

  outfile_selection.open(filename_selection.c_str(), ofstream::out | ofstream::trunc);
  outfile_selection << temp_vs_header[i_s] << endline;
  outfile_selection << endline;
 
  for (int i_r = 0; i_r < osi->n_scale_ren_TSV[i_s]; i_r++){
    for (int i_f = 0; i_f < osi->n_scale_fact_TSV[i_s]; i_f++){
      if (!ygeneric->output_selection_scale_check_TSV(selection, i_s, i_r, i_f)){continue;}
      int temp_size_result = int(log10(abs(osi->unit_factor_result * result_TSV[i_m][0][i_s][i_r][i_f])));
      int temp_size_deviation = int(log10(abs(osi->unit_factor_result * deviation_TSV[i_m][0][i_s][i_r][i_f])));
      if (osi->unit_factor_result * deviation_TSV[i_m][0][i_s][i_r][i_f] >= 1.){temp_size_deviation++;}
      int setw_result = 9;
      int setw_deviation = 9 - (temp_size_result - temp_size_deviation + 1);
      if (result_TSV[i_m][0][i_s][i_r][i_f] == 0.){setw_result = 1; setw_deviation = 1;}
      else if (abs(osi->unit_factor_result * result_TSV[i_m][0][i_s][i_r][i_f]) < 1.){setw_result--;}
	
      stringstream temp_ss;
      temp_ss << left;
      if (active_qTcut){temp_ss << setw(15) << "extrapolation";}
      else {temp_ss << setw(15) << "independent";}
      temp_ss << setw(15) << setprecision(8) << osi->relative_scale_ren_TSV[i_s][i_r];
      temp_ss << setw(15) << setprecision(8) << osi->relative_scale_fact_TSV[i_s][i_f];
      if (channel_selection != "" && channel_selection != "---"){temp_ss << left << setw(5) << channel_selection;}
      else {temp_ss << left << setw(5) << "";}
      temp_ss << setw(25) << xcontribution[0]->infix_order_contribution;
      if (extra_selection != "" && extra_selection != "---"){temp_ss << left << setw(15) << extra_selection;}
      else {temp_ss << left << setw(15) << "";}
      temp_ss << right << setprecision(setw_result) << setw(15) << showpoint << osi->unit_factor_result * result_TSV[i_m][0][i_s][i_r][i_f];
      temp_ss << setw(4) << " +- ";
      temp_ss << right << setprecision(setw_deviation) << setw(15) << showpoint << osi->unit_factor_result * deviation_TSV[i_m][0][i_s][i_r][i_f];

      outfile_selection << temp_ss.str() << endline;
      outfile_selection << endline;
    }
  }
  outfile_selection << temp_s_separation_two << endline << endline;

  for (int i_q = 0; i_q < xcontribution[0]->output_n_qTcut; i_q++){
    outfile_selection << temp_vs_header[i_s] << endline;
    outfile_selection << endline;
    for (int i_r = 0; i_r < osi->n_scale_ren_TSV[i_s]; i_r++){
      for (int i_f = 0; i_f < osi->n_scale_fact_TSV[i_s]; i_f++){
	if (!ygeneric->output_selection_scale_check_TSV(selection, i_s, i_r, i_f)){continue;}
	int temp_size_result = int(log10(abs(osi->unit_factor_result * xcontribution[0]->result_TSV[i_m][0][i_q][i_s][i_r][i_f])));
	for (int i_c = 0; i_c < xcontribution.size(); i_c++){
	  int temp_size_result_c = int(log10(abs(osi->unit_factor_result * xcontribution[i_c]->result_TSV[i_m][0][i_q][i_s][i_r][i_f])));
	  if (temp_size_result_c > temp_size_result){temp_size_result = temp_size_result_c;}
	}
	int temp_size_deviation = int(log10(abs(osi->unit_factor_result * xcontribution[0]->deviation_TSV[i_m][0][i_q][i_s][i_r][i_f])));
	if (osi->unit_factor_result * xcontribution[0]->deviation_TSV[i_m][0][i_q][i_s][i_r][i_f] >= 1.){temp_size_deviation++;}

	for (int i_c = 0; i_c < xcontribution.size(); i_c++){
	  int temp_size_result_subprocess = int(log10(abs(osi->unit_factor_result * xcontribution[i_c]->result_TSV[i_m][0][i_q][i_s][i_r][i_f])));
	  int temp_size_deviation_subprocess = int(log10(abs(osi->unit_factor_result * xcontribution[i_c]->deviation_TSV[i_m][0][i_q][i_s][i_r][i_f])));
	  if (osi->unit_factor_result * xcontribution[i_c]->deviation_TSV[i_m][0][i_q][i_s][i_r][i_f] >= 1.){temp_size_deviation_subprocess++;}
	  if (xcontribution[i_c]->result_TSV[i_m][0][i_q][i_s][i_r][i_f] == 0){temp_size_result_subprocess = 0;}
	  if (xcontribution[i_c]->deviation_TSV[i_m][0][i_q][i_s][i_r][i_f] == 0){temp_size_deviation_subprocess = 0;}
	  int setw_result = 9 + temp_size_result_subprocess - temp_size_result;
	  int setw_deviation = 9 + temp_size_deviation_subprocess - temp_size_deviation - (temp_size_result - temp_size_deviation + 1);
	  if (xcontribution[i_c]->result_TSV[i_m][0][i_q][i_s][i_r][i_f] == 0.){setw_result = 1; setw_deviation = 1;}
	  else if (abs(osi->unit_factor_result * xcontribution[i_c]->result_TSV[i_m][0][i_q][i_s][i_r][i_f]) < 1.){setw_result--;}

	  stringstream temp_ss;
	  temp_ss << left;
	  if (active_qTcut){temp_ss << setw(15) << setprecision(8) << osi->value_qTcut[i_q];}
	  else {temp_ss << setw(15) << "independent";}
	  temp_ss << setw(15) << setprecision(8) << osi->relative_scale_ren_TSV[i_s][i_r];
	  temp_ss << setw(15) << setprecision(8) << osi->relative_scale_fact_TSV[i_s][i_f];
	  if (channel_selection != "" && channel_selection != "---"){temp_ss << left << setw(5) << channel_selection;}
	  else {temp_ss << left << setw(5) << "";}
	  if (i_c == 0){temp_ss << setw(25) << xcontribution[i_c]->infix_order_contribution;}
	  else {temp_ss << setw(25) << xcontribution[i_c]->infix_contribution;}
	  if (xcontribution[i_c]->extra_selection_contribution != "" && xcontribution[i_c]->extra_selection_contribution != "---"){temp_ss << left << setw(15) << xcontribution[i_c]->extra_selection_contribution;}
	  //	  else if (extra_selection != "" && extra_selection != "---"){temp_ss << left << setw(15) << extra_selection;}
	  else {temp_ss << left << setw(15) << "";}
	  temp_ss << right << setw(15) << setprecision(setw_result) << showpoint << osi->unit_factor_result * xcontribution[i_c]->result_TSV[i_m][0][i_q][i_s][i_r][i_f];
	  temp_ss << setw(4) << " +- ";
	  temp_ss << right << setw(15) << setprecision(setw_deviation) << showpoint << osi->unit_factor_result * xcontribution[i_c]->deviation_TSV[i_m][0][i_q][i_s][i_r][i_f];

	  outfile_selection << temp_ss.str() << endline;
	  if (i_c == 0){
	    outfile_selection << temp_s_separation_one << endline;
	  }
	}
	outfile_selection << endline;
      }
    }
    outfile_selection << temp_s_separation_two << endline << endline;
  }
  outfile_selection.close();
	      
  logger.finished();
}


void summary_list::output_result_TSV(){
  static Logger logger("summary_list::output_result_TSV");
  logger.called();

  int start_contribution = 0;
  int end_contribution = 1;

  if (Log::getLogThreshold() <= LOG_DEBUG){
    logger << LOG_DEBUG << "resultdirectory = " << resultdirectory << endline_flush;
    logger << LOG_DEBUG << "xcontribution[0]->infix_order_contribution = " << xcontribution[0]->infix_order_contribution << endline_flush;
  }

  int start_i_m = 0; // temporary !!!
  for (int i_m = start_i_m; i_m < 1; i_m++){
    //  for (int i_m = start_i_m; i_m < osi->n_moments; i_m++){
    for (int i_s = 0; i_s < osi->n_extended_set_TSV; i_s++){
      if (!ygeneric->switch_output_scaleset[i_s]){continue;}
      for (int i_c = start_contribution; i_c < end_contribution; i_c++){
	if (ygeneric->switch_output_complete){output_selection_result_TSV("complete", i_m, i_s, i_c);}
	if (ygeneric->switch_output_ren){output_selection_result_TSV("ren", i_m, i_s, i_c);}
	if (ygeneric->switch_output_fact){output_selection_result_TSV("fact", i_m, i_s, i_c);}
	if (ygeneric->switch_output_equal){output_selection_result_TSV("equal", i_m, i_s, i_c);}
	if (ygeneric->switch_output_antipodal){output_selection_result_TSV("antipodal", i_m, i_s, i_c);}
	if (ygeneric->switch_output_7point){output_selection_result_TSV("7-point", i_m, i_s, i_c);}
	if (ygeneric->switch_output_9point){output_selection_result_TSV("9-point", i_m, i_s, i_c);}
      }
    }
  }

  logger.finished();
}


void summary_list::output_selection_result_TSV(string selection, int i_m, int i_s, int i_c){
  static Logger logger("summary_list::output_selection_result_TSV");
  logger.called();

  static vector<string> temp_vs_header;
  static bool initialization = true;
  if (initialization){
    temp_vs_header.resize(osi->n_extended_set_TSV);
    for (int i_s = 0; i_s < osi->n_extended_set_TSV; i_s++){
      if (!ygeneric->switch_output_scaleset[i_s]){continue;}
      stringstream name_ss;
      stringstream header_ss;
      header_ss << left;
      //      if (xcontribution[i_c]->active_qTcut){ header_ss << setw(15) << "qTcut"; }
      header_ss << setw(15) << "qTcut";
      header_ss << setw(5) << "mu_R/" << setw(10) << osi->name_extended_set_TSV[i_s];
      header_ss << setw(5) << "mu_F/" << setw(10) << osi->name_extended_set_TSV[i_s];
      header_ss << setw(10) << "dXS +- err";
      temp_vs_header[i_s] = header_ss.str();
    }
    initialization = false;
  }

  string filename_selection;
  ofstream outfile_selection;
  filename_selection = "" + ygeneric->final_resultdirectory + "/" + osi->name_extended_set_TSV[i_s] + "/" + selection + "/" + resultdirectory + "/result" + ygeneric->infix_name_moment[i_m] + "." + resultdirectory + ".dat";
  if (Log::getLogThreshold() <= LOG_DEBUG){ logger << LOG_DEBUG << "filename_selection = " << filename_selection << endline_flush; }
  outfile_selection.open(filename_selection.c_str(), ofstream::out | ofstream::trunc);
  stringstream name_ss;
  //  name_ss << "(" << xcontribution[i_c]->infix_order_contribution << ")";
  name_ss << "(" << resultdirectory << ")";
  outfile_selection << temp_vs_header[i_s] << " " << left << setw(23) << name_ss.str();
  //  if (i_c == 0 && xcontribution[i_c]->active_qTcut){ outfile_selection << setw(15) << "err(stat)" << setw(15) << "err(extr)"; }
  if (active_qTcut){ outfile_selection << setw(15) << "err(stat)" << setw(15) << "err(extr)"; }
  outfile_selection << endline;
  {
    //  if (!active_qTcut){
    //  if (i_c == 0 || !(xcontribution[i_c]->active_qTcut)){
    outfile_selection << endline;
    for (int i_r = 0; i_r < osi->n_scale_ren_TSV[i_s]; i_r++){
      for (int i_f = 0; i_f < osi->n_scale_fact_TSV[i_s]; i_f++){
	if (!ygeneric->output_selection_scale_check_TSV(selection, i_s, i_r, i_f)){continue;}
	stringstream temp_ss;
	temp_ss << left;
	if (active_qTcut){ temp_ss << setw(15) << "extrapolation"; }
	else { temp_ss << setw(15) << "independent"; }
	temp_ss	<< noshowpoint << left << setw(15) << setprecision(8) << osi->relative_scale_ren_TSV[i_s][i_r];
	temp_ss	<< noshowpoint << left << setw(15) << setprecision(8) << osi->relative_scale_fact_TSV[i_s][i_f];
	temp_ss	<< left << showpoint << setprecision(8) << setw(15) << osi->unit_factor_result * result_TSV[i_m][0][i_s][i_r][i_f];
	temp_ss	<< " +- ";
	temp_ss	<< left << setprecision(8) << setw(15) << osi->unit_factor_result * deviation_TSV[i_m][0][i_s][i_r][i_f];
	if (active_qTcut){
	  //	if (xcontribution[i_c]->active_qTcut){
	  temp_ss << setprecision(8) << setw(15) << osi->unit_factor_result * deviation_statistics_TSV[i_m][0][i_s][i_r][i_f];
	  temp_ss << setprecision(8) << setw(15) << osi->unit_factor_result * deviation_extrapolation_TSV[i_m][0][i_s][i_r][i_f];
	}
	outfile_selection << temp_ss.str() << endline;
      }
    }
  }
  if (active_qTcut){
    //    for (int i_q = 0; i_q < xcontribution[i_c]->output_n_qTcut; i_q++){
    for (int i_q = 0; i_q < output_n_qTcut; i_q++){
      outfile_selection << endline;
      for (int i_r = 0; i_r < osi->n_scale_ren_TSV[i_s]; i_r++){
	for (int i_f = 0; i_f < osi->n_scale_fact_TSV[i_s]; i_f++){
	  if (!ygeneric->output_selection_scale_check_TSV(selection, i_s, i_r, i_f)){continue;}
	  stringstream temp_ss;
	  temp_ss << left;
	  if (active_qTcut){temp_ss << setw(15) << osi->value_qTcut[i_q];}
	  //	  if (xcontribution[i_c]->active_qTcut){temp_ss << setw(15) << osi->value_qTcut[i_q];}
	  temp_ss << setw(15) << setprecision(8) << osi->relative_scale_ren_TSV[i_s][i_r];;
	  temp_ss << setw(15) << setprecision(8) << osi->relative_scale_fact_TSV[i_s][i_f];
	  temp_ss << setprecision(8) << setw(15) << osi->unit_factor_result * xcontribution[i_c]->result_TSV[i_m][0][i_q][i_s][i_r][i_f];
	  //	  temp_ss << setprecision(8) << setw(15) << osi->unit_factor_result * result_qTcut_TSV[i_m][0][i_q][i_s][i_r][i_f];
	  temp_ss << " +- ";
	  temp_ss << setprecision(8) << setw(15) << osi->unit_factor_result * xcontribution[i_c]->deviation_TSV[i_m][0][i_q][i_s][i_r][i_f];
	  //	  temp_ss << setprecision(8) << setw(15) << osi->unit_factor_result * deviation_qTcut_TSV[i_m][0][i_q][i_s][i_r][i_f];
	  outfile_selection << temp_ss.str() << endline;
	}
      }
    }
  }
  outfile_selection.close();
	
  logger.finished();
}


void summary_list::output_plot_qTcut_TSV(){
  static Logger logger("summary_list::output_plot_qTcut_TSV");
  logger.called();
  
  int start_contribution = 0;
  int end_contribution = 1;
  //  if (ygeneric->switch_output_plot > 2){end_contribution = xcontribution.size();}

  int start_i_m = 0; // temporary !!!
  for (int i_m = start_i_m; i_m < 1; i_m++){
    //  for (int i_m = start_i_m; i_m < osi->n_moments; i_m++){
    for (int i_s = 0; i_s < osi->n_extended_set_TSV; i_s++){
      if (!ygeneric->switch_output_scaleset[i_s]){continue;}
      for (int i_c = start_contribution; i_c < end_contribution; i_c++){
	if (ygeneric->switch_output_complete){output_selection_plot_qTcut_TSV("complete", i_m, i_s, i_c);}
	if (ygeneric->switch_output_ren){output_selection_plot_qTcut_TSV("ren", i_m, i_s, i_c);}
	if (ygeneric->switch_output_fact){output_selection_plot_qTcut_TSV("fact", i_m, i_s, i_c);}
	if (ygeneric->switch_output_equal){output_selection_plot_qTcut_TSV("equal", i_m, i_s, i_c);}
	if (ygeneric->switch_output_antipodal){output_selection_plot_qTcut_TSV("antipodal", i_m, i_s, i_c);}
	if (ygeneric->switch_output_7point){output_selection_plot_qTcut_TSV("7-point", i_m, i_s, i_c);}
	if (ygeneric->switch_output_9point){output_selection_plot_qTcut_TSV("9-point", i_m, i_s, i_c);}
      }
    }
  }

  logger.finished();
}


void summary_list::output_selection_plot_qTcut_TSV(string selection, int i_m, int i_s, int i_c){
  static Logger logger("summary_list::output_selection_plot_qTcut_TSV");
  logger.called();

  string filename_selection;
  ofstream outfile_selection;
  filename_selection = "" + ygeneric->final_resultdirectory + "/" + osi->name_extended_set_TSV[i_s] + "/" + selection + "/" + resultdirectory + "/plot.qTcut" + ygeneric->infix_name_moment[i_m] + "." + xcontribution[i_c]->infix_order_contribution + ".dat";
  if (Log::getLogThreshold() <= LOG_DEBUG){ logger << LOG_DEBUG << "filename_selection = " << filename_selection << endline_flush; }

  outfile_selection.open(filename_selection.c_str(), ofstream::out | ofstream::trunc);
  outfile_selection << left << setw(15) << "#qTcut";
  for (int i_r = 0; i_r < osi->n_scale_ren_TSV[i_s]; i_r++){
    for (int i_f = 0; i_f < osi->n_scale_fact_TSV[i_s]; i_f++){
      if (!ygeneric->output_selection_scale_check_TSV(selection, i_s, i_r, i_f)){continue;}
      outfile_selection << left << setw(30) << ygeneric->scalelabel_xi_R_F_TSV[i_s][i_r][i_f]; 
    }
  }
  outfile_selection << ygeneric->scalelabel_mu_R_F_TSV[i_s] << endline;
  if (!(xcontribution[i_c]->active_qTcut)){
    outfile_selection << setw(15) << "0";
    for (int i_r = 0; i_r < osi->n_scale_ren_TSV[i_s]; i_r++){
      for (int i_f = 0; i_f < osi->n_scale_fact_TSV[i_s]; i_f++){
	if (!ygeneric->output_selection_scale_check_TSV(selection, i_s, i_r, i_f)){continue;}
	stringstream temp_ss;
	temp_ss << left	<< setprecision(8) << setw(15) << osi->unit_factor_result * xcontribution[i_c]->result_TSV[i_m][0][0][i_s][i_r][i_f];
	temp_ss << left	<< setprecision(8) << setw(15) << osi->unit_factor_result * xcontribution[i_c]->deviation_TSV[i_m][0][0][i_s][i_r][i_f];
	outfile_selection << temp_ss.str();
      }
    }
    outfile_selection << endline;
  }

  for (int i_q = 0; i_q < osi->n_qTcut; i_q++){
    outfile_selection << setw(15) << osi->value_qTcut[i_q];
    for (int i_r = 0; i_r < osi->n_scale_ren_TSV[i_s]; i_r++){
      for (int i_f = 0; i_f < osi->n_scale_fact_TSV[i_s]; i_f++){
	if (!ygeneric->output_selection_scale_check_TSV(selection, i_s, i_r, i_f)){continue;}
	stringstream temp_ss;
	temp_ss << left	<< setprecision(8) << setw(15) << osi->unit_factor_result * xcontribution[i_c]->result_TSV[i_m][0][i_q][i_s][i_r][i_f];
	temp_ss << left	<< setprecision(8) << setw(15) << osi->unit_factor_result * xcontribution[i_c]->deviation_TSV[i_m][0][i_q][i_s][i_r][i_f];
	outfile_selection << temp_ss.str();
      }
    }
    outfile_selection << endline;
  }
  outfile_selection.close();
	
  logger.finished();
}


void summary_list::output_plot_TSV(){
  static Logger logger("summary_list::output_plot_TSV");
  logger.called();

  int start_i_m = 0; // temporary !!!
  for (int i_m = start_i_m; i_m < osi->n_moments; i_m++){
    for (int i_s = 0; i_s < osi->n_extended_set_TSV; i_s++){
      if (!ygeneric->switch_output_scaleset[i_s]){continue;}

      if (ygeneric->switch_output_complete){output_selection_plot_TSV("complete", i_m, i_s);}
      if (ygeneric->switch_output_ren){output_selection_plot_TSV("ren", i_m, i_s);}
      if (ygeneric->switch_output_fact){output_selection_plot_TSV("fact", i_m, i_s);}
      if (ygeneric->switch_output_equal){output_selection_plot_TSV("equal", i_m, i_s);}
      if (ygeneric->switch_output_antipodal){output_selection_plot_TSV("antipodal", i_m, i_s);}
      if (ygeneric->switch_output_7point){output_selection_plot_TSV("7-point", i_m, i_s);}
      if (ygeneric->switch_output_9point){output_selection_plot_TSV("9-point", i_m, i_s);}
    }
  }

  logger.finished();
}


void summary_list::output_selection_plot_TSV(string selection, int i_m, int i_s){
  static Logger logger("summary_list::output_selection_plot_TSV");
  logger.called();

  string filename_selection;
  ofstream outfile_selection;
  filename_selection = "" + ygeneric->final_resultdirectory + "/" + osi->name_extended_set_TSV[i_s] + "/" + selection + "/" + resultdirectory + "/plot" + ygeneric->infix_name_moment[i_m] + "." + resultdirectory + ".dat";
  outfile_selection.open(filename_selection.c_str(), ofstream::out | ofstream::trunc);
  outfile_selection << left << setw(15) << "#qTcut";
  for (int i_r = 0; i_r < osi->n_scale_ren_TSV[i_s]; i_r++){
    for (int i_f = 0; i_f < osi->n_scale_fact_TSV[i_s]; i_f++){
      if (!ygeneric->output_selection_scale_check_TSV(selection, i_s, i_r, i_f)){continue;}
      outfile_selection << left << setw(30) << ygeneric->scalelabel_xi_R_F_TSV[i_s][i_r][i_f]; 
    }
  }
  outfile_selection << ygeneric->scalelabel_mu_R_F_TSV[i_s] << endline;
  outfile_selection << setw(15) << "0";
  for (int i_r = 0; i_r < osi->n_scale_ren_TSV[i_s]; i_r++){
    for (int i_f = 0; i_f < osi->n_scale_fact_TSV[i_s]; i_f++){
      if (!ygeneric->output_selection_scale_check_TSV(selection, i_s, i_r, i_f)){continue;}
      stringstream temp_ss;
      temp_ss << left << setprecision(8) << setw(15) << osi->unit_factor_result * result_TSV[i_m][0][i_s][i_r][i_f];
      temp_ss << left << setprecision(8) << setw(15) << osi->unit_factor_result * deviation_TSV[i_m][0][i_s][i_r][i_f];
      outfile_selection << temp_ss.str();
    }
  }
  outfile_selection << endline;
  outfile_selection.close();
	
  logger.finished();
}





// All functions below are only relevant for CV variation:

// Should be expressed from <list> results !!!

void summary_list::output_contribution_result_overview_qTcut_CV(){
  static Logger logger("summary_list::output_contribution_result_overview_qTcut_CV");
  logger.called();

  string filename;
  ofstream outfile;

  stringstream temp_ss_separation_one;
  stringstream temp_ss_separation_two;
  int counter_separation = 15 + 15 + 15 + 25 + 15 + 4 + 15;
  for (int i_x = 0; i_x < counter_separation; i_x++){
    temp_ss_separation_one << "-";
    temp_ss_separation_two << "=";
  }

  vector<double> rel_scale_CV(osi->n_scales_CV);
  vector<double> scale_CV(osi->n_scales_CV);
  if (osi->n_scales_CV != 0 && osi->n_qTcut != 0){
    for (int s = 0; s < osi->n_scales_CV; s++){
      if (osi->n_scales_CV > 1){rel_scale_CV[s] = pow(10., log10(double(osi->variation_factor_CV)) * double(2. * s / (osi->n_scales_CV - 1) - 1));}
      else {rel_scale_CV[s] = 1;}
      scale_CV[s] = rel_scale_CV[s] * osi->scale_ren;
    }
  }

  int start_i_m = 0; // temporary !!!
  for (int i_m = start_i_m; i_m < osi->n_moments; i_m++){
    filename = "" + ygeneric->final_resultdirectory + "/CV/" + ygeneric->name_variation_CV + "/" + resultdirectory + "/overview" + ygeneric->infix_name_moment[i_m] + "." + xcontribution[0]->infix_order_contribution + ".dat";
    logger << LOG_DEBUG << "FILENAME:   " << filename << endline_flush;

    outfile.open(filename.c_str(), ofstream::out | ofstream::trunc);

    stringstream name_ss;
    name_ss << "dXS +- err (contribution)";

    stringstream header_ss;
    header_ss << left
	      << setw(15) << "qTcut"
	      << setw(5) << "mu_R/" << setw(10) << "CV"
	      << setw(5) << "mu_F/" << setw(10) << "CV"
	      << setw(25) << "contribution"
	      << setw(34) << right << name_ss.str();

    outfile << header_ss.str() << endline;

    outfile << endline;

    for (int i_s = 0; i_s < osi->n_scales_CV; i_s++){
      stringstream temp_ss;
      temp_ss << noshowpoint << left;
      if (active_qTcut){temp_ss << setw(15) << "extrapolation";}
      else {temp_ss << setw(15) << "independent";}
      temp_ss << setw(15) << setprecision(8) << osi->rel_scale_factor_ren_CV[i_s]
	      << setw(15) << setprecision(8) << osi->rel_scale_factor_fact_CV[i_s]
	      << setw(25) << xcontribution[0]->infix_order_contribution
	      << showpoint
	      << right << setprecision(8) << setw(15) << osi->unit_factor_result * result_CV[i_m][0][i_s]
	      << setw(4) << " +- "
	      << right << setprecision(8) << setw(15) << osi->unit_factor_result * deviation_CV[i_m][0][i_s];

      outfile << temp_ss.str() << endline;

      outfile << endline;
    }

    outfile << temp_ss_separation_two.str() << endline << endline;

    for (int i_q = 0; i_q < xcontribution[0]->output_n_qTcut; i_q++){
      outfile << header_ss.str() << endline;

      outfile << endline;

      for (int i_s = 0; i_s < osi->n_scales_CV; i_s++){
	int temp_size_result = int(log10(abs(osi->unit_factor_result * xcontribution[0]->result_CV[i_m][0][i_q][i_s])));
	for (int i_c = 0; i_c < xcontribution.size(); i_c++){
	  int temp_size_result_c = int(log10(abs(osi->unit_factor_result * xcontribution[i_c]->result_CV[i_m][0][i_q][i_s])));
	  if (temp_size_result_c > temp_size_result){temp_size_result = temp_size_result_c;}
	}
	int temp_size_deviation = int(log10(abs(osi->unit_factor_result * xcontribution[0]->deviation_CV[i_m][0][i_q][i_s])));
	if (osi->unit_factor_result * xcontribution[0]->deviation_CV[i_m][0][i_q][i_s] >= 1.){temp_size_deviation++;}

	for (int i_c = 0; i_c < xcontribution.size(); i_c++){
	  int temp_size_result_subprocess = int(log10(abs(osi->unit_factor_result * xcontribution[i_c]->result_CV[i_m][0][i_q][i_s])));
	  int temp_size_deviation_subprocess = int(log10(abs(osi->unit_factor_result * xcontribution[i_c]->deviation_CV[i_m][0][i_q][i_s])));
	  if (osi->unit_factor_result * xcontribution[i_c]->deviation_CV[i_m][0][i_q][i_s] >= 1.){temp_size_deviation_subprocess++;}
	  if (xcontribution[i_c]->result_CV[i_m][0][i_q][i_s] == 0){temp_size_result_subprocess = 0;}
	  if (xcontribution[i_c]->deviation_CV[i_m][0][i_q][i_s] == 0){temp_size_deviation_subprocess = 0;}
	  int setw_result = 9 + temp_size_result_subprocess - temp_size_result;
	  int setw_deviation = 9 + temp_size_deviation_subprocess - temp_size_deviation - (temp_size_result - temp_size_deviation + 1);
	  if (xcontribution[i_c]->result_CV[i_m][0][i_q][i_s] == 0.){setw_result = 1;setw_deviation = 1;}
	  else if (abs(osi->unit_factor_result * xcontribution[i_c]->result_CV[i_m][0][i_q][i_s]) < 1.){setw_result--;}

	  stringstream temp_ss;
	  temp_ss << noshowpoint << left;
	  if (active_qTcut){temp_ss << setw(15) << setprecision(8) << osi->value_qTcut[i_q];}
	  else {temp_ss << setw(15) << "independent";}
	  temp_ss << setw(15) << setprecision(8) << osi->rel_scale_factor_ren_CV[i_s]
		  << setw(15) << setprecision(8) << osi->rel_scale_factor_fact_CV[i_s];
	  if (i_c == 0){temp_ss << setw(25) << xcontribution[i_c]->infix_order_contribution;}
	  else {temp_ss << setw(25) << xcontribution[i_c]->infix_contribution;}
	  temp_ss << showpoint
		  << right << setw(15) << setprecision(setw_result)
		  << osi->unit_factor_result * xcontribution[i_c]->result_CV[i_m][0][i_q][i_s]
		  << setw(4) << " +- "
		  << right << setw(15) << setprecision(setw_deviation)
		  << osi->unit_factor_result * xcontribution[i_c]->deviation_CV[i_m][0][i_q][i_s];

	  outfile << temp_ss.str() << endline;

	  if (i_c == 0){
	    outfile << temp_ss_separation_one.str() << endline;
	  }
	}
	outfile << endline;
      }
      outfile << temp_ss_separation_two.str() << endline << endline;
    }
  }
  outfile.close();

  logger.finished();
}


void summary_list::output_contribution_result_qTcut_CV(){
  static Logger logger("summary_list::output_contribution_result_qTcut_CV");
  logger.called();

  int start_contribution = 0;
  int end_contribution = 1;
  //  if (ygeneric->switch_output_result > 2){end_contribution = xcontribution.size();}

  string filename;
  ofstream outfile;

  int start_i_m = 0;
  for (int i_m = start_i_m; i_m < osi->n_moments; i_m++){
    for (int i_c = start_contribution; i_c < end_contribution; i_c++){
      filename = "" + ygeneric->final_resultdirectory + "/CV/" + ygeneric->name_variation_CV + "/" + resultdirectory + "/result" + ygeneric->infix_name_moment[i_m] + "." + xcontribution[i_c]->infix_order_contribution + ".dat";

      logger << LOG_DEBUG << "FILENAME:   " << filename << endline_flush;

      outfile.open(filename.c_str(), ofstream::out | ofstream::trunc);

      stringstream name_ss;
      name_ss << "XS +- err (" << xcontribution[i_c]->infix_order_contribution << ")";

      stringstream header_ss;
      header_ss << left
		<< setw(15) << "qTcut"
		<< setw(5) << "mu_R/" << setw(10) << "CV"
		<< setw(5) << "mu_F/" << setw(10) << "CV"
		<< setw(34) << name_ss.str();
      if (i_c == 0 && xcontribution[i_c]->active_qTcut){
	header_ss << setw(15) << "err(stat)"
		  << setw(15) << "err(extr)";
      }
      outfile << header_ss.str() << endline;
      if (i_c == 0 || !(xcontribution[i_c]->active_qTcut)){
	outfile << endline;
	for (int i_s = 0; i_s < osi->n_scales_CV; i_s++){
	  outfile << left;
	  if (active_qTcut){outfile << setw(15) << "extrapolation";}
	  else {outfile << setw(15) << "independent";}
	  outfile << noshowpoint
		  << setw(15) << setprecision(8) << osi->rel_scale_factor_ren_CV[i_s]
		  << setw(15) << setprecision(8) << osi->rel_scale_factor_fact_CV[i_s]
		  << showpoint
		  << setprecision(8) << setw(15) << osi->unit_factor_result * result_CV[i_m][0][i_s]
		  << " +- "
		  << setprecision(8) << setw(15) << osi->unit_factor_result * deviation_CV[i_m][0][i_s];
	  if (xcontribution[i_c]->active_qTcut){
	    outfile << setprecision(8) << setw(15) << osi->unit_factor_result * deviation_statistics_CV[i_m][0][i_s]
		    << setprecision(8) << setw(15) << osi->unit_factor_result * deviation_extrapolation_CV[i_m][0][i_s];
	  }
	  outfile << endline;
	}
      }

      if (xcontribution[i_c]->active_qTcut){
	for (int i_q = 0; i_q < xcontribution[i_c]->output_n_qTcut; i_q++){
	  outfile << endline;
	  for (int i_s = 0; i_s < osi->n_scales_CV; i_s++){
	    stringstream temp_ss;
	    temp_ss << noshowpoint
		    << left;
	    temp_ss << setw(15) << osi->value_qTcut[i_q];
	    temp_ss << setw(15) << setprecision(8) << osi->rel_scale_factor_ren_CV[i_s]
		    << setw(15) << setprecision(8) << osi->rel_scale_factor_fact_CV[i_s]
		    << showpoint
		    << setprecision(8) << setw(15) << osi->unit_factor_result * xcontribution[i_c]->result_CV[i_m][0][i_q][i_s]
		    << " +- "
		    << setprecision(8) << setw(15) << osi->unit_factor_result * xcontribution[i_c]->deviation_CV[i_m][0][i_q][i_s];
	    outfile << temp_ss.str() << endline;
	  }
	}
      }
      outfile.close();
    }
  }

  logger.finished();
}


void summary_list::output_contribution_result_plot_qTcut_CV(){
  static Logger logger("summary_list::output_contribution_result_plot_qTcut_CV");
  logger.called();

  int start_contribution = 0;
  int end_contribution = 1;

  string filename;

  int start_i_m = 0;
  for (int i_m = start_i_m; i_m < osi->n_moments; i_m++){
    for (int i_c = start_contribution; i_c < end_contribution; i_c++){
      ofstream outfile;

      if (osi->n_qTcut > 1){
	///////////////////////////////////////
	//  output of usual qTcut variation  //
	///////////////////////////////////////
	filename = ygeneric->final_resultdirectory + "/CV/" + ygeneric->name_variation_CV + "/" + resultdirectory + "/plot" + ygeneric->infix_name_moment[i_m] + ".qTcut." + xcontribution[i_c]->infix_order_contribution + ".dat";

	logger << LOG_DEBUG << "FILENAME:   " << filename << endline_flush;

	outfile.open(filename.c_str(), ofstream::out | ofstream::trunc);

	outfile << noshowpoint;
	outfile << left << setw(15) << "# qTcut";
	for (int i_s = 0; i_s < osi->n_scales_CV; i_s++){
	  stringstream temp_ss;
	  temp_ss << "mu_R = "
		  << setprecision(2) << setw(4) << osi->rel_scale_factor_ren_CV[i_s]
		  << " -- "
		  << "mu_F = "
		  << setprecision(2) << setw(4) << osi->rel_scale_factor_fact_CV[i_s] << "    ";
	  outfile << setw(30) << temp_ss.str() << left;
	}
	outfile << endline;

	if (!(xcontribution[i_c]->active_qTcut)){
	  outfile << setw(15) << "0";
	  for (int i_s = 0; i_s < osi->n_scales_CV; i_s++){
	    stringstream temp_ss;
	    temp_ss << left
		    << showpoint
		    << setprecision(8) << setw(15) << osi->unit_factor_result * xcontribution[i_c]->result_CV[i_m][0][0][i_s]
		    << setprecision(8) << setw(15) << osi->unit_factor_result * xcontribution[i_c]->deviation_CV[i_m][0][0][i_s];
	    outfile << temp_ss.str();
	  }
	  outfile << endline;
	}

	for (int i_q = 0; i_q < osi->n_qTcut; i_q++){
	  outfile << noshowpoint
		  << setprecision(4) << setw(15) << osi->value_qTcut[i_q];
	  for (int i_s = 0; i_s < osi->n_scales_CV; i_s++){
	    outfile << showpoint
		    << setprecision(8) << setw(15) << osi->unit_factor_result * xcontribution[i_c]->result_CV[i_m][0][i_q][i_s]
		    << setprecision(8) << setw(15) << osi->unit_factor_result * xcontribution[i_c]->deviation_CV[i_m][0][i_q][i_s];
	  }
	  outfile << endline;
	}
	outfile.close();
      }
    }
  }

  logger.finished();
}


void summary_list::output_contribution_result_plot_CV(){
  static Logger logger("summary_list::output_contribution_result_plot_CV");
  logger.called();

  string filename;

  vector<double> rel_scale_CV(osi->n_scales_CV);
  vector<double> scale_CV(osi->n_scales_CV);
  if (osi->n_scales_CV != 0 && osi->n_qTcut != 0){
    for (int s = 0; s < osi->n_scales_CV; s++){
      if (osi->n_scales_CV > 1){rel_scale_CV[s] = pow(10., log10(double(osi->variation_factor_CV)) * double(2. * s / (osi->n_scales_CV - 1) - 1));}
      else {rel_scale_CV[s] = 1;}
      scale_CV[s] = rel_scale_CV[s] * osi->scale_ren;
    }
  }

  int i_q = 0;

  int start_i_m = 0;
  for (int i_m = start_i_m; i_m < osi->n_moments; i_m++){
    ofstream outfile;

    ////////////////////////////////////
    //  output of usual CV variation  //
    ////////////////////////////////////
    filename = ygeneric->final_resultdirectory + "/CV/" + ygeneric->name_variation_CV + "/" + resultdirectory + "/plot" + ygeneric->infix_name_moment[i_m] + ".CV." + xcontribution[0]->infix_order_contribution + ".dat";

    logger << LOG_DEBUG << "FILENAME:   " << filename << endline_flush;

    outfile.open(filename.c_str(), ofstream::out | ofstream::trunc);

    for (int i_s = 0; i_s < osi->n_scales_CV; i_s++){
      outfile << setw(15) << setprecision(8) << rel_scale_CV[i_s]
	      << setprecision(8) << setw(15) << osi->unit_factor_result * xcontribution[0]->result_CV[i_m][0][i_q][i_s]
	      << setprecision(8) << setw(15) << osi->unit_factor_result * xcontribution[0]->deviation_CV[i_m][0][i_q][i_s]
	      << endline;
    }
    outfile.close();

    ////////////////////////////////////////////////////////////////////////
    //   output of summed NLO contributions on Born phase-space (BVIKP)   //
    ////////////////////////////////////////////////////////////////////////
    vector<int> temp_exclude_real;
    for (int i_c = 0; i_c < xcontribution.size(); i_c++){
      if (xcontribution[i_c]->type_contribution == "RA"){temp_exclude_real.push_back(i_c);}
    }
    if (temp_exclude_real.size() != 0){
      filename = ygeneric->final_resultdirectory + "/CV/" + ygeneric->name_variation_CV + "/" + resultdirectory + "/plot" + ygeneric->infix_name_moment[i_m] + ".CV." + xcontribution[0]->infix_order_contribution + ".VIKP.dat";

      logger << LOG_DEBUG << "FILENAME:   " << filename << endline_flush;

      outfile.open(filename.c_str(), ofstream::out | ofstream::trunc);

      for (int i_s = 0; i_s < osi->n_scales_CV; i_s++){
	logger << LOG_DEBUG_VERBOSE << "i_q = " << i_q << "   i_s = " << i_s << endline_flush;
	double temp_result = 0.;
	double temp_deviation2 = 0.;
	for (int i_c = 1; i_c < xcontribution.size(); i_c++){
	  //	for (int i_c = 1; i_c < temp_result_CV.size(); i_c++){
	  int flag = temp_exclude_real.size();
	  for (int j_c = 0; j_c < temp_exclude_real.size(); j_c++){if (temp_exclude_real[j_c] == i_c){flag = i_c;}}
	  if (flag == temp_exclude_real.size()){
	    temp_result += xcontribution[i_c]->result_CV[i_m][0][i_q][i_s];
	    temp_deviation2 += pow(xcontribution[i_c]->deviation_CV[i_m][0][i_q][i_s], 2);
	  }
	}
	outfile << setw(15) << setprecision(8) << rel_scale_CV[i_s] << setprecision(8) << setw(15) << osi->unit_factor_result * temp_result << setprecision(8) << setw(15) << osi->unit_factor_result * sqrt(temp_deviation2) << endline;
      }
      outfile.close();
      logger << LOG_DEBUG_VERBOSE << filename << " closed." << endline_flush;
    }

    //////////////////////////////////////////////////////////////////
    //  output of extrapolated (or qTcut-independent) CV variation  //
    //////////////////////////////////////////////////////////////////
    filename = ygeneric->final_resultdirectory + "/CV/" + ygeneric->name_variation_CV + "/" + resultdirectory + "/plot" + ygeneric->infix_name_moment[i_m] + ".CV.extrapolated." + xcontribution[0]->infix_order_contribution + ".dat";

    logger << LOG_DEBUG << "FILENAME:   " << filename << endline_flush;

    outfile.open(filename.c_str(), ofstream::out | ofstream::trunc);

    for (int i_s = 0; i_s < osi->n_scales_CV; i_s++){
      logger << LOG_DEBUG_VERBOSE << "i_q = " << i_q << "   i_s = " << i_s << endline_flush;
      outfile << noshowpoint
	      << setw(15) << setprecision(8) << rel_scale_CV[i_s]
	      << showpoint
	      << setprecision(8) << setw(15) << osi->unit_factor_result * result_CV[i_m][0][i_s]
	      << setprecision(8) << setw(15) << osi->unit_factor_result * deviation_CV[i_m][0][i_s]
	      << endline;
    }
    outfile.close();

    ///////////////////////////////////////////////////////////////////////////
    //  standard output of extrapolated (or qTcut-independent) CV variation  //
    ///////////////////////////////////////////////////////////////////////////
    filename = ygeneric->final_resultdirectory + "/CV/" + ygeneric->name_variation_CV + "/" + resultdirectory + "/plot" + ygeneric->infix_name_moment[i_m] + "." + xcontribution[0]->infix_order_contribution + ".dat";

    logger << LOG_DEBUG << "FILENAME:   " << filename << endline_flush;

    outfile.open(filename.c_str(), ofstream::out | ofstream::trunc);

    outfile << left << setw(15) << "# qTcut";
    for (int i_s = 0; i_s < osi->n_scales_CV; i_s++){
      stringstream temp_ss;
      temp_ss << noshowpoint
	      << "mu_R = "
	      << setprecision(2) << setw(4) << showpoint << osi->rel_scale_factor_ren_CV[i_s]
	      << " -- "
	      << "mu_F = "
	      << setprecision(2) << setw(4) << showpoint << osi->rel_scale_factor_fact_CV[i_s] << "    ";
      outfile << setw(30) << temp_ss.str() << left;
    }
    outfile << endline;

    outfile << noshowpoint
	    << setw(15) << osi->value_qTcut[i_q];
    for (int i_s = 0; i_s < osi->n_scales_CV; i_s++){
      outfile << showpoint
	      << setprecision(8) << setw(15) << osi->unit_factor_result * result_CV[i_m][0][i_s]
	      << setprecision(8) << setw(15) << osi->unit_factor_result * deviation_CV[i_m][0][i_s];
    }
    outfile << endline;
    outfile.close();
  }

  logger.finished();
}
