#include "header.hpp"

void summary_list::calculate_runtime(){
  static Logger logger("summary_list::calculate_runtime");
  logger.called();

  // reset to zero for xcontribution[0]->xsubprocess[0] component !!!
  xcontribution[0]->xsubprocess[0]->used_runtime = 0.;
  xcontribution[0]->xsubprocess[0]->used_n_event = 0;
  xcontribution[0]->xsubprocess[0]->error2_time = 0.;

  for (int i_c = 1; i_c < xcontribution.size(); i_c++){
    xcontribution[0]->xsubprocess[0]->error2_time += xcontribution[i_c]->xsubprocess[0]->error2_time;
  }
  for (int i_c = 1; i_c < xcontribution.size(); i_c++){
    xcontribution[0]->xsubprocess[0]->used_runtime += xcontribution[i_c]->xsubprocess[0]->used_runtime;
    xcontribution[0]->xsubprocess[0]->used_n_event += xcontribution[i_c]->xsubprocess[0]->used_n_event;
  }
  stringstream temp_ss;
  for (int i_c = 0; i_c < xcontribution.size(); i_c++){
    temp_ss << left << setw(25) << xcontribution[i_c]->infix_order_contribution << " - xcontribution[" << i_c << "]:   used_runtime = " << right << setw(15) << setprecision(8) << xcontribution[i_c]->xsubprocess[0]->used_runtime << "   used_n_event = " << setw(15) << xcontribution[i_c]->xsubprocess[0]->used_n_event << "   error2_time = " << setw(20) << xcontribution[i_c]->xsubprocess[0]->error2_time << endline;
  }
  logger << LOG_INFO << endline << temp_ss.str() << endline_flush;
    
  logger.finished();
}


void summary_list::output_runtime_MATRIX(ofstream & outfile_readin_extrapolated){
  static Logger logger("summary_list::output_runtime_MATRIX");
  logger.called();

  /////////////////////////////////////////////////////////////
  //  extrapolated runtime - readin.extrapolated.runtime.dat //
  /////////////////////////////////////////////////////////////

  stringstream temp_ss;
  temp_ss << left << setw(25) << "contribution" << setw(15) << "optimization" << setw(20) << "subprocess" << right << setw(20) << "time_per_event" << setw(20) << "used_n_event" << setw(20) << "used_runtime" << endline;
  for (int i_s = 0; i_s < 120; i_s++){temp_ss << "-";}
  temp_ss << endline;
  for (int i_c = 1; i_c < xcontribution.size(); i_c++){
    for (int i_p = 1; i_p < xcontribution[i_c]->xsubprocess.size(); i_p++){
      for (int i_o = 0; i_o < ygeneric->phasespace_optimization.size(); i_o++){
	if (ygeneric->phasespace_optimization[i_o] == "combined"){continue;}
	string temp_directory = xcontribution[i_c]->infix_path_contribution;// + ygeneric->phasespace_optimization[i_o];
	temp_ss << left << setw(25) << temp_directory;
	temp_ss << left << setw(15) << ygeneric->name_phasespace_optimization[i_o];
	if ( xcontribution[i_c]->xsubprocess[i_p]->used_n_event_group.size() == 0){continue;}
	temp_ss << left << setw(20) << xcontribution[i_c]->xsubprocess[i_p]->name;
	temp_ss << right << setw(20) << xcontribution[i_c]->xsubprocess[i_p]->time_per_event_group[i_o];
	temp_ss << right << setw(20) << xcontribution[i_c]->xsubprocess[i_p]->used_n_event_group[i_o];
	temp_ss << right << setw(20) << xcontribution[i_c]->xsubprocess[i_p]->used_runtime_group[i_o];
	temp_ss << endline;
	  //  time_per_event_group
      }
    }
    temp_ss << endline;
  }
  logger << LOG_INFO << "Used runtime for  " << resultdirectory << endline << endline << temp_ss.str() << endline_flush;

    
  for (int i_c = 1; i_c < xcontribution.size(); i_c++){
    for (int i_p = 1; i_p < xcontribution[i_c]->xsubprocess.size(); i_p++){
      for (int i_o = 0; i_o < ygeneric->phasespace_optimization.size(); i_o++){
	if (ygeneric->phasespace_optimization[i_o] == "combined"){continue;}
 	string temp_directory = xcontribution[i_c]->infix_path_contribution;// + ygeneric->phasespace_optimization[i_o];
	outfile_readin_extrapolated << left << setw(25) << temp_directory;
	outfile_readin_extrapolated << left << setw(15) << ygeneric->name_phasespace_optimization[i_o];
	outfile_readin_extrapolated << left << setw(20) << xcontribution[i_c]->xsubprocess[i_p]->name;
	double temp_extrapolated_runtime = xcontribution[i_c]->xsubprocess[i_p]->extrapolated_runtime;
	if (i_o > 0 && i_o < xcontribution[i_c]->extended_directory.size()){
	  if (xcontribution[i_c]->xsubprocess[i_p]->used_runtime_group[i_o] != 0.){
	    temp_extrapolated_runtime = xcontribution[i_c]->xsubprocess[i_p]->extrapolated_runtime * xcontribution[i_c]->xsubprocess[i_p]->time_per_event_group[i_o] / xcontribution[i_c]->xsubprocess[i_p]->time_per_event_group[0];
	  }
	}
	outfile_readin_extrapolated << right << setw(12) << (long long)(temp_extrapolated_runtime) << "   ";
	outfile_readin_extrapolated << right << setw(12) << (long long)(xcontribution[i_c]->xsubprocess[i_p]->extrapolated_n_event) << "   ";
	outfile_readin_extrapolated << right << setw(15) << setprecision(8) << xcontribution[i_c]->xsubprocess[i_p]->extrapolated_sigma_normalization_deviation;
	outfile_readin_extrapolated << right << setw(15) << setprecision(8) << xcontribution[i_c]->xsubprocess[i_p]->extrapolated_sigma_normalization;
	outfile_readin_extrapolated << right << setw(15) << setprecision(8) << xcontribution[i_c]->xsubprocess[i_p]->extrapolated_sigma_deviation;
	outfile_readin_extrapolated << endline;
      }
    }
  }

  logger.finished();
}


void summary_list::output_extrapolated_runtime(ofstream & outfile_extrapolated){
  static Logger logger("summary_list::output_extrapolated_runtime");
  logger.called();

  static string temp_s_separation_one;
  static bool initialization = true;
  if (initialization){
    stringstream temp_ss_separation_one;
    for (int i_s = 0; i_s < 129; i_s++){ temp_ss_separation_one << "-";}
    temp_s_separation_one = temp_ss_separation_one.str();
    initialization = false;
  }

  ///////////////////////////////////////////////////////////
  //  extrapolated runtime - info.extrapolated.runtime.txt //
  ///////////////////////////////////////////////////////////

  for (int i_c = 1; i_c < xcontribution.size(); i_c++){
    for (int i_p = 0; i_p < xcontribution[i_c]->xsubprocess.size(); i_p++){
      outfile_extrapolated << left << setw(25) << xcontribution[i_c]->infix_path_contribution;
      outfile_extrapolated << left << setw(20) << xcontribution[i_c]->xsubprocess[i_p]->name;
      if (Log::getLogThreshold() <= LOG_DEBUG){ logger << LOG_DEBUG << "time_hms_from_double(xcontribution[" << i_c << "] = " << xcontribution[i_c]->infix_contribution << "->xsubprocess[" << i_p << "] = " << xcontribution[i_c]->xsubprocess[i_p]->name << "->extrapolated_runtime) = " << time_hms_from_double(xcontribution[i_c]->xsubprocess[i_p]->extrapolated_runtime) << endline_flush; }
      outfile_extrapolated << time_hms_from_double(xcontribution[i_c]->xsubprocess[i_p]->extrapolated_runtime) << "   ";
      if (i_p == 0){
	outfile_extrapolated << endline;
	outfile_extrapolated << temp_s_separation_one << endline;
      }
      else {
	outfile_extrapolated << right << setw(12) << (long long)(xcontribution[i_c]->xsubprocess[i_p]->extrapolated_n_event) << "   ";
	outfile_extrapolated << right << setw(15) << setprecision(8) << xcontribution[i_c]->xsubprocess[i_p]->extrapolated_sigma_normalization_deviation;
	outfile_extrapolated << right << setw(15) << setprecision(8) << xcontribution[i_c]->xsubprocess[i_p]->extrapolated_sigma_normalization;
	outfile_extrapolated << right << setw(15) << setprecision(8) << xcontribution[i_c]->xsubprocess[i_p]->extrapolated_sigma_deviation;
	outfile_extrapolated << endline;
      }
    }
    outfile_extrapolated << endline;
  }

  logger.finished();
}


void summary_list::output_combined_extrapolated_runtime(ofstream & outfile_extrapolated){
  static Logger logger("summary_list::output_extrapolated_runtime");
  logger.called();

  // needs to be updated !!! identical to non-combined version !!!

  static string temp_s_separation_one;
  static bool initialization = true;
  if (initialization){
    stringstream temp_ss_separation_one;
    for (int i_s = 0; i_s < 129; i_s++){ temp_ss_separation_one << "-";}
    temp_s_separation_one = temp_ss_separation_one.str();
    initialization = false;
  }

  ///////////////////////////////////////////////////////////
  //  extrapolated runtime - info.extrapolated.runtime.txt //
  ///////////////////////////////////////////////////////////

  for (int i_c = 1; i_c < xcontribution.size(); i_c++){
    for (int i_p = 0; i_p < xcontribution[i_c]->xsubprocess.size(); i_p++){
      outfile_extrapolated << left << setw(25) << xcontribution[i_c]->infix_path_contribution;
      if (i_p == 0){
	outfile_extrapolated << left << setw(5) << name_channel_selection;
	outfile_extrapolated << left << setw(15) << xcontribution[i_c]->name_extra_selection_contribution;
      }
      else {
	outfile_extrapolated << left << setw(20) << xcontribution[i_c]->xsubprocess[i_p]->name;
      }
      if (Log::getLogThreshold() <= LOG_DEBUG){ logger << LOG_DEBUG << "time_hms_from_double(xcontribution[" << i_c << "] = " << xcontribution[i_c]->infix_contribution << "->xsubprocess[" << i_p << "] = " << xcontribution[i_c]->xsubprocess[i_p]->name << "->extrapolated_runtime) = " << time_hms_from_double(xcontribution[i_c]->xsubprocess[i_p]->extrapolated_runtime) << endline_flush; }
      outfile_extrapolated << time_hms_from_double(xcontribution[i_c]->xsubprocess[i_p]->extrapolated_runtime) << "   ";
      if (i_p == 0){
	outfile_extrapolated << endline;
	outfile_extrapolated << temp_s_separation_one << endline;
      }
      else {
	outfile_extrapolated << right << setw(12) << (long long)(xcontribution[i_c]->xsubprocess[i_p]->extrapolated_n_event) << "   ";
	outfile_extrapolated << right << setw(15) << setprecision(8) << xcontribution[i_c]->xsubprocess[i_p]->extrapolated_sigma_normalization_deviation;
	outfile_extrapolated << right << setw(15) << setprecision(8) << xcontribution[i_c]->xsubprocess[i_p]->extrapolated_sigma_normalization;
	outfile_extrapolated << right << setw(15) << setprecision(8) << xcontribution[i_c]->xsubprocess[i_p]->extrapolated_sigma_deviation;
	outfile_extrapolated << endline;
      }
    }
    outfile_extrapolated << endline;
  }

  logger.finished();
}


void summary_list::output_used_runtime(ofstream & outfile_used){
  static Logger logger("summary_list::output_used_runtime");
  logger.called();

  static string temp_s_separation_one;
  static bool initialization = true;
  if (initialization){
    stringstream temp_ss_separation_one;
    for (int i_s = 0; i_s < 129; i_s++){ temp_ss_separation_one << "-";}
    temp_s_separation_one = temp_ss_separation_one.str();
    initialization = false;
  }

  ///////////////////////////////////////////
  //  used runtime - info.used.runtime.txt //
  ///////////////////////////////////////////

  for (int i_c = 1; i_c < xcontribution.size(); i_c++){
    for (int i_p = 0; i_p < xcontribution[i_c]->xsubprocess.size(); i_p++){
      outfile_used << left << setw(25) << xcontribution[i_c]->infix_path_contribution;
      if (i_p == 0){
	outfile_used << left << setw(5) << name_channel_selection;
	outfile_used << left << setw(15) << xcontribution[i_c]->name_extra_selection_contribution;
      }
      else {
	outfile_used << left << setw(20) << xcontribution[i_c]->xsubprocess[i_p]->name;
      }
      outfile_used << time_hms_from_double(xcontribution[i_c]->xsubprocess[i_p]->used_runtime) << "   ";
      if (i_p == 0){
	outfile_used << endline;
	outfile_used << temp_s_separation_one << endline;
      }
      else {
	outfile_used << right << setw(12) << (long long)(xcontribution[i_c]->xsubprocess[i_p]->used_n_event) << "   ";
	outfile_used << right << setw(15) << setprecision(8) << "";//xcontribution[i_c]->xsubprocess[i_p]->used_sigma_normalization_deviation;
	outfile_used << right << setw(15) << setprecision(8) << xcontribution[i_c]->xsubprocess[i_p]->extrapolated_sigma_normalization;
	outfile_used << right << setw(15) << setprecision(8) << "";//xcontribution[i_c]->xsubprocess[i_p]->used_sigma_deviation;
	outfile_used << right << setw(15) << setprecision(8) << xcontribution[i_c]->xsubprocess[i_p]->error2_time;
	outfile_used << endline;
      }
    }
    outfile_used << endline;
  }

  logger.finished();
}


void summary_list::output_combined_used_runtime(ofstream & outfile_used){
  static Logger logger("summary_list::output_used_runtime");
  logger.called();

  static string temp_s_separation_one;
  static string temp_s_separation_two;
  static bool initialization = true;
  if (initialization){
    stringstream temp_ss_separation_one;
    stringstream temp_ss_separation_two;
    for (int i_s = 0; i_s < 129; i_s++){
      temp_ss_separation_one << "-";
      temp_ss_separation_two << "=";
    }
    temp_s_separation_one = temp_ss_separation_one.str();
    temp_s_separation_two = temp_ss_separation_two.str();
    initialization = false;
  }

  ///////////////////////////////////////////
  //  used runtime - info.used.runtime.txt //
  ///////////////////////////////////////////

  for (int i_c = 1; i_c < xcontribution.size(); i_c++){
    bool switch_mapping = false;
    if (xcontribution[i_c]->extended_directory.size() > 1){switch_mapping = true;}
    for (int i_p = 0; i_p < xcontribution[i_c]->xsubprocess.size(); i_p++){
      outfile_used << left << setw(25) << xcontribution[i_c]->infix_path_contribution;
       if (i_p == 0){
	outfile_used << left << setw(5) << name_channel_selection;
	outfile_used << left << setw(15) << xcontribution[i_c]->name_extra_selection_contribution;
      }
      else {
	outfile_used << left << setw(20) << xcontribution[i_c]->xsubprocess[i_p]->name;
      }
      if (switch_mapping){outfile_used << left << setw(10) << "combined";}

      double temp_used_runtime = 0.;
      for (int i_o = 0; i_o < xcontribution[i_c]->extended_directory.size(); i_o++){temp_used_runtime += xcontribution[i_c]->xsubprocess[i_p]->used_runtime_group[i_o];}
      outfile_used << time_hms_from_double(temp_used_runtime) << "   ";
      //      outfile_used << time_hms_from_double(xcontribution[i_c]->xsubprocess[i_p]->used_runtime) << "   ";
      if (i_p == 0 || switch_mapping){
	outfile_used << endline;
	outfile_used << temp_s_separation_one << endline;
      }
      else {
	outfile_used << right << setw(12) << (long long)(xcontribution[i_c]->xsubprocess[i_p]->used_n_event) << "   ";
	outfile_used << right << setw(15) << setprecision(8) << "";//xcontribution[i_c]->xsubprocess[i_p]->used_sigma_normalization_deviation;
	outfile_used << right << setw(15) << setprecision(8) << xcontribution[i_c]->xsubprocess[i_p]->extrapolated_sigma_normalization;
	outfile_used << right << setw(15) << setprecision(8) << "";//xcontribution[i_c]->xsubprocess[i_p]->used_sigma_deviation;
	outfile_used << right << setw(15) << setprecision(8) << xcontribution[i_c]->xsubprocess[i_p]->error2_time;
	outfile_used << endline;
      }
      if (switch_mapping){
	for (int i_o = 0; i_o < xcontribution[i_c]->extended_directory.size(); i_o++){
	  outfile_used << left << setw(25) << xcontribution[i_c]->infix_path_contribution;
	  outfile_used << left << setw(20) << xcontribution[i_c]->xsubprocess[i_p]->name;
	  outfile_used << left << setw(10) << xcontribution[i_c]->extended_directory_name[i_o];
	  outfile_used << time_hms_from_double(xcontribution[i_c]->xsubprocess[i_p]->used_runtime_group[i_o]) << "   ";
	  if (i_p == 0){
	    outfile_used << endline;
	    if (i_o == xcontribution[i_c]->extended_directory.size() - 1){ outfile_used << temp_s_separation_two << endline; }
	  }
	  else {
	    outfile_used << right << setw(12) << (long long)(xcontribution[i_c]->xsubprocess[i_p]->used_n_event_group[i_o]) << "   ";
	    outfile_used << right << setw(15) << setprecision(8) << "";//xcontribution[i_c]->xsubprocess[i_p]->used_sigma_normalization_deviation;
	    outfile_used << right << setw(15) << setprecision(8) << xcontribution[i_c]->xsubprocess[i_p]->extrapolated_sigma_normalization;
	    /////	  outfile_used << right << setw(15) << setprecision(8) << xcontribution[i_c]->xsubprocess[i_p]->extrapolated_sigma_normalization_group[i_o];
	    outfile_used << right << setw(15) << setprecision(8) << "";//xcontribution[i_c]->xsubprocess[i_p]->used_sigma_deviation;
	    outfile_used << right << setw(15) << setprecision(8) << xcontribution[i_c]->xsubprocess[i_p]->error2_time_group[i_o];
	    outfile_used << endline;
	  }
	  if (i_o == xcontribution[i_c]->extended_directory.size() - 1){outfile_used << endline;}
	}
      }
    }
    if (switch_mapping){ outfile_used << temp_s_separation_two << endline; }
    outfile_used << endline;
  }

  logger.finished();
}
