#include "header.hpp"

void summary_order::output_distribution_TSV(){
  static Logger logger("summary_order::output_distribution_TSV");
  logger.called();

  int plot_mode = 0;
  string name_result = resultdirectory;
  string subdirectory = "";

  vector<string> identifier_sdd(2);
  identifier_sdd[0] = "norm";
  identifier_sdd[1] = "plot";

  if (Log::getLogThreshold() <= LOG_DEBUG){ logger << LOG_DEBUG << "subdirectory = " << subdirectory << "   resultdirectory = " << resultdirectory << "   selection_n_qTcut = " << selection_n_qTcut << endline_flush; }
  for (int i_i = 0; i_i < identifier_sdd.size(); i_i++){
    if (Log::getLogThreshold() <= LOG_DEBUG){ logger << LOG_DEBUG << "ygeneric->output_distribution_initialization_file_reduction_TSV(name_result = " << name_result << "   subdirectory = " << subdirectory << "   identifier_sdd[" << i_i << "] = " << identifier_sdd[i_i] << "   selection_n_qTcut = " << selection_n_qTcut << ");" << endline_flush; }
    if (ygeneric->switch_output_plot_reduction == 1){ ygeneric->output_distribution_initialization_file_reduction_TSV(name_result, subdirectory, identifier_sdd[i_i], selection_n_qTcut); }

    if (active_qTcut && selection_n_qTcut > 1){
      // inverted output for bin-wise rcut dependence
      for (int i_g = 0; i_g < ygeneric->subgroup.size(); i_g++){
	//    for (int i_d = 0; i_d < ygeneric->osi->dat.size(); i_d++){
	for (int i_d = 0; i_d < ygeneric->osi->extended_distribution.size(); i_d++){
	  if (!ygeneric->switch_output_distribution[i_d]){continue;}
	  vector<vector<vector<vector<vector<double> > > > > rcut_distribution_result_qTcut_TSV(selection_n_qTcut);
	  vector<vector<vector<vector<vector<double> > > > > rcut_distribution_deviation_qTcut_TSV(selection_n_qTcut);
	  for (int x_q = 0; x_q < selection_n_qTcut; x_q++){
	    rcut_distribution_result_qTcut_TSV[x_q] = distribution_result_qTcut_TSV[x_q][i_g][i_d];
	    rcut_distribution_deviation_qTcut_TSV[x_q] = distribution_deviation_qTcut_TSV[x_q][i_g][i_d];
	  }
	  if (i_d < ygeneric->osi->dat.size()){
	    ygeneric->output_rcut_sddistribution_TSV(identifier_sdd[i_i], rcut_distribution_result_qTcut_TSV, rcut_distribution_deviation_qTcut_TSV, i_d, name_result, subdirectory, plot_mode, distribution_result_TSV[i_g][i_d], distribution_deviation_TSV[i_g][i_d]);
	  }
	  else {
	    ygeneric->output_rcut_dddistribution_TSV(identifier_sdd[i_i], rcut_distribution_result_qTcut_TSV, rcut_distribution_deviation_qTcut_TSV, i_d, name_result, subdirectory, plot_mode);
	  }
	}
      }
    }
    // single-differential distributions
    for (int i_g = 0; i_g < ygeneric->subgroup.size(); i_g++){
      for (int i_d = 0; i_d < ygeneric->osi->dat.size(); i_d++){
	if (!ygeneric->switch_output_distribution[i_d]){continue;}
	ygeneric->output_distribution_TSV(identifier_sdd[i_i], distribution_result_TSV[i_g][i_d], distribution_deviation_TSV[i_g][i_d], i_d, name_result, subdirectory, plot_mode);
	ygeneric->output_sddistribution_TSV(identifier_sdd[i_i], distribution_result_TSV[i_g][i_d], distribution_deviation_TSV[i_g][i_d], i_d, name_result, subdirectory, plot_mode);
      }
    }
    // double-differential distributions
    for (int i_g = 0; i_g < ygeneric->subgroup.size(); i_g++){
      for (int i_d = ygeneric->osi->dat.size(); i_d < ygeneric->osi->extended_distribution.size(); i_d++){
	if (!ygeneric->switch_output_distribution[i_d]){continue;}
	ygeneric->output_dddistribution_TSV(identifier_sdd[i_i], distribution_result_TSV[i_g][i_d], distribution_deviation_TSV[i_g][i_d], i_d, name_result, subdirectory, plot_mode);
	ygeneric->output_dddistribution_reconstruct_first_sdd_TSV(identifier_sdd[i_i], distribution_result_TSV[i_g][i_d], distribution_deviation_TSV[i_g][i_d], i_d, name_result, subdirectory, plot_mode);
	ygeneric->output_dddistribution_reconstruct_second_sdd_TSV(identifier_sdd[i_i], distribution_result_TSV[i_g][i_d], distribution_deviation_TSV[i_g][i_d], i_d, name_result, subdirectory, plot_mode);
	ygeneric->output_dddistribution_slice_in_first_sdd_TSV(identifier_sdd[i_i], distribution_result_TSV[i_g][i_d], distribution_deviation_TSV[i_g][i_d], i_d, name_result, subdirectory, plot_mode);
	ygeneric->output_dddistribution_slice_in_second_sdd_TSV(identifier_sdd[i_i], distribution_result_TSV[i_g][i_d], distribution_deviation_TSV[i_g][i_d], i_d, name_result, subdirectory, plot_mode);
	ygeneric->output_dddistribution_ge_in_first_sdd_TSV(identifier_sdd[i_i], distribution_result_TSV[i_g][i_d], distribution_deviation_TSV[i_g][i_d], i_d, name_result, subdirectory, plot_mode);
	ygeneric->output_dddistribution_ge_in_second_sdd_TSV(identifier_sdd[i_i], distribution_result_TSV[i_g][i_d], distribution_deviation_TSV[i_g][i_d], i_d, name_result, subdirectory, plot_mode);
	ygeneric->output_dddistribution_lt_in_first_sdd_TSV(identifier_sdd[i_i], distribution_result_TSV[i_g][i_d], distribution_deviation_TSV[i_g][i_d], i_d, name_result, subdirectory, plot_mode);
	ygeneric->output_dddistribution_lt_in_second_sdd_TSV(identifier_sdd[i_i], distribution_result_TSV[i_g][i_d], distribution_deviation_TSV[i_g][i_d], i_d, name_result, subdirectory, plot_mode);
      }
    }
  }

  logger.finished();
}


void summary_order::output_distribution_qTcut_TSV(){
  static Logger logger("summary_order::output_distribution_qTcut_TSV");
  logger.called();

  if (!active_qTcut || selection_n_qTcut == 1){return;}

  int plot_mode = 0;
  string name_result = resultdirectory;

  vector<string> identifier_sdd(2);
  identifier_sdd[0] = "norm";
  identifier_sdd[1] = "plot";

  string subdirectory = "";
  vector<string> subdirectory_qTcut(selection_n_qTcut, "");
  for (int x_q = 0; x_q < selection_n_qTcut; x_q++){
    stringstream qTcut_ss;
    qTcut_ss << "qTcut-" << ygeneric->osi->value_qTcut_distribution[x_q];
    subdirectory_qTcut[x_q] = "/" + qTcut_ss.str();
  }

  for (int x_q = 0; x_q < selection_n_qTcut; x_q++){
    for (int i_s = 0; i_s < osi->n_extended_set_TSV; i_s++){
      if (!ygeneric->switch_output_scaleset[i_s]){continue;}
      if (!ygeneric->osi->switch_distribution_TSV[i_s]){continue;}
      for (int i_r = 0; i_r < ygeneric->osi->n_scale_ren_TSV[i_s]; i_r++){
	for (int i_f = 0; i_f < ygeneric->osi->n_scale_fact_TSV[i_s]; i_f++){
	  string directory_distribution_plot = ygeneric->scalepath_TSV[i_s][i_r][i_f] + "/" + subdirectory_qTcut[x_q];
	  if (Log::getLogThreshold() <= LOG_DEBUG){ logger << LOG_DEBUG << "mkdir " << directory_distribution_plot << endline_flush; }
	  system_execute(logger, "mkdir " + directory_distribution_plot);
	}
      }
    }
  }

  for (int i_i = 0; i_i < identifier_sdd.size(); i_i++){
    if (ygeneric->switch_output_plot_reduction == 1){
      for (int x_q = 0; x_q < selection_n_qTcut; x_q++){
	ygeneric->output_distribution_initialization_file_reduction_qTcut_TSV(name_result, subdirectory_qTcut[x_q], identifier_sdd[i_i], selection_n_qTcut);
      }
    }
  
    for (int x_q = 0; x_q < selection_n_qTcut; x_q++){
      // single-differential distributions
      for (int i_g = 0; i_g < ygeneric->subgroup.size(); i_g++){
	for (int i_d = 0; i_d < ygeneric->osi->dat.size(); i_d++){
	  if (!ygeneric->switch_output_distribution[i_d]){continue;}
	  ygeneric->output_distribution_TSV(identifier_sdd[i_i], distribution_result_qTcut_TSV[x_q][i_g][i_d], distribution_deviation_qTcut_TSV[x_q][i_g][i_d], i_d, name_result, subdirectory_qTcut[x_q], plot_mode);
	  ygeneric->output_sddistribution_TSV(identifier_sdd[i_i], distribution_result_qTcut_TSV[x_q][i_g][i_d], distribution_deviation_qTcut_TSV[x_q][i_g][i_d], i_d, name_result, subdirectory_qTcut[x_q], plot_mode);
	}
      }
      // double-differential distributions
      for (int i_g = 0; i_g < ygeneric->subgroup.size(); i_g++){
	for (int i_d = ygeneric->osi->dat.size(); i_d < ygeneric->osi->extended_distribution.size(); i_d++){
	  if (!ygeneric->switch_output_distribution[i_d]){continue;}
	  ygeneric->output_dddistribution_TSV(identifier_sdd[i_i], distribution_result_qTcut_TSV[x_q][i_g][i_d], distribution_deviation_qTcut_TSV[x_q][i_g][i_d], i_d, name_result, subdirectory_qTcut[x_q], plot_mode);
	  ygeneric->output_dddistribution_reconstruct_first_sdd_TSV(identifier_sdd[i_i], distribution_result_qTcut_TSV[x_q][i_g][i_d], distribution_deviation_qTcut_TSV[x_q][i_g][i_d], i_d, name_result, subdirectory_qTcut[x_q], plot_mode);
	  ygeneric->output_dddistribution_reconstruct_second_sdd_TSV(identifier_sdd[i_i], distribution_result_qTcut_TSV[x_q][i_g][i_d], distribution_deviation_qTcut_TSV[x_q][i_g][i_d], i_d, name_result, subdirectory_qTcut[x_q], plot_mode);
	  ygeneric->output_dddistribution_slice_in_first_sdd_TSV(identifier_sdd[i_i], distribution_result_qTcut_TSV[x_q][i_g][i_d], distribution_deviation_qTcut_TSV[x_q][i_g][i_d], i_d, name_result, subdirectory_qTcut[x_q], plot_mode);
	  ygeneric->output_dddistribution_slice_in_second_sdd_TSV(identifier_sdd[i_i], distribution_result_qTcut_TSV[x_q][i_g][i_d], distribution_deviation_qTcut_TSV[x_q][i_g][i_d], i_d, name_result, subdirectory_qTcut[x_q], plot_mode);
	  ygeneric->output_dddistribution_ge_in_first_sdd_TSV(identifier_sdd[i_i], distribution_result_qTcut_TSV[x_q][i_g][i_d], distribution_deviation_qTcut_TSV[x_q][i_g][i_d], i_d, name_result, subdirectory_qTcut[x_q], plot_mode);
	  ygeneric->output_dddistribution_ge_in_second_sdd_TSV(identifier_sdd[i_i], distribution_result_qTcut_TSV[x_q][i_g][i_d], distribution_deviation_qTcut_TSV[x_q][i_g][i_d], i_d, name_result, subdirectory_qTcut[x_q], plot_mode);
	  ygeneric->output_dddistribution_lt_in_first_sdd_TSV(identifier_sdd[i_i], distribution_result_qTcut_TSV[x_q][i_g][i_d], distribution_deviation_qTcut_TSV[x_q][i_g][i_d], i_d, name_result, subdirectory_qTcut[x_q], plot_mode);
	  ygeneric->output_dddistribution_lt_in_second_sdd_TSV(identifier_sdd[i_i], distribution_result_qTcut_TSV[x_q][i_g][i_d], distribution_deviation_qTcut_TSV[x_q][i_g][i_d], i_d, name_result, subdirectory_qTcut[x_q], plot_mode);
	}
      }
    }
  }

  logger.finished();
}


void summary_order::output_distribution_overview_TSV(){
  static Logger logger("summary_order::output_distribution_overview_TSV");
  logger.called();

  ofstream out_overviewfile;
  string filename_distribution_overview;
  string filepath_distribution_overview;

  stringstream header_ss;
  header_ss << left << setw(16) << "qTcut";
  header_ss << left << setw(25) << "order/list";
  header_ss << setw(15) << "";
  header_ss << right << setw(16) << "dsigma";
  header_ss << setw(4) << " +- ";
  header_ss << right << setw(16) << "error";

  stringstream temp_ss_separation_one;
  stringstream temp_ss_separation_two;
  int counter_separation = 20 + 5 + 16 + 25 + 15 + 16 + 4 + 16;
  for (int i_x = 0; i_x < counter_separation; i_x++){
    temp_ss_separation_one << "-";
    temp_ss_separation_two << "=";
  }

  for (int i_s = 0; i_s < osi->n_extended_set_TSV; i_s++){
    if (!ygeneric->switch_output_scaleset[i_s]){continue;}
    if (!osi->switch_distribution_TSV[i_s]){continue;}
    if (i_s != osi->no_reference_TSV){ continue; }
    /*
    if (ygeneric->switch_output_overview_reduction == 2){
      filename_distribution_overview = "overview." + resultdirectory + ".dat";
      filepath_distribution_overview = ygeneric->final_resultdirectory + "/" + osi->name_extended_set_TSV[i_s] + "/" + filename_distribution_overview;
      out_overviewfile.open(filepath_distribution_overview.c_str(), ofstream::out | ofstream::trunc);
    }
    */
    for (int i_r = 0; i_r < osi->n_scale_ren_TSV[i_s]; i_r++){
      for (int i_f = 0; i_f < osi->n_scale_fact_TSV[i_s]; i_f++){
	if (i_r != osi->no_scale_ren_reference_TSV || i_f != osi->no_scale_fact_reference_TSV){ continue; }
	
	if (ygeneric->switch_output_overview_reduction == 1){
	  filename_distribution_overview = "overview.." + resultdirectory + ".dat";
	  filepath_distribution_overview = ygeneric->scalepath_TSV[i_s][i_r][i_f] + "/" + filename_distribution_overview;
	  out_overviewfile.open(filepath_distribution_overview.c_str(), ofstream::out | ofstream::trunc);
	}

	for (int i_g = 0; i_g < ygeneric->subgroup.size(); i_g++){
	  for (int i_d = 0; i_d < osi->dat.size(); i_d++){
	    if (!ygeneric->switch_output_distribution[i_d]){continue;}
	    
	    if (ygeneric->switch_output_overview_reduction){
	      out_overviewfile << "## " << ygeneric->scalename_TSV[i_s][i_r][i_f] << "/" << "overview." << osi->extended_distribution[i_d].xdistribution_name << ".." << resultdirectory << ".dat" << endline;
	      out_overviewfile << endline;
	    }
	    else {
	      filename_distribution_overview = "overview." + osi->extended_distribution[i_d].xdistribution_name + ".." + resultdirectory + ".dat";
	      filepath_distribution_overview = ygeneric->scalepath_TSV[i_s][i_r][i_f] + "/" + filename_distribution_overview;
	      logger << LOG_DEBUG << "filename_distribution_overview = " << filename_distribution_overview << endline_flush;
	      logger << LOG_DEBUG << "filepath_distribution_overview = " << filepath_distribution_overview << endline_flush;
	      out_overviewfile.open(filepath_distribution_overview.c_str(), ofstream::out | ofstream::trunc);
	    }
	    stringstream bin_label;
	    bin_label << "bin (" << osi->extended_distribution[i_d].xdistribution_name << ")";
	    out_overviewfile << setw(22) << bin_label.str() << setw(3) << "" << header_ss.str() << endline;
	    out_overviewfile << endline;

	    for (int i_b = 0; i_b < osi->extended_distribution[i_d].n_bins; i_b++){
	      if (distribution_result_TSV[i_g][i_d][i_b][i_s][i_r][i_f] == 0. && distribution_deviation_TSV[i_g][i_d][i_b][i_s][i_r][i_f] == 0.){continue;}
	      if (munich_isnan(distribution_result_TSV[i_g][i_d][i_b][i_s][i_r][i_f]) || munich_isnan(distribution_deviation_TSV[i_g][i_d][i_b][i_s][i_r][i_f])){continue;}

	      int temp_size_result = int(log10(abs(osi->unit_factor_distribution * distribution_result_TSV[i_g][i_d][i_b][i_s][i_r][i_f])));
	      int temp_size_result_order = temp_size_result;
	      for (int i_l = 0; i_l < xlist.size(); i_l++){
		int temp_size_result_c = int(log10(abs(osi->unit_factor_distribution * xlist[i_l]->distribution_result_TSV[i_g][i_d][i_b][i_s][i_r][i_f])));
		if (temp_size_result_c > temp_size_result){temp_size_result = temp_size_result_c;}
	      }
	      int temp_size_deviation = int(log10(abs(osi->unit_factor_distribution * distribution_deviation_TSV[i_g][i_d][i_b][i_s][i_r][i_f])));
	      if (osi->unit_factor_distribution * distribution_deviation_TSV[i_g][i_d][i_b][i_s][i_r][i_f] >= 1.){temp_size_deviation++;}
	      int setw_result = 9 + temp_size_result_order - temp_size_result;
	      int setw_deviation = 9 + temp_size_deviation - temp_size_result - 1;
	      if (distribution_result_TSV[i_g][i_d][i_b][i_s][i_r][i_f] == 0.){setw_result = 1; setw_deviation = 1;}
	      else if (abs(osi->unit_factor_distribution * distribution_result_TSV[i_g][i_d][i_b][i_s][i_r][i_f]) < 1.){setw_result--;}

	      out_overviewfile << right << setw(10) << setprecision(8) << noshowpoint << osi->extended_distribution[i_d].bin_edge[i_b];
	      out_overviewfile << setw(2) << "";
	      out_overviewfile << right << setw(10) << setprecision(8) << noshowpoint << osi->extended_distribution[i_d].bin_edge[i_b + 1];
	      out_overviewfile << setw(3) << "";
	      if (active_qTcut){ out_overviewfile << left << setw(16) << "extrapolation"; }
	      else { out_overviewfile << left << setw(16) << "independent"; }
	      out_overviewfile << left << setw(25) << resultdirectory;
	      out_overviewfile << left << setw(15) << "";
	      out_overviewfile << showpoint << right << setw(16) << setprecision(setw_result) << osi->unit_factor_distribution * distribution_result_TSV[i_g][i_d][i_b][i_s][i_r][i_f];
	      out_overviewfile << " +- ";
	      out_overviewfile << showpoint << right << setw(16) << setprecision(setw_deviation) << osi->unit_factor_distribution * distribution_deviation_TSV[i_g][i_d][i_b][i_s][i_r][i_f];
	      out_overviewfile << endline;
	      out_overviewfile << temp_ss_separation_one.str() << endline;

	      for (int i_l = 0; i_l < xlist.size(); i_l++){
		int temp_size_result_subprocess = int(log10(abs(osi->unit_factor_distribution * xlist[i_l]->distribution_result_TSV[i_g][i_d][i_b][i_s][i_r][i_f])));
		int temp_size_deviation_subprocess = int(log10(abs(osi->unit_factor_distribution * xlist[i_l]->distribution_deviation_TSV[i_g][i_d][i_b][i_s][i_r][i_f])));
		if (osi->unit_factor_distribution * xlist[i_l]->distribution_deviation_TSV[i_g][i_d][i_b][i_s][i_r][i_f] >= 1.){temp_size_deviation_subprocess++;}
		if (xlist[i_l]->distribution_result_TSV[i_g][i_d][i_b][i_s][i_r][i_f] == 0){temp_size_result_subprocess = 0;}
		if (xlist[i_l]->distribution_deviation_TSV[i_g][i_d][i_b][i_s][i_r][i_f] == 0){temp_size_deviation_subprocess = 0;}
		int setw_result = 9 + temp_size_result_subprocess - temp_size_result;
		int setw_deviation = 9 + temp_size_deviation_subprocess - temp_size_deviation - (temp_size_result - temp_size_deviation + 1);
		if (xlist[i_l]->distribution_result_TSV[i_g][i_d][i_b][i_s][i_r][i_f] == 0.){setw_result = 1; setw_deviation = 1;}
		else if (abs(osi->unit_factor_distribution * xlist[i_l]->distribution_result_TSV[i_g][i_d][i_b][i_s][i_r][i_f]) < 1.){setw_result--;}
		out_overviewfile << right << setw(10) << setprecision(8) << noshowpoint << osi->extended_distribution[i_d].bin_edge[i_b];
		out_overviewfile << setw(2) << "";
		out_overviewfile << right << setw(10) << setprecision(8) << noshowpoint << osi->extended_distribution[i_d].bin_edge[i_b + 1];
		out_overviewfile << setw(3) << "";
		if (xlist[i_l]->active_qTcut){out_overviewfile << left << setw(16) << "extrapolation";}
		else {out_overviewfile << left << setw(16) << "independent";}
		out_overviewfile << left << setw(25) << xlist[i_l]->xcontribution[0]->infix_order_contribution;
		if (xlist[i_l]->channel_selection != "" && xlist[i_l]->channel_selection != "---"){out_overviewfile << left << setw(5) << xlist[i_l]->channel_selection;}
		else {out_overviewfile << left << setw(5) << "";}
		if (xlist[i_l]->extra_selection != "" && xlist[i_l]->extra_selection != "---"){out_overviewfile << left << setw(10) << xlist[i_l]->extra_selection;}
		else {out_overviewfile << left << setw(10) << "";}
		out_overviewfile << showpoint << right << setw(16) << setprecision(setw_result) << osi->unit_factor_distribution * xlist[i_l]->distribution_result_TSV[i_g][i_d][i_b][i_s][i_r][i_f];
		out_overviewfile << " +- ";
		out_overviewfile << showpoint << right << setw(16) << setprecision(setw_deviation) << osi->unit_factor_distribution * xlist[i_l]->distribution_deviation_TSV[i_g][i_d][i_b][i_s][i_r][i_f];
		out_overviewfile << endline;
	      }
	      out_overviewfile << endline;

	      if (active_qTcut){
		int counter_empty_bin = 0;
		for (int x_q = 0; x_q < selection_n_qTcut; x_q++){
		  // check if bin is empty (to reduce output)
		  if (distribution_result_qTcut_TSV[x_q][i_g][i_d][i_b][i_s][i_r][i_f] == 0. && distribution_deviation_qTcut_TSV[x_q][i_g][i_d][i_b][i_s][i_r][i_f] == 0.){counter_empty_bin++; continue;}

		  int temp_size_result = int(log10(abs(osi->unit_factor_distribution * distribution_result_qTcut_TSV[x_q][i_g][i_d][i_b][i_s][i_r][i_f])));
		  int temp_size_result_order = temp_size_result;
		  for (int i_l = 0; i_l < xlist.size(); i_l++){
		    int y_q = 0;
		    if (xlist[i_l]->active_qTcut){y_q = x_q;}
		    int temp_size_result_c = int(log10(abs(osi->unit_factor_distribution * xlist[i_l]->distribution_result_qTcut_TSV[y_q][i_g][i_d][i_b][i_s][i_r][i_f])));
		    if (temp_size_result_c > temp_size_result){temp_size_result = temp_size_result_c;}
		  }
		  int temp_size_deviation = int(log10(abs(osi->unit_factor_distribution * distribution_deviation_qTcut_TSV[x_q][i_g][i_d][i_b][i_s][i_r][i_f])));
		  if (osi->unit_factor_distribution * distribution_deviation_qTcut_TSV[x_q][i_g][i_d][i_b][i_s][i_r][i_f] >= 1.){temp_size_deviation++;}
		  int setw_result = 9 + temp_size_result_order - temp_size_result;
		  int setw_deviation = 9 + temp_size_deviation - temp_size_result - 1;
		  if (distribution_result_qTcut_TSV[x_q][i_g][i_d][i_b][i_s][i_r][i_f] == 0.){setw_result = 1; setw_deviation = 1;}
		  else if (abs(osi->unit_factor_distribution * distribution_result_qTcut_TSV[x_q][i_g][i_d][i_b][i_s][i_r][i_f]) < 1.){setw_result--;}

		  out_overviewfile << setw(10) << setprecision(8) << noshowpoint << osi->extended_distribution[i_d].bin_edge[i_b];
		  out_overviewfile << setw(2) << "";
		  out_overviewfile << setw(10) << setprecision(8) << noshowpoint << osi->extended_distribution[i_d].bin_edge[i_b + 1];
		  out_overviewfile << setw(3) << "";
		  if (active_qTcut){ out_overviewfile << left << noshowpoint << setw(16) << osi->value_qTcut_distribution[x_q]; }
		  else { out_overviewfile << left << setw(16) << "independent"; }
		  out_overviewfile << left << setw(25) << resultdirectory;
		  out_overviewfile << setw(15) << "";
		  out_overviewfile << showpoint << right << setw(16) << setprecision(setw_result) << osi->unit_factor_distribution * distribution_result_qTcut_TSV[x_q][i_g][i_d][i_b][i_s][i_r][i_f];
		  out_overviewfile << " +- ";
		  out_overviewfile << showpoint << right << setw(16) << setprecision(setw_deviation) << osi->unit_factor_distribution * distribution_deviation_qTcut_TSV[x_q][i_g][i_d][i_b][i_s][i_r][i_f];
		  out_overviewfile << endline;
		  out_overviewfile << temp_ss_separation_one.str() << endline;

		  for (int i_l = 0; i_l < xlist.size(); i_l++){
		    int y_q = 0;
		    if (xlist[i_l]->active_qTcut){y_q = x_q;}
		    int temp_size_result_subprocess = int(log10(abs(osi->unit_factor_distribution * xlist[i_l]->distribution_result_qTcut_TSV[y_q][i_g][i_d][i_b][i_s][i_r][i_f])));
		    int temp_size_deviation_subprocess = int(log10(abs(osi->unit_factor_distribution * xlist[i_l]->distribution_deviation_qTcut_TSV[y_q][i_g][i_d][i_b][i_s][i_r][i_f])));
		    if (osi->unit_factor_distribution * xlist[i_l]->distribution_deviation_qTcut_TSV[y_q][i_g][i_d][i_b][i_s][i_r][i_f] >= 1.){temp_size_deviation_subprocess++;}
		    if (xlist[i_l]->distribution_result_qTcut_TSV[y_q][i_g][i_d][i_b][i_s][i_r][i_f] == 0){temp_size_result_subprocess = 0;}
		    if (xlist[i_l]->distribution_deviation_qTcut_TSV[y_q][i_g][i_d][i_b][i_s][i_r][i_f] == 0){temp_size_deviation_subprocess = 0;}
		    int setw_result = 9 + temp_size_result_subprocess - temp_size_result;
		    int setw_deviation = 9 + temp_size_deviation_subprocess - temp_size_deviation - (temp_size_result - temp_size_deviation + 1);
		    if (xlist[i_l]->distribution_result_qTcut_TSV[y_q][i_g][i_d][i_b][i_s][i_r][i_f] == 0.){setw_result = 1; setw_deviation = 1;}
		    else if (abs(osi->unit_factor_distribution * xlist[i_l]->distribution_result_qTcut_TSV[y_q][i_g][i_d][i_b][i_s][i_r][i_f]) < 1.){setw_result--;}
		    out_overviewfile << setw(10) << setprecision(8) << noshowpoint << osi->extended_distribution[i_d].bin_edge[i_b];
		    out_overviewfile << setw(2) << "";
		    out_overviewfile << setw(10) << setprecision(8) << noshowpoint << osi->extended_distribution[i_d].bin_edge[i_b + 1];
		    out_overviewfile << setw(3) << "";
		    if (xlist[i_l]->active_qTcut){ out_overviewfile << left << noshowpoint << setw(16) << osi->value_qTcut_distribution[x_q]; }
		    else { out_overviewfile << left << setw(16) << "independent"; }
		    out_overviewfile << left << setw(25) << xlist[i_l]->xcontribution[0]->infix_order_contribution;
		    if (xlist[i_l]->channel_selection != "" && xlist[i_l]->channel_selection != "---"){out_overviewfile << left << setw(5) << xlist[i_l]->channel_selection;}
		    else {out_overviewfile << setw(5) << "";}
		    if (xlist[i_l]->extra_selection != "" && xlist[i_l]->extra_selection != "---"){out_overviewfile << left << setw(10) << xlist[i_l]->extra_selection;}
		    else {out_overviewfile << setw(10) << "";}
		    out_overviewfile << showpoint << right << setw(16) << setprecision(setw_result) << osi->unit_factor_distribution * xlist[i_l]->distribution_result_qTcut_TSV[y_q][i_g][i_d][i_b][i_s][i_r][i_f];
		    out_overviewfile << " +- ";
		    out_overviewfile << showpoint << right << setw(16) << setprecision(setw_deviation) << osi->unit_factor_distribution * xlist[i_l]->distribution_deviation_qTcut_TSV[y_q][i_g][i_d][i_b][i_s][i_r][i_f];
		    out_overviewfile << endline;
		  }
		  out_overviewfile << endline;
		}
		if (counter_empty_bin < selection_n_qTcut){out_overviewfile << temp_ss_separation_two.str() << endline << endline;}
	      }
	    }
	    if (!ygeneric->switch_output_overview_reduction){ out_overviewfile.close(); }
	  }
	  if (ygeneric->switch_output_overview_reduction == 1){ out_overviewfile.close(); }
	}
      }
      //      if (ygeneric->switch_output_overview_reduction == 2){ out_overviewfile.close(); }
    }
  }

  logger.finished();
}


void summary_order::output_dddistribution_overview_TSV(){
  static Logger logger("summary_order::output_dddistribution_overview_TSV");
  logger.called();

  ofstream out_overviewfile;
  string filename_distribution_overview;
  string filepath_distribution_overview;

  stringstream header_ss;
  header_ss << left;
  header_ss << left << setw(16) << "qTcut";
  header_ss << left << setw(25) << "order/list";
  header_ss << setw(15) << "";
  header_ss << right << setw(16) << "dsigma";
  header_ss << setw(4) << " +- ";
  header_ss << right << setw(16) << "error";

  stringstream temp_ss_separation_one;
  stringstream temp_ss_separation_two;
  int counter_separation = 20 + 5 + 20 + 5 + 16 + 25 + 15 + 16 + 4 + 16;
  for (int i_x = 0; i_x < counter_separation; i_x++){
    temp_ss_separation_one << "-";
    temp_ss_separation_two << "=";
  }

  for (int i_s = 0; i_s < osi->n_extended_set_TSV; i_s++){
    if (!ygeneric->switch_output_scaleset[i_s]){continue;}
    if (!osi->switch_distribution_TSV[i_s]){continue;}
    if (i_s != osi->no_reference_TSV){ continue; }
    /*
      if (ygeneric->switch_output_overview_reduction == 2){
      filename_distribution_overview = "overview.." + resultdirectory + ".dat";
      filepath_distribution_overview = ygeneric->final_resultdirectory + "/" + osi->name_extended_set_TSV[i_s] + "/" + filename_distribution_overview;
      out_overviewfile.open(filepath_distribution_overview.c_str(), ofstream::out | ofstream::trunc);
      }
    */
    for (int i_r = 0; i_r < osi->n_scale_ren_TSV[i_s]; i_r++){
      for (int i_f = 0; i_f < osi->n_scale_fact_TSV[i_s]; i_f++){
	if (i_r != osi->no_scale_ren_reference_TSV || i_f != osi->no_scale_fact_reference_TSV){ continue; }

	if (ygeneric->switch_output_overview_reduction == 1){
	  filename_distribution_overview = "overview.." + resultdirectory + ".dat";
	  filepath_distribution_overview = ygeneric->scalepath_TSV[i_s][i_r][i_f] + "/" + filename_distribution_overview;
	  out_overviewfile.open(filepath_distribution_overview.c_str(), ofstream::out | ofstream::app);
	}

	for (int i_g = 0; i_g < ygeneric->subgroup.size(); i_g++){
	  for (int i_d = osi->dat.size(); i_d < osi->extended_distribution.size(); i_d++){
	    int i_ddd = i_d - osi->dat.size();
	    if (!ygeneric->switch_output_distribution[i_d]){continue;}

	    if (ygeneric->switch_output_overview_reduction){
	      out_overviewfile << "## " << ygeneric->scalename_TSV[i_s][i_r][i_f] << "/" << "overview." << osi->extended_distribution[i_d].xdistribution_name << ".." << resultdirectory << ".dat" << endline;
	      out_overviewfile << endline;
	    }
	    else {
	      filename_distribution_overview = "overview." + osi->extended_distribution[i_d].xdistribution_name + ".." + resultdirectory + ".dat";
	      filepath_distribution_overview = ygeneric->scalepath_TSV[i_s][i_r][i_f] + "/" + filename_distribution_overview;
	      if (Log::getLogThreshold() <= LOG_DEBUG){
		logger << LOG_DEBUG << "filename_distribution_overview = " << filename_distribution_overview << endline_flush;
		logger << LOG_DEBUG << "filepath_distribution_overview = " << filepath_distribution_overview << endline_flush;
	      }
	      out_overviewfile.open(filepath_distribution_overview.c_str(), ofstream::out | ofstream::trunc);
	    }
	    stringstream bin_label_1;
	    bin_label_1 << "bin (" << osi->dddat[i_ddd].distribution_1.xdistribution_name << ")";
	    stringstream bin_label_2;
	    bin_label_2 << "bin (" << osi->dddat[i_ddd].distribution_2.xdistribution_name << ")";
	    out_overviewfile << setw(22) << bin_label_1.str() << setw(3) << "" << setw(22) << bin_label_2.str() << setw(3) << "" << header_ss.str() << endline;
	    out_overviewfile << endline;

	    for (int i_b1 = 0; i_b1 < osi->dddat[i_ddd].distribution_1.n_bins; i_b1++){
	      for (int i_b2 = 0; i_b2 < osi->dddat[i_ddd].distribution_2.n_bins; i_b2++){
		int i_b = i_b1 * osi->dddat[i_ddd].distribution_2.n_bins + i_b2;
		if (distribution_result_TSV[i_g][i_d][i_b][i_s][i_r][i_f] == 0. && distribution_deviation_TSV[i_g][i_d][i_b][i_s][i_r][i_f] == 0.){continue;}
		if (munich_isnan(distribution_result_TSV[i_g][i_d][i_b][i_s][i_r][i_f]) || munich_isnan(distribution_deviation_TSV[i_g][i_d][i_b][i_s][i_r][i_f])){continue;}

		int temp_size_result = int(log10(abs(osi->unit_factor_distribution * distribution_result_TSV[i_g][i_d][i_b][i_s][i_r][i_f])));
		int temp_size_result_order = temp_size_result;
		for (int i_l = 0; i_l < xlist.size(); i_l++){
		  int temp_size_result_c = int(log10(abs(osi->unit_factor_distribution * xlist[i_l]->distribution_result_TSV[i_g][i_d][i_b][i_s][i_r][i_f])));
		  if (temp_size_result_c > temp_size_result){temp_size_result = temp_size_result_c;}
		}
		int temp_size_deviation = int(log10(abs(osi->unit_factor_distribution * distribution_deviation_TSV[i_g][i_d][i_b][i_s][i_r][i_f])));
		if (osi->unit_factor_distribution * distribution_deviation_TSV[i_g][i_d][i_b][i_s][i_r][i_f] >= 1.){temp_size_deviation++;}
		int setw_result = 9 + temp_size_result_order - temp_size_result;
		int setw_deviation = 9 + temp_size_deviation - temp_size_result - 1;
		if (distribution_result_TSV[i_g][i_d][i_b][i_s][i_r][i_f] == 0.){setw_result = 1; setw_deviation = 1;}
		else if (abs(osi->unit_factor_distribution * distribution_result_TSV[i_g][i_d][i_b][i_s][i_r][i_f]) < 1.){setw_result--;}

		out_overviewfile << right << noshowpoint << setw(10) << setprecision(8) << osi->dddat[i_ddd].distribution_1.bin_edge[i_b1];
		out_overviewfile << setw(2) << "";
		out_overviewfile << right << noshowpoint << setw(10) << setprecision(8) << osi->dddat[i_ddd].distribution_1.bin_edge[i_b1 + 1];
		out_overviewfile << setw(3) << "";
		out_overviewfile << right << noshowpoint << setw(10) << setprecision(8) << osi->dddat[i_ddd].distribution_2.bin_edge[i_b2];
		out_overviewfile << setw(2) << "";
		out_overviewfile << right << noshowpoint << setw(10) << setprecision(8) << osi->dddat[i_ddd].distribution_2.bin_edge[i_b2 + 1];
		out_overviewfile << setw(3) << "";
		if (active_qTcut){ out_overviewfile << left << setw(16) << "extrapolation"; }
		else { out_overviewfile << left << setw(16) << "independent"; }
		out_overviewfile << left << setw(25) << resultdirectory;
		out_overviewfile << setw(15) << "";
		out_overviewfile << showpoint << right << setw(16) << setprecision(setw_result) << osi->unit_factor_distribution * distribution_result_TSV[i_g][i_d][i_b][i_s][i_r][i_f];
		out_overviewfile << " +- ";
		out_overviewfile << showpoint << right << setw(16) << setprecision(setw_deviation) << osi->unit_factor_distribution * distribution_deviation_TSV[i_g][i_d][i_b][i_s][i_r][i_f];
		out_overviewfile << endline;
		out_overviewfile << temp_ss_separation_one.str() << endline;

		for (int i_l = 0; i_l < xlist.size(); i_l++){
		  int temp_size_result_subprocess = int(log10(abs(osi->unit_factor_distribution * xlist[i_l]->distribution_result_TSV[i_g][i_d][i_b][i_s][i_r][i_f])));
		  int temp_size_deviation_subprocess = int(log10(abs(osi->unit_factor_distribution * xlist[i_l]->distribution_deviation_TSV[i_g][i_d][i_b][i_s][i_r][i_f])));
		  if (osi->unit_factor_distribution * xlist[i_l]->distribution_deviation_TSV[i_g][i_d][i_b][i_s][i_r][i_f] >= 1.){temp_size_deviation_subprocess++;}
		  if (xlist[i_l]->distribution_result_TSV[i_g][i_d][i_b][i_s][i_r][i_f] == 0){temp_size_result_subprocess = 0;}
		  if (xlist[i_l]->distribution_deviation_TSV[i_g][i_d][i_b][i_s][i_r][i_f] == 0){temp_size_deviation_subprocess = 0;}
		  int setw_result = 9 + temp_size_result_subprocess - temp_size_result;
		  int setw_deviation = 9 + temp_size_deviation_subprocess - temp_size_deviation - (temp_size_result - temp_size_deviation + 1);
		  if (xlist[i_l]->distribution_result_TSV[i_g][i_d][i_b][i_s][i_r][i_f] == 0.){setw_result = 1; setw_deviation = 1;}
		  else if (abs(osi->unit_factor_distribution * xlist[i_l]->distribution_result_TSV[i_g][i_d][i_b][i_s][i_r][i_f]) < 1.){setw_result--;}

		  out_overviewfile << right << noshowpoint << setw(10) << setprecision(8) << osi->dddat[i_ddd].distribution_1.bin_edge[i_b1];
		  out_overviewfile << setw(2) << "";
		  out_overviewfile << right << noshowpoint << setw(10) << setprecision(8) << osi->dddat[i_ddd].distribution_1.bin_edge[i_b1 + 1];
		  out_overviewfile << setw(3) << "";
		  out_overviewfile << right << noshowpoint << setw(10) << setprecision(8) << osi->dddat[i_ddd].distribution_2.bin_edge[i_b2];
		  out_overviewfile << setw(2) << "";
		  out_overviewfile << right << noshowpoint << setw(10) << setprecision(8) << osi->dddat[i_ddd].distribution_2.bin_edge[i_b2 + 1];
		  out_overviewfile << setw(3) << "";
		
		  if (xlist[i_l]->active_qTcut){ out_overviewfile << left << setw(16) << "extrapolation"; }
		  else { out_overviewfile << left << setw(16) << "independent"; }
		  out_overviewfile << setw(25) << xlist[i_l]->xcontribution[0]->infix_order_contribution;
		  if (xlist[i_l]->channel_selection != "" && xlist[i_l]->channel_selection != "---"){ out_overviewfile << left << setw(5) << xlist[i_l]->channel_selection; }
		  else { out_overviewfile << left << setw(5) << ""; }
		  if (xlist[i_l]->extra_selection != "" && xlist[i_l]->extra_selection != "---"){ out_overviewfile << left << setw(10) << xlist[i_l]->extra_selection; }
		  else { out_overviewfile << left << setw(10) << ""; }
		  out_overviewfile << showpoint << right << setw(16) << setprecision(setw_result) << osi->unit_factor_distribution * xlist[i_l]->distribution_result_TSV[i_g][i_d][i_b][i_s][i_r][i_f];
		  out_overviewfile << " +- ";
		  out_overviewfile << showpoint << right << setw(16) << setprecision(setw_deviation) << osi->unit_factor_distribution * xlist[i_l]->distribution_deviation_TSV[i_g][i_d][i_b][i_s][i_r][i_f];
		  out_overviewfile << endline;
		}
		out_overviewfile << endline;

		if (active_qTcut){
		  int counter_empty_bin = 0;
		  for (int x_q = 0; x_q < selection_n_qTcut; x_q++){
		    // check if bin is empty (to reduce output)
		    if (distribution_result_qTcut_TSV[x_q][i_g][i_d][i_b][i_s][i_r][i_f] == 0. && distribution_deviation_qTcut_TSV[x_q][i_g][i_d][i_b][i_s][i_r][i_f] == 0.){counter_empty_bin++; continue;}

		    int temp_size_result = int(log10(abs(osi->unit_factor_distribution * distribution_result_qTcut_TSV[x_q][i_g][i_d][i_b][i_s][i_r][i_f])));
		    int temp_size_result_order = temp_size_result;
		    for (int i_l = 0; i_l < xlist.size(); i_l++){
		      int y_q = 0;
		      if (xlist[i_l]->active_qTcut){y_q = x_q;}
		      int temp_size_result_c = int(log10(abs(osi->unit_factor_distribution * xlist[i_l]->distribution_result_qTcut_TSV[y_q][i_g][i_d][i_b][i_s][i_r][i_f])));
		      if (temp_size_result_c > temp_size_result){temp_size_result = temp_size_result_c;}
		    }
		    int temp_size_deviation = int(log10(abs(osi->unit_factor_distribution * distribution_deviation_qTcut_TSV[x_q][i_g][i_d][i_b][i_s][i_r][i_f])));
		    if (osi->unit_factor_distribution * distribution_deviation_qTcut_TSV[x_q][i_g][i_d][i_b][i_s][i_r][i_f] >= 1.){temp_size_deviation++;}
		    int setw_result = 9 + temp_size_result_order - temp_size_result;
		    int setw_deviation = 9 + temp_size_deviation - temp_size_result - 1;
		    if (distribution_result_qTcut_TSV[x_q][i_g][i_d][i_b][i_s][i_r][i_f] == 0.){setw_result = 1; setw_deviation = 1;}
		    else if (abs(osi->unit_factor_distribution * distribution_result_qTcut_TSV[x_q][i_g][i_d][i_b][i_s][i_r][i_f]) < 1.){setw_result--;}

		    out_overviewfile << right << noshowpoint << setw(10) << setprecision(8) << osi->dddat[i_ddd].distribution_1.bin_edge[i_b1];
		    out_overviewfile << setw(2) << "";
		    out_overviewfile << right << noshowpoint << setw(10) << setprecision(8) << osi->dddat[i_ddd].distribution_1.bin_edge[i_b1 + 1];
		    out_overviewfile << setw(3) << "";
		    out_overviewfile << right << noshowpoint << setw(10) << setprecision(8) << osi->dddat[i_ddd].distribution_2.bin_edge[i_b2];
		    out_overviewfile << setw(2) << "";
		    out_overviewfile << right << noshowpoint << setw(10) << setprecision(8) << osi->dddat[i_ddd].distribution_2.bin_edge[i_b2 + 1];
		    out_overviewfile << setw(3) << "";
		    if (active_qTcut){ out_overviewfile << left << noshowpoint << setw(16) << osi->value_qTcut_distribution[x_q]; }
		    else { out_overviewfile << left << setw(16) << "independent"; }
		    out_overviewfile << left << setw(25) << resultdirectory;
		    out_overviewfile << left << setw(15) << "";
		    out_overviewfile << right << showpoint << setw(16) << setprecision(setw_result) << osi->unit_factor_distribution * distribution_result_qTcut_TSV[x_q][i_g][i_d][i_b][i_s][i_r][i_f];
		    out_overviewfile << " +- ";
		    out_overviewfile << right << showpoint << setw(16) << setprecision(setw_deviation) << osi->unit_factor_distribution * distribution_deviation_qTcut_TSV[x_q][i_g][i_d][i_b][i_s][i_r][i_f];
		    out_overviewfile << endline;
		    out_overviewfile << temp_ss_separation_one.str() << endline;

		    for (int i_l = 0; i_l < xlist.size(); i_l++){
		      int y_q = 0;
		      if (xlist[i_l]->active_qTcut){y_q = x_q;}

		      int temp_size_result_subprocess = int(log10(abs(osi->unit_factor_distribution * xlist[i_l]->distribution_result_qTcut_TSV[y_q][i_g][i_d][i_b][i_s][i_r][i_f])));
		      int temp_size_deviation_subprocess = int(log10(abs(osi->unit_factor_distribution * xlist[i_l]->distribution_deviation_qTcut_TSV[y_q][i_g][i_d][i_b][i_s][i_r][i_f])));
		      if (osi->unit_factor_distribution * xlist[i_l]->distribution_deviation_qTcut_TSV[y_q][i_g][i_d][i_b][i_s][i_r][i_f] >= 1.){temp_size_deviation_subprocess++;}
		      if (xlist[i_l]->distribution_result_qTcut_TSV[y_q][i_g][i_d][i_b][i_s][i_r][i_f] == 0){temp_size_result_subprocess = 0;}
		      if (xlist[i_l]->distribution_deviation_qTcut_TSV[y_q][i_g][i_d][i_b][i_s][i_r][i_f] == 0){temp_size_deviation_subprocess = 0;}
		      int setw_result = 9 + temp_size_result_subprocess - temp_size_result;
		      int setw_deviation = 9 + temp_size_deviation_subprocess - temp_size_deviation - (temp_size_result - temp_size_deviation + 1);
		      if (xlist[i_l]->distribution_result_qTcut_TSV[y_q][i_g][i_d][i_b][i_s][i_r][i_f] == 0.){setw_result = 1; setw_deviation = 1;}
		      else if (abs(osi->unit_factor_distribution * xlist[i_l]->distribution_result_qTcut_TSV[y_q][i_g][i_d][i_b][i_s][i_r][i_f]) < 1.){setw_result--;}

		      out_overviewfile << right << noshowpoint << setw(10) << setprecision(8) << osi->dddat[i_ddd].distribution_1.bin_edge[i_b1];
		      out_overviewfile << setw(2) << "";
		      out_overviewfile << right << noshowpoint << setw(10) << setprecision(8) << osi->dddat[i_ddd].distribution_1.bin_edge[i_b1 + 1];
		      out_overviewfile << setw(3) << "";
		      out_overviewfile << right << noshowpoint << setw(10) << setprecision(8) << osi->dddat[i_ddd].distribution_2.bin_edge[i_b2];
		      out_overviewfile << setw(2) << "";
		      out_overviewfile << right << noshowpoint << setw(10) << setprecision(8) << osi->dddat[i_ddd].distribution_2.bin_edge[i_b2 + 1];
		      out_overviewfile << setw(3) << "";
		      if (xlist[i_l]->active_qTcut){ out_overviewfile << left << noshowpoint << setw(16) << osi->value_qTcut_distribution[x_q]; }
		      else { out_overviewfile << left << setw(16) << "independent"; }
		      out_overviewfile << left << setw(25) << xlist[i_l]->xcontribution[0]->infix_order_contribution;
		      if (xlist[i_l]->channel_selection != "" && xlist[i_l]->channel_selection != "---"){ out_overviewfile << left << setw(5) << xlist[i_l]->channel_selection; }
		      else { out_overviewfile << setw(5) << ""; }
		      if (xlist[i_l]->extra_selection != "" && xlist[i_l]->extra_selection != "---"){ out_overviewfile << left << setw(10) << xlist[i_l]->extra_selection; }
		      else { out_overviewfile << setw(10) << ""; }
		      out_overviewfile << right << showpoint << setw(16) << setprecision(setw_result) << osi->unit_factor_distribution * xlist[i_l]->distribution_result_qTcut_TSV[y_q][i_g][i_d][i_b][i_s][i_r][i_f];
		      out_overviewfile << " +- ";
		      out_overviewfile << right << showpoint << setw(16) << setprecision(setw_deviation) << osi->unit_factor_distribution * xlist[i_l]->distribution_deviation_qTcut_TSV[y_q][i_g][i_d][i_b][i_s][i_r][i_f];
		      out_overviewfile  << endline;
		    }
		    out_overviewfile << endline;
		  }
		  if (counter_empty_bin < selection_n_qTcut){out_overviewfile << temp_ss_separation_two.str() << endl << endline;}
		}
	      }
	    }
	    if (!ygeneric->switch_output_overview_reduction){ out_overviewfile.close(); }
	  }
	  if (ygeneric->switch_output_overview_reduction == 1){ out_overviewfile.close(); }
	}
      }
      //      if (ygeneric->switch_output_overview_reduction == 2){ out_overviewfile.close(); }
    }
  }

  logger.finished();
}





// All functions below are only relevant for CV variation:

void summary_order::output_distribution_overview_CV(){
  static Logger logger("summary_order::output_distribution_overview_CV");
  logger.called();

  stringstream header_ss;
  header_ss << left;
  header_ss << setw(16) << "bin";
  header_ss << setw(16) << "qTcut";
  header_ss << setw(25) << "list";
  header_ss << setw(15) << "";
  header_ss << right << setw(16) << "dXS (list)";
  header_ss << setw(4) << " +- ";
  header_ss << right << setw(16) << "err (list)";
  //	   header_ss << right << setw(34) << "dXS +- err (list)";

  stringstream temp_ss_separation_one;
  stringstream temp_ss_separation_two;
  int counter_separation = 16 + 16 + 25 + 15 + 16 + 4 + 16;
  //  int counter_separation = 16 + 16 + 25 + 16 + 4 + 16;
  for (int i_x = 0; i_x < counter_separation; i_x++){
    temp_ss_separation_one << "-";
    temp_ss_separation_two << "=";
  }

  int i_q = 0;
  for (int i_s = 0; i_s < osi->n_scales_CV; i_s++){
    for (int i_g = 0; i_g < ygeneric->subgroup.size(); i_g++){
      for (int i_d = 0; i_d < osi->extended_distribution.size(); i_d++){
	if (!ygeneric->switch_output_distribution[i_d]){continue;}
	string filename_distribution_overview = "overview." + osi->extended_distribution[i_d].xdistribution_name + ".." + resultdirectory + ".dat";
	string filepath_distribution_overview = ygeneric->final_resultdirectory + "/CV/" + osi->directory_name_scale_CV[i_s] + "/" + filename_distribution_overview;
	logger << LOG_DEBUG_VERBOSE << "filename_distribution_overview = " << filename_distribution_overview << endline_flush;
	logger << LOG_DEBUG << "filepath_distribution_overview = " << filepath_distribution_overview << endline_flush;

	ofstream out_overviewfile;
	out_overviewfile.open(filepath_distribution_overview.c_str(), ofstream::out | ofstream::trunc);
	out_overviewfile << header_ss.str() << endline;
	out_overviewfile << endline;

	for (int i_b = 0; i_b < osi->extended_distribution[i_d].n_bins; i_b++){
	  int counter_empty_bin = 0;
	  // check if bin is empty (to reduce output):
	  if (distribution_result_CV[i_g][i_d][i_b][i_s] == 0.){counter_empty_bin++; continue;}
	      if (munich_isnan(distribution_result_CV[i_g][i_d][i_b][i_s]) || munich_isnan(distribution_deviation_CV[i_g][i_d][i_b][i_s])){continue;}

	  int temp_size_result = int(log10(abs(osi->unit_factor_distribution * distribution_result_CV[i_g][i_d][i_b][i_s])));
	  int temp_size_result_order = temp_size_result;
	  for (int i_l = 0; i_l < xlist.size(); i_l++){
	    int temp_size_result_c = int(log10(abs(osi->unit_factor_distribution * xlist[i_l]->xcontribution[0]->distribution_result_CV[i_g][i_d][i_b][i_s])));
	    if (temp_size_result_c > temp_size_result){temp_size_result = temp_size_result_c;}
	  }
	  int temp_size_deviation = int(log10(abs(osi->unit_factor_distribution * distribution_deviation_CV[i_g][i_d][i_b][i_s])));
	  if (osi->unit_factor_distribution * distribution_deviation_CV[i_g][i_d][i_b][i_s] >= 1.){temp_size_deviation++;}
 	  int setw_result = 9 + temp_size_result_order - temp_size_result;
	  int setw_deviation = 9 + temp_size_deviation - temp_size_result - 1;
	  if (distribution_result_CV[i_g][i_d][i_b][i_s] == 0.){setw_result = 1; setw_deviation = 1;}
	  else if (abs(osi->unit_factor_distribution * distribution_result_CV[i_g][i_d][i_b][i_s]) < 1.){setw_result--;}

	  out_overviewfile << left
			   << setw(16) << setprecision(8) << noshowpoint
			   << osi->extended_distribution[i_d].bin_edge[i_b];
	  if (active_qTcut){out_overviewfile << noshowpoint << setw(16) << osi->value_qTcut_distribution[i_q];}
	  else {out_overviewfile << setw(16) << "independent";}
	  out_overviewfile << setw(25) << resultdirectory;
	  out_overviewfile << left << setw(15) << "";
	  out_overviewfile << showpoint << right
			   << setw(16) << setprecision(setw_result) << osi->unit_factor_distribution * distribution_result_CV[i_g][i_d][i_b][i_s]
			   << " +- "
			   << setw(16) << setprecision(setw_deviation) << osi->unit_factor_distribution * distribution_deviation_CV[i_g][i_d][i_b][i_s]
			   << endline;

	  out_overviewfile << temp_ss_separation_one.str() << endline;
	  //	  out_overviewfile << "xlist.size() = " << xlist.size() << endline;
	  for (int i_l = 0; i_l < xlist.size(); i_l++){
	    //	    out_overviewfile << "xlist[" << i_l << "] = " << xlist[i_l]->resultdirectory << endline;
	    int temp_size_result_subprocess = int(log10(abs(osi->unit_factor_distribution * xlist[i_l]->xcontribution[0]->distribution_result_CV[i_g][i_d][i_b][i_s])));
	    int temp_size_deviation_subprocess = int(log10(abs(osi->unit_factor_distribution * xlist[i_l]->xcontribution[0]->distribution_deviation_CV[i_g][i_d][i_b][i_s])));
	    if (osi->unit_factor_distribution * xlist[i_l]->xcontribution[0]->distribution_deviation_CV[i_g][i_d][i_b][i_s] >= 1.){temp_size_deviation_subprocess++;}
	    if (xlist[i_l]->xcontribution[0]->distribution_result_CV[i_g][i_d][i_b][i_s] == 0){temp_size_result_subprocess = 0;}
	    if (xlist[i_l]->xcontribution[0]->distribution_deviation_CV[i_g][i_d][i_b][i_s] == 0){temp_size_deviation_subprocess = 0;}

	    int setw_result = 9 + temp_size_result_subprocess - temp_size_result;
	    int setw_deviation = 9 + temp_size_deviation_subprocess - temp_size_deviation - (temp_size_result - temp_size_deviation + 1);
	    if (xlist[i_l]->xcontribution[0]->distribution_result_CV[i_g][i_d][i_b][i_s] == 0.){
	      setw_result = 1;
	      setw_deviation = 1;
	    }
	    else if (abs(osi->unit_factor_distribution * xlist[i_l]->xcontribution[0]->distribution_result_CV[i_g][i_d][i_b][i_s]) < 1.){
	      setw_result--;
	    }

	    out_overviewfile << left
			     << setw(16) << setprecision(8) << noshowpoint
			     << osi->extended_distribution[i_d].bin_edge[i_b];
	    if (xlist[i_l]->active_qTcut){out_overviewfile << noshowpoint << setw(16) << osi->value_qTcut[i_q];}
	    else {out_overviewfile << setw(16) << "independent";}
	    out_overviewfile << setw(25) << xlist[i_l]->resultdirectory;
	    out_overviewfile << left << setw(15) << "";
	    out_overviewfile << showpoint << right
			     << setw(16) << setprecision(setw_result) << osi->unit_factor_distribution * xlist[i_l]->xcontribution[0]->distribution_result_CV[i_g][i_d][i_b][i_s]
			     << " +- "
			     << setw(16) << setprecision(setw_deviation) << osi->unit_factor_distribution * xlist[i_l]->xcontribution[0]->distribution_deviation_CV[i_g][i_d][i_b][i_s]
			     << endline;
	    /*
	    if (i_c == 0){
	      out_overviewfile << temp_ss_separation_one.str() << endline;
	    }
	    */
	  }
	  out_overviewfile << endline;
	  if (counter_empty_bin < selection_n_qTcut){out_overviewfile << temp_ss_separation_two.str() << endl << endline;}
	}
	out_overviewfile.close();
      }
    }
  }

  logger.finished();
}


void summary_order::output_distribution_CV(){
  static Logger logger("output_distribution_CV");
  logger.called();

  string subdirectory = "";

  for (int i_g = 0; i_g < ygeneric->subgroup.size(); i_g++){
    for (int i_d = 0; i_d < osi->extended_distribution.size(); i_d++){
      if (!ygeneric->switch_output_distribution[i_d]){continue;}
      //      if (i_d >= ygeneric->osi->dat.size()){continue;}
      string identifier = "";
      /* // commented out for v2.1 release 
      identifier = "norm";
      output_sddistribution_CV(identifier, distribution_result_CV[i_g][i_d], distribution_deviation_CV[i_g][i_d], i_d, subdirectory);
      */
      identifier = "plot";
      output_distribution_CV(identifier, distribution_result_CV[i_g][i_d], distribution_deviation_CV[i_g][i_d], i_d, subdirectory);
      output_sddistribution_CV(identifier, distribution_result_CV[i_g][i_d], distribution_deviation_CV[i_g][i_d], i_d, subdirectory);
    }
  }


  for (int i_g = 0; i_g < ygeneric->subgroup.size(); i_g++){
    for (int i_d = 0; i_d < osi->extended_distribution.size(); i_d++){
      if (!ygeneric->switch_output_distribution[i_d]){continue;}
      if (i_d < ygeneric->osi->dat.size()){continue;}
      string identifier = "";
      /* // commented out for v2.1 release 
      identifier = "norm";
      output_dddistribution_CV(identifier, distribution_result_CV[i_g][i_d], distribution_deviation_CV[i_g][i_d], i_d, subdirectory);
      */
      identifier = "plot";
      output_dddistribution_CV(identifier, distribution_result_CV[i_g][i_d], distribution_deviation_CV[i_g][i_d], i_d, subdirectory);
    }
  }

  logger.finished();
}


// old output format:
void summary_order::output_distribution_CV(string & identifier, vector<vector<double> > & this_distribution_result_CV, vector<vector<double> > & this_distribution_deviation_CV, int i_d, string & subdirectory){
  static Logger logger("summary_order::output_distribution_CV");
  logger.called();

  /////////////////////////////////////////
  //  singly-differential distributions  //
  /////////////////////////////////////////

  int plotmode = 0;

  for (int i_s = 0; i_s < osi->n_scales_CV; i_s++){
    string filename_distribution_plot = identifier + "." + osi->extended_distribution[i_d].xdistribution_name + ".." + resultdirectory + ".dat";
    string filename_full = ygeneric->final_resultdirectory + "/CV/"  + osi->directory_name_scale_CV[i_s] + subdirectory + "/" + filename_distribution_plot;
    logger << LOG_DEBUG_VERBOSE << "filename_full              = " << filename_full << endline_flush;
    ofstream out_plotfile;
    out_plotfile.open(filename_full.c_str(), ofstream::out | ofstream::trunc);
    double temp_result = 0;
    double temp_deviation = 0;
    for (int i_b = 0; i_b < osi->extended_distribution[i_d].n_bins; i_b++){
      if (identifier == "norm"){
	temp_result = this_distribution_result_CV[i_b][i_s];
	temp_deviation = this_distribution_deviation_CV[i_b][i_s];
      }
      else if (identifier == "plot"){
	temp_result = this_distribution_result_CV[i_b][i_s] / osi->extended_distribution[i_d].bin_width[i_b];
	temp_deviation = this_distribution_deviation_CV[i_b][i_s] / osi->extended_distribution[i_d].bin_width[i_b];
      }
      if (plotmode == 1){if (temp_result < 0.){temp_result = 0.;}}
      out_plotfile << right;
      out_plotfile << setw(10) << osi->extended_distribution[i_d].bin_edge[i_b]
		   << setw(16) << setprecision(8) << osi->unit_factor_distribution * temp_result
		   << setw(16) << setprecision(8) << osi->unit_factor_distribution * temp_deviation << endline;
    }
    out_plotfile << setw(10) << osi->extended_distribution[i_d].bin_edge[osi->extended_distribution[i_d].n_bins]
		 << setw(16) << setprecision(8) << osi->unit_factor_distribution * temp_result
		 << setw(16) << setprecision(8) << osi->unit_factor_distribution * temp_deviation << endline;
    out_plotfile.close();
    logger << LOG_DEBUG_VERBOSE << "singly-differential output finished" << endline_flush;
  }

  logger.finished();
}


void summary_order::output_sddistribution_CV(string & identifier, vector<vector<double> > & this_distribution_result_CV, vector<vector<double> > & this_distribution_deviation_CV, int i_d, string & subdirectory){
  static Logger logger("summary_order::output_sddistribution_CV");
  logger.called();

  /////////////////////////////////////////
  //  singly-differential distributions  //
  /////////////////////////////////////////

  //  int plotmode = 0;

  for (int i_s = 0; i_s < osi->n_scales_CV; i_s++){
    string filename_distribution_plot = "1dd." + identifier + "." + osi->extended_distribution[i_d].xdistribution_name + ".." + resultdirectory + ".dat";
    string filename_full = ygeneric->final_resultdirectory + "/CV/"  + osi->directory_name_scale_CV[i_s] + subdirectory + "/" + filename_distribution_plot;
    logger << LOG_DEBUG_VERBOSE << "filename_full              = " << filename_full << endline_flush;
    ofstream out_plotfile;
    out_plotfile.open(filename_full.c_str(), ofstream::out | ofstream::trunc);
    double temp_result = 0;
    double temp_deviation = 0;
    for (int i_b = 0; i_b < osi->extended_distribution[i_d].n_bins; i_b++){
      if (identifier == "norm"){
	temp_result = this_distribution_result_CV[i_b][i_s];
	temp_deviation = this_distribution_deviation_CV[i_b][i_s];
      }
      else if (identifier == "plot"){
	temp_result = this_distribution_result_CV[i_b][i_s] / osi->extended_distribution[i_d].bin_width[i_b];
	temp_deviation = this_distribution_deviation_CV[i_b][i_s] / osi->extended_distribution[i_d].bin_width[i_b];
      }
      //      if (plotmode == 1){if (temp_result < 0.){temp_result = 0.;}}
      out_plotfile << "  " << right << noshowpoint << setw(10) << osi->extended_distribution[i_d].bin_edge[i_b];
      out_plotfile << "  " << right << noshowpoint << setw(10) << osi->extended_distribution[i_d].bin_edge[i_b + 1];
      out_plotfile << setw(3) << "";
      out_plotfile << right << showpoint << setw(15) << setprecision(8) << osi->unit_factor_distribution * temp_result;
      out_plotfile << right << showpoint << setw(13) << setprecision(6) << osi->unit_factor_distribution * temp_deviation;
      out_plotfile << endline; 
    }
    out_plotfile.close();
    logger << LOG_DEBUG_VERBOSE << "singly-differential output finished" << endline_flush;
  }

  logger.finished();
}


void summary_order::output_dddistribution_CV(string & identifier, vector<vector<double> > & this_distribution_result_CV, vector<vector<double> > & this_distribution_deviation_CV, int i_d, string & subdirectory){
  static Logger logger("summary_order::output_dddistribution_CV");
  logger.called();

  /////////////////////////////////////////
  //  doubly-differential distributions  //
  /////////////////////////////////////////

  int i_ddd = i_d - osi->dat.size();

  //  int plotmode = 0;

  for (int i_s = 0; i_s < osi->n_scales_CV; i_s++){
    string filename_distribution_plot = "2dd." + identifier + "." + osi->extended_distribution[i_d].xdistribution_name + ".." + resultdirectory + ".dat";
    string filename_full = ygeneric->final_resultdirectory + "/CV/"  + osi->directory_name_scale_CV[i_s] + subdirectory + "/" + filename_distribution_plot;
    logger << LOG_DEBUG_VERBOSE << "filename_full              = " << filename_full << endline_flush;
    ofstream out_plotfile;
    out_plotfile.open(filename_full.c_str(), ofstream::out | ofstream::trunc);
    double temp_result = 0;
    double temp_deviation = 0;
    for (int i_b1 = 0; i_b1 < osi->dddat[i_ddd].distribution_1.n_bins; i_b1++){
      for (int i_b2 = 0; i_b2 < osi->dddat[i_ddd].distribution_2.n_bins; i_b2++){
	int i_b = i_b1 * osi->dddat[i_ddd].distribution_2.n_bins + i_b2;
	if (identifier == "norm"){
	  temp_result = this_distribution_result_CV[i_b][i_s];
	  temp_deviation = this_distribution_deviation_CV[i_b][i_s];
	}
	else if (identifier == "plot"){
	  temp_result = this_distribution_result_CV[i_b][i_s] / osi->dddat[i_ddd].distribution_1.bin_width[i_b1] / osi->dddat[i_ddd].distribution_2.bin_width[i_b2];
	  temp_deviation = this_distribution_deviation_CV[i_b][i_s] / osi->dddat[i_ddd].distribution_1.bin_width[i_b1] / osi->dddat[i_ddd].distribution_2.bin_width[i_b2];
	}
	//	if (plotmode == 1){if (temp_result < 0.){temp_result = 0.;}}
	out_plotfile << "  " << right << noshowpoint << setw(10) << osi->dddat[i_ddd].distribution_1.bin_edge[i_b1];
	out_plotfile << "  " << right << noshowpoint << setw(10) << osi->dddat[i_ddd].distribution_1.bin_edge[i_b1 + 1];
	out_plotfile << setw(3) << "";
	out_plotfile << "  " << right << noshowpoint << setw(10) << osi->dddat[i_ddd].distribution_2.bin_edge[i_b2];
	out_plotfile << "  " << right << noshowpoint << setw(10) << osi->dddat[i_ddd].distribution_2.bin_edge[i_b2 + 1];
	out_plotfile << setw(3) << "";
	out_plotfile << setw(15) << setprecision(8) << osi->unit_factor_distribution * temp_result;
	out_plotfile << setw(13) << setprecision(6) << osi->unit_factor_distribution * temp_deviation;
	out_plotfile << endline;
      }
    }
    out_plotfile.close();
    logger << LOG_DEBUG_VERBOSE << "singly-differential output finished" << endline_flush;
  }

  logger.finished();
}


/* // old version
void summary_order::output_dddistribution_CV(string & identifier, vector<vector<double> > & this_distribution_result_CV, vector<vector<double> > & this_distribution_deviation_CV, int i_d, string & subdirectory){
  static Logger logger("summary_order::output_dddistribution_CV");
  logger.called();

  /////////////////////////////////////////
  //  doubly-differential distributions  //
  /////////////////////////////////////////

  int i_ddd = i_d - osi->dat.size();

  int plotmode = 0;

  for (int i_s = 0; i_s < osi->n_scales_CV; i_s++){
    string filename_distribution_plot = identifier + "." + "dddistribution" + "." + osi->extended_distribution[i_d].xdistribution_name + ".." + resultdirectory + ".dat";
    string filename_full = ygeneric->final_resultdirectory + "/CV/"  + osi->directory_name_scale_CV[i_s] + subdirectory + "/" + filename_distribution_plot;
    logger << LOG_DEBUG_VERBOSE << "filename_full              = " << filename_full << endline_flush;
    ofstream out_plotfile;
    out_plotfile.open(filename_full.c_str(), ofstream::out | ofstream::trunc);
    double temp_result = 0;
    double temp_deviation = 0;
    //    for (int i_b = 0; i_b < osi->extended_distribution[i_d].n_bins; i_b++){
    for (int i_b1 = 0; i_b1 < osi->dddat[i_ddd].distribution_1.n_bins; i_b1++){
      for (int i_b2 = 0; i_b2 < osi->dddat[i_ddd].distribution_2.n_bins; i_b2++){
	int i_b = i_b1 * osi->dddat[i_ddd].distribution_2.n_bins + i_b2;
	if (identifier == "norm" || identifier == "norm.norm"){
	  temp_result = this_distribution_result_CV[i_b][i_s];
	  temp_deviation = this_distribution_deviation_CV[i_b][i_s];
	}
	else if (identifier == "plot" || identifier == "plot.plot"){
	  temp_result = this_distribution_result_CV[i_b][i_s] / osi->dddat[i_ddd].distribution_1.bin_width[i_b1] / osi->dddat[i_ddd].distribution_2.bin_width[i_b2];
	  temp_deviation = this_distribution_deviation_CV[i_b][i_s] / osi->dddat[i_ddd].distribution_1.bin_width[i_b1] / osi->dddat[i_ddd].distribution_2.bin_width[i_b2];
	  //	  temp_result = this_distribution_result_CV[i_b][i_s] / osi->extended_distribution[i_d].bin_width[i_b];
	  //	  temp_deviation = this_distribution_deviation_CV[i_b][i_s] / osi->extended_distribution[i_d].bin_width[i_b];
	}
	else if (identifier == "norm.plot"){
	  temp_result = this_distribution_result_CV[i_b][i_s] / osi->dddat[i_ddd].distribution_2.bin_width[i_b2];
	  temp_deviation = this_distribution_deviation_CV[i_b][i_s] / osi->dddat[i_ddd].distribution_2.bin_width[i_b2];
	}
	else if (identifier == "plot.norm"){
	  temp_result = this_distribution_result_CV[i_b][i_s] / osi->dddat[i_ddd].distribution_1.bin_width[i_b1];
	  temp_deviation = this_distribution_deviation_CV[i_b][i_s] / osi->dddat[i_ddd].distribution_1.bin_width[i_b1];
	}
	if (plotmode == 1){if (temp_result < 0.){temp_result = 0.;}}

	out_plotfile << right;
	out_plotfile  << setw(10) << setprecision(8) << osi->dddat[i_ddd].distribution_1.bin_edge[i_b1]
		      << setw(10) << setprecision(8) << osi->dddat[i_ddd].distribution_1.bin_edge[i_b1 + 1]
		      << setw(5)
		      << setw(10) << setprecision(8) << osi->dddat[i_ddd].distribution_2.bin_edge[i_b2]
		      << setw(10) << setprecision(8) << osi->dddat[i_ddd].distribution_2.bin_edge[i_b2 + 1]
		      << setw(5)
		      << setw(16) << setprecision(8) << osi->unit_factor_distribution * temp_result
		      << setw(16) << setprecision(8) << osi->unit_factor_distribution * temp_deviation << endline;
      }
    }
    /*
    out_plotfile << setw(10) << osi->extended_distribution[i_d].bin_edge[osi->extended_distribution[i_d].n_bins]
		 << setw(16) << setprecision(8) << osi->unit_factor_distribution * temp_result
		 << setw(16) << setprecision(8) << osi->unit_factor_distribution * temp_deviation << endline;
*//*
    out_plotfile.close();
    logger << LOG_DEBUG_VERBOSE << "singly-differential output finished" << endline_flush;
  }

  logger.finished();
}
*/


void summary_order::output_dddistribution_slice_in_first_sdd_CV(string & identifier, vector<vector<double> > & this_distribution_result_CV, vector<vector<double> > & this_distribution_deviation_CV, int i_d, string & subdirectory){
  static Logger logger("summary_order::output_dddistribution_slice_in_first_sdd_CV");
  logger.called();

  int i_ddd = i_d - osi->dat.size();

  for (int i_s = 0; i_s < osi->n_scales_CV; i_s++){

    /////////////////////////////////////////////////////////////
    //  state re-normalized distibutions for each pTratio-bin  //
    //  state re-normalized distibutions for each abseta-bin   //
    /////////////////////////////////////////////////////////////

    for (int i_b1 = 0; i_b1 < osi->dddat[i_ddd].distribution_1.n_bins; i_b1++){
      //    string filename_distribution_plot = identifier + "." + osi->extended_distribution[i_d].xdistribution_name + ".." + resultdirectory + ".dat";
      stringstream filename_distribution_plot_ss;
      filename_distribution_plot_ss << identifier << ".slice." << osi->dddat[i_ddd].name << "_" << osi->dddat[i_ddd].distribution_1.bin_edge[i_b1] << "-" << osi->dddat[i_ddd].distribution_1.bin_edge[i_b1 + 1] << ".." << resultdirectory << ".dat";
      string filename_distribution_plot = filename_distribution_plot_ss.str();
      string filename_full = ygeneric->final_resultdirectory + "/CV/"  + osi->directory_name_scale_CV[i_s] + subdirectory + "/" + filename_distribution_plot;
      ofstream out_plotfile;
      out_plotfile.open(filename_full.c_str(), ofstream::out | ofstream::trunc);

      double temp_result = 0;
      double temp_deviation = 0;
      for (int i_b2 = 0; i_b2 < osi->dddat[i_ddd].distribution_2.n_bins; i_b2++){
	int i_b = i_b1 * osi->dddat[i_ddd].distribution_2.n_bins + i_b2;

	if (identifier == "norm.norm"){
	  temp_result = this_distribution_result_CV[i_b][i_s];
	  temp_deviation = this_distribution_deviation_CV[i_b][i_s];
	}
	else if (identifier == "norm.plot"){
	  temp_result = this_distribution_result_CV[i_b][i_s] / osi->dddat[i_ddd].distribution_2.bin_width[i_b2];
	  temp_deviation = this_distribution_deviation_CV[i_b][i_s] / osi->dddat[i_ddd].distribution_2.bin_width[i_b2];
	}
	else if (identifier == "plot.norm"){
	  temp_result = this_distribution_result_CV[i_b][i_s] / osi->dddat[i_ddd].distribution_1.bin_width[i_b1];
	  temp_deviation = this_distribution_deviation_CV[i_b][i_s] / osi->dddat[i_ddd].distribution_1.bin_width[i_b1];
	}
	else if (identifier == "plot.plot"){
	  temp_result = this_distribution_result_CV[i_b][i_s] / osi->dddat[i_ddd].distribution_2.bin_width[i_b2] / osi->dddat[i_ddd].distribution_1.bin_width[i_b1];
	  temp_deviation = this_distribution_deviation_CV[i_b][i_s] / osi->dddat[i_ddd].distribution_2.bin_width[i_b2] / osi->dddat[i_ddd].distribution_1.bin_width[i_b1];
	}

	out_plotfile << right;
	out_plotfile << setw(10) << osi->dddat[i_ddd].distribution_2.bin_edge[i_b2]
		     << setw(16) << setprecision(8) << osi->unit_factor_distribution * temp_result
		     << setw(16) << setprecision(8) << osi->unit_factor_distribution * temp_deviation
		     << endline;
      }
      out_plotfile << setw(10) << osi->dddat[i_ddd].distribution_2.bin_edge[osi->dddat[i_ddd].distribution_2.n_bins]
		   << setw(16) << setprecision(8) << osi->unit_factor_distribution * temp_result
		   << setw(16) << setprecision(8) << osi->unit_factor_distribution * temp_deviation
		   << endline;
      out_plotfile.close();
    }
  }

  logger.finished();
}

