#include "header.hpp"

void summary_subprocess::output_distribution_TSV(){
  static Logger logger("summary_subprocess::output_distribution_TSV");
  logger.called();

  int plot_mode = 0;
  string name_result = ycontribution->infix_order_contribution + "." + name;

  vector<string> identifier_sdd(2);
  identifier_sdd[0] = "norm";
  identifier_sdd[1] = "plot";

  string subdirectory = "/" + ycontribution->ylist->resultdirectory + "/" + ycontribution->infix_contribution + "/" + name;
  
  if (Log::getLogThreshold() <= LOG_DEBUG){ logger << LOG_DEBUG << "subdirectory = " << subdirectory << "   resultdirectory = " << ycontribution->ylist->resultdirectory << "   selection_n_qTcut = " << ycontribution->selection_n_qTcut << endline_flush; }
  for (int i_i = 0; i_i < identifier_sdd.size(); i_i++){
    if (Log::getLogThreshold() <= LOG_DEBUG){ logger << LOG_DEBUG << "ygeneric->output_distribution_initialization_file_reduction_TSV(name_result = " << name_result << "   subdirectory = " << subdirectory << "   identifier_sdd[" << i_i << "] = " << identifier_sdd[i_i] << "   selection_n_qTcut = " << ycontribution->selection_n_qTcut << ");" << endline_flush; }
    
    if (!ycontribution->active_qTcut || ycontribution->selection_n_qTcut == 1){
      if (ygeneric->switch_output_plot_reduction == 1){ ygeneric->output_distribution_initialization_file_reduction_TSV(name_result, subdirectory, identifier_sdd[i_i], ycontribution->selection_n_qTcut); }
    }
     
    if (ycontribution->active_qTcut && ycontribution->selection_n_qTcut > 1){
      // inverted output for bin-wise rcut dependence
      for (int i_g = 0; i_g < ygeneric->subgroup.size(); i_g++){
	for (int i_d = 0; i_d < ygeneric->osi->extended_distribution.size(); i_d++){
	  if (!ygeneric->switch_output_distribution[i_d]){continue;}
	  vector<vector<vector<vector<vector<double> > > > > rcut_distribution_result_qTcut_TSV(ycontribution->selection_n_qTcut);
	  vector<vector<vector<vector<vector<double> > > > > rcut_distribution_deviation_qTcut_TSV(ycontribution->selection_n_qTcut);
	  for (int x_q = 0; x_q < ycontribution->selection_n_qTcut; x_q++){
	    rcut_distribution_result_qTcut_TSV[x_q] = distribution_result_qTcut_TSV[x_q][i_g][i_d];
	    rcut_distribution_deviation_qTcut_TSV[x_q] = distribution_deviation_qTcut_TSV[x_q][i_g][i_d];
	  }
	  if (i_d < ygeneric->osi->dat.size()){
	    ygeneric->output_rcut_sddistribution_TSV(identifier_sdd[i_i], rcut_distribution_result_qTcut_TSV, rcut_distribution_deviation_qTcut_TSV, i_d, name_result, subdirectory, plot_mode);
	  }
	  else {
	    ygeneric->output_rcut_dddistribution_TSV(identifier_sdd[i_i], rcut_distribution_result_qTcut_TSV, rcut_distribution_deviation_qTcut_TSV, i_d, name_result, subdirectory, plot_mode);
	  }
	}
      }
    }

    if (!ycontribution->active_qTcut || ycontribution->selection_n_qTcut == 1){
      // single-differential distributions
      for (int i_g = 0; i_g < ygeneric->subgroup.size(); i_g++){
	for (int i_d = 0; i_d < ygeneric->osi->dat.size(); i_d++){
	  //    for (int i_d = 0; i_d < ygeneric->osi->extended_distribution.size(); i_d++){
	  if (!ygeneric->switch_output_distribution[i_d]){continue;}
	  ygeneric->output_distribution_TSV(identifier_sdd[i_i], distribution_result_qTcut_TSV[0][i_g][i_d], distribution_deviation_qTcut_TSV[0][i_g][i_d], i_d, name_result, subdirectory, plot_mode);
	  ygeneric->output_sddistribution_TSV(identifier_sdd[i_i], distribution_result_qTcut_TSV[0][i_g][i_d], distribution_deviation_qTcut_TSV[0][i_g][i_d], i_d, name_result, subdirectory, plot_mode);
	}
      }
      // double-differential distributions
      for (int i_g = 0; i_g < ygeneric->subgroup.size(); i_g++){
	for (int i_d = ygeneric->osi->dat.size(); i_d < ygeneric->osi->extended_distribution.size(); i_d++){
	  if (!ygeneric->switch_output_distribution[i_d]){continue;}
	  ygeneric->output_dddistribution_TSV(identifier_sdd[i_i], distribution_result_qTcut_TSV[0][i_g][i_d], distribution_deviation_qTcut_TSV[0][i_g][i_d], i_d, name_result, subdirectory, plot_mode);
	  ygeneric->output_dddistribution_reconstruct_first_sdd_TSV(identifier_sdd[i_i], distribution_result_qTcut_TSV[0][i_g][i_d], distribution_deviation_qTcut_TSV[0][i_g][i_d], i_d, name_result, subdirectory, plot_mode);
	  ygeneric->output_dddistribution_reconstruct_second_sdd_TSV(identifier_sdd[i_i], distribution_result_qTcut_TSV[0][i_g][i_d], distribution_deviation_qTcut_TSV[0][i_g][i_d], i_d, name_result, subdirectory, plot_mode);
	  ygeneric->output_dddistribution_slice_in_first_sdd_TSV(identifier_sdd[i_i], distribution_result_qTcut_TSV[0][i_g][i_d], distribution_deviation_qTcut_TSV[0][i_g][i_d], i_d, name_result, subdirectory, plot_mode);
	  ygeneric->output_dddistribution_slice_in_second_sdd_TSV(identifier_sdd[i_i], distribution_result_qTcut_TSV[0][i_g][i_d], distribution_deviation_qTcut_TSV[0][i_g][i_d], i_d, name_result, subdirectory, plot_mode);
	  ygeneric->output_dddistribution_ge_in_first_sdd_TSV(identifier_sdd[i_i], distribution_result_qTcut_TSV[0][i_g][i_d], distribution_deviation_qTcut_TSV[0][i_g][i_d], i_d, name_result, subdirectory, plot_mode);
	  ygeneric->output_dddistribution_ge_in_second_sdd_TSV(identifier_sdd[i_i], distribution_result_qTcut_TSV[0][i_g][i_d], distribution_deviation_qTcut_TSV[0][i_g][i_d], i_d, name_result, subdirectory, plot_mode);
	  ygeneric->output_dddistribution_lt_in_first_sdd_TSV(identifier_sdd[i_i], distribution_result_qTcut_TSV[0][i_g][i_d], distribution_deviation_qTcut_TSV[0][i_g][i_d], i_d, name_result, subdirectory, plot_mode);
	  ygeneric->output_dddistribution_lt_in_second_sdd_TSV(identifier_sdd[i_i], distribution_result_qTcut_TSV[0][i_g][i_d], distribution_deviation_qTcut_TSV[0][i_g][i_d], i_d, name_result, subdirectory, plot_mode);
	}
      }
    }
  }
  
  logger.finished();
}


void summary_subprocess::output_distribution_qTcut_TSV(){
  static Logger logger("summary_subprocess::output_distribution_qTcut_TSV");
  logger.called();

  if (!ycontribution->active_qTcut || ycontribution->selection_n_qTcut == 1){return;}
    
  int local_n_qTcut = 1;
  if (ycontribution->active_qTcut){local_n_qTcut = ycontribution->selection_n_qTcut;}

  int plot_mode = 0;
  string name_result = ycontribution->infix_order_contribution + "." + name;

  vector<string> identifier_sdd(2);
  identifier_sdd[0] = "norm";
  identifier_sdd[1] = "plot";

  string subdirectory = "/" + ycontribution->ylist->resultdirectory + "/" + ycontribution->infix_contribution + "/" + name;
  vector<string> subdirectory_qTcut(ycontribution->selection_n_qTcut, "");
  for (int x_q = 0; x_q < local_n_qTcut; x_q++){
    if (ycontribution->active_qTcut){
      stringstream qTcut_ss;
      qTcut_ss << "qTcut-" << ygeneric->osi->value_qTcut_distribution[x_q];
      subdirectory_qTcut[x_q] = "/" + ycontribution->ylist->resultdirectory + "/" + ycontribution->infix_contribution + "/" + name + "/" + qTcut_ss.str();
    }
    else {subdirectory_qTcut[x_q] = "/" + ycontribution->ylist->resultdirectory + "/" + ycontribution->infix_contribution + "/" + name;}
  }
  for (int x_q = 0; x_q < local_n_qTcut; x_q++){
    for (int i_s = 0; i_s < osi->n_extended_set_TSV; i_s++){
      if (!ygeneric->switch_output_scaleset[i_s]){continue;}
      if (!ygeneric->osi->switch_distribution_TSV[i_s]){continue;}
      for (int i_r = 0; i_r < ygeneric->osi->n_scale_ren_TSV[i_s]; i_r++){
	for (int i_f = 0; i_f < ygeneric->osi->n_scale_fact_TSV[i_s]; i_f++){
	  string directory_distribution_plot = ygeneric->scalepath_TSV[i_s][i_r][i_f] + "/" + subdirectory_qTcut[x_q] + "/" + name;
	  if (Log::getLogThreshold() <= LOG_DEBUG){ logger << LOG_DEBUG << "mkdir " << directory_distribution_plot << endline_flush; }
	  system_execute(logger, "mkdir " + directory_distribution_plot);
	}
      }
    }
  }
  for (int x_q = 0; x_q < local_n_qTcut; x_q++){
    for (int i_i = 0; i_i < identifier_sdd.size(); i_i++){
      for (int i_g = 0; i_g < ygeneric->subgroup.size(); i_g++){
	for (int i_d = 0; i_d < ygeneric->osi->dat.size(); i_d++){
	  if (!ygeneric->switch_output_distribution[i_d]){continue;}
	  ygeneric->output_distribution_TSV(identifier_sdd[i_i], distribution_result_qTcut_TSV[x_q][i_g][i_d], distribution_deviation_qTcut_TSV[x_q][i_g][i_d], i_d, name_result, subdirectory, plot_mode);
	  ygeneric->output_sddistribution_TSV(identifier_sdd[i_i], distribution_result_qTcut_TSV[x_q][i_g][i_d], distribution_deviation_qTcut_TSV[x_q][i_g][i_d], i_d, name_result, subdirectory, plot_mode);
	}
      }

      // only for dddistributions
      for (int i_g = 0; i_g < ygeneric->subgroup.size(); i_g++){
	for (int i_d = ygeneric->osi->dat.size(); i_d < ygeneric->osi->extended_distribution.size(); i_d++){
	  if (!ygeneric->switch_output_distribution[i_d]){continue;}
	  ygeneric->output_dddistribution_TSV(identifier_sdd[i_i], distribution_result_qTcut_TSV[x_q][i_g][i_d], distribution_deviation_qTcut_TSV[x_q][i_g][i_d], i_d, name_result, subdirectory, plot_mode);
	  ygeneric->output_dddistribution_reconstruct_first_sdd_TSV(identifier_sdd[i_i], distribution_result_qTcut_TSV[x_q][i_g][i_d], distribution_deviation_qTcut_TSV[x_q][i_g][i_d], i_d, name_result, subdirectory, plot_mode);
	  ygeneric->output_dddistribution_reconstruct_second_sdd_TSV(identifier_sdd[i_i], distribution_result_qTcut_TSV[x_q][i_g][i_d], distribution_deviation_qTcut_TSV[x_q][i_g][i_d], i_d, name_result, subdirectory, plot_mode);
	  ygeneric->output_dddistribution_slice_in_first_sdd_TSV(identifier_sdd[i_i], distribution_result_qTcut_TSV[x_q][i_g][i_d], distribution_deviation_qTcut_TSV[x_q][i_g][i_d], i_d, name_result, subdirectory, plot_mode);
	  ygeneric->output_dddistribution_slice_in_second_sdd_TSV(identifier_sdd[i_i], distribution_result_qTcut_TSV[x_q][i_g][i_d], distribution_deviation_qTcut_TSV[x_q][i_g][i_d], i_d, name_result, subdirectory, plot_mode);
	  ygeneric->output_dddistribution_ge_in_first_sdd_TSV(identifier_sdd[i_i], distribution_result_qTcut_TSV[x_q][i_g][i_d], distribution_deviation_qTcut_TSV[x_q][i_g][i_d], i_d, name_result, subdirectory, plot_mode);
	  ygeneric->output_dddistribution_ge_in_second_sdd_TSV(identifier_sdd[i_i], distribution_result_qTcut_TSV[x_q][i_g][i_d], distribution_deviation_qTcut_TSV[x_q][i_g][i_d], i_d, name_result, subdirectory, plot_mode);
	  ygeneric->output_dddistribution_lt_in_first_sdd_TSV(identifier_sdd[i_i], distribution_result_qTcut_TSV[x_q][i_g][i_d], distribution_deviation_qTcut_TSV[x_q][i_g][i_d], i_d, name_result, subdirectory, plot_mode);
	  ygeneric->output_dddistribution_lt_in_second_sdd_TSV(identifier_sdd[i_i], distribution_result_qTcut_TSV[x_q][i_g][i_d], distribution_deviation_qTcut_TSV[x_q][i_g][i_d], i_d, name_result, subdirectory, plot_mode);
	}
      }
    }
  }

  logger.finished();
}

