#include "header.hpp"

void summary_subprocess::output_plot_qTcut_TSV(){
  static Logger logger("summary_subprocess::output_plot_qTcut_TSV");
  logger.called();

  int start_i_m = 0;
  //  for (int i_m = start_i_m; i_m < osi->n_moments; i_m++){
  for (int i_m = start_i_m; i_m < 1; i_m++){
    for (int i_s = 0; i_s < osi->n_extended_set_TSV; i_s++){
      if (!ygeneric->switch_output_scaleset[i_s]){continue;}
      if (ygeneric->switch_output_complete){output_selection_plot_qTcut_TSV("complete", i_m, i_s);}
      if (ygeneric->switch_output_ren){output_selection_plot_qTcut_TSV("ren", i_m, i_s);}
      if (ygeneric->switch_output_fact){output_selection_plot_qTcut_TSV("fact", i_m, i_s);}
      if (ygeneric->switch_output_equal){output_selection_plot_qTcut_TSV("equal", i_m, i_s);}
      if (ygeneric->switch_output_antipodal){output_selection_plot_qTcut_TSV("antipodal", i_m, i_s);}
      if (ygeneric->switch_output_7point){output_selection_plot_qTcut_TSV("7-point", i_m, i_s);}
      if (ygeneric->switch_output_9point){output_selection_plot_qTcut_TSV("9-point", i_m, i_s);}
    }
  }

  logger.finished();
}


void summary_subprocess::output_selection_plot_qTcut_TSV(string selection, int i_m, int i_s){
  static Logger logger("summary_subprocess::output_selection_plot_qTcut_TSV");
  logger.called();

  string filename_selection;
  ofstream outfile_selection;
  filename_selection = "" + ygeneric->final_resultdirectory + "/" + osi->name_extended_set_TSV[i_s] + "/" + selection + "/" + ycontribution->ylist->resultdirectory + "/" + ycontribution->infix_contribution + "/plot" + ygeneric->infix_name_moment[i_m] + ".qTcut." + name + ".dat";
 if (Log::getLogThreshold() <= LOG_DEBUG){ logger << LOG_DEBUG << "filename_selection = " << filename_selection << endline_flush; }

  outfile_selection.open(filename_selection.c_str(), ofstream::out | ofstream::trunc);
  outfile_selection << left << setw(15) << "#qTcut";
  for (int i_r = 0; i_r < osi->n_scale_ren_TSV[i_s]; i_r++){
    for (int i_f = 0; i_f < osi->n_scale_fact_TSV[i_s]; i_f++){
      if (!ygeneric->output_selection_scale_check_TSV(selection, i_s, i_r, i_f)){continue;}
      outfile_selection << left << setw(30) << ygeneric->scalelabel_xi_R_F_TSV[i_s][i_r][i_f];
    }
  }
  outfile_selection << ygeneric->scalelabel_mu_R_F_TSV[i_s] << endline;

  if (!ycontribution->active_qTcut){
    outfile_selection << setw(15) << "0";
    for (int i_r = 0; i_r < osi->n_scale_ren_TSV[i_s]; i_r++){
      for (int i_f = 0; i_f < osi->n_scale_fact_TSV[i_s]; i_f++){
	if (!ygeneric->output_selection_scale_check_TSV(selection, i_s, i_r, i_f)){continue;}
	stringstream temp_ss;
	temp_ss << left << setprecision(8) << setw(15) << osi->unit_factor_result * result_TSV[i_m][0][i_s][i_r][i_f];
	temp_ss << left << setprecision(8) << setw(15) << osi->unit_factor_result * deviation_TSV[i_m][0][i_s][i_r][i_f];
	outfile_selection << temp_ss.str();
      }
    }
    outfile_selection << endline;
  }

  for (int i_q = 0; i_q < osi->n_qTcut; i_q++){
    int x_q = 0;
    if (ycontribution->active_qTcut){ x_q = i_q; }
    outfile_selection << setw(15) << osi->value_qTcut[i_q];
    for (int i_r = 0; i_r < osi->n_scale_ren_TSV[i_s]; i_r++){
      for (int i_f = 0; i_f < osi->n_scale_fact_TSV[i_s]; i_f++){
	if (!ygeneric->output_selection_scale_check_TSV(selection, i_s, i_r, i_f)){continue;}
	stringstream temp_ss;
	temp_ss << left << setprecision(8) << setw(15) << osi->unit_factor_result * result_TSV[i_m][x_q][i_s][i_r][i_f];
	temp_ss << left << setprecision(8) << setw(15) << osi->unit_factor_result * deviation_TSV[i_m][x_q][i_s][i_r][i_f];
	outfile_selection << temp_ss.str();
      }
    }
    outfile_selection << endline;
  }
  outfile_selection.close();

  logger.finished();
}


void summary_subprocess::output_plot_TSV(){
  static Logger logger("summary_subprocess::output_plot_TSV");
  logger.called();

  if (ycontribution->active_qTcut && osi->n_qTcut > 1){
    if (ygeneric->switch_output_qTcut < 4){ output_plot_qTcut_TSV(); }
    return;
  }
  
  int start_i_m = 0;
  //  for (int i_m = start_i_m; i_m < osi->n_moments; i_m++){
  for (int i_m = start_i_m; i_m < 1; i_m++){
    for (int i_s = 0; i_s < osi->n_extended_set_TSV; i_s++){
      if (!ygeneric->switch_output_scaleset[i_s]){continue;}
      if (ygeneric->switch_output_complete){output_selection_plot_TSV("complete", i_m, i_s);}
      if (ygeneric->switch_output_ren){output_selection_plot_TSV("ren", i_m, i_s);}
      if (ygeneric->switch_output_fact){output_selection_plot_TSV("fact", i_m, i_s);}
      if (ygeneric->switch_output_equal){output_selection_plot_TSV("equal", i_m, i_s);}
      if (ygeneric->switch_output_antipodal){output_selection_plot_TSV("antipodal", i_m, i_s);}
      if (ygeneric->switch_output_7point){output_selection_plot_TSV("7-point", i_m, i_s);}
      if (ygeneric->switch_output_9point){output_selection_plot_TSV("9-point", i_m, i_s);}
    }
  }

  logger.finished();
}


void summary_subprocess::output_selection_plot_TSV(string selection, int i_m, int i_s){
  static Logger logger("summary_subprocess::output_selection_plot_TSV");
  logger.called();

  string filename_selection;
  ofstream outfile_selection;
  filename_selection = "" + ygeneric->final_resultdirectory + "/" + osi->name_extended_set_TSV[i_s] + "/" + selection + "/" + ycontribution->ylist->resultdirectory + "/" + ycontribution->infix_contribution + "/plot" + ygeneric->infix_name_moment[i_m] + "." + name + ".dat";
  outfile_selection.open(filename_selection.c_str(), ofstream::out | ofstream::trunc);
  outfile_selection << left << setw(15) << "#qTcut";
  for (int i_r = 0; i_r < osi->n_scale_ren_TSV[i_s]; i_r++){
    for (int i_f = 0; i_f < osi->n_scale_fact_TSV[i_s]; i_f++){
      if (!ygeneric->output_selection_scale_check_TSV(selection, i_s, i_r, i_f)){continue;}
      outfile_selection << left << setw(30) << ygeneric->scalelabel_xi_R_F_TSV[i_s][i_r][i_f]; 
    }
  }
  outfile_selection << ygeneric->scalelabel_mu_R_F_TSV[i_s] << endline;
  outfile_selection << setw(15) << "0";
  for (int i_r = 0; i_r < osi->n_scale_ren_TSV[i_s]; i_r++){
    for (int i_f = 0; i_f < osi->n_scale_fact_TSV[i_s]; i_f++){
      if (!ygeneric->output_selection_scale_check_TSV(selection, i_s, i_r, i_f)){continue;}
      stringstream temp_ss;
      temp_ss << left << setprecision(8) << setw(15) << osi->unit_factor_result * result_TSV[i_m][0][i_s][i_r][i_f];
      temp_ss << left << setprecision(8) << setw(15) << osi->unit_factor_result * deviation_TSV[i_m][0][i_s][i_r][i_f];
      outfile_selection << temp_ss.str();
    }
  }
  outfile_selection << endline;
  outfile_selection.close();

  logger.finished();
}
