#include "header.hpp"

void summary_subprocess::readin_result_TSV(string & result_moment){
  static Logger logger("summary_subprocess::readin_result_TSV");
  logger.called();

  for (int i_o = 0; i_o < ycontribution->extended_directory.size(); i_o++){
    for (int i_z = 0; i_z < ycontribution->extended_directory[i_o].size(); i_z++){
      for (int i_s = 0; i_s < osi->n_extended_set_TSV; i_s++){
	if (!ygeneric->switch_output_scaleset[i_s]){continue;}
	stringstream temp_ss;
	if (osi->switch_moment && osi->n_moments > 0 && osi->switch_moment_TSV[i_s]){temp_ss << "moment";}
	else {temp_ss << "result";}
	result_moment = temp_ss.str();

	string result_file = result_moment + "_" + name + ".txt";
	if (Log::getLogThreshold() <= LOG_DEBUG){ logger << LOG_DEBUG << "TSV: result_file = " << result_file << endline_flush; }
	string filename = "../" + ycontribution->extended_directory[i_o][i_z] + "/" + result_moment + "/" + osi->name_extended_set_TSV[i_s] + "/" + result_file;
	if (Log::getLogThreshold() <= LOG_DEBUG){ logger << LOG_DEBUG << "TSV: filename[" << i_o << "][" << i_z << "] = " << filename << endline_flush; }

	vector<vector<string> > readin_data;
	get_data_split(filename, readin_data);

	int default_size = 1;
	if (osi->switch_moment && osi->switch_moment_TSV[i_s]){default_size += osi->n_moments * ycontribution->output_n_qTcut * (osi->n_scale_ren_TSV[i_s] * osi->n_scale_fact_TSV[i_s]);}
	else {default_size += ycontribution->output_n_qTcut * (osi->n_scale_ren_TSV[i_s] * osi->n_scale_fact_TSV[i_s]);}
	if (default_size == readin_data.size()){
	  N_event_group_run_TSV[i_o][i_z] = atoll(readin_data[0][0].c_str());
	  for (int i_m = 0; i_m < osi->n_moments; i_m++){
	    if (i_m > 0 && !osi->switch_moment_TSV[i_s]){continue;}
	    for (int i_q = 0; i_q < ycontribution->output_n_qTcut; i_q++){
	      int proc = (i_q + i_m * ycontribution->output_n_qTcut) * osi->n_scale_ren_TSV[i_s] * osi->n_scale_fact_TSV[i_s];
	      for (int i_r = 0; i_r < osi->n_scale_ren_TSV[i_s]; i_r++){
		for (int i_f = 0; i_f < osi->n_scale_fact_TSV[i_s]; i_f++){
		  result_group_run_TSV[i_o][i_z][i_m][i_q][i_s][i_r][i_f] = atof(readin_data[proc + i_r * osi->n_scale_fact_TSV[i_s] + i_f + 1][4].c_str());
		  deviation_group_run_TSV[i_o][i_z][i_m][i_q][i_s][i_r][i_f] = atof(readin_data[proc + i_r * osi->n_scale_fact_TSV[i_s] + i_f + 1][5].c_str());
		  if (Log::getLogThreshold() <= LOG_DEBUG_VERBOSE){ logger << LOG_DEBUG_VERBOSE << "result_group_run_TSV[" << i_o << "][" << i_z << "][" << i_m << "][" << i_q << "][" << i_s << "][" << i_r << "][" << i_f << "] = " << setw(23) << setprecision(15) << result_group_run_TSV[i_o][i_z][i_m][i_q][i_s][i_r][i_f] << " +- = " << setw(23) << setprecision(15) << deviation_group_run_TSV[i_o][i_z][i_m][i_q][i_s][i_r][i_f] << endline_flush; }
		}
	      }
	    }
	  }
	}
	else {
	  if (Log::getLogThreshold() <= LOG_DEBUG){ logger << LOG_DEBUG << "TSV: result_file = " << filename << " has not the expected content:   default_size = " << default_size << " != " << readin_data.size() << " = readin_data.size()" << endline_flush; }
	}
      }
    }
  }

  logger.finished();
}


void summary_subprocess::combination_result_TSV(string & result_moment){
  static Logger logger("summary_subprocess::combination_result_TSV");
  logger.called();

  logger << LOG_DEBUG << left << name << endline_flush;
  int x_m = 0;
  int x_q = 0;
  if (ycontribution->active_qTcut && ygeneric->no_qTcut_runtime_estimate){x_q = ygeneric->no_qTcut_runtime_estimate;}
  int x_s = osi->no_reference_TSV;
  int x_r = (osi->n_scale_ren_TSV[x_s] - 1) / 2;
  int x_f = (osi->n_scale_fact_TSV[x_s] - 1) / 2;
  if (Log::getLogThreshold() <= LOG_DEBUG_VERBOSE){
    logger << LOG_DEBUG_VERBOSE << "x_m = " << x_m << endline_flush;
    logger << LOG_DEBUG_VERBOSE << "x_q = " << x_q << endline_flush;
    logger << LOG_DEBUG_VERBOSE << "x_s = " << x_s << endline_flush;
    logger << LOG_DEBUG_VERBOSE << "x_r = " << x_r << endline_flush;
    logger << LOG_DEBUG_VERBOSE << "x_f = " << x_f << endline_flush;
  }

  for (int i_q = 0; i_q < ycontribution->output_n_qTcut; i_q++){
    for (int i_o = 0; i_o < ycontribution->extended_directory.size(); i_o++){
      n_parallel_runs_group_reference_TSV[i_o][i_q] = 0;
      for (int i_z = 0; i_z < ycontribution->extended_directory[i_o].size(); i_z++){
	if (N_event_group_run_TSV[i_o][i_z] != 0 &&
	    result_group_run_TSV[i_o][i_z][x_m][i_q][x_s][x_r][x_f] != 0. &&
	    deviation_group_run_TSV[i_o][i_z][x_m][i_q][x_s][x_r][x_f] != 0.){
	  n_parallel_runs_group_reference_TSV[i_o][i_q]++;
	  if (!remove_group_run_qTcut_TSV[i_q][i_o][i_z]){
	    n_valid_parallel_runs_group_reference_TSV[i_o][i_q]++;
	  }
	}
      }
    }
  }

  removal_exceptional_runs_result_TSV();
  combine_result_original_TSV();
  /*
  if (ygeneric->average_factor == 0){combine_result_alternative_TSV();}  // removal of exceptional runs not included !!!
  else if (ygeneric->average_factor == 1){combine_result_original_TSV();}  // removal of exceptional runs included
  else {combine_result_hybrid_TSV();}  // removal of exceptional runs not included !!!
  */
  
  for (int i_q = 0; i_q < ycontribution->output_n_qTcut; i_q++){
    for (int i_s = 0; i_s < osi->n_extended_set_TSV; i_s++){
      if (!ygeneric->switch_output_scaleset[i_s]){continue;}
      for (int i_r = 0; i_r < osi->n_scale_ren_TSV[i_s]; i_r++){
	for (int i_f = 0; i_f < osi->n_scale_fact_TSV[i_s]; i_f++){
 	  for (int i_o = 0; i_o < ycontribution->extended_directory.size(); i_o++){
	    for (int i_z = 0; i_z < ycontribution->extended_directory[i_o].size(); i_z++){
 	      if (N_event_group_run_TSV[i_o][i_z] != 0 &&
		  result_group_run_TSV[i_o][i_z][x_m][i_q][i_s][i_r][i_f] != 0. &&
		  deviation_group_run_TSV[i_o][i_z][x_m][i_q][i_s][i_r][i_f] != 0.){
		n_parallel_runs_group_TSV[i_o][x_m][i_q][i_s][i_r][i_f]++;
		if (!remove_group_run_qTcut_TSV[i_q][i_o][i_z]){
		  n_valid_parallel_runs_group_TSV[i_o][x_m][i_q][i_s][i_r][i_f]++;
		}
	      }
	    }
	    chi2_group_TSV[i_o][x_m][i_q][i_s][i_r][i_f] = 0.;
	    if (n_parallel_runs_group_TSV[i_o][x_m][i_q][i_s][i_r][i_f] > 1){
	      for (int i_z = 0; i_z < ycontribution->extended_directory[i_o].size(); i_z++){
		if (!(result_group_run_TSV[i_o][i_z][x_m][i_q][i_s][i_r][i_f] == 0. && deviation_group_run_TSV[i_o][i_z][x_m][i_q][i_s][i_r][i_f] == 0.)){
		  chi2_group_TSV[i_o][x_m][i_q][i_s][i_r][i_f] += pow((result_group_run_TSV[i_o][i_z][x_m][i_q][i_s][i_r][i_f] - result_group_TSV[i_o][x_m][i_q][i_s][i_r][i_f]) / deviation_group_run_TSV[i_o][i_z][x_m][i_q][i_s][i_r][i_f], 2.);
		}
	      }
	      chi2_group_TSV[i_o][x_m][i_q][i_s][i_r][i_f] = chi2_group_TSV[i_o][x_m][i_q][i_s][i_r][i_f] / n_parallel_runs_group_TSV[i_o][x_m][i_q][i_s][i_r][i_f];
	    }
	  }
	}
      }
    }
  }

  result_TSV = result_group_TSV[0];
  deviation_TSV = deviation_group_TSV[0];
  chi2_TSV = chi2_group_TSV[0];
  
  // Probably needed for runtime extrapolation ???
  
  for (int i_z = 0; i_z < ycontribution->extended_directory[0].size(); i_z++){
    result_run[i_z] = result_group_run_TSV[0][i_z][x_m][x_q][x_s][x_r][x_f];
    deviation_run[i_z] = deviation_group_run_TSV[0][i_z][x_m][x_q][x_s][x_r][x_f];
  }
  result_group_run.resize(ycontribution->extended_directory.size());
  deviation_group_run.resize(ycontribution->extended_directory.size());
  for (int i_o = 0; i_o < ycontribution->extended_directory.size(); i_o++){
    result_group_run[i_o].resize(ycontribution->extended_directory[i_o].size());
    deviation_group_run[i_o].resize(ycontribution->extended_directory[i_o].size());
    for (int i_z = 0; i_z < ycontribution->extended_directory[i_o].size(); i_z++){
      if (ycontribution->type_contribution == "PT" || ycontribution->type_contribution == "PT2" || ycontribution->type_contribution == "L2PT"){
	result_group_run[i_o][i_z] = result_group_run_TSV[i_o][i_z][x_m][ycontribution->output_n_qTcut - 1][x_s][x_r][x_f];
	deviation_group_run[i_o][i_z] = deviation_group_run_TSV[i_o][i_z][x_m][ycontribution->output_n_qTcut - 1][x_s][x_r][x_f];
      }
      else {
 	result_group_run[i_o][i_z] = result_group_run_TSV[i_o][i_z][x_m][x_q][x_s][x_r][x_f];
	deviation_group_run[i_o][i_z] = deviation_group_run_TSV[i_o][i_z][x_m][x_q][x_s][x_r][x_f];
      }
    }
  }
  
  if (ygeneric->switch_output_subprocess){
    //    if (ygeneric->switch_output_plot > 3 && ycontribution->active_qTcut){ output_result_plot_TSV(); }
    if (ygeneric->switch_output_plot > 3){ output_plot_TSV(); }
    if (ygeneric->switch_output_qTcut > 3){ output_plot_qTcut_TSV(); }
  }
  
  logger.finished();
}


void summary_subprocess::removal_exceptional_runs_result_TSV(){
  static Logger logger("summary_subprocess::removal_exceptional_runs_result_TSV");
  logger.called();

  int x_m = 0;
  for (int i_o = 0; i_o < ycontribution->extended_directory.size(); i_o++){
    N_event_group_TSV[i_o] = accumulate(N_event_group_run_TSV[i_o].begin(), N_event_group_run_TSV[i_o].end(), 0);
    Nd_event_group_TSV[i_o] = 0.;
    for (int i_z = 0; i_z < ycontribution->extended_directory[i_o].size(); i_z++){Nd_event_group_TSV[i_o] += double(N_event_group_run_TSV[i_o][i_z]);}

    vector<vector<double> > deviation_measure_qTcut(ycontribution->output_n_qTcut, vector<double> (ycontribution->extended_directory[i_o].size(), 0.));
    //  if (n_parallel_runs_group_reference_TSV[i_o][0] > 0 && N_event_group_TSV[i_o] > 0){
    if (Nd_event_group_TSV[i_o] > 0.){
      //    if (n_parallel_runs_group_reference_TSV[i_o][0] > 0 && Nd_event_group_TSV[i_o] > 0.){
      for (int i_q = 0; i_q < ycontribution->output_n_qTcut; i_q++){
	if (n_parallel_runs_group_reference_TSV[i_o][i_q] > 0 && ygeneric->deviation_tolerance_factor != 0.){
	  //	if (ygeneric->deviation_tolerance_factor != 0.){
	  // remove runs that indicate numerical instabilities from the combination procedure
	  // (separately for each qTcut, but not for all different scales)
	  double tolerance_factor = ygeneric->deviation_tolerance_factor;
	  int x_s = osi->no_reference_TSV;
	  int x_r = (osi->n_scale_ren_TSV[x_s] - 1) / 2;
	  int x_f = (osi->n_scale_fact_TSV[x_s] - 1) / 2;
	  vector<double> deviation_measure(ycontribution->extended_directory[i_o].size(), 0.);
	  double min_deviation_measure = 1.e99;
	  double max_deviation_measure = 0.;
	  for (int i_z = 0; i_z < ycontribution->extended_directory[i_o].size(); i_z++){
	    logger << LOG_DEBUG << "result_group_run_TSV[" << setw(2) << i_o << "][" << setw(4) << i_z << "][" << setw(2) << x_m << "][" << setw(2) << i_q << "][" << setw(2) << x_s << "][" << setw(2) << x_r << "][" << setw(2) << x_f << "] = " << setw(23) << setprecision(15) << result_group_run_TSV[i_o][i_z][x_m][i_q][x_s][x_r][x_f] << " +- " << setw(23) << setprecision(15) << deviation_group_run_TSV[i_o][i_z][x_m][i_q][x_s][x_r][x_f] << "   ---   " << N_event_group_run_TSV[i_o][i_z] << endline_flush;
	    if (N_event_group_run_TSV[i_o][i_z] > 0){
	      deviation_measure[i_z] = deviation_group_run_TSV[i_o][i_z][x_m][i_q][x_s][x_r][x_f] * sqrt(N_event_group_run_TSV[i_o][i_z]);
	    }
	  }
	  for (int i_z = 0; i_z < ycontribution->extended_directory[i_o].size(); i_z++){
	    if (N_event_group_run_TSV[i_o][i_z] > 0 && deviation_measure[i_z] < min_deviation_measure && deviation_measure[i_z] != 0.){min_deviation_measure = deviation_measure[i_z];}
	    //	    if (N_event_group_run_TSV[i_o][i_z] > 0 && deviation_measure[i_z] < min_deviation_measure){min_deviation_measure = deviation_measure[i_z];}
	    if (N_event_group_run_TSV[i_o][i_z] > 0 && deviation_measure[i_z] > max_deviation_measure){max_deviation_measure = deviation_measure[i_z];}
	  }
	  N_valid_event_group_TSV[i_o][i_q] = 0;
	  for (int i_z = 0; i_z < ycontribution->extended_directory[i_o].size(); i_z++){
	    deviation_measure_qTcut[i_q][i_z] = deviation_measure[i_z] / min_deviation_measure;
	    if (deviation_measure[i_z] > tolerance_factor * min_deviation_measure){remove_group_run_qTcut_TSV[i_q][i_o][i_z] = 1;}
	    else {N_valid_event_group_TSV[i_o][i_q] += N_event_group_run_TSV[i_o][i_z];}
	  }
	}
      }
    }

    if (ygeneric->deviation_tolerance_factor != 0.){
      // information output about removed runs
      for (int i_q = 0; i_q < ycontribution->output_n_qTcut; i_q++){
	if (accumulate(remove_group_run_qTcut_TSV[i_q][i_o].begin(), remove_group_run_qTcut_TSV[i_q][i_o].end(), 0)){
	  stringstream temp_ss;
	  temp_ss << setw(8) << ycontribution->type_contribution << "   " << setw(15) << name << "   i_q = " << setw(3) << i_q << "   erased: " << setw(3) << accumulate(remove_group_run_qTcut_TSV[i_q][i_o].begin(), remove_group_run_qTcut_TSV[i_q][i_o].end(), 0) << " (" << setw(4) << n_parallel_runs_group_reference_TSV[i_o][i_q] << ")   ---   ";
	  for (int i_z = 0; i_z < ycontribution->extended_directory[i_o].size(); i_z++){
	    if (remove_group_run_qTcut_TSV[i_q][i_o][i_z]){
	      temp_ss << setprecision(3) << setw(5) << deviation_measure_qTcut[i_q][i_z] << " ";
	    }
	  }
	  logger << LOG_INFO << temp_ss.str() << endline_flush;
	}
      }
    }
  }

  logger.finished();
}


void summary_subprocess::combine_result_original_TSV(){
  static Logger logger("summary_subprocess::combine_result_original_TSV");
  logger.called();

  for (int i_o = 0; i_o < ycontribution->extended_directory.size(); i_o++){
    if (Nd_event_group_TSV[i_o] == 0.){
      //    if (n_parallel_runs_group_reference_TSV[i_o][0] == 0 || Nd_event_group_TSV[i_o] == 0.){
      for (int i_m = 0; i_m < osi->n_moments; i_m++){
	for (int i_q = 0; i_q < ycontribution->output_n_qTcut; i_q++){
	  for (int i_s = 0; i_s < osi->n_extended_set_TSV; i_s++){
	    if (!ygeneric->switch_output_scaleset[i_s]){continue;}
	    if (i_m > 0 && !osi->switch_moment_TSV[i_s]){continue;}
	    for (int i_r = 0; i_r < osi->n_scale_ren_TSV[i_s]; i_r++){
	      for (int i_f = 0; i_f < osi->n_scale_fact_TSV[i_s]; i_f++){
		// Simplify ??? is part of other case anyway...
		result_group_TSV[i_o][i_m][i_q][i_s][i_r][i_f] = 0.;
		deviation_group_TSV[i_o][i_m][i_q][i_s][i_r][i_f] = 0.;
	      }
	    }
	  }
	}
      }
    }
    else {
      for (int i_m = 0; i_m < osi->n_moments; i_m++){
	for (int i_q = 0; i_q < ycontribution->output_n_qTcut; i_q++){
	  if (n_parallel_runs_group_reference_TSV[i_o][i_q] == 0){
	    logger << LOG_INFO << name << "   " << ycontribution->type_contribution << "   n_parallel_runs_group_reference_TSV[" << i_o << "][" << i_q << "] = " << n_parallel_runs_group_reference_TSV[i_o][i_q] << endline_flush;
	    for (int i_s = 0; i_s < osi->n_extended_set_TSV; i_s++){
	      if (!ygeneric->switch_output_scaleset[i_s]){continue;}
	      if (i_m > 0 && !osi->switch_moment_TSV[i_s]){continue;}
	      for (int i_r = 0; i_r < osi->n_scale_ren_TSV[i_s]; i_r++){
		for (int i_f = 0; i_f < osi->n_scale_fact_TSV[i_s]; i_f++){
		  // Simplify ??? is part of other case anyway...
		  result_group_TSV[i_o][i_m][i_q][i_s][i_r][i_f] = 0.;
		  deviation_group_TSV[i_o][i_m][i_q][i_s][i_r][i_f] = 0.;
		}
	      }
	    }
	  }
	  else {
	    for (int i_s = 0; i_s < osi->n_extended_set_TSV; i_s++){
	      if (!ygeneric->switch_output_scaleset[i_s]){continue;}
	      if (i_m > 0 && !osi->switch_moment_TSV[i_s]){continue;}
	      for (int i_r = 0; i_r < osi->n_scale_ren_TSV[i_s]; i_r++){
		for (int i_f = 0; i_f < osi->n_scale_fact_TSV[i_s]; i_f++){
		  result_group_TSV[i_o][i_m][i_q][i_s][i_r][i_f] = 0.;
		  deviation_group_TSV[i_o][i_m][i_q][i_s][i_r][i_f] = 0.;
		  double dev = 0.;
		  double res = 0.;
		  for (int i_z = 0; i_z < ycontribution->extended_directory[i_o].size(); i_z++){
		    // simplify !!!
		    if (remove_group_run_qTcut_TSV[i_q][i_o][i_z]){
		      res += 0.;
		      dev += 0.;
		    }
		    else if (N_event_group_run_TSV[i_o][i_z] != 0 && result_group_run_TSV[i_o][i_z][i_m][i_q][i_s][i_r][i_f] != 0. && deviation_group_run_TSV[i_o][i_z][i_m][i_q][i_s][i_r][i_f] != 0.){
		      res += N_event_group_run_TSV[i_o][i_z] * result_group_run_TSV[i_o][i_z][i_m][i_q][i_s][i_r][i_f];
		      dev += pow((N_event_group_run_TSV[i_o][i_z] - 1) * deviation_group_run_TSV[i_o][i_z][i_m][i_q][i_s][i_r][i_f], 2) + N_event_group_run_TSV[i_o][i_z] * pow(result_group_run_TSV[i_o][i_z][i_m][i_q][i_s][i_r][i_f], 2);
		    }
		    else if (result_group_run_TSV[i_o][i_z][i_m][i_q][i_s][i_r][i_f] == 0. && deviation_group_run_TSV[i_o][i_z][i_m][i_q][i_s][i_r][i_f] == 0.){
		      res += 0.;
		      dev += 0.;
		    }
		    else {logger << LOG_FATAL << "Should not happen!" << endline_flush;}
		  }
		  if (N_valid_event_group_TSV[i_o][i_q] != 0 && res != 0. && dev != 0.){
		    deviation_group_TSV[i_o][i_m][i_q][i_s][i_r][i_f] = sqrt((N_valid_event_group_TSV[i_o][i_q] * dev - pow(res , 2)) / N_valid_event_group_TSV[i_o][i_q]) / (N_valid_event_group_TSV[i_o][i_q] - 1);
		    result_group_TSV[i_o][i_m][i_q][i_s][i_r][i_f] = res / N_valid_event_group_TSV[i_o][i_q];
		  }
		  else {
		    result_group_TSV[i_o][i_m][i_q][i_s][i_r][i_f] = 0.;
		    deviation_group_TSV[i_o][i_m][i_q][i_s][i_r][i_f] = 0.;
		  }
		}
	      }
	    }
	  }
	}
      }
    }
  }

  logger.finished();
}





// All functions below are only relevant for CV variation:

void summary_subprocess::readin_result_CV(string & result_moment){
  static Logger logger("summary_subprocess::readin_result_CV");
  logger.called();

  for (int i_z = 0; i_z < n_seed; i_z++){
    string result_file = result_moment + "_" + name + ".dat";
    logger << LOG_DEBUG_VERBOSE << "result_file = " << result_file << endline_flush;
    string filename = "../" + ycontribution->directory[i_z] + "/result/" + result_file;
    logger << LOG_DEBUG << "Input:   filename = " << filename << endline_flush;
    vector<string> readin;
    get_data(filename, readin);
    if (readin.size() > default_size_CV){readin.erase(readin.begin() + default_size_CV, readin.end());}

    if (readin.size() == default_size_CV){
      used_n_event_run[i_z] = atoll(readin[0].c_str());
      N_event_run_CV[i_z] = atoll(readin[0].c_str());

      result_run[i_z] = atof(readin[1].c_str());
      deviation_run[i_z] = atof(readin[2].c_str());
      int proc = 3;

      for (int i_q = 0; i_q < ycontribution->output_n_qTcut; i_q++){
	for (int i_s = 0; i_s < osi->n_scales_CV; i_s++){
	  result_run_CV[i_q][i_s][i_z] = atof(readin[proc + 2 * (i_s + osi->n_scales_CV * i_q)].c_str());
	  deviation_run_CV[i_q][i_s][i_z] = atof(readin[proc + 1 + 2 * (i_s + osi->n_scales_CV * i_q)].c_str());
	  //	  logger << LOG_INFO << setw(20) << name << setw(15) << ycontribution->type_contribution << "   result_run_CV[" << i_q << "][" << i_s << "][" << i_z << "] = " << result_run_CV[i_q][i_s][i_z] << " +/- " << deviation_run_CV[i_q][i_s][i_z] << endline_flush;
	}
      }
    }
    else {
      if (readin.size() != 0){logger << LOG_ERROR << result_file << "   error" << endline_flush;}
      else {logger << LOG_DEBUG << result_file << "   empty" << endline_flush;}
      used_n_event_run[i_z] = 0;
      N_event_run_CV[i_z] = 0;
      result_run[i_z] = 0.;
      deviation_run[i_z] = 0.;
      for (int i_q = 0; i_q < ycontribution->output_n_qTcut; i_q++){
	for (int i_s = 0; i_s < osi->n_scales_CV; i_s++){
	  result_run_CV[i_q][i_s][i_z] = 0.;
	  deviation_run_CV[i_q][i_s][i_z] = 0.;
	}
      }
    }
  }

  int x_q = 0;
  int x_s = (osi->n_scales_CV - 1) / 2;

  for (int i_z = 0; i_z < n_seed; i_z++){
    if (N_event_run_CV[i_z] > 0){
      logger << LOG_DEBUG << setw(20) << name << setw(15) << ycontribution->type_contribution << "   result_run_CV[" << x_q << "][" << x_s << "][" << i_z << "] = " << result_run_CV[x_q][x_s][i_z] << " +/- " << deviation_run_CV[x_q][x_s][i_z] << endline_flush;
    }
  }

  logger.finished();
}


void summary_subprocess::combination_result_CV(string & result_moment){
  static Logger logger("summary_subprocess::combination_result_CV");
  logger.called();

  logger << LOG_DEBUG << left << name << endline_flush;

  int x_s = (osi->n_scales_CV - 1) / 2;

  for (int i_q = 0; i_q < ycontribution->output_n_qTcut; i_q++){
    n_parallel_runs_reference_CV[i_q] = 0;
    for (int i_z = 0; i_z < ycontribution->directory.size(); i_z++){
      logger << LOG_DEBUG_VERBOSE << "N_event_run_CV[" << setw(4) << i_z << "] = " << N_event_run_CV[i_z] << endline_flush;
      if (N_event_run_CV[i_z] != 0 &&
	  result_run_CV[i_q][x_s][i_z] != 0. &&
	  deviation_run_CV[i_q][x_s][i_z] != 0.){
	n_parallel_runs_reference_CV[i_q]++;
	if (!remove_run_qTcut_CV[i_q][i_z]){
	  n_valid_parallel_runs_reference_CV[i_q]++;
	}
      }
    }
  }

  removal_exceptional_runs_result_CV();
  combine_result_original_CV();
  /*
  if (ygeneric->average_factor == 0){combine_result_alternative_CV();}  // bug: results zero !!!
  else if (ygeneric->average_factor == 1){combine_result_original_CV();}  // removal of exceptional runs included
  else {combine_result_hybrid_CV();}  // removal of exceptional runs not included !!!
  */
  
  // higher qTcut-values are identified with i_q = 0 (for qTcut independent runs); could be improved...
  if (ycontribution->output_n_qTcut < osi->n_qTcut){
    for (int i_q = ycontribution->output_n_qTcut; i_q < osi->n_qTcut; i_q++){
      for (int i_s = 0; i_s < osi->n_scales_CV; i_s++){
	result_CV[i_q][i_s] = result_CV[0][i_s];
	deviation_CV[i_q][i_s] = deviation_CV[0][i_s];
      }
    }
  }

  for (int i_q = 0; i_q < ycontribution->output_n_qTcut; i_q++){
    for (int i_s = 0; i_s < osi->n_scales_CV; i_s++){
      for (int i_z = 0; i_z < ycontribution->directory.size(); i_z++){
	if (N_event_run_CV[i_z] != 0 &&
	    result_run_CV[i_q][i_s][i_z] != 0. &&
	    deviation_run_CV[i_q][i_s][i_z] != 0.){
	  n_parallel_runs_CV[i_q][i_s]++;
	  if (!remove_run_qTcut_CV[i_q][i_z]){
	    n_valid_parallel_runs_CV[i_q][i_s]++;
	  }
	}
      }

      chi2_CV[i_q][i_s] = 0.;
      if (n_parallel_runs_CV[i_q][i_s] > 1){
	for (int i_z = 0; i_z < ycontribution->directory.size(); i_z++){
	  if (!(result_run_CV[i_q][i_s][i_z] == 0. && deviation_run_CV[i_q][i_s][i_z] == 0.)){
	    chi2_CV[i_q][i_s] += pow((result_run_CV[i_q][i_s][i_z] - result_CV[i_q][i_s]) / deviation_run_CV[i_q][i_s][i_z], 2.);
	  }
	}
	chi2_CV[i_q][i_s] = chi2_CV[i_q][i_s] / n_parallel_runs_CV[i_q][i_s];
      }
    }
  }

  logger.finished();
}


void summary_subprocess::removal_exceptional_runs_result_CV(){
  static Logger logger("summary_subprocess::removal_exceptional_runs_result_CV");
  logger.called();

  N_event_CV = accumulate(N_event_run_CV.begin(), N_event_run_CV.end(), 0);
  //  Nd_event_CV = accumulate(N_event_run_CV.begin(), N_event_run_CV.end(), 0);
  Nd_event_CV = 0.;
  for (int i_z = 0; i_z < n_seed; i_z++){
    Nd_event_CV += double(N_event_run_CV[i_z]);
  }

  vector<vector<double> > deviation_measure_qTcut(osi->n_qTcut, vector<double> (n_seed, 0.));

  //  if (n_parallel_runs_reference_CV[0] > 0 && N_event_CV > 0){
  if (n_parallel_runs_reference_CV[0] > 0 && Nd_event_CV > 0.){
    for (int i_q = 0; i_q < ycontribution->output_n_qTcut; i_q++){
      if (ygeneric->deviation_tolerance_factor != 0.){
	// remove runs that indicate numerical instabilities from the combination procedure
	// (separately for each qTcut, but not for all different scales)
	double tolerance_factor = ygeneric->deviation_tolerance_factor;
	int i_s = 0;
	if (osi->switch_CV == 1 || osi->switch_CV == 2 || osi->switch_CV == 3 || osi->switch_CV == 4){i_s = (osi->n_scales_CV - 1) / 2;}
	else if (osi->switch_CV == 5){i_s = 3;}
	else if (osi->switch_CV == 6){i_s = 4;}
	else {logger << LOG_FATAL << "Illegal value of switch_CV = " << osi->switch_CV << "."; exit(1);}
	vector<double> deviation_measure(n_seed, 0.);
	double min_deviation_measure = 1.e99;
	double max_deviation_measure = 0.;
	for (int i_z = 0; i_z < n_seed; i_z++){
	  if (N_event_run_CV[i_z] > 0){
	    deviation_measure[i_z] = deviation_run_CV[i_q][i_s][i_z] * sqrt(N_event_run_CV[i_z]);
	  }
	}
	for (int i_z = 0; i_z < n_seed; i_z++){
	  if (N_event_run_CV[i_z] > 0 && deviation_measure[i_z] < min_deviation_measure){min_deviation_measure = deviation_measure[i_z];}
	  if (N_event_run_CV[i_z] > 0 && deviation_measure[i_z] > max_deviation_measure){max_deviation_measure = deviation_measure[i_z];}
	}
	N_valid_event_CV[i_q] = 0;
	for (int i_z = 0; i_z < n_seed; i_z++){
	  deviation_measure_qTcut[i_q][i_z] = deviation_measure[i_z] / min_deviation_measure;
	  if (deviation_measure[i_z] > tolerance_factor * min_deviation_measure){remove_run_qTcut_CV[i_q][i_z] = 1;}
	  else {N_valid_event_CV[i_q] += N_event_run_CV[i_z];}
	  ///	  logger << LOG_INFO << left << setw(10) << ycontribution->type_contribution << setw(20) << name << "   N_valid_event_CV[" << setw(3) << i_q << "] = " << N_valid_event_CV[i_q] << "   N_event_run_CV[" << i_z << "] = " << N_event_run_CV[i_z] << endline_flush;
	}
      }
    }
  }

  logger.finished();
}


void summary_subprocess::combine_result_original_CV(){
  static Logger logger("summary_subprocess::combine_result_original_CV");
  logger.called();

  if (n_parallel_runs_reference_CV[0] == 0 || Nd_event_CV == 0.){
    //  if (n_parallel_runs_reference_CV[0] == 0 || N_event_CV == 0){
    for (int i_q = 0; i_q < ycontribution->output_n_qTcut; i_q++){
      for (int i_s = 0; i_s < osi->n_scales_CV; i_s++){
	result_CV[i_q][i_s] = 0.;
	deviation_CV[i_q][i_s] = 0.;
      }
    }
  }
  else {
    for (int i_q = 0; i_q < ycontribution->output_n_qTcut; i_q++){
      for (int i_s = 0; i_s < osi->n_scales_CV; i_s++){
	result_CV[i_q][i_s] = 0.;
	deviation_CV[i_q][i_s] = 0.;

	double dev = 0.;
	double res = 0.;
	for (int i_z = 0; i_z < n_seed; i_z++){
	  if (remove_run_qTcut_CV[i_q][i_z]){
	    res += 0.;
	    dev += 0.;
	    logger << LOG_DEBUG_VERBOSE << "removed: result_run_CV[" << i_s << "][" << i_q << "][" << i_z << "] = " << setw(23) << setprecision(15) << result_run_CV[i_q][i_s][i_z] << " +- = " << setw(23) << setprecision(15) << deviation_run_CV[i_q][i_s][i_z] << endline_flush;
	  }
	  else if (N_event_run_CV[i_z] != 0 && result_run_CV[i_q][i_s][i_z] != 0. && deviation_run_CV[i_q][i_s][i_z] != 0.){
	    logger << LOG_DEBUG_VERBOSE << "normal:  result_run_CV[" << i_s << "][" << i_q << "][" << i_z << "] = " << setw(23) << setprecision(15) << result_run_CV[i_q][i_s][i_z] << " +- = " << setw(23) << setprecision(15) << deviation_run_CV[i_q][i_s][i_z] << endline_flush;

	    res += N_event_run_CV[i_z] * result_run_CV[i_q][i_s][i_z];
	    dev += pow((N_event_run_CV[i_z] - 1) * deviation_run_CV[i_q][i_s][i_z], 2) + N_event_run_CV[i_z] * pow(result_run_CV[i_q][i_s][i_z], 2);
	  }
	  else if (result_run_CV[i_q][i_s][i_z] == 0. && deviation_run_CV[i_q][i_s][i_z] == 0.){
	    res += 0.;
	    dev += 0.;
	  }
	  else {
	    logger << LOG_FATAL << name << endline_flush;
	    logger << LOG_FATAL << "N[" << i_z << "] = " << N_event_run_CV[i_z] << endline_flush;
	    logger << LOG_FATAL << "result_run_CV[" << i_q << "][" << i_s << "][" << i_z << "] = " << result_run_CV[i_q][i_s][i_z] << endline_flush;
	    logger << LOG_FATAL << "deviation_run_CV[" << i_q << "][" << i_s << "][" << i_z << "] = " << deviation_run_CV[i_q][i_s][i_z] << endline_flush;
	    logger << LOG_FATAL << "Should not happen!" << endline_flush;
	  }
	}

	if (N_valid_event_CV[i_q] != 0 && res != 0. && dev != 0.){
	  deviation_CV[i_q][i_s] = sqrt((N_valid_event_CV[i_q] * dev - pow(res, 2)) / N_valid_event_CV[i_q]) / (N_valid_event_CV[i_q] - 1);
	  result_CV[i_q][i_s] = res / N_valid_event_CV[i_q];
	}
	else {
	  result_CV[i_q][i_s] = 0.;
	  deviation_CV[i_q][i_s] = 0.;
	}
      }
    }
  }

  if (ycontribution->output_n_qTcut < osi->n_qTcut){
    for (int i_q = ycontribution->output_n_qTcut; i_q < osi->n_qTcut; i_q++){
      for (int i_s = 0; i_s < osi->n_scales_CV; i_s++){
	result_CV[i_q][i_s] = result_CV[0][i_s];
	deviation_CV[i_q][i_s] = deviation_CV[0][i_s];
      }
    }
  }

  logger.finished();
}

