#!/usr/bin/env python3

import pathlib
import os

flist = [p for p in pathlib.Path('remainders/').glob('**/*.hpp') if not p.match('*coefficients.hpp')]

flist = sorted(['#include "'+str(p)+'"' for p in flist])

flist = '\n'.join(flist)

content = '''\
#pragma once

#include "RemainderEvaluator.h"
#include "MathList.h"

namespace FivePointAmplitudes {

''' + flist + '''

}\
'''

cpplist  = [p for p in pathlib.Path('remainders/').glob('**/*.cpp')]

cpplist = sorted(['\''+str(p) + '\',' for p in cpplist])
cpplist = '\n'.join(cpplist)

mesonbuild = '''\
FivePointAmplitudes_sources += [
''' + cpplist + '''
]
'''

with open('src/RemaindersList.h','w') as f :
    f.write(content)

with open('src/meson.build','w') as f :
    f.write(mesonbuild)
