#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_100(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[23];
z[0] = iW[1];
z[1] = iW[2];
z[2] = iW[5];
z[3] = iW[16];
z[4] = v[0];
z[5] = v[4];
z[6] = v[3];
z[7] = iW[3];
z[8] = v[2];
z[9] = v[1];
z[10] = prod_pow(z[0], 2);
z[11] = z[5] * z[10];
z[12] = 3 * z[0];
z[13] = z[11] + -z[12];
z[13] = z[5] * z[13];
z[13] = 3 + z[13];
z[13] = z[5] * z[13];
z[13] = -z[9] + z[13];
z[14] = (T(1) / T(2)) * z[1];
z[13] = z[13] * z[14];
z[15] = (T(1) / T(2)) * z[5];
z[10] = z[10] * z[15];
z[16] = -z[0] + z[10];
z[16] = z[5] * z[16];
z[16] = T(1) / T(2) + z[16];
z[17] = -z[13] + z[16];
z[14] = z[14] * z[17];
z[13] = -z[13] + 5 * z[16];
z[17] = -z[0] + (T(1) / T(3)) * z[11];
z[17] = z[5] * z[17];
z[17] = 1 + z[17];
z[17] = z[5] * z[17];
z[17] = (T(-1) / T(3)) * z[9] + z[17];
z[17] = z[7] * z[17];
z[13] = (T(1) / T(2)) * z[13] + z[17];
z[13] = z[7] * z[13];
z[17] = (T(7) / T(3)) * z[16] + (T(5) / T(2)) * z[17];
z[18] = prod_pow(z[7], 2);
z[17] = z[17] * z[18];
z[19] = (T(1) / T(3)) * z[8];
z[20] = prod_pow(z[7], 3) * z[19];
z[21] = 2 * z[0] + -z[11];
z[21] = z[5] * z[21];
z[21] = -1 + z[21];
z[21] = z[20] * z[21];
z[17] = z[17] + z[21];
z[17] = z[8] * z[17];
z[13] = z[13] + z[14] + z[17];
z[13] = z[4] * z[13];
z[14] = -z[0] + (T(7) / T(3)) * z[11];
z[14] = z[14] * z[15];
z[17] = (T(5) / T(3)) * z[7];
z[21] = z[0] * z[5];
z[22] = -2 + z[21];
z[22] = z[5] * z[22];
z[22] = z[9] + z[22];
z[17] = z[17] * z[22];
z[14] = T(-2) / T(3) + z[14] + z[17];
z[14] = z[7] * z[14];
z[14] = (T(7) / T(6)) * z[11] + z[14];
z[14] = z[7] * z[14];
z[17] = 1 + -z[21];
z[17] = z[7] * z[17];
z[17] = -z[11] + 2 * z[17];
z[17] = z[17] * z[18] * z[19];
z[14] = z[14] + z[17];
z[14] = z[8] * z[14];
z[17] = (T(1) / T(2)) * z[7];
z[19] = 9 * z[0] + (T(-5) / T(3)) * z[11];
z[19] = z[5] * z[19];
z[19] = -13 + z[19];
z[19] = z[5] * z[19];
z[19] = (T(17) / T(3)) * z[9] + z[19];
z[19] = z[17] * z[19];
z[21] = 11 * z[0] + (T(-5) / T(2)) * z[11];
z[21] = z[5] * z[21];
z[21] = T(-17) / T(2) + z[21];
z[19] = z[19] + (T(1) / T(3)) * z[21];
z[19] = z[7] * z[19];
z[14] = (T(5) / T(4)) * z[11] + z[14] + z[19];
z[14] = z[8] * z[14];
z[16] = z[1] * z[16];
z[16] = z[0] + -z[11] + z[16];
z[16] = z[1] * z[5] * z[16];
z[16] = z[10] + z[16];
z[16] = z[6] * z[16];
z[19] = 7 * z[0] + -3 * z[11];
z[19] = z[15] * z[19];
z[10] = z[10] + -z[12];
z[10] = z[5] * z[10];
z[10] = T(9) / T(2) + z[10];
z[10] = z[10] * z[15];
z[10] = -z[9] + z[10];
z[10] = z[1] * z[10];
z[11] = 4 * z[0] + -z[11];
z[11] = z[5] * z[11];
z[11] = -5 + z[11];
z[11] = z[5] * z[11];
z[11] = 2 * z[9] + z[11];
z[11] = z[7] * z[11];
z[10] = -2 + z[10] + (T(1) / T(3)) * z[11] + z[13] + z[14] + (T(1) / T(2)) * z[16] + z[19];
z[10] = z[4] * z[10];
z[11] = z[5] + -z[9];
z[12] = z[7] * z[11];
z[13] = T(19) / T(6) + 5 * z[12];
z[13] = z[13] * z[17];
z[14] = -1 + (T(5) / T(3)) * z[12];
z[14] = z[14] * z[18];
z[14] = (T(1) / T(2)) * z[14] + -z[20];
z[14] = z[8] * z[14];
z[13] = z[13] + z[14];
z[13] = z[8] * z[13];
z[12] = 7 + (T(11) / T(3)) * z[12];
z[12] = (T(1) / T(4)) * z[12] + z[13];
z[12] = z[8] * z[12];
z[10] = z[10] + (T(-3) / T(4)) * z[11] + z[12];
return z[2] * z[3] * z[4] * z[10];
}



template double eval_coef_2q3y_2l_pmmpp_12345_100(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_100(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
