#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_103(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[32];
z[0] = iW[0];
z[1] = iW[1];
z[2] = iW[9];
z[3] = v[3];
z[4] = v[4];
z[5] = v[2];
z[6] = iW[3];
z[7] = iW[22];
z[8] = iW[15];
z[9] = v[0];
z[10] = iW[14];
z[11] = v[1];
z[12] = z[5] * z[7];
z[13] = 1 + z[12];
z[14] = z[6] * z[13];
z[15] = z[6] * z[7];
z[16] = z[4] * z[15];
z[14] = z[7] + -z[14] + z[16];
z[17] = (T(1) / T(2)) * z[4];
z[14] = z[14] * z[17];
z[18] = z[0] * z[3];
z[19] = 3 * z[12];
z[20] = T(-31) / T(6) + -z[19];
z[14] = z[14] + z[18] + (T(1) / T(2)) * z[20];
z[14] = z[4] * z[14];
z[20] = z[5] * z[18];
z[21] = T(-7) / T(12) + -z[12];
z[21] = z[3] * z[21];
z[14] = z[14] + (T(-1) / T(2)) * z[20] + z[21];
z[14] = z[4] * z[14];
z[21] = prod_pow(z[5], 2);
z[22] = z[13] * z[21];
z[23] = z[3] * z[5];
z[24] = T(-13) / T(6) + -z[12];
z[24] = z[23] * z[24];
z[24] = -z[22] + z[24];
z[24] = z[3] * z[24];
z[23] = z[4] * z[23];
z[23] = (T(-19) / T(6)) * z[23] + z[24];
z[24] = (T(1) / T(2)) * z[8];
z[23] = z[23] * z[24];
z[25] = -1 + z[18];
z[25] = z[4] * z[25];
z[25] = z[3] + -z[9] + z[25];
z[26] = prod_pow(z[4], 2) * z[2];
z[25] = z[25] * z[26];
z[27] = z[3] * z[7];
z[28] = (T(1) / T(2)) * z[21];
z[29] = z[27] * z[28];
z[14] = z[14] + z[23] + (T(-1) / T(2)) * z[25] + z[29];
z[14] = z[1] * z[14];
z[13] = z[13] * z[28];
z[23] = T(1) / T(3) + -z[19];
z[23] = z[5] * z[23];
z[28] = T(-13) / T(12) + -z[12];
z[28] = z[3] * z[28];
z[23] = (T(1) / T(2)) * z[23] + z[28];
z[23] = z[3] * z[23];
z[28] = -17 * z[3] + (T(7) / T(3)) * z[5];
z[28] = (T(-19) / T(3)) * z[4] + (T(1) / T(2)) * z[28];
z[28] = z[17] * z[28];
z[23] = -z[13] + z[23] + z[28];
z[23] = z[8] * z[23];
z[28] = T(11) / T(3) + z[12];
z[29] = (T(-19) / T(12)) * z[0] + z[6] + (T(-1) / T(2)) * z[7] + -z[16];
z[29] = z[4] * z[29];
z[28] = (T(7) / T(3)) * z[18] + (T(1) / T(2)) * z[28] + z[29];
z[28] = z[4] * z[28];
z[29] = z[0] * z[4];
z[18] = T(7) / T(3) + -3 * z[18] + (T(19) / T(3)) * z[29];
z[30] = (T(1) / T(4)) * z[4];
z[18] = z[18] * z[30];
z[18] = -z[3] + (T(-3) / T(4)) * z[9] + z[18];
z[18] = z[4] * z[18];
z[18] = z[18] + (T(-1) / T(4)) * z[25];
z[18] = z[2] * z[18];
z[25] = z[7] * z[21];
z[31] = -z[5] * z[10];
z[31] = -1 + z[31];
z[31] = z[9] * z[31];
z[25] = z[25] + z[31];
z[31] = T(7) / T(3) + z[12];
z[31] = z[3] * z[31];
z[14] = z[14] + z[18] + (T(-11) / T(6)) * z[20] + z[23] + (T(1) / T(2)) * z[25] + z[28] + z[31];
z[14] = z[1] * z[14];
z[18] = z[3] + z[5];
z[20] = z[0] * z[18];
z[23] = T(-19) / T(6) + -z[20] + (T(25) / T(6)) * z[29];
z[23] = z[4] * z[23];
z[18] = -z[9] + z[18];
z[25] = 1 + -z[20];
z[25] = z[4] * z[25];
z[25] = z[18] + z[25];
z[25] = z[2] * z[17] * z[25];
z[18] = (T(-1) / T(2)) * z[18] + z[23] + z[25];
z[18] = z[2] * z[18];
z[15] = z[15] * z[21];
z[21] = z[7] + z[10];
z[21] = z[5] * z[21];
z[23] = z[9] * z[10];
z[15] = T(-1) / T(2) + z[15] + z[18] + z[21] + z[23];
z[18] = -1 + -z[19] + -z[27];
z[18] = z[3] * z[18];
z[19] = -1 + (T(-3) / T(2)) * z[12];
z[19] = z[5] * z[19];
z[18] = (T(1) / T(2)) * z[18] + z[19];
z[18] = z[3] * z[18];
z[13] = -z[13] + z[18];
z[13] = z[0] * z[13];
z[18] = T(13) / T(2) + -z[20] + -z[29];
z[17] = z[17] * z[18];
z[18] = -1 + -z[29];
z[18] = z[18] * z[26];
z[19] = -z[5] + -z[11];
z[19] = z[3] + (T(1) / T(2)) * z[19];
z[13] = z[13] + z[17] + (T(19) / T(12)) * z[18] + (T(7) / T(6)) * z[19];
z[13] = z[13] * z[24];
z[17] = z[6] * z[22];
z[18] = z[3] * z[12];
z[17] = z[17] + z[18];
z[18] = T(2) / T(3) + (T(-1) / T(2)) * z[12];
z[18] = z[5] * z[18];
z[17] = (T(-1) / T(4)) * z[17] + z[18];
z[17] = z[0] * z[17];
z[12] = -1 + z[12];
z[12] = z[6] * z[12];
z[12] = z[12] + z[16];
z[12] = z[12] * z[30];
return z[12] + z[13] + (T(1) / T(2)) * z[14] + (T(1) / T(4)) * z[15] + z[17];
}



template double eval_coef_2q3y_2l_pmmpp_12345_103(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_103(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
