#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_112(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[32];
z[0] = iW[1];
z[1] = iW[3];
z[2] = iW[5];
z[3] = v[0];
z[4] = v[4];
z[5] = iW[17];
z[6] = v[2];
z[7] = iW[21];
z[8] = v[3];
z[9] = iW[12];
z[10] = iW[15];
z[11] = iW[18];
z[12] = z[1] * z[3];
z[13] = z[8] * z[10];
z[14] = z[12] + -z[13];
z[14] = z[4] * z[14];
z[15] = z[7] * z[14];
z[16] = z[5] * z[8];
z[17] = prod_pow(z[16], 2);
z[15] = -z[15] + z[17];
z[18] = z[2] * z[3];
z[19] = T(3) / T(2) + -z[18];
z[19] = z[12] * z[19];
z[20] = T(1) / T(2) + z[13];
z[20] = z[8] * z[20];
z[21] = prod_pow(z[3], 2);
z[22] = z[1] * z[21];
z[23] = z[20] + z[22];
z[24] = (T(1) / T(2)) * z[7];
z[23] = z[23] * z[24];
z[15] = T(-1) / T(4) + (T(1) / T(4)) * z[15] + z[19] + z[23];
z[15] = z[4] * z[15];
z[19] = 1 + z[13];
z[19] = z[8] * z[19];
z[19] = z[3] + z[19];
z[23] = -z[19] + -z[22];
z[23] = z[23] * z[24];
z[25] = -1 + z[18];
z[26] = z[2] * z[22];
z[23] = -z[16] + z[23] + -z[25] + z[26];
z[23] = z[4] * z[23];
z[26] = -z[19] * z[24];
z[25] = -z[25] + z[26];
z[25] = z[8] * z[25];
z[21] = z[11] * z[21];
z[21] = (T(1) / T(2)) * z[21];
z[26] = prod_pow(z[8], 2) * z[5];
z[23] = z[21] + z[23] + z[25] + -z[26];
z[23] = z[4] * z[23];
z[25] = (T(1) / T(2)) * z[8];
z[19] = -z[19] * z[25];
z[19] = z[19] + z[23];
z[23] = (T(1) / T(2)) * z[5];
z[25] = 5 + z[16];
z[25] = z[23] * z[25];
z[27] = (T(3) / T(2)) * z[1];
z[23] = z[9] + z[23] + z[27];
z[28] = z[4] * z[5];
z[23] = z[23] * z[28];
z[23] = z[9] + z[23] + z[25];
z[23] = z[4] * z[23];
z[25] = (T(-1) / T(4)) * z[5] + 2 * z[9];
z[29] = -z[5] * z[25];
z[30] = (T(3) / T(4)) * z[1];
z[31] = -z[9] + -z[30];
z[31] = prod_pow(z[5], 2) * z[4] * z[31];
z[29] = z[29] + z[31];
z[29] = z[4] * z[29];
z[29] = z[5] + -z[9] + z[29];
z[29] = z[6] * z[29];
z[23] = 2 * z[16] + z[23] + z[29];
z[23] = z[6] * z[23];
z[29] = -1 + (T(1) / T(4)) * z[16];
z[29] = z[5] * z[29];
z[29] = z[29] + -z[30];
z[29] = z[4] * z[29];
z[17] = -7 + z[17];
z[17] = (T(1) / T(4)) * z[17] + z[29];
z[17] = z[4] * z[17];
z[17] = -z[8] + z[17] + z[23] + z[26];
z[17] = z[6] * z[17];
z[17] = z[17] + (T(1) / T(2)) * z[19];
z[17] = z[0] * z[17];
z[19] = (T(5) / T(2)) * z[3] + z[20] + -z[21];
z[20] = -z[25] + -z[27];
z[20] = z[20] * z[28];
z[20] = -z[9] + z[20];
z[20] = z[6] * z[20];
z[16] = 1 + z[16];
z[16] = z[5] * z[16];
z[16] = 3 * z[1] + z[16];
z[16] = z[4] * z[16];
z[16] = 1 + (T(1) / T(2)) * z[16] + z[20];
z[16] = z[6] * z[16];
z[15] = z[15] + z[16] + z[17] + (T(1) / T(2)) * z[19];
z[15] = z[0] * z[15];
z[16] = z[6] * z[12];
z[14] = z[14] + z[16] + -z[22];
z[14] = z[14] * z[24];
z[16] = T(-5) / T(2) + z[18];
z[12] = z[12] * z[16];
z[12] = z[12] + (T(-1) / T(2)) * z[13] + z[14] + z[18];
return (T(1) / T(2)) * z[12] + z[15];
}



template double eval_coef_2q3y_2l_pmmpp_12345_112(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_112(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
