#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_116(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[30];
z[0] = iW[1];
z[1] = iW[2];
z[2] = iW[5];
z[3] = v[0];
z[4] = v[3];
z[5] = v[4];
z[6] = iW[3];
z[7] = iW[12];
z[8] = iW[15];
z[9] = iW[22];
z[10] = v[2];
z[11] = iW[4];
z[12] = (T(1) / T(2)) * z[6];
z[13] = prod_pow(z[5], 2);
z[14] = z[12] * z[13];
z[15] = (T(1) / T(2)) * z[4];
z[16] = z[5] + z[15];
z[17] = z[14] + z[16];
z[17] = z[10] * z[17];
z[18] = 3 * z[6];
z[19] = prod_pow(z[5], 3);
z[20] = z[18] * z[19];
z[21] = z[13] + z[20];
z[22] = -z[4] + -2 * z[5];
z[22] = z[4] * z[22];
z[21] = (T(-3) / T(2)) * z[17] + (T(1) / T(4)) * z[21] + z[22];
z[21] = z[10] * z[21];
z[22] = (T(3) / T(2)) * z[13];
z[23] = z[4] * z[5];
z[24] = z[22] + z[23];
z[24] = z[4] * z[24];
z[25] = (T(1) / T(2)) * z[19];
z[24] = z[24] + -z[25];
z[21] = z[21] + (T(1) / T(2)) * z[24];
z[21] = z[0] * z[21];
z[12] = -z[12] * z[19];
z[12] = z[12] + -z[13] + 3 * z[17];
z[17] = (T(1) / T(2)) * z[0];
z[12] = z[12] * z[17];
z[24] = (T(1) / T(4)) * z[6];
z[24] = z[13] * z[24];
z[12] = (T(3) / T(4)) * z[4] + z[5] + z[12] + z[24];
z[12] = z[3] * z[12];
z[26] = -z[6] * z[19];
z[26] = z[13] + z[26];
z[27] = z[6] * z[13];
z[27] = z[5] + -z[15] + z[27];
z[28] = (T(1) / T(2)) * z[10];
z[27] = z[27] * z[28];
z[29] = -z[4] + (T(-3) / T(2)) * z[5];
z[29] = z[4] * z[29];
z[12] = z[12] + z[21] + (T(1) / T(4)) * z[26] + z[27] + z[29];
z[12] = z[0] * z[12];
z[21] = z[16] + z[24];
z[12] = z[12] + z[21];
z[12] = z[3] * z[12];
z[20] = 5 * z[13] + z[20];
z[14] = z[5] + z[14];
z[14] = z[4] + 3 * z[14];
z[24] = -z[10] * z[14];
z[20] = (T(1) / T(2)) * z[20] + z[23] + z[24];
z[20] = z[20] * z[28];
z[24] = z[4] + z[5];
z[26] = z[4] * z[24];
z[26] = (T(-5) / T(2)) * z[13] + z[26];
z[26] = z[4] * z[26];
z[27] = z[4] + 3 * z[5];
z[27] = z[4] * z[27];
z[22] = z[22] + z[27];
z[22] = z[10] * z[22];
z[22] = (T(-3) / T(2)) * z[19] + z[22] + z[26];
z[22] = z[10] * z[22];
z[26] = prod_pow(z[4], 2);
z[27] = -z[5] * z[26];
z[19] = z[19] + z[27];
z[19] = z[4] * z[19];
z[19] = z[19] + z[22];
z[19] = z[17] * z[19];
z[22] = z[4] * z[16];
z[22] = -z[13] + z[22];
z[22] = z[4] * z[22];
z[19] = z[19] + z[20] + z[22] + -z[25];
z[19] = z[0] * z[19];
z[15] = -z[15] * z[24];
z[20] = -z[10] * z[21];
z[12] = z[12] + z[13] + z[15] + z[19] + z[20];
z[12] = z[7] * z[8] * z[9] * z[12];
z[14] = -z[0] * z[14];
z[14] = T(-1) / T(2) + z[14];
z[14] = z[0] * z[14];
z[14] = z[14] + z[18];
z[12] = z[12] + (T(1) / T(2)) * z[14];
z[12] = z[3] * z[12];
z[14] = z[13] + z[23];
z[15] = z[14] * z[17];
z[15] = z[15] + -z[16];
z[15] = z[0] * z[15];
z[15] = T(1) / T(2) + z[15];
z[15] = z[3] * z[15];
z[14] = z[0] * z[4] * z[14];
z[14] = z[14] + -z[23];
z[14] = z[14] * z[17];
z[14] = z[14] + -z[15];
z[14] = z[1] * z[14];
z[16] = -3 * z[13] + -z[23];
z[16] = z[0] * z[16];
z[19] = z[4] + 11 * z[5];
z[16] = z[16] + (T(1) / T(2)) * z[19];
z[16] = z[0] * z[16];
z[13] = z[13] * z[18];
z[13] = -z[5] + z[13];
z[17] = z[13] * z[17];
z[18] = z[5] * z[18];
z[17] = T(1) / T(2) + z[17] + -z[18];
z[17] = z[0] * z[17];
z[17] = (T(3) / T(2)) * z[6] + z[17];
z[17] = z[3] * z[17];
z[14] = T(-5) / T(2) + z[14] + z[16] + z[17];
z[14] = (T(1) / T(2)) * z[14];
z[16] = prod_pow(z[3], 2) * z[2];
z[14] = z[14] * z[16];
z[14] = z[14] + z[15];
z[14] = z[1] * z[14];
z[15] = -z[4] * z[10];
z[15] = z[15] + -z[26];
z[15] = z[11] * z[15];
z[13] = -z[4] + -z[10] + -z[13] + z[15];
z[13] = z[0] * z[13];
z[13] = T(1) / T(4) + (T(1) / T(4)) * z[13] + z[18];
z[13] = z[0] * z[13];
z[13] = (T(-9) / T(4)) * z[6] + z[13];
z[13] = z[13] * z[16];
return z[12] + z[13] + z[14];
}



template double eval_coef_2q3y_2l_pmmpp_12345_116(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_116(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
