#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_119(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[34];
z[0] = iW[0];
z[1] = iW[3];
z[2] = iW[16];
z[3] = v[2];
z[4] = v[4];
z[5] = v[1];
z[6] = v[3];
z[7] = iW[1];
z[8] = v[0];
z[9] = iW[5];
z[10] = iW[18];
z[11] = prod_pow(z[7], 2);
z[12] = z[6] * z[10] * z[11];
z[13] = (T(1) / T(2)) * z[12];
z[14] = z[7] * z[10];
z[15] = z[11] + -z[13] + (T(3) / T(4)) * z[14];
z[15] = z[6] * z[15];
z[16] = 3 * z[11] + -z[12] + z[14];
z[17] = 2 * z[0];
z[18] = -z[2] * z[17];
z[16] = (T(1) / T(4)) * z[16] + z[18];
z[16] = z[3] * z[16];
z[18] = z[0] * z[4];
z[19] = 2 * z[18];
z[20] = (T(1) / T(2)) * z[6];
z[21] = -z[0] * z[20];
z[21] = 3 + z[19] + z[21];
z[21] = z[2] * z[21];
z[22] = (T(1) / T(2)) * z[0];
z[23] = z[4] * z[11];
z[24] = z[7] + -z[10];
z[15] = z[15] + z[16] + z[21] + z[22] + -z[23] + (T(1) / T(4)) * z[24];
z[15] = z[3] * z[15];
z[16] = -z[7] + z[23];
z[21] = 5 * z[4];
z[21] = z[16] * z[21];
z[24] = z[2] * z[3];
z[25] = z[7] * z[24];
z[26] = -z[7] + z[25];
z[26] = z[3] * z[26];
z[27] = z[4] * z[7];
z[28] = 1 + z[26] + -z[27];
z[29] = (T(1) / T(2)) * z[3];
z[28] = z[28] * z[29];
z[30] = -2 + z[27];
z[30] = z[4] * z[30];
z[30] = z[5] + z[30];
z[28] = z[28] + 2 * z[30];
z[28] = z[1] * z[28];
z[21] = z[21] + 4 * z[26] + 3 * z[28];
z[21] = z[3] * z[21];
z[26] = 2 * z[7] + -z[23];
z[26] = z[4] * z[26];
z[26] = -1 + z[26];
z[26] = z[4] * z[26];
z[21] = z[21] + 4 * z[26];
z[21] = z[1] * z[21];
z[26] = (T(-5) / T(2)) * z[7] + z[23];
z[25] = 7 * z[25] + 3 * z[26];
z[25] = z[25] * z[29];
z[26] = (T(1) / T(2)) * z[23];
z[28] = -z[7] + -z[26];
z[28] = z[4] * z[28];
z[30] = z[4] * z[16];
z[31] = -1 + z[30];
z[31] = z[4] * z[31];
z[31] = z[5] + z[31];
z[31] = z[9] * z[31];
z[21] = T(3) / T(2) + z[21] + z[25] + z[28] + z[31];
z[21] = z[1] * z[21];
z[25] = 3 * z[7];
z[28] = -z[23] + z[25];
z[28] = z[4] * z[28];
z[28] = -3 + z[28];
z[28] = z[4] * z[28];
z[28] = z[5] + z[28];
z[31] = -1 + z[24];
z[31] = z[3] * z[11] * z[31];
z[32] = -z[16] + z[31];
z[33] = z[29] * z[32];
z[26] = -z[7] + z[26];
z[26] = z[4] * z[26];
z[26] = T(1) / T(2) + z[26];
z[33] = -z[26] + z[33];
z[33] = z[3] * z[33];
z[33] = -2 * z[28] + z[33];
z[33] = z[1] * z[33];
z[28] = z[9] * z[28];
z[26] = -z[26] + z[28];
z[28] = z[3] * z[32];
z[26] = (T(1) / T(2)) * z[26] + z[28] + z[33];
z[26] = z[1] * z[26];
z[28] = (T(-3) / T(2)) * z[16] + z[31];
z[26] = z[26] + (T(1) / T(2)) * z[28];
z[26] = z[1] * z[26];
z[12] = -z[11] + z[12];
z[26] = (T(-1) / T(4)) * z[12] + z[26];
z[26] = z[8] * z[26];
z[28] = z[12] + -z[14];
z[28] = z[20] * z[28];
z[12] = z[12] + (T(-1) / T(2)) * z[14];
z[31] = z[2] * z[7];
z[12] = (T(1) / T(2)) * z[12] + z[31];
z[12] = z[3] * z[12];
z[31] = (T(3) / T(2)) * z[23];
z[32] = (T(1) / T(2)) * z[7] + -z[23];
z[32] = z[4] * z[32];
z[33] = T(-1) / T(2) + -z[32];
z[33] = z[9] * z[33];
z[12] = -z[7] + z[12] + z[21] + z[26] + z[28] + z[31] + z[33];
z[12] = z[8] * z[12];
z[21] = -z[9] * z[23];
z[13] = (T(1) / T(2)) * z[11] + -z[13] + z[14] + z[21];
z[13] = z[13] * z[20];
z[14] = -z[10] + -z[16];
z[16] = T(-1) / T(2) + z[32];
z[16] = z[9] * z[16];
z[13] = z[13] + (T(1) / T(4)) * z[14] + z[16];
z[13] = z[6] * z[13];
z[14] = z[0] * z[24];
z[16] = 2 + z[18];
z[16] = z[2] * z[16];
z[16] = z[14] + -z[16];
z[21] = z[0] + 5 * z[23];
z[16] = -3 * z[16] + (T(1) / T(2)) * z[21];
z[16] = z[3] * z[16];
z[16] = -2 + z[16] + z[18] + (T(-9) / T(2)) * z[30];
z[16] = z[3] * z[16];
z[21] = -z[17] * z[24];
z[19] = 5 + z[19];
z[19] = z[2] * z[19];
z[19] = z[19] + z[21] + -z[22];
z[19] = z[3] * z[19];
z[21] = T(3) / T(2) + 5 * z[27];
z[22] = 2 * z[4];
z[23] = z[5] + z[22];
z[23] = z[0] * z[23];
z[19] = z[19] + (T(1) / T(2)) * z[21] + z[23];
z[19] = z[3] * z[19];
z[21] = -z[7] * z[22];
z[21] = T(7) / T(2) + z[21];
z[21] = z[4] * z[21];
z[19] = (T(-3) / T(2)) * z[5] + z[19] + z[21];
z[19] = z[3] * z[19];
z[21] = 3 + z[18];
z[21] = z[2] * z[21];
z[14] = z[0] + -z[14] + z[21];
z[14] = z[14] * z[29];
z[17] = z[5] * z[17];
z[14] = T(-3) / T(2) + z[14] + z[17];
z[14] = z[3] * z[14];
z[17] = z[4] + -z[5];
z[14] = z[14] + 6 * z[17];
z[14] = prod_pow(z[3], 2) * z[1] * z[14];
z[14] = z[14] + z[19];
z[14] = z[1] * z[14];
z[11] = z[11] * z[22];
z[11] = z[11] + -z[25];
z[11] = z[4] * z[11];
z[11] = T(3) / T(2) + z[11];
z[11] = z[4] * z[11];
z[11] = (T(-1) / T(2)) * z[5] + z[11] + z[14] + z[16];
z[11] = z[1] * z[11];
z[14] = z[7] + z[31];
z[14] = z[4] * z[14];
z[16] = -1 + -z[30];
z[16] = z[4] * z[16];
z[16] = z[5] + z[16];
z[16] = z[9] * z[16];
z[14] = z[14] + z[16];
z[16] = 1 + z[18];
z[16] = z[2] * z[16] * z[20];
return z[11] + z[12] + z[13] + (T(1) / T(2)) * z[14] + z[15] + z[16];
}



template double eval_coef_2q3y_2l_pmmpp_12345_119(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_119(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
