#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_120(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[33];
z[0] = iW[0];
z[1] = iW[3];
z[2] = iW[19];
z[3] = v[1];
z[4] = v[2];
z[5] = v[4];
z[6] = iW[1];
z[7] = v[0];
z[8] = iW[12];
z[9] = iW[4];
z[10] = v[3];
z[11] = z[2] * z[5];
z[12] = -1 + z[11];
z[13] = z[2] * z[4];
z[14] = z[12] + -z[13];
z[14] = z[5] * z[14];
z[15] = 7 * z[7];
z[16] = z[4] + -z[14] + -z[15];
z[16] = z[5] * z[16];
z[17] = prod_pow(z[7], 2);
z[18] = (T(-5) / T(2)) * z[4] + -z[7];
z[18] = z[4] * z[18];
z[16] = 2 * z[16] + (T(7) / T(2)) * z[17] + z[18];
z[16] = z[5] * z[16];
z[18] = z[12] + -2 * z[13];
z[18] = z[5] * z[18];
z[19] = prod_pow(z[4], 2);
z[20] = z[2] * z[19];
z[21] = z[4] * z[8];
z[22] = -3 + z[21];
z[22] = z[4] * z[22];
z[23] = 11 * z[7] + -z[22];
z[18] = z[18] + z[20] + (T(1) / T(2)) * z[23];
z[18] = z[5] * z[18];
z[23] = (T(7) / T(4)) * z[17];
z[24] = z[4] * z[7];
z[18] = z[18] + -z[23] + -5 * z[24];
z[25] = prod_pow(z[5], 2);
z[18] = z[6] * z[18] * z[25];
z[16] = z[16] + z[18];
z[16] = z[6] * z[16];
z[18] = (T(1) / T(2)) * z[17];
z[26] = (T(1) / T(2)) * z[4];
z[27] = z[7] + -z[26];
z[27] = z[4] * z[27];
z[27] = -z[18] + z[27];
z[28] = z[5] * z[12];
z[29] = z[4] + -z[7];
z[30] = z[28] + -z[29];
z[31] = (T(1) / T(2)) * z[5];
z[30] = z[30] * z[31];
z[27] = 5 * z[27] + z[30];
z[27] = z[5] * z[27];
z[24] = -z[17] + z[24];
z[14] = -z[7] + -z[14];
z[14] = z[5] * z[14];
z[14] = z[14] + -5 * z[24];
z[14] = z[14] * z[25];
z[11] = (T(1) / T(2)) * z[11];
z[25] = z[11] + -z[13];
z[30] = T(-1) / T(2) + z[25];
z[30] = z[5] * z[30];
z[20] = z[4] + z[7] + z[20];
z[20] = (T(1) / T(2)) * z[20] + z[30];
z[20] = z[5] * z[20];
z[17] = (T(5) / T(2)) * z[17];
z[20] = -z[17] + z[20];
z[20] = prod_pow(z[5], 3) * z[6] * z[20];
z[14] = (T(3) / T(2)) * z[14] + z[20];
z[14] = z[6] * z[14];
z[14] = z[14] + 3 * z[27];
z[14] = z[1] * z[14];
z[20] = z[0] * z[4];
z[27] = T(-27) / T(2) + 5 * z[20];
z[27] = z[26] * z[27];
z[27] = 6 * z[7] + z[27];
z[27] = z[4] * z[27];
z[30] = 2 * z[20];
z[32] = T(-19) / T(2) + -z[30];
z[32] = z[4] * z[32];
z[28] = (T(23) / T(2)) * z[7] + z[28] + z[32];
z[28] = z[5] * z[28];
z[14] = z[14] + z[16] + -z[23] + z[27] + z[28];
z[14] = z[1] * z[14];
z[16] = (T(1) / T(2)) * z[2];
z[23] = z[16] * z[19];
z[27] = 13 + -3 * z[21];
z[27] = z[26] * z[27];
z[25] = T(-7) / T(2) + z[21] + z[25];
z[25] = z[5] * z[25];
z[25] = 4 * z[7] + z[23] + z[25] + z[27];
z[25] = z[5] * z[25];
z[15] = -5 * z[4] + -z[15];
z[15] = z[4] * z[15];
z[15] = z[15] + z[18];
z[15] = (T(1) / T(2)) * z[15] + z[25];
z[15] = z[6] * z[15];
z[18] = 2 * z[21];
z[11] = T(15) / T(2) + -z[11] + (T(1) / T(2)) * z[13] + -z[18];
z[11] = z[5] * z[11];
z[25] = -11 * z[4] + -13 * z[7];
z[11] = z[11] + z[15] + (T(1) / T(2)) * z[25];
z[11] = z[5] * z[11];
z[11] = z[11] + (T(1) / T(4)) * z[24];
z[11] = z[6] * z[11];
z[12] = -z[12] + -z[13];
z[12] = z[12] * z[31];
z[12] = z[4] + (T(-1) / T(2)) * z[7] + z[12] + -z[23];
z[12] = z[5] * z[12];
z[13] = -1 + z[20];
z[15] = prod_pow(z[4], 3) * z[13] * z[16];
z[16] = T(15) / T(2) + -z[30];
z[16] = z[4] * z[16];
z[16] = (T(-15) / T(2)) * z[7] + z[16];
z[16] = z[4] * z[16];
z[12] = z[12] + z[15] + z[16] + z[17];
z[12] = z[1] * z[12];
z[15] = 2 + -z[20];
z[15] = z[4] * z[15];
z[15] = -z[7] + z[15];
z[12] = z[12] + 3 * z[15];
z[12] = z[1] * z[12];
z[12] = z[12] + -z[13];
z[12] = z[3] * z[12];
z[15] = 3 * z[20];
z[16] = T(-11) / T(2) + z[15];
z[16] = z[4] * z[16];
z[15] = -5 + -z[15];
z[15] = z[5] * z[15];
z[11] = (T(5) / T(2)) * z[7] + z[11] + z[12] + z[14] + z[15] + z[16];
z[11] = z[1] * z[11];
z[12] = -1 + -z[21];
z[12] = z[12] * z[26];
z[14] = z[8] * z[31];
z[15] = T(1) / T(4) + -z[14] + z[21];
z[15] = z[5] * z[15];
z[12] = z[12] + z[15];
z[12] = z[10] * z[12];
z[15] = (T(7) / T(2)) * z[4] + -z[7];
z[16] = -z[15] * z[26];
z[14] = T(-11) / T(4) + -z[14] + z[18];
z[14] = z[5] * z[14];
z[17] = -z[7] + -3 * z[22];
z[14] = z[14] + (T(1) / T(2)) * z[17];
z[14] = z[5] * z[14];
z[12] = z[12] + z[14] + z[16];
z[12] = z[6] * z[12];
z[14] = z[5] * z[8];
z[16] = T(-1) / T(2) + z[14] + -z[21];
z[16] = z[10] * z[16];
z[15] = z[15] + -z[16];
z[16] = 7 + -5 * z[21];
z[14] = z[14] + (T(1) / T(2)) * z[16];
z[14] = z[5] * z[14];
z[12] = z[12] + z[14] + (T(-1) / T(2)) * z[15];
z[12] = z[6] * z[12];
z[14] = z[6] * z[19];
z[14] = z[4] + z[14];
z[14] = z[10] * z[14];
z[15] = -z[4] * z[29];
z[14] = z[14] + z[15];
z[14] = z[6] * z[14];
z[14] = z[14] + -z[29];
z[14] = z[9] * z[14];
z[15] = -z[0] + -z[8];
z[15] = z[5] * z[15];
return z[11] + z[12] + z[13] + (T(1) / T(4)) * z[14] + z[15];
}



template double eval_coef_2q3y_2l_pmmpp_12345_120(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_120(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
