#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_129(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[39];
z[0] = iW[0];
z[1] = iW[3];
z[2] = iW[19];
z[3] = v[1];
z[4] = v[2];
z[5] = v[3];
z[6] = v[4];
z[7] = iW[1];
z[8] = iW[2];
z[9] = v[0];
z[10] = iW[4];
z[11] = iW[15];
z[12] = 5 * z[8];
z[13] = prod_pow(z[8], 2);
z[14] = z[9] * z[13];
z[15] = -z[12] + (T(3) / T(2)) * z[14];
z[15] = z[9] * z[15];
z[15] = T(13) / T(2) + z[15];
z[15] = z[1] * z[15];
z[16] = (T(1) / T(2)) * z[5];
z[17] = prod_pow(z[11], 2);
z[18] = -z[16] * z[17];
z[19] = (T(3) / T(2)) * z[8];
z[20] = z[1] * z[2];
z[21] = z[6] * z[20];
z[22] = 3 * z[21];
z[23] = 5 * z[2];
z[24] = (T(1) / T(2)) * z[11];
z[15] = -z[14] + z[15] + z[18] + z[19] + -z[22] + -z[23] + -z[24];
z[18] = (T(1) / T(2)) * z[6];
z[15] = z[15] * z[18];
z[25] = z[3] * z[17];
z[26] = (T(1) / T(2)) * z[10];
z[26] = z[25] * z[26];
z[27] = z[5] * z[10] * z[17];
z[28] = (T(3) / T(2)) * z[27];
z[26] = z[26] + -z[28];
z[29] = z[10] * z[11];
z[30] = -z[17] + (T(1) / T(2)) * z[29];
z[31] = z[26] + z[30];
z[32] = (T(1) / T(2)) * z[3];
z[31] = z[31] * z[32];
z[33] = z[12] + -z[14];
z[33] = z[9] * z[33];
z[33] = -9 + z[33];
z[34] = (T(1) / T(2)) * z[1];
z[33] = z[33] * z[34];
z[33] = z[2] + -z[10] + z[33];
z[35] = (T(3) / T(4)) * z[27];
z[36] = -z[30] + z[35];
z[36] = z[5] * z[36];
z[37] = (T(1) / T(2)) * z[17] + z[20];
z[37] = z[18] * z[37];
z[31] = z[31] + (T(1) / T(2)) * z[33] + z[36] + z[37];
z[31] = z[3] * z[31];
z[33] = 7 * z[2];
z[19] = -z[19] + z[33];
z[12] = z[12] + -3 * z[14];
z[12] = z[9] * z[12];
z[12] = -3 + (T(1) / T(2)) * z[12];
z[12] = z[12] * z[34];
z[36] = z[5] * z[13];
z[12] = z[12] + z[14] + (T(1) / T(2)) * z[19] + (T(3) / T(2)) * z[21] + (T(-1) / T(4)) * z[36];
z[12] = z[6] * z[12];
z[19] = (T(1) / T(2)) * z[8] + z[23];
z[19] = z[16] * z[19];
z[36] = z[1] * z[9];
z[37] = z[8] * z[9];
z[38] = -9 + -z[37];
z[12] = z[12] + z[19] + z[36] + (T(1) / T(4)) * z[38];
z[12] = z[6] * z[12];
z[19] = 3 * z[2];
z[21] = z[19] + z[21];
z[38] = z[13] * z[16];
z[13] = prod_pow(z[9], 2) * z[13];
z[13] = 1 + (T(1) / T(2)) * z[13];
z[13] = z[1] * z[13];
z[13] = z[13] + -z[14] + -z[21] + z[38];
z[13] = z[6] * z[13];
z[14] = -z[8] + -z[19];
z[14] = z[5] * z[14];
z[13] = 3 + z[13] + z[14] + -z[36] + z[37];
z[13] = z[6] * z[13];
z[14] = z[2] * z[5];
z[36] = 1 + -z[14];
z[36] = z[5] * z[36];
z[13] = z[13] + z[36];
z[13] = z[13] * z[18];
z[18] = (T(1) / T(2)) * z[27];
z[36] = -z[2] + z[11];
z[36] = z[10] * z[36];
z[36] = -z[18] + z[36];
z[36] = z[5] * z[36];
z[19] = -z[19] + z[36];
z[19] = z[5] * z[19];
z[36] = -z[6] * z[21];
z[19] = z[19] + z[36];
z[36] = (T(1) / T(2)) * z[4];
z[19] = z[19] * z[36];
z[21] = z[21] + -z[34];
z[21] = z[6] * z[21];
z[14] = T(-1) / T(2) + z[14];
z[21] = 3 * z[14] + z[21];
z[21] = z[6] * z[21];
z[38] = z[2] + -z[24];
z[38] = prod_pow(z[5], 2) * z[38];
z[19] = z[19] + z[21] + z[38];
z[19] = z[4] * z[19];
z[13] = z[13] + z[19];
z[13] = z[7] * z[13];
z[19] = (T(3) / T(2)) * z[11];
z[21] = -z[2] + z[19];
z[21] = z[10] * z[21];
z[21] = -z[17] + z[21] + -z[27];
z[21] = z[5] * z[21];
z[19] = z[19] + z[21] + -z[23];
z[19] = z[5] * z[19];
z[21] = -z[22] + -z[33];
z[21] = z[6] * z[21];
z[19] = z[19] + z[21];
z[21] = -z[29] + z[35];
z[21] = z[4] * z[5] * z[21];
z[19] = (T(1) / T(2)) * z[19] + z[21];
z[19] = z[4] * z[19];
z[14] = z[14] * z[16];
z[12] = z[12] + z[13] + z[14] + z[19];
z[12] = z[7] * z[12];
z[13] = -z[17] + (T(3) / T(2)) * z[29];
z[14] = z[10] * z[25];
z[14] = z[13] + z[14] + z[20] + -3 * z[27];
z[14] = z[14] * z[32];
z[13] = -z[13] + z[28];
z[13] = z[5] * z[13];
z[17] = z[26] + z[29];
z[17] = z[17] * z[36];
z[19] = z[1] + -z[10] + -z[24];
z[13] = z[13] + z[14] + z[17] + (T(1) / T(2)) * z[19];
z[13] = z[4] * z[13];
z[14] = -z[18] + z[30];
z[14] = z[14] * z[16];
z[14] = -z[2] + z[14];
z[14] = z[5] * z[14];
z[16] = -z[9] * z[34];
z[17] = -z[4] * z[20];
z[17] = (T(3) / T(2)) * z[1] + -z[2] + z[17];
z[17] = z[3] * z[17];
z[17] = T(-5) / T(2) + z[17];
z[17] = z[4] * z[17];
z[17] = -z[5] + (T(3) / T(2)) * z[6] + z[17];
z[17] = z[0] * z[17];
z[12] = 3 + z[12] + z[13] + z[14] + z[15] + z[16] + (T(1) / T(2)) * z[17] + z[31] + (T(-1) / T(4)) * z[37];
return (T(1) / T(2)) * z[12];
}



template double eval_coef_2q3y_2l_pmmpp_12345_129(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_129(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
