#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_136(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[39];
z[0] = iW[0];
z[1] = iW[3];
z[2] = iW[5];
z[3] = iW[16];
z[4] = v[1];
z[5] = v[2];
z[6] = v[4];
z[7] = v[3];
z[8] = iW[1];
z[9] = iW[2];
z[10] = v[0];
z[11] = 5 * z[5];
z[12] = prod_pow(z[1], 3);
z[13] = z[11] * z[12];
z[14] = prod_pow(z[1], 2);
z[15] = 2 * z[14];
z[16] = z[1] + z[9];
z[16] = z[9] * z[16];
z[17] = z[13] + z[15] + (T(-3) / T(2)) * z[16];
z[17] = z[10] * z[17];
z[18] = z[5] * z[12];
z[19] = 15 * z[18];
z[20] = -29 * z[14] + -z[19];
z[20] = z[5] * z[20];
z[21] = z[7] * z[9];
z[22] = T(7) / T(2) + z[21];
z[22] = z[9] * z[22];
z[20] = (T(-13) / T(2)) * z[1] + z[20] + 3 * z[22];
z[17] = z[17] + (T(1) / T(2)) * z[20];
z[17] = z[10] * z[17];
z[20] = 7 * z[7];
z[22] = prod_pow(z[7], 2);
z[23] = z[9] * z[22];
z[24] = z[20] + z[23];
z[25] = -z[9] * z[24];
z[25] = T(5) / T(3) + z[25];
z[26] = (T(5) / T(2)) * z[18];
z[27] = 7 * z[14] + z[26];
z[27] = z[5] * z[27];
z[27] = (T(89) / T(12)) * z[1] + z[27];
z[27] = z[5] * z[27];
z[28] = (T(1) / T(3)) * z[5];
z[29] = z[14] * z[28];
z[30] = z[1] + z[29];
z[30] = z[11] * z[30];
z[30] = T(11) / T(6) + z[30];
z[30] = z[5] * z[30];
z[30] = (T(-3) / T(2)) * z[7] + z[30];
z[30] = z[0] * z[30];
z[17] = z[17] + (T(1) / T(4)) * z[25] + z[27] + (T(1) / T(2)) * z[30];
z[17] = z[6] * z[17];
z[25] = z[5] * z[14];
z[27] = 5 * z[1];
z[30] = z[25] + z[27];
z[30] = z[5] * z[30];
z[31] = (T(5) / T(2)) * z[7];
z[32] = z[23] + z[31];
z[32] = z[9] * z[32];
z[32] = T(-19) / T(6) + (T(-5) / T(3)) * z[30] + z[32];
z[33] = (T(4) / T(3)) * z[14] + -z[16] + (T(10) / T(3)) * z[18];
z[33] = z[10] * z[33];
z[34] = z[13] + (T(49) / T(3)) * z[14];
z[34] = z[5] * z[34];
z[35] = 3 * z[21];
z[36] = T(-11) / T(2) + -z[35];
z[36] = z[9] * z[36];
z[34] = (T(29) / T(6)) * z[1] + z[34] + z[36];
z[34] = -z[33] + (T(1) / T(2)) * z[34];
z[34] = z[10] * z[34];
z[32] = (T(1) / T(2)) * z[32] + z[34];
z[32] = z[6] * z[32];
z[34] = (T(7) / T(2)) * z[14] + -z[18];
z[36] = z[5] * z[34];
z[37] = z[9] + z[27];
z[36] = z[36] + (T(3) / T(4)) * z[37];
z[36] = z[10] * z[36];
z[15] = -z[15] + -z[18];
z[15] = z[5] * z[15];
z[15] = (T(31) / T(4)) * z[1] + z[15];
z[15] = z[5] * z[15];
z[15] = 8 + z[15] + (T(7) / T(4)) * z[21] + -z[36];
z[15] = z[10] * z[15];
z[38] = -5 + 7 * z[30];
z[38] = z[5] * z[38];
z[15] = (T(-9) / T(2)) * z[7] + z[15] + -z[23] + z[32] + (T(1) / T(6)) * z[38];
z[15] = z[6] * z[15];
z[32] = z[28] * z[34];
z[32] = z[32] + (T(1) / T(4)) * z[37];
z[32] = z[10] * z[32];
z[27] = 7 * z[25] + -z[27];
z[27] = z[27] * z[28];
z[27] = -3 + -z[21] + z[27] + z[32];
z[27] = z[10] * z[27];
z[16] = (T(1) / T(3)) * z[14] + (T(-1) / T(4)) * z[16] + (T(5) / T(6)) * z[18];
z[16] = z[10] * z[16];
z[34] = 1 + z[21];
z[34] = z[9] * z[34];
z[34] = (T(-2) / T(3)) * z[1] + z[16] + (T(-5) / T(3)) * z[25] + (T(1) / T(2)) * z[34];
z[34] = z[10] * z[34];
z[37] = (T(1) / T(4)) * z[9];
z[38] = -z[7] + -z[23];
z[37] = z[37] * z[38];
z[38] = z[1] * z[5];
z[34] = T(1) / T(3) + z[34] + z[37] + (T(5) / T(6)) * z[38];
z[34] = z[6] * z[34];
z[20] = z[20] + 3 * z[23];
z[23] = T(1) / T(2) + -2 * z[38];
z[23] = z[5] * z[23];
z[20] = (T(1) / T(4)) * z[20] + z[23] + z[27] + z[34];
z[20] = z[6] * z[20];
z[23] = 2 * z[5];
z[27] = -z[14] * z[23];
z[27] = 7 * z[1] + z[27];
z[27] = z[27] * z[28];
z[27] = T(5) / T(2) + z[27];
z[27] = z[5] * z[27];
z[27] = (T(1) / T(2)) * z[7] + z[27];
z[27] = z[10] * z[27];
z[34] = -2 + (T(3) / T(2)) * z[38];
z[34] = z[5] * z[34];
z[34] = (T(-11) / T(4)) * z[7] + z[34];
z[34] = z[5] * z[34];
z[20] = z[20] + (T(-3) / T(4)) * z[22] + z[27] + z[34];
z[20] = z[6] * z[20];
z[27] = T(7) / T(2) + -z[38];
z[27] = z[27] * z[28];
z[27] = (T(5) / T(4)) * z[7] + z[27];
z[27] = z[5] * z[27];
z[27] = (T(1) / T(4)) * z[22] + z[27];
z[27] = z[5] * z[27];
z[20] = z[20] + z[27];
z[20] = z[8] * z[20];
z[27] = (T(7) / T(2)) * z[1] + -z[25];
z[27] = z[27] * z[28];
z[27] = T(5) / T(4) + z[27];
z[27] = z[5] * z[27];
z[27] = (T(1) / T(4)) * z[7] + z[27];
z[27] = z[10] * z[27];
z[30] = T(29) / T(4) + -z[30];
z[30] = z[28] * z[30];
z[30] = (T(13) / T(4)) * z[7] + z[30];
z[30] = z[5] * z[30];
z[15] = z[15] + z[20] + (T(1) / T(2)) * z[22] + -z[27] + z[30];
z[15] = z[8] * z[15];
z[19] = (T(67) / T(3)) * z[14] + z[19];
z[19] = z[5] * z[19];
z[20] = T(-17) / T(2) + -z[21];
z[20] = z[9] * z[20];
z[19] = (T(23) / T(6)) * z[1] + z[19] + z[20];
z[19] = (T(1) / T(2)) * z[19] + -z[33];
z[19] = z[10] * z[19];
z[20] = -z[13] + (T(-23) / T(2)) * z[14];
z[20] = z[5] * z[20];
z[20] = (T(-17) / T(3)) * z[1] + z[20];
z[20] = z[5] * z[20];
z[22] = z[14] + (T(1) / T(2)) * z[18];
z[22] = z[11] * z[22];
z[22] = (T(-19) / T(4)) * z[1] + z[22];
z[22] = z[5] * z[22];
z[22] = -5 + z[22];
z[22] = z[22] * z[28];
z[30] = (T(3) / T(4)) * z[7];
z[22] = z[22] + z[30];
z[22] = z[0] * z[22];
z[33] = T(31) / T(3) + z[35];
z[19] = z[19] + z[20] + z[22] + (T(1) / T(4)) * z[33];
z[19] = z[4] * z[19];
z[20] = z[12] * z[23];
z[20] = -3 * z[14] + z[20];
z[20] = z[5] * z[20];
z[20] = (T(-21) / T(2)) * z[1] + z[20];
z[20] = z[5] * z[20];
z[20] = -7 + z[20] + (T(-1) / T(2)) * z[21] + z[36];
z[20] = z[10] * z[20];
z[22] = (T(2) / T(3)) * z[14] + -z[18];
z[22] = z[5] * z[22];
z[22] = (T(41) / T(12)) * z[1] + z[22];
z[22] = z[5] * z[22];
z[22] = T(19) / T(4) + z[22];
z[22] = z[5] * z[22];
z[33] = -3 * z[1] + (T(-7) / T(6)) * z[25];
z[33] = z[5] * z[33];
z[33] = T(2) / T(3) + z[33];
z[33] = z[5] * z[33];
z[31] = z[31] + z[33];
z[33] = z[0] * z[5];
z[31] = z[31] * z[33];
z[15] = z[15] + z[17] + z[19] + z[20] + z[22] + (T(1) / T(4)) * z[24] + z[31];
z[15] = z[6] * z[15];
z[13] = -z[13] + (T(-19) / T(3)) * z[14];
z[13] = z[5] * z[13];
z[17] = (T(-1) / T(3)) * z[1] + z[9];
z[13] = z[13] + (T(5) / T(2)) * z[17];
z[13] = (T(1) / T(2)) * z[13] + z[16];
z[13] = z[10] * z[13];
z[16] = (T(16) / T(3)) * z[14] + z[26];
z[16] = z[5] * z[16];
z[16] = (T(19) / T(12)) * z[1] + z[16];
z[16] = z[5] * z[16];
z[12] = -z[12] * z[28];
z[12] = z[12] + -z[14];
z[11] = z[11] * z[12];
z[11] = (T(-11) / T(6)) * z[1] + z[11];
z[11] = z[5] * z[11];
z[11] = T(3) / T(2) + z[11];
z[11] = z[11] * z[33];
z[11] = T(-7) / T(4) + (T(1) / T(2)) * z[11] + z[13] + z[16];
z[11] = z[4] * z[11];
z[12] = (T(8) / T(3)) * z[14] + -z[18];
z[12] = z[5] * z[12];
z[12] = (T(53) / T(12)) * z[1] + z[12];
z[12] = z[5] * z[12];
z[12] = 2 + z[12] + (T(-1) / T(4)) * z[21] + -z[32];
z[12] = z[10] * z[12];
z[13] = (T(-11) / T(6)) * z[14] + z[18];
z[13] = z[5] * z[13];
z[13] = (T(-29) / T(4)) * z[1] + z[13];
z[13] = z[5] * z[13];
z[13] = T(-53) / T(12) + z[13];
z[13] = z[5] * z[13];
z[14] = z[14] + -z[18];
z[14] = z[5] * z[14];
z[14] = (T(49) / T(4)) * z[1] + z[14];
z[14] = z[5] * z[14];
z[14] = 8 + z[14];
z[14] = z[14] * z[28];
z[14] = z[14] + -z[30];
z[14] = z[14] * z[33];
z[11] = z[7] + z[11] + z[12] + z[13] + z[14];
z[11] = z[4] * z[11];
z[12] = z[1] + -z[25];
z[12] = z[12] * z[23];
z[12] = T(17) / T(2) + z[12];
z[12] = z[12] * z[28];
z[12] = 2 * z[7] + z[12];
z[12] = z[5] * z[12];
z[13] = (T(1) / T(2)) * z[1] + z[29];
z[13] = z[5] * z[13];
z[13] = T(-19) / T(12) + z[13];
z[13] = z[5] * z[13];
z[13] = (T(-7) / T(4)) * z[7] + z[13];
z[13] = prod_pow(z[5], 2) * z[0] * z[13];
z[11] = z[11] + z[12] + z[13] + z[15] + -z[27];
return z[2] * z[3] * z[11];
}



template double eval_coef_2q3y_2l_pmmpp_12345_136(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_136(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
