#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_138(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[37];
z[0] = iW[0];
z[1] = iW[3];
z[2] = iW[21];
z[3] = v[1];
z[4] = v[2];
z[5] = iW[22];
z[6] = iW[8];
z[7] = v[3];
z[8] = v[4];
z[9] = iW[1];
z[10] = v[0];
z[11] = iW[4];
z[12] = iW[18];
z[13] = (T(1) / T(4)) * z[4];
z[14] = prod_pow(z[5], 2);
z[15] = -z[13] * z[14];
z[16] = (T(1) / T(3)) * z[5];
z[15] = z[15] + z[16];
z[15] = z[4] * z[15];
z[17] = z[8] * z[14];
z[18] = z[4] * z[14];
z[19] = (T(-1) / T(4)) * z[17] + z[18];
z[19] = z[8] * z[19];
z[15] = T(1) / T(4) + z[15] + (T(1) / T(3)) * z[19];
z[15] = z[8] * z[15];
z[19] = z[4] * z[5];
z[20] = 1 + z[19];
z[21] = (T(1) / T(2)) * z[4];
z[22] = -z[20] * z[21];
z[15] = z[15] + z[22];
z[15] = z[8] * z[15];
z[22] = prod_pow(z[2], 2);
z[23] = z[13] * z[22];
z[24] = (T(1) / T(2)) * z[22];
z[25] = z[2] * z[12];
z[25] = z[24] + z[25];
z[26] = (T(1) / T(2)) * z[7];
z[27] = -z[25] * z[26];
z[27] = (T(5) / T(4)) * z[2] + z[12] + z[23] + z[27];
z[28] = (T(1) / T(3)) * z[7];
z[27] = z[27] * z[28];
z[29] = (T(1) / T(2)) * z[5] + z[11];
z[30] = -z[19] * z[29];
z[30] = -z[2] + z[12] + z[30];
z[31] = (T(1) / T(3)) * z[4];
z[30] = z[30] * z[31];
z[30] = -1 + z[30];
z[27] = z[27] + (T(1) / T(2)) * z[30];
z[27] = z[7] * z[27];
z[30] = z[14] * z[21];
z[16] = z[16] + -z[30];
z[16] = z[4] * z[16];
z[32] = z[8] * z[18];
z[16] = T(5) / T(6) + z[16] + (T(1) / T(3)) * z[32];
z[16] = z[8] * z[16];
z[20] = z[4] * z[20];
z[16] = z[16] + -z[20];
z[16] = (T(1) / T(2)) * z[16] + z[27];
z[16] = z[7] * z[16];
z[27] = z[5] + -z[30];
z[27] = z[4] * z[27];
z[30] = (T(1) / T(2)) * z[8];
z[33] = -z[14] * z[30];
z[33] = z[18] + z[33];
z[33] = z[8] * z[33];
z[27] = T(1) / T(2) + z[27] + z[33];
z[27] = z[8] * z[27];
z[20] = -z[20] + z[27];
z[27] = prod_pow(z[8], 2);
z[33] = (T(1) / T(6)) * z[27];
z[20] = z[20] * z[33];
z[34] = z[4] * z[22];
z[35] = 5 * z[2] + z[34];
z[35] = z[13] * z[35];
z[35] = 1 + z[35];
z[31] = z[31] * z[35];
z[31] = (T(1) / T(4)) * z[8] + z[31];
z[31] = z[10] * z[31];
z[31] = z[31] + -z[33];
z[31] = z[10] * z[31];
z[20] = z[20] + z[31];
z[20] = z[1] * z[20];
z[15] = z[15] + z[16] + z[20];
z[16] = z[2] * z[4];
z[16] = 1 + z[16];
z[13] = -z[13] * z[16];
z[13] = -z[8] + z[13];
z[20] = z[7] * z[25];
z[31] = (T(-7) / T(2)) * z[2] + -z[12] + z[20] + -z[34];
z[28] = z[28] * z[31];
z[31] = z[2] + (T(1) / T(6)) * z[34];
z[31] = z[4] * z[31];
z[28] = 1 + z[28] + z[31];
z[28] = z[26] * z[28];
z[13] = (T(1) / T(3)) * z[13] + z[28];
z[23] = -z[2] + -z[23];
z[23] = z[4] * z[23];
z[23] = T(-1) / T(2) + z[23];
z[28] = z[2] + (T(1) / T(3)) * z[34];
z[28] = (T(-1) / T(9)) * z[20] + (T(1) / T(2)) * z[28];
z[28] = z[26] * z[28];
z[23] = (T(1) / T(3)) * z[23] + z[28];
z[23] = z[10] * z[23];
z[13] = (T(1) / T(3)) * z[13] + (T(1) / T(2)) * z[23];
z[13] = z[10] * z[13];
z[13] = z[13] + (T(1) / T(6)) * z[15];
z[13] = z[9] * z[13];
z[15] = 199 * z[5];
z[23] = -z[15] + 277 * z[17] + (T(-1385) / T(2)) * z[18];
z[23] = z[8] * z[23];
z[23] = T(-337) / T(9) + (T(-127) / T(4)) * z[19] + (T(1) / T(18)) * z[23];
z[23] = z[8] * z[23];
z[16] = z[4] * z[16];
z[16] = (T(-277) / T(36)) * z[16] + z[23];
z[23] = -z[5] * z[29];
z[23] = z[23] + -z[24];
z[23] = z[4] * z[23];
z[23] = z[20] + z[23];
z[23] = (T(-101) / T(4)) * z[2] + (T(-277) / T(9)) * z[12] + (T(277) / T(18)) * z[23];
z[23] = z[7] * z[23];
z[28] = z[11] + z[12];
z[28] = (T(329) / T(4)) * z[2] + (T(-277) / T(3)) * z[28];
z[28] = (T(-101) / T(2)) * z[5] + (T(1) / T(3)) * z[28] + (T(277) / T(36)) * z[34];
z[28] = z[4] * z[28];
z[28] = T(1541) / T(36) + z[28] + (T(-277) / T(9)) * z[32];
z[23] = z[23] + (T(1) / T(2)) * z[28];
z[23] = z[7] * z[23];
z[16] = (T(1) / T(2)) * z[16] + z[23];
z[23] = -z[4] + z[30];
z[28] = z[8] * z[23];
z[29] = prod_pow(z[4], 2);
z[30] = (T(1) / T(2)) * z[29];
z[28] = z[28] + z[30];
z[28] = z[6] * z[7] * z[28];
z[31] = -z[4] + z[8];
z[26] = z[26] * z[31];
z[26] = z[26] + z[28];
z[26] = z[6] * z[26];
z[31] = 277 * z[34];
z[32] = 277 * z[12];
z[20] = (T(1463) / T(2)) * z[2] + -277 * z[20] + z[31] + z[32];
z[20] = z[7] * z[20];
z[33] = -3913 * z[2] + -1385 * z[34];
z[33] = z[21] * z[33];
z[33] = -355 + z[33];
z[20] = z[20] + (T(1) / T(2)) * z[33];
z[20] = z[10] * z[20];
z[33] = (T(277) / T(2)) * z[4];
z[34] = z[14] * z[33];
z[35] = (T(277) / T(2)) * z[17];
z[36] = (T(-199) / T(3)) * z[5] + -z[34] + z[35];
z[36] = z[8] * z[36];
z[19] = -361 + -433 * z[19];
z[19] = (T(1) / T(6)) * z[19] + z[36];
z[19] = z[19] * z[27];
z[27] = z[22] * z[33];
z[33] = (T(1463) / T(3)) * z[2] + z[27];
z[33] = z[4] * z[33];
z[33] = T(2095) / T(6) + z[33];
z[33] = z[4] * z[33];
z[33] = (T(79) / T(3)) * z[8] + (T(-277) / T(16)) * z[10] + (T(1) / T(8)) * z[33];
z[33] = z[10] * z[33];
z[19] = (T(1) / T(8)) * z[19] + z[33];
z[19] = z[1] * z[19];
z[13] = (T(277) / T(2)) * z[13] + (T(1) / T(2)) * z[16] + (T(1) / T(3)) * z[19] + (T(1) / T(36)) * z[20] + z[26];
z[13] = z[9] * z[13];
z[16] = (T(-433) / T(2)) * z[2] + (T(277) / T(2)) * z[5] + 277 * z[11] + -z[27] + z[32];
z[16] = z[4] * z[16];
z[19] = z[3] * z[34];
z[20] = z[15] + -z[35];
z[20] = z[8] * z[20];
z[16] = T(-505) / T(2) + z[16] + z[19] + z[20];
z[19] = z[14] + z[22];
z[20] = z[4] * z[19];
z[26] = -z[5] * z[11];
z[25] = -z[25] + z[26];
z[26] = (T(277) / T(2)) * z[7];
z[25] = z[25] * z[26];
z[20] = (T(433) / T(4)) * z[2] + (T(-277) / T(2)) * z[11] + (T(277) / T(4)) * z[20] + z[25] + z[32];
z[20] = z[7] * z[20];
z[16] = (T(1) / T(2)) * z[16] + z[20];
z[20] = z[3] + 3 * z[4] + -z[8];
z[20] = z[6] * z[20];
z[25] = z[10] * z[11];
z[16] = (T(1) / T(18)) * z[16] + z[20] + (T(-277) / T(36)) * z[25];
z[20] = (T(277) / T(12)) * z[4];
z[19] = -z[19] * z[20];
z[19] = -13 * z[2] + (T(-355) / T(6)) * z[5] + z[19];
z[19] = z[4] * z[19];
z[25] = -z[14] * z[26];
z[26] = 277 * z[18];
z[25] = (T(-433) / T(2)) * z[5] + z[25] + -z[26];
z[25] = z[7] * z[25];
z[18] = z[3] * z[18];
z[18] = -13 + (T(-277) / T(12)) * z[18] + z[19] + (T(1) / T(6)) * z[25];
z[18] = z[7] * z[18];
z[19] = -z[2] + z[5];
z[25] = z[19] * z[29];
z[24] = -z[14] + z[24];
z[24] = z[4] * z[24];
z[19] = 13 * z[19];
z[24] = -z[19] + (T(277) / T(6)) * z[24];
z[24] = z[3] * z[4] * z[24];
z[18] = z[18] + z[24] + (T(-277) / T(12)) * z[25];
z[24] = z[4] * z[8];
z[24] = z[24] + z[28] + -z[29];
z[24] = z[6] * z[24];
z[18] = (T(1) / T(12)) * z[18] + z[24];
z[18] = z[0] * z[18];
z[24] = (T(1697) / T(3)) * z[2] + z[31];
z[21] = z[21] * z[24];
z[21] = T(433) / T(3) + z[21];
z[21] = z[4] * z[21];
z[24] = (T(1) / T(6)) * z[3];
z[25] = -121 * z[5] + z[26];
z[25] = z[4] * z[25];
z[25] = 193 + z[25];
z[25] = z[24] * z[25];
z[21] = z[21] + z[25];
z[25] = -z[15] + z[34];
z[25] = z[3] * z[25];
z[25] = T(-109) / T(2) + z[25];
z[26] = z[3] * z[14];
z[15] = z[15] + (T(277) / T(4)) * z[26];
z[15] = (T(1) / T(3)) * z[15] + (T(-277) / T(4)) * z[17];
z[15] = z[8] * z[15];
z[15] = z[15] + (T(1) / T(6)) * z[25];
z[15] = z[8] * z[15];
z[15] = z[15] + (T(1) / T(2)) * z[21];
z[17] = (T(-1) / T(2)) * z[3] + -z[4];
z[17] = z[3] * z[17];
z[21] = z[3] + -z[23];
z[21] = z[8] * z[21];
z[17] = z[17] + z[21] + -z[30];
z[17] = z[6] * z[17];
z[14] = -z[14] + z[22];
z[14] = z[14] * z[20];
z[14] = z[14] + -z[19];
z[14] = z[14] * z[24];
z[14] = 1 + z[14];
z[14] = z[0] * z[14] * z[29];
z[14] = (T(-355) / T(72)) * z[10] + (T(1) / T(2)) * z[14] + (T(1) / T(12)) * z[15] + z[17];
z[14] = z[1] * z[14];
return z[13] + z[14] + (T(1) / T(2)) * z[16] + z[18];
}



template double eval_coef_2q3y_2l_pmmpp_12345_138(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_138(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
