#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_139(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[35];
z[0] = iW[1];
z[1] = iW[2];
z[2] = v[0];
z[3] = iW[3];
z[4] = iW[21];
z[5] = v[2];
z[6] = iW[22];
z[7] = v[4];
z[8] = iW[4];
z[9] = v[3];
z[10] = iW[15];
z[11] = iW[17];
z[12] = iW[18];
z[13] = (T(3) / T(2)) * z[7];
z[14] = z[6] * z[7];
z[15] = T(-5) / T(2) + z[14];
z[15] = z[13] * z[15];
z[16] = (T(1) / T(2)) * z[7];
z[17] = prod_pow(z[6], 2);
z[18] = z[7] * z[17];
z[19] = 11 * z[6] + (T(-3) / T(2)) * z[18];
z[19] = z[16] * z[19];
z[19] = -3 + z[19];
z[20] = prod_pow(z[7], 2);
z[21] = z[3] * z[20];
z[19] = z[19] * z[21];
z[15] = z[15] + z[19];
z[19] = 7 * z[6] + -z[18];
z[13] = -z[13] * z[19];
z[13] = 5 + z[13];
z[22] = (T(1) / T(4)) * z[7];
z[23] = -17 * z[6] + 3 * z[18];
z[23] = z[22] * z[23];
z[23] = 1 + z[23];
z[24] = z[3] * z[7];
z[23] = z[23] * z[24];
z[13] = (T(1) / T(2)) * z[13] + z[23];
z[23] = z[17] * z[22];
z[23] = -z[6] + z[23];
z[25] = -1 + (T(-1) / T(2)) * z[24];
z[25] = z[23] * z[25];
z[25] = (T(-1) / T(4)) * z[11] + z[25];
z[25] = z[5] * z[25];
z[13] = (T(1) / T(2)) * z[13] + z[25];
z[13] = z[5] * z[13];
z[13] = z[13] + (T(1) / T(2)) * z[15];
z[13] = z[5] * z[13];
z[15] = (T(1) / T(2)) * z[5];
z[25] = z[3] * z[15];
z[25] = -1 + z[25];
z[26] = prod_pow(z[4], 2);
z[25] = z[25] * z[26];
z[27] = z[3] * z[4];
z[25] = z[25] + -z[27];
z[25] = z[5] * z[25];
z[28] = z[8] + z[12];
z[25] = -z[1] + (T(-3) / T(2)) * z[3] + 3 * z[4] + z[25] + -z[28];
z[25] = z[2] * z[25];
z[29] = T(5) / T(2) + z[24];
z[30] = z[3] * z[5];
z[31] = z[4] * z[30];
z[32] = -z[3] + (T(3) / T(2)) * z[4] + -z[31];
z[32] = z[5] * z[32];
z[25] = z[25] + 3 * z[29] + z[32];
z[29] = (T(1) / T(2)) * z[2];
z[25] = z[25] * z[29];
z[32] = -z[4] * z[15];
z[32] = 1 + z[24] + z[32];
z[32] = z[5] * z[32];
z[33] = -z[7] + -z[21];
z[25] = z[25] + z[32] + (T(7) / T(4)) * z[33];
z[25] = z[25] * z[29];
z[32] = z[7] * z[19];
z[32] = 1 + z[32];
z[20] = z[20] * z[32];
z[32] = 9 * z[6] + -z[18];
z[32] = z[7] * z[32];
z[33] = 1 + (T(-1) / T(8)) * z[32];
z[33] = prod_pow(z[7], 3) * z[3] * z[33];
z[13] = z[13] + (T(1) / T(8)) * z[20] + z[25] + z[33];
z[13] = z[0] * z[13];
z[20] = (T(5) / T(2)) * z[6];
z[25] = -z[18] + z[20];
z[25] = z[7] * z[25];
z[33] = T(1) / T(2) + -z[25];
z[33] = z[24] * z[33];
z[34] = z[6] + -z[18];
z[34] = z[24] * z[34];
z[34] = (T(1) / T(2)) * z[6] + -z[18] + z[34];
z[34] = z[15] * z[34];
z[14] = T(1) / T(2) + -z[14];
z[14] = (T(1) / T(2)) * z[14] + z[33] + z[34];
z[14] = z[14] * z[15];
z[31] = z[3] + -z[31];
z[31] = z[15] * z[31];
z[33] = -1 + z[30];
z[33] = z[26] * z[33];
z[33] = z[27] + z[33];
z[33] = z[15] * z[33];
z[28] = (T(-1) / T(2)) * z[3] + (T(-1) / T(4)) * z[4] + z[28] + z[33];
z[28] = z[2] * z[28];
z[28] = T(3) / T(4) + z[24] + z[28] + z[31];
z[28] = z[28] * z[29];
z[25] = T(-1) / T(2) + -z[25];
z[25] = z[22] * z[25];
z[23] = -z[7] * z[23];
z[23] = T(-3) / T(4) + z[23];
z[21] = z[21] * z[23];
z[13] = z[13] + z[14] + z[21] + z[25] + z[28];
z[13] = z[0] * z[13];
z[14] = z[16] * z[17];
z[21] = (T(1) / T(2)) * z[4];
z[23] = -z[8] + z[14] + z[21];
z[25] = z[6] * z[8];
z[17] = (T(1) / T(4)) * z[17] + -z[25];
z[25] = -z[5] * z[17];
z[28] = (T(3) / T(2)) * z[11];
z[25] = z[6] + -z[23] + z[25] + -z[28];
z[25] = z[5] * z[25];
z[29] = (T(-13) / T(2)) * z[6] + z[18];
z[29] = z[7] * z[29];
z[25] = T(3) / T(4) + z[25] + z[29];
z[25] = z[5] * z[25];
z[29] = -11 + z[32];
z[29] = z[22] * z[29];
z[31] = z[4] * z[12];
z[26] = (T(1) / T(4)) * z[26];
z[31] = -z[26] + z[31];
z[32] = z[2] * z[31];
z[33] = z[5] * z[26];
z[33] = -z[4] + -z[12] + -z[32] + z[33];
z[33] = z[2] * z[33];
z[21] = z[8] + z[21];
z[34] = z[5] * z[21];
z[33] = z[33] + z[34];
z[33] = z[2] * z[33];
z[25] = z[25] + z[29] + z[33];
z[25] = z[0] * z[25];
z[29] = z[4] + z[6];
z[33] = (T(1) / T(2)) * z[10];
z[34] = z[29] * z[33];
z[34] = -z[17] + z[34];
z[34] = z[5] * z[34];
z[20] = z[10] + -z[20] + -z[23] + z[34];
z[20] = z[5] * z[20];
z[14] = z[6] + z[14];
z[23] = z[14] * z[16];
z[32] = z[8] + -z[32];
z[32] = z[2] * z[32];
z[34] = z[7] * z[10];
z[20] = -1 + z[20] + z[23] + z[25] + z[32] + z[34];
z[20] = z[0] * z[20];
z[23] = z[10] * z[29];
z[15] = z[15] * z[23];
z[15] = z[15] + z[20];
z[19] = -z[19] * z[22];
z[20] = prod_pow(z[2], 2) * z[31];
z[19] = z[19] + z[20] + -z[34];
z[20] = -z[6] + -z[10] + z[21] + -z[28];
z[21] = -z[17] + (T(-1) / T(4)) * z[23];
z[21] = z[5] * z[21];
z[20] = (T(1) / T(2)) * z[20] + z[21];
z[20] = z[5] * z[20];
z[19] = (T(1) / T(2)) * z[19] + z[20];
z[19] = z[0] * z[19];
z[20] = z[4] + -z[6];
z[20] = z[20] * z[33];
z[20] = -z[17] + z[20];
z[20] = z[5] * z[20];
z[21] = -z[10] + -z[11];
z[20] = z[20] + (T(1) / T(2)) * z[21];
z[20] = z[0] * z[20];
z[21] = -z[6] * z[33];
z[20] = -z[17] + z[20] + z[21];
z[20] = z[9] * z[20];
z[20] = (T(-11) / T(4)) * z[6] + z[8] + z[20] + z[33];
z[21] = -z[4] * z[33];
z[17] = -z[17] + z[21];
z[17] = z[5] * z[17];
z[17] = z[17] + z[19] + (T(1) / T(2)) * z[20];
z[17] = z[0] * z[17];
z[19] = (T(1) / T(4)) * z[10];
z[19] = z[6] * z[19];
z[17] = z[17] + z[19];
z[17] = z[9] * z[17];
z[15] = (T(1) / T(2)) * z[15] + z[17];
z[15] = z[9] * z[15];
z[17] = -z[5] * z[24];
z[17] = -z[7] + z[17];
z[14] = z[14] * z[17];
z[17] = z[6] + z[18];
z[16] = z[16] * z[17];
z[16] = -1 + z[16];
z[16] = z[16] * z[24];
z[14] = z[14] + z[16];
z[16] = z[26] * z[30];
z[16] = z[16] + z[27];
z[16] = z[5] * z[16];
z[16] = (T(3) / T(4)) * z[3] + z[16];
z[16] = z[2] * z[16];
z[14] = (T(1) / T(2)) * z[14] + z[16];
return z[13] + (T(1) / T(2)) * z[14] + z[15];
}



template double eval_coef_2q3y_2l_pmmpp_12345_139(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_139(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
