#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_140(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[34];
z[0] = iW[0];
z[1] = iW[1];
z[2] = v[2];
z[3] = v[3];
z[4] = v[4];
z[5] = iW[3];
z[6] = v[1];
z[7] = iW[16];
z[8] = iW[19];
z[9] = v[0];
z[10] = iW[2];
z[11] = iW[4];
z[12] = iW[23];
z[13] = prod_pow(z[9], 2);
z[14] = z[5] * z[13];
z[15] = (T(19) / T(6)) * z[14];
z[16] = z[9] * z[10];
z[17] = T(-19) / T(3) + -z[16];
z[17] = z[9] * z[17];
z[17] = z[15] + z[17];
z[17] = z[5] * z[17];
z[18] = z[3] + -z[9];
z[19] = z[0] * z[3];
z[20] = (T(3) / T(2)) * z[19];
z[21] = 1 + -z[20];
z[21] = z[2] * z[21];
z[18] = (T(1) / T(2)) * z[18] + z[21];
z[18] = z[1] * z[18];
z[21] = 3 * z[16];
z[22] = T(-31) / T(3) + z[21];
z[23] = (T(1) / T(2)) * z[3];
z[24] = -z[10] * z[23];
z[25] = z[5] * z[9];
z[26] = 9 + (T(-13) / T(6)) * z[25];
z[26] = z[5] * z[26];
z[26] = (T(25) / T(4)) * z[0] + z[26];
z[26] = z[2] * z[26];
z[17] = z[17] + z[18] + -z[20] + (T(1) / T(2)) * z[22] + z[24] + z[26];
z[18] = (T(1) / T(4)) * z[1];
z[17] = z[17] * z[18];
z[22] = -11 + (T(3) / T(2)) * z[16];
z[22] = z[22] * z[25];
z[24] = T(51) / T(2) + -z[16];
z[22] = z[22] + (T(1) / T(2)) * z[24];
z[24] = (T(1) / T(2)) * z[5];
z[22] = z[22] * z[24];
z[26] = -z[10] + -z[12];
z[22] = z[8] + z[22] + (T(1) / T(4)) * z[26];
z[26] = z[0] * z[5];
z[27] = (T(19) / T(3)) * z[5] + -z[8];
z[27] = z[5] * z[27];
z[27] = (T(13) / T(12)) * z[26] + z[27];
z[27] = z[2] * z[27];
z[17] = (T(4) / T(3)) * z[0] + z[17] + (T(1) / T(2)) * z[22] + (T(1) / T(4)) * z[27];
z[17] = z[1] * z[17];
z[22] = T(19) / T(3) + -z[16];
z[22] = z[22] * z[25];
z[22] = T(-21) / T(2) + z[16] + z[22];
z[22] = z[5] * z[22];
z[27] = -1 + z[19];
z[27] = z[1] * z[27];
z[22] = (T(-25) / T(6)) * z[0] + z[12] + z[22] + z[27];
z[27] = (T(1) / T(2)) * z[1];
z[22] = z[22] * z[27];
z[28] = z[5] * z[8];
z[22] = z[22] + z[28];
z[22] = z[4] * z[18] * z[22];
z[17] = z[17] + z[22] + (T(-5) / T(8)) * z[28];
z[17] = z[4] * z[17];
z[22] = T(23) / T(6) + z[16];
z[22] = z[9] * z[22];
z[22] = -z[15] + z[22];
z[22] = z[5] * z[22];
z[29] = (T(3) / T(4)) * z[19];
z[30] = T(47) / T(3) + -z[21];
z[31] = z[8] * z[23];
z[22] = z[22] + z[29] + (T(1) / T(4)) * z[30] + z[31];
z[30] = z[3] * z[12];
z[31] = (T(35) / T(6)) * z[9] + z[14];
z[31] = z[5] * z[31];
z[30] = z[30] + z[31];
z[31] = (T(1) / T(2)) * z[2];
z[32] = -1 + 3 * z[19];
z[32] = z[31] * z[32];
z[32] = -z[3] + (T(1) / T(2)) * z[9] + z[32];
z[18] = z[18] * z[32];
z[32] = 3 * z[5];
z[33] = -5 * z[0] + -z[32];
z[33] = z[2] * z[33];
z[18] = T(7) / T(3) + z[18] + z[29] + (T(1) / T(4)) * z[30] + (T(5) / T(16)) * z[33];
z[18] = z[2] * z[18];
z[29] = -31 * z[9] + -19 * z[14];
z[29] = -z[3] + (T(1) / T(24)) * z[29];
z[18] = z[18] + (T(1) / T(2)) * z[29];
z[18] = z[1] * z[18];
z[29] = prod_pow(z[5], 2);
z[30] = -5 * z[26] + -13 * z[29];
z[30] = z[2] * z[30];
z[33] = T(-49) / T(8) + 8 * z[25];
z[33] = z[5] * z[33];
z[30] = (T(-29) / T(12)) * z[0] + (T(-1) / T(2)) * z[8] + (T(1) / T(12)) * z[30] + (T(1) / T(3)) * z[33];
z[30] = z[2] * z[30];
z[18] = z[18] + (T(1) / T(2)) * z[22] + z[30];
z[18] = z[1] * z[18];
z[21] = 25 + -z[21];
z[21] = z[21] * z[25];
z[21] = T(-37) / T(2) + -z[16] + z[21];
z[21] = z[21] * z[24];
z[22] = z[26] + (T(-17) / T(2)) * z[29];
z[30] = z[0] * z[29];
z[33] = z[2] * z[30];
z[22] = 5 * z[22] + (T(19) / T(2)) * z[33];
z[22] = z[2] * z[22];
z[33] = 3 * z[8];
z[28] = z[6] * z[28];
z[21] = (T(-15) / T(4)) * z[0] + (T(1) / T(2)) * z[10] + z[12] + z[21] + (T(1) / T(3)) * z[22] + (T(3) / T(2)) * z[28] + -z[33];
z[17] = z[17] + z[18] + (T(1) / T(4)) * z[21];
z[17] = z[4] * z[17];
z[18] = z[11] * z[12];
z[21] = -z[7] + z[32];
z[21] = z[5] * z[21];
z[21] = z[18] + 5 * z[21];
z[22] = -z[7] + -z[33];
z[22] = (T(-11) / T(3)) * z[5] + (T(1) / T(2)) * z[22];
z[22] = z[6] * z[22];
z[22] = T(5) / T(6) + z[22];
z[22] = z[22] * z[26];
z[28] = z[7] * z[29];
z[29] = -z[28] + (T(-13) / T(6)) * z[30];
z[29] = z[2] * z[29];
z[21] = (T(1) / T(2)) * z[21] + z[22] + z[29];
z[21] = z[21] * z[31];
z[22] = (T(47) / T(3)) * z[5] + z[33];
z[22] = z[22] * z[24];
z[22] = z[18] + z[22];
z[24] = (T(1) / T(2)) * z[6];
z[22] = z[22] * z[24];
z[29] = (T(-15) / T(4)) * z[5] + -z[7] + (T(-3) / T(2)) * z[8];
z[29] = z[6] * z[29];
z[29] = T(17) / T(4) + z[29];
z[29] = z[0] * z[29];
z[29] = -z[11] + z[29];
z[30] = z[3] * z[18];
z[32] = 1 + (T(-17) / T(4)) * z[25];
z[32] = z[5] * z[32];
z[21] = -z[7] + (T(-3) / T(4)) * z[12] + z[21] + z[22] + (T(1) / T(2)) * z[29] + -z[30] + z[32];
z[21] = z[21] * z[31];
z[22] = z[7] * z[9];
z[29] = (T(-13) / T(12)) * z[9] + -z[14];
z[29] = z[5] * z[29];
z[30] = -z[8] + z[11] + z[30];
z[31] = (T(3) / T(2)) * z[12] + z[30];
z[31] = z[3] * z[31];
z[29] = T(-7) / T(3) + -z[20] + -z[22] + z[29] + z[31];
z[31] = z[18] * z[23];
z[22] = T(11) / T(6) + -5 * z[22];
z[22] = (T(1) / T(4)) * z[22] + z[25];
z[22] = z[5] * z[22];
z[32] = -z[9] * z[28];
z[26] = (T(7) / T(24)) * z[26] + z[32];
z[26] = z[2] * z[26];
z[22] = (T(13) / T(6)) * z[0] + z[22] + z[26] + -z[31];
z[22] = z[2] * z[22];
z[22] = z[22] + (T(1) / T(2)) * z[29];
z[22] = z[2] * z[22];
z[26] = z[7] * z[13];
z[26] = z[14] + (T(-1) / T(2)) * z[26];
z[26] = z[5] * z[26];
z[13] = -z[13] * z[28];
z[13] = (T(25) / T(12)) * z[0] + z[13];
z[13] = z[2] * z[13];
z[28] = prod_pow(z[3], 2) * z[18];
z[13] = T(-11) / T(3) + z[13] + -z[20] + z[26] + (T(1) / T(2)) * z[28];
z[13] = z[2] * z[13];
z[20] = (T(19) / T(6)) * z[9] + z[14];
z[13] = 3 * z[3] + z[13] + (T(1) / T(2)) * z[20];
z[13] = z[2] * z[13];
z[19] = -z[2] * z[19];
z[19] = z[3] + z[19];
z[19] = prod_pow(z[2], 2) * z[19] * z[27];
z[13] = z[13] + z[19];
z[13] = z[13] * z[27];
z[15] = 5 * z[3] + -z[9] + z[15];
z[13] = z[13] + (T(1) / T(4)) * z[15] + z[22];
z[13] = z[13] * z[27];
z[15] = (T(1) / T(4)) * z[16];
z[19] = T(-7) / T(3) + z[15];
z[19] = z[19] * z[25];
z[16] = T(7) / T(2) + z[16];
z[16] = (T(1) / T(4)) * z[16] + z[19];
z[16] = z[5] * z[16];
z[18] = z[6] * z[18];
z[18] = -z[11] + z[18];
z[19] = z[8] + -z[12];
z[16] = z[16] + (T(1) / T(4)) * z[18] + (T(3) / T(4)) * z[19] + -z[31];
z[16] = z[16] * z[24];
z[18] = z[9] * z[11];
z[19] = -z[7] + 3 * z[12] + z[30];
z[19] = z[3] * z[19];
z[18] = z[18] + z[19];
z[15] = T(-1) / T(3) + -z[15];
z[15] = z[9] * z[15];
z[14] = (T(19) / T(24)) * z[14] + z[15];
z[14] = z[5] * z[14];
z[15] = -z[6] * z[7] * z[23];
z[15] = -z[3] + z[15];
z[15] = z[0] * z[15];
return T(5) / T(8) + z[13] + z[14] + (T(1) / T(4)) * z[15] + z[16] + z[17] + (T(1) / T(8)) * z[18] + z[21];
}



template double eval_coef_2q3y_2l_pmmpp_12345_140(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_140(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
