#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_144(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[43];
z[0] = iW[0];
z[1] = iW[1];
z[2] = v[2];
z[3] = v[3];
z[4] = v[4];
z[5] = iW[3];
z[6] = iW[21];
z[7] = v[1];
z[8] = iW[15];
z[9] = iW[17];
z[10] = iW[5];
z[11] = v[0];
z[12] = iW[12];
z[13] = iW[18];
z[14] = (T(1) / T(2)) * z[5];
z[15] = z[10] * z[11];
z[16] = -7 + 3 * z[15];
z[16] = z[14] * z[16];
z[17] = (T(1) / T(4)) * z[0];
z[18] = z[2] * z[5];
z[19] = -z[17] * z[18];
z[20] = z[5] * z[11];
z[21] = (T(1) / T(2)) * z[0];
z[22] = z[5] + z[21];
z[23] = z[2] * z[22];
z[23] = -z[20] + z[23];
z[24] = (T(1) / T(2)) * z[6];
z[23] = z[23] * z[24];
z[25] = z[0] * z[9];
z[26] = (T(1) / T(2)) * z[9];
z[27] = -z[10] + z[26];
z[27] = z[9] * z[27];
z[27] = z[25] + z[27];
z[28] = (T(1) / T(2)) * z[3];
z[27] = z[27] * z[28];
z[22] = z[6] * z[22];
z[29] = (T(1) / T(2)) * z[8];
z[30] = z[6] * z[29];
z[31] = -z[0] * z[4] * z[30];
z[22] = z[22] + z[31];
z[22] = z[4] * z[22];
z[31] = 2 * z[12];
z[32] = (T(1) / T(4)) * z[13];
z[16] = (T(-5) / T(4)) * z[0] + (T(1) / T(4)) * z[9] + z[10] + z[16] + z[19] + (T(1) / T(2)) * z[22] + z[23] + z[27] + -z[31] + z[32];
z[16] = z[4] * z[16];
z[19] = 4 * z[12];
z[22] = (T(-9) / T(4)) * z[5] + -z[19] + z[26];
z[23] = z[2] * z[9];
z[22] = z[22] * z[23];
z[27] = (T(1) / T(4)) * z[6];
z[33] = -1 + 3 * z[20];
z[33] = z[27] * z[33];
z[34] = z[9] * z[10];
z[35] = z[28] * z[34];
z[36] = -z[5] + -z[29];
z[36] = z[4] * z[24] * z[36];
z[37] = T(3) / T(2) + -z[15];
z[37] = z[5] * z[37];
z[22] = (T(-3) / T(4)) * z[9] + z[10] + (T(-1) / T(2)) * z[13] + z[22] + z[31] + z[33] + z[35] + z[36] + (T(3) / T(2)) * z[37];
z[22] = z[4] * z[22];
z[33] = z[9] + -z[12];
z[17] = z[17] + -z[33];
z[30] = z[30] + z[34];
z[35] = z[28] * z[30];
z[36] = prod_pow(z[9], 2);
z[37] = z[2] * z[36];
z[38] = z[10] + z[37];
z[38] = z[17] + z[27] + -z[29] + z[35] + (T(1) / T(2)) * z[38];
z[38] = z[3] * z[38];
z[39] = z[11] * z[13];
z[40] = 3 + -z[39];
z[41] = (T(9) / T(4)) * z[9] + z[32];
z[42] = -5 * z[12] + z[41];
z[42] = z[2] * z[42];
z[22] = z[22] + z[38] + (T(1) / T(2)) * z[40] + z[42];
z[22] = z[4] * z[22];
z[38] = (T(3) / T(4)) * z[5];
z[40] = z[31] + z[38];
z[40] = z[9] * z[40];
z[38] = -z[12] + -z[38];
z[37] = z[37] * z[38];
z[37] = z[37] + z[40];
z[37] = z[2] * z[37];
z[38] = 1 + z[20];
z[27] = -z[27] * z[38];
z[40] = -1 + (T(1) / T(2)) * z[20];
z[40] = z[10] * z[40];
z[27] = -z[12] + z[26] + z[27] + z[32] + -z[35] + z[37] + z[40];
z[27] = z[4] * z[27];
z[30] = z[3] * z[30];
z[32] = (T(1) / T(4)) * z[8];
z[24] = -z[10] + -z[24] + -z[30] + z[32] + z[33];
z[24] = z[3] * z[24];
z[26] = -3 * z[12] + z[26];
z[23] = z[23] * z[26];
z[19] = z[19] + z[23] + -z[41];
z[19] = z[2] * z[19];
z[23] = 1 + (T(1) / T(2)) * z[39];
z[19] = z[19] + (T(1) / T(2)) * z[23] + z[24] + z[27];
z[19] = z[4] * z[19];
z[23] = (T(1) / T(4)) * z[2];
z[24] = z[23] * z[36];
z[24] = -z[9] + z[24] + z[31];
z[24] = z[2] * z[24];
z[26] = z[9] + z[29] + -z[30];
z[26] = z[26] * z[28];
z[24] = T(-1) / T(4) + z[24] + z[26];
z[24] = z[3] * z[24];
z[26] = z[2] * z[33];
z[26] = T(1) / T(4) + 3 * z[26];
z[26] = z[2] * z[26];
z[19] = z[19] + z[24] + z[26];
z[19] = z[4] * z[19];
z[24] = prod_pow(z[2], 2) * z[33];
z[26] = -z[3] * z[8] * z[23];
z[24] = z[24] + z[26];
z[24] = z[3] * z[24];
z[19] = z[19] + z[24];
z[19] = z[1] * z[19];
z[17] = -z[17] + z[32];
z[17] = z[2] * z[17];
z[24] = -z[3] * z[32];
z[17] = T(1) / T(4) + z[17] + z[24];
z[17] = z[3] * z[17];
z[17] = z[17] + z[19] + z[22] + z[23];
z[17] = z[1] * z[17];
z[19] = -7 + -z[20] + z[39];
z[20] = z[18] * z[21];
z[20] = -z[5] + z[20];
z[22] = 3 * z[0] + -z[20];
z[22] = z[2] * z[22];
z[20] = -z[2] * z[20];
z[20] = z[20] + (T(-1) / T(2)) * z[38];
z[20] = z[2] * z[20];
z[20] = (T(1) / T(2)) * z[11] + z[20];
z[20] = z[6] * z[20];
z[19] = (T(1) / T(2)) * z[19] + z[20] + z[22];
z[15] = T(7) / T(2) + -z[15];
z[14] = z[14] * z[15];
z[15] = z[0] * z[18];
z[14] = -z[10] + z[14] + (T(-5) / T(4)) * z[15] + z[21];
z[14] = z[7] * z[14];
z[15] = z[25] + -z[34];
z[18] = z[3] + -z[7];
z[15] = z[15] * z[18];
z[15] = -z[0] + z[10] + z[15] + z[29];
z[15] = z[15] * z[28];
return z[14] + z[15] + z[16] + z[17] + (T(1) / T(2)) * z[19];
}



template double eval_coef_2q3y_2l_pmmpp_12345_144(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_144(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
