#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_150(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[49];
z[0] = iW[0];
z[1] = iW[1];
z[2] = iW[9];
z[3] = v[3];
z[4] = v[4];
z[5] = v[2];
z[6] = iW[3];
z[7] = iW[21];
z[8] = iW[22];
z[9] = v[1];
z[10] = iW[15];
z[11] = v[0];
z[12] = iW[4];
z[13] = iW[23];
z[14] = prod_pow(z[1], 2);
z[15] = z[3] * z[14];
z[16] = z[11] * z[14];
z[17] = z[15] + -z[16];
z[18] = z[0] * z[5];
z[19] = z[14] * z[18];
z[20] = (T(1) / T(2)) * z[0];
z[21] = z[1] + z[20];
z[22] = z[1] * z[21];
z[19] = z[19] + -z[22];
z[22] = -z[5] * z[19];
z[23] = z[4] * z[14];
z[24] = z[0] * z[23];
z[19] = z[19] + -z[24];
z[19] = z[4] * z[19];
z[25] = (T(3) / T(2)) * z[1];
z[19] = (T(13) / T(3)) * z[0] + z[17] + 3 * z[19] + z[22] + -z[25];
z[22] = (T(1) / T(2)) * z[3];
z[19] = z[19] * z[22];
z[26] = (T(1) / T(2)) * z[5];
z[27] = z[14] * z[26];
z[28] = -z[1] + z[20];
z[29] = (T(3) / T(2)) * z[16] + -z[27] + -z[28];
z[30] = prod_pow(z[5], 2);
z[29] = z[29] * z[30];
z[31] = z[5] * z[14];
z[17] = z[1] + -z[17] + z[31];
z[17] = z[3] * z[17];
z[32] = -z[1] + z[31];
z[33] = z[5] * z[32];
z[34] = z[11] * z[31];
z[17] = z[17] + z[33] + -3 * z[34];
z[17] = z[17] * z[22];
z[17] = z[17] + z[29];
z[17] = z[7] * z[17];
z[29] = (T(19) / T(6)) * z[0];
z[33] = z[1] + z[29];
z[34] = z[1] * z[4];
z[35] = -z[33] * z[34];
z[36] = -25 * z[0] + -7 * z[1];
z[35] = z[35] + (T(1) / T(6)) * z[36];
z[35] = z[4] * z[35];
z[35] = T(19) / T(6) + z[18] + z[35];
z[35] = z[4] * z[35];
z[25] = -z[23] + z[25];
z[25] = z[4] * z[25];
z[25] = T(-1) / T(2) + z[25];
z[25] = z[11] * z[25];
z[25] = z[25] + z[26] + z[35];
z[35] = -1 + z[18];
z[36] = -z[34] + z[35];
z[36] = z[4] * z[36];
z[37] = z[0] + z[1];
z[38] = z[0] * z[34];
z[38] = z[37] + z[38];
z[38] = z[4] * z[38];
z[38] = -1 + z[38];
z[38] = z[3] * z[38];
z[39] = 1 + -z[34];
z[39] = z[11] * z[39];
z[36] = -z[5] + z[36] + z[38] + z[39];
z[36] = z[2] * z[4] * z[36];
z[38] = (T(3) / T(2)) * z[0] + z[1];
z[38] = z[1] * z[38];
z[24] = z[24] + z[38];
z[24] = z[4] * z[24];
z[24] = z[21] + (T(1) / T(2)) * z[24];
z[24] = z[4] * z[24];
z[24] = T(1) / T(4) + z[24];
z[24] = z[3] * z[24];
z[24] = z[24] + (T(1) / T(2)) * z[25] + (T(1) / T(4)) * z[36];
z[24] = z[2] * z[24];
z[25] = z[1] * z[5];
z[36] = -19 * z[0] + (T(239) / T(3)) * z[1];
z[36] = z[25] * z[36];
z[38] = z[0] + (T(-65) / T(18)) * z[1];
z[34] = z[34] * z[38];
z[34] = (T(161) / T(9)) * z[1] + (T(19) / T(4)) * z[34] + (T(1) / T(4)) * z[36];
z[34] = z[4] * z[34];
z[36] = (T(1) / T(2)) * z[25];
z[29] = -z[1] + z[29];
z[29] = z[29] * z[36];
z[28] = (T(5) / T(3)) * z[28] + z[29];
z[28] = z[5] * z[28];
z[29] = z[23] + z[32];
z[29] = z[11] * z[29];
z[17] = T(-607) / T(72) + z[17] + z[19] + z[24] + z[28] + z[29] + z[34];
z[19] = z[30] * z[35];
z[24] = (T(121) / T(4)) * z[1] + -79 * z[31];
z[24] = (T(13) / T(4)) * z[23] + (T(1) / T(3)) * z[24];
z[24] = z[4] * z[24];
z[28] = 277 * z[31];
z[29] = (T(433) / T(2)) * z[1] + z[28];
z[29] = z[5] * z[29];
z[29] = -359 + z[29];
z[24] = z[24] + (T(1) / T(12)) * z[29];
z[24] = z[4] * z[24];
z[24] = (T(13) / T(4)) * z[5] + z[24];
z[24] = z[4] * z[24];
z[29] = (T(1) / T(2)) * z[9];
z[34] = T(121) / T(12) + 13 * z[18];
z[34] = z[5] * z[34];
z[34] = (T(199) / T(6)) * z[4] + z[34];
z[34] = z[29] * z[34];
z[24] = (T(-13) / T(4)) * z[19] + z[24] + z[34];
z[34] = (T(1) / T(2)) * z[6];
z[24] = z[24] * z[34];
z[38] = z[0] * z[3];
z[39] = z[4] * z[31];
z[40] = (T(79) / T(3)) * z[0] + (T(329) / T(4)) * z[1] + (T(145) / T(2)) * z[31];
z[40] = z[5] * z[40];
z[40] = (T(433) / T(24)) * z[38] + (T(-355) / T(12)) * z[39] + z[40];
z[40] = z[22] * z[40];
z[41] = 20 * z[1] + (T(-671) / T(8)) * z[31];
z[41] = (T(13) / T(8)) * z[23] + (T(1) / T(3)) * z[41];
z[41] = z[4] * z[41];
z[42] = (T(407) / T(2)) * z[1] + z[28];
z[42] = z[5] * z[42];
z[42] = T(-199) / T(3) + z[42];
z[41] = z[41] + (T(1) / T(8)) * z[42];
z[41] = z[4] * z[41];
z[42] = z[9] * z[18];
z[43] = (T(121) / T(6)) * z[0] + 13 * z[1];
z[43] = z[5] * z[43];
z[43] = T(-199) / T(6) + z[43];
z[43] = z[5] * z[43];
z[24] = z[24] + z[40] + z[41] + (T(13) / T(4)) * z[42] + (T(1) / T(8)) * z[43];
z[35] = z[5] * z[35];
z[35] = z[35] + z[42];
z[40] = (T(1) / T(3)) * z[1];
z[41] = (T(1) / T(4)) * z[31];
z[42] = z[40] + z[41];
z[42] = z[5] * z[42];
z[42] = (T(-1) / T(6)) * z[39] + z[42];
z[42] = z[4] * z[42];
z[43] = z[27] + z[37];
z[43] = z[5] * z[43];
z[44] = z[3] * z[20];
z[43] = z[43] + z[44];
z[43] = z[3] * z[43];
z[35] = (T(1) / T(12)) * z[35] + z[42] + (T(1) / T(6)) * z[43];
z[35] = z[3] * z[35];
z[42] = (T(1) / T(2)) * z[1];
z[43] = (T(1) / T(4)) * z[23] + -z[31] + -z[42];
z[44] = (T(1) / T(3)) * z[4];
z[43] = z[43] * z[44];
z[45] = (T(5) / T(3)) * z[1] + z[31];
z[45] = z[5] * z[45];
z[45] = T(1) / T(3) + z[45];
z[43] = z[43] + (T(1) / T(4)) * z[45];
z[45] = prod_pow(z[4], 2);
z[43] = z[43] * z[45];
z[46] = (T(1) / T(3)) * z[31];
z[47] = (T(1) / T(6)) * z[23] + -z[42] + -z[46];
z[47] = z[4] * z[47];
z[48] = z[1] + z[46];
z[48] = z[5] * z[48];
z[48] = 1 + z[48];
z[47] = z[47] + (T(1) / T(2)) * z[48];
z[47] = prod_pow(z[4], 3) * z[47];
z[48] = -z[4] + -z[5];
z[48] = z[4] * z[48];
z[19] = z[19] + z[48];
z[48] = (T(1) / T(6)) * z[9];
z[19] = z[19] * z[48];
z[19] = z[19] + z[47];
z[19] = z[19] * z[34];
z[18] = T(-1) / T(2) + z[18];
z[18] = z[5] * z[18] * z[48];
z[18] = z[18] + z[19] + z[35] + z[43];
z[18] = z[8] * z[18];
z[19] = -z[20] + (T(-1) / T(6)) * z[31] + -z[40];
z[19] = z[5] * z[19];
z[19] = z[19] + (T(-1) / T(6)) * z[38];
z[19] = z[3] * z[19];
z[20] = -z[37] + -z[46];
z[34] = (T(1) / T(2)) * z[30];
z[20] = z[20] * z[34];
z[19] = z[19] + z[20];
z[19] = z[3] * z[19];
z[20] = prod_pow(z[5], 3);
z[35] = z[20] * z[37];
z[19] = z[19] + (T(-1) / T(6)) * z[35];
z[19] = z[10] * z[19];
z[18] = (T(277) / T(12)) * z[18] + (T(13) / T(4)) * z[19] + (T(1) / T(3)) * z[24];
z[18] = z[8] * z[18];
z[14] = -z[14] * z[20];
z[15] = z[15] * z[30];
z[14] = z[14] + z[15];
z[14] = z[3] * z[14];
z[14] = z[14] + -z[35];
z[14] = z[7] * z[14];
z[15] = -z[5] * z[33];
z[15] = T(59) / T(6) + z[15];
z[15] = z[5] * z[15];
z[14] = z[14] + z[15];
z[15] = (T(1) / T(3)) * z[5];
z[19] = (T(-19) / T(8)) * z[0] + -8 * z[1];
z[15] = z[15] * z[19];
z[19] = -4 * z[0] + (T(19) / T(8)) * z[1];
z[19] = z[19] * z[44];
z[15] = T(-15) / T(4) + z[15] + z[19];
z[15] = z[4] * z[15];
z[19] = 13 * z[0];
z[24] = -49 * z[1] + -z[19];
z[24] = (T(1) / T(4)) * z[24] + -4 * z[31];
z[24] = z[5] * z[24];
z[19] = 19 * z[1] + -z[19];
z[19] = z[4] * z[19];
z[19] = T(-59) / T(8) + (T(1) / T(8)) * z[19] + z[24] + (T(-13) / T(8)) * z[38];
z[19] = z[3] * z[19];
z[24] = z[0] * z[4];
z[24] = 1 + z[24];
z[24] = z[2] * z[24] * z[45];
z[14] = (T(23) / T(12)) * z[9] + (T(1) / T(4)) * z[14] + z[15] + (T(1) / T(3)) * z[19] + (T(19) / T(24)) * z[24];
z[14] = z[10] * z[14];
z[15] = -z[26] * z[32];
z[15] = T(55) / T(9) + z[15];
z[19] = (T(-55) / T(9)) * z[1] + (T(55) / T(18)) * z[23] + -z[41];
z[19] = z[4] * z[19];
z[15] = (T(1) / T(2)) * z[15] + z[19];
z[15] = z[11] * z[15];
z[19] = (T(589) / T(2)) * z[1] + (T(-355) / T(2)) * z[23] + z[28];
z[19] = z[4] * z[19];
z[19] = T(-113) / T(12) + (T(1) / T(6)) * z[19] + -19 * z[25];
z[19] = z[4] * z[19];
z[16] = (T(-1) / T(2)) * z[16] + -z[21];
z[16] = z[7] * z[16] * z[20];
z[20] = (T(-4) / T(3)) * z[0] + -z[42];
z[20] = z[5] * z[20];
z[20] = T(-163) / T(72) + z[20];
z[20] = z[5] * z[20];
z[15] = (T(-121) / T(144)) * z[9] + z[15] + (T(1) / T(2)) * z[16] + (T(1) / T(12)) * z[19] + z[20];
z[15] = z[6] * z[15];
z[16] = z[1] + -z[23];
z[16] = z[4] * z[16];
z[16] = -2 + z[16];
z[16] = z[16] * z[44];
z[19] = -1 + -z[25] + (T(-2) / T(3)) * z[39];
z[19] = z[3] * z[19];
z[20] = z[5] + z[9];
z[16] = z[16] + z[19] + z[20];
z[19] = z[1] + z[27];
z[19] = z[5] * z[19];
z[19] = T(1) / T(2) + z[19];
z[21] = z[19] * z[22];
z[22] = 1 + z[36];
z[22] = z[5] * z[22];
z[21] = z[21] + -z[22] + -z[29];
z[21] = z[3] * z[21];
z[22] = z[5] + z[29];
z[22] = z[9] * z[22];
z[22] = z[22] + z[34];
z[21] = z[21] + (T(1) / T(2)) * z[22];
z[22] = z[10] * z[21];
z[16] = 32 * z[16] + (T(7) / T(2)) * z[22];
z[16] = z[13] * z[16];
z[21] = -z[13] * z[21];
z[19] = prod_pow(z[3], 2) * z[8] * z[19];
z[19] = (T(1) / T(2)) * z[19] + (T(1) / T(4)) * z[20] + z[21];
z[19] = z[12] * z[19];
return z[14] + z[15] + (T(1) / T(3)) * z[16] + (T(1) / T(2)) * z[17] + z[18] + (T(277) / T(18)) * z[19];
}



template double eval_coef_2q3y_2l_pmmpp_12345_150(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_150(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
