#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_157(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[46];
z[0] = iW[1];
z[1] = iW[3];
z[2] = iW[21];
z[3] = v[0];
z[4] = v[2];
z[5] = iW[22];
z[6] = v[4];
z[7] = iW[4];
z[8] = v[3];
z[9] = iW[17];
z[10] = iW[18];
z[11] = z[5] + (T(1) / T(4)) * z[9];
z[11] = z[5] * z[11];
z[12] = prod_pow(z[9], 2);
z[13] = (T(1) / T(4)) * z[12];
z[11] = z[11] + -z[13];
z[11] = z[5] * z[11];
z[14] = z[8] * z[11];
z[15] = z[5] + (T(1) / T(2)) * z[9];
z[16] = z[5] * z[15];
z[17] = z[14] + z[16];
z[17] = z[8] * z[17];
z[18] = prod_pow(z[3], 2);
z[19] = z[1] * z[18];
z[20] = prod_pow(z[2], 2);
z[21] = -z[19] * z[20];
z[17] = z[17] + z[21];
z[21] = (T(1) / T(2)) * z[8];
z[22] = prod_pow(z[5], 2);
z[23] = z[21] * z[22];
z[24] = z[5] + z[23];
z[25] = (T(1) / T(4)) * z[8];
z[26] = z[7] * z[25];
z[27] = z[24] * z[26];
z[28] = z[6] * z[22];
z[29] = (T(1) / T(2)) * z[1];
z[30] = z[5] + z[29];
z[31] = z[28] * z[30];
z[32] = prod_pow(z[5], 3);
z[33] = z[8] * z[32];
z[34] = z[31] + z[33];
z[35] = (T(1) / T(4)) * z[22] + z[34];
z[35] = z[6] * z[35];
z[17] = (T(1) / T(2)) * z[17] + z[27] + z[35];
z[17] = z[4] * z[17];
z[35] = (T(3) / T(2)) * z[22];
z[36] = z[33] + z[35];
z[36] = z[8] * z[36];
z[37] = 2 * z[5];
z[38] = -z[1] + -z[37];
z[28] = z[28] * z[38];
z[38] = (T(5) / T(2)) * z[5];
z[39] = z[1] + z[38];
z[39] = z[5] * z[39];
z[28] = z[28] + z[39];
z[28] = z[6] * z[28];
z[39] = (T(1) / T(2)) * z[5];
z[28] = z[28] + z[36] + z[39];
z[28] = z[6] * z[28];
z[36] = z[8] * z[22];
z[40] = 3 * z[5];
z[36] = z[36] + z[40];
z[36] = z[8] * z[36];
z[36] = 1 + z[36];
z[26] = z[26] * z[36];
z[36] = z[14] + (T(3) / T(2)) * z[16];
z[41] = prod_pow(z[8], 2);
z[36] = z[36] * z[41];
z[42] = z[1] * z[2];
z[43] = (T(1) / T(2)) * z[20];
z[42] = z[42] + -z[43];
z[44] = prod_pow(z[10], 2);
z[45] = -z[42] + (T(-3) / T(8)) * z[44];
z[45] = z[18] * z[45];
z[17] = z[17] + z[26] + z[28] + z[36] + z[45];
z[17] = z[4] * z[17];
z[28] = z[9] + z[40];
z[28] = z[5] * z[28];
z[12] = (T(-1) / T(2)) * z[12] + z[28];
z[12] = (T(1) / T(2)) * z[12] + z[14];
z[12] = z[12] * z[21];
z[28] = z[1] + (T(3) / T(2)) * z[5];
z[28] = z[28] * z[39];
z[28] = z[28] + (T(1) / T(2)) * z[31] + z[33];
z[28] = z[6] * z[28];
z[12] = z[12] + z[15] + z[27] + z[28];
z[12] = z[4] * z[12];
z[27] = (T(9) / T(4)) * z[22] + z[33];
z[27] = z[8] * z[27];
z[28] = -z[5] * z[29];
z[28] = z[28] + -z[34];
z[34] = (T(3) / T(2)) * z[6];
z[28] = z[28] * z[34];
z[36] = z[1] + z[5];
z[27] = z[27] + z[28] + (T(1) / T(2)) * z[36];
z[27] = z[6] * z[27];
z[13] = -z[13] + z[14];
z[14] = (T(3) / T(4)) * z[9] + z[37];
z[14] = z[5] * z[14];
z[14] = z[13] + z[14];
z[14] = z[8] * z[14];
z[14] = z[14] + (T(11) / T(4)) * z[15];
z[14] = z[8] * z[14];
z[28] = prod_pow(z[3], 3) * z[1] * z[20];
z[12] = T(1) / T(2) + z[12] + z[14] + z[26] + z[27] + (T(-1) / T(4)) * z[28];
z[12] = z[4] * z[12];
z[14] = -z[20] + (T(3) / T(2)) * z[44];
z[14] = z[8] * z[14];
z[14] = z[2] + (T(-3) / T(2)) * z[10] + z[14];
z[26] = -z[3] * z[42];
z[14] = (T(1) / T(4)) * z[14] + z[26];
z[14] = z[3] * z[14];
z[14] = T(1) / T(2) + z[14];
z[14] = z[3] * z[14];
z[26] = 3 * z[22];
z[27] = -z[26] + -2 * z[33];
z[27] = z[8] * z[27];
z[28] = z[31] + -z[35];
z[28] = z[28] * z[34];
z[27] = z[27] + z[28] + -z[30];
z[27] = z[6] * z[27];
z[28] = z[22] * z[41];
z[34] = z[3] * z[29];
z[27] = T(1) / T(4) + z[27] + z[28] + z[34];
z[27] = z[6] * z[27];
z[25] = z[22] * z[25];
z[25] = z[5] + z[25];
z[25] = z[8] * z[25];
z[25] = T(3) / T(4) + z[25];
z[25] = z[25] * z[41];
z[28] = z[3] * z[21];
z[25] = z[25] + z[28];
z[28] = (T(1) / T(2)) * z[7];
z[25] = z[25] * z[28];
z[28] = z[9] + z[38];
z[28] = z[5] * z[28];
z[13] = z[13] + z[28];
z[13] = z[13] * z[21];
z[13] = z[9] + z[13] + z[37];
z[13] = z[8] * z[13];
z[13] = T(3) / T(4) + z[13];
z[13] = z[8] * z[13];
z[12] = z[12] + z[13] + z[14] + z[25] + z[27];
z[12] = z[4] * z[12];
z[13] = z[2] + (T(3) / T(4)) * z[10];
z[13] = z[10] * z[13];
z[13] = z[13] + z[43];
z[13] = z[13] * z[21];
z[14] = -z[10] + z[13];
z[27] = -z[2] + z[14];
z[27] = z[8] * z[27];
z[28] = -z[1] + z[2];
z[14] = -z[14] + (T(3) / T(2)) * z[28];
z[14] = z[3] * z[14];
z[14] = T(9) / T(8) + z[14] + z[27];
z[14] = z[3] * z[14];
z[14] = (T(1) / T(8)) * z[8] + z[14];
z[14] = z[3] * z[14];
z[27] = z[31] + -z[33];
z[28] = z[29] + z[40];
z[28] = z[5] * z[28];
z[28] = -z[27] + z[28];
z[28] = z[6] * z[28];
z[29] = z[32] * z[41];
z[28] = -z[5] + z[28] + z[29];
z[29] = (T(1) / T(2)) * z[6];
z[28] = z[28] * z[29];
z[26] = -z[26] + -z[33];
z[26] = z[21] * z[26];
z[26] = -z[5] + z[26];
z[26] = z[8] * z[26];
z[32] = z[1] * z[3];
z[26] = T(-1) / T(4) + z[26] + z[28] + (T(-1) / T(4)) * z[32];
z[26] = z[6] * z[26];
z[28] = prod_pow(z[8], 3);
z[32] = z[22] * z[28];
z[19] = z[19] + (T(1) / T(2)) * z[32];
z[19] = (T(1) / T(2)) * z[19] + z[26];
z[19] = z[6] * z[19];
z[15] = z[8] * z[15];
z[15] = T(1) / T(2) + z[15];
z[15] = z[15] * z[41];
z[12] = z[12] + z[14] + (T(1) / T(4)) * z[15] + z[19];
z[12] = z[0] * z[12];
z[14] = z[22] + -z[33];
z[14] = z[8] * z[14];
z[14] = z[1] + z[14] + z[40];
z[15] = -z[1] + (T(-11) / T(4)) * z[5];
z[15] = z[5] * z[15];
z[15] = z[15] + z[27];
z[15] = z[6] * z[15];
z[14] = (T(1) / T(2)) * z[14] + z[15];
z[14] = z[6] * z[14];
z[15] = z[8] * z[24];
z[14] = T(1) / T(4) + z[14] + z[15];
z[14] = z[6] * z[14];
z[11] = z[11] * z[21];
z[11] = z[11] + z[16];
z[11] = z[11] * z[28];
z[13] = -z[1] + (T(3) / T(4)) * z[2] + (T(7) / T(8)) * z[10] + -z[13];
z[13] = z[13] * z[18];
z[11] = z[11] + z[12] + z[13] + z[14] + z[17] + z[25];
z[11] = z[0] * z[11];
z[12] = 3 * z[1] + 5 * z[5];
z[12] = z[12] * z[39];
z[12] = z[12] + -z[27];
z[12] = z[12] * z[29];
z[12] = z[12] + -z[23] + -z[30];
z[12] = z[6] * z[12];
z[13] = -z[5] * z[36];
z[13] = z[13] + z[31];
z[13] = z[6] * z[13];
z[14] = -z[4] * z[20] * z[34];
z[13] = z[13] + z[14];
z[13] = z[4] * z[13];
return z[11] + z[12] + (T(1) / T(2)) * z[13] + z[34];
}



template double eval_coef_2q3y_2l_pmmpp_12345_157(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_157(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
