#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_161(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[46];
z[0] = iW[1];
z[1] = iW[2];
z[2] = iW[21];
z[3] = v[0];
z[4] = v[3];
z[5] = iW[3];
z[6] = v[2];
z[7] = iW[22];
z[8] = v[4];
z[9] = iW[4];
z[10] = iW[17];
z[11] = iW[18];
z[12] = (T(1) / T(2)) * z[4];
z[13] = prod_pow(z[0], 2);
z[14] = z[12] * z[13];
z[15] = 2 * z[6];
z[16] = z[13] * z[15];
z[17] = -z[0] + -z[14] + -z[16];
z[17] = z[4] * z[17];
z[18] = (T(3) / T(2)) * z[6];
z[19] = z[13] * z[18];
z[20] = z[0] + z[19];
z[21] = z[6] * z[20];
z[17] = 1 + z[17] + -3 * z[21];
z[17] = z[4] * z[17];
z[21] = z[4] * z[13];
z[22] = z[6] * z[13];
z[23] = -z[0] + 3 * z[21] + 6 * z[22];
z[23] = z[4] * z[23];
z[24] = 11 * z[0] + 9 * z[22];
z[25] = 3 * z[13];
z[26] = -z[8] * z[25];
z[24] = (T(1) / T(2)) * z[24] + z[26];
z[24] = z[8] * z[24];
z[26] = z[0] * z[6];
z[26] = T(-1) / T(2) + -z[26];
z[23] = z[23] + z[24] + 5 * z[26];
z[23] = z[8] * z[23];
z[24] = 3 * z[22];
z[26] = -z[0] + -z[24];
z[26] = z[6] * z[26];
z[26] = 1 + (T(1) / T(2)) * z[26];
z[26] = z[6] * z[26];
z[17] = z[17] + z[23] + z[26];
z[17] = z[8] * z[17];
z[23] = z[8] * z[13];
z[26] = 2 * z[0];
z[27] = -z[21] + z[23] + -z[24] + -z[26];
z[27] = z[8] * z[27];
z[28] = -z[21] + z[26];
z[28] = z[4] * z[28];
z[29] = 4 * z[0] + z[24];
z[29] = z[6] * z[29];
z[27] = 1 + z[27] + z[28] + z[29];
z[27] = z[8] * z[27];
z[28] = prod_pow(z[6], 2);
z[25] = z[25] * z[28];
z[29] = 4 * z[22];
z[30] = z[0] + z[21] + z[29];
z[30] = z[4] * z[30];
z[25] = -1 + z[25] + z[30];
z[25] = z[4] * z[25];
z[30] = -z[22] + -z[26];
z[30] = z[6] * z[30];
z[30] = -1 + z[30];
z[30] = z[6] * z[30];
z[25] = z[25] + z[27] + z[30];
z[25] = z[8] * z[25];
z[27] = z[0] + z[22];
z[30] = z[27] * z[28];
z[31] = z[4] * z[27];
z[32] = -z[6] * z[31];
z[32] = -z[30] + z[32];
z[32] = z[4] * z[32];
z[25] = z[25] + 2 * z[32];
z[25] = z[8] * z[25];
z[32] = -z[15] * z[27];
z[32] = -z[31] + z[32];
z[32] = z[4] * z[32];
z[30] = -z[30] + z[32];
z[32] = prod_pow(z[4], 2);
z[30] = z[30] * z[32];
z[25] = z[25] + z[30];
z[25] = z[7] * z[25];
z[30] = 3 * z[0];
z[33] = -z[29] + -z[30];
z[33] = z[6] * z[33];
z[34] = (T(-5) / T(2)) * z[22] + -z[26];
z[34] = z[4] * z[34];
z[33] = z[33] + z[34];
z[33] = z[4] * z[33];
z[34] = -z[20] * z[28];
z[33] = z[33] + z[34];
z[33] = z[4] * z[33];
z[17] = z[17] + z[25] + z[33];
z[17] = z[7] * z[17];
z[25] = z[16] + 2 * z[21] + z[23] + -z[30];
z[25] = z[8] * z[25];
z[33] = z[6] * z[27];
z[34] = -z[4] * z[26];
z[25] = 2 + z[25] + -z[33] + z[34];
z[25] = z[8] * z[25];
z[34] = z[13] * z[28];
z[29] = -z[14] + -z[29];
z[29] = z[4] * z[29];
z[29] = z[29] + (T(-11) / T(2)) * z[34];
z[29] = z[4] * z[29];
z[35] = prod_pow(z[6], 3);
z[36] = z[13] * z[35];
z[17] = z[17] + z[25] + z[29] + -2 * z[36];
z[17] = z[7] * z[17];
z[25] = z[3] * z[13];
z[29] = z[22] + z[25];
z[29] = z[6] * z[29];
z[37] = prod_pow(z[3], 2);
z[38] = z[13] * z[37];
z[39] = (T(1) / T(2)) * z[25];
z[40] = -z[0] + z[22] + z[39];
z[40] = z[8] * z[40];
z[40] = 1 + -z[29] + -z[38] + z[40];
z[40] = z[8] * z[40];
z[41] = z[19] + -z[26];
z[41] = z[6] * z[41];
z[42] = (T(1) / T(2)) * z[13];
z[43] = z[8] * z[42];
z[44] = z[26] + -z[43];
z[44] = z[8] * z[44];
z[41] = T(-3) / T(2) + z[41] + z[44];
z[41] = z[8] * z[41];
z[44] = 1 + -z[34];
z[44] = z[6] * z[44];
z[41] = z[41] + z[44];
z[41] = z[8] * z[41];
z[19] = z[19] + z[26];
z[19] = z[6] * z[19];
z[20] = -z[20] + z[43];
z[20] = z[8] * z[20];
z[19] = T(1) / T(2) + z[19] + z[20];
z[19] = z[8] * z[19];
z[20] = -z[0] + (T(-1) / T(2)) * z[22];
z[20] = z[6] * z[20];
z[20] = T(-1) / T(2) + z[20];
z[20] = z[6] * z[20];
z[19] = z[19] + z[20];
z[19] = prod_pow(z[8], 2) * z[7] * z[19];
z[19] = z[19] + z[41];
z[19] = z[7] * z[19];
z[20] = z[0] + z[25];
z[41] = z[20] * z[37];
z[15] = z[15] * z[41];
z[43] = z[3] * z[28];
z[44] = z[0] + z[39];
z[44] = z[3] * z[44];
z[44] = T(1) / T(2) + z[44];
z[44] = z[2] * z[43] * z[44];
z[44] = z[15] + z[44];
z[44] = z[2] * z[44];
z[45] = z[0] + (T(3) / T(2)) * z[25];
z[45] = z[3] * z[45];
z[45] = T(-1) / T(2) + z[45];
z[45] = z[3] * z[45];
z[19] = z[19] + z[40] + z[44] + z[45];
z[19] = z[5] * z[19];
z[40] = z[18] * z[27];
z[40] = z[31] + z[40];
z[40] = z[4] * z[40];
z[28] = (T(1) / T(2)) * z[28];
z[28] = z[27] * z[28];
z[40] = z[28] + z[40];
z[40] = z[4] * z[40];
z[44] = z[12] * z[27];
z[33] = z[33] + z[44];
z[33] = z[4] * z[33];
z[28] = z[28] + z[33];
z[28] = z[7] * z[28];
z[33] = (T(1) / T(2)) * z[32];
z[44] = z[28] * z[33];
z[40] = z[40] + z[44];
z[40] = z[7] * z[40];
z[44] = z[12] * z[22];
z[44] = z[34] + z[44];
z[44] = z[4] * z[44];
z[35] = z[35] * z[42];
z[35] = z[35] + z[44];
z[35] = z[4] * z[35];
z[28] = z[28] * z[32];
z[28] = z[28] + z[35];
z[28] = z[10] * z[28];
z[16] = -z[16] + (T(-1) / T(4)) * z[21];
z[16] = z[4] * z[16];
z[16] = z[16] + (T(-11) / T(4)) * z[34];
z[16] = z[4] * z[16];
z[16] = z[16] + (T(1) / T(2)) * z[28] + -z[36] + -z[40];
z[16] = z[10] * z[16];
z[21] = z[21] * z[37];
z[28] = (T(7) / T(2)) * z[25] + z[30];
z[28] = z[28] * z[37];
z[18] = z[18] * z[38];
z[18] = z[18] + -3 * z[21] + z[28];
z[18] = z[4] * z[18];
z[28] = -z[21] + z[41];
z[30] = -z[22] * z[37];
z[30] = -z[28] + z[30];
z[30] = z[4] * z[30];
z[15] = z[15] + z[30];
z[15] = z[4] * z[15];
z[26] = -z[25] + -z[26];
z[26] = z[3] * z[26];
z[26] = -1 + z[26];
z[26] = z[26] * z[43];
z[15] = z[15] + z[26];
z[15] = z[2] * z[15];
z[26] = -9 * z[0] + -7 * z[25];
z[26] = z[3] * z[26];
z[26] = -1 + (T(1) / T(2)) * z[26];
z[26] = z[3] * z[6] * z[26];
z[15] = z[15] + z[18] + z[26];
z[15] = z[2] * z[15];
z[18] = -5 * z[0] + -z[22] + -9 * z[25];
z[18] = z[18] * z[37];
z[18] = z[18] + 7 * z[21];
z[15] = z[15] + (T(1) / T(2)) * z[18];
z[15] = z[2] * z[15];
z[18] = (T(3) / T(2)) * z[21] + -z[41];
z[18] = z[4] * z[18];
z[22] = z[2] * z[28];
z[26] = z[22] * z[33];
z[18] = z[18] + z[26];
z[26] = (T(1) / T(2)) * z[2];
z[18] = z[18] * z[26];
z[26] = -z[18] + z[41];
z[26] = z[11] * z[26];
z[25] = -z[25] + -z[27];
z[25] = z[6] * z[25];
z[20] = -z[3] * z[20];
z[20] = z[20] + z[25] + (T(-3) / T(2)) * z[31];
z[20] = z[12] * z[20];
z[20] = z[20] + -z[40] + z[41];
z[20] = z[9] * z[20];
z[22] = z[22] * z[32];
z[13] = prod_pow(z[3], 3) * z[13];
z[13] = z[13] + -z[21];
z[21] = -z[4] * z[13];
z[21] = z[21] + z[22];
z[21] = z[1] * z[21];
z[13] = -z[13] + -z[18] + (T(1) / T(4)) * z[21];
z[13] = z[1] * z[13];
z[14] = -z[14] + -z[24] + -z[39];
z[12] = z[12] * z[14];
z[14] = z[23] + -z[27];
z[14] = z[8] * z[14];
return z[12] + z[13] + (T(1) / T(2)) * z[14] + z[15] + z[16] + z[17] + z[19] + z[20] + z[26] + -z[29] + (T(-3) / T(2)) * z[38];
}



template double eval_coef_2q3y_2l_pmmpp_12345_161(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_161(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
