#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_165(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[72];
z[0] = iW[1];
z[1] = iW[2];
z[2] = iW[5];
z[3] = v[0];
z[4] = v[4];
z[5] = iW[18];
z[6] = v[3];
z[7] = iW[3];
z[8] = iW[16];
z[9] = v[2];
z[10] = iW[19];
z[11] = iW[17];
z[12] = iW[4];
z[13] = iW[15];
z[14] = iW[12];
z[15] = iW[23];
z[16] = v[1];
z[17] = prod_pow(z[0], 2);
z[18] = z[4] * z[17];
z[19] = z[9] * z[17];
z[20] = -52 * z[0] + 20 * z[18] + (T(-71) / T(4)) * z[19];
z[20] = z[4] * z[20];
z[21] = z[0] * z[9];
z[20] = 32 + z[20] + (T(-197) / T(8)) * z[21];
z[22] = (T(1) / T(2)) * z[4];
z[23] = z[17] * z[22];
z[24] = -z[0] + z[23];
z[25] = z[22] * z[24];
z[25] = T(1) / T(4) + (T(-40) / T(9)) * z[21] + z[25];
z[25] = z[4] * z[25];
z[26] = (T(1) / T(2)) * z[21];
z[27] = T(40) / T(9) + -z[26];
z[27] = z[9] * z[27];
z[25] = z[25] + z[27];
z[25] = z[7] * z[25];
z[20] = (T(1) / T(9)) * z[20] + z[25];
z[20] = z[7] * z[20];
z[25] = -19 * z[0] + (T(113) / T(6)) * z[18] + (T(-77) / T(6)) * z[19];
z[27] = 2 * z[0];
z[28] = z[23] + -z[27];
z[29] = (T(1) / T(3)) * z[4];
z[28] = z[28] * z[29];
z[28] = T(1) / T(2) + z[28];
z[28] = z[2] * z[28];
z[20] = z[20] + (T(1) / T(12)) * z[25] + z[28];
z[20] = z[7] * z[20];
z[25] = z[4] * z[24];
z[25] = T(1) / T(2) + z[25];
z[25] = z[2] * z[25];
z[28] = -z[0] + z[18];
z[30] = -z[19] + (T(-143) / T(36)) * z[28];
z[31] = (T(40) / T(9)) * z[0] + (T(-20) / T(9)) * z[18] + (T(-1) / T(4)) * z[19];
z[31] = z[4] * z[31];
z[32] = -z[0] + z[19];
z[33] = z[9] * z[32];
z[31] = T(-20) / T(9) + z[31] + (T(-1) / T(4)) * z[33];
z[31] = z[7] * z[31];
z[30] = (T(-1) / T(3)) * z[25] + (T(1) / T(2)) * z[30] + z[31];
z[30] = z[7] * z[30];
z[31] = (T(1) / T(3)) * z[28];
z[33] = z[25] + z[31];
z[33] = z[2] * z[33];
z[34] = (T(97) / T(36)) * z[17] + -z[33];
z[30] = z[30] + (T(1) / T(2)) * z[34];
z[30] = z[7] * z[30];
z[34] = (T(1) / T(2)) * z[6];
z[35] = z[17] * z[34];
z[31] = -z[31] + z[35];
z[25] = -z[25] + (T(1) / T(2)) * z[31];
z[31] = (T(1) / T(2)) * z[1];
z[25] = z[25] * z[31];
z[25] = (T(1) / T(3)) * z[17] + z[25] + (T(-1) / T(2)) * z[33];
z[25] = z[1] * z[25];
z[25] = z[25] + z[30];
z[25] = z[3] * z[25];
z[30] = z[0] + z[18];
z[33] = z[6] * z[17];
z[36] = -z[30] + -5 * z[33];
z[37] = z[0] * z[4];
z[37] = 1 + -z[37];
z[37] = z[2] * z[37];
z[36] = (T(1) / T(4)) * z[36] + 2 * z[37];
z[37] = (T(1) / T(3)) * z[18] + -z[35];
z[37] = z[6] * z[37];
z[38] = z[4] * z[28];
z[37] = z[37] + z[38];
z[37] = z[1] * z[37];
z[36] = (T(1) / T(3)) * z[36] + (T(1) / T(4)) * z[37];
z[36] = z[1] * z[36];
z[37] = z[2] * z[18];
z[37] = (T(-13) / T(3)) * z[17] + z[37];
z[20] = z[20] + z[25] + z[36] + (T(1) / T(6)) * z[37];
z[20] = z[3] * z[20];
z[25] = 5 * z[19];
z[30] = z[25] + -z[30] + (T(5) / T(4)) * z[33];
z[36] = (T(1) / T(2)) * z[9];
z[37] = z[17] * z[36];
z[38] = -z[24] + z[37];
z[38] = z[4] * z[38];
z[38] = T(-1) / T(2) + z[38];
z[38] = z[4] * z[38];
z[38] = -z[36] + z[38];
z[38] = z[22] * z[38];
z[39] = prod_pow(z[9], 2);
z[38] = z[38] + (T(-20) / T(9)) * z[39];
z[38] = z[7] * z[38];
z[40] = z[0] + z[19];
z[41] = -z[18] + z[40];
z[42] = prod_pow(z[4], 2);
z[43] = (T(1) / T(2)) * z[42];
z[41] = z[41] * z[43];
z[41] = (T(-61) / T(9)) * z[9] + z[41];
z[38] = z[38] + (T(1) / T(2)) * z[41];
z[38] = z[7] * z[38];
z[41] = 5 * z[0] + z[19];
z[44] = -z[23] + z[41];
z[44] = z[4] * z[44];
z[44] = -13 + -5 * z[21] + z[44];
z[38] = z[38] + (T(1) / T(6)) * z[44];
z[38] = z[7] * z[38];
z[44] = z[17] * z[39];
z[45] = prod_pow(z[9], 3);
z[46] = z[17] * z[45];
z[47] = (T(1) / T(2)) * z[7];
z[48] = z[46] * z[47];
z[48] = z[44] + z[48];
z[48] = z[7] * z[48];
z[48] = -z[37] + z[48];
z[48] = z[7] * z[48];
z[49] = z[2] * z[33];
z[48] = z[17] + z[48] + -z[49];
z[48] = z[3] * z[48];
z[45] = z[7] * z[45];
z[50] = (T(5) / T(2)) * z[39] + z[45];
z[50] = prod_pow(z[7], 2) * z[50];
z[51] = z[2] * z[6];
z[50] = z[50] + -z[51];
z[50] = z[0] * z[50];
z[52] = (T(3) / T(2)) * z[0];
z[48] = z[48] + z[50] + z[52];
z[48] = z[3] * z[48];
z[45] = 3 * z[39] + z[45];
z[45] = z[7] * z[45];
z[45] = z[9] + z[45];
z[45] = z[7] * z[45];
z[45] = 1 + z[45];
z[45] = (T(1) / T(2)) * z[45] + z[48];
z[45] = z[8] * z[45];
z[20] = z[20] + (T(1) / T(6)) * z[30] + z[38] + (T(1) / T(2)) * z[45];
z[20] = z[3] * z[20];
z[30] = z[39] * z[40];
z[38] = z[23] * z[39];
z[38] = -z[30] + z[38];
z[38] = z[4] * z[38];
z[45] = z[18] * z[39];
z[48] = -z[30] + z[45];
z[48] = z[34] * z[48];
z[50] = z[11] * z[46];
z[53] = z[43] * z[50];
z[38] = z[38] + z[48] + -z[53];
z[38] = z[14] * z[38];
z[37] = z[0] + z[37];
z[48] = -z[37] * z[39];
z[48] = (T(3) / T(2)) * z[45] + z[48];
z[48] = z[4] * z[48];
z[48] = z[48] + -z[53];
z[48] = z[11] * z[48];
z[52] = z[19] + z[52];
z[52] = z[9] * z[52];
z[52] = T(1) / T(2) + z[52];
z[52] = z[9] * z[52];
z[53] = 3 * z[19];
z[54] = z[27] + z[53];
z[54] = z[9] * z[54];
z[55] = z[4] * z[19];
z[54] = z[54] + -z[55];
z[54] = z[4] * z[54];
z[56] = (T(3) / T(2)) * z[19];
z[57] = z[0] + z[56];
z[57] = z[9] * z[57];
z[58] = -z[55] + z[57];
z[58] = z[6] * z[58];
z[38] = z[38] + z[48] + -z[52] + z[54] + z[58];
z[38] = z[14] * z[38];
z[48] = z[36] * z[40];
z[54] = (T(1) / T(3)) * z[6];
z[58] = z[40] * z[54];
z[59] = -z[48] + -z[58];
z[59] = z[6] * z[59];
z[59] = (T(-1) / T(6)) * z[30] + z[59];
z[59] = z[6] * z[59];
z[60] = (T(1) / T(2)) * z[30];
z[61] = z[34] * z[40];
z[62] = z[9] * z[40];
z[63] = z[61] + z[62];
z[63] = z[6] * z[63];
z[63] = z[60] + z[63];
z[64] = prod_pow(z[6], 2);
z[63] = z[11] * z[63] * z[64];
z[59] = z[59] + (T(1) / T(6)) * z[63];
z[59] = z[11] * z[59];
z[63] = (T(5) / T(4)) * z[19] + z[27];
z[65] = (T(1) / T(3)) * z[9];
z[63] = z[63] * z[65];
z[61] = T(1) / T(4) + z[61] + z[63];
z[61] = z[6] * z[61];
z[63] = z[6] * z[40];
z[66] = 1 + z[21];
z[67] = z[63] + (T(1) / T(4)) * z[66];
z[68] = 41 * z[0] + 47 * z[19];
z[68] = (T(-7) / T(2)) * z[33] + (T(1) / T(3)) * z[68];
z[69] = z[3] * z[17];
z[68] = (T(1) / T(3)) * z[68] + (T(1) / T(2)) * z[69];
z[68] = z[3] * z[68];
z[67] = (T(1) / T(3)) * z[67] + (T(1) / T(4)) * z[68];
z[67] = z[3] * z[67];
z[68] = z[6] * z[19];
z[69] = z[0] * z[3];
z[69] = -z[21] + z[68] + z[69];
z[70] = prod_pow(z[3], 2);
z[69] = z[12] * z[69] * z[70];
z[71] = z[9] + z[16];
z[59] = (T(5) / T(2)) * z[59] + z[61] + z[67] + (T(3) / T(8)) * z[69] + (T(-1) / T(8)) * z[71];
z[59] = z[12] * z[59];
z[53] = -z[28] + z[53];
z[53] = z[22] * z[53];
z[53] = z[53] + -z[57];
z[57] = z[4] * z[53];
z[57] = z[57] + z[60];
z[43] = z[43] * z[57];
z[37] = z[9] * z[37];
z[37] = T(1) / T(2) + z[37];
z[57] = z[36] * z[37];
z[61] = -z[24] + z[56];
z[67] = z[22] * z[61];
z[69] = -z[0] + (T(-3) / T(4)) * z[19];
z[69] = z[9] * z[69];
z[67] = T(-1) / T(4) + z[67] + z[69];
z[67] = z[4] * z[67];
z[57] = z[57] + z[67];
z[67] = prod_pow(z[4], 3) * z[7];
z[57] = z[57] * z[67];
z[43] = z[43] + z[57];
z[43] = z[7] * z[43];
z[27] = z[27] + z[56];
z[27] = z[9] * z[27];
z[56] = -z[4] * z[61];
z[27] = T(1) / T(2) + z[27] + z[56];
z[27] = z[4] * z[27];
z[56] = -z[9] * z[37];
z[27] = z[27] + z[56];
z[27] = z[4] * z[27];
z[27] = z[27] + z[43];
z[27] = z[7] * z[27];
z[43] = (T(1) / T(2)) * z[0];
z[56] = z[19] + z[43];
z[57] = z[18] + -3 * z[56];
z[57] = z[4] * z[57];
z[57] = T(1) / T(2) + z[57] + 3 * z[62];
z[57] = z[4] * z[57];
z[53] = -z[6] * z[53];
z[30] = -z[14] * z[30] * z[34];
z[27] = z[27] + z[30] + -z[52] + z[53] + z[57];
z[27] = z[10] * z[27];
z[30] = z[31] * z[64];
z[52] = -z[17] * z[30];
z[52] = -z[33] + z[52];
z[52] = z[31] * z[52];
z[49] = (T(7) / T(12)) * z[17] + -z[49] + z[52];
z[49] = z[3] * z[49];
z[52] = -z[0] + z[33];
z[30] = z[30] * z[52];
z[52] = -z[0] + (T(3) / T(2)) * z[33];
z[52] = z[6] * z[52];
z[30] = z[30] + z[52];
z[30] = z[30] * z[31];
z[31] = T(7) / T(6) + -z[51];
z[31] = z[0] * z[31];
z[30] = -z[19] + z[30] + z[31] + (T(-7) / T(12)) * z[33] + z[49];
z[30] = z[3] * z[30];
z[31] = -z[32] + -z[35];
z[31] = z[6] * z[31];
z[31] = T(-1) / T(2) + z[21] + z[31];
z[30] = z[30] + (T(1) / T(6)) * z[31];
z[30] = z[3] * z[30];
z[31] = z[32] + z[33];
z[31] = z[6] * z[31];
z[35] = -z[3] * z[33];
z[31] = -z[21] + z[31] + z[35];
z[31] = z[5] * z[31] * z[70];
z[17] = -z[17] * z[54];
z[35] = (T(1) / T(3)) * z[19];
z[17] = z[0] + z[17] + -z[35];
z[17] = z[17] * z[34];
z[17] = T(-1) / T(2) + z[17] + (T(1) / T(3)) * z[21];
z[17] = z[6] * z[17];
z[49] = -z[9] + z[16];
z[17] = z[17] + (T(1) / T(6)) * z[49];
z[17] = (T(1) / T(2)) * z[17] + z[30] + (T(3) / T(4)) * z[31];
z[17] = z[5] * z[17];
z[30] = z[58] + -z[66];
z[30] = z[6] * z[30];
z[30] = z[30] + z[71];
z[30] = z[6] * z[30];
z[31] = (T(1) / T(3)) * z[16];
z[49] = z[31] * z[71];
z[30] = z[30] + -z[49];
z[51] = -z[12] + -z[15];
z[30] = z[30] * z[51];
z[51] = (T(-1) / T(4)) * z[63] + z[66];
z[51] = z[51] * z[54];
z[51] = z[51] + (T(-1) / T(2)) * z[71];
z[51] = z[6] * z[51];
z[49] = z[49] + z[51];
z[49] = z[6] * z[49];
z[51] = prod_pow(z[16], 2);
z[51] = (T(1) / T(12)) * z[51];
z[52] = -z[51] * z[71];
z[49] = z[49] + z[52];
z[49] = z[12] * z[49];
z[52] = -z[21] + (T(1) / T(4)) * z[68];
z[52] = z[52] * z[54];
z[52] = z[36] + z[52];
z[52] = z[6] * z[52];
z[53] = -z[9] * z[31];
z[52] = z[52] + z[53];
z[52] = z[6] * z[52];
z[53] = z[9] * z[51];
z[52] = z[52] + z[53];
z[52] = z[5] * z[52];
z[49] = z[49] + z[52];
z[49] = z[13] * z[49];
z[52] = z[0] + (T(-1) / T(4)) * z[33];
z[52] = z[52] * z[54];
z[52] = T(-1) / T(2) + z[52];
z[52] = z[6] * z[52];
z[31] = z[31] + z[52];
z[31] = z[6] * z[31];
z[31] = z[31] + -z[51];
z[31] = z[5] * z[31];
z[30] = z[30] + z[31] + z[49];
z[30] = z[13] * z[30];
z[17] = z[17] + z[30];
z[30] = -z[4] * z[40];
z[30] = z[30] + 5 * z[44] + (T(5) / T(2)) * z[68];
z[30] = z[30] * z[34];
z[31] = -z[19] * z[22];
z[31] = z[31] + -z[62];
z[31] = z[4] * z[31];
z[30] = z[30] + z[31] + (T(5) / T(4)) * z[46];
z[30] = z[6] * z[30];
z[31] = -z[45] + -z[60];
z[31] = z[4] * z[31];
z[30] = z[30] + z[31];
z[30] = z[11] * z[30];
z[31] = z[0] + z[23];
z[34] = z[4] * z[31];
z[34] = z[34] + (T(-55) / T(4)) * z[44];
z[49] = -z[19] + (T(-1) / T(8)) * z[33];
z[49] = z[6] * z[49];
z[34] = (T(1) / T(2)) * z[34] + 5 * z[49];
z[34] = z[6] * z[34];
z[32] = -z[32] * z[36];
z[32] = z[32] + z[55];
z[32] = z[4] * z[32];
z[30] = (T(1) / T(2)) * z[30] + z[32] + z[34] + (T(-5) / T(2)) * z[46];
z[30] = z[11] * z[30];
z[25] = z[0] + z[25];
z[25] = z[25] * z[36];
z[25] = 1 + z[25] + z[30];
z[30] = z[23] + -z[56];
z[30] = z[4] * z[30];
z[30] = z[30] + z[48];
z[30] = z[30] * z[42];
z[23] = z[23] + -z[40];
z[23] = z[4] * z[23];
z[23] = z[23] + z[37];
z[23] = z[23] * z[67];
z[23] = z[23] + z[30];
z[23] = z[23] * z[47];
z[30] = -1 + (T(1) / T(3)) * z[44];
z[24] = (T(-1) / T(6)) * z[19] + -z[24];
z[24] = z[4] * z[24];
z[24] = z[24] + (T(1) / T(2)) * z[30];
z[24] = z[4] * z[24];
z[30] = -z[0] + (T(-2) / T(3)) * z[19];
z[30] = z[30] * z[39];
z[30] = z[30] + (T(7) / T(4)) * z[45];
z[30] = z[4] * z[30];
z[32] = z[42] * z[50];
z[30] = z[30] + (T(-7) / T(12)) * z[32];
z[30] = z[11] * z[30];
z[23] = z[23] + z[24] + z[30];
z[23] = z[7] * z[23];
z[19] = (T(13) / T(4)) * z[19] + -z[31] + (T(5) / T(8)) * z[33];
z[19] = z[19] * z[54];
z[24] = (T(-1) / T(6)) * z[18] + -z[35] + -z[43];
z[24] = z[6] * z[24];
z[30] = -z[18] + (T(-1) / T(2)) * z[40];
z[30] = z[29] * z[30];
z[21] = 1 + (T(2) / T(3)) * z[21] + z[24] + z[30];
z[21] = z[6] * z[21];
z[22] = -z[22] * z[28];
z[22] = 1 + z[22] + z[26];
z[22] = z[22] * z[29];
z[21] = (T(-1) / T(2)) * z[16] + z[21] + z[22] + -z[65];
z[21] = z[15] * z[21];
z[18] = -3 * z[18] + (T(1) / T(3)) * z[41];
z[18] = z[4] * z[18];
return (T(1) / T(2)) * z[17] + (T(1) / T(4)) * z[18] + z[19] + z[20] + z[21] + z[23] + (T(1) / T(3)) * z[25] + z[27] + z[38] + z[59];
}



template double eval_coef_2q3y_2l_pmmpp_12345_165(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_165(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
