#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_27(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[18];
z[0] = iW[1];
z[1] = iW[2];
z[2] = iW[3];
z[3] = iW[16];
z[4] = iW[17];
z[5] = iW[19];
z[6] = v[0];
z[7] = v[4];
z[8] = v[2];
z[9] = v[3];
z[10] = v[1];
z[11] = z[0] * z[7];
z[12] = -1 + (T(1) / T(2)) * z[11];
z[12] = z[7] * z[12];
z[12] = (T(1) / T(2)) * z[10] + z[12];
z[12] = z[1] * z[12];
z[13] = z[0] * z[9];
z[14] = (T(1) / T(2)) * z[0];
z[14] = z[8] * z[14];
z[15] = -5 + (T(3) / T(2)) * z[11] + -z[12] + z[13] + -z[14];
z[15] = z[7] * z[15];
z[16] = -1 + z[11];
z[17] = -z[12] + z[14] + -z[16];
z[17] = z[6] * z[17];
z[13] = T(1) / T(2) + -z[13] + -z[14];
z[13] = z[8] * z[13];
z[13] = -z[9] + (T(7) / T(2)) * z[10] + z[13] + z[15] + z[17];
z[13] = z[6] * z[13];
z[14] = prod_pow(z[8], 2);
z[15] = z[8] * z[10];
z[17] = z[7] + -5 * z[8] + -z[10];
z[17] = z[7] * z[17];
z[15] = -z[14] + 7 * z[15] + z[17];
z[17] = z[0] * z[8];
z[17] = 7 + -z[17];
z[11] = -z[11] + z[12] + (T(1) / T(2)) * z[17];
z[11] = z[7] * z[11];
z[12] = z[12] + (T(1) / T(2)) * z[16];
z[12] = z[6] * z[12];
z[11] = z[8] + (T(-5) / T(2)) * z[10] + z[11] + z[12];
z[11] = z[6] * z[11];
z[11] = z[11] + (T(1) / T(2)) * z[15];
z[11] = z[6] * z[11];
z[12] = z[10] * z[14];
z[11] = z[11] + (T(-3) / T(2)) * z[12];
z[11] = z[2] * z[11];
z[12] = z[7] + -z[8];
z[12] = (T(1) / T(2)) * z[12];
z[14] = z[8] + z[9];
z[12] = z[12] * z[14];
z[14] = -z[8] + (T(-1) / T(2)) * z[9];
z[14] = z[10] * z[14];
z[12] = z[12] + z[14];
z[11] = z[11] + 3 * z[12] + z[13];
return (T(1) / T(2)) * z[3] * z[4] * z[5] * z[6] * z[11];
}



template double eval_coef_2q3y_2l_pmmpp_12345_27(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_27(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
