#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_32(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[22];
z[0] = iW[1];
z[1] = iW[4];
z[2] = iW[17];
z[3] = iW[18];
z[4] = v[0];
z[5] = v[2];
z[6] = v[3];
z[7] = v[4];
z[8] = v[1];
z[9] = (T(3) / T(2)) * z[5] + z[6];
z[9] = z[6] * z[9];
z[10] = prod_pow(z[5], 2);
z[11] = (T(1) / T(2)) * z[6];
z[12] = -z[5] + -z[11];
z[12] = z[8] * z[12];
z[12] = z[9] + -z[10] + z[12];
z[12] = z[6] * z[12];
z[13] = prod_pow(z[6], 2);
z[14] = z[10] + (T(-1) / T(4)) * z[13];
z[14] = z[13] * z[14];
z[15] = -z[5] * z[11];
z[15] = -z[10] + z[15];
z[16] = (T(1) / T(2)) * z[0];
z[17] = prod_pow(z[6], 3) * z[16];
z[15] = z[15] * z[17];
z[14] = z[14] + z[15];
z[14] = z[0] * z[14];
z[15] = -z[5] + z[11];
z[18] = z[13] * z[15];
z[17] = z[5] * z[17];
z[17] = z[17] + z[18];
z[17] = z[0] * z[17];
z[18] = (T(1) / T(2)) * z[5];
z[19] = -z[6] + z[18];
z[19] = z[6] * z[19];
z[20] = z[8] * z[11];
z[17] = z[17] + z[19] + z[20];
z[17] = z[4] * z[17];
z[12] = (T(1) / T(2)) * z[12] + z[14] + z[17];
z[12] = z[1] * z[12];
z[14] = (T(1) / T(2)) * z[10];
z[9] = z[9] + z[14];
z[9] = z[6] * z[9];
z[17] = -z[5] * z[6];
z[17] = (T(-3) / T(2)) * z[10] + z[17];
z[20] = (T(1) / T(2)) * z[7];
z[17] = z[17] * z[20];
z[21] = prod_pow(z[5], 3);
z[9] = z[9] + z[17] + (T(3) / T(4)) * z[21];
z[9] = z[7] * z[9];
z[17] = z[6] * z[15];
z[17] = -3 * z[10] + z[17];
z[13] = z[13] * z[17];
z[9] = z[9] + (T(1) / T(2)) * z[13];
z[9] = z[0] * z[9];
z[13] = z[5] + z[6];
z[13] = z[6] * z[13];
z[17] = z[10] + -z[13];
z[17] = z[6] * z[17];
z[13] = (T(3) / T(4)) * z[10] + -z[13];
z[13] = z[7] * z[13];
z[9] = z[9] + z[13] + (T(3) / T(2)) * z[17];
z[9] = z[9] * z[16];
z[13] = (T(1) / T(4)) * z[7];
z[15] = -z[13] * z[15];
z[17] = (T(7) / T(4)) * z[6];
z[21] = -2 * z[5] + -z[17];
z[21] = z[6] * z[21];
z[15] = (T(-5) / T(4)) * z[10] + z[15] + z[21];
z[15] = z[7] * z[15];
z[10] = (T(-1) / T(4)) * z[10] + z[19];
z[10] = z[10] * z[11];
z[10] = z[10] + z[15];
z[10] = z[0] * z[10];
z[11] = z[5] + 5 * z[6];
z[11] = z[11] * z[13];
z[13] = z[5] + (T(9) / T(4)) * z[6];
z[13] = z[6] * z[13];
z[10] = z[10] + z[11] + z[13] + z[14];
z[10] = z[0] * z[10];
z[11] = (T(11) / T(2)) * z[5] + 7 * z[6] + z[20];
z[11] = z[11] * z[20];
z[13] = z[6] + z[18];
z[13] = z[6] * z[13];
z[11] = z[11] + z[13];
z[11] = z[11] * z[16];
z[11] = -z[5] + (T(-5) / T(8)) * z[7] + z[11] + -z[17];
z[11] = z[0] * z[11];
z[13] = (T(-1) / T(4)) * z[6] + -z[7];
z[13] = z[0] * z[13];
z[13] = 1 + z[13];
z[13] = z[4] * z[13] * z[16];
z[11] = T(1) / T(2) + z[11] + z[13];
z[11] = z[4] * z[11];
z[13] = -z[5] + (T(-11) / T(4)) * z[6];
z[10] = z[10] + z[11] + (T(1) / T(2)) * z[13];
z[10] = z[4] * z[10];
z[11] = z[5] + (T(5) / T(8)) * z[6];
z[11] = z[6] * z[11];
z[9] = z[9] + z[10] + z[11] + (T(1) / T(2)) * z[12];
z[10] = z[2] * z[3] * z[4];
return prod_pow(z[10], 2) * z[9];
}



template double eval_coef_2q3y_2l_pmmpp_12345_32(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_32(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
