#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_39(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[22];
z[0] = iW[1];
z[1] = iW[4];
z[2] = iW[15];
z[3] = v[0];
z[4] = v[2];
z[5] = v[3];
z[6] = v[4];
z[7] = v[1];
z[8] = z[0] * z[6];
z[9] = -1 + z[8];
z[10] = (T(1) / T(2)) * z[0];
z[11] = z[9] * z[10];
z[12] = z[1] * z[4];
z[13] = prod_pow(z[0], 2);
z[14] = z[4] * z[13];
z[15] = -z[0] + -z[14];
z[15] = z[12] * z[15];
z[15] = -z[11] + z[14] + (T(1) / T(2)) * z[15];
z[15] = z[5] * z[15];
z[16] = z[0] * z[4];
z[17] = 1 + z[16];
z[18] = z[12] * z[17];
z[15] = z[9] + z[15] + (T(-5) / T(2)) * z[16] + (T(3) / T(2)) * z[18];
z[15] = z[5] * z[15];
z[18] = z[4] + z[7];
z[19] = z[12] * z[18];
z[20] = -z[6] + z[7];
z[15] = z[4] + (T(1) / T(2)) * z[15] + (T(-3) / T(4)) * z[19] + (T(1) / T(4)) * z[20];
z[15] = z[5] * z[15];
z[19] = z[4] * z[7];
z[20] = prod_pow(z[7], 2);
z[21] = z[19] + z[20];
z[12] = z[12] * z[21];
z[12] = z[12] + -z[19];
z[12] = (T(1) / T(4)) * z[12] + z[15];
z[15] = (T(1) / T(2)) * z[1];
z[17] = z[15] * z[17];
z[9] = z[0] * z[9];
z[17] = (T(-7) / T(4)) * z[9] + z[14] + z[17];
z[17] = z[5] * z[17];
z[18] = -z[15] * z[18];
z[11] = z[3] * z[11];
z[11] = T(-1) / T(2) + z[8] + z[11] + z[17] + z[18];
z[11] = z[3] * z[11];
z[17] = (T(5) / T(2)) * z[4];
z[13] = -z[13] * z[17];
z[10] = -z[10] + z[14];
z[10] = z[4] * z[10];
z[10] = T(-3) / T(2) + z[10];
z[10] = z[10] * z[15];
z[9] = 2 * z[9] + z[10] + z[13];
z[9] = z[5] * z[9];
z[8] = 3 + -5 * z[8] + (T(11) / T(2)) * z[16];
z[10] = T(1) / T(2) + -z[16];
z[10] = z[4] * z[10];
z[10] = (T(3) / T(2)) * z[7] + z[10];
z[10] = z[1] * z[10];
z[8] = (T(1) / T(2)) * z[8] + z[9] + z[10];
z[8] = z[5] * z[8];
z[9] = z[4] + (T(-1) / T(2)) * z[7];
z[9] = z[4] * z[9];
z[9] = z[9] + (T(-3) / T(2)) * z[20];
z[9] = z[1] * z[9];
z[10] = z[4] + -z[6];
z[9] = z[7] + z[9] + (T(-1) / T(2)) * z[10];
z[8] = z[8] + (T(1) / T(2)) * z[9] + z[11];
z[8] = z[3] * z[8];
z[8] = z[8] + 3 * z[12];
return prod_pow(z[2], 2) * z[8];
}



template double eval_coef_2q3y_2l_pmmpp_12345_39(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_39(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
