#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_41(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[17];
z[0] = iW[1];
z[1] = iW[15];
z[2] = iW[18];
z[3] = v[0];
z[4] = v[4];
z[5] = v[2];
z[6] = v[3];
z[7] = v[1];
z[8] = z[0] * z[6];
z[9] = prod_pow(z[0], 2);
z[10] = z[6] * z[9];
z[11] = -z[5] * z[10];
z[12] = (T(1) / T(2)) * z[3];
z[13] = z[0] * z[12];
z[11] = T(5) / T(4) + -z[8] + z[11] + z[13];
z[11] = z[3] * z[11];
z[13] = T(-3) / T(2) + z[8];
z[13] = z[6] * z[13];
z[14] = (T(-11) / T(2)) * z[0] + 5 * z[10];
z[14] = z[6] * z[14];
z[14] = T(1) / T(2) + z[14];
z[14] = z[5] * z[14];
z[13] = (T(1) / T(2)) * z[7] + z[13] + z[14];
z[11] = z[11] + (T(1) / T(2)) * z[13];
z[11] = z[3] * z[11];
z[13] = (T(5) / T(2)) * z[0];
z[14] = -2 * z[10] + z[13];
z[14] = z[6] * z[14];
z[15] = (T(7) / T(4)) * z[6] + -z[12];
z[15] = z[9] * z[15];
z[15] = -z[0] + z[15];
z[15] = z[3] * z[15];
z[14] = T(-1) / T(4) + z[14] + z[15];
z[14] = z[3] * z[14];
z[15] = (T(1) / T(2)) * z[6];
z[9] = z[9] * z[15];
z[9] = -z[0] + z[9];
z[9] = z[6] * z[9];
z[9] = T(1) / T(2) + z[9];
z[16] = z[6] * z[9];
z[14] = z[14] + (T(3) / T(2)) * z[16];
z[14] = z[4] * z[14];
z[13] = -z[10] + z[13];
z[13] = z[13] * z[15];
z[13] = -1 + z[13];
z[13] = z[6] * z[13];
z[13] = (T(1) / T(4)) * z[7] + z[13];
z[13] = z[5] * z[13];
z[11] = z[11] + 3 * z[13] + z[14];
z[11] = z[4] * z[11];
z[9] = -z[5] * z[9];
z[13] = -2 + z[8];
z[13] = z[6] * z[13];
z[9] = z[7] + z[9] + z[13];
z[9] = z[5] * z[9];
z[13] = z[6] + -z[7];
z[8] = 1 + -z[8];
z[8] = z[5] * z[8];
z[8] = z[8] + (T(1) / T(2)) * z[13];
z[8] = z[8] * z[12];
z[8] = z[8] + z[9];
z[8] = z[3] * z[8];
z[9] = -3 * z[0] + z[10];
z[9] = z[6] * z[9];
z[9] = 3 + z[9];
z[9] = z[6] * z[9];
z[9] = -z[7] + z[9];
z[9] = prod_pow(z[5], 2) * z[9];
z[8] = z[8] + (T(3) / T(4)) * z[9] + z[11];
return prod_pow(z[1], 2) * z[2] * z[8];
}



template double eval_coef_2q3y_2l_pmmpp_12345_41(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_41(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
