#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_49(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[24];
z[0] = iW[1];
z[1] = iW[4];
z[2] = iW[7];
z[3] = iW[15];
z[4] = iW[23];
z[5] = v[0];
z[6] = v[2];
z[7] = v[3];
z[8] = v[4];
z[9] = v[1];
z[10] = prod_pow(z[7], 2);
z[11] = prod_pow(z[0], 2);
z[12] = z[10] * z[11];
z[12] = -1 + z[12];
z[13] = (T(1) / T(2)) * z[5];
z[14] = (T(-3) / T(2)) * z[7] + z[13];
z[14] = z[11] * z[14];
z[14] = z[0] + z[14];
z[14] = z[5] * z[14];
z[15] = z[7] * z[11];
z[16] = -z[0] + z[15];
z[16] = z[6] * z[16];
z[12] = (T(3) / T(2)) * z[12] + z[14] + z[16];
z[12] = z[12] * z[13];
z[14] = (T(1) / T(4)) * z[7];
z[14] = z[11] * z[14];
z[14] = -z[0] + z[14];
z[14] = z[7] * z[14];
z[16] = (T(1) / T(2)) * z[7];
z[17] = (T(1) / T(4)) * z[5] + -z[16];
z[17] = z[11] * z[17];
z[17] = z[0] + z[17];
z[17] = z[5] * z[17];
z[14] = 1 + z[14] + z[17];
z[14] = z[8] * z[14];
z[17] = z[11] * z[16];
z[18] = -z[0] + -z[17];
z[18] = z[7] * z[18];
z[18] = T(9) / T(2) + z[18];
z[18] = z[7] * z[18];
z[18] = -3 * z[9] + z[18];
z[19] = -3 * z[0] + z[15];
z[20] = -z[16] * z[19];
z[20] = -1 + z[20];
z[20] = z[6] * z[20];
z[12] = z[12] + z[14] + (T(1) / T(2)) * z[18] + z[20];
z[12] = z[8] * z[12];
z[14] = -z[0] + z[17];
z[14] = z[7] * z[14];
z[14] = T(1) / T(2) + z[14];
z[17] = (T(1) / T(2)) * z[6];
z[17] = z[14] * z[17];
z[18] = (T(1) / T(2)) * z[0];
z[20] = z[15] + -z[18];
z[21] = z[16] * z[20];
z[21] = -1 + z[21];
z[21] = z[7] * z[21];
z[21] = (T(3) / T(4)) * z[9] + z[17] + z[21];
z[21] = z[6] * z[21];
z[22] = z[6] * z[11];
z[22] = (T(-5) / T(2)) * z[0] + 3 * z[15] + z[22];
z[22] = z[7] * z[22];
z[11] = z[5] * z[11];
z[11] = z[11] + -3 * z[20];
z[11] = z[5] * z[11];
z[11] = z[11] + z[22];
z[11] = z[11] * z[13];
z[20] = (T(3) / T(2)) * z[0] + -z[15];
z[20] = z[7] * z[20];
z[20] = T(-1) / T(2) + z[20];
z[16] = z[16] * z[20];
z[20] = (T(3) / T(4)) * z[0] + -z[15];
z[20] = z[7] * z[20];
z[20] = T(1) / T(4) + z[20];
z[20] = z[6] * z[20];
z[11] = z[11] + z[16] + z[20];
z[11] = z[5] * z[11];
z[16] = z[0] * z[7];
z[20] = 1 + (T(-1) / T(4)) * z[16];
z[20] = z[10] * z[20];
z[22] = (T(1) / T(2)) * z[9];
z[23] = (T(-5) / T(2)) * z[7] + z[9];
z[23] = z[22] * z[23];
z[11] = z[11] + z[12] + z[20] + z[21] + z[23];
z[11] = z[8] * z[11];
z[12] = z[15] + z[18];
z[12] = z[6] * z[12];
z[18] = -z[7] + z[9];
z[20] = -1 + z[16];
z[20] = z[6] * z[20];
z[18] = (T(1) / T(2)) * z[18] + z[20];
z[18] = z[1] * z[18];
z[20] = -z[0] + z[1];
z[13] = z[13] * z[20];
z[12] = z[12] + z[13] + z[16] + z[18];
z[12] = z[5] * z[12];
z[13] = z[6] * z[14];
z[14] = 2 + -z[16];
z[14] = z[7] * z[14];
z[13] = -z[9] + z[13] + z[14];
z[13] = z[1] * z[13];
z[14] = (T(9) / T(4)) * z[0] + -2 * z[15];
z[14] = z[7] * z[14];
z[13] = T(-1) / T(4) + z[13] + z[14];
z[13] = z[6] * z[13];
z[14] = T(-1) / T(2) + -z[16];
z[14] = z[7] * z[14];
z[14] = (T(3) / T(2)) * z[9] + z[14];
z[12] = z[12] + z[13] + (T(1) / T(2)) * z[14];
z[12] = z[5] * z[12];
z[13] = -z[7] + z[22];
z[13] = z[9] * z[13];
z[14] = z[7] * z[19];
z[14] = 3 + z[14];
z[14] = z[7] * z[14];
z[14] = -z[9] + z[14];
z[15] = prod_pow(z[6], 2) * z[1] * z[14];
z[13] = (T(1) / T(2)) * z[10] + z[13] + -z[15];
z[15] = z[14] + z[17];
z[15] = z[6] * z[15];
z[12] = z[12] + (T(1) / T(2)) * z[13] + z[15];
z[12] = z[5] * z[12];
z[13] = -3 + z[16];
z[10] = z[10] * z[13];
z[13] = 3 * z[7] + -z[9];
z[13] = z[9] * z[13];
z[14] = -z[6] * z[14];
z[10] = z[10] + z[13] + z[14];
z[10] = z[6] * z[10];
z[10] = (T(1) / T(4)) * z[10] + z[11] + z[12];
return z[2] * z[3] * z[4] * z[10];
}



template double eval_coef_2q3y_2l_pmmpp_12345_49(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_49(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
