#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_55(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[32];
z[0] = iW[1];
z[1] = iW[15];
z[2] = iW[23];
z[3] = v[0];
z[4] = v[2];
z[5] = v[4];
z[6] = v[3];
z[7] = iW[3];
z[8] = v[1];
z[9] = (T(1) / T(2)) * z[5];
z[10] = 3 * z[4] + -z[5];
z[10] = z[9] * z[10];
z[11] = (T(1) / T(2)) * z[6];
z[12] = -z[4] + z[5];
z[13] = z[11] * z[12];
z[14] = prod_pow(z[4], 2);
z[10] = z[10] + z[13] + -z[14];
z[10] = z[6] * z[10];
z[13] = -z[4] + z[9];
z[13] = z[5] * z[13];
z[13] = z[13] + (T(1) / T(2)) * z[14];
z[15] = z[5] * z[13];
z[10] = z[10] + -z[15];
z[16] = (T(1) / T(2)) * z[0];
z[10] = z[10] * z[16];
z[17] = z[5] * z[7];
z[18] = z[4] * z[7];
z[19] = 1 + (T(-7) / T(12)) * z[18];
z[19] = (T(21) / T(8)) * z[17] + 5 * z[19];
z[19] = z[5] * z[19];
z[20] = (T(19) / T(4)) * z[18];
z[21] = -41 + z[20];
z[21] = z[4] * z[21];
z[19] = z[19] + (T(1) / T(6)) * z[21];
z[19] = z[5] * z[19];
z[21] = (T(-13) / T(2)) * z[4] + 5 * z[5];
z[21] = z[6] * z[21];
z[10] = z[10] + (T(25) / T(12)) * z[14] + z[19] + (T(1) / T(6)) * z[21];
z[10] = z[0] * z[10];
z[19] = prod_pow(z[7], 2);
z[21] = z[5] * z[19];
z[22] = z[4] * z[19];
z[23] = (T(-41) / T(2)) * z[7] + (T(-19) / T(6)) * z[21] + -z[22];
z[23] = z[5] * z[23];
z[24] = 35 * z[7] + (T(13) / T(2)) * z[22];
z[24] = z[4] * z[24];
z[24] = T(-95) / T(2) + z[24];
z[23] = z[23] + (T(1) / T(3)) * z[24];
z[23] = z[5] * z[23];
z[24] = 3 + (T(1) / T(3)) * z[18];
z[24] = z[4] * z[24];
z[23] = (T(-13) / T(6)) * z[6] + z[23] + (T(7) / T(2)) * z[24];
z[10] = z[10] + (T(1) / T(2)) * z[23];
z[10] = z[0] * z[10];
z[23] = 13 * z[4];
z[24] = z[19] * z[23];
z[25] = -67 * z[7] + -z[24];
z[25] = z[4] * z[25];
z[26] = 19 * z[5];
z[26] = z[19] * z[26];
z[27] = 31 * z[7] + -5 * z[22] + z[26];
z[27] = z[5] * z[27];
z[25] = 5 + (T(1) / T(4)) * z[25] + z[27];
z[27] = (T(-127) / T(2)) * z[7] + z[24] + -z[26];
z[28] = (T(1) / T(4)) * z[5];
z[27] = z[27] * z[28];
z[27] = -5 + 16 * z[18] + z[27];
z[27] = z[5] * z[27];
z[29] = (T(1) / T(2)) * z[4];
z[20] = 13 + -z[20];
z[20] = z[20] * z[29];
z[20] = z[20] + z[27];
z[27] = -z[4] * z[5];
z[27] = z[14] + z[27];
z[30] = z[6] * z[12];
z[27] = (T(1) / T(2)) * z[27] + -z[30];
z[27] = z[16] * z[27];
z[20] = (T(1) / T(4)) * z[6] + (T(1) / T(3)) * z[20] + z[27];
z[20] = z[0] * z[20];
z[20] = z[20] + (T(1) / T(3)) * z[25];
z[20] = z[0] * z[20];
z[25] = -z[7] + z[22];
z[27] = -13 * z[25] + z[26];
z[27] = z[5] * z[27];
z[12] = z[0] * z[12];
z[12] = T(-1) / T(4) + (T(1) / T(4)) * z[12] + (T(-4) / T(3)) * z[18] + (T(1) / T(12)) * z[27];
z[12] = z[0] * z[12];
z[25] = (T(13) / T(2)) * z[25] + -z[26];
z[12] = z[12] + (T(1) / T(6)) * z[25];
z[12] = z[0] * z[12];
z[12] = z[12] + (T(19) / T(12)) * z[19];
z[12] = z[3] * z[12];
z[25] = (T(-121) / T(2)) * z[7] + -95 * z[21] + 7 * z[22];
z[27] = z[8] * z[19];
z[12] = z[12] + z[20] + (T(1) / T(12)) * z[25] + (T(19) / T(6)) * z[27];
z[12] = z[3] * z[12];
z[20] = 11 * z[7];
z[25] = -z[20] + -z[24];
z[25] = z[4] * z[25];
z[25] = 19 + z[25];
z[31] = (T(271) / T(2)) * z[7] + 31 * z[22];
z[26] = z[26] + (T(1) / T(3)) * z[31];
z[26] = z[9] * z[26];
z[25] = (T(1) / T(3)) * z[25] + z[26];
z[20] = -z[20] + (T(-25) / T(4)) * z[22];
z[20] = (T(1) / T(3)) * z[20] + (T(-19) / T(4)) * z[21] + (T(19) / T(12)) * z[27];
z[20] = z[8] * z[20];
z[10] = z[10] + z[12] + z[20] + (T(1) / T(2)) * z[25];
z[10] = z[3] * z[10];
z[12] = 7 * z[4] + (T(-31) / T(8)) * z[5];
z[12] = z[5] * z[12];
z[12] = z[12] + (T(-25) / T(8)) * z[14];
z[12] = z[5] * z[12];
z[20] = 17 * z[4] + (T(-37) / T(4)) * z[5];
z[20] = z[5] * z[20];
z[20] = (T(-31) / T(4)) * z[14] + z[20];
z[11] = z[11] * z[20];
z[11] = z[11] + z[12];
z[12] = z[6] * z[13];
z[12] = z[12] + z[15];
z[12] = z[6] * z[12] * z[16];
z[11] = (T(1) / T(3)) * z[11] + z[12];
z[11] = z[0] * z[11];
z[12] = z[14] + z[30];
z[13] = T(37) / T(3) + (T(25) / T(6)) * z[17] + -z[18];
z[13] = z[13] * z[28];
z[14] = -10 + (T(-7) / T(8)) * z[18];
z[14] = z[4] * z[14];
z[13] = z[13] + (T(1) / T(3)) * z[14];
z[13] = z[5] * z[13];
z[11] = z[11] + (T(3) / T(4)) * z[12] + z[13];
z[11] = z[0] * z[11];
z[12] = z[19] * z[29];
z[12] = -z[7] + z[12];
z[12] = z[12] * z[23];
z[13] = 19 * z[22];
z[14] = (T(-43) / T(2)) * z[7] + -z[13];
z[9] = z[9] * z[14];
z[9] = T(-29) / T(4) + z[9] + z[12];
z[9] = z[5] * z[9];
z[12] = T(-1) / T(3) + (T(11) / T(2)) * z[18];
z[12] = z[12] * z[29];
z[9] = (T(7) / T(12)) * z[6] + (T(1) / T(3)) * z[9] + z[12];
z[12] = 29 * z[7] + -z[24];
z[12] = z[4] * z[12];
z[14] = (T(7) / T(2)) * z[7] + -z[13];
z[14] = z[8] * z[14];
z[12] = -7 + z[12] + z[14];
z[13] = (T(11) / T(4)) * z[7] + z[13];
z[13] = z[5] * z[13];
z[12] = (T(1) / T(2)) * z[12] + z[13];
z[12] = z[8] * z[12];
z[9] = (T(1) / T(2)) * z[9] + z[10] + z[11] + (T(1) / T(6)) * z[12];
return z[1] * z[2] * z[3] * z[9];
}



template double eval_coef_2q3y_2l_pmmpp_12345_55(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_55(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
