#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_56(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[18];
z[0] = iW[1];
z[1] = v[0];
z[2] = v[2];
z[3] = v[4];
z[4] = iW[3];
z[5] = iW[7];
z[6] = iW[15];
z[7] = v[3];
z[8] = prod_pow(z[2], 2);
z[9] = 11 * z[2];
z[10] = (T(25) / T(4)) * z[3] + -z[9];
z[10] = z[3] * z[10];
z[9] = (T(25) / T(4)) * z[1] + 5 * z[3] + -z[9];
z[9] = z[1] * z[9];
z[9] = (T(19) / T(4)) * z[8] + z[9] + z[10];
z[9] = z[1] * z[9];
z[10] = 13 * z[2];
z[11] = 19 * z[3];
z[12] = -13 * z[1] + z[10] + -z[11];
z[13] = (T(1) / T(2)) * z[4];
z[14] = prod_pow(z[1], 2);
z[12] = z[3] * z[12] * z[13] * z[14];
z[9] = z[9] + z[12];
z[12] = (T(1) / T(3)) * z[4];
z[9] = z[9] * z[12];
z[13] = -z[2] + z[3];
z[15] = (T(1) / T(2)) * z[1];
z[16] = -z[13] * z[15];
z[17] = z[2] + (T(-1) / T(2)) * z[3];
z[17] = z[3] * z[17];
z[16] = (T(-1) / T(2)) * z[8] + z[16] + z[17];
z[16] = z[0] * z[16];
z[16] = (T(-3) / T(2)) * z[2] + z[3] + (T(1) / T(2)) * z[7] + z[16];
z[16] = z[1] * z[16];
z[9] = z[9] + z[16];
z[16] = (T(1) / T(2)) * z[0];
z[9] = z[9] * z[16];
z[11] = -z[2] * z[11];
z[8] = 13 * z[8] + z[11];
z[10] = (T(13) / T(2)) * z[1] + (T(19) / T(2)) * z[3] + -z[10];
z[10] = z[1] * z[10];
z[8] = (T(1) / T(2)) * z[8] + z[10];
z[8] = z[4] * z[8] * z[15];
z[10] = -z[1] + z[2] + (T(-7) / T(4)) * z[3];
z[10] = z[1] * z[10];
z[8] = z[8] + 5 * z[10];
z[8] = z[8] * z[12];
z[8] = -z[1] + z[8] + z[9];
z[8] = z[0] * z[8];
z[9] = z[3] * z[7];
z[10] = prod_pow(z[3], 2);
z[9] = z[9] + -z[10];
z[11] = z[7] * z[9];
z[12] = -z[2] + z[7];
z[12] = z[7] * z[12];
z[10] = z[10] + z[12];
z[10] = z[1] * z[10];
z[10] = z[10] + z[11];
z[10] = z[0] * z[10] * z[15];
z[11] = -z[7] + (T(-1) / T(2)) * z[13];
z[11] = z[1] * z[11];
z[9] = (T(-1) / T(2)) * z[9] + z[11];
z[9] = z[1] * z[9];
z[9] = z[9] + z[10];
z[9] = z[0] * z[5] * z[9];
z[10] = (T(1) / T(2)) * z[5];
z[10] = z[10] * z[14];
z[9] = z[9] + z[10];
z[9] = z[6] * z[9];
return z[8] + (T(1) / T(2)) * z[9];
}



template double eval_coef_2q3y_2l_pmmpp_12345_56(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_56(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
