#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_63(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[30];
z[0] = iW[1];
z[1] = iW[3];
z[2] = iW[21];
z[3] = v[0];
z[4] = v[4];
z[5] = iW[22];
z[6] = v[2];
z[7] = iW[15];
z[8] = v[3];
z[9] = iW[9];
z[10] = iW[20];
z[11] = z[1] * z[4];
z[12] = T(1) / T(2) + z[11];
z[13] = z[1] * z[6];
z[14] = (T(1) / T(2)) * z[4];
z[15] = z[9] * z[14];
z[16] = -z[1] + (T(1) / T(2)) * z[9];
z[16] = z[3] * z[16];
z[15] = (T(-277) / T(18)) * z[12] + z[13] + z[15] + z[16];
z[15] = z[3] * z[15];
z[16] = (T(1) / T(2)) * z[1];
z[17] = prod_pow(z[4], 2);
z[18] = z[16] * z[17];
z[19] = z[4] + (T(1) / T(2)) * z[8];
z[20] = z[18] + z[19];
z[21] = z[6] * z[20];
z[22] = prod_pow(z[4], 3);
z[16] = -z[16] * z[22];
z[19] = z[8] * z[19];
z[16] = z[16] + z[19] + z[21];
z[23] = z[4] * z[8];
z[24] = z[17] + z[23];
z[25] = z[1] * z[3];
z[26] = z[17] * z[25];
z[26] = z[24] + z[26];
z[26] = z[3] * z[26];
z[27] = prod_pow(z[8], 2);
z[28] = z[7] * z[27];
z[28] = z[8] + z[28];
z[28] = z[24] * z[28];
z[26] = z[26] + z[28];
z[26] = z[2] * z[26];
z[12] = z[3] * z[12];
z[12] = z[12] + (T(277) / T(18)) * z[20];
z[12] = z[3] * z[12];
z[12] = z[12] + (T(277) / T(18)) * z[16] + (T(277) / T(36)) * z[26];
z[12] = z[0] * z[12];
z[16] = -z[4] + z[6];
z[20] = z[8] + z[16];
z[20] = z[6] * z[20];
z[20] = z[20] + -z[23];
z[20] = z[10] * z[20];
z[26] = z[1] * z[17];
z[20] = -z[16] + z[20] + (T(277) / T(18)) * z[26];
z[26] = (T(1) / T(2)) * z[17];
z[28] = z[23] + z[26];
z[28] = z[7] * z[8] * z[28];
z[29] = -z[3] * z[11];
z[18] = z[18] + z[29];
z[18] = z[3] * z[18];
z[18] = z[18] + (T(-1) / T(2)) * z[23] + -z[28];
z[29] = (T(277) / T(18)) * z[2];
z[18] = z[18] * z[29];
z[12] = z[12] + z[15] + z[18] + (T(1) / T(2)) * z[20];
z[12] = z[0] * z[12];
z[15] = prod_pow(z[4], 4) * z[1];
z[15] = z[15] + -z[22];
z[18] = z[19] + -z[26];
z[18] = z[8] * z[18];
z[15] = (T(1) / T(2)) * z[15] + z[18];
z[18] = z[1] * z[22];
z[19] = -z[18] + z[21] + -z[26];
z[14] = (T(1) / T(3)) * z[8] + z[14];
z[14] = z[8] * z[14];
z[14] = z[14] + (T(1) / T(3)) * z[19];
z[14] = z[6] * z[14];
z[19] = (T(1) / T(6)) * z[7];
z[19] = z[19] * z[24] * z[27];
z[14] = z[14] + (T(1) / T(3)) * z[15] + z[19];
z[14] = z[0] * z[14];
z[15] = 1 + z[13];
z[15] = z[15] * z[17];
z[15] = z[15] + -z[18] + -z[23];
z[15] = (T(1) / T(2)) * z[15] + -z[28];
z[14] = z[14] + (T(1) / T(3)) * z[15];
z[14] = z[0] * z[14];
z[15] = z[7] * z[23];
z[14] = z[14] + (T(1) / T(6)) * z[15];
z[14] = z[5] * z[14];
z[11] = -z[11] + -z[13] + z[25];
z[11] = z[3] * z[11];
z[11] = z[11] + z[15];
z[11] = z[11] * z[29];
z[13] = -z[10] * z[16];
z[11] = z[11] + z[13];
z[11] = (T(1) / T(2)) * z[11] + z[12] + (T(277) / T(6)) * z[14];
return (T(1) / T(4)) * z[11];
}



template double eval_coef_2q3y_2l_pmmpp_12345_63(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_63(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
