#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_71(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[20];
z[0] = iW[1];
z[1] = iW[16];
z[2] = v[0];
z[3] = v[2];
z[4] = v[4];
z[5] = iW[2];
z[6] = iW[3];
z[7] = iW[19];
z[8] = v[1];
z[9] = (T(1) / T(2)) * z[4];
z[10] = prod_pow(z[0], 2);
z[11] = z[9] * z[10];
z[11] = -z[0] + z[11];
z[12] = z[4] * z[11];
z[12] = T(1) / T(2) + z[12];
z[13] = z[5] * z[12];
z[14] = z[4] * z[10];
z[15] = -z[0] + z[14];
z[16] = z[3] * z[15];
z[12] = -19 * z[12] + (T(13) / T(2)) * z[16];
z[12] = z[6] * z[12];
z[16] = z[3] * z[10];
z[12] = (T(1) / T(3)) * z[12] + z[13] + (T(13) / T(12)) * z[15] + (T(-25) / T(12)) * z[16];
z[13] = (T(1) / T(2)) * z[2];
z[12] = z[12] * z[13];
z[15] = (T(1) / T(3)) * z[4];
z[17] = (T(-83) / T(4)) * z[0] + 8 * z[14];
z[17] = z[15] * z[17];
z[11] = z[3] * z[11];
z[11] = T(17) / T(4) + (T(-13) / T(6)) * z[11] + z[17];
z[11] = z[3] * z[11];
z[17] = z[10] * z[15];
z[17] = -z[0] + z[17];
z[18] = -z[4] * z[17];
z[18] = -1 + z[18];
z[18] = z[4] * z[18];
z[18] = (T(1) / T(3)) * z[8] + z[18];
z[11] = z[11] + (T(19) / T(4)) * z[18];
z[11] = z[6] * z[11];
z[17] = z[9] * z[17];
z[17] = T(1) / T(3) + z[17];
z[18] = 13 * z[0] + (T(-35) / T(3)) * z[14];
z[16] = (T(11) / T(3)) * z[16] + (T(1) / T(2)) * z[18];
z[18] = (T(1) / T(2)) * z[3];
z[16] = z[16] * z[18];
z[19] = -3 * z[0] + z[14];
z[19] = z[4] * z[19];
z[19] = 3 + z[19];
z[19] = z[4] * z[19];
z[19] = -z[8] + z[19];
z[19] = z[5] * z[19];
z[11] = z[11] + z[12] + z[16] + 5 * z[17] + (T(1) / T(4)) * z[19];
z[11] = z[6] * z[11];
z[12] = prod_pow(z[0], 3);
z[9] = -z[9] * z[12];
z[9] = z[9] + z[10];
z[9] = z[4] * z[9];
z[16] = -z[4] + z[18];
z[16] = z[12] * z[16];
z[17] = -z[10] + -z[16];
z[17] = z[3] * z[17];
z[9] = -z[0] + z[9] + z[17];
z[9] = (T(1) / T(2)) * z[9] + z[11];
z[9] = z[2] * z[9];
z[11] = z[3] * z[6];
z[17] = -1 + -z[11];
z[9] = z[9] + (T(1) / T(4)) * z[17];
z[9] = z[1] * z[9];
z[14] = 29 * z[0] + (T(-25) / T(2)) * z[14];
z[14] = z[14] * z[15];
z[14] = T(-9) / T(2) + z[14];
z[15] = (T(-19) / T(8)) * z[3] + (T(11) / T(2)) * z[4];
z[15] = z[10] * z[15];
z[15] = -5 * z[0] + z[15];
z[15] = z[3] * z[15];
z[17] = z[0] * z[3];
z[18] = z[0] * z[4];
z[19] = -1 + z[18];
z[19] = -13 * z[17] + 19 * z[19];
z[11] = z[11] * z[19];
z[11] = (T(1) / T(12)) * z[11] + (T(1) / T(4)) * z[14] + (T(1) / T(3)) * z[15];
z[11] = z[6] * z[11];
z[12] = z[4] * z[12];
z[12] = -3 * z[10] + z[12];
z[12] = z[4] * z[12];
z[12] = z[0] + z[12];
z[10] = (T(3) / T(2)) * z[10] + z[16];
z[10] = z[3] * z[10];
z[10] = z[10] + (T(1) / T(2)) * z[12];
z[9] = z[9] + (T(1) / T(2)) * z[10] + z[11];
z[9] = z[2] * z[9];
z[10] = T(-3) / T(2) + z[18];
z[11] = z[4] * z[10];
z[12] = -z[3] * z[18];
z[11] = z[11] + z[12];
z[11] = z[6] * z[11];
z[10] = z[10] + z[11] + -z[17];
z[10] = z[7] * z[10] * z[13];
return z[9] + z[10];
}



template double eval_coef_2q3y_2l_pmmpp_12345_71(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_71(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
