#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_72(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[42];
z[0] = iW[0];
z[1] = iW[3];
z[2] = iW[18];
z[3] = iW[21];
z[4] = v[1];
z[5] = v[2];
z[6] = v[4];
z[7] = v[3];
z[8] = iW[1];
z[9] = v[0];
z[10] = z[5] * z[7];
z[11] = 3 * z[10];
z[12] = prod_pow(z[5], 2);
z[13] = z[11] + (T(-7) / T(2)) * z[12];
z[13] = z[7] * z[13];
z[11] = -z[11] + 2 * z[12];
z[11] = z[9] * z[11];
z[11] = z[11] + z[13];
z[11] = z[8] * z[11];
z[13] = z[1] * z[5];
z[14] = T(-3) / T(2) + z[13];
z[15] = 3 * z[9];
z[16] = z[14] * z[15];
z[17] = z[1] * z[12];
z[18] = (T(3) / T(2)) * z[17];
z[19] = 6 * z[5] + (T(-13) / T(2)) * z[7] + -z[16] + z[18];
z[19] = z[9] * z[19];
z[20] = 7 * z[5];
z[21] = 2 * z[7] + -z[20];
z[21] = z[7] * z[21];
z[11] = z[11] + z[12] + z[19] + z[21];
z[11] = z[8] * z[11];
z[19] = (T(3) / T(2)) * z[7];
z[21] = 4 * z[5];
z[22] = -z[19] + z[21];
z[22] = z[7] * z[22];
z[23] = 5 * z[5];
z[24] = 3 * z[7];
z[25] = z[23] + -z[24];
z[14] = z[9] * z[14];
z[26] = z[14] + -z[25];
z[26] = z[9] * z[26];
z[22] = z[22] + z[26];
z[22] = z[8] * z[22];
z[26] = z[1] * z[9];
z[27] = -2 + (T(-1) / T(2)) * z[13];
z[27] = 6 * z[26] + 5 * z[27];
z[27] = z[9] * z[27];
z[28] = 4 * z[7];
z[22] = -z[5] + z[22] + z[27] + z[28];
z[22] = z[8] * z[22];
z[27] = 2 * z[26];
z[29] = z[1] * z[4];
z[30] = z[27] + -z[29];
z[31] = (T(1) / T(2)) * z[7];
z[32] = (T(1) / T(2)) * z[26];
z[33] = 1 + -z[32];
z[33] = z[9] * z[33];
z[33] = -z[31] + z[33];
z[33] = z[8] * z[33];
z[34] = 1 + -z[26];
z[33] = 3 * z[33] + (T(1) / T(2)) * z[34];
z[33] = z[8] * z[33];
z[33] = (T(1) / T(4)) * z[1] + z[33];
z[33] = z[6] * z[33];
z[22] = T(-3) / T(4) + -z[13] + z[22] + z[30] + z[33];
z[22] = z[6] * z[22];
z[33] = (T(1) / T(2)) * z[1];
z[34] = z[4] * z[33];
z[34] = T(-1) / T(4) + z[13] + -z[26] + z[34];
z[34] = z[4] * z[34];
z[35] = (T(5) / T(2)) * z[1];
z[35] = z[12] * z[35];
z[36] = -z[5] + (T(-11) / T(2)) * z[7] + -z[35];
z[37] = (T(5) / T(2)) * z[13];
z[38] = 4 + -3 * z[26] + z[37];
z[38] = z[15] * z[38];
z[11] = z[11] + z[22] + 3 * z[34] + (T(1) / T(2)) * z[36] + z[38];
z[11] = z[6] * z[11];
z[22] = -2 + z[27] + -z[37];
z[15] = z[15] * z[22];
z[22] = 3 * z[13];
z[27] = T(7) / T(4) + -z[22] + z[30];
z[27] = z[4] * z[27];
z[15] = z[15] + z[21] + z[27] + -z[31] + z[35];
z[15] = z[4] * z[15];
z[27] = -z[5] + z[17];
z[16] = z[16] + -3 * z[27] + z[28];
z[16] = z[9] * z[16];
z[27] = prod_pow(z[5], 3);
z[28] = (T(3) / T(2)) * z[12];
z[30] = -z[7] * z[28];
z[30] = z[27] + z[30];
z[30] = z[8] * z[30];
z[34] = 3 * z[12];
z[30] = -2 * z[10] + z[30] + z[34];
z[30] = z[7] * z[30];
z[36] = (T(3) / T(2)) * z[10] + -z[12];
z[36] = z[9] * z[36];
z[38] = (T(1) / T(2)) * z[27];
z[30] = z[30] + z[36] + -z[38];
z[30] = z[8] * z[30];
z[39] = z[27] * z[33];
z[40] = (T(1) / T(4)) * z[7];
z[41] = z[5] + -z[40];
z[41] = z[7] * z[41];
z[11] = z[11] + (T(-13) / T(4)) * z[12] + z[15] + z[16] + z[30] + z[39] + z[41];
z[11] = z[6] * z[11];
z[14] = -z[14] + z[18] + -z[21] + -z[31];
z[14] = z[9] * z[14];
z[15] = z[19] + -z[23] + -z[35];
z[16] = T(-3) / T(4) + z[13] + (T(1) / T(4)) * z[29] + -z[32];
z[16] = z[4] * z[16];
z[18] = 1 + (T(-3) / T(2)) * z[26] + z[37];
z[18] = z[9] * z[18];
z[15] = (T(1) / T(2)) * z[15] + z[16] + z[18];
z[15] = z[4] * z[15];
z[16] = 2 * z[5] + -z[40];
z[16] = z[7] * z[16];
z[14] = (T(9) / T(4)) * z[12] + z[14] + z[15] + z[16] + -z[39];
z[14] = z[4] * z[14];
z[15] = 13 * z[5] + -z[24];
z[15] = z[7] * z[15];
z[16] = -z[1] * z[27];
z[15] = -7 * z[12] + z[15] + z[16];
z[16] = (T(1) / T(4)) * z[4];
z[18] = -1 + z[22];
z[18] = z[16] * z[18];
z[19] = -11 * z[5] + z[24];
z[18] = z[17] + z[18] + (T(1) / T(4)) * z[19];
z[18] = z[4] * z[18];
z[15] = (T(1) / T(4)) * z[15] + z[18];
z[15] = z[4] * z[15];
z[18] = 1 + -z[13];
z[18] = z[4] * z[18];
z[17] = -z[17] + (T(3) / T(2)) * z[18] + z[25];
z[17] = z[4] * z[17];
z[18] = -z[20] + z[24];
z[18] = z[7] * z[18];
z[18] = z[12] + z[18];
z[19] = -z[5] + z[7];
z[20] = -3 + z[13];
z[20] = z[4] * z[20];
z[19] = z[6] + 3 * z[19] + z[20];
z[20] = (T(1) / T(2)) * z[6];
z[19] = z[19] * z[20];
z[17] = z[17] + (T(1) / T(2)) * z[18] + z[19];
z[17] = z[17] * z[20];
z[18] = z[7] + -z[23];
z[18] = z[7] * z[18];
z[18] = z[18] + z[34];
z[18] = z[7] * z[18];
z[18] = z[18] + z[27];
z[15] = z[15] + z[17] + (T(1) / T(4)) * z[18];
z[15] = z[6] * z[15];
z[17] = -z[10] + z[12];
z[17] = 3 * z[17] + z[39];
z[18] = -z[12] * z[33];
z[13] = -z[13] * z[16];
z[13] = z[5] + z[13] + z[18];
z[13] = z[4] * z[13];
z[13] = z[13] + (T(1) / T(2)) * z[17];
z[13] = z[4] * z[13];
z[16] = z[10] + -z[28];
z[16] = z[7] * z[16];
z[13] = z[13] + z[16] + -z[38];
z[13] = z[4] * z[13];
z[10] = (T(1) / T(2)) * z[10];
z[16] = -z[10] + z[12];
z[16] = z[7] * z[16];
z[16] = z[16] + z[38];
z[16] = z[16] * z[31];
z[13] = z[13] + z[15] + z[16];
z[13] = z[0] * z[13];
z[10] = -z[10] + -z[12];
z[10] = z[7] * z[10];
z[10] = z[10] + z[11] + z[13] + z[14] + z[36] + z[38];
return prod_pow(z[3], 2) * z[2] * z[10];
}



template double eval_coef_2q3y_2l_pmmpp_12345_72(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_72(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
