#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_77(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[37];
z[0] = iW[1];
z[1] = iW[3];
z[2] = iW[12];
z[3] = iW[15];
z[4] = iW[17];
z[5] = iW[19];
z[6] = v[0];
z[7] = v[4];
z[8] = v[2];
z[9] = v[3];
z[10] = v[1];
z[11] = 5 * z[1];
z[12] = (T(13) / T(6)) * z[0] + -z[1];
z[12] = z[11] * z[12];
z[13] = prod_pow(z[0], 2);
z[14] = (T(13) / T(3)) * z[13];
z[15] = z[0] * z[1];
z[16] = 7 * z[15];
z[17] = -z[14] + -z[16];
z[18] = (T(1) / T(2)) * z[1];
z[19] = z[6] * z[18];
z[17] = z[17] * z[19];
z[20] = (T(3) / T(2)) * z[13];
z[12] = z[12] + z[17] + -z[20];
z[12] = z[6] * z[12];
z[17] = z[9] * z[13];
z[21] = -91 * z[0] + 25 * z[17];
z[22] = z[1] * z[10];
z[23] = 3 * z[22];
z[24] = T(287) / T(9) + -z[23];
z[24] = z[1] * z[24];
z[21] = (T(1) / T(3)) * z[21] + z[24];
z[12] = z[12] + (T(1) / T(2)) * z[21];
z[21] = (T(1) / T(2)) * z[6];
z[12] = z[12] * z[21];
z[24] = prod_pow(z[1], 2);
z[25] = z[6] * z[13] * z[24];
z[26] = (T(5) / T(3)) * z[25];
z[27] = -7 * z[13] + (T(-1) / T(2)) * z[15];
z[27] = z[1] * z[27];
z[27] = z[26] + z[27];
z[27] = z[21] * z[27];
z[28] = -4 * z[0] + (T(-13) / T(4)) * z[1];
z[28] = z[1] * z[28];
z[28] = 8 * z[13] + z[28];
z[27] = z[27] + (T(1) / T(3)) * z[28];
z[27] = z[6] * z[27];
z[28] = -z[0] + z[1];
z[29] = (T(1) / T(4)) * z[28];
z[27] = z[27] + z[29];
z[27] = z[7] * z[27];
z[30] = z[0] * z[9];
z[12] = T(-29) / T(9) + z[12] + (T(89) / T(36)) * z[22] + z[27] + (T(3) / T(4)) * z[30];
z[12] = z[7] * z[12];
z[27] = z[1] * z[28];
z[31] = (T(-8) / T(3)) * z[13] + (T(-3) / T(2)) * z[27];
z[31] = z[6] * z[31];
z[32] = 19 * z[17];
z[33] = (T(-61) / T(3)) * z[0] + z[32];
z[34] = T(29) / T(3) + (T(-3) / T(2)) * z[22];
z[34] = z[1] * z[34];
z[31] = z[31] + (T(1) / T(4)) * z[33] + z[34];
z[31] = z[6] * z[31];
z[33] = (T(19) / T(12)) * z[17];
z[34] = 2 * z[0] + -z[33];
z[34] = z[9] * z[34];
z[31] = T(-317) / T(36) + (T(20) / T(3)) * z[22] + z[31] + z[34];
z[31] = z[6] * z[31];
z[34] = T(20) / T(9) + (T(-1) / T(4)) * z[30];
z[34] = z[9] * z[34];
z[12] = (T(-71) / T(36)) * z[10] + z[12] + z[31] + z[34];
z[12] = z[6] * z[12];
z[31] = 13 * z[13];
z[34] = z[16] + z[31];
z[34] = z[19] * z[34];
z[24] = (T(-13) / T(2)) * z[13] + 5 * z[24] + z[34];
z[24] = z[6] * z[24];
z[34] = -3 + z[22];
z[34] = z[18] * z[34];
z[24] = z[0] + (T(1) / T(3)) * z[24] + z[34];
z[24] = z[7] * z[24];
z[28] = -z[19] * z[28];
z[34] = (T(1) / T(2)) * z[22];
z[35] = 1 + -z[34];
z[35] = z[1] * z[35];
z[28] = (T(-1) / T(2)) * z[0] + z[28] + z[35];
z[28] = z[8] * z[28];
z[24] = z[24] + z[28];
z[24] = z[21] * z[24];
z[27] = (T(4) / T(3)) * z[13] + z[27];
z[27] = z[6] * z[27];
z[28] = 37 * z[0] + -z[32];
z[35] = T(-38) / T(9) + z[22];
z[35] = z[1] * z[35];
z[28] = z[27] + (T(1) / T(12)) * z[28] + z[35];
z[28] = z[6] * z[28];
z[35] = (T(20) / T(9)) * z[22];
z[36] = T(49) / T(9) + -z[30];
z[28] = z[28] + -z[35] + (T(1) / T(2)) * z[36];
z[28] = z[6] * z[28];
z[24] = z[24] + z[28];
z[24] = z[8] * z[24];
z[12] = z[12] + z[24];
z[12] = z[8] * z[12];
z[24] = (T(31) / T(3)) * z[13] + z[15];
z[24] = z[18] * z[24];
z[24] = z[24] + -z[26];
z[24] = z[6] * z[24];
z[26] = (T(-41) / T(2)) * z[0] + 13 * z[1];
z[26] = z[1] * z[26];
z[26] = (T(-55) / T(2)) * z[13] + z[26];
z[24] = z[24] + (T(1) / T(6)) * z[26];
z[24] = z[6] * z[24];
z[26] = 47 * z[0] + 13 * z[17];
z[26] = -19 * z[1] + (T(1) / T(3)) * z[26];
z[24] = z[24] + (T(1) / T(4)) * z[26];
z[24] = z[6] * z[24];
z[26] = 1 + -z[30];
z[24] = z[24] + (T(1) / T(4)) * z[26];
z[24] = z[6] * z[24];
z[26] = (T(35) / T(4)) * z[13] + -4 * z[15];
z[26] = z[1] * z[26];
z[26] = -4 * z[25] + z[26];
z[26] = z[6] * z[26];
z[28] = -z[13] + z[15];
z[26] = z[26] + (T(19) / T(4)) * z[28];
z[28] = prod_pow(z[6], 2);
z[36] = z[7] * z[28];
z[26] = z[26] * z[36];
z[24] = z[24] + (T(1) / T(3)) * z[26];
z[24] = z[7] * z[24];
z[26] = (T(-13) / T(3)) * z[0] + z[1];
z[11] = z[11] * z[26];
z[14] = -z[14] + z[16];
z[14] = z[14] * z[19];
z[11] = z[11] + (T(67) / T(6)) * z[13] + z[14];
z[11] = z[6] * z[11];
z[14] = 187 * z[0] + -95 * z[17];
z[19] = T(-493) / T(9) + z[23];
z[19] = z[1] * z[19];
z[14] = (T(1) / T(3)) * z[14] + z[19];
z[11] = z[11] + (T(1) / T(2)) * z[14];
z[11] = z[11] * z[21];
z[14] = -6 * z[0] + (T(19) / T(6)) * z[17];
z[14] = z[9] * z[14];
z[11] = T(39) / T(4) + z[11] + z[14] + (T(-89) / T(18)) * z[22];
z[11] = z[6] * z[11];
z[14] = T(-89) / T(9) + z[30];
z[14] = z[9] * z[14];
z[11] = (T(20) / T(9)) * z[10] + z[11] + (T(1) / T(4)) * z[14];
z[11] = z[6] * z[11];
z[11] = z[11] + z[24];
z[11] = z[7] * z[11];
z[14] = 23 * z[0] + -41 * z[17];
z[19] = T(-26) / T(3) + z[22];
z[19] = z[1] * z[19];
z[14] = (T(1) / T(12)) * z[14] + z[19] + z[27];
z[14] = z[6] * z[14];
z[19] = z[0] + 11 * z[17];
z[19] = z[9] * z[19];
z[19] = T(85) / T(3) + (T(1) / T(2)) * z[19] + -20 * z[22];
z[14] = z[14] + (T(1) / T(3)) * z[19];
z[14] = z[6] * z[14];
z[19] = T(-28) / T(3) + (T(-5) / T(2)) * z[30];
z[19] = z[9] * z[19];
z[19] = (T(71) / T(6)) * z[10] + z[19];
z[14] = z[14] + (T(1) / T(3)) * z[19];
z[14] = z[14] * z[28];
z[11] = z[11] + z[12] + z[14];
z[11] = z[8] * z[11];
z[12] = (T(-5) / T(3)) * z[13] + (T(-1) / T(4)) * z[15];
z[12] = z[1] * z[12];
z[12] = z[12] + (T(5) / T(6)) * z[25];
z[12] = z[6] * z[12];
z[14] = 19 * z[0] + (T(-13) / T(3)) * z[1];
z[14] = z[1] * z[14];
z[14] = -5 * z[13] + z[14];
z[12] = z[12] + (T(1) / T(4)) * z[14];
z[12] = z[6] * z[12];
z[12] = -10 * z[0] + (T(9) / T(2)) * z[1] + z[12] + (T(11) / T(3)) * z[17];
z[12] = z[6] * z[12];
z[14] = 5 * z[0] + -z[33];
z[14] = z[9] * z[14];
z[12] = T(-41) / T(12) + z[12] + z[14];
z[12] = z[12] * z[28];
z[14] = (T(-9) / T(2)) * z[13] + (T(4) / T(3)) * z[15];
z[14] = z[1] * z[14];
z[14] = z[14] + (T(4) / T(3)) * z[25];
z[14] = z[6] * z[14];
z[13] = (T(1) / T(2)) * z[13] + (T(-1) / T(3)) * z[15];
z[13] = (T(19) / T(2)) * z[13] + z[14];
z[13] = z[6] * z[13];
z[14] = z[0] + -z[17];
z[13] = z[13] + (T(19) / T(12)) * z[14];
z[13] = z[13] * z[36];
z[12] = z[12] + z[13];
z[12] = z[7] * z[12];
z[13] = (T(13) / T(2)) * z[0] + -z[1];
z[13] = z[1] * z[13];
z[13] = (T(1) / T(3)) * z[13] + -z[20];
z[14] = -z[16] + z[31];
z[15] = z[1] * z[6];
z[14] = z[14] * z[15];
z[13] = 5 * z[13] + (T(1) / T(6)) * z[14];
z[13] = z[6] * z[13];
z[14] = T(233) / T(9) + -z[22];
z[14] = z[14] * z[18];
z[16] = -z[0] + (T(1) / T(2)) * z[17];
z[13] = z[13] + z[14] + 17 * z[16];
z[13] = z[6] * z[13];
z[14] = 25 * z[0] + -z[32];
z[14] = z[9] * z[14];
z[14] = T(-235) / T(3) + z[14] + (T(89) / T(3)) * z[22];
z[13] = z[13] + (T(1) / T(6)) * z[14];
z[13] = z[13] * z[21];
z[14] = T(2) / T(3) + z[30];
z[14] = z[9] * z[14];
z[14] = (T(-5) / T(3)) * z[10] + z[14];
z[13] = z[13] + (T(4) / T(3)) * z[14];
z[13] = z[13] * z[28];
z[12] = z[12] + z[13];
z[12] = z[7] * z[12];
z[13] = T(49) / T(9) + -z[34];
z[13] = z[13] * z[18];
z[14] = -z[15] * z[29];
z[15] = (T(1) / T(4)) * z[17];
z[13] = (T(1) / T(3)) * z[0] + z[13] + z[14] + z[15];
z[13] = z[6] * z[13];
z[14] = (T(-5) / T(3)) * z[0] + -z[15];
z[14] = z[9] * z[14];
z[13] = T(-121) / T(36) + z[13] + z[14] + z[35];
z[13] = z[6] * z[13];
z[14] = T(8) / T(3) + (T(13) / T(4)) * z[30];
z[14] = z[9] * z[14];
z[14] = (T(-71) / T(12)) * z[10] + z[14];
z[13] = z[13] + (T(1) / T(3)) * z[14];
z[13] = prod_pow(z[6], 3) * z[13];
z[11] = z[11] + z[12] + z[13];
return z[2] * z[3] * z[4] * z[5] * z[11];
}



template double eval_coef_2q3y_2l_pmmpp_12345_77(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_77(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
