#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_80(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[28];
z[0] = iW[1];
z[1] = iW[3];
z[2] = iW[12];
z[3] = iW[17];
z[4] = v[0];
z[5] = v[4];
z[6] = v[2];
z[7] = iW[4];
z[8] = v[3];
z[9] = (T(1) / T(2)) * z[5];
z[10] = prod_pow(z[0], 2);
z[11] = z[9] * z[10];
z[12] = z[5] * z[10];
z[13] = 3 * z[0];
z[14] = z[12] + -z[13];
z[15] = -z[5] * z[14];
z[15] = -2 + z[15];
z[15] = z[1] * z[15];
z[15] = z[11] + z[15];
z[15] = z[1] * z[15];
z[15] = z[10] + z[15];
z[15] = z[6] * z[15];
z[16] = 2 * z[0];
z[17] = -z[12] + z[16];
z[17] = z[5] * z[17];
z[17] = -1 + z[17];
z[17] = z[1] * z[17];
z[18] = (T(3) / T(2)) * z[0];
z[19] = -z[7] + z[18];
z[19] = z[0] * z[19];
z[20] = z[6] * z[7] * z[10];
z[19] = z[19] + -z[20];
z[21] = (T(1) / T(2)) * z[8];
z[22] = z[19] * z[21];
z[23] = -z[0] + z[11];
z[24] = z[5] * z[23];
z[25] = T(1) / T(2) + z[24];
z[26] = prod_pow(z[1], 2);
z[25] = z[25] * z[26];
z[10] = (T(1) / T(2)) * z[10];
z[25] = -z[10] + z[25];
z[25] = z[4] * z[25];
z[27] = -z[0] + -z[12];
z[15] = z[15] + z[17] + z[22] + z[25] + (T(1) / T(4)) * z[27];
z[15] = z[4] * z[15];
z[17] = z[11] + -z[13];
z[17] = z[5] * z[17];
z[17] = 3 + z[17];
z[17] = z[1] * z[17];
z[17] = -z[12] + z[17];
z[17] = z[1] * z[17];
z[10] = -z[10] + z[17];
z[10] = z[6] * z[10];
z[17] = -4 * z[0] + (T(3) / T(2)) * z[12];
z[17] = z[5] * z[17];
z[17] = 3 + z[17];
z[17] = z[1] * z[17];
z[10] = z[10] + z[17] + (T(-1) / T(2)) * z[23];
z[10] = z[6] * z[10];
z[17] = z[6] * z[19];
z[19] = -z[0] + z[7];
z[19] = z[0] * z[19];
z[19] = z[19] + z[20];
z[19] = z[8] * z[19];
z[19] = (T(3) / T(4)) * z[12] + -z[17] + (T(1) / T(4)) * z[19];
z[19] = z[8] * z[19];
z[18] = z[12] + -z[18];
z[18] = z[5] * z[18];
z[10] = T(1) / T(2) + z[10] + z[15] + z[18] + z[19];
z[10] = z[4] * z[10];
z[15] = z[11] + z[17];
z[17] = (T(1) / T(2)) * z[6];
z[15] = z[15] * z[17];
z[13] = -z[7] + z[13];
z[13] = z[0] * z[13];
z[13] = z[13] + -z[20];
z[13] = z[13] * z[17];
z[13] = z[0] + -z[12] + z[13];
z[13] = z[13] * z[21];
z[13] = z[13] + z[15] + -z[24];
z[13] = z[8] * z[13];
z[15] = -z[11] + z[16];
z[15] = z[5] * z[15];
z[16] = z[0] * z[5];
z[16] = -2 + z[16];
z[16] = z[1] * z[16];
z[11] = z[11] + z[16];
z[11] = z[6] * z[11];
z[11] = -3 + z[11] + z[15];
z[11] = z[1] * z[11];
z[12] = (T(-1) / T(2)) * z[0] + z[12];
z[11] = z[11] + (T(1) / T(2)) * z[12];
z[11] = z[6] * z[11];
z[9] = -z[9] * z[14];
z[9] = -1 + z[9] + z[11];
z[9] = z[6] * z[9];
z[9] = z[9] + z[10] + z[13];
z[9] = z[4] * z[9];
z[10] = z[17] * z[26];
z[10] = z[1] + z[10];
z[10] = z[6] * z[10];
z[10] = T(1) / T(2) + z[10];
z[10] = prod_pow(z[6], 2) * z[10];
z[9] = z[9] + z[10];
return prod_pow(z[3], 2) * z[2] * z[4] * z[9];
}



template double eval_coef_2q3y_2l_pmmpp_12345_80(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_80(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
