#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_81(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[19];
z[0] = iW[1];
z[1] = iW[2];
z[2] = iW[5];
z[3] = iW[18];
z[4] = v[0];
z[5] = v[3];
z[6] = v[4];
z[7] = iW[3];
z[8] = v[2];
z[9] = v[1];
z[10] = (T(1) / T(2)) * z[6];
z[11] = prod_pow(z[0], 2);
z[10] = z[10] * z[11];
z[12] = -z[0] + z[10];
z[12] = z[6] * z[12];
z[12] = T(1) / T(2) + z[12];
z[13] = -z[6] * z[12];
z[14] = z[5] * z[6];
z[15] = (T(3) / T(4)) * z[14];
z[16] = z[6] * z[11];
z[17] = z[0] + -z[16];
z[15] = z[15] * z[17];
z[13] = z[13] + z[15];
z[13] = z[1] * z[13];
z[14] = z[11] * z[14];
z[15] = (T(3) / T(4)) * z[6];
z[11] = -z[11] * z[15];
z[15] = 2 * z[0];
z[11] = z[11] + z[15];
z[11] = z[6] * z[11];
z[11] = T(-5) / T(4) + z[11] + z[13] + (T(3) / T(4)) * z[14];
z[11] = z[5] * z[11];
z[13] = -z[10] + z[15];
z[13] = z[6] * z[13];
z[13] = T(-5) / T(2) + z[13];
z[13] = z[6] * z[13];
z[11] = z[9] + z[11] + z[13];
z[11] = z[1] * z[11];
z[13] = -z[15] + z[16];
z[13] = z[6] * z[13];
z[15] = -3 * z[0] + z[16];
z[15] = z[6] * z[15];
z[15] = 3 + z[15];
z[15] = z[6] * z[15];
z[15] = -z[9] + z[15];
z[17] = (T(1) / T(2)) * z[7];
z[18] = z[15] * z[17];
z[13] = 1 + z[13] + z[18];
z[13] = z[7] * z[13];
z[18] = z[5] * z[12];
z[18] = z[15] + 3 * z[18];
z[18] = z[1] * z[18];
z[15] = z[7] * z[15];
z[12] = 5 * z[12] + z[15] + z[18];
z[12] = z[1] * z[12];
z[12] = (T(1) / T(2)) * z[12] + z[13];
z[12] = z[4] * z[12];
z[13] = (T(11) / T(2)) * z[0] + -z[16];
z[13] = z[6] * z[13];
z[15] = 5 * z[0] + -z[16];
z[15] = z[6] * z[15];
z[15] = -7 + z[15];
z[15] = z[6] * z[15];
z[15] = 3 * z[9] + z[15];
z[15] = z[7] * z[15];
z[13] = T(-9) / T(2) + z[13] + (T(5) / T(2)) * z[14] + z[15];
z[10] = z[0] + z[10];
z[10] = z[6] * z[10];
z[14] = z[0] * z[6];
z[14] = -2 + z[14];
z[14] = z[6] * z[14];
z[14] = z[9] + z[14];
z[14] = z[7] * z[14];
z[10] = T(-3) / T(2) + z[10] + z[14];
z[10] = z[7] * z[10];
z[10] = z[10] + z[16];
z[10] = z[8] * z[10];
z[10] = z[10] + z[11] + z[12] + (T(1) / T(2)) * z[13];
z[10] = z[4] * z[10];
z[11] = z[8] * z[17];
z[11] = 1 + z[11];
z[12] = z[6] + -z[9];
z[13] = z[7] * z[12];
z[13] = 1 + z[13];
z[11] = z[8] * z[11] * z[13];
z[12] = z[5] + z[12];
z[10] = z[10] + z[11] + (T(1) / T(2)) * z[12];
return z[2] * z[3] * z[4] * z[10];
}



template double eval_coef_2q3y_2l_pmmpp_12345_81(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_81(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
