#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_82(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[22];
z[0] = iW[0];
z[1] = iW[3];
z[2] = iW[15];
z[3] = v[1];
z[4] = v[2];
z[5] = v[4];
z[6] = v[3];
z[7] = iW[1];
z[8] = iW[4];
z[9] = v[0];
z[10] = (T(1) / T(2)) * z[8];
z[11] = prod_pow(z[7], 2);
z[12] = z[4] * z[11];
z[13] = -z[7] + -z[12];
z[13] = z[10] * z[13];
z[11] = z[11] + z[13];
z[11] = z[4] * z[11];
z[13] = (T(1) / T(2)) * z[7];
z[14] = z[5] * z[7];
z[15] = -1 + z[14];
z[16] = -z[13] * z[15];
z[11] = z[11] + z[16];
z[11] = z[6] * z[11];
z[16] = z[7] * z[15];
z[17] = (T(-5) / T(2)) * z[12] + 2 * z[16];
z[17] = z[9] * z[17];
z[13] = z[12] + -z[13];
z[13] = z[4] * z[13];
z[13] = T(-3) / T(2) + z[13];
z[13] = z[9] * z[13];
z[18] = z[4] * z[7];
z[19] = 1 + z[18];
z[20] = z[4] * z[19];
z[13] = z[13] + (T(9) / T(2)) * z[20];
z[13] = z[10] * z[13];
z[11] = T(-5) / T(2) + (T(3) / T(2)) * z[11] + z[13] + 2 * z[14] + z[17] + (T(-17) / T(4)) * z[18];
z[11] = z[6] * z[11];
z[12] = z[12] + (T(-7) / T(4)) * z[16];
z[12] = z[9] * z[12];
z[12] = z[12] + -4 * z[15] + (T(15) / T(4)) * z[18];
z[12] = z[9] * z[12];
z[13] = (T(1) / T(2)) * z[9];
z[14] = z[13] * z[19];
z[16] = (T(3) / T(2)) * z[3];
z[17] = T(1) / T(2) + -z[18];
z[17] = z[4] * z[17];
z[14] = z[14] + z[16] + z[17];
z[14] = z[9] * z[14];
z[17] = z[3] + z[4];
z[18] = z[4] * z[17];
z[14] = z[14] + (T(-9) / T(4)) * z[18];
z[14] = z[8] * z[14];
z[11] = (T(5) / T(2)) * z[3] + 4 * z[4] + -2 * z[5] + z[11] + z[12] + z[14];
z[11] = z[6] * z[11];
z[12] = z[3] * z[4];
z[14] = -z[3] * z[5];
z[18] = -z[4] + z[5];
z[18] = z[6] * z[18];
z[14] = (T(3) / T(2)) * z[12] + z[14] + (T(1) / T(2)) * z[18];
z[14] = z[6] * z[14];
z[18] = prod_pow(z[3], 2);
z[19] = prod_pow(z[3], 3) * z[1];
z[19] = -3 * z[18] + z[19];
z[19] = z[4] * z[19];
z[20] = z[5] * z[18];
z[19] = z[19] + z[20];
z[14] = z[14] + (T(1) / T(2)) * z[19];
z[14] = z[0] * z[14];
z[19] = z[1] * z[18];
z[19] = -z[3] + (T(-1) / T(2)) * z[19];
z[20] = z[3] + -z[5];
z[19] = z[19] * z[20];
z[14] = (T(-5) / T(2)) * z[12] + z[14] + z[19];
z[19] = -z[1] + z[7];
z[19] = z[9] * z[19];
z[19] = 5 + z[19];
z[15] = z[15] * z[19];
z[19] = z[1] * z[20];
z[21] = -z[1] + -z[7];
z[21] = z[4] * z[21];
z[15] = z[15] + (T(3) / T(2)) * z[19] + z[21];
z[13] = z[13] * z[15];
z[15] = (T(1) / T(2)) * z[4];
z[16] = -z[1] * z[16];
z[16] = -1 + z[16];
z[15] = z[15] * z[16];
z[13] = z[13] + z[15] + -2 * z[20];
z[13] = z[9] * z[13];
z[15] = (T(-1) / T(2)) * z[3] + z[4];
z[15] = z[4] * z[15];
z[16] = -z[9] * z[17];
z[15] = z[15] + z[16] + (T(-3) / T(2)) * z[18];
z[15] = z[9] * z[15];
z[12] = z[12] + z[18];
z[12] = z[4] * z[12];
z[12] = (T(3) / T(2)) * z[12] + z[15];
z[10] = z[10] * z[12];
z[10] = z[10] + z[11] + z[13] + (T(1) / T(2)) * z[14];
return prod_pow(z[2], 2) * z[10];
}



template double eval_coef_2q3y_2l_pmmpp_12345_82(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_82(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
