#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_86(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[34];
z[0] = iW[0];
z[1] = iW[1];
z[2] = iW[5];
z[3] = iW[12];
z[4] = iW[17];
z[5] = v[2];
z[6] = v[3];
z[7] = v[4];
z[8] = iW[3];
z[9] = v[1];
z[10] = iW[2];
z[11] = v[0];
z[12] = prod_pow(z[11], 3);
z[13] = z[10] * z[12];
z[14] = prod_pow(z[11], 2);
z[15] = (T(1) / T(2)) * z[14];
z[16] = z[0] * z[5];
z[17] = T(7) / T(2) + z[16];
z[17] = z[5] * z[17];
z[17] = (T(-19) / T(2)) * z[11] + z[17];
z[17] = z[5] * z[17];
z[17] = (T(5) / T(2)) * z[13] + z[15] + z[17];
z[18] = (T(1) / T(2)) * z[6];
z[19] = z[16] * z[18];
z[20] = z[10] * z[15];
z[21] = T(3) / T(4) + z[16];
z[21] = z[5] * z[21];
z[19] = (T(-7) / T(4)) * z[11] + z[19] + -z[20] + z[21];
z[19] = z[6] * z[19];
z[21] = z[5] + (T(-11) / T(4)) * z[11];
z[21] = z[5] * z[21];
z[21] = z[14] + z[21];
z[21] = z[5] * z[21];
z[22] = prod_pow(z[11], 4) * z[10];
z[23] = (T(3) / T(4)) * z[22];
z[21] = (T(3) / T(2)) * z[12] + z[21] + -z[23];
z[21] = z[8] * z[21];
z[17] = (T(1) / T(2)) * z[17] + z[19] + z[21];
z[17] = z[7] * z[17];
z[19] = 3 * z[5];
z[21] = 1 + (T(-1) / T(4)) * z[16];
z[21] = z[19] * z[21];
z[21] = (T(-11) / T(2)) * z[11] + z[21];
z[21] = z[5] * z[21];
z[24] = 2 * z[14];
z[25] = z[6] * z[16];
z[25] = 5 * z[5] + -9 * z[11] + z[25];
z[25] = z[6] * z[25];
z[21] = z[21] + z[24] + (T(1) / T(4)) * z[25];
z[21] = z[6] * z[21];
z[25] = (T(1) / T(2)) * z[5];
z[26] = T(7) / T(2) + -z[16];
z[26] = z[25] * z[26];
z[27] = 3 * z[11];
z[26] = z[26] + -z[27];
z[26] = z[5] * z[26];
z[24] = z[24] + z[26];
z[24] = z[5] * z[24];
z[17] = (T(-1) / T(4)) * z[12] + z[17] + z[21] + z[24];
z[17] = z[7] * z[17];
z[21] = z[5] * z[11];
z[21] = (T(-3) / T(2)) * z[14] + z[21];
z[21] = z[5] * z[21];
z[24] = (T(1) / T(2)) * z[12];
z[21] = z[21] + (T(1) / T(2)) * z[22] + -z[24];
z[21] = z[8] * z[21];
z[26] = z[5] + -z[11];
z[28] = z[10] * z[14];
z[28] = -z[6] + -3 * z[26] + z[28];
z[28] = z[18] * z[28];
z[29] = -z[5] + z[27];
z[29] = z[5] * z[29];
z[21] = -z[13] + -z[15] + z[21] + z[28] + z[29];
z[21] = z[7] * z[21];
z[28] = z[25] + z[27];
z[28] = z[5] * z[28];
z[29] = (T(5) / T(2)) * z[11];
z[30] = -z[5] + z[29];
z[31] = -z[18] + z[30];
z[31] = z[6] * z[31];
z[32] = 3 * z[14];
z[28] = z[28] + z[31] + -z[32];
z[28] = z[6] * z[28];
z[31] = (T(1) / T(2)) * z[11];
z[33] = z[5] + -z[31];
z[33] = z[5] * z[33];
z[32] = -z[32] + z[33];
z[32] = z[5] * z[32];
z[21] = z[12] + z[21] + z[28] + z[32];
z[21] = z[7] * z[21];
z[19] = z[19] * z[26];
z[26] = z[5] + z[11];
z[26] = z[6] * z[26];
z[19] = -z[14] + z[19] + z[26];
z[19] = z[18] * z[19];
z[26] = prod_pow(z[5], 2);
z[28] = -z[26] * z[30];
z[19] = z[19] + z[28];
z[19] = z[6] * z[19];
z[19] = z[19] + z[21];
z[19] = z[7] * z[19];
z[21] = z[5] * z[6];
z[21] = -z[21] + -z[26];
z[21] = prod_pow(z[6], 2) * z[11] * z[21];
z[19] = z[19] + (T(1) / T(2)) * z[21];
z[19] = z[1] * z[19];
z[21] = T(-5) / T(2) + z[16];
z[21] = z[5] * z[21];
z[26] = -z[21] + -z[29];
z[26] = z[5] * z[26];
z[28] = -1 + (T(1) / T(2)) * z[16];
z[28] = z[5] * z[28];
z[29] = -z[11] + -z[28];
z[29] = z[6] * z[29];
z[26] = z[15] + z[26] + z[29];
z[26] = z[6] * z[26];
z[29] = 3 + -z[16];
z[29] = z[5] * z[29];
z[27] = -z[27] + z[29];
z[27] = z[5] * z[27];
z[27] = z[14] + z[27];
z[27] = z[25] * z[27];
z[26] = z[26] + z[27];
z[26] = z[18] * z[26];
z[17] = z[17] + (T(1) / T(2)) * z[19] + z[26];
z[17] = z[1] * z[17];
z[19] = -1 + -z[16];
z[19] = z[18] * z[19];
z[26] = (T(-3) / T(2)) * z[5] + z[11];
z[19] = z[19] + z[20] + 3 * z[26];
z[19] = z[18] * z[19];
z[20] = T(-9) / T(2) + z[16];
z[20] = z[5] * z[20];
z[20] = (T(9) / T(2)) * z[11] + z[20];
z[20] = z[20] * z[25];
z[20] = z[14] + z[20];
z[20] = z[5] * z[20];
z[20] = (T(-9) / T(4)) * z[12] + z[20] + z[23];
z[20] = z[8] * z[20];
z[23] = -17 + 3 * z[16];
z[23] = z[5] * z[23];
z[23] = 4 * z[11] + (T(1) / T(4)) * z[23];
z[23] = z[5] * z[23];
z[19] = -z[13] + z[15] + z[19] + z[20] + z[23];
z[19] = z[7] * z[19];
z[20] = -z[28] + z[31];
z[20] = z[5] * z[20];
z[20] = (T(-5) / T(2)) * z[14] + z[20];
z[20] = z[20] * z[25];
z[12] = z[12] + z[20] + (T(-1) / T(4)) * z[22];
z[12] = z[8] * z[12];
z[20] = z[28] + z[31];
z[18] = -z[18] * z[20];
z[22] = (T(-1) / T(4)) * z[11] + -z[28];
z[22] = z[5] * z[22];
z[12] = z[12] + (T(1) / T(4)) * z[13] + -z[15] + z[18] + z[22];
z[12] = z[9] * z[12];
z[13] = (T(3) / T(2)) * z[11];
z[16] = T(-9) / T(4) + z[16];
z[16] = z[5] * z[16];
z[16] = z[13] + z[16];
z[16] = z[5] * z[16];
z[18] = z[6] * z[20];
z[14] = (T(-1) / T(4)) * z[14] + z[16] + z[18];
z[14] = z[6] * z[14];
z[13] = z[13] + z[21];
z[13] = z[5] * z[13];
z[13] = z[13] + z[15];
z[13] = z[5] * z[13];
z[13] = z[13] + -z[24];
z[12] = z[12] + (T(1) / T(2)) * z[13] + z[14] + z[17] + z[19];
return z[2] * z[3] * z[4] * z[12];
}



template double eval_coef_2q3y_2l_pmmpp_12345_86(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_86(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
