#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_88(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[35];
z[0] = iW[0];
z[1] = iW[3];
z[2] = iW[7];
z[3] = iW[18];
z[4] = iW[21];
z[5] = v[1];
z[6] = v[2];
z[7] = v[4];
z[8] = v[3];
z[9] = iW[1];
z[10] = v[0];
z[11] = 2 * z[7];
z[12] = prod_pow(z[9], 2);
z[13] = z[11] * z[12];
z[14] = (T(13) / T(16)) * z[0];
z[15] = -16 * z[9] + -z[13] + -z[14];
z[16] = (T(1) / T(3)) * z[7];
z[15] = z[15] * z[16];
z[17] = 2 * z[8];
z[18] = z[12] * z[17];
z[19] = z[7] * z[12];
z[20] = 4 * z[19];
z[18] = -7 * z[9] + z[18] + z[20];
z[21] = (T(2) / T(3)) * z[8];
z[18] = z[18] * z[21];
z[15] = T(81) / T(16) + z[15] + z[18];
z[15] = z[8] * z[15];
z[18] = z[0] * z[5];
z[22] = 13 * z[18];
z[23] = z[0] * z[7];
z[23] = T(83) / T(2) + z[22] + (T(-13) / T(2)) * z[23];
z[23] = z[7] * z[23];
z[23] = -35 * z[5] + z[23];
z[24] = -2 + (T(13) / T(16)) * z[18];
z[24] = z[16] * z[24];
z[18] = 15 + (T(-13) / T(3)) * z[18];
z[18] = z[5] * z[18];
z[18] = (T(1) / T(16)) * z[18] + z[24];
z[18] = z[7] * z[18];
z[24] = prod_pow(z[5], 2);
z[18] = z[18] + (T(-13) / T(48)) * z[24];
z[18] = z[1] * z[18];
z[25] = (T(1) / T(3)) * z[1];
z[26] = z[5] + -z[7];
z[26] = z[25] * z[26];
z[27] = (T(-1) / T(3)) * z[9] + -z[19];
z[27] = z[8] * z[27];
z[26] = z[26] + z[27];
z[27] = 2 * z[10];
z[26] = z[26] * z[27];
z[28] = 2 * z[9];
z[29] = -z[8] * z[12];
z[29] = z[28] + z[29];
z[29] = z[8] * z[29];
z[29] = -1 + z[29];
z[29] = z[6] * z[29];
z[15] = z[15] + z[18] + (T(1) / T(24)) * z[23] + z[26] + (T(2) / T(3)) * z[29];
z[15] = z[6] * z[15];
z[18] = 4 * z[9];
z[23] = -z[18] + (T(301) / T(48)) * z[19];
z[23] = z[7] * z[23];
z[18] = z[18] + (T(173) / T(16)) * z[19];
z[26] = (T(1) / T(3)) * z[8];
z[18] = z[18] * z[26];
z[18] = T(-17) / T(8) + z[18] + z[23];
z[18] = z[8] * z[18];
z[20] = (T(-19) / T(16)) * z[9] + -z[20];
z[20] = z[7] * z[20];
z[20] = T(29) / T(4) + z[20];
z[20] = z[16] * z[20];
z[23] = z[7] * z[9];
z[29] = T(199) / T(16) + -4 * z[23];
z[29] = z[7] * z[29];
z[29] = (T(-103) / T(8)) * z[5] + z[29];
z[29] = z[7] * z[29];
z[29] = (T(71) / T(16)) * z[24] + z[29];
z[25] = z[25] * z[29];
z[29] = (T(2) / T(3)) * z[9] + -z[19];
z[29] = z[7] * z[29];
z[30] = 2 + -z[23];
z[30] = z[7] * z[30];
z[30] = -z[5] + z[30];
z[30] = z[1] * z[30];
z[29] = T(1) / T(3) + z[29] + (T(2) / T(3)) * z[30];
z[29] = z[27] * z[29];
z[18] = (T(-11) / T(16)) * z[5] + z[18] + z[20] + z[25] + z[29];
z[18] = z[10] * z[18];
z[20] = (T(-7) / T(16)) * z[19] + z[28];
z[20] = z[7] * z[20];
z[25] = -z[12] * z[26];
z[29] = -z[9] + z[19];
z[25] = z[25] + -2 * z[29];
z[25] = z[17] * z[25];
z[20] = -8 + 7 * z[20] + z[25];
z[20] = z[8] * z[20];
z[14] = 20 * z[9] + z[14] + (T(109) / T(16)) * z[19];
z[14] = z[14] * z[16];
z[14] = T(-243) / T(16) + z[14];
z[14] = z[7] * z[14];
z[14] = (T(20) / T(3)) * z[5] + z[14] + z[20];
z[14] = z[8] * z[14];
z[20] = z[0] + z[9];
z[20] = z[7] * z[20];
z[20] = -95 + 13 * z[20] + -z[22];
z[22] = (T(1) / T(2)) * z[7];
z[20] = z[20] * z[22];
z[20] = 89 * z[5] + z[20];
z[20] = z[7] * z[20];
z[25] = -z[5] + z[22];
z[25] = z[7] * z[25];
z[25] = (T(1) / T(2)) * z[24] + z[25];
z[30] = z[1] * z[7];
z[25] = z[25] * z[30];
z[31] = 2 * z[24];
z[14] = z[14] + z[15] + z[18] + (T(1) / T(24)) * z[20] + (T(71) / T(24)) * z[25] + -z[31];
z[14] = z[6] * z[14];
z[15] = (T(1) / T(8)) * z[7];
z[18] = (T(79) / T(2)) * z[9] + (T(-173) / T(3)) * z[19];
z[18] = z[15] * z[18];
z[20] = -z[9] + -z[13];
z[20] = z[20] * z[21];
z[18] = T(10) / T(3) + z[18] + z[20];
z[18] = z[8] * z[18];
z[20] = (T(589) / T(16)) * z[9] + -14 * z[19];
z[20] = z[16] * z[20];
z[20] = T(-47) / T(16) + z[20];
z[20] = z[7] * z[20];
z[18] = (T(-14) / T(3)) * z[5] + z[18] + z[20];
z[18] = z[8] * z[18];
z[20] = (T(199) / T(16)) * z[9] + -z[13];
z[20] = z[16] * z[20];
z[20] = T(-135) / T(16) + z[20];
z[20] = z[7] * z[20];
z[20] = (T(341) / T(48)) * z[5] + z[20];
z[20] = z[7] * z[20];
z[25] = z[12] * z[16];
z[32] = -z[9] + z[25];
z[33] = z[7] * z[32];
z[33] = 1 + z[33];
z[33] = z[7] * z[33];
z[33] = (T(-1) / T(3)) * z[5] + z[33];
z[27] = -z[27] * z[33];
z[20] = z[20] + (T(-103) / T(48)) * z[24] + z[27];
z[20] = z[1] * z[20];
z[27] = (T(-109) / T(2)) * z[9] + 77 * z[19];
z[27] = z[16] * z[27];
z[27] = T(-15) / T(2) + z[27];
z[27] = z[8] * z[27];
z[34] = -6 * z[9] + (T(109) / T(24)) * z[19];
z[34] = z[7] * z[34];
z[34] = T(-13) / T(8) + z[34];
z[34] = z[7] * z[34];
z[20] = (T(37) / T(12)) * z[5] + z[20] + (T(1) / T(8)) * z[27] + z[34];
z[20] = z[10] * z[20];
z[27] = (T(-15) / T(2)) * z[9] + (T(77) / T(3)) * z[19];
z[27] = z[22] * z[27];
z[27] = -23 + z[27];
z[27] = z[7] * z[27];
z[27] = (T(71) / T(12)) * z[5] + z[27];
z[34] = (T(1) / T(4)) * z[7];
z[27] = z[27] * z[34];
z[34] = z[9] * z[16];
z[34] = -1 + z[34];
z[34] = z[7] * z[34];
z[34] = z[5] + z[34];
z[34] = z[7] * z[34];
z[34] = (T(-1) / T(3)) * z[24] + z[34];
z[34] = z[30] * z[34];
z[18] = z[18] + z[20] + z[27] + z[31] + (T(103) / T(16)) * z[34];
z[18] = z[10] * z[18];
z[20] = z[19] + -z[28];
z[20] = z[7] * z[20];
z[20] = T(2) / T(3) + z[20];
z[13] = -z[9] + z[13];
z[13] = z[13] * z[26];
z[13] = z[13] + 2 * z[20];
z[13] = z[13] * z[17];
z[20] = (T(-11) / T(2)) * z[9] + z[25];
z[20] = z[7] * z[20];
z[20] = T(52) / T(3) + (T(19) / T(8)) * z[20];
z[20] = z[7] * z[20];
z[13] = -4 * z[5] + z[13] + z[20];
z[13] = z[8] * z[13];
z[20] = -17 * z[9] + (T(-61) / T(3)) * z[19];
z[20] = z[15] * z[20];
z[20] = 18 + z[20];
z[20] = z[7] * z[20];
z[20] = -16 * z[5] + z[20];
z[20] = z[7] * z[20];
z[13] = z[13] + z[20] + (T(8) / T(3)) * z[24];
z[13] = z[8] * z[13];
z[20] = 109 + (T(-13) / T(2)) * z[23];
z[20] = z[16] * z[20];
z[20] = (T(-143) / T(2)) * z[5] + z[20];
z[20] = z[15] * z[20];
z[20] = z[20] + (T(16) / T(3)) * z[24];
z[20] = z[7] * z[20];
z[23] = prod_pow(z[5], 3);
z[25] = (T(2) / T(3)) * z[23];
z[13] = z[13] + z[14] + z[18] + z[20] + -z[25];
z[13] = z[6] * z[13];
z[14] = -z[9] + (T(1) / T(4)) * z[19];
z[14] = z[7] * z[14];
z[14] = T(3) / T(2) + z[14];
z[14] = z[7] * z[14];
z[14] = -z[5] + z[14];
z[14] = z[7] * z[14];
z[14] = z[14] + (T(1) / T(4)) * z[24];
z[18] = z[14] * z[30];
z[14] = z[1] * z[14];
z[20] = -3 * z[9] + z[19];
z[20] = z[7] * z[20];
z[20] = 3 + z[20];
z[20] = z[7] * z[20];
z[20] = -z[5] + z[20];
z[14] = z[14] + (T(1) / T(4)) * z[20];
z[14] = z[10] * z[14];
z[14] = z[14] + z[18];
z[12] = -z[12] * z[22];
z[12] = z[9] + z[12];
z[12] = z[7] * z[12];
z[12] = T(-1) / T(2) + z[12];
z[12] = z[7] * z[12];
z[18] = z[11] * z[29];
z[20] = -z[8] * z[18];
z[12] = (T(77) / T(4)) * z[12] + z[20];
z[12] = z[12] * z[26];
z[20] = z[7] * z[33];
z[12] = z[12] + (T(15) / T(4)) * z[14] + (T(-77) / T(16)) * z[20];
z[12] = z[10] * z[12];
z[14] = (T(1) / T(48)) * z[7];
z[20] = -365 * z[9] + 173 * z[19];
z[20] = z[14] * z[20];
z[20] = 2 + z[20];
z[20] = z[7] * z[20];
z[18] = -1 + z[18];
z[18] = z[18] * z[21];
z[18] = 2 * z[5] + z[18] + z[20];
z[18] = z[8] * z[18];
z[20] = -115 * z[9] + (T(19) / T(2)) * z[19];
z[20] = z[7] * z[20];
z[20] = T(307) / T(2) + z[20];
z[20] = prod_pow(z[7], 2) * z[20];
z[18] = z[18] + (T(1) / T(24)) * z[20] + -z[31];
z[18] = z[8] * z[18];
z[20] = (T(103) / T(3)) * z[9] + -15 * z[19];
z[20] = z[7] * z[20];
z[20] = T(-55) / T(3) + z[20];
z[20] = z[7] * z[20];
z[20] = -z[5] + z[20];
z[20] = z[15] * z[20];
z[20] = z[20] + (T(-2) / T(3)) * z[24];
z[20] = z[7] * z[20];
z[12] = z[12] + z[18] + z[20] + z[25];
z[12] = z[10] * z[12];
z[11] = -z[11] * z[32];
z[11] = T(-5) / T(3) + z[11];
z[11] = z[7] * z[11];
z[18] = -z[8] * z[16] * z[29];
z[11] = z[11] + z[18];
z[11] = z[11] * z[17];
z[17] = 179 * z[9] + 13 * z[19];
z[14] = z[14] * z[17];
z[14] = -10 + z[14];
z[14] = z[7] * z[14];
z[14] = 6 * z[5] + z[14];
z[14] = z[7] * z[14];
z[11] = z[11] + z[14];
z[11] = z[8] * z[11];
z[14] = (T(-13) / T(3)) * z[9] + (T(15) / T(2)) * z[19];
z[14] = z[7] * z[14];
z[14] = T(-307) / T(6) + z[14];
z[14] = z[14] * z[15];
z[14] = (T(32) / T(3)) * z[5] + z[14];
z[14] = z[7] * z[14];
z[14] = z[14] + (T(-14) / T(3)) * z[24];
z[14] = z[7] * z[14];
z[11] = z[11] + z[14];
z[11] = z[8] * z[11];
z[14] = z[5] + -z[16];
z[14] = z[7] * z[14];
z[14] = z[14] + -z[24];
z[14] = z[7] * z[14];
z[14] = z[14] + (T(1) / T(3)) * z[23];
z[15] = 4 * z[7];
z[14] = z[14] * z[15];
z[11] = z[11] + z[12] + z[13] + z[14];
return prod_pow(z[4], 2) * z[2] * z[3] * z[11];
}



template double eval_coef_2q3y_2l_pmmpp_12345_88(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_88(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
