#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_93(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[22];
z[0] = iW[1];
z[1] = iW[3];
z[2] = iW[21];
z[3] = v[0];
z[4] = v[2];
z[5] = iW[7];
z[6] = iW[18];
z[7] = v[3];
z[8] = v[4];
z[9] = iW[17];
z[10] = v[1];
z[11] = -z[5] + z[6];
z[12] = z[6] * z[7];
z[13] = z[5] * z[12];
z[14] = z[5] * z[6] * z[10];
z[14] = -z[11] + -3 * z[13] + z[14];
z[15] = (T(1) / T(2)) * z[4];
z[14] = z[14] * z[15];
z[16] = z[11] + (T(3) / T(2)) * z[13];
z[16] = z[7] * z[16];
z[17] = z[5] * z[8];
z[18] = -1 + z[17];
z[18] = (T(1) / T(2)) * z[18];
z[16] = z[16] + z[18];
z[16] = z[4] * z[16];
z[11] = z[9] + -z[11] + -z[13];
z[11] = z[7] * z[11];
z[11] = z[11] + -z[17];
z[13] = (T(1) / T(2)) * z[7];
z[11] = z[11] * z[13];
z[17] = z[7] + z[15];
z[17] = z[9] * z[17];
z[17] = T(-1) / T(2) + z[17];
z[17] = z[4] * z[17];
z[11] = z[11] + z[17];
z[11] = z[4] * z[11];
z[17] = prod_pow(z[8], 2) * z[18];
z[11] = z[11] + z[17];
z[11] = z[0] * z[11];
z[17] = -z[8] * z[18];
z[11] = z[11] + z[16] + z[17];
z[11] = z[0] * z[11];
z[11] = z[11] + z[14];
z[14] = prod_pow(z[2], 2);
z[16] = z[1] * z[4] * z[14];
z[17] = z[1] * z[2];
z[18] = prod_pow(z[6], 2);
z[19] = z[14] + -z[16] + (T(-5) / T(4)) * z[17] + (T(259) / T(72)) * z[18];
z[19] = z[4] * z[19];
z[18] = (T(259) / T(36)) * z[18];
z[20] = -z[14] + z[18];
z[13] = z[13] * z[20];
z[13] = z[2] + z[13];
z[21] = (T(277) / T(36)) * z[6] + -z[13];
z[21] = z[7] * z[21];
z[18] = -z[14] + -z[18];
z[18] = z[7] * z[18];
z[18] = z[2] + (T(259) / T(36)) * z[6] + z[18];
z[18] = z[15] * z[18];
z[18] = T(-259) / T(72) + z[18] + z[21];
z[18] = z[0] * z[18];
z[20] = z[7] * z[20];
z[21] = 3 * z[2] + (T(-337) / T(18)) * z[6];
z[20] = (T(13) / T(6)) * z[1] + z[20] + (T(1) / T(2)) * z[21];
z[18] = z[18] + z[19] + (T(1) / T(2)) * z[20];
z[18] = z[0] * z[18];
z[15] = -z[1] * z[15];
z[15] = 1 + z[15];
z[14] = z[14] * z[15];
z[14] = z[14] + -z[17];
z[14] = z[4] * z[14];
z[13] = (T(241) / T(72)) * z[1] + (T(-67) / T(9)) * z[6] + z[13] + z[14];
z[13] = prod_pow(z[0], 2) * z[3] * z[13];
z[13] = z[13] + z[18];
z[13] = z[3] * z[13];
z[14] = -z[16] + (T(-1) / T(2)) * z[17];
z[14] = z[4] * z[14];
z[15] = z[4] * z[6];
z[12] = -1 + -z[12];
z[12] = z[4] * z[12];
z[12] = z[8] + z[12];
z[12] = z[0] * z[12];
z[12] = -1 + z[12] + z[15];
z[12] = z[0] * z[12];
z[12] = (T(-13) / T(12)) * z[1] + (T(1) / T(2)) * z[12] + z[14];
z[12] = (T(1) / T(2)) * z[12] + z[13];
z[12] = z[3] * z[12];
return (T(1) / T(2)) * z[11] + z[12];
}



template double eval_coef_2q3y_2l_pmmpp_12345_93(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_93(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
