#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_94(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[30];
z[0] = iW[0];
z[1] = iW[1];
z[2] = v[2];
z[3] = v[3];
z[4] = v[4];
z[5] = iW[15];
z[6] = iW[3];
z[7] = v[1];
z[8] = v[0];
z[9] = iW[23];
z[10] = z[1] + -z[6];
z[10] = z[0] * z[10];
z[11] = z[1] * z[6];
z[10] = z[10] + -z[11];
z[10] = z[5] * z[10];
z[11] = (T(1) / T(2)) * z[1];
z[12] = -z[1] + (T(-15) / T(2)) * z[6];
z[12] = z[11] * z[12];
z[13] = prod_pow(z[6], 2);
z[14] = (T(13) / T(3)) * z[13];
z[12] = z[12] + -z[14];
z[12] = z[1] * z[12];
z[15] = z[1] * z[3];
z[16] = T(-25) / T(2) + 3 * z[15];
z[17] = prod_pow(z[1], 2);
z[16] = z[16] * z[17];
z[18] = (T(19) / T(3)) * z[13];
z[19] = z[16] + z[18];
z[20] = (T(1) / T(2)) * z[0];
z[19] = z[19] * z[20];
z[12] = (T(5) / T(3)) * z[10] + z[12] + z[19];
z[19] = (T(1) / T(2)) * z[2];
z[12] = z[12] * z[19];
z[21] = -z[3] + (T(1) / T(2)) * z[8];
z[21] = z[11] * z[21];
z[22] = z[6] * z[8];
z[23] = (T(4) / T(3)) * z[22];
z[24] = z[3] * z[9];
z[21] = T(16) / T(3) + z[21] + -z[23] + (T(-1) / T(2)) * z[24];
z[21] = z[1] * z[21];
z[25] = z[8] * z[13];
z[26] = (T(-31) / T(2)) * z[6] + 13 * z[25];
z[21] = z[21] + (T(1) / T(6)) * z[26];
z[21] = z[1] * z[21];
z[26] = (T(5) / T(3)) * z[6];
z[27] = -3 * z[1] + -z[26];
z[27] = z[20] * z[27];
z[12] = z[12] + -z[18] + z[21] + z[27];
z[12] = z[2] * z[12];
z[21] = z[1] + 9 * z[6] + (T(-13) / T(6)) * z[25];
z[21] = z[1] * z[21];
z[18] = z[18] + z[21];
z[18] = z[1] * z[18];
z[16] = -z[16] * z[20];
z[16] = (T(-13) / T(12)) * z[10] + z[16] + z[18];
z[16] = z[16] * z[19];
z[18] = (T(19) / T(3)) * z[25];
z[20] = -z[1] + (T(-21) / T(2)) * z[6] + -z[9] + z[18];
z[20] = z[17] * z[20];
z[21] = T(-25) / T(6) + z[15];
z[17] = z[17] * z[21];
z[21] = z[0] * z[17];
z[20] = z[20] + z[21];
z[20] = z[4] * z[20];
z[21] = (T(1) / T(4)) * z[1];
z[27] = z[3] + -z[8];
z[27] = z[21] * z[27];
z[28] = -8 + (T(13) / T(4)) * z[22];
z[27] = z[27] + (T(1) / T(3)) * z[28];
z[27] = z[1] * z[27];
z[28] = (T(119) / T(6)) * z[6] + z[9] + -19 * z[25];
z[27] = (T(3) / T(4)) * z[0] + z[27] + (T(1) / T(4)) * z[28];
z[27] = z[1] * z[27];
z[16] = z[16] + (T(1) / T(4)) * z[20] + z[27];
z[16] = z[4] * z[16];
z[20] = 7 + (T(-13) / T(2)) * z[22];
z[27] = z[8] * z[11];
z[20] = (T(1) / T(3)) * z[20] + z[27];
z[20] = z[1] * z[20];
z[27] = (T(7) / T(24)) * z[0];
z[28] = (T(-49) / T(12)) * z[6] + -z[9] + (T(19) / T(2)) * z[25];
z[29] = 1 + -z[15];
z[29] = z[5] * z[29];
z[12] = z[12] + z[16] + z[20] + z[27] + (T(1) / T(2)) * z[28] + (T(1) / T(4)) * z[29];
z[12] = z[4] * z[12];
z[16] = -z[14] + -z[17];
z[16] = z[0] * z[16];
z[10] = (T(-7) / T(6)) * z[10] + z[16];
z[10] = z[10] * z[19];
z[15] = T(-35) / T(3) + z[15];
z[15] = z[1] * z[15];
z[15] = (T(-13) / T(2)) * z[6] + z[15];
z[15] = z[11] * z[15];
z[16] = prod_pow(z[3], 2);
z[17] = z[11] * z[16];
z[20] = -z[9] * z[17];
z[20] = z[20] + z[24];
z[20] = z[1] * z[20];
z[28] = (T(1) / T(2)) * z[9];
z[20] = z[20] + -z[28];
z[20] = z[5] * z[20];
z[26] = (T(3) / T(2)) * z[1] + z[26];
z[26] = z[0] * z[26];
z[10] = z[10] + z[14] + z[15] + z[20] + z[26];
z[10] = z[10] * z[19];
z[14] = z[3] + z[8];
z[15] = -z[14] * z[21];
z[15] = T(-7) / T(3) + z[15] + z[23] + (T(-3) / T(4)) * z[24];
z[15] = z[1] * z[15];
z[19] = 3 * z[9];
z[20] = (T(-23) / T(3)) * z[6] + z[19] + (T(-13) / T(3)) * z[25];
z[21] = T(3) / T(2) + -z[24];
z[21] = z[3] * z[21];
z[17] = -z[17] + z[21];
z[11] = z[11] * z[17];
z[11] = T(-1) / T(2) + z[11] + z[24];
z[11] = z[5] * z[11];
z[10] = z[10] + z[11] + z[15] + (T(1) / T(4)) * z[20] + -z[27];
z[10] = z[2] * z[10];
z[11] = 3 + -z[24];
z[11] = z[3] * z[11];
z[15] = -z[1] * z[16];
z[11] = z[11] + z[15];
z[11] = z[5] * z[11];
z[14] = -z[1] * z[14];
z[11] = T(7) / T(3) + z[11] + z[14] + (T(13) / T(3)) * z[22] + -3 * z[24];
z[14] = z[0] * z[6];
z[14] = 19 * z[13] + (T(7) / T(4)) * z[14];
z[15] = -z[5] * z[9];
z[13] = z[0] * z[2] * z[13];
z[13] = (T(-19) / T(6)) * z[13] + (T(1) / T(3)) * z[14] + z[15];
z[13] = z[2] * z[13];
z[14] = -z[7] * z[28];
z[14] = -1 + z[14] + z[24];
z[14] = z[5] * z[14];
z[15] = (T(-7) / T(6)) * z[6] + -z[18] + z[19];
z[13] = z[13] + z[14] + (T(1) / T(2)) * z[15];
z[13] = z[7] * z[13];
return z[10] + (T(1) / T(4)) * z[11] + z[12] + (T(1) / T(2)) * z[13];
}



template double eval_coef_2q3y_2l_pmmpp_12345_94(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_94(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
