#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_95(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[37];
z[0] = iW[1];
z[1] = iW[2];
z[2] = iW[22];
z[3] = iW[23];
z[4] = v[0];
z[5] = v[3];
z[6] = v[4];
z[7] = iW[3];
z[8] = v[2];
z[9] = iW[4];
z[10] = v[1];
z[11] = 259 * z[5];
z[12] = prod_pow(z[9], 2);
z[11] = z[11] * z[12];
z[13] = (T(289) / T(2)) * z[9] + -z[11];
z[13] = z[5] * z[13];
z[13] = T(99) / T(2) + (T(1) / T(9)) * z[13];
z[14] = 31 * z[9] + z[11];
z[14] = -373 * z[7] + 7 * z[14];
z[15] = z[4] * z[12];
z[14] = (T(1) / T(3)) * z[14] + -259 * z[15];
z[14] = z[4] * z[14];
z[16] = z[6] * z[7];
z[13] = (T(1) / T(2)) * z[13] + (T(1) / T(24)) * z[14] + (T(4) / T(3)) * z[16];
z[14] = prod_pow(z[4], 2);
z[13] = z[13] * z[14];
z[17] = (T(-277) / T(2)) * z[7] + (T(241) / T(2)) * z[9] + z[11];
z[17] = z[4] * z[17];
z[18] = z[5] * z[12];
z[19] = (T(-1) / T(2)) * z[9] + -z[18];
z[19] = z[5] * z[19];
z[17] = T(277) / T(4) + (T(277) / T(12)) * z[16] + (T(1) / T(6)) * z[17] + (T(259) / T(3)) * z[19];
z[17] = z[4] * z[17];
z[19] = (T(277) / T(2)) * z[9] + z[11];
z[20] = (T(1) / T(2)) * z[5];
z[19] = z[19] * z[20];
z[19] = -277 + z[19];
z[21] = (T(1) / T(3)) * z[5];
z[19] = z[19] * z[21];
z[17] = (T(-259) / T(4)) * z[6] + z[17] + z[19];
z[19] = z[0] * z[14];
z[17] = z[17] * z[19];
z[13] = z[13] + (T(1) / T(6)) * z[17];
z[13] = z[0] * z[13];
z[17] = z[7] * z[10];
z[22] = -1 + -z[16] + z[17];
z[23] = (T(95) / T(2)) * z[9];
z[24] = (T(13) / T(6)) * z[7] + (T(-259) / T(9)) * z[18] + z[23];
z[25] = (T(-259) / T(6)) * z[15] + -z[24];
z[25] = z[4] * z[25];
z[22] = (T(19) / T(6)) * z[22] + z[25];
z[25] = (T(1) / T(4)) * z[4];
z[22] = z[22] * z[25];
z[26] = (T(259) / T(8)) * z[15];
z[27] = 67 * z[9];
z[28] = (T(-259) / T(4)) * z[18] + z[26] + -z[27];
z[28] = z[14] * z[28];
z[29] = (T(259) / T(8)) * z[5];
z[29] = z[12] * z[29];
z[30] = z[27] + z[29];
z[30] = z[5] * z[30];
z[31] = -z[9] + -z[18];
z[31] = z[4] * z[31];
z[30] = T(259) / T(8) + z[30] + (T(259) / T(8)) * z[31];
z[30] = z[19] * z[30];
z[28] = z[28] + z[30];
z[28] = z[0] * z[28];
z[12] = z[12] * z[14];
z[12] = (T(259) / T(8)) * z[12] + z[28];
z[12] = z[8] * z[12];
z[12] = (T(1) / T(9)) * z[12] + z[13] + z[22];
z[12] = z[8] * z[12];
z[13] = T(-19) / T(2) + 5 * z[16];
z[22] = (T(1) / T(3)) * z[10];
z[13] = z[13] * z[22];
z[22] = prod_pow(z[6], 2);
z[28] = z[7] * z[22];
z[30] = (T(-19) / T(3)) * z[5] + -3 * z[6];
z[30] = -z[13] + (T(5) / T(3)) * z[28] + (T(1) / T(2)) * z[30];
z[31] = 149 * z[9] + -z[29];
z[31] = z[21] * z[31];
z[32] = T(329) / T(8) + (T(25) / T(2)) * z[16] + (T(-19) / T(4)) * z[17] + -z[31];
z[33] = (T(259) / T(12)) * z[15] + z[24];
z[33] = z[4] * z[33];
z[32] = (T(1) / T(3)) * z[32] + (T(1) / T(2)) * z[33];
z[32] = z[4] * z[32];
z[30] = (T(1) / T(2)) * z[30] + z[32];
z[30] = z[4] * z[30];
z[32] = -1451 * z[9] + (T(1813) / T(2)) * z[18];
z[32] = z[5] * z[32];
z[32] = T(-2269) / T(2) + z[32];
z[32] = 76 * z[16] + (T(1) / T(4)) * z[32];
z[33] = (T(373) / T(4)) * z[7] + (T(587) / T(4)) * z[9] + -z[11];
z[26] = z[26] + (T(1) / T(3)) * z[33];
z[26] = z[4] * z[26];
z[26] = z[26] + (T(1) / T(3)) * z[32];
z[32] = (T(1) / T(3)) * z[4];
z[26] = z[26] * z[32];
z[33] = 24 * z[9] + (T(-259) / T(36)) * z[18];
z[33] = z[5] * z[33];
z[33] = T(373) / T(36) + z[33];
z[33] = z[5] * z[33];
z[26] = -25 * z[6] + z[26] + (T(-41) / T(12)) * z[28] + z[33];
z[26] = z[14] * z[26];
z[33] = (T(1367) / T(3)) * z[9] + -z[11];
z[33] = z[21] * z[33];
z[33] = 275 + z[33];
z[33] = z[5] * z[33];
z[33] = (T(-313) / T(9)) * z[6] + z[33];
z[11] = 295 * z[9] + -z[11];
z[11] = 277 * z[7] + (T(1) / T(2)) * z[11];
z[11] = z[11] * z[32];
z[34] = (T(-563) / T(3)) * z[9] + (T(259) / T(2)) * z[18];
z[34] = z[5] * z[34];
z[11] = T(-1903) / T(6) + z[11] + z[34];
z[11] = z[11] * z[32];
z[11] = z[11] + (T(-277) / T(9)) * z[28] + (T(1) / T(2)) * z[33];
z[11] = z[11] * z[25];
z[27] = -z[27] + z[29];
z[27] = z[5] * z[27];
z[27] = T(-563) / T(4) + z[27];
z[27] = z[5] * z[27];
z[27] = (T(277) / T(4)) * z[6] + z[27];
z[21] = z[21] * z[27];
z[21] = z[21] + (T(247) / T(8)) * z[22];
z[11] = z[11] + (T(1) / T(3)) * z[21];
z[11] = z[11] * z[19];
z[11] = z[11] + z[26];
z[11] = z[0] * z[11];
z[11] = z[11] + z[12] + z[30];
z[11] = z[8] * z[11];
z[12] = (T(259) / T(18)) * z[15];
z[15] = z[1] + (T(-373) / T(18)) * z[7] + -z[12] + (T(259) / T(6)) * z[18] + -z[23];
z[15] = z[15] * z[25];
z[21] = z[1] * z[6];
z[23] = (T(-3) / T(2)) * z[1] + (T(581) / T(9)) * z[9] + (T(-259) / T(12)) * z[18];
z[23] = z[5] * z[23];
z[23] = T(469) / T(36) + z[21] + z[23];
z[15] = z[15] + (T(-88) / T(9)) * z[16] + (T(1) / T(2)) * z[23];
z[15] = z[4] * z[15];
z[23] = 3 * z[1];
z[18] = (T(-2083) / T(18)) * z[9] + (T(259) / T(18)) * z[18] + z[23];
z[26] = (T(1) / T(4)) * z[5];
z[18] = z[18] * z[26];
z[18] = T(64) / T(9) + z[18] + -z[21];
z[18] = z[5] * z[18];
z[27] = T(1817) / T(18) + z[21];
z[27] = z[6] * z[27];
z[15] = z[15] + z[18] + (T(1) / T(4)) * z[27] + (T(-73) / T(72)) * z[28];
z[15] = z[4] * z[15];
z[18] = -z[1] + (T(307) / T(9)) * z[9];
z[18] = z[18] * z[26];
z[26] = (T(1) / T(2)) * z[21];
z[18] = T(-76) / T(9) + z[18] + z[26];
z[18] = z[5] * z[18];
z[27] = (T(1) / T(4)) * z[21];
z[29] = T(-109) / T(9) + -z[27];
z[29] = z[6] * z[29];
z[18] = z[18] + z[29];
z[18] = z[5] * z[18];
z[29] = prod_pow(z[6], 3);
z[30] = z[7] * z[29];
z[15] = z[15] + z[18] + (T(89) / T(18)) * z[22] + (T(13) / T(12)) * z[30];
z[14] = z[14] * z[15];
z[15] = -z[1] + (T(277) / T(18)) * z[9];
z[18] = (T(-277) / T(18)) * z[7] + -z[15];
z[18] = z[18] * z[25];
z[32] = z[5] * z[15];
z[33] = T(265) / T(6) + z[21];
z[18] = (T(-277) / T(72)) * z[16] + z[18] + z[32] + (T(1) / T(4)) * z[33];
z[18] = z[4] * z[18];
z[33] = (T(1) / T(2)) * z[6];
z[34] = T(581) / T(9) + -z[21];
z[34] = z[33] * z[34];
z[35] = 3 * z[21];
z[36] = T(-241) / T(6) + -z[35];
z[23] = (T(-277) / T(6)) * z[9] + z[23];
z[23] = z[5] * z[23];
z[23] = z[23] + (T(1) / T(2)) * z[36];
z[23] = z[5] * z[23];
z[23] = z[23] + (T(313) / T(36)) * z[28] + z[34];
z[18] = z[18] + (T(1) / T(2)) * z[23];
z[18] = z[4] * z[18];
z[23] = T(-1493) / T(36) + z[21];
z[23] = z[23] * z[33];
z[33] = T(169) / T(18) + z[35];
z[32] = z[32] + (T(1) / T(4)) * z[33];
z[32] = z[5] * z[32];
z[23] = z[23] + z[32];
z[23] = z[5] * z[23];
z[21] = T(-313) / T(18) + -z[21];
z[21] = z[21] * z[22];
z[18] = z[18] + (T(1) / T(4)) * z[21] + z[23] + (T(241) / T(72)) * z[30];
z[18] = z[4] * z[18];
z[15] = -z[15] * z[20];
z[15] = 1 + z[15] + -z[26];
z[15] = z[15] * z[20];
z[20] = T(76) / T(9) + -z[27];
z[20] = z[6] * z[20];
z[15] = z[15] + z[20];
z[15] = z[5] * z[15];
z[20] = z[1] * z[29];
z[15] = z[15] + (T(1) / T(4)) * z[20];
z[15] = z[5] * z[15];
z[15] = z[15] + z[18] + (T(-223) / T(72)) * z[29];
z[15] = z[15] * z[19];
z[14] = z[14] + z[15];
z[14] = z[0] * z[14];
z[15] = T(-155) / T(4) + z[31];
z[12] = -z[12] + -z[24];
z[12] = z[12] * z[25];
z[12] = z[12] + (T(1) / T(3)) * z[15] + (T(-27) / T(8)) * z[16] + (T(19) / T(24)) * z[17];
z[12] = z[4] * z[12];
z[15] = z[5] * z[9];
z[15] = 803 + -337 * z[15];
z[15] = z[5] * z[15];
z[15] = -43 * z[6] + z[15];
z[15] = (T(1) / T(9)) * z[15] + -11 * z[28];
z[13] = z[13] + (T(1) / T(4)) * z[15];
z[12] = z[12] + (T(1) / T(2)) * z[13];
z[12] = z[4] * z[12];
z[13] = -19 * z[5] + z[6];
z[13] = z[5] * z[13];
z[13] = z[13] + 7 * z[22] + -13 * z[30];
z[15] = (T(19) / T(4)) * z[5] + -5 * z[6] + (T(13) / T(4)) * z[28];
z[15] = z[10] * z[15];
z[13] = (T(1) / T(4)) * z[13] + z[15];
z[12] = z[12] + (T(1) / T(6)) * z[13];
z[12] = z[4] * z[12];
z[11] = z[11] + z[12] + z[14];
return prod_pow(z[2], 2) * z[3] * z[11];
}



template double eval_coef_2q3y_2l_pmmpp_12345_95(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_95(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
