#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_96(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[35];
z[0] = iW[0];
z[1] = iW[1];
z[2] = v[2];
z[3] = v[3];
z[4] = v[4];
z[5] = iW[15];
z[6] = iW[3];
z[7] = v[0];
z[8] = iW[7];
z[9] = v[1];
z[10] = z[1] + -z[6];
z[10] = z[0] * z[10];
z[11] = z[1] * z[6];
z[10] = z[10] + -z[11];
z[10] = z[5] * z[10];
z[11] = z[1] * z[3];
z[12] = T(-25) / T(6) + z[11];
z[13] = prod_pow(z[1], 2);
z[14] = z[12] * z[13];
z[15] = prod_pow(z[6], 2);
z[16] = (T(13) / T(3)) * z[15];
z[14] = z[14] + z[16];
z[14] = z[0] * z[14];
z[14] = (T(7) / T(6)) * z[10] + z[14];
z[14] = z[2] * z[14];
z[17] = T(11) / T(3) + (T(-1) / T(2)) * z[11];
z[17] = z[1] * z[17];
z[17] = (T(-11) / T(12)) * z[6] + z[17];
z[17] = z[1] * z[17];
z[17] = (T(-13) / T(2)) * z[15] + z[17];
z[18] = prod_pow(z[3], 2);
z[19] = (T(1) / T(2)) * z[1];
z[20] = z[18] * z[19];
z[21] = -z[8] * z[20];
z[22] = z[3] * z[8];
z[21] = z[21] + z[22];
z[21] = z[1] * z[21];
z[21] = (T(-1) / T(2)) * z[8] + z[21];
z[23] = (T(1) / T(2)) * z[5];
z[21] = z[21] * z[23];
z[24] = 3 * z[11];
z[25] = T(-29) / T(3) + z[24];
z[25] = z[1] * z[25];
z[25] = (T(5) / T(3)) * z[6] + (T(1) / T(4)) * z[25];
z[25] = z[0] * z[25];
z[14] = (T(1) / T(4)) * z[14] + (T(1) / T(2)) * z[17] + z[21] + z[25];
z[14] = z[2] * z[14];
z[17] = z[6] * z[7];
z[21] = T(23) / T(3) + (T(43) / T(6)) * z[17] + z[22];
z[25] = 3 * z[3];
z[26] = (T(-19) / T(12)) * z[7] + -z[25];
z[26] = z[1] * z[26];
z[21] = (T(1) / T(2)) * z[21] + z[26];
z[21] = z[19] * z[21];
z[18] = z[1] * z[18];
z[18] = z[18] + -z[25];
z[18] = z[18] * z[19];
z[18] = 1 + z[18];
z[18] = z[18] * z[23];
z[25] = z[7] * z[15];
z[26] = (T(13) / T(4)) * z[25];
z[27] = -1 + z[11];
z[28] = z[0] * z[27];
z[14] = (T(-10) / T(3)) * z[6] + (T(-1) / T(4)) * z[8] + z[14] + z[18] + z[21] + z[26] + z[28];
z[14] = z[2] * z[14];
z[18] = (T(19) / T(3)) * z[15];
z[21] = -z[1] + -9 * z[6] + (T(13) / T(6)) * z[25];
z[21] = z[1] * z[21];
z[21] = -z[18] + z[21];
z[21] = z[1] * z[21];
z[28] = T(-25) / T(2) + z[24];
z[29] = z[0] * z[13];
z[30] = z[28] * z[29];
z[21] = (T(13) / T(12)) * z[10] + z[21] + (T(1) / T(2)) * z[30];
z[21] = z[2] * z[21];
z[30] = (T(1) / T(3)) * z[7];
z[31] = 13 * z[25];
z[32] = 23 * z[6] + -z[31];
z[32] = z[30] * z[32];
z[33] = -z[3] + z[7];
z[33] = z[1] * z[33];
z[32] = T(37) / T(3) + z[22] + z[32] + z[33];
z[32] = z[19] * z[32];
z[33] = -z[8] + (T(19) / T(3)) * z[25];
z[32] = (T(-133) / T(12)) * z[6] + z[32] + z[33];
z[32] = z[1] * z[32];
z[34] = z[1] + (T(21) / T(2)) * z[6] + -z[33];
z[34] = z[13] * z[34];
z[12] = -z[12] * z[29];
z[12] = z[12] + z[34];
z[29] = (T(1) / T(2)) * z[4];
z[12] = z[12] * z[29];
z[24] = T(-35) / T(3) + z[24];
z[24] = z[0] * z[19] * z[24];
z[12] = z[12] + z[21] + z[24] + z[32];
z[12] = z[12] * z[29];
z[21] = z[1] + (T(15) / T(2)) * z[6];
z[21] = z[19] * z[21];
z[16] = z[16] + z[21];
z[16] = z[1] * z[16];
z[13] = -z[13] * z[28];
z[13] = z[13] + -z[18];
z[13] = z[0] * z[13];
z[10] = (T(-5) / T(3)) * z[10] + (T(1) / T(2)) * z[13] + z[16];
z[10] = z[2] * z[10];
z[13] = z[3] + (T(-1) / T(2)) * z[7];
z[13] = z[1] * z[13];
z[13] = T(-31) / T(3) + z[13] + (T(-35) / T(6)) * z[17] + -z[22];
z[13] = z[13] * z[19];
z[13] = (T(11) / T(4)) * z[6] + z[13] + (T(-13) / T(3)) * z[25];
z[13] = z[1] * z[13];
z[16] = T(16) / T(3) + (T(-3) / T(2)) * z[11];
z[16] = z[1] * z[16];
z[16] = (T(-35) / T(12)) * z[6] + z[16];
z[16] = z[0] * z[16];
z[10] = (T(1) / T(2)) * z[10] + z[13] + (T(19) / T(6)) * z[15] + z[16];
z[10] = z[2] * z[10];
z[13] = (T(-43) / T(2)) * z[6] + z[31];
z[13] = z[13] * z[30];
z[15] = 7 + 25 * z[17];
z[15] = z[7] * z[15];
z[15] = 7 * z[3] + (T(1) / T(6)) * z[15];
z[15] = z[15] * z[19];
z[13] = T(-31) / T(3) + z[13] + z[15] + (T(-1) / T(2)) * z[22];
z[13] = z[1] * z[13];
z[15] = (T(35) / T(3)) * z[6] + -z[33];
z[13] = z[13] + (T(1) / T(2)) * z[15];
z[15] = (T(1) / T(4)) * z[5];
z[16] = z[15] * z[27];
z[11] = -z[0] * z[11];
z[10] = z[10] + z[11] + z[12] + (T(1) / T(2)) * z[13] + z[16];
z[10] = z[4] * z[10];
z[11] = 5 * z[6] + -z[26];
z[11] = z[11] * z[30];
z[12] = 1 + (T(-25) / T(12)) * z[17];
z[12] = z[7] * z[12];
z[12] = (T(-7) / T(2)) * z[3] + z[12];
z[12] = z[12] * z[19];
z[13] = -z[3] + z[20];
z[13] = z[13] * z[23];
z[15] = z[9] * z[15];
return 1 + z[10] + z[11] + z[12] + z[13] + z[14] + z[15];
}



template double eval_coef_2q3y_2l_pmmpp_12345_96(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_96(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
