#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_98(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[31];
z[0] = iW[1];
z[1] = iW[4];
z[2] = v[2];
z[3] = v[3];
z[4] = iW[15];
z[5] = v[0];
z[6] = iW[18];
z[7] = iW[23];
z[8] = v[4];
z[9] = prod_pow(z[0], 2);
z[10] = z[2] * z[9];
z[11] = z[3] * z[9];
z[12] = 13 * z[11];
z[13] = (T(-17) / T(2)) * z[0] + z[12];
z[13] = (T(-5) / T(2)) * z[10] + (T(1) / T(3)) * z[13];
z[13] = z[2] * z[13];
z[14] = (T(1) / T(2)) * z[4];
z[15] = z[10] * z[14];
z[16] = z[0] * z[4];
z[15] = z[15] + z[16];
z[17] = z[2] * z[15];
z[17] = z[14] + z[17];
z[17] = z[5] * z[17];
z[13] = T(7) / T(6) + z[13] + 5 * z[17];
z[13] = z[5] * z[13];
z[17] = (T(1) / T(2)) * z[3];
z[17] = z[9] * z[17];
z[18] = -z[0] + z[17];
z[18] = z[3] * z[18];
z[18] = T(1) / T(2) + z[18];
z[19] = prod_pow(z[2], 2) * z[18];
z[20] = (T(1) / T(2)) * z[5];
z[21] = z[0] * z[3];
z[21] = -1 + z[21];
z[21] = z[2] * z[21];
z[21] = z[20] + z[21];
z[21] = z[5] * z[21];
z[19] = z[19] + z[21];
z[19] = z[1] * z[19];
z[21] = -z[0] + z[11];
z[22] = (T(1) / T(3)) * z[2];
z[23] = -z[21] * z[22];
z[24] = (T(13) / T(3)) * z[11];
z[25] = (T(11) / T(2)) * z[0] + -z[24];
z[25] = z[3] * z[25];
z[23] = T(-7) / T(6) + z[23] + z[25];
z[23] = z[2] * z[23];
z[13] = z[13] + (T(13) / T(3)) * z[19] + z[23];
z[13] = z[1] * z[13];
z[19] = (T(1) / T(6)) * z[2];
z[19] = z[19] * z[21];
z[23] = (T(1) / T(3)) * z[3];
z[25] = z[9] * z[23];
z[26] = (T(1) / T(2)) * z[0];
z[25] = z[25] + -z[26];
z[25] = z[3] * z[25];
z[19] = T(1) / T(6) + z[19] + z[25];
z[19] = z[2] * z[19];
z[18] = z[18] * z[23];
z[18] = z[18] + z[19];
z[19] = z[2] * z[4];
z[23] = 1 + (T(-5) / T(2)) * z[19];
z[23] = z[9] * z[23];
z[25] = (T(1) / T(2)) * z[2];
z[27] = z[9] * z[25];
z[28] = prod_pow(z[4], 2);
z[29] = z[27] * z[28];
z[30] = -z[4] * z[9];
z[29] = z[29] + z[30];
z[29] = z[5] * z[29];
z[30] = (T(1) / T(2)) * z[16];
z[23] = z[23] + z[29] + -z[30];
z[23] = z[2] * z[23];
z[23] = z[23] + -z[24];
z[23] = z[20] * z[23];
z[24] = z[11] + -z[26];
z[10] = z[10] + (T(29) / T(6)) * z[24];
z[10] = z[2] * z[10];
z[26] = z[3] * z[21];
z[10] = z[10] + z[23] + (T(23) / T(6)) * z[26];
z[10] = z[5] * z[10];
z[10] = z[10] + (T(-17) / T(2)) * z[18];
z[10] = z[6] * z[10];
z[12] = -z[0] + z[12];
z[12] = z[3] * z[12];
z[10] = -2 + z[10] + (T(1) / T(12)) * z[12] + z[13];
z[12] = z[15] * z[22];
z[13] = z[0] + z[14];
z[14] = z[5] * z[9];
z[12] = z[12] + (T(1) / T(3)) * z[13] + (T(1) / T(6)) * z[14] + -z[17];
z[12] = z[5] * z[12];
z[13] = (T(-2) / T(3)) * z[0] + z[17];
z[13] = z[3] * z[13];
z[14] = z[21] + -z[27];
z[14] = z[14] * z[22];
z[12] = T(1) / T(3) + z[12] + z[13] + z[14];
z[12] = z[5] * z[12];
z[12] = z[12] + -z[18];
z[12] = z[7] * z[12];
z[13] = z[9] + z[16];
z[13] = z[13] * z[19];
z[14] = (T(1) / T(2)) * z[28];
z[13] = (T(11) / T(3)) * z[9] + z[13] + z[14];
z[15] = (T(1) / T(3)) * z[5];
z[13] = z[13] * z[15];
z[16] = (T(-1) / T(3)) * z[9] + -z[30];
z[16] = z[2] * z[16];
z[11] = 5 * z[0] + -19 * z[11];
z[11] = (T(1) / T(9)) * z[11] + z[13] + z[16];
z[11] = z[11] * z[20];
z[9] = -z[9] + z[14];
z[9] = z[9] * z[15];
z[9] = z[9] + z[17];
z[9] = z[8] * z[9];
z[13] = -z[24] * z[25];
return (T(1) / T(2)) * z[9] + (T(1) / T(3)) * z[10] + z[11] + 5 * z[12] + z[13];
}



template double eval_coef_2q3y_2l_pmmpp_12345_98(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_98(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
