#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_nf_12345_26(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[20];
z[0] = iW[1];
z[1] = iW[3];
z[2] = iW[15];
z[3] = iW[23];
z[4] = v[0];
z[5] = v[4];
z[6] = iW[4];
z[7] = v[2];
z[8] = v[3];
z[9] = v[1];
z[10] = (T(1) / T(2)) * z[5];
z[11] = z[6] * z[8];
z[12] = 1 + (T(19) / T(6)) * z[11];
z[12] = z[8] * z[12];
z[12] = z[10] + z[12];
z[12] = z[0] * z[12];
z[13] = (T(19) / T(3)) * z[11];
z[14] = z[1] * z[5];
z[12] = z[12] + -z[13] + (T(1) / T(2)) * z[14];
z[12] = z[0] * z[12];
z[15] = -z[1] + (T(19) / T(3)) * z[6];
z[13] = -1 + -z[13];
z[13] = z[0] * z[13];
z[13] = z[13] + z[15];
z[16] = z[0] * z[4];
z[13] = z[13] * z[16];
z[17] = -z[1] + (T(19) / T(6)) * z[6];
z[12] = z[12] + (T(1) / T(2)) * z[13] + z[17];
z[12] = z[4] * z[12];
z[13] = (T(1) / T(2)) * z[1];
z[18] = z[5] + -z[9];
z[13] = z[13] * z[18];
z[18] = (T(1) / T(2)) * z[0];
z[19] = -z[5] + -z[8];
z[18] = z[18] * z[19];
z[12] = 1 + z[12] + z[13] + z[18];
z[12] = z[7] * z[12];
z[11] = -47 + 19 * z[11];
z[11] = (T(1) / T(9)) * z[11] + -z[14];
z[13] = prod_pow(z[5], 2);
z[18] = z[1] * z[13];
z[10] = (T(19) / T(9)) * z[8] + z[10] + (T(1) / T(6)) * z[18];
z[10] = z[0] * z[10];
z[10] = z[10] + (T(1) / T(2)) * z[11];
z[10] = z[0] * z[10];
z[11] = T(-19) / T(3) + -z[14];
z[11] = z[0] * z[11];
z[11] = z[11] + -z[15];
z[11] = z[11] * z[16];
z[10] = z[10] + (T(1) / T(6)) * z[11] + (T(-1) / T(3)) * z[17];
z[10] = z[4] * z[10];
z[11] = -z[5] + (T(-19) / T(6)) * z[8];
z[11] = z[8] * z[11];
z[11] = z[11] + (T(-1) / T(2)) * z[13];
z[11] = z[0] * z[11];
z[14] = 5 * z[5] + (T(47) / T(3)) * z[8] + z[18];
z[11] = z[11] + (T(1) / T(2)) * z[14];
z[11] = z[0] * z[11];
z[14] = -z[5] + (T(1) / T(2)) * z[9];
z[14] = z[1] * z[14];
z[11] = T(-31) / T(6) + z[11] + z[14];
z[10] = z[10] + (T(1) / T(3)) * z[11];
z[10] = z[4] * z[10];
z[11] = z[5] * z[8];
z[11] = z[11] + z[13];
z[11] = z[0] * z[11];
z[11] = -z[5] + z[11];
z[10] = z[10] + (T(1) / T(6)) * z[11] + (T(1) / T(3)) * z[12];
return z[2] * z[3] * z[4] * z[10];
}



template double eval_coef_2q3y_2l_pmmpp_nf_12345_26(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_nf_12345_26(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
