#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_nf_12345_34(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[17];
z[0] = iW[0];
z[1] = iW[1];
z[2] = v[2];
z[3] = v[4];
z[4] = iW[3];
z[5] = v[1];
z[6] = v[0];
z[7] = z[2] * z[3];
z[8] = prod_pow(z[3], 2);
z[9] = z[7] + -z[8];
z[9] = z[1] * z[9];
z[10] = 2 * z[3];
z[11] = -z[5] + z[9] + z[10];
z[12] = z[0] * z[2];
z[13] = z[0] * z[3];
z[14] = -2 + z[12] + -z[13];
z[15] = z[0] * z[5];
z[15] = z[14] + z[15];
z[15] = z[2] * z[15];
z[11] = 2 * z[11] + z[15];
z[11] = z[2] * z[11];
z[15] = prod_pow(z[3], 3);
z[16] = z[2] * z[8];
z[16] = -z[15] + z[16];
z[16] = z[1] * z[16];
z[7] = (T(-2) / T(3)) * z[7] + z[8] + (T(1) / T(3)) * z[16];
z[7] = z[1] * z[7];
z[16] = z[2] + z[5];
z[7] = -z[3] + z[7] + (T(1) / T(3)) * z[16];
z[7] = z[6] * z[7];
z[7] = z[7] + (T(1) / T(3)) * z[11];
z[7] = z[4] * z[7];
z[11] = (T(1) / T(2)) * z[0];
z[16] = -z[5] * z[11];
z[14] = -z[14] + z[16];
z[14] = z[2] * z[14];
z[9] = -z[2] + z[9] + z[10];
z[9] = z[1] * z[9];
z[9] = -1 + z[9];
z[9] = z[6] * z[9];
z[10] = z[3] + z[5];
z[9] = z[9] + (T(1) / T(2)) * z[10] + z[14];
z[10] = (T(1) / T(6)) * z[12];
z[12] = T(1) / T(2) + -z[10] + (T(1) / T(3)) * z[13];
z[12] = z[2] * z[12];
z[13] = (T(1) / T(2)) * z[13];
z[14] = 1 + -z[13];
z[14] = z[3] * z[14];
z[12] = z[12] + (T(1) / T(3)) * z[14];
z[12] = z[2] * z[12];
z[14] = (T(1) / T(2)) * z[3];
z[14] = z[2] * z[14];
z[14] = -z[8] + z[14];
z[14] = z[2] * z[14];
z[14] = z[14] + (T(1) / T(2)) * z[15];
z[14] = z[1] * z[14];
z[12] = (T(-5) / T(6)) * z[8] + z[12] + z[14];
z[12] = z[1] * z[12];
z[7] = z[7] + (T(1) / T(3)) * z[9] + z[12];
z[7] = z[4] * z[7];
z[9] = 2 + z[13];
z[8] = z[8] * z[9];
z[9] = T(2) / T(3) + -z[10] + z[13];
z[9] = z[2] * z[9];
z[10] = T(-4) / T(3) + -z[13];
z[10] = z[3] * z[10];
z[9] = z[9] + z[10];
z[9] = z[2] * z[9];
z[8] = (T(1) / T(3)) * z[8] + z[9];
z[8] = z[1] * z[8];
z[9] = z[2] + -z[3];
z[8] = z[8] + (T(1) / T(3)) * z[9];
z[8] = z[1] * z[8];
z[9] = z[2] * z[11];
z[9] = -1 + z[9] + -z[13];
return z[7] + z[8] + (T(1) / T(3)) * z[9];
}



template double eval_coef_2q3y_2l_pmmpp_nf_12345_34(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_nf_12345_34(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
