#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_nf_12345_36(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[21];
z[0] = iW[0];
z[1] = iW[3];
z[2] = v[1];
z[3] = v[2];
z[4] = v[4];
z[5] = iW[1];
z[6] = v[0];
z[7] = (T(1) / T(2)) * z[4];
z[8] = -z[0] + -z[5];
z[8] = z[7] * z[8];
z[9] = z[0] * z[2];
z[10] = z[0] * z[3];
z[8] = -1 + z[8] + -z[9] + (T(1) / T(2)) * z[10];
z[11] = (T(1) / T(2)) * z[3];
z[8] = z[8] * z[11];
z[12] = (T(1) / T(2)) * z[5];
z[13] = prod_pow(z[5], 2);
z[14] = -z[4] * z[13];
z[14] = z[12] + z[14];
z[14] = z[4] * z[14];
z[14] = T(1) / T(2) + z[14];
z[15] = (T(1) / T(2)) * z[6];
z[14] = z[14] * z[15];
z[16] = z[4] * z[5];
z[16] = -5 + z[16];
z[16] = z[4] * z[16];
z[8] = z[2] + z[8] + z[14] + (T(1) / T(4)) * z[16];
z[14] = (T(1) / T(3)) * z[3];
z[8] = z[8] * z[14];
z[16] = (T(1) / T(3)) * z[4];
z[16] = z[13] * z[16];
z[17] = -z[5] + z[16];
z[17] = z[4] * z[17];
z[17] = 1 + z[17];
z[17] = z[4] * z[17];
z[18] = (T(1) / T(3)) * z[2];
z[17] = z[17] + -z[18];
z[19] = (T(1) / T(2)) * z[17];
z[20] = -prod_pow(z[6], 2) * z[19];
z[18] = -z[10] * z[18];
z[18] = z[2] + -z[4] + z[18];
z[11] = z[11] * z[18];
z[18] = -z[5] * z[7];
z[18] = 1 + z[18];
z[18] = z[4] * z[18];
z[18] = (T(-1) / T(2)) * z[2] + z[18];
z[18] = z[6] * z[18];
z[11] = z[11] + z[18];
z[11] = z[3] * z[11];
z[11] = z[11] + z[20];
z[11] = z[1] * z[11];
z[15] = z[15] * z[17];
z[8] = z[8] + (T(1) / T(2)) * z[11] + z[15];
z[8] = z[1] * z[8];
z[11] = (T(-1) / T(3)) * z[0] + -z[12] + z[16];
z[11] = z[4] * z[11];
z[7] = -z[7] * z[13];
z[7] = z[0] + z[7];
z[7] = z[7] * z[14];
z[7] = T(-1) / T(3) + z[7] + (T(-1) / T(6)) * z[9] + z[11];
z[7] = z[3] * z[7];
z[7] = z[7] + -z[19];
z[7] = (T(1) / T(2)) * z[7] + z[8];
z[7] = z[1] * z[7];
z[8] = z[0] * z[4];
z[8] = -z[8] + z[10];
z[8] = 5 + (T(11) / T(4)) * z[8];
z[7] = 11 * z[7] + (T(1) / T(3)) * z[8];
return (T(1) / T(3)) * z[7];
}



template double eval_coef_2q3y_2l_pmmpp_nf_12345_36(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_nf_12345_36(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
