#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_nf_12345_37(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[29];
z[0] = iW[1];
z[1] = iW[3];
z[2] = iW[7];
z[3] = iW[18];
z[4] = iW[21];
z[5] = v[0];
z[6] = v[2];
z[7] = v[4];
z[8] = v[3];
z[9] = v[1];
z[10] = (T(5) / T(3)) * z[0];
z[11] = prod_pow(z[0], 2);
z[12] = z[7] * z[11];
z[13] = z[10] + -3 * z[12];
z[14] = (T(1) / T(4)) * z[7];
z[13] = z[13] * z[14];
z[15] = (T(1) / T(2)) * z[7];
z[16] = z[11] * z[15];
z[17] = 2 * z[0];
z[18] = z[16] + -z[17];
z[18] = z[7] * z[18];
z[18] = T(5) / T(2) + z[18];
z[18] = z[7] * z[18];
z[18] = -z[9] + z[18];
z[19] = (T(1) / T(3)) * z[1];
z[18] = z[18] * z[19];
z[19] = (T(1) / T(2)) * z[1];
z[20] = z[0] * z[7];
z[21] = -1 + z[20];
z[21] = z[19] * z[21];
z[21] = z[12] + z[21];
z[22] = (T(1) / T(3)) * z[6];
z[21] = z[21] * z[22];
z[13] = T(1) / T(3) + z[13] + z[18] + z[21];
z[13] = z[6] * z[13];
z[18] = -z[0] + z[16];
z[18] = z[7] * z[18];
z[18] = T(1) / T(2) + z[18];
z[21] = 3 * z[0];
z[23] = -z[12] + z[21];
z[23] = z[7] * z[23];
z[23] = -3 + z[23];
z[23] = z[7] * z[23];
z[23] = z[9] + z[23];
z[24] = z[19] * z[23];
z[24] = -z[18] + z[24];
z[25] = z[1] * z[18] * z[22];
z[24] = (T(1) / T(2)) * z[24] + z[25];
z[24] = z[5] * z[24];
z[25] = (T(1) / T(3)) * z[7];
z[18] = z[18] * z[25];
z[23] = z[1] * z[14] * z[23];
z[26] = -z[0] + z[12];
z[27] = z[7] * z[26];
z[28] = -z[6] * z[12];
z[27] = z[27] + z[28];
z[28] = z[8] * z[12];
z[27] = (T(7) / T(2)) * z[27] + z[28];
z[28] = (T(1) / T(6)) * z[8];
z[27] = z[27] * z[28];
z[13] = z[13] + z[18] + z[23] + z[24] + z[27];
z[13] = z[5] * z[13];
z[18] = z[16] + z[17];
z[18] = z[7] * z[18];
z[18] = T(-7) / T(4) + z[18];
z[23] = z[0] * z[25];
z[23] = T(-1) / T(2) + z[23];
z[23] = z[7] * z[23];
z[23] = (T(1) / T(6)) * z[9] + z[23];
z[19] = z[19] * z[23];
z[23] = z[0] * z[6];
z[18] = (T(1) / T(3)) * z[18] + z[19] + (T(-1) / T(6)) * z[23];
z[18] = z[6] * z[18];
z[19] = (T(-5) / T(3)) * z[12] + -z[21];
z[19] = z[14] * z[19];
z[19] = T(5) / T(3) + z[19];
z[19] = z[7] * z[19];
z[20] = 2 + -z[20];
z[20] = z[7] * z[20];
z[20] = -z[9] + z[20];
z[20] = z[1] * z[20] * z[25];
z[18] = (T(-1) / T(2)) * z[9] + z[18] + z[19] + z[20];
z[18] = z[6] * z[18];
z[19] = -z[11] * z[25];
z[19] = z[0] + z[19];
z[19] = z[7] * z[19];
z[20] = z[6] * z[11];
z[21] = (T(-5) / T(2)) * z[0] + 2 * z[12] + -z[20];
z[21] = z[21] * z[22];
z[20] = z[20] + -z[26];
z[20] = z[20] * z[28];
z[19] = T(-1) / T(2) + z[19] + z[20] + z[21];
z[19] = z[8] * z[19];
z[20] = z[11] * z[22];
z[10] = z[10] + -z[12] + z[20];
z[10] = z[6] * z[10];
z[11] = z[11] * z[14];
z[11] = z[11] + -z[17];
z[11] = z[7] * z[11];
z[10] = T(7) / T(6) + (T(1) / T(2)) * z[10] + z[11];
z[10] = z[6] * z[10];
z[11] = 11 * z[0] + z[12];
z[11] = z[7] * z[11];
z[11] = -3 + (T(1) / T(6)) * z[11];
z[11] = z[7] * z[11];
z[11] = z[9] + z[11];
z[10] = z[10] + (T(1) / T(2)) * z[11] + z[19];
z[10] = z[8] * z[10];
z[11] = (T(-1) / T(3)) * z[0] + z[16];
z[11] = z[7] * z[11];
z[11] = T(-7) / T(6) + z[11];
z[11] = z[11] * z[15];
z[11] = (T(2) / T(3)) * z[9] + z[11];
z[11] = z[7] * z[11];
z[12] = prod_pow(z[9], 2);
z[10] = z[10] + z[11] + (T(-1) / T(6)) * z[12] + z[13] + z[18];
z[10] = z[5] * z[10];
z[11] = -z[7] + z[9];
z[11] = z[1] * z[11];
z[11] = -1 + z[11];
z[11] = prod_pow(z[6], 2) * z[7] * z[11];
z[10] = z[10] + (T(1) / T(12)) * z[11];
return prod_pow(z[4], 2) * z[2] * z[3] * z[5] * z[10];
}



template double eval_coef_2q3y_2l_pmmpp_nf_12345_37(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_nf_12345_37(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
