#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_nf_12345_38(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[17];
z[0] = iW[0];
z[1] = iW[3];
z[2] = v[1];
z[3] = v[2];
z[4] = v[4];
z[5] = iW[1];
z[6] = v[0];
z[7] = iW[4];
z[8] = v[3];
z[9] = -z[3] + z[6];
z[10] = -z[4] + (T(19) / T(6)) * z[9];
z[10] = z[6] * z[10];
z[11] = prod_pow(z[6], 2) * z[4] * z[5];
z[10] = z[10] + (T(-19) / T(6)) * z[11];
z[10] = z[5] * z[10];
z[11] = (T(1) / T(2)) * z[0];
z[12] = z[3] * z[11];
z[12] = T(-1) / T(2) + z[12];
z[12] = z[2] * z[12];
z[13] = (T(1) / T(2)) * z[4];
z[10] = z[9] + z[10] + z[12] + z[13];
z[10] = z[1] * z[10];
z[12] = prod_pow(z[3], 2);
z[14] = (T(1) / T(2)) * z[12];
z[15] = (T(1) / T(2)) * z[6];
z[16] = z[3] + -z[15];
z[16] = z[6] * z[16];
z[16] = -z[14] + z[16];
z[16] = z[7] * z[16];
z[9] = (T(-25) / T(2)) * z[9] + 19 * z[16];
z[9] = z[7] * z[9];
z[16] = -z[3] + z[4];
z[11] = z[11] * z[16];
z[9] = -1 + (T(1) / T(3)) * z[9] + z[10] + z[11];
z[10] = z[3] * z[6];
z[11] = -z[10] + -z[14];
z[11] = z[7] * z[11];
z[14] = -z[7] * z[14];
z[14] = z[3] + z[14];
z[14] = z[7] * z[14];
z[14] = T(-1) / T(2) + z[14];
z[14] = z[8] * z[14];
z[11] = z[3] + z[6] + z[11] + -z[13] + z[14];
z[11] = z[8] * z[11];
z[13] = -z[15] + z[16];
z[13] = z[6] * z[13];
z[11] = z[11] + z[13];
z[11] = z[5] * z[11];
z[10] = z[10] + -z[12];
z[10] = z[7] * z[10];
z[12] = (T(-25) / T(6)) * z[3] + z[4] + (T(-22) / T(3)) * z[6] + (T(-19) / T(6)) * z[10];
z[10] = (T(-7) / T(2)) * z[3] + (T(-19) / T(9)) * z[10];
z[10] = z[7] * z[10];
z[10] = T(25) / T(18) + z[10];
z[10] = z[8] * z[10];
z[10] = z[10] + (T(19) / T(9)) * z[11] + (T(1) / T(3)) * z[12];
z[10] = z[5] * z[10];
return (T(1) / T(3)) * z[9] + z[10];
}



template double eval_coef_2q3y_2l_pmmpp_nf_12345_38(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_nf_12345_38(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
