#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_nf_12345_39(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[20];
z[0] = iW[0];
z[1] = iW[3];
z[2] = iW[18];
z[3] = v[1];
z[4] = v[2];
z[5] = v[4];
z[6] = v[3];
z[7] = iW[1];
z[8] = v[0];
z[9] = prod_pow(z[7], 2) * z[6];
z[10] = (T(1) / T(2)) * z[0];
z[11] = z[7] * z[8];
z[12] = 19 * z[11];
z[13] = T(25) / T(2) + z[12];
z[13] = z[7] * z[13];
z[13] = (T(-19) / T(3)) * z[9] + z[10] + (T(1) / T(3)) * z[13];
z[13] = z[4] * z[13];
z[14] = -1 + (T(-19) / T(3)) * z[11];
z[14] = z[7] * z[14];
z[14] = (T(19) / T(6)) * z[9] + -z[10] + z[14];
z[14] = z[5] * z[14];
z[15] = z[0] + (T(25) / T(6)) * z[7];
z[15] = z[6] * z[15];
z[16] = z[0] * z[3];
z[13] = 1 + (T(41) / T(3)) * z[11] + z[13] + z[14] + -z[15] + z[16];
z[13] = z[5] * z[13];
z[12] = -13 + -z[12];
z[9] = -z[7] + z[9];
z[9] = z[4] * z[9];
z[9] = (T(19) / T(6)) * z[9] + (T(1) / T(6)) * z[12] + z[15] + -2 * z[16];
z[9] = z[4] * z[9];
z[10] = -z[6] * z[10];
z[10] = T(1) / T(2) + z[10] + z[16];
z[10] = z[6] * z[10];
z[12] = (T(1) / T(2)) * z[16];
z[14] = -1 + z[12];
z[15] = z[3] * z[14];
z[9] = (T(-25) / T(3)) * z[8] + z[9] + z[10] + z[13] + -z[15];
z[10] = (T(1) / T(3)) * z[5];
z[9] = z[9] * z[10];
z[13] = (T(19) / T(6)) * z[7];
z[17] = prod_pow(z[8], 2);
z[13] = z[13] * z[17];
z[11] = (T(19) / T(6)) * z[11] + -z[14];
z[14] = (T(1) / T(3)) * z[4];
z[11] = z[11] * z[14];
z[18] = z[8] + z[13];
z[18] = z[7] * z[18];
z[18] = T(-1) / T(2) + z[18];
z[10] = z[10] * z[18];
z[18] = (T(1) / T(2)) * z[3];
z[19] = -z[8] + z[18];
z[10] = z[10] + z[11] + -z[13] + z[19];
z[10] = z[5] * z[10];
z[11] = z[3] * z[19];
z[11] = z[11] + (T(-19) / T(6)) * z[17];
z[13] = -2 + z[16];
z[13] = z[3] * z[13];
z[13] = (T(-19) / T(3)) * z[8] + z[13];
z[13] = z[13] * z[14];
z[10] = z[10] + -z[11] + z[13];
z[10] = z[5] * z[10];
z[13] = (T(19) / T(6)) * z[8] + -z[15];
z[13] = z[4] * z[13];
z[11] = z[11] + z[13];
z[11] = z[3] * z[11];
z[10] = z[10] + (T(1) / T(3)) * z[11];
z[10] = z[1] * z[10];
z[11] = -z[3] + z[8];
z[11] = z[3] * z[11];
z[13] = z[6] * z[18];
z[11] = z[11] + z[13];
z[13] = z[0] * z[6];
z[13] = T(1) / T(3) + -z[12] + (T(1) / T(6)) * z[13];
z[13] = z[6] * z[13];
z[12] = T(-2) / T(3) + z[12];
z[12] = z[3] * z[12];
z[12] = (T(-19) / T(18)) * z[8] + z[12] + z[13];
z[12] = z[4] * z[12];
z[9] = z[9] + z[10] + (T(1) / T(3)) * z[11] + z[12];
return prod_pow(z[2], 2) * z[9];
}



template double eval_coef_2q3y_2l_pmmpp_nf_12345_39(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_nf_12345_39(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
