#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_nf_12345_47(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[36];
z[0] = iW[1];
z[1] = iW[3];
z[2] = iW[18];
z[3] = iW[21];
z[4] = iW[22];
z[5] = v[0];
z[6] = v[2];
z[7] = v[4];
z[8] = iW[4];
z[9] = v[3];
z[10] = v[1];
z[11] = z[1] * z[7];
z[12] = z[1] * z[6];
z[13] = T(-349) / T(6) + (T(-22) / T(3)) * z[11] + 2 * z[12];
z[13] = z[7] * z[13];
z[14] = T(463) / T(3) + 17 * z[12];
z[14] = z[6] * z[14];
z[14] = (T(647) / T(6)) * z[9] + z[14];
z[13] = z[13] + (T(1) / T(2)) * z[14];
z[13] = z[7] * z[13];
z[14] = prod_pow(z[9], 2);
z[15] = (T(1) / T(3)) * z[12];
z[16] = -1 + -z[15];
z[16] = z[6] * z[16];
z[16] = (T(-208) / T(3)) * z[9] + (T(19) / T(2)) * z[16];
z[16] = z[6] * z[16];
z[13] = z[13] + (T(265) / T(3)) * z[14] + z[16];
z[13] = z[7] * z[13];
z[16] = (T(1) / T(3)) * z[6];
z[17] = -19 * z[6] + (T(601) / T(4)) * z[9];
z[17] = z[16] * z[17];
z[17] = (T(-137) / T(2)) * z[14] + z[17];
z[17] = z[6] * z[17];
z[18] = (T(7) / T(3)) * z[14];
z[19] = z[6] * z[9];
z[20] = z[18] + -z[19];
z[20] = z[6] * z[20];
z[21] = prod_pow(z[9], 3);
z[20] = z[20] + -z[21];
z[20] = z[6] * z[20];
z[22] = prod_pow(z[9], 4);
z[23] = (T(1) / T(3)) * z[22];
z[20] = z[20] + -z[23];
z[20] = z[8] * z[20];
z[13] = z[13] + z[17] + (T(19) / T(2)) * z[20] + (T(221) / T(12)) * z[21];
z[17] = (T(1) / T(2)) * z[6];
z[20] = (T(1) / T(2)) * z[9];
z[24] = -z[6] + -z[20];
z[24] = z[17] * z[24];
z[18] = z[18] + z[24];
z[18] = z[6] * z[18];
z[18] = z[18] + (T(-13) / T(12)) * z[21];
z[24] = (T(25) / T(4)) * z[6] + -z[9];
z[24] = z[16] * z[24];
z[24] = (T(-7) / T(4)) * z[14] + z[24];
z[25] = -z[6] + (T(17) / T(36)) * z[7] + (T(5) / T(36)) * z[9];
z[25] = z[7] * z[25];
z[24] = (T(1) / T(3)) * z[24] + z[25];
z[24] = z[7] * z[24];
z[18] = (T(1) / T(3)) * z[18] + z[24];
z[18] = z[7] * z[18];
z[24] = -z[14] + (T(1) / T(6)) * z[19];
z[24] = z[6] * z[24];
z[24] = (T(7) / T(6)) * z[21] + z[24];
z[24] = z[6] * z[24];
z[24] = -z[23] + z[24];
z[25] = z[14] * z[17];
z[25] = -z[21] + z[25];
z[25] = z[6] * z[25];
z[25] = (T(1) / T(2)) * z[22] + z[25];
z[26] = z[6] * z[8];
z[25] = z[25] * z[26];
z[18] = z[18] + (T(1) / T(3)) * z[24] + (T(1) / T(9)) * z[25];
z[24] = 19 * z[0];
z[18] = z[18] * z[24];
z[13] = (T(1) / T(3)) * z[13] + z[18];
z[13] = z[0] * z[13];
z[18] = (T(5) / T(2)) * z[9];
z[25] = z[6] + -z[18];
z[25] = z[17] * z[25];
z[27] = (T(1) / T(3)) * z[11];
z[28] = T(11) / T(6) + z[12];
z[28] = -z[27] + (T(1) / T(2)) * z[28];
z[28] = z[7] * z[28];
z[29] = T(-5) / T(2) + -z[15];
z[29] = z[6] * z[29];
z[29] = (T(7) / T(2)) * z[9] + z[29];
z[28] = z[28] + (T(1) / T(2)) * z[29];
z[28] = z[7] * z[28];
z[25] = (T(2) / T(3)) * z[14] + z[25] + z[28];
z[25] = z[7] * z[25];
z[28] = -z[14] + (T(1) / T(2)) * z[19];
z[28] = z[6] * z[28];
z[28] = (T(1) / T(2)) * z[21] + z[28];
z[25] = z[25] + (T(1) / T(3)) * z[28];
z[24] = z[24] * z[25];
z[25] = T(-158) / T(3) + (T(89) / T(6)) * z[11] + (T(-55) / T(2)) * z[12];
z[25] = z[7] * z[25];
z[29] = T(259) / T(6) + 19 * z[12];
z[29] = z[6] * z[29];
z[29] = (T(-563) / T(6)) * z[9] + z[29];
z[25] = z[25] + (T(1) / T(2)) * z[29];
z[25] = z[7] * z[25];
z[28] = z[8] * z[28];
z[24] = z[24] + z[25] + (T(19) / T(3)) * z[28];
z[24] = z[0] * z[24];
z[25] = z[1] * z[10];
z[28] = T(599) / T(2) + -37 * z[25];
z[28] = -13 * z[11] + 53 * z[12] + (T(1) / T(3)) * z[28];
z[28] = z[7] * z[28];
z[29] = -23 + (T(25) / T(3)) * z[25];
z[29] = z[10] * z[29];
z[28] = (T(25) / T(3)) * z[9] + z[28] + z[29];
z[29] = (T(1) / T(3)) * z[10];
z[30] = z[9] + -z[29];
z[30] = z[10] * z[30];
z[30] = -z[14] + z[30];
z[31] = 2 * z[9] + -z[10] + -z[17];
z[31] = z[16] * z[31];
z[30] = (T(1) / T(2)) * z[30] + z[31];
z[31] = 19 * z[8];
z[30] = z[30] * z[31];
z[32] = -1 + z[25];
z[33] = (T(-19) / T(3)) * z[12] + (T(-17) / T(2)) * z[32];
z[33] = z[6] * z[33];
z[24] = z[24] + (T(1) / T(2)) * z[28] + z[30] + z[33];
z[28] = T(-1) / T(2) + z[15];
z[30] = (T(1) / T(4)) * z[11] + (T(-1) / T(3)) * z[28];
z[30] = z[7] * z[30];
z[33] = (T(1) / T(2)) * z[11];
z[28] = z[28] + -z[33];
z[28] = prod_pow(z[7], 2) * z[0] * z[28];
z[28] = (T(1) / T(6)) * z[28] + z[30];
z[28] = z[0] * z[28];
z[15] = z[15] + (T(1) / T(2)) * z[32];
z[15] = (T(1) / T(3)) * z[15] + -z[33];
z[15] = (T(1) / T(2)) * z[15] + z[28];
z[15] = z[5] * z[15];
z[15] = 19 * z[15] + (T(1) / T(3)) * z[24];
z[15] = z[5] * z[15];
z[24] = T(241) / T(3) + -95 * z[25];
z[11] = (T(271) / T(6)) * z[11] + -29 * z[12] + (T(1) / T(2)) * z[24];
z[11] = z[7] * z[11];
z[24] = 80 + (T(109) / T(4)) * z[25];
z[24] = z[24] * z[29];
z[24] = (T(-433) / T(4)) * z[9] + z[24];
z[28] = T(-109) / T(6) + 23 * z[25];
z[28] = (T(-15) / T(4)) * z[12] + (T(1) / T(3)) * z[28];
z[28] = z[6] * z[28];
z[11] = (T(1) / T(6)) * z[11] + (T(1) / T(3)) * z[24] + z[28];
z[11] = z[7] * z[11];
z[24] = z[9] * z[29];
z[24] = -z[14] + z[24];
z[24] = z[10] * z[24];
z[24] = z[21] + z[24];
z[28] = (T(5) / T(2)) * z[14];
z[18] = -z[10] + z[18];
z[30] = -z[10] * z[18];
z[30] = z[28] + z[30];
z[33] = (T(1) / T(9)) * z[6] + (T(2) / T(9)) * z[10] + -z[20];
z[33] = z[6] * z[33];
z[30] = (T(1) / T(9)) * z[30] + z[33];
z[30] = z[6] * z[30];
z[30] = (T(1) / T(6)) * z[24] + z[30];
z[30] = z[30] * z[31];
z[31] = (T(7) / T(6)) * z[25];
z[33] = -31 + -z[31];
z[33] = z[10] * z[33];
z[33] = (T(173) / T(2)) * z[9] + z[33];
z[33] = z[10] * z[33];
z[33] = (T(-157) / T(2)) * z[14] + z[33];
z[34] = T(-92) / T(3) + (T(19) / T(6)) * z[12] + (T(11) / T(4)) * z[25];
z[34] = z[16] * z[34];
z[35] = T(-25) / T(9) + (T(-7) / T(2)) * z[25];
z[35] = z[10] * z[35];
z[34] = (T(205) / T(9)) * z[9] + z[34] + z[35];
z[34] = z[6] * z[34];
z[11] = z[11] + z[13] + z[15] + z[30] + (T(1) / T(6)) * z[33] + z[34];
z[11] = z[5] * z[11];
z[13] = (T(1) / T(3)) * z[7];
z[15] = -z[9] * z[13];
z[15] = (T(-1) / T(3)) * z[14] + z[15] + z[19];
z[15] = z[7] * z[15];
z[30] = 35 * z[14] + -43 * z[19];
z[30] = z[16] * z[30];
z[15] = 13 * z[15] + z[21] + z[30];
z[15] = z[7] * z[15];
z[30] = -11 * z[14] + 7 * z[19];
z[30] = z[6] * z[30];
z[30] = (T(-1) / T(3)) * z[21] + z[30];
z[30] = z[6] * z[30];
z[15] = z[15] + (T(5) / T(3)) * z[22] + z[30];
z[15] = z[7] * z[15];
z[30] = (T(13) / T(4)) * z[14] + -z[19];
z[30] = z[6] * z[30];
z[30] = -z[21] + z[30];
z[30] = z[6] * z[30];
z[30] = (T(-7) / T(4)) * z[22] + z[30];
z[30] = z[6] * z[30];
z[33] = prod_pow(z[9], 5);
z[30] = z[30] + (T(1) / T(2)) * z[33];
z[34] = -z[6] * z[14];
z[34] = z[21] + z[34];
z[34] = z[6] * z[34];
z[34] = z[22] + z[34];
z[34] = z[6] * z[34];
z[33] = -z[33] + z[34];
z[33] = z[26] * z[33];
z[15] = (T(1) / T(4)) * z[15] + (T(1) / T(3)) * z[30] + (T(1) / T(6)) * z[33];
z[15] = z[0] * z[15];
z[30] = (T(37) / T(9)) * z[6] + -15 * z[9];
z[30] = z[6] * z[30];
z[33] = -127 * z[6] + 211 * z[9];
z[33] = 151 * z[7] + (T(5) / T(2)) * z[33];
z[33] = z[7] * z[33];
z[30] = (T(89) / T(9)) * z[14] + 4 * z[30] + (T(1) / T(18)) * z[33];
z[30] = z[7] * z[30];
z[33] = (T(-335) / T(9)) * z[6] + 179 * z[9];
z[33] = z[6] * z[33];
z[33] = (T(-251) / T(3)) * z[14] + z[33];
z[33] = z[6] * z[33];
z[33] = -37 * z[21] + z[33];
z[30] = z[30] + (T(1) / T(4)) * z[33];
z[30] = z[7] * z[30];
z[33] = (T(19) / T(3)) * z[6] + (T(-97) / T(2)) * z[9];
z[33] = z[6] * z[33];
z[33] = (T(253) / T(6)) * z[14] + z[33];
z[33] = z[6] * z[33];
z[33] = (T(79) / T(3)) * z[21] + z[33];
z[33] = z[6] * z[33];
z[33] = (T(-41) / T(3)) * z[22] + z[33];
z[34] = 2 * z[14];
z[19] = z[19] + -z[34];
z[19] = z[6] * z[19];
z[19] = z[19] + -z[21];
z[19] = z[6] * z[19];
z[19] = z[19] + 2 * z[22];
z[19] = z[19] * z[26];
z[15] = (T(19) / T(3)) * z[15] + (T(19) / T(9)) * z[19] + z[30] + (T(1) / T(3)) * z[33];
z[15] = z[0] * z[15];
z[19] = T(-283) / T(12) + (T(-17) / T(6)) * z[12] + z[25] + -z[27];
z[19] = z[7] * z[19];
z[22] = 301 + (T(109) / T(2)) * z[25];
z[22] = (T(7) / T(2)) * z[12] + (T(1) / T(9)) * z[22];
z[22] = z[6] * z[22];
z[27] = T(403) / T(18) + -z[25];
z[27] = z[10] * z[27];
z[19] = (T(-595) / T(18)) * z[9] + z[19] + z[22] + z[27];
z[19] = z[7] * z[19];
z[22] = T(-91) / T(4) + z[25];
z[22] = z[22] * z[29];
z[22] = 9 * z[9] + z[22];
z[22] = z[10] * z[22];
z[12] = T(-113) / T(2) + -z[12] + -19 * z[25];
z[12] = z[6] * z[12];
z[27] = -131 + (T(-65) / T(3)) * z[25];
z[27] = z[10] * z[27];
z[27] = (T(857) / T(3)) * z[9] + z[27];
z[12] = z[12] + (T(1) / T(2)) * z[27];
z[12] = z[12] * z[16];
z[12] = z[12] + (T(175) / T(36)) * z[14] + z[19] + z[22];
z[12] = z[7] * z[12];
z[19] = (T(1) / T(2)) * z[10];
z[22] = T(31) / T(2) + z[25];
z[22] = z[10] * z[22];
z[22] = -23 * z[9] + (T(7) / T(9)) * z[22];
z[22] = z[19] * z[22];
z[27] = 31 + 17 * z[25];
z[27] = z[10] * z[27];
z[27] = (T(-359) / T(3)) * z[9] + z[27];
z[30] = T(323) / T(12) + z[25];
z[30] = z[6] * z[30];
z[27] = (T(1) / T(2)) * z[27] + z[30];
z[27] = z[16] * z[27];
z[22] = z[22] + z[27];
z[22] = z[6] * z[22];
z[27] = -z[9] * z[19];
z[27] = z[27] + z[34];
z[27] = z[27] * z[29];
z[17] = -z[17] + z[18];
z[17] = z[6] * z[17];
z[18] = z[9] + -z[19];
z[18] = z[10] * z[18];
z[17] = z[17] + z[18];
z[17] = z[16] * z[17];
z[17] = z[17] + -z[21] + z[27];
z[17] = z[17] * z[26];
z[18] = 29 * z[9] + 7 * z[10];
z[18] = z[18] * z[29];
z[18] = -41 * z[14] + z[18];
z[18] = z[18] * z[19];
z[18] = z[18] + 25 * z[21];
z[11] = z[11] + z[12] + z[15] + (T(19) / T(3)) * z[17] + (T(1) / T(3)) * z[18] + z[22];
z[11] = z[5] * z[11];
z[12] = -1 + -z[31];
z[12] = z[12] * z[16];
z[15] = T(-5) / T(2) + (T(2) / T(3)) * z[25];
z[15] = z[10] * z[15];
z[12] = (T(10) / T(9)) * z[9] + z[12] + z[15];
z[12] = z[6] * z[12];
z[15] = T(13) / T(6) + -z[25];
z[15] = z[15] * z[16];
z[13] = (T(43) / T(36)) * z[9] + -z[10] + z[13] + z[15];
z[13] = z[7] * z[13];
z[15] = (T(-31) / T(12)) * z[9] + z[10];
z[15] = z[10] * z[15];
z[12] = z[12] + z[13] + (T(19) / T(12)) * z[14] + z[15];
z[12] = z[7] * z[12];
z[13] = T(13) / T(2) + -z[25];
z[13] = z[10] * z[13];
z[13] = (T(-17) / T(3)) * z[9] + z[13];
z[13] = z[10] * z[13];
z[13] = z[13] + (T(1) / T(6)) * z[14];
z[15] = 1 + (T(7) / T(12)) * z[25];
z[15] = z[10] * z[15];
z[16] = z[6] * z[32];
z[15] = (T(-19) / T(12)) * z[9] + z[15] + (T(13) / T(18)) * z[16];
z[15] = z[6] * z[15];
z[13] = (T(1) / T(3)) * z[13] + z[15];
z[13] = z[6] * z[13];
z[15] = (T(19) / T(4)) * z[9] + -z[10];
z[15] = z[10] * z[15];
z[15] = (T(-13) / T(2)) * z[14] + z[15];
z[15] = z[10] * z[15];
z[15] = z[15] + (T(11) / T(4)) * z[21];
z[12] = z[12] + z[13] + (T(1) / T(3)) * z[15];
z[12] = z[7] * z[12];
z[13] = -31 + -7 * z[25];
z[13] = z[10] * z[13];
z[13] = 83 * z[9] + z[13];
z[13] = z[10] * z[13];
z[13] = (T(1) / T(9)) * z[13] + -5 * z[14];
z[14] = 1 + (T(-1) / T(2)) * z[25];
z[14] = z[10] * z[14];
z[14] = z[14] + -z[20];
z[14] = z[6] * z[14];
z[13] = (T(1) / T(4)) * z[13] + (T(13) / T(9)) * z[14];
z[13] = z[6] * z[13];
z[14] = 4 * z[9] + (T(-7) / T(2)) * z[10];
z[14] = z[10] * z[14];
z[14] = z[14] + z[28];
z[14] = z[14] * z[29];
z[14] = z[14] + -z[21];
z[13] = z[13] + (T(1) / T(3)) * z[14];
z[13] = z[6] * z[13];
z[14] = -z[10] * z[24];
z[14] = z[14] + z[23];
z[11] = z[11] + z[12] + z[13] + (T(7) / T(12)) * z[14];
z[12] = z[3] * z[4];
return prod_pow(z[12], 2) * z[2] * z[5] * z[11];
}



template double eval_coef_2q3y_2l_pmmpp_nf_12345_47(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_nf_12345_47(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
