#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_nf_12345_49(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[40];
z[0] = iW[0];
z[1] = iW[3];
z[2] = iW[7];
z[3] = iW[18];
z[4] = iW[21];
z[5] = v[1];
z[6] = v[2];
z[7] = v[4];
z[8] = v[3];
z[9] = iW[1];
z[10] = v[0];
z[11] = prod_pow(z[5], 2);
z[12] = z[1] * z[11];
z[13] = (T(1) / T(2)) * z[12];
z[14] = (T(1) / T(2)) * z[8];
z[15] = -z[5] + z[13] + z[14];
z[15] = z[0] * z[15];
z[16] = prod_pow(z[9], 2);
z[17] = z[8] * z[16];
z[18] = z[1] * z[5];
z[19] = 1 + -z[18];
z[19] = z[0] * z[19];
z[19] = z[1] + z[17] + (T(1) / T(2)) * z[19];
z[19] = z[7] * z[19];
z[15] = z[15] + z[19];
z[19] = 2 * z[9];
z[20] = -z[17] + z[19];
z[21] = 2 * z[8];
z[20] = z[20] * z[21];
z[20] = T(-5) / T(4) + z[20];
z[22] = (T(1) / T(2)) * z[10];
z[23] = (T(1) / T(3)) * z[1] + z[17];
z[23] = z[22] * z[23];
z[15] = (T(1) / T(6)) * z[15] + (T(-1) / T(4)) * z[18] + (T(1) / T(3)) * z[20] + z[23];
z[15] = z[7] * z[15];
z[20] = (T(7) / T(2)) * z[9] + -z[17];
z[23] = (T(1) / T(3)) * z[8];
z[24] = z[20] * z[23];
z[24] = T(-5) / T(4) + z[24];
z[24] = z[8] * z[24];
z[25] = z[8] * z[9];
z[26] = -z[18] + z[25];
z[26] = z[10] * z[26];
z[27] = z[14] * z[16];
z[28] = -z[9] + z[27];
z[29] = z[8] * z[28];
z[29] = T(1) / T(2) + z[29];
z[29] = z[6] * z[29];
z[30] = (T(1) / T(3)) * z[5];
z[15] = (T(1) / T(12)) * z[12] + z[15] + z[24] + (T(1) / T(6)) * z[26] + (T(1) / T(3)) * z[29] + z[30];
z[15] = z[6] * z[15];
z[24] = z[1] * z[9];
z[26] = (T(1) / T(2)) * z[16] + (T(1) / T(3)) * z[24];
z[26] = z[10] * z[26];
z[29] = -13 * z[1] + z[9] + -19 * z[17];
z[26] = z[26] + (T(1) / T(12)) * z[29];
z[26] = z[10] * z[26];
z[29] = z[16] + z[24];
z[29] = z[10] * z[29];
z[31] = -z[0] + -5 * z[1] + -z[9] + -7 * z[17];
z[29] = z[29] + (T(1) / T(4)) * z[31];
z[31] = (T(1) / T(3)) * z[7];
z[29] = z[29] * z[31];
z[32] = (T(-5) / T(3)) * z[9] + (T(3) / T(4)) * z[17];
z[32] = z[8] * z[32];
z[33] = z[5] + -z[8];
z[33] = z[0] * z[33];
z[26] = T(5) / T(12) + (T(5) / T(6)) * z[18] + z[26] + z[29] + z[32] + (T(1) / T(12)) * z[33];
z[26] = z[7] * z[26];
z[29] = (T(1) / T(3)) * z[10];
z[32] = -2 * z[1] + -z[9];
z[32] = z[29] * z[32];
z[33] = z[9] + (T(-11) / T(12)) * z[17];
z[33] = z[8] * z[33];
z[32] = T(-2) / T(3) + (T(7) / T(6)) * z[18] + z[32] + z[33];
z[32] = z[10] * z[32];
z[33] = (T(5) / T(12)) * z[12];
z[20] = -z[8] * z[20];
z[20] = T(15) / T(4) + z[20];
z[20] = z[8] * z[20];
z[20] = (T(-5) / T(6)) * z[5] + z[20] + z[26] + z[32] + -z[33];
z[20] = z[7] * z[20];
z[26] = T(-1) / T(2) + z[18];
z[26] = z[26] * z[29];
z[32] = z[9] * z[23];
z[32] = T(-1) / T(2) + z[32];
z[34] = -z[8] * z[32];
z[26] = (T(1) / T(4)) * z[5] + z[26] + -z[33] + z[34];
z[26] = z[10] * z[26];
z[33] = prod_pow(z[8], 2);
z[34] = -z[9] + (T(1) / T(6)) * z[17];
z[34] = z[8] * z[34];
z[35] = 2 + z[34];
z[35] = z[33] * z[35];
z[36] = (T(1) / T(2)) * z[5];
z[37] = (T(-5) / T(3)) * z[8] + z[36];
z[37] = z[5] * z[37];
z[15] = z[15] + z[20] + z[26] + z[35] + z[37];
z[15] = z[6] * z[15];
z[20] = z[1] * z[10];
z[26] = z[16] * z[20];
z[35] = -7 * z[16] + (T(-13) / T(2)) * z[24] + z[26];
z[35] = z[29] * z[35];
z[37] = (T(1) / T(2)) * z[9];
z[35] = (T(7) / T(2)) * z[1] + (T(7) / T(3)) * z[17] + z[35] + z[37];
z[35] = z[10] * z[35];
z[38] = z[16] * z[23];
z[39] = z[9] + -z[38];
z[39] = z[8] * z[39];
z[35] = T(-7) / T(3) + z[35] + z[39];
z[39] = -5 * z[16] + (T(-7) / T(2)) * z[24] + z[26];
z[39] = z[22] * z[39];
z[39] = (T(1) / T(4)) * z[9] + 2 * z[17] + z[39];
z[31] = z[31] * z[39];
z[31] = z[31] + (T(1) / T(2)) * z[35];
z[31] = z[7] * z[31];
z[35] = (T(-37) / T(2)) * z[9] + 11 * z[17];
z[35] = z[23] * z[35];
z[39] = 3 + -z[20];
z[39] = z[9] * z[39];
z[39] = (T(9) / T(2)) * z[1] + (T(-5) / T(3)) * z[17] + z[39];
z[39] = z[10] * z[39];
z[35] = 3 + (T(-7) / T(2)) * z[18] + z[35] + z[39];
z[35] = z[22] * z[35];
z[39] = (T(13) / T(4)) * z[9] + -z[17];
z[39] = z[8] * z[39];
z[39] = T(-9) / T(2) + z[39];
z[39] = z[8] * z[39];
z[31] = (T(9) / T(4)) * z[5] + z[31] + z[35] + z[39];
z[31] = z[7] * z[31];
z[20] = 1 + (T(-23) / T(6)) * z[18] + z[20] + (T(7) / T(6)) * z[25];
z[20] = z[20] * z[22];
z[35] = (T(-5) / T(4)) * z[9] + z[38];
z[35] = z[8] * z[35];
z[35] = T(3) / T(4) + z[35];
z[35] = z[8] * z[35];
z[20] = (T(-5) / T(12)) * z[5] + (T(7) / T(12)) * z[12] + z[20] + z[35];
z[20] = z[10] * z[20];
z[19] = z[19] + -z[38];
z[19] = z[8] * z[19];
z[19] = T(-13) / T(3) + z[19];
z[19] = z[19] * z[33];
z[35] = -z[8] + z[30];
z[35] = z[5] * z[35];
z[19] = z[19] + z[20] + z[31] + -4 * z[35];
z[19] = z[7] * z[19];
z[20] = -z[18] * z[29];
z[20] = (T(-5) / T(3)) * z[5] + (T(7) / T(6)) * z[12] + z[14] + z[20];
z[20] = z[10] * z[20];
z[25] = -5 + z[25];
z[29] = z[25] * z[33];
z[31] = -z[5] + (T(7) / T(3)) * z[8];
z[31] = z[5] * z[31];
z[20] = z[20] + (T(1) / T(3)) * z[29] + z[31];
z[20] = z[20] * z[22];
z[29] = prod_pow(z[8], 3);
z[31] = (T(1) / T(3)) * z[29];
z[39] = z[9] * z[14];
z[39] = -2 + z[39];
z[39] = z[31] * z[39];
z[21] = -z[21] + z[36];
z[21] = z[21] * z[30];
z[21] = z[21] + z[33];
z[21] = z[5] * z[21];
z[15] = z[15] + z[19] + z[20] + z[21] + z[39];
z[15] = z[6] * z[15];
z[19] = (T(5) / T(12)) * z[16] + z[24] + (T(-1) / T(4)) * z[26];
z[19] = z[10] * z[19];
z[20] = 7 * z[9];
z[21] = -z[20] + -z[27];
z[19] = z[19] + (T(1) / T(6)) * z[21];
z[19] = z[10] * z[19];
z[21] = z[16] + (T(-1) / T(2)) * z[26];
z[21] = z[10] * z[21];
z[21] = z[21] + -z[27];
z[21] = z[7] * z[21];
z[26] = -z[14] * z[28];
z[26] = 1 + z[26];
z[19] = z[19] + (T(1) / T(2)) * z[21] + (T(1) / T(3)) * z[26];
z[19] = z[7] * z[19];
z[21] = -z[37] + z[38];
z[21] = -3 * z[1] + 5 * z[21];
z[16] = (T(-1) / T(4)) * z[16] + z[24];
z[16] = z[10] * z[16];
z[16] = z[16] + (T(1) / T(2)) * z[21];
z[16] = z[10] * z[16];
z[20] = (T(-11) / T(2)) * z[17] + z[20];
z[14] = z[14] * z[20];
z[14] = 2 + z[14];
z[14] = (T(1) / T(3)) * z[14] + z[16];
z[14] = z[10] * z[14];
z[16] = (T(-11) / T(4)) * z[9] + z[17];
z[16] = z[8] * z[16];
z[16] = T(19) / T(4) + z[16];
z[16] = z[16] * z[23];
z[14] = -z[5] + z[14] + z[16] + z[19];
z[14] = z[7] * z[14];
z[16] = -5 * z[9] + z[27];
z[16] = z[16] * z[23];
z[19] = -z[1] + z[37];
z[19] = z[10] * z[19];
z[16] = T(5) / T(4) + z[16] + z[18] + (T(3) / T(2)) * z[19];
z[16] = z[10] * z[16];
z[17] = (T(23) / T(4)) * z[9] + -z[17];
z[17] = z[8] * z[17];
z[17] = T(-19) / T(4) + z[17];
z[17] = z[17] * z[23];
z[16] = z[16] + z[17];
z[16] = z[10] * z[16];
z[17] = T(5) / T(2) + z[34];
z[17] = z[17] * z[33];
z[19] = z[5] + (T(-8) / T(3)) * z[8];
z[19] = z[5] * z[19];
z[14] = z[14] + z[16] + z[17] + z[19];
z[14] = z[7] * z[14];
z[16] = z[32] * z[33];
z[17] = -z[8] * z[25];
z[17] = (T(-5) / T(2)) * z[5] + z[17];
z[13] = -z[13] + (T(1) / T(3)) * z[17];
z[17] = T(-3) / T(4) + z[18];
z[17] = z[10] * z[17];
z[13] = (T(1) / T(2)) * z[13] + z[17];
z[13] = z[10] * z[13];
z[11] = (T(1) / T(6)) * z[11] + z[13] + z[16];
z[11] = z[10] * z[11];
z[13] = z[25] * z[29];
z[16] = -z[5] + (T(7) / T(2)) * z[8];
z[16] = z[16] * z[30];
z[16] = z[16] + (T(-3) / T(2)) * z[33];
z[16] = z[5] * z[16];
z[11] = z[11] + (T(-1) / T(6)) * z[13] + z[14] + z[16];
z[11] = z[7] * z[11];
z[13] = -z[33] + -z[35];
z[13] = z[5] * z[13];
z[12] = z[5] + -z[12];
z[12] = prod_pow(z[10], 2) * z[12];
z[12] = (T(1) / T(2)) * z[12] + z[13] + z[31];
z[12] = z[12] * z[22];
z[11] = z[11] + z[12] + z[15];
return prod_pow(z[4], 2) * z[2] * z[3] * z[11];
}



template double eval_coef_2q3y_2l_pmmpp_nf_12345_49(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_nf_12345_49(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
