#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_nf_12345_50(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[27];
z[0] = iW[1];
z[1] = iW[3];
z[2] = iW[18];
z[3] = v[0];
z[4] = v[2];
z[5] = v[4];
z[6] = iW[4];
z[7] = v[3];
z[8] = iW[7];
z[9] = iW[15];
z[10] = v[1];
z[11] = z[0] * z[1];
z[12] = prod_pow(z[0], 2);
z[13] = z[11] + -2 * z[12];
z[14] = (T(1) / T(3)) * z[4];
z[13] = z[1] * z[13] * z[14];
z[15] = z[5] * z[12];
z[16] = prod_pow(z[1], 2);
z[17] = z[4] * z[16];
z[17] = z[1] + (T(-1) / T(2)) * z[17];
z[17] = z[15] * z[17];
z[13] = -z[11] + (T(5) / T(12)) * z[12] + z[13] + (T(1) / T(3)) * z[17];
z[13] = z[5] * z[13];
z[17] = z[0] + (T(-1) / T(6)) * z[1];
z[17] = z[1] * z[17];
z[17] = (T(-3) / T(4)) * z[12] + z[17];
z[17] = z[4] * z[17];
z[18] = z[7] * z[12];
z[13] = (T(-71) / T(36)) * z[0] + z[1] + z[13] + z[17] + (T(19) / T(18)) * z[18];
z[13] = z[5] * z[13];
z[17] = 2 * z[0] + -z[18];
z[17] = z[7] * z[17];
z[17] = -1 + z[17];
z[17] = z[6] * z[17];
z[17] = (T(14) / T(3)) * z[0] + -z[1] + (T(4) / T(3)) * z[17] + (T(-11) / T(3)) * z[18];
z[17] = z[14] * z[17];
z[19] = -19 * z[0] + 4 * z[18];
z[19] = z[7] * z[19];
z[20] = (T(1) / T(3)) * z[10];
z[21] = -z[1] * z[20];
z[22] = z[0] * z[7];
z[23] = 2 + -z[22];
z[23] = z[7] * z[23];
z[23] = -z[10] + z[23];
z[23] = z[6] * z[23];
z[13] = 2 + z[13] + z[17] + (T(1) / T(9)) * z[19] + z[21] + (T(4) / T(9)) * z[23];
z[13] = z[2] * z[13];
z[17] = -z[0] + z[18];
z[19] = (T(1) / T(12)) * z[4];
z[21] = z[17] * z[19];
z[23] = (T(1) / T(3)) * z[7];
z[19] = (T(1) / T(12)) * z[5] + -z[19] + z[23];
z[19] = z[12] * z[19];
z[19] = (T(-1) / T(2)) * z[0] + z[19];
z[19] = z[5] * z[19];
z[24] = (T(-2) / T(3)) * z[0] + (T(1) / T(4)) * z[18];
z[24] = z[7] * z[24];
z[19] = T(5) / T(12) + z[19] + z[21] + z[24];
z[19] = z[5] * z[19];
z[21] = (T(1) / T(2)) * z[7];
z[21] = z[12] * z[21];
z[21] = -z[0] + z[21];
z[24] = z[7] * z[21];
z[24] = T(1) / T(2) + z[24];
z[14] = z[14] * z[24];
z[19] = -z[14] + z[19];
z[24] = prod_pow(z[9], 2) * z[5] * z[8];
z[19] = z[19] * z[24];
z[13] = z[13] + z[19];
z[13] = z[2] * z[13];
z[19] = -z[4] + -z[5] + -z[7];
z[19] = z[15] * z[19];
z[25] = z[4] * z[17];
z[19] = 1 + z[19] + -z[22] + z[25];
z[19] = z[19] * z[24];
z[25] = z[2] * z[7];
z[25] = T(-19) / T(3) + (T(19) / T(6)) * z[25];
z[25] = z[12] * z[25];
z[19] = (T(1) / T(2)) * z[19] + z[25];
z[19] = z[2] * z[19];
z[25] = (T(1) / T(2)) * z[12];
z[26] = z[11] + z[25];
z[26] = z[1] * z[26];
z[15] = -z[15] * z[16];
z[15] = z[15] + z[19] + z[26];
z[15] = z[3] * z[15];
z[13] = z[13] + (T(1) / T(6)) * z[15];
z[13] = z[3] * z[13];
z[15] = (T(1) / T(6)) * z[4];
z[15] = z[15] * z[17];
z[16] = (T(1) / T(4)) * z[7];
z[17] = (T(11) / T(3)) * z[0] + -z[18];
z[16] = z[16] * z[17];
z[17] = z[5] * z[21];
z[16] = T(-2) / T(3) + z[15] + z[16] + (T(-1) / T(6)) * z[17];
z[16] = z[5] * z[16];
z[17] = z[0] + (T(-1) / T(6)) * z[18];
z[17] = z[7] * z[17];
z[17] = T(-3) / T(2) + z[17];
z[17] = z[7] * z[17];
z[14] = (T(2) / T(3)) * z[10] + z[14] + z[16] + z[17];
z[14] = z[5] * z[14];
z[12] = z[12] * z[23];
z[12] = -z[0] + z[12];
z[12] = z[7] * z[12];
z[12] = 1 + z[12];
z[12] = z[7] * z[12];
z[12] = z[12] + -z[20];
z[12] = z[4] * z[12];
z[16] = -1 + (T(1) / T(3)) * z[22];
z[16] = prod_pow(z[7], 2) * z[16];
z[17] = z[7] + -z[20];
z[17] = z[10] * z[17];
z[12] = z[12] + z[16] + z[17];
z[12] = (T(1) / T(2)) * z[12] + z[14];
z[12] = z[12] * z[24];
z[12] = z[12] + -z[15];
z[12] = z[2] * z[12];
z[14] = -prod_pow(z[4], 2) * z[26];
z[14] = -z[0] + z[14];
z[11] = -z[11] + z[25];
z[11] = z[5] * z[11];
z[11] = z[11] + (T(1) / T(2)) * z[14];
z[11] = (T(1) / T(3)) * z[11] + z[12] + z[13];
return z[3] * z[11];
}



template double eval_coef_2q3y_2l_pmmpp_nf_12345_50(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_nf_12345_50(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
